import { defineComponent as lt, shallowRef as eo, inject as vh, computed as Fm, toRaw as zm, onMounted as Xl, watch as ut, onBeforeUnmount as Hm, h as Vm, mergeModels as ts, useModel as Jl, openBlock as se, createBlock as xn, unref as Wi, ref as oe, nextTick as _m, createElementBlock as xe, createElementVNode as I, Fragment as qt, renderList as sn, toDisplayString as In, renderSlot as Ni, withCtx as ot, createTextVNode as fi, withDirectives as dt, vModelSelect as Sh, vModelText as zt, render as xt, normalizeClass as jr, createCommentVNode as Wo, createVNode as Ut, provide as $m, onBeforeMount as jm, isRef as qa, Teleport as Wm } from "vue";
class re {
  /**
  Get the line description around the given position.
  */
  lineAt(e) {
    if (e < 0 || e > this.length)
      throw new RangeError(`Invalid position ${e} in document of length ${this.length}`);
    return this.lineInner(e, !1, 1, 0);
  }
  /**
  Get the description for the given (1-based) line number.
  */
  line(e) {
    if (e < 1 || e > this.lines)
      throw new RangeError(`Invalid line number ${e} in ${this.lines}-line document`);
    return this.lineInner(e, !0, 1, 0);
  }
  /**
  Replace a range of the text with the given content.
  */
  replace(e, t, i) {
    [e, t] = si(this, e, t);
    let r = [];
    return this.decompose(
      0,
      e,
      r,
      2
      /* Open.To */
    ), i.length && i.decompose(
      0,
      i.length,
      r,
      3
      /* Open.To */
    ), this.decompose(
      t,
      this.length,
      r,
      1
      /* Open.From */
    ), Pt.from(r, this.length - (t - e) + i.length);
  }
  /**
  Append another document to this one.
  */
  append(e) {
    return this.replace(this.length, this.length, e);
  }
  /**
  Retrieve the text between the given points.
  */
  slice(e, t = this.length) {
    [e, t] = si(this, e, t);
    let i = [];
    return this.decompose(e, t, i, 0), Pt.from(i, t - e);
  }
  /**
  Test whether this text is equal to another instance.
  */
  eq(e) {
    if (e == this)
      return !0;
    if (e.length != this.length || e.lines != this.lines)
      return !1;
    let t = this.scanIdentical(e, 1), i = this.length - this.scanIdentical(e, -1), r = new Fi(this), s = new Fi(e);
    for (let o = t, l = t; ; ) {
      if (r.next(o), s.next(o), o = 0, r.lineBreak != s.lineBreak || r.done != s.done || r.value != s.value)
        return !1;
      if (l += r.value.length, r.done || l >= i)
        return !0;
    }
  }
  /**
  Iterate over the text. When `dir` is `-1`, iteration happens
  from end to start. This will return lines and the breaks between
  them as separate strings.
  */
  iter(e = 1) {
    return new Fi(this, e);
  }
  /**
  Iterate over a range of the text. When `from` > `to`, the
  iterator will run in reverse.
  */
  iterRange(e, t = this.length) {
    return new Ch(this, e, t);
  }
  /**
  Return a cursor that iterates over the given range of lines,
  _without_ returning the line breaks between, and yielding empty
  strings for empty lines.
  
  When `from` and `to` are given, they should be 1-based line numbers.
  */
  iterLines(e, t) {
    let i;
    if (e == null)
      i = this.iter();
    else {
      t == null && (t = this.lines + 1);
      let r = this.line(e).from;
      i = this.iterRange(r, Math.max(r, t == this.lines + 1 ? this.length : t <= 1 ? 0 : this.line(t - 1).to));
    }
    return new Ah(i);
  }
  /**
  Return the document as a string, using newline characters to
  separate lines.
  */
  toString() {
    return this.sliceString(0);
  }
  /**
  Convert the document to an array of lines (which can be
  deserialized again via [`Text.of`](https://codemirror.net/6/docs/ref/#state.Text^of)).
  */
  toJSON() {
    let e = [];
    return this.flatten(e), e;
  }
  /**
  @internal
  */
  constructor() {
  }
  /**
  Create a `Text` instance for the given array of lines.
  */
  static of(e) {
    if (e.length == 0)
      throw new RangeError("A document must have at least one line");
    return e.length == 1 && !e[0] ? re.empty : e.length <= 32 ? new we(e) : Pt.from(we.split(e, []));
  }
}
class we extends re {
  constructor(e, t = qm(e)) {
    super(), this.text = e, this.length = t;
  }
  get lines() {
    return this.text.length;
  }
  get children() {
    return null;
  }
  lineInner(e, t, i, r) {
    for (let s = 0; ; s++) {
      let o = this.text[s], l = r + o.length;
      if ((t ? i : l) >= e)
        return new Um(r, l, i, o);
      r = l + 1, i++;
    }
  }
  decompose(e, t, i, r) {
    let s = e <= 0 && t >= this.length ? this : new we(Ua(this.text, e, t), Math.min(t, this.length) - Math.max(0, e));
    if (r & 1) {
      let o = i.pop(), l = Wr(s.text, o.text.slice(), 0, s.length);
      if (l.length <= 32)
        i.push(new we(l, o.length + s.length));
      else {
        let a = l.length >> 1;
        i.push(new we(l.slice(0, a)), new we(l.slice(a)));
      }
    } else
      i.push(s);
  }
  replace(e, t, i) {
    if (!(i instanceof we))
      return super.replace(e, t, i);
    [e, t] = si(this, e, t);
    let r = Wr(this.text, Wr(i.text, Ua(this.text, 0, e)), t), s = this.length + i.length - (t - e);
    return r.length <= 32 ? new we(r, s) : Pt.from(we.split(r, []), s);
  }
  sliceString(e, t = this.length, i = `
`) {
    [e, t] = si(this, e, t);
    let r = "";
    for (let s = 0, o = 0; s <= t && o < this.text.length; o++) {
      let l = this.text[o], a = s + l.length;
      s > e && o && (r += i), e < a && t > s && (r += l.slice(Math.max(0, e - s), t - s)), s = a + 1;
    }
    return r;
  }
  flatten(e) {
    for (let t of this.text)
      e.push(t);
  }
  scanIdentical() {
    return 0;
  }
  static split(e, t) {
    let i = [], r = -1;
    for (let s of e)
      i.push(s), r += s.length + 1, i.length == 32 && (t.push(new we(i, r)), i = [], r = -1);
    return r > -1 && t.push(new we(i, r)), t;
  }
}
class Pt extends re {
  constructor(e, t) {
    super(), this.children = e, this.length = t, this.lines = 0;
    for (let i of e)
      this.lines += i.lines;
  }
  lineInner(e, t, i, r) {
    for (let s = 0; ; s++) {
      let o = this.children[s], l = r + o.length, a = i + o.lines - 1;
      if ((t ? a : l) >= e)
        return o.lineInner(e, t, i, r);
      r = l + 1, i = a + 1;
    }
  }
  decompose(e, t, i, r) {
    for (let s = 0, o = 0; o <= t && s < this.children.length; s++) {
      let l = this.children[s], a = o + l.length;
      if (e <= a && t >= o) {
        let u = r & ((o <= e ? 1 : 0) | (a >= t ? 2 : 0));
        o >= e && a <= t && !u ? i.push(l) : l.decompose(e - o, t - o, i, u);
      }
      o = a + 1;
    }
  }
  replace(e, t, i) {
    if ([e, t] = si(this, e, t), i.lines < this.lines)
      for (let r = 0, s = 0; r < this.children.length; r++) {
        let o = this.children[r], l = s + o.length;
        if (e >= s && t <= l) {
          let a = o.replace(e - s, t - s, i), u = this.lines - o.lines + a.lines;
          if (a.lines < u >> 4 && a.lines > u >> 6) {
            let c = this.children.slice();
            return c[r] = a, new Pt(c, this.length - (t - e) + i.length);
          }
          return super.replace(s, l, a);
        }
        s = l + 1;
      }
    return super.replace(e, t, i);
  }
  sliceString(e, t = this.length, i = `
`) {
    [e, t] = si(this, e, t);
    let r = "";
    for (let s = 0, o = 0; s < this.children.length && o <= t; s++) {
      let l = this.children[s], a = o + l.length;
      o > e && s && (r += i), e < a && t > o && (r += l.sliceString(e - o, t - o, i)), o = a + 1;
    }
    return r;
  }
  flatten(e) {
    for (let t of this.children)
      t.flatten(e);
  }
  scanIdentical(e, t) {
    if (!(e instanceof Pt))
      return 0;
    let i = 0, [r, s, o, l] = t > 0 ? [0, 0, this.children.length, e.children.length] : [this.children.length - 1, e.children.length - 1, -1, -1];
    for (; ; r += t, s += t) {
      if (r == o || s == l)
        return i;
      let a = this.children[r], u = e.children[s];
      if (a != u)
        return i + a.scanIdentical(u, t);
      i += a.length + 1;
    }
  }
  static from(e, t = e.reduce((i, r) => i + r.length + 1, -1)) {
    let i = 0;
    for (let d of e)
      i += d.lines;
    if (i < 32) {
      let d = [];
      for (let p of e)
        p.flatten(d);
      return new we(d, t);
    }
    let r = Math.max(
      32,
      i >> 5
      /* Tree.BranchShift */
    ), s = r << 1, o = r >> 1, l = [], a = 0, u = -1, c = [];
    function h(d) {
      let p;
      if (d.lines > s && d instanceof Pt)
        for (let g of d.children)
          h(g);
      else
        d.lines > o && (a > o || !a) ? (f(), l.push(d)) : d instanceof we && a && (p = c[c.length - 1]) instanceof we && d.lines + p.lines <= 32 ? (a += d.lines, u += d.length + 1, c[c.length - 1] = new we(p.text.concat(d.text), p.length + 1 + d.length)) : (a + d.lines > r && f(), a += d.lines, u += d.length + 1, c.push(d));
    }
    function f() {
      a != 0 && (l.push(c.length == 1 ? c[0] : Pt.from(c, u)), u = -1, a = c.length = 0);
    }
    for (let d of e)
      h(d);
    return f(), l.length == 1 ? l[0] : new Pt(l, t);
  }
}
re.empty = /* @__PURE__ */ new we([""], 0);
function qm(n) {
  let e = -1;
  for (let t of n)
    e += t.length + 1;
  return e;
}
function Wr(n, e, t = 0, i = 1e9) {
  for (let r = 0, s = 0, o = !0; s < n.length && r <= i; s++) {
    let l = n[s], a = r + l.length;
    a >= t && (a > i && (l = l.slice(0, i - r)), r < t && (l = l.slice(t - r)), o ? (e[e.length - 1] += l, o = !1) : e.push(l)), r = a + 1;
  }
  return e;
}
function Ua(n, e, t) {
  return Wr(n, [""], e, t);
}
class Fi {
  constructor(e, t = 1) {
    this.dir = t, this.done = !1, this.lineBreak = !1, this.value = "", this.nodes = [e], this.offsets = [t > 0 ? 1 : (e instanceof we ? e.text.length : e.children.length) << 1];
  }
  nextInner(e, t) {
    for (this.done = this.lineBreak = !1; ; ) {
      let i = this.nodes.length - 1, r = this.nodes[i], s = this.offsets[i], o = s >> 1, l = r instanceof we ? r.text.length : r.children.length;
      if (o == (t > 0 ? l : 0)) {
        if (i == 0)
          return this.done = !0, this.value = "", this;
        t > 0 && this.offsets[i - 1]++, this.nodes.pop(), this.offsets.pop();
      } else if ((s & 1) == (t > 0 ? 0 : 1)) {
        if (this.offsets[i] += t, e == 0)
          return this.lineBreak = !0, this.value = `
`, this;
        e--;
      } else if (r instanceof we) {
        let a = r.text[o + (t < 0 ? -1 : 0)];
        if (this.offsets[i] += t, a.length > Math.max(0, e))
          return this.value = e == 0 ? a : t > 0 ? a.slice(e) : a.slice(0, a.length - e), this;
        e -= a.length;
      } else {
        let a = r.children[o + (t < 0 ? -1 : 0)];
        e > a.length ? (e -= a.length, this.offsets[i] += t) : (t < 0 && this.offsets[i]--, this.nodes.push(a), this.offsets.push(t > 0 ? 1 : (a instanceof we ? a.text.length : a.children.length) << 1));
      }
    }
  }
  next(e = 0) {
    return e < 0 && (this.nextInner(-e, -this.dir), e = this.value.length), this.nextInner(e, this.dir);
  }
}
class Ch {
  constructor(e, t, i) {
    this.value = "", this.done = !1, this.cursor = new Fi(e, t > i ? -1 : 1), this.pos = t > i ? e.length : 0, this.from = Math.min(t, i), this.to = Math.max(t, i);
  }
  nextInner(e, t) {
    if (t < 0 ? this.pos <= this.from : this.pos >= this.to)
      return this.value = "", this.done = !0, this;
    e += Math.max(0, t < 0 ? this.pos - this.to : this.from - this.pos);
    let i = t < 0 ? this.pos - this.from : this.to - this.pos;
    e > i && (e = i), i -= e;
    let { value: r } = this.cursor.next(e);
    return this.pos += (r.length + e) * t, this.value = r.length <= i ? r : t < 0 ? r.slice(r.length - i) : r.slice(0, i), this.done = !this.value, this;
  }
  next(e = 0) {
    return e < 0 ? e = Math.max(e, this.from - this.pos) : e > 0 && (e = Math.min(e, this.to - this.pos)), this.nextInner(e, this.cursor.dir);
  }
  get lineBreak() {
    return this.cursor.lineBreak && this.value != "";
  }
}
class Ah {
  constructor(e) {
    this.inner = e, this.afterBreak = !0, this.value = "", this.done = !1;
  }
  next(e = 0) {
    let { done: t, lineBreak: i, value: r } = this.inner.next(e);
    return t && this.afterBreak ? (this.value = "", this.afterBreak = !1) : t ? (this.done = !0, this.value = "") : i ? this.afterBreak ? this.value = "" : (this.afterBreak = !0, this.next()) : (this.value = r, this.afterBreak = !1), this;
  }
  get lineBreak() {
    return !1;
  }
}
typeof Symbol < "u" && (re.prototype[Symbol.iterator] = function() {
  return this.iter();
}, Fi.prototype[Symbol.iterator] = Ch.prototype[Symbol.iterator] = Ah.prototype[Symbol.iterator] = function() {
  return this;
});
class Um {
  /**
  @internal
  */
  constructor(e, t, i, r) {
    this.from = e, this.to = t, this.number = i, this.text = r;
  }
  /**
  The length of the line (not including any line break after it).
  */
  get length() {
    return this.to - this.from;
  }
}
function si(n, e, t) {
  return e = Math.max(0, Math.min(n.length, e)), [e, Math.max(e, Math.min(n.length, t))];
}
let Jn = /* @__PURE__ */ "lc,34,7n,7,7b,19,,,,2,,2,,,20,b,1c,l,g,,2t,7,2,6,2,2,,4,z,,u,r,2j,b,1m,9,9,,o,4,,9,,3,,5,17,3,3b,f,,w,1j,,,,4,8,4,,3,7,a,2,t,,1m,,,,2,4,8,,9,,a,2,q,,2,2,1l,,4,2,4,2,2,3,3,,u,2,3,,b,2,1l,,4,5,,2,4,,k,2,m,6,,,1m,,,2,,4,8,,7,3,a,2,u,,1n,,,,c,,9,,14,,3,,1l,3,5,3,,4,7,2,b,2,t,,1m,,2,,2,,3,,5,2,7,2,b,2,s,2,1l,2,,,2,4,8,,9,,a,2,t,,20,,4,,2,3,,,8,,29,,2,7,c,8,2q,,2,9,b,6,22,2,r,,,,,,1j,e,,5,,2,5,b,,10,9,,2u,4,,6,,2,2,2,p,2,4,3,g,4,d,,2,2,6,,f,,jj,3,qa,3,t,3,t,2,u,2,1s,2,,7,8,,2,b,9,,19,3,3b,2,y,,3a,3,4,2,9,,6,3,63,2,2,,1m,,,7,,,,,2,8,6,a,2,,1c,h,1r,4,1c,7,,,5,,14,9,c,2,w,4,2,2,,3,1k,,,2,3,,,3,1m,8,2,2,48,3,,d,,7,4,,6,,3,2,5i,1m,,5,ek,,5f,x,2da,3,3x,,2o,w,fe,6,2x,2,n9w,4,,a,w,2,28,2,7k,,3,,4,,p,2,5,,47,2,q,i,d,,12,8,p,b,1a,3,1c,,2,4,2,2,13,,1v,6,2,2,2,2,c,,8,,1b,,1f,,,3,2,2,5,2,,,16,2,8,,6m,,2,,4,,fn4,,kh,g,g,g,a6,2,gt,,6a,,45,5,1ae,3,,2,5,4,14,3,4,,4l,2,fx,4,ar,2,49,b,4w,,1i,f,1k,3,1d,4,2,2,1x,3,10,5,,8,1q,,c,2,1g,9,a,4,2,,2n,3,2,,,2,6,,4g,,3,8,l,2,1l,2,,,,,m,,e,7,3,5,5f,8,2,3,,,n,,29,,2,6,,,2,,,2,,2,6j,,2,4,6,2,,2,r,2,2d,8,2,,,2,2y,,,,2,6,,,2t,3,2,4,,5,77,9,,2,6t,,a,2,,,4,,40,4,2,2,4,,w,a,14,6,2,4,8,,9,6,2,3,1a,d,,2,ba,7,,6,,,2a,m,2,7,,2,,2,3e,6,3,,,2,,7,,,20,2,3,,,,9n,2,f0b,5,1n,7,t4,,1r,4,29,,f5k,2,43q,,,3,4,5,8,8,2,7,u,4,44,3,1iz,1j,4,1e,8,,e,,m,5,,f,11s,7,,h,2,7,,2,,5,79,7,c5,4,15s,7,31,7,240,5,gx7k,2o,3k,6o".split(",").map((n) => n ? parseInt(n, 36) : 1);
for (let n = 1; n < Jn.length; n++)
  Jn[n] += Jn[n - 1];
function Km(n) {
  for (let e = 1; e < Jn.length; e += 2)
    if (Jn[e] > n)
      return Jn[e - 1] <= n;
  return !1;
}
function Ka(n) {
  return n >= 127462 && n <= 127487;
}
const Ga = 8205;
function Re(n, e, t = !0, i = !0) {
  return (t ? Mh : Gm)(n, e, i);
}
function Mh(n, e, t) {
  if (e == n.length)
    return e;
  e && Th(n.charCodeAt(e)) && Oh(n.charCodeAt(e - 1)) && e--;
  let i = Le(n, e);
  for (e += ht(i); e < n.length; ) {
    let r = Le(n, e);
    if (i == Ga || r == Ga || t && Km(r))
      e += ht(r), i = r;
    else if (Ka(r)) {
      let s = 0, o = e - 2;
      for (; o >= 0 && Ka(Le(n, o)); )
        s++, o -= 2;
      if (s % 2 == 0)
        break;
      e += 2;
    } else
      break;
  }
  return e;
}
function Gm(n, e, t) {
  for (; e > 0; ) {
    let i = Mh(n, e - 2, t);
    if (i < e)
      return i;
    e--;
  }
  return 0;
}
function Th(n) {
  return n >= 56320 && n < 57344;
}
function Oh(n) {
  return n >= 55296 && n < 56320;
}
function Le(n, e) {
  let t = n.charCodeAt(e);
  if (!Oh(t) || e + 1 == n.length)
    return t;
  let i = n.charCodeAt(e + 1);
  return Th(i) ? (t - 55296 << 10) + (i - 56320) + 65536 : t;
}
function Ql(n) {
  return n <= 65535 ? String.fromCharCode(n) : (n -= 65536, String.fromCharCode((n >> 10) + 55296, (n & 1023) + 56320));
}
function ht(n) {
  return n < 65536 ? 1 : 2;
}
const qo = /\r\n?|\n/;
var qe = /* @__PURE__ */ function(n) {
  return n[n.Simple = 0] = "Simple", n[n.TrackDel = 1] = "TrackDel", n[n.TrackBefore = 2] = "TrackBefore", n[n.TrackAfter = 3] = "TrackAfter", n;
}(qe || (qe = {}));
class Ht {
  // Sections are encoded as pairs of integers. The first is the
  // length in the current document, and the second is -1 for
  // unaffected sections, and the length of the replacement content
  // otherwise. So an insertion would be (0, n>0), a deletion (n>0,
  // 0), and a replacement two positive numbers.
  /**
  @internal
  */
  constructor(e) {
    this.sections = e;
  }
  /**
  The length of the document before the change.
  */
  get length() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2)
      e += this.sections[t];
    return e;
  }
  /**
  The length of the document after the change.
  */
  get newLength() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2) {
      let i = this.sections[t + 1];
      e += i < 0 ? this.sections[t] : i;
    }
    return e;
  }
  /**
  False when there are actual changes in this set.
  */
  get empty() {
    return this.sections.length == 0 || this.sections.length == 2 && this.sections[1] < 0;
  }
  /**
  Iterate over the unchanged parts left by these changes. `posA`
  provides the position of the range in the old document, `posB`
  the new position in the changed document.
  */
  iterGaps(e) {
    for (let t = 0, i = 0, r = 0; t < this.sections.length; ) {
      let s = this.sections[t++], o = this.sections[t++];
      o < 0 ? (e(i, r, s), r += s) : r += o, i += s;
    }
  }
  /**
  Iterate over the ranges changed by these changes. (See
  [`ChangeSet.iterChanges`](https://codemirror.net/6/docs/ref/#state.ChangeSet.iterChanges) for a
  variant that also provides you with the inserted text.)
  `fromA`/`toA` provides the extent of the change in the starting
  document, `fromB`/`toB` the extent of the replacement in the
  changed document.
  
  When `individual` is true, adjacent changes (which are kept
  separate for [position mapping](https://codemirror.net/6/docs/ref/#state.ChangeDesc.mapPos)) are
  reported separately.
  */
  iterChangedRanges(e, t = !1) {
    Uo(this, e, t);
  }
  /**
  Get a description of the inverted form of these changes.
  */
  get invertedDesc() {
    let e = [];
    for (let t = 0; t < this.sections.length; ) {
      let i = this.sections[t++], r = this.sections[t++];
      r < 0 ? e.push(i, r) : e.push(r, i);
    }
    return new Ht(e);
  }
  /**
  Compute the combined effect of applying another set of changes
  after this one. The length of the document after this set should
  match the length before `other`.
  */
  composeDesc(e) {
    return this.empty ? e : e.empty ? this : Dh(this, e);
  }
  /**
  Map this description, which should start with the same document
  as `other`, over another set of changes, so that it can be
  applied after it. When `before` is true, map as if the changes
  in `other` happened before the ones in `this`.
  */
  mapDesc(e, t = !1) {
    return e.empty ? this : Ko(this, e, t);
  }
  mapPos(e, t = -1, i = qe.Simple) {
    let r = 0, s = 0;
    for (let o = 0; o < this.sections.length; ) {
      let l = this.sections[o++], a = this.sections[o++], u = r + l;
      if (a < 0) {
        if (u > e)
          return s + (e - r);
        s += l;
      } else {
        if (i != qe.Simple && u >= e && (i == qe.TrackDel && r < e && u > e || i == qe.TrackBefore && r < e || i == qe.TrackAfter && u > e))
          return null;
        if (u > e || u == e && t < 0 && !l)
          return e == r || t < 0 ? s : s + a;
        s += a;
      }
      r = u;
    }
    if (e > r)
      throw new RangeError(`Position ${e} is out of range for changeset of length ${r}`);
    return s;
  }
  /**
  Check whether these changes touch a given range. When one of the
  changes entirely covers the range, the string `"cover"` is
  returned.
  */
  touchesRange(e, t = e) {
    for (let i = 0, r = 0; i < this.sections.length && r <= t; ) {
      let s = this.sections[i++], o = this.sections[i++], l = r + s;
      if (o >= 0 && r <= t && l >= e)
        return r < e && l > t ? "cover" : !0;
      r = l;
    }
    return !1;
  }
  /**
  @internal
  */
  toString() {
    let e = "";
    for (let t = 0; t < this.sections.length; ) {
      let i = this.sections[t++], r = this.sections[t++];
      e += (e ? " " : "") + i + (r >= 0 ? ":" + r : "");
    }
    return e;
  }
  /**
  Serialize this change desc to a JSON-representable value.
  */
  toJSON() {
    return this.sections;
  }
  /**
  Create a change desc from its JSON representation (as produced
  by [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeDesc.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e) || e.length % 2 || e.some((t) => typeof t != "number"))
      throw new RangeError("Invalid JSON representation of ChangeDesc");
    return new Ht(e);
  }
  /**
  @internal
  */
  static create(e) {
    return new Ht(e);
  }
}
class Te extends Ht {
  constructor(e, t) {
    super(e), this.inserted = t;
  }
  /**
  Apply the changes to a document, returning the modified
  document.
  */
  apply(e) {
    if (this.length != e.length)
      throw new RangeError("Applying change set to a document with the wrong length");
    return Uo(this, (t, i, r, s, o) => e = e.replace(r, r + (i - t), o), !1), e;
  }
  mapDesc(e, t = !1) {
    return Ko(this, e, t, !0);
  }
  /**
  Given the document as it existed _before_ the changes, return a
  change set that represents the inverse of this set, which could
  be used to go from the document created by the changes back to
  the document as it existed before the changes.
  */
  invert(e) {
    let t = this.sections.slice(), i = [];
    for (let r = 0, s = 0; r < t.length; r += 2) {
      let o = t[r], l = t[r + 1];
      if (l >= 0) {
        t[r] = l, t[r + 1] = o;
        let a = r >> 1;
        for (; i.length < a; )
          i.push(re.empty);
        i.push(o ? e.slice(s, s + o) : re.empty);
      }
      s += o;
    }
    return new Te(t, i);
  }
  /**
  Combine two subsequent change sets into a single set. `other`
  must start in the document produced by `this`. If `this` goes
  `docA` → `docB` and `other` represents `docB` → `docC`, the
  returned value will represent the change `docA` → `docC`.
  */
  compose(e) {
    return this.empty ? e : e.empty ? this : Dh(this, e, !0);
  }
  /**
  Given another change set starting in the same document, maps this
  change set over the other, producing a new change set that can be
  applied to the document produced by applying `other`. When
  `before` is `true`, order changes as if `this` comes before
  `other`, otherwise (the default) treat `other` as coming first.
  
  Given two changes `A` and `B`, `A.compose(B.map(A))` and
  `B.compose(A.map(B, true))` will produce the same document. This
  provides a basic form of [operational
  transformation](https://en.wikipedia.org/wiki/Operational_transformation),
  and can be used for collaborative editing.
  */
  map(e, t = !1) {
    return e.empty ? this : Ko(this, e, t, !0);
  }
  /**
  Iterate over the changed ranges in the document, calling `f` for
  each, with the range in the original document (`fromA`-`toA`)
  and the range that replaces it in the new document
  (`fromB`-`toB`).
  
  When `individual` is true, adjacent changes are reported
  separately.
  */
  iterChanges(e, t = !1) {
    Uo(this, e, t);
  }
  /**
  Get a [change description](https://codemirror.net/6/docs/ref/#state.ChangeDesc) for this change
  set.
  */
  get desc() {
    return Ht.create(this.sections);
  }
  /**
  @internal
  */
  filter(e) {
    let t = [], i = [], r = [], s = new qi(this);
    e:
      for (let o = 0, l = 0; ; ) {
        let a = o == e.length ? 1e9 : e[o++];
        for (; l < a || l == a && s.len == 0; ) {
          if (s.done)
            break e;
          let c = Math.min(s.len, a - l);
          Fe(r, c, -1);
          let h = s.ins == -1 ? -1 : s.off == 0 ? s.ins : 0;
          Fe(t, c, h), h > 0 && on(i, t, s.text), s.forward(c), l += c;
        }
        let u = e[o++];
        for (; l < u; ) {
          if (s.done)
            break e;
          let c = Math.min(s.len, u - l);
          Fe(t, c, -1), Fe(r, c, s.ins == -1 ? -1 : s.off == 0 ? s.ins : 0), s.forward(c), l += c;
        }
      }
    return {
      changes: new Te(t, i),
      filtered: Ht.create(r)
    };
  }
  /**
  Serialize this change set to a JSON-representable value.
  */
  toJSON() {
    let e = [];
    for (let t = 0; t < this.sections.length; t += 2) {
      let i = this.sections[t], r = this.sections[t + 1];
      r < 0 ? e.push(i) : r == 0 ? e.push([i]) : e.push([i].concat(this.inserted[t >> 1].toJSON()));
    }
    return e;
  }
  /**
  Create a change set for the given changes, for a document of the
  given length, using `lineSep` as line separator.
  */
  static of(e, t, i) {
    let r = [], s = [], o = 0, l = null;
    function a(c = !1) {
      if (!c && !r.length)
        return;
      o < t && Fe(r, t - o, -1);
      let h = new Te(r, s);
      l = l ? l.compose(h.map(l)) : h, r = [], s = [], o = 0;
    }
    function u(c) {
      if (Array.isArray(c))
        for (let h of c)
          u(h);
      else if (c instanceof Te) {
        if (c.length != t)
          throw new RangeError(`Mismatched change set length (got ${c.length}, expected ${t})`);
        a(), l = l ? l.compose(c.map(l)) : c;
      } else {
        let { from: h, to: f = h, insert: d } = c;
        if (h > f || h < 0 || f > t)
          throw new RangeError(`Invalid change range ${h} to ${f} (in doc of length ${t})`);
        let p = d ? typeof d == "string" ? re.of(d.split(i || qo)) : d : re.empty, g = p.length;
        if (h == f && g == 0)
          return;
        h < o && a(), h > o && Fe(r, h - o, -1), Fe(r, f - h, g), on(s, r, p), o = f;
      }
    }
    return u(e), a(!l), l;
  }
  /**
  Create an empty changeset of the given length.
  */
  static empty(e) {
    return new Te(e ? [e, -1] : [], []);
  }
  /**
  Create a changeset from its JSON representation (as produced by
  [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeSet.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e))
      throw new RangeError("Invalid JSON representation of ChangeSet");
    let t = [], i = [];
    for (let r = 0; r < e.length; r++) {
      let s = e[r];
      if (typeof s == "number")
        t.push(s, -1);
      else {
        if (!Array.isArray(s) || typeof s[0] != "number" || s.some((o, l) => l && typeof o != "string"))
          throw new RangeError("Invalid JSON representation of ChangeSet");
        if (s.length == 1)
          t.push(s[0], 0);
        else {
          for (; i.length < r; )
            i.push(re.empty);
          i[r] = re.of(s.slice(1)), t.push(s[0], i[r].length);
        }
      }
    }
    return new Te(t, i);
  }
  /**
  @internal
  */
  static createSet(e, t) {
    return new Te(e, t);
  }
}
function Fe(n, e, t, i = !1) {
  if (e == 0 && t <= 0)
    return;
  let r = n.length - 2;
  r >= 0 && t <= 0 && t == n[r + 1] ? n[r] += e : e == 0 && n[r] == 0 ? n[r + 1] += t : i ? (n[r] += e, n[r + 1] += t) : n.push(e, t);
}
function on(n, e, t) {
  if (t.length == 0)
    return;
  let i = e.length - 2 >> 1;
  if (i < n.length)
    n[n.length - 1] = n[n.length - 1].append(t);
  else {
    for (; n.length < i; )
      n.push(re.empty);
    n.push(t);
  }
}
function Uo(n, e, t) {
  let i = n.inserted;
  for (let r = 0, s = 0, o = 0; o < n.sections.length; ) {
    let l = n.sections[o++], a = n.sections[o++];
    if (a < 0)
      r += l, s += l;
    else {
      let u = r, c = s, h = re.empty;
      for (; u += l, c += a, a && i && (h = h.append(i[o - 2 >> 1])), !(t || o == n.sections.length || n.sections[o + 1] < 0); )
        l = n.sections[o++], a = n.sections[o++];
      e(r, u, s, c, h), r = u, s = c;
    }
  }
}
function Ko(n, e, t, i = !1) {
  let r = [], s = i ? [] : null, o = new qi(n), l = new qi(e);
  for (let a = -1; ; )
    if (o.ins == -1 && l.ins == -1) {
      let u = Math.min(o.len, l.len);
      Fe(r, u, -1), o.forward(u), l.forward(u);
    } else if (l.ins >= 0 && (o.ins < 0 || a == o.i || o.off == 0 && (l.len < o.len || l.len == o.len && !t))) {
      let u = l.len;
      for (Fe(r, l.ins, -1); u; ) {
        let c = Math.min(o.len, u);
        o.ins >= 0 && a < o.i && o.len <= c && (Fe(r, 0, o.ins), s && on(s, r, o.text), a = o.i), o.forward(c), u -= c;
      }
      l.next();
    } else if (o.ins >= 0) {
      let u = 0, c = o.len;
      for (; c; )
        if (l.ins == -1) {
          let h = Math.min(c, l.len);
          u += h, c -= h, l.forward(h);
        } else if (l.ins == 0 && l.len < c)
          c -= l.len, l.next();
        else
          break;
      Fe(r, u, a < o.i ? o.ins : 0), s && a < o.i && on(s, r, o.text), a = o.i, o.forward(o.len - c);
    } else {
      if (o.done && l.done)
        return s ? Te.createSet(r, s) : Ht.create(r);
      throw new Error("Mismatched change set lengths");
    }
}
function Dh(n, e, t = !1) {
  let i = [], r = t ? [] : null, s = new qi(n), o = new qi(e);
  for (let l = !1; ; ) {
    if (s.done && o.done)
      return r ? Te.createSet(i, r) : Ht.create(i);
    if (s.ins == 0)
      Fe(i, s.len, 0, l), s.next();
    else if (o.len == 0 && !o.done)
      Fe(i, 0, o.ins, l), r && on(r, i, o.text), o.next();
    else {
      if (s.done || o.done)
        throw new Error("Mismatched change set lengths");
      {
        let a = Math.min(s.len2, o.len), u = i.length;
        if (s.ins == -1) {
          let c = o.ins == -1 ? -1 : o.off ? 0 : o.ins;
          Fe(i, a, c, l), r && c && on(r, i, o.text);
        } else
          o.ins == -1 ? (Fe(i, s.off ? 0 : s.len, a, l), r && on(r, i, s.textBit(a))) : (Fe(i, s.off ? 0 : s.len, o.off ? 0 : o.ins, l), r && !o.off && on(r, i, o.text));
        l = (s.ins > a || o.ins >= 0 && o.len > a) && (l || i.length > u), s.forward2(a), o.forward(a);
      }
    }
  }
}
class qi {
  constructor(e) {
    this.set = e, this.i = 0, this.next();
  }
  next() {
    let { sections: e } = this.set;
    this.i < e.length ? (this.len = e[this.i++], this.ins = e[this.i++]) : (this.len = 0, this.ins = -2), this.off = 0;
  }
  get done() {
    return this.ins == -2;
  }
  get len2() {
    return this.ins < 0 ? this.len : this.ins;
  }
  get text() {
    let { inserted: e } = this.set, t = this.i - 2 >> 1;
    return t >= e.length ? re.empty : e[t];
  }
  textBit(e) {
    let { inserted: t } = this.set, i = this.i - 2 >> 1;
    return i >= t.length && !e ? re.empty : t[i].slice(this.off, e == null ? void 0 : this.off + e);
  }
  forward(e) {
    e == this.len ? this.next() : (this.len -= e, this.off += e);
  }
  forward2(e) {
    this.ins == -1 ? this.forward(e) : e == this.ins ? this.next() : (this.ins -= e, this.off += e);
  }
}
class Dn {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.flags = i;
  }
  /**
  The anchor of the range—the side that doesn't move when you
  extend it.
  */
  get anchor() {
    return this.flags & 32 ? this.to : this.from;
  }
  /**
  The head of the range, which is moved when the range is
  [extended](https://codemirror.net/6/docs/ref/#state.SelectionRange.extend).
  */
  get head() {
    return this.flags & 32 ? this.from : this.to;
  }
  /**
  True when `anchor` and `head` are at the same position.
  */
  get empty() {
    return this.from == this.to;
  }
  /**
  If this is a cursor that is explicitly associated with the
  character on one of its sides, this returns the side. -1 means
  the character before its position, 1 the character after, and 0
  means no association.
  */
  get assoc() {
    return this.flags & 8 ? -1 : this.flags & 16 ? 1 : 0;
  }
  /**
  The bidirectional text level associated with this cursor, if
  any.
  */
  get bidiLevel() {
    let e = this.flags & 7;
    return e == 7 ? null : e;
  }
  /**
  The goal column (stored vertical offset) associated with a
  cursor. This is used to preserve the vertical position when
  [moving](https://codemirror.net/6/docs/ref/#view.EditorView.moveVertically) across
  lines of different length.
  */
  get goalColumn() {
    let e = this.flags >> 6;
    return e == 16777215 ? void 0 : e;
  }
  /**
  Map this range through a change, producing a valid range in the
  updated document.
  */
  map(e, t = -1) {
    let i, r;
    return this.empty ? i = r = e.mapPos(this.from, t) : (i = e.mapPos(this.from, 1), r = e.mapPos(this.to, -1)), i == this.from && r == this.to ? this : new Dn(i, r, this.flags);
  }
  /**
  Extend this range to cover at least `from` to `to`.
  */
  extend(e, t = e) {
    if (e <= this.anchor && t >= this.anchor)
      return T.range(e, t);
    let i = Math.abs(e - this.anchor) > Math.abs(t - this.anchor) ? e : t;
    return T.range(this.anchor, i);
  }
  /**
  Compare this range to another range.
  */
  eq(e, t = !1) {
    return this.anchor == e.anchor && this.head == e.head && (!t || !this.empty || this.assoc == e.assoc);
  }
  /**
  Return a JSON-serializable object representing the range.
  */
  toJSON() {
    return { anchor: this.anchor, head: this.head };
  }
  /**
  Convert a JSON representation of a range to a `SelectionRange`
  instance.
  */
  static fromJSON(e) {
    if (!e || typeof e.anchor != "number" || typeof e.head != "number")
      throw new RangeError("Invalid JSON representation for SelectionRange");
    return T.range(e.anchor, e.head);
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new Dn(e, t, i);
  }
}
class T {
  constructor(e, t) {
    this.ranges = e, this.mainIndex = t;
  }
  /**
  Map a selection through a change. Used to adjust the selection
  position for changes.
  */
  map(e, t = -1) {
    return e.empty ? this : T.create(this.ranges.map((i) => i.map(e, t)), this.mainIndex);
  }
  /**
  Compare this selection to another selection. By default, ranges
  are compared only by position. When `includeAssoc` is true,
  cursor ranges must also have the same
  [`assoc`](https://codemirror.net/6/docs/ref/#state.SelectionRange.assoc) value.
  */
  eq(e, t = !1) {
    if (this.ranges.length != e.ranges.length || this.mainIndex != e.mainIndex)
      return !1;
    for (let i = 0; i < this.ranges.length; i++)
      if (!this.ranges[i].eq(e.ranges[i], t))
        return !1;
    return !0;
  }
  /**
  Get the primary selection range. Usually, you should make sure
  your code applies to _all_ ranges, by using methods like
  [`changeByRange`](https://codemirror.net/6/docs/ref/#state.EditorState.changeByRange).
  */
  get main() {
    return this.ranges[this.mainIndex];
  }
  /**
  Make sure the selection only has one range. Returns a selection
  holding only the main range from this selection.
  */
  asSingle() {
    return this.ranges.length == 1 ? this : new T([this.main], 0);
  }
  /**
  Extend this selection with an extra range.
  */
  addRange(e, t = !0) {
    return T.create([e].concat(this.ranges), t ? 0 : this.mainIndex + 1);
  }
  /**
  Replace a given range with another range, and then normalize the
  selection to merge and sort ranges if necessary.
  */
  replaceRange(e, t = this.mainIndex) {
    let i = this.ranges.slice();
    return i[t] = e, T.create(i, this.mainIndex);
  }
  /**
  Convert this selection to an object that can be serialized to
  JSON.
  */
  toJSON() {
    return { ranges: this.ranges.map((e) => e.toJSON()), main: this.mainIndex };
  }
  /**
  Create a selection from a JSON representation.
  */
  static fromJSON(e) {
    if (!e || !Array.isArray(e.ranges) || typeof e.main != "number" || e.main >= e.ranges.length)
      throw new RangeError("Invalid JSON representation for EditorSelection");
    return new T(e.ranges.map((t) => Dn.fromJSON(t)), e.main);
  }
  /**
  Create a selection holding a single range.
  */
  static single(e, t = e) {
    return new T([T.range(e, t)], 0);
  }
  /**
  Sort and merge the given set of ranges, creating a valid
  selection.
  */
  static create(e, t = 0) {
    if (e.length == 0)
      throw new RangeError("A selection needs at least one range");
    for (let i = 0, r = 0; r < e.length; r++) {
      let s = e[r];
      if (s.empty ? s.from <= i : s.from < i)
        return T.normalized(e.slice(), t);
      i = s.to;
    }
    return new T(e, t);
  }
  /**
  Create a cursor selection range at the given position. You can
  safely ignore the optional arguments in most situations.
  */
  static cursor(e, t = 0, i, r) {
    return Dn.create(e, e, (t == 0 ? 0 : t < 0 ? 8 : 16) | (i == null ? 7 : Math.min(6, i)) | (r ?? 16777215) << 6);
  }
  /**
  Create a selection range.
  */
  static range(e, t, i, r) {
    let s = (i ?? 16777215) << 6 | (r == null ? 7 : Math.min(6, r));
    return t < e ? Dn.create(t, e, 48 | s) : Dn.create(e, t, (t > e ? 8 : 0) | s);
  }
  /**
  @internal
  */
  static normalized(e, t = 0) {
    let i = e[t];
    e.sort((r, s) => r.from - s.from), t = e.indexOf(i);
    for (let r = 1; r < e.length; r++) {
      let s = e[r], o = e[r - 1];
      if (s.empty ? s.from <= o.to : s.from < o.to) {
        let l = o.from, a = Math.max(s.to, o.to);
        r <= t && t--, e.splice(--r, 2, s.anchor > s.head ? T.range(a, l) : T.range(l, a));
      }
    }
    return new T(e, t);
  }
}
function Eh(n, e) {
  for (let t of n.ranges)
    if (t.to > e)
      throw new RangeError("Selection points outside of document");
}
let Zl = 0;
class j {
  constructor(e, t, i, r, s) {
    this.combine = e, this.compareInput = t, this.compare = i, this.isStatic = r, this.id = Zl++, this.default = e([]), this.extensions = typeof s == "function" ? s(this) : s;
  }
  /**
  Returns a facet reader for this facet, which can be used to
  [read](https://codemirror.net/6/docs/ref/#state.EditorState.facet) it but not to define values for it.
  */
  get reader() {
    return this;
  }
  /**
  Define a new facet.
  */
  static define(e = {}) {
    return new j(e.combine || ((t) => t), e.compareInput || ((t, i) => t === i), e.compare || (e.combine ? (t, i) => t === i : ea), !!e.static, e.enables);
  }
  /**
  Returns an extension that adds the given value to this facet.
  */
  of(e) {
    return new qr([], this, 0, e);
  }
  /**
  Create an extension that computes a value for the facet from a
  state. You must take care to declare the parts of the state that
  this value depends on, since your function is only called again
  for a new state when one of those parts changed.
  
  In cases where your value depends only on a single field, you'll
  want to use the [`from`](https://codemirror.net/6/docs/ref/#state.Facet.from) method instead.
  */
  compute(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new qr(e, this, 1, t);
  }
  /**
  Create an extension that computes zero or more values for this
  facet from a state.
  */
  computeN(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new qr(e, this, 2, t);
  }
  from(e, t) {
    return t || (t = (i) => i), this.compute([e], (i) => t(i.field(e)));
  }
}
function ea(n, e) {
  return n == e || n.length == e.length && n.every((t, i) => t === e[i]);
}
class qr {
  constructor(e, t, i, r) {
    this.dependencies = e, this.facet = t, this.type = i, this.value = r, this.id = Zl++;
  }
  dynamicSlot(e) {
    var t;
    let i = this.value, r = this.facet.compareInput, s = this.id, o = e[s] >> 1, l = this.type == 2, a = !1, u = !1, c = [];
    for (let h of this.dependencies)
      h == "doc" ? a = !0 : h == "selection" ? u = !0 : ((t = e[h.id]) !== null && t !== void 0 ? t : 1) & 1 || c.push(e[h.id]);
    return {
      create(h) {
        return h.values[o] = i(h), 1;
      },
      update(h, f) {
        if (a && f.docChanged || u && (f.docChanged || f.selection) || Go(h, c)) {
          let d = i(h);
          if (l ? !Ya(d, h.values[o], r) : !r(d, h.values[o]))
            return h.values[o] = d, 1;
        }
        return 0;
      },
      reconfigure: (h, f) => {
        let d, p = f.config.address[s];
        if (p != null) {
          let g = is(f, p);
          if (this.dependencies.every((m) => m instanceof j ? f.facet(m) === h.facet(m) : m instanceof Ne ? f.field(m, !1) == h.field(m, !1) : !0) || (l ? Ya(d = i(h), g, r) : r(d = i(h), g)))
            return h.values[o] = g, 0;
        } else
          d = i(h);
        return h.values[o] = d, 1;
      }
    };
  }
}
function Ya(n, e, t) {
  if (n.length != e.length)
    return !1;
  for (let i = 0; i < n.length; i++)
    if (!t(n[i], e[i]))
      return !1;
  return !0;
}
function Go(n, e) {
  let t = !1;
  for (let i of e)
    zi(n, i) & 1 && (t = !0);
  return t;
}
function Ym(n, e, t) {
  let i = t.map((a) => n[a.id]), r = t.map((a) => a.type), s = i.filter((a) => !(a & 1)), o = n[e.id] >> 1;
  function l(a) {
    let u = [];
    for (let c = 0; c < i.length; c++) {
      let h = is(a, i[c]);
      if (r[c] == 2)
        for (let f of h)
          u.push(f);
      else
        u.push(h);
    }
    return e.combine(u);
  }
  return {
    create(a) {
      for (let u of i)
        zi(a, u);
      return a.values[o] = l(a), 1;
    },
    update(a, u) {
      if (!Go(a, s))
        return 0;
      let c = l(a);
      return e.compare(c, a.values[o]) ? 0 : (a.values[o] = c, 1);
    },
    reconfigure(a, u) {
      let c = Go(a, i), h = u.config.facets[e.id], f = u.facet(e);
      if (h && !c && ea(t, h))
        return a.values[o] = f, 0;
      let d = l(a);
      return e.compare(d, f) ? (a.values[o] = f, 0) : (a.values[o] = d, 1);
    }
  };
}
const Xa = /* @__PURE__ */ j.define({ static: !0 });
class Ne {
  constructor(e, t, i, r, s) {
    this.id = e, this.createF = t, this.updateF = i, this.compareF = r, this.spec = s, this.provides = void 0;
  }
  /**
  Define a state field.
  */
  static define(e) {
    let t = new Ne(Zl++, e.create, e.update, e.compare || ((i, r) => i === r), e);
    return e.provide && (t.provides = e.provide(t)), t;
  }
  create(e) {
    let t = e.facet(Xa).find((i) => i.field == this);
    return ((t == null ? void 0 : t.create) || this.createF)(e);
  }
  /**
  @internal
  */
  slot(e) {
    let t = e[this.id] >> 1;
    return {
      create: (i) => (i.values[t] = this.create(i), 1),
      update: (i, r) => {
        let s = i.values[t], o = this.updateF(s, r);
        return this.compareF(s, o) ? 0 : (i.values[t] = o, 1);
      },
      reconfigure: (i, r) => r.config.address[this.id] != null ? (i.values[t] = r.field(this), 0) : (i.values[t] = this.create(i), 1)
    };
  }
  /**
  Returns an extension that enables this field and overrides the
  way it is initialized. Can be useful when you need to provide a
  non-default starting value for the field.
  */
  init(e) {
    return [this, Xa.of({ field: this, create: e })];
  }
  /**
  State field instances can be used as
  [`Extension`](https://codemirror.net/6/docs/ref/#state.Extension) values to enable the field in a
  given state.
  */
  get extension() {
    return this;
  }
}
const Mn = { lowest: 4, low: 3, default: 2, high: 1, highest: 0 };
function ki(n) {
  return (e) => new Lh(e, n);
}
const Hn = {
  /**
  The highest precedence level, for extensions that should end up
  near the start of the precedence ordering.
  */
  highest: /* @__PURE__ */ ki(Mn.highest),
  /**
  A higher-than-default precedence, for extensions that should
  come before those with default precedence.
  */
  high: /* @__PURE__ */ ki(Mn.high),
  /**
  The default precedence, which is also used for extensions
  without an explicit precedence.
  */
  default: /* @__PURE__ */ ki(Mn.default),
  /**
  A lower-than-default precedence.
  */
  low: /* @__PURE__ */ ki(Mn.low),
  /**
  The lowest precedence level. Meant for things that should end up
  near the end of the extension order.
  */
  lowest: /* @__PURE__ */ ki(Mn.lowest)
};
class Lh {
  constructor(e, t) {
    this.inner = e, this.prec = t;
  }
}
class ir {
  /**
  Create an instance of this compartment to add to your [state
  configuration](https://codemirror.net/6/docs/ref/#state.EditorStateConfig.extensions).
  */
  of(e) {
    return new Yo(this, e);
  }
  /**
  Create an [effect](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) that
  reconfigures this compartment.
  */
  reconfigure(e) {
    return ir.reconfigure.of({ compartment: this, extension: e });
  }
  /**
  Get the current content of the compartment in the state, or
  `undefined` if it isn't present.
  */
  get(e) {
    return e.config.compartments.get(this);
  }
}
class Yo {
  constructor(e, t) {
    this.compartment = e, this.inner = t;
  }
}
class ns {
  constructor(e, t, i, r, s, o) {
    for (this.base = e, this.compartments = t, this.dynamicSlots = i, this.address = r, this.staticValues = s, this.facets = o, this.statusTemplate = []; this.statusTemplate.length < i.length; )
      this.statusTemplate.push(
        0
        /* SlotStatus.Unresolved */
      );
  }
  staticFacet(e) {
    let t = this.address[e.id];
    return t == null ? e.default : this.staticValues[t >> 1];
  }
  static resolve(e, t, i) {
    let r = [], s = /* @__PURE__ */ Object.create(null), o = /* @__PURE__ */ new Map();
    for (let f of Xm(e, t, o))
      f instanceof Ne ? r.push(f) : (s[f.facet.id] || (s[f.facet.id] = [])).push(f);
    let l = /* @__PURE__ */ Object.create(null), a = [], u = [];
    for (let f of r)
      l[f.id] = u.length << 1, u.push((d) => f.slot(d));
    let c = i == null ? void 0 : i.config.facets;
    for (let f in s) {
      let d = s[f], p = d[0].facet, g = c && c[f] || [];
      if (d.every(
        (m) => m.type == 0
        /* Provider.Static */
      ))
        if (l[p.id] = a.length << 1 | 1, ea(g, d))
          a.push(i.facet(p));
        else {
          let m = p.combine(d.map((y) => y.value));
          a.push(i && p.compare(m, i.facet(p)) ? i.facet(p) : m);
        }
      else {
        for (let m of d)
          m.type == 0 ? (l[m.id] = a.length << 1 | 1, a.push(m.value)) : (l[m.id] = u.length << 1, u.push((y) => m.dynamicSlot(y)));
        l[p.id] = u.length << 1, u.push((m) => Ym(m, p, d));
      }
    }
    let h = u.map((f) => f(l));
    return new ns(e, o, h, l, a, s);
  }
}
function Xm(n, e, t) {
  let i = [[], [], [], [], []], r = /* @__PURE__ */ new Map();
  function s(o, l) {
    let a = r.get(o);
    if (a != null) {
      if (a <= l)
        return;
      let u = i[a].indexOf(o);
      u > -1 && i[a].splice(u, 1), o instanceof Yo && t.delete(o.compartment);
    }
    if (r.set(o, l), Array.isArray(o))
      for (let u of o)
        s(u, l);
    else if (o instanceof Yo) {
      if (t.has(o.compartment))
        throw new RangeError("Duplicate use of compartment in extensions");
      let u = e.get(o.compartment) || o.inner;
      t.set(o.compartment, u), s(u, l);
    } else if (o instanceof Lh)
      s(o.inner, o.prec);
    else if (o instanceof Ne)
      i[l].push(o), o.provides && s(o.provides, l);
    else if (o instanceof qr)
      i[l].push(o), o.facet.extensions && s(o.facet.extensions, Mn.default);
    else {
      let u = o.extension;
      if (!u)
        throw new Error(`Unrecognized extension value in extension set (${o}). This sometimes happens because multiple instances of @codemirror/state are loaded, breaking instanceof checks.`);
      s(u, l);
    }
  }
  return s(n, Mn.default), i.reduce((o, l) => o.concat(l));
}
function zi(n, e) {
  if (e & 1)
    return 2;
  let t = e >> 1, i = n.status[t];
  if (i == 4)
    throw new Error("Cyclic dependency between fields and/or facets");
  if (i & 2)
    return i;
  n.status[t] = 4;
  let r = n.computeSlot(n, n.config.dynamicSlots[t]);
  return n.status[t] = 2 | r;
}
function is(n, e) {
  return e & 1 ? n.config.staticValues[e >> 1] : n.values[e >> 1];
}
const Ih = /* @__PURE__ */ j.define(), Xo = /* @__PURE__ */ j.define({
  combine: (n) => n.some((e) => e),
  static: !0
}), Ph = /* @__PURE__ */ j.define({
  combine: (n) => n.length ? n[0] : void 0,
  static: !0
}), Bh = /* @__PURE__ */ j.define(), Rh = /* @__PURE__ */ j.define(), Nh = /* @__PURE__ */ j.define(), Fh = /* @__PURE__ */ j.define({
  combine: (n) => n.length ? n[0] : !1
});
class Xt {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Define a new type of annotation.
  */
  static define() {
    return new Jm();
  }
}
class Jm {
  /**
  Create an instance of this annotation.
  */
  of(e) {
    return new Xt(this, e);
  }
}
class Qm {
  /**
  @internal
  */
  constructor(e) {
    this.map = e;
  }
  /**
  Create a [state effect](https://codemirror.net/6/docs/ref/#state.StateEffect) instance of this
  type.
  */
  of(e) {
    return new X(this, e);
  }
}
class X {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Map this effect through a position mapping. Will return
  `undefined` when that ends up deleting the effect.
  */
  map(e) {
    let t = this.type.map(this.value, e);
    return t === void 0 ? void 0 : t == this.value ? this : new X(this.type, t);
  }
  /**
  Tells you whether this effect object is of a given
  [type](https://codemirror.net/6/docs/ref/#state.StateEffectType).
  */
  is(e) {
    return this.type == e;
  }
  /**
  Define a new effect type. The type parameter indicates the type
  of values that his effect holds. It should be a type that
  doesn't include `undefined`, since that is used in
  [mapping](https://codemirror.net/6/docs/ref/#state.StateEffect.map) to indicate that an effect is
  removed.
  */
  static define(e = {}) {
    return new Qm(e.map || ((t) => t));
  }
  /**
  Map an array of effects through a change set.
  */
  static mapEffects(e, t) {
    if (!e.length)
      return e;
    let i = [];
    for (let r of e) {
      let s = r.map(t);
      s && i.push(s);
    }
    return i;
  }
}
X.reconfigure = /* @__PURE__ */ X.define();
X.appendConfig = /* @__PURE__ */ X.define();
class Oe {
  constructor(e, t, i, r, s, o) {
    this.startState = e, this.changes = t, this.selection = i, this.effects = r, this.annotations = s, this.scrollIntoView = o, this._doc = null, this._state = null, i && Eh(i, t.newLength), s.some((l) => l.type == Oe.time) || (this.annotations = s.concat(Oe.time.of(Date.now())));
  }
  /**
  @internal
  */
  static create(e, t, i, r, s, o) {
    return new Oe(e, t, i, r, s, o);
  }
  /**
  The new document produced by the transaction. Contrary to
  [`.state`](https://codemirror.net/6/docs/ref/#state.Transaction.state)`.doc`, accessing this won't
  force the entire new state to be computed right away, so it is
  recommended that [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) use this getter
  when they need to look at the new document.
  */
  get newDoc() {
    return this._doc || (this._doc = this.changes.apply(this.startState.doc));
  }
  /**
  The new selection produced by the transaction. If
  [`this.selection`](https://codemirror.net/6/docs/ref/#state.Transaction.selection) is undefined,
  this will [map](https://codemirror.net/6/docs/ref/#state.EditorSelection.map) the start state's
  current selection through the changes made by the transaction.
  */
  get newSelection() {
    return this.selection || this.startState.selection.map(this.changes);
  }
  /**
  The new state created by the transaction. Computed on demand
  (but retained for subsequent access), so it is recommended not to
  access it in [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) when possible.
  */
  get state() {
    return this._state || this.startState.applyTransaction(this), this._state;
  }
  /**
  Get the value of the given annotation type, if any.
  */
  annotation(e) {
    for (let t of this.annotations)
      if (t.type == e)
        return t.value;
  }
  /**
  Indicates whether the transaction changed the document.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Indicates whether this transaction reconfigures the state
  (through a [configuration compartment](https://codemirror.net/6/docs/ref/#state.Compartment) or
  with a top-level configuration
  [effect](https://codemirror.net/6/docs/ref/#state.StateEffect^reconfigure).
  */
  get reconfigured() {
    return this.startState.config != this.state.config;
  }
  /**
  Returns true if the transaction has a [user
  event](https://codemirror.net/6/docs/ref/#state.Transaction^userEvent) annotation that is equal to
  or more specific than `event`. For example, if the transaction
  has `"select.pointer"` as user event, `"select"` and
  `"select.pointer"` will match it.
  */
  isUserEvent(e) {
    let t = this.annotation(Oe.userEvent);
    return !!(t && (t == e || t.length > e.length && t.slice(0, e.length) == e && t[e.length] == "."));
  }
}
Oe.time = /* @__PURE__ */ Xt.define();
Oe.userEvent = /* @__PURE__ */ Xt.define();
Oe.addToHistory = /* @__PURE__ */ Xt.define();
Oe.remote = /* @__PURE__ */ Xt.define();
function Zm(n, e) {
  let t = [];
  for (let i = 0, r = 0; ; ) {
    let s, o;
    if (i < n.length && (r == e.length || e[r] >= n[i]))
      s = n[i++], o = n[i++];
    else if (r < e.length)
      s = e[r++], o = e[r++];
    else
      return t;
    !t.length || t[t.length - 1] < s ? t.push(s, o) : t[t.length - 1] < o && (t[t.length - 1] = o);
  }
}
function zh(n, e, t) {
  var i;
  let r, s, o;
  return t ? (r = e.changes, s = Te.empty(e.changes.length), o = n.changes.compose(e.changes)) : (r = e.changes.map(n.changes), s = n.changes.mapDesc(e.changes, !0), o = n.changes.compose(r)), {
    changes: o,
    selection: e.selection ? e.selection.map(s) : (i = n.selection) === null || i === void 0 ? void 0 : i.map(r),
    effects: X.mapEffects(n.effects, r).concat(X.mapEffects(e.effects, s)),
    annotations: n.annotations.length ? n.annotations.concat(e.annotations) : e.annotations,
    scrollIntoView: n.scrollIntoView || e.scrollIntoView
  };
}
function Jo(n, e, t) {
  let i = e.selection, r = Qn(e.annotations);
  return e.userEvent && (r = r.concat(Oe.userEvent.of(e.userEvent))), {
    changes: e.changes instanceof Te ? e.changes : Te.of(e.changes || [], t, n.facet(Ph)),
    selection: i && (i instanceof T ? i : T.single(i.anchor, i.head)),
    effects: Qn(e.effects),
    annotations: r,
    scrollIntoView: !!e.scrollIntoView
  };
}
function Hh(n, e, t) {
  let i = Jo(n, e.length ? e[0] : {}, n.doc.length);
  e.length && e[0].filter === !1 && (t = !1);
  for (let s = 1; s < e.length; s++) {
    e[s].filter === !1 && (t = !1);
    let o = !!e[s].sequential;
    i = zh(i, Jo(n, e[s], o ? i.changes.newLength : n.doc.length), o);
  }
  let r = Oe.create(n, i.changes, i.selection, i.effects, i.annotations, i.scrollIntoView);
  return tg(t ? eg(r) : r);
}
function eg(n) {
  let e = n.startState, t = !0;
  for (let r of e.facet(Bh)) {
    let s = r(n);
    if (s === !1) {
      t = !1;
      break;
    }
    Array.isArray(s) && (t = t === !0 ? s : Zm(t, s));
  }
  if (t !== !0) {
    let r, s;
    if (t === !1)
      s = n.changes.invertedDesc, r = Te.empty(e.doc.length);
    else {
      let o = n.changes.filter(t);
      r = o.changes, s = o.filtered.mapDesc(o.changes).invertedDesc;
    }
    n = Oe.create(e, r, n.selection && n.selection.map(s), X.mapEffects(n.effects, s), n.annotations, n.scrollIntoView);
  }
  let i = e.facet(Rh);
  for (let r = i.length - 1; r >= 0; r--) {
    let s = i[r](n);
    s instanceof Oe ? n = s : Array.isArray(s) && s.length == 1 && s[0] instanceof Oe ? n = s[0] : n = Hh(e, Qn(s), !1);
  }
  return n;
}
function tg(n) {
  let e = n.startState, t = e.facet(Nh), i = n;
  for (let r = t.length - 1; r >= 0; r--) {
    let s = t[r](n);
    s && Object.keys(s).length && (i = zh(i, Jo(e, s, n.changes.newLength), !0));
  }
  return i == n ? n : Oe.create(e, n.changes, n.selection, i.effects, i.annotations, i.scrollIntoView);
}
const ng = [];
function Qn(n) {
  return n == null ? ng : Array.isArray(n) ? n : [n];
}
var be = /* @__PURE__ */ function(n) {
  return n[n.Word = 0] = "Word", n[n.Space = 1] = "Space", n[n.Other = 2] = "Other", n;
}(be || (be = {}));
const ig = /[\u00df\u0587\u0590-\u05f4\u0600-\u06ff\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/;
let Qo;
try {
  Qo = /* @__PURE__ */ new RegExp("[\\p{Alphabetic}\\p{Number}_]", "u");
} catch {
}
function rg(n) {
  if (Qo)
    return Qo.test(n);
  for (let e = 0; e < n.length; e++) {
    let t = n[e];
    if (/\w/.test(t) || t > "" && (t.toUpperCase() != t.toLowerCase() || ig.test(t)))
      return !0;
  }
  return !1;
}
function sg(n) {
  return (e) => {
    if (!/\S/.test(e))
      return be.Space;
    if (rg(e))
      return be.Word;
    for (let t = 0; t < n.length; t++)
      if (e.indexOf(n[t]) > -1)
        return be.Word;
    return be.Other;
  };
}
class Q {
  constructor(e, t, i, r, s, o) {
    this.config = e, this.doc = t, this.selection = i, this.values = r, this.status = e.statusTemplate.slice(), this.computeSlot = s, o && (o._state = this);
    for (let l = 0; l < this.config.dynamicSlots.length; l++)
      zi(this, l << 1);
    this.computeSlot = null;
  }
  field(e, t = !0) {
    let i = this.config.address[e.id];
    if (i == null) {
      if (t)
        throw new RangeError("Field is not present in this state");
      return;
    }
    return zi(this, i), is(this, i);
  }
  /**
  Create a [transaction](https://codemirror.net/6/docs/ref/#state.Transaction) that updates this
  state. Any number of [transaction specs](https://codemirror.net/6/docs/ref/#state.TransactionSpec)
  can be passed. Unless
  [`sequential`](https://codemirror.net/6/docs/ref/#state.TransactionSpec.sequential) is set, the
  [changes](https://codemirror.net/6/docs/ref/#state.TransactionSpec.changes) (if any) of each spec
  are assumed to start in the _current_ document (not the document
  produced by previous specs), and its
  [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection) and
  [effects](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) are assumed to refer
  to the document created by its _own_ changes. The resulting
  transaction contains the combined effect of all the different
  specs. For [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection), later
  specs take precedence over earlier ones.
  */
  update(...e) {
    return Hh(this, e, !0);
  }
  /**
  @internal
  */
  applyTransaction(e) {
    let t = this.config, { base: i, compartments: r } = t;
    for (let l of e.effects)
      l.is(ir.reconfigure) ? (t && (r = /* @__PURE__ */ new Map(), t.compartments.forEach((a, u) => r.set(u, a)), t = null), r.set(l.value.compartment, l.value.extension)) : l.is(X.reconfigure) ? (t = null, i = l.value) : l.is(X.appendConfig) && (t = null, i = Qn(i).concat(l.value));
    let s;
    t ? s = e.startState.values.slice() : (t = ns.resolve(i, r, this), s = new Q(t, this.doc, this.selection, t.dynamicSlots.map(() => null), (a, u) => u.reconfigure(a, this), null).values);
    let o = e.startState.facet(Xo) ? e.newSelection : e.newSelection.asSingle();
    new Q(t, e.newDoc, o, s, (l, a) => a.update(l, e), e);
  }
  /**
  Create a [transaction spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec) that
  replaces every selection range with the given content.
  */
  replaceSelection(e) {
    return typeof e == "string" && (e = this.toText(e)), this.changeByRange((t) => ({
      changes: { from: t.from, to: t.to, insert: e },
      range: T.cursor(t.from + e.length)
    }));
  }
  /**
  Create a set of changes and a new selection by running the given
  function for each range in the active selection. The function
  can return an optional set of changes (in the coordinate space
  of the start document), plus an updated range (in the coordinate
  space of the document produced by the call's own changes). This
  method will merge all the changes and ranges into a single
  changeset and selection, and return it as a [transaction
  spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec), which can be passed to
  [`update`](https://codemirror.net/6/docs/ref/#state.EditorState.update).
  */
  changeByRange(e) {
    let t = this.selection, i = e(t.ranges[0]), r = this.changes(i.changes), s = [i.range], o = Qn(i.effects);
    for (let l = 1; l < t.ranges.length; l++) {
      let a = e(t.ranges[l]), u = this.changes(a.changes), c = u.map(r);
      for (let f = 0; f < l; f++)
        s[f] = s[f].map(c);
      let h = r.mapDesc(u, !0);
      s.push(a.range.map(h)), r = r.compose(c), o = X.mapEffects(o, c).concat(X.mapEffects(Qn(a.effects), h));
    }
    return {
      changes: r,
      selection: T.create(s, t.mainIndex),
      effects: o
    };
  }
  /**
  Create a [change set](https://codemirror.net/6/docs/ref/#state.ChangeSet) from the given change
  description, taking the state's document length and line
  separator into account.
  */
  changes(e = []) {
    return e instanceof Te ? e : Te.of(e, this.doc.length, this.facet(Q.lineSeparator));
  }
  /**
  Using the state's [line
  separator](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator), create a
  [`Text`](https://codemirror.net/6/docs/ref/#state.Text) instance from the given string.
  */
  toText(e) {
    return re.of(e.split(this.facet(Q.lineSeparator) || qo));
  }
  /**
  Return the given range of the document as a string.
  */
  sliceDoc(e = 0, t = this.doc.length) {
    return this.doc.sliceString(e, t, this.lineBreak);
  }
  /**
  Get the value of a state [facet](https://codemirror.net/6/docs/ref/#state.Facet).
  */
  facet(e) {
    let t = this.config.address[e.id];
    return t == null ? e.default : (zi(this, t), is(this, t));
  }
  /**
  Convert this state to a JSON-serializable object. When custom
  fields should be serialized, you can pass them in as an object
  mapping property names (in the resulting object, which should
  not use `doc` or `selection`) to fields.
  */
  toJSON(e) {
    let t = {
      doc: this.sliceDoc(),
      selection: this.selection.toJSON()
    };
    if (e)
      for (let i in e) {
        let r = e[i];
        r instanceof Ne && this.config.address[r.id] != null && (t[i] = r.spec.toJSON(this.field(e[i]), this));
      }
    return t;
  }
  /**
  Deserialize a state from its JSON representation. When custom
  fields should be deserialized, pass the same object you passed
  to [`toJSON`](https://codemirror.net/6/docs/ref/#state.EditorState.toJSON) when serializing as
  third argument.
  */
  static fromJSON(e, t = {}, i) {
    if (!e || typeof e.doc != "string")
      throw new RangeError("Invalid JSON representation for EditorState");
    let r = [];
    if (i) {
      for (let s in i)
        if (Object.prototype.hasOwnProperty.call(e, s)) {
          let o = i[s], l = e[s];
          r.push(o.init((a) => o.spec.fromJSON(l, a)));
        }
    }
    return Q.create({
      doc: e.doc,
      selection: T.fromJSON(e.selection),
      extensions: t.extensions ? r.concat([t.extensions]) : r
    });
  }
  /**
  Create a new state. You'll usually only need this when
  initializing an editor—updated states are created by applying
  transactions.
  */
  static create(e = {}) {
    let t = ns.resolve(e.extensions || [], /* @__PURE__ */ new Map()), i = e.doc instanceof re ? e.doc : re.of((e.doc || "").split(t.staticFacet(Q.lineSeparator) || qo)), r = e.selection ? e.selection instanceof T ? e.selection : T.single(e.selection.anchor, e.selection.head) : T.single(0);
    return Eh(r, i.length), t.staticFacet(Xo) || (r = r.asSingle()), new Q(t, i, r, t.dynamicSlots.map(() => null), (s, o) => o.create(s), null);
  }
  /**
  The size (in columns) of a tab in the document, determined by
  the [`tabSize`](https://codemirror.net/6/docs/ref/#state.EditorState^tabSize) facet.
  */
  get tabSize() {
    return this.facet(Q.tabSize);
  }
  /**
  Get the proper [line-break](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator)
  string for this state.
  */
  get lineBreak() {
    return this.facet(Q.lineSeparator) || `
`;
  }
  /**
  Returns true when the editor is
  [configured](https://codemirror.net/6/docs/ref/#state.EditorState^readOnly) to be read-only.
  */
  get readOnly() {
    return this.facet(Fh);
  }
  /**
  Look up a translation for the given phrase (via the
  [`phrases`](https://codemirror.net/6/docs/ref/#state.EditorState^phrases) facet), or return the
  original string if no translation is found.
  
  If additional arguments are passed, they will be inserted in
  place of markers like `$1` (for the first value) and `$2`, etc.
  A single `$` is equivalent to `$1`, and `$$` will produce a
  literal dollar sign.
  */
  phrase(e, ...t) {
    for (let i of this.facet(Q.phrases))
      if (Object.prototype.hasOwnProperty.call(i, e)) {
        e = i[e];
        break;
      }
    return t.length && (e = e.replace(/\$(\$|\d*)/g, (i, r) => {
      if (r == "$")
        return "$";
      let s = +(r || 1);
      return !s || s > t.length ? i : t[s - 1];
    })), e;
  }
  /**
  Find the values for a given language data field, provided by the
  the [`languageData`](https://codemirror.net/6/docs/ref/#state.EditorState^languageData) facet.
  
  Examples of language data fields are...
  
  - [`"commentTokens"`](https://codemirror.net/6/docs/ref/#commands.CommentTokens) for specifying
    comment syntax.
  - [`"autocomplete"`](https://codemirror.net/6/docs/ref/#autocomplete.autocompletion^config.override)
    for providing language-specific completion sources.
  - [`"wordChars"`](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) for adding
    characters that should be considered part of words in this
    language.
  - [`"closeBrackets"`](https://codemirror.net/6/docs/ref/#autocomplete.CloseBracketConfig) controls
    bracket closing behavior.
  */
  languageDataAt(e, t, i = -1) {
    let r = [];
    for (let s of this.facet(Ih))
      for (let o of s(this, t, i))
        Object.prototype.hasOwnProperty.call(o, e) && r.push(o[e]);
    return r;
  }
  /**
  Return a function that can categorize strings (expected to
  represent a single [grapheme cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak))
  into one of:
  
   - Word (contains an alphanumeric character or a character
     explicitly listed in the local language's `"wordChars"`
     language data, which should be a string)
   - Space (contains only whitespace)
   - Other (anything else)
  */
  charCategorizer(e) {
    return sg(this.languageDataAt("wordChars", e).join(""));
  }
  /**
  Find the word at the given position, meaning the range
  containing all [word](https://codemirror.net/6/docs/ref/#state.CharCategory.Word) characters
  around it. If no word characters are adjacent to the position,
  this returns null.
  */
  wordAt(e) {
    let { text: t, from: i, length: r } = this.doc.lineAt(e), s = this.charCategorizer(e), o = e - i, l = e - i;
    for (; o > 0; ) {
      let a = Re(t, o, !1);
      if (s(t.slice(a, o)) != be.Word)
        break;
      o = a;
    }
    for (; l < r; ) {
      let a = Re(t, l);
      if (s(t.slice(l, a)) != be.Word)
        break;
      l = a;
    }
    return o == l ? null : T.range(o + i, l + i);
  }
}
Q.allowMultipleSelections = Xo;
Q.tabSize = /* @__PURE__ */ j.define({
  combine: (n) => n.length ? n[0] : 4
});
Q.lineSeparator = Ph;
Q.readOnly = Fh;
Q.phrases = /* @__PURE__ */ j.define({
  compare(n, e) {
    let t = Object.keys(n), i = Object.keys(e);
    return t.length == i.length && t.every((r) => n[r] == e[r]);
  }
});
Q.languageData = Ih;
Q.changeFilter = Bh;
Q.transactionFilter = Rh;
Q.transactionExtender = Nh;
ir.reconfigure = /* @__PURE__ */ X.define();
function Vt(n, e, t = {}) {
  let i = {};
  for (let r of n)
    for (let s of Object.keys(r)) {
      let o = r[s], l = i[s];
      if (l === void 0)
        i[s] = o;
      else if (!(l === o || o === void 0))
        if (Object.hasOwnProperty.call(t, s))
          i[s] = t[s](l, o);
        else
          throw new Error("Config merge conflict for field " + s);
    }
  for (let r in e)
    i[r] === void 0 && (i[r] = e[r]);
  return i;
}
class Pn {
  /**
  Compare this value with another value. Used when comparing
  rangesets. The default implementation compares by identity.
  Unless you are only creating a fixed number of unique instances
  of your value type, it is a good idea to implement this
  properly.
  */
  eq(e) {
    return this == e;
  }
  /**
  Create a [range](https://codemirror.net/6/docs/ref/#state.Range) with this value.
  */
  range(e, t = e) {
    return Zo.create(e, t, this);
  }
}
Pn.prototype.startSide = Pn.prototype.endSide = 0;
Pn.prototype.point = !1;
Pn.prototype.mapMode = qe.TrackDel;
let Zo = class Vh {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.value = i;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new Vh(e, t, i);
  }
};
function el(n, e) {
  return n.from - e.from || n.value.startSide - e.value.startSide;
}
class ta {
  constructor(e, t, i, r) {
    this.from = e, this.to = t, this.value = i, this.maxPoint = r;
  }
  get length() {
    return this.to[this.to.length - 1];
  }
  // Find the index of the given position and side. Use the ranges'
  // `from` pos when `end == false`, `to` when `end == true`.
  findIndex(e, t, i, r = 0) {
    let s = i ? this.to : this.from;
    for (let o = r, l = s.length; ; ) {
      if (o == l)
        return o;
      let a = o + l >> 1, u = s[a] - e || (i ? this.value[a].endSide : this.value[a].startSide) - t;
      if (a == o)
        return u >= 0 ? o : l;
      u >= 0 ? l = a : o = a + 1;
    }
  }
  between(e, t, i, r) {
    for (let s = this.findIndex(t, -1e9, !0), o = this.findIndex(i, 1e9, !1, s); s < o; s++)
      if (r(this.from[s] + e, this.to[s] + e, this.value[s]) === !1)
        return !1;
  }
  map(e, t) {
    let i = [], r = [], s = [], o = -1, l = -1;
    for (let a = 0; a < this.value.length; a++) {
      let u = this.value[a], c = this.from[a] + e, h = this.to[a] + e, f, d;
      if (c == h) {
        let p = t.mapPos(c, u.startSide, u.mapMode);
        if (p == null || (f = d = p, u.startSide != u.endSide && (d = t.mapPos(c, u.endSide), d < f)))
          continue;
      } else if (f = t.mapPos(c, u.startSide), d = t.mapPos(h, u.endSide), f > d || f == d && u.startSide > 0 && u.endSide <= 0)
        continue;
      (d - f || u.endSide - u.startSide) < 0 || (o < 0 && (o = f), u.point && (l = Math.max(l, d - f)), i.push(u), r.push(f - o), s.push(d - o));
    }
    return { mapped: i.length ? new ta(r, s, i, l) : null, pos: o };
  }
}
class ie {
  constructor(e, t, i, r) {
    this.chunkPos = e, this.chunk = t, this.nextLayer = i, this.maxPoint = r;
  }
  /**
  @internal
  */
  static create(e, t, i, r) {
    return new ie(e, t, i, r);
  }
  /**
  @internal
  */
  get length() {
    let e = this.chunk.length - 1;
    return e < 0 ? 0 : Math.max(this.chunkEnd(e), this.nextLayer.length);
  }
  /**
  The number of ranges in the set.
  */
  get size() {
    if (this.isEmpty)
      return 0;
    let e = this.nextLayer.size;
    for (let t of this.chunk)
      e += t.value.length;
    return e;
  }
  /**
  @internal
  */
  chunkEnd(e) {
    return this.chunkPos[e] + this.chunk[e].length;
  }
  /**
  Update the range set, optionally adding new ranges or filtering
  out existing ones.
  
  (Note: The type parameter is just there as a kludge to work
  around TypeScript variance issues that prevented `RangeSet<X>`
  from being a subtype of `RangeSet<Y>` when `X` is a subtype of
  `Y`.)
  */
  update(e) {
    let { add: t = [], sort: i = !1, filterFrom: r = 0, filterTo: s = this.length } = e, o = e.filter;
    if (t.length == 0 && !o)
      return this;
    if (i && (t = t.slice().sort(el)), this.isEmpty)
      return t.length ? ie.of(t) : this;
    let l = new _h(this, null, -1).goto(0), a = 0, u = [], c = new dn();
    for (; l.value || a < t.length; )
      if (a < t.length && (l.from - t[a].from || l.startSide - t[a].value.startSide) >= 0) {
        let h = t[a++];
        c.addInner(h.from, h.to, h.value) || u.push(h);
      } else
        l.rangeIndex == 1 && l.chunkIndex < this.chunk.length && (a == t.length || this.chunkEnd(l.chunkIndex) < t[a].from) && (!o || r > this.chunkEnd(l.chunkIndex) || s < this.chunkPos[l.chunkIndex]) && c.addChunk(this.chunkPos[l.chunkIndex], this.chunk[l.chunkIndex]) ? l.nextChunk() : ((!o || r > l.to || s < l.from || o(l.from, l.to, l.value)) && (c.addInner(l.from, l.to, l.value) || u.push(Zo.create(l.from, l.to, l.value))), l.next());
    return c.finishInner(this.nextLayer.isEmpty && !u.length ? ie.empty : this.nextLayer.update({ add: u, filter: o, filterFrom: r, filterTo: s }));
  }
  /**
  Map this range set through a set of changes, return the new set.
  */
  map(e) {
    if (e.empty || this.isEmpty)
      return this;
    let t = [], i = [], r = -1;
    for (let o = 0; o < this.chunk.length; o++) {
      let l = this.chunkPos[o], a = this.chunk[o], u = e.touchesRange(l, l + a.length);
      if (u === !1)
        r = Math.max(r, a.maxPoint), t.push(a), i.push(e.mapPos(l));
      else if (u === !0) {
        let { mapped: c, pos: h } = a.map(l, e);
        c && (r = Math.max(r, c.maxPoint), t.push(c), i.push(h));
      }
    }
    let s = this.nextLayer.map(e);
    return t.length == 0 ? s : new ie(i, t, s || ie.empty, r);
  }
  /**
  Iterate over the ranges that touch the region `from` to `to`,
  calling `f` for each. There is no guarantee that the ranges will
  be reported in any specific order. When the callback returns
  `false`, iteration stops.
  */
  between(e, t, i) {
    if (!this.isEmpty) {
      for (let r = 0; r < this.chunk.length; r++) {
        let s = this.chunkPos[r], o = this.chunk[r];
        if (t >= s && e <= s + o.length && o.between(s, e - s, t - s, i) === !1)
          return;
      }
      this.nextLayer.between(e, t, i);
    }
  }
  /**
  Iterate over the ranges in this set, in order, including all
  ranges that end at or after `from`.
  */
  iter(e = 0) {
    return Ui.from([this]).goto(e);
  }
  /**
  @internal
  */
  get isEmpty() {
    return this.nextLayer == this;
  }
  /**
  Iterate over the ranges in a collection of sets, in order,
  starting from `from`.
  */
  static iter(e, t = 0) {
    return Ui.from(e).goto(t);
  }
  /**
  Iterate over two groups of sets, calling methods on `comparator`
  to notify it of possible differences.
  */
  static compare(e, t, i, r, s = -1) {
    let o = e.filter((h) => h.maxPoint > 0 || !h.isEmpty && h.maxPoint >= s), l = t.filter((h) => h.maxPoint > 0 || !h.isEmpty && h.maxPoint >= s), a = Ja(o, l, i), u = new vi(o, a, s), c = new vi(l, a, s);
    i.iterGaps((h, f, d) => Qa(u, h, c, f, d, r)), i.empty && i.length == 0 && Qa(u, 0, c, 0, 0, r);
  }
  /**
  Compare the contents of two groups of range sets, returning true
  if they are equivalent in the given range.
  */
  static eq(e, t, i = 0, r) {
    r == null && (r = 999999999);
    let s = e.filter((c) => !c.isEmpty && t.indexOf(c) < 0), o = t.filter((c) => !c.isEmpty && e.indexOf(c) < 0);
    if (s.length != o.length)
      return !1;
    if (!s.length)
      return !0;
    let l = Ja(s, o), a = new vi(s, l, 0).goto(i), u = new vi(o, l, 0).goto(i);
    for (; ; ) {
      if (a.to != u.to || !tl(a.active, u.active) || a.point && (!u.point || !a.point.eq(u.point)))
        return !1;
      if (a.to > r)
        return !0;
      a.next(), u.next();
    }
  }
  /**
  Iterate over a group of range sets at the same time, notifying
  the iterator about the ranges covering every given piece of
  content. Returns the open count (see
  [`SpanIterator.span`](https://codemirror.net/6/docs/ref/#state.SpanIterator.span)) at the end
  of the iteration.
  */
  static spans(e, t, i, r, s = -1) {
    let o = new vi(e, null, s).goto(t), l = t, a = o.openStart;
    for (; ; ) {
      let u = Math.min(o.to, i);
      if (o.point) {
        let c = o.activeForPoint(o.to), h = o.pointFrom < t ? c.length + 1 : o.point.startSide < 0 ? c.length : Math.min(c.length, a);
        r.point(l, u, o.point, c, h, o.pointRank), a = Math.min(o.openEnd(u), c.length);
      } else
        u > l && (r.span(l, u, o.active, a), a = o.openEnd(u));
      if (o.to > i)
        return a + (o.point && o.to > i ? 1 : 0);
      l = o.to, o.next();
    }
  }
  /**
  Create a range set for the given range or array of ranges. By
  default, this expects the ranges to be _sorted_ (by start
  position and, if two start at the same position,
  `value.startSide`). You can pass `true` as second argument to
  cause the method to sort them.
  */
  static of(e, t = !1) {
    let i = new dn();
    for (let r of e instanceof Zo ? [e] : t ? og(e) : e)
      i.add(r.from, r.to, r.value);
    return i.finish();
  }
  /**
  Join an array of range sets into a single set.
  */
  static join(e) {
    if (!e.length)
      return ie.empty;
    let t = e[e.length - 1];
    for (let i = e.length - 2; i >= 0; i--)
      for (let r = e[i]; r != ie.empty; r = r.nextLayer)
        t = new ie(r.chunkPos, r.chunk, t, Math.max(r.maxPoint, t.maxPoint));
    return t;
  }
}
ie.empty = /* @__PURE__ */ new ie([], [], null, -1);
function og(n) {
  if (n.length > 1)
    for (let e = n[0], t = 1; t < n.length; t++) {
      let i = n[t];
      if (el(e, i) > 0)
        return n.slice().sort(el);
      e = i;
    }
  return n;
}
ie.empty.nextLayer = ie.empty;
class dn {
  finishChunk(e) {
    this.chunks.push(new ta(this.from, this.to, this.value, this.maxPoint)), this.chunkPos.push(this.chunkStart), this.chunkStart = -1, this.setMaxPoint = Math.max(this.setMaxPoint, this.maxPoint), this.maxPoint = -1, e && (this.from = [], this.to = [], this.value = []);
  }
  /**
  Create an empty builder.
  */
  constructor() {
    this.chunks = [], this.chunkPos = [], this.chunkStart = -1, this.last = null, this.lastFrom = -1e9, this.lastTo = -1e9, this.from = [], this.to = [], this.value = [], this.maxPoint = -1, this.setMaxPoint = -1, this.nextLayer = null;
  }
  /**
  Add a range. Ranges should be added in sorted (by `from` and
  `value.startSide`) order.
  */
  add(e, t, i) {
    this.addInner(e, t, i) || (this.nextLayer || (this.nextLayer = new dn())).add(e, t, i);
  }
  /**
  @internal
  */
  addInner(e, t, i) {
    let r = e - this.lastTo || i.startSide - this.last.endSide;
    if (r <= 0 && (e - this.lastFrom || i.startSide - this.last.startSide) < 0)
      throw new Error("Ranges must be added sorted by `from` position and `startSide`");
    return r < 0 ? !1 : (this.from.length == 250 && this.finishChunk(!0), this.chunkStart < 0 && (this.chunkStart = e), this.from.push(e - this.chunkStart), this.to.push(t - this.chunkStart), this.last = i, this.lastFrom = e, this.lastTo = t, this.value.push(i), i.point && (this.maxPoint = Math.max(this.maxPoint, t - e)), !0);
  }
  /**
  @internal
  */
  addChunk(e, t) {
    if ((e - this.lastTo || t.value[0].startSide - this.last.endSide) < 0)
      return !1;
    this.from.length && this.finishChunk(!0), this.setMaxPoint = Math.max(this.setMaxPoint, t.maxPoint), this.chunks.push(t), this.chunkPos.push(e);
    let i = t.value.length - 1;
    return this.last = t.value[i], this.lastFrom = t.from[i] + e, this.lastTo = t.to[i] + e, !0;
  }
  /**
  Finish the range set. Returns the new set. The builder can't be
  used anymore after this has been called.
  */
  finish() {
    return this.finishInner(ie.empty);
  }
  /**
  @internal
  */
  finishInner(e) {
    if (this.from.length && this.finishChunk(!1), this.chunks.length == 0)
      return e;
    let t = ie.create(this.chunkPos, this.chunks, this.nextLayer ? this.nextLayer.finishInner(e) : e, this.setMaxPoint);
    return this.from = null, t;
  }
}
function Ja(n, e, t) {
  let i = /* @__PURE__ */ new Map();
  for (let s of n)
    for (let o = 0; o < s.chunk.length; o++)
      s.chunk[o].maxPoint <= 0 && i.set(s.chunk[o], s.chunkPos[o]);
  let r = /* @__PURE__ */ new Set();
  for (let s of e)
    for (let o = 0; o < s.chunk.length; o++) {
      let l = i.get(s.chunk[o]);
      l != null && (t ? t.mapPos(l) : l) == s.chunkPos[o] && !(t != null && t.touchesRange(l, l + s.chunk[o].length)) && r.add(s.chunk[o]);
    }
  return r;
}
class _h {
  constructor(e, t, i, r = 0) {
    this.layer = e, this.skip = t, this.minPoint = i, this.rank = r;
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  get endSide() {
    return this.value ? this.value.endSide : 0;
  }
  goto(e, t = -1e9) {
    return this.chunkIndex = this.rangeIndex = 0, this.gotoInner(e, t, !1), this;
  }
  gotoInner(e, t, i) {
    for (; this.chunkIndex < this.layer.chunk.length; ) {
      let r = this.layer.chunk[this.chunkIndex];
      if (!(this.skip && this.skip.has(r) || this.layer.chunkEnd(this.chunkIndex) < e || r.maxPoint < this.minPoint))
        break;
      this.chunkIndex++, i = !1;
    }
    if (this.chunkIndex < this.layer.chunk.length) {
      let r = this.layer.chunk[this.chunkIndex].findIndex(e - this.layer.chunkPos[this.chunkIndex], t, !0);
      (!i || this.rangeIndex < r) && this.setRangeIndex(r);
    }
    this.next();
  }
  forward(e, t) {
    (this.to - e || this.endSide - t) < 0 && this.gotoInner(e, t, !0);
  }
  next() {
    for (; ; )
      if (this.chunkIndex == this.layer.chunk.length) {
        this.from = this.to = 1e9, this.value = null;
        break;
      } else {
        let e = this.layer.chunkPos[this.chunkIndex], t = this.layer.chunk[this.chunkIndex], i = e + t.from[this.rangeIndex];
        if (this.from = i, this.to = e + t.to[this.rangeIndex], this.value = t.value[this.rangeIndex], this.setRangeIndex(this.rangeIndex + 1), this.minPoint < 0 || this.value.point && this.to - this.from >= this.minPoint)
          break;
      }
  }
  setRangeIndex(e) {
    if (e == this.layer.chunk[this.chunkIndex].value.length) {
      if (this.chunkIndex++, this.skip)
        for (; this.chunkIndex < this.layer.chunk.length && this.skip.has(this.layer.chunk[this.chunkIndex]); )
          this.chunkIndex++;
      this.rangeIndex = 0;
    } else
      this.rangeIndex = e;
  }
  nextChunk() {
    this.chunkIndex++, this.rangeIndex = 0, this.next();
  }
  compare(e) {
    return this.from - e.from || this.startSide - e.startSide || this.rank - e.rank || this.to - e.to || this.endSide - e.endSide;
  }
}
class Ui {
  constructor(e) {
    this.heap = e;
  }
  static from(e, t = null, i = -1) {
    let r = [];
    for (let s = 0; s < e.length; s++)
      for (let o = e[s]; !o.isEmpty; o = o.nextLayer)
        o.maxPoint >= i && r.push(new _h(o, t, i, s));
    return r.length == 1 ? r[0] : new Ui(r);
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  goto(e, t = -1e9) {
    for (let i of this.heap)
      i.goto(e, t);
    for (let i = this.heap.length >> 1; i >= 0; i--)
      to(this.heap, i);
    return this.next(), this;
  }
  forward(e, t) {
    for (let i of this.heap)
      i.forward(e, t);
    for (let i = this.heap.length >> 1; i >= 0; i--)
      to(this.heap, i);
    (this.to - e || this.value.endSide - t) < 0 && this.next();
  }
  next() {
    if (this.heap.length == 0)
      this.from = this.to = 1e9, this.value = null, this.rank = -1;
    else {
      let e = this.heap[0];
      this.from = e.from, this.to = e.to, this.value = e.value, this.rank = e.rank, e.value && e.next(), to(this.heap, 0);
    }
  }
}
function to(n, e) {
  for (let t = n[e]; ; ) {
    let i = (e << 1) + 1;
    if (i >= n.length)
      break;
    let r = n[i];
    if (i + 1 < n.length && r.compare(n[i + 1]) >= 0 && (r = n[i + 1], i++), t.compare(r) < 0)
      break;
    n[i] = t, n[e] = r, e = i;
  }
}
class vi {
  constructor(e, t, i) {
    this.minPoint = i, this.active = [], this.activeTo = [], this.activeRank = [], this.minActive = -1, this.point = null, this.pointFrom = 0, this.pointRank = 0, this.to = -1e9, this.endSide = 0, this.openStart = -1, this.cursor = Ui.from(e, t, i);
  }
  goto(e, t = -1e9) {
    return this.cursor.goto(e, t), this.active.length = this.activeTo.length = this.activeRank.length = 0, this.minActive = -1, this.to = e, this.endSide = t, this.openStart = -1, this.next(), this;
  }
  forward(e, t) {
    for (; this.minActive > -1 && (this.activeTo[this.minActive] - e || this.active[this.minActive].endSide - t) < 0; )
      this.removeActive(this.minActive);
    this.cursor.forward(e, t);
  }
  removeActive(e) {
    pr(this.active, e), pr(this.activeTo, e), pr(this.activeRank, e), this.minActive = Za(this.active, this.activeTo);
  }
  addActive(e) {
    let t = 0, { value: i, to: r, rank: s } = this.cursor;
    for (; t < this.activeRank.length && (s - this.activeRank[t] || r - this.activeTo[t]) > 0; )
      t++;
    mr(this.active, t, i), mr(this.activeTo, t, r), mr(this.activeRank, t, s), e && mr(e, t, this.cursor.from), this.minActive = Za(this.active, this.activeTo);
  }
  // After calling this, if `this.point` != null, the next range is a
  // point. Otherwise, it's a regular range, covered by `this.active`.
  next() {
    let e = this.to, t = this.point;
    this.point = null;
    let i = this.openStart < 0 ? [] : null;
    for (; ; ) {
      let r = this.minActive;
      if (r > -1 && (this.activeTo[r] - this.cursor.from || this.active[r].endSide - this.cursor.startSide) < 0) {
        if (this.activeTo[r] > e) {
          this.to = this.activeTo[r], this.endSide = this.active[r].endSide;
          break;
        }
        this.removeActive(r), i && pr(i, r);
      } else if (this.cursor.value)
        if (this.cursor.from > e) {
          this.to = this.cursor.from, this.endSide = this.cursor.startSide;
          break;
        } else {
          let s = this.cursor.value;
          if (!s.point)
            this.addActive(i), this.cursor.next();
          else if (t && this.cursor.to == this.to && this.cursor.from < this.cursor.to)
            this.cursor.next();
          else {
            this.point = s, this.pointFrom = this.cursor.from, this.pointRank = this.cursor.rank, this.to = this.cursor.to, this.endSide = s.endSide, this.cursor.next(), this.forward(this.to, this.endSide);
            break;
          }
        }
      else {
        this.to = this.endSide = 1e9;
        break;
      }
    }
    if (i) {
      this.openStart = 0;
      for (let r = i.length - 1; r >= 0 && i[r] < e; r--)
        this.openStart++;
    }
  }
  activeForPoint(e) {
    if (!this.active.length)
      return this.active;
    let t = [];
    for (let i = this.active.length - 1; i >= 0 && !(this.activeRank[i] < this.pointRank); i--)
      (this.activeTo[i] > e || this.activeTo[i] == e && this.active[i].endSide >= this.point.endSide) && t.push(this.active[i]);
    return t.reverse();
  }
  openEnd(e) {
    let t = 0;
    for (let i = this.activeTo.length - 1; i >= 0 && this.activeTo[i] > e; i--)
      t++;
    return t;
  }
}
function Qa(n, e, t, i, r, s) {
  n.goto(e), t.goto(i);
  let o = i + r, l = i, a = i - e;
  for (; ; ) {
    let u = n.to + a - t.to || n.endSide - t.endSide, c = u < 0 ? n.to + a : t.to, h = Math.min(c, o);
    if (n.point || t.point ? n.point && t.point && (n.point == t.point || n.point.eq(t.point)) && tl(n.activeForPoint(n.to), t.activeForPoint(t.to)) || s.comparePoint(l, h, n.point, t.point) : h > l && !tl(n.active, t.active) && s.compareRange(l, h, n.active, t.active), c > o)
      break;
    l = c, u <= 0 && n.next(), u >= 0 && t.next();
  }
}
function tl(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (n[t] != e[t] && !n[t].eq(e[t]))
      return !1;
  return !0;
}
function pr(n, e) {
  for (let t = e, i = n.length - 1; t < i; t++)
    n[t] = n[t + 1];
  n.pop();
}
function mr(n, e, t) {
  for (let i = n.length - 1; i >= e; i--)
    n[i + 1] = n[i];
  n[e] = t;
}
function Za(n, e) {
  let t = -1, i = 1e9;
  for (let r = 0; r < e.length; r++)
    (e[r] - i || n[r].endSide - n[t].endSide) < 0 && (t = r, i = e[r]);
  return t;
}
function di(n, e, t = n.length) {
  let i = 0;
  for (let r = 0; r < t; )
    n.charCodeAt(r) == 9 ? (i += e - i % e, r++) : (i++, r = Re(n, r));
  return i;
}
function nl(n, e, t, i) {
  for (let r = 0, s = 0; ; ) {
    if (s >= e)
      return r;
    if (r == n.length)
      break;
    s += n.charCodeAt(r) == 9 ? t - s % t : 1, r = Re(n, r);
  }
  return i === !0 ? -1 : n.length;
}
const il = "ͼ", eu = typeof Symbol > "u" ? "__" + il : Symbol.for(il), rl = typeof Symbol > "u" ? "__styleSet" + Math.floor(Math.random() * 1e8) : Symbol("styleSet"), tu = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : {};
class pn {
  // :: (Object<Style>, ?{finish: ?(string) → string})
  // Create a style module from the given spec.
  //
  // When `finish` is given, it is called on regular (non-`@`)
  // selectors (after `&` expansion) to compute the final selector.
  constructor(e, t) {
    this.rules = [];
    let { finish: i } = t || {};
    function r(o) {
      return /^@/.test(o) ? [o] : o.split(/,\s*/);
    }
    function s(o, l, a, u) {
      let c = [], h = /^@(\w+)\b/.exec(o[0]), f = h && h[1] == "keyframes";
      if (h && l == null)
        return a.push(o[0] + ";");
      for (let d in l) {
        let p = l[d];
        if (/&/.test(d))
          s(
            d.split(/,\s*/).map((g) => o.map((m) => g.replace(/&/, m))).reduce((g, m) => g.concat(m)),
            p,
            a
          );
        else if (p && typeof p == "object") {
          if (!h)
            throw new RangeError("The value of a property (" + d + ") should be a primitive value.");
          s(r(d), p, c, f);
        } else
          p != null && c.push(d.replace(/_.*/, "").replace(/[A-Z]/g, (g) => "-" + g.toLowerCase()) + ": " + p + ";");
      }
      (c.length || f) && a.push((i && !h && !u ? o.map(i) : o).join(", ") + " {" + c.join(" ") + "}");
    }
    for (let o in e)
      s(r(o), e[o], this.rules);
  }
  // :: () → string
  // Returns a string containing the module's CSS rules.
  getRules() {
    return this.rules.join(`
`);
  }
  // :: () → string
  // Generate a new unique CSS class name.
  static newName() {
    let e = tu[eu] || 1;
    return tu[eu] = e + 1, il + e.toString(36);
  }
  // :: (union<Document, ShadowRoot>, union<[StyleModule], StyleModule>, ?{nonce: ?string})
  //
  // Mount the given set of modules in the given DOM root, which ensures
  // that the CSS rules defined by the module are available in that
  // context.
  //
  // Rules are only added to the document once per root.
  //
  // Rule order will follow the order of the modules, so that rules from
  // modules later in the array take precedence of those from earlier
  // modules. If you call this function multiple times for the same root
  // in a way that changes the order of already mounted modules, the old
  // order will be changed.
  //
  // If a Content Security Policy nonce is provided, it is added to
  // the `<style>` tag generated by the library.
  static mount(e, t, i) {
    let r = e[rl], s = i && i.nonce;
    r ? s && r.setNonce(s) : r = new lg(e, s), r.mount(Array.isArray(t) ? t : [t], e);
  }
}
let nu = /* @__PURE__ */ new Map();
class lg {
  constructor(e, t) {
    let i = e.ownerDocument || e, r = i.defaultView;
    if (!e.head && e.adoptedStyleSheets && r.CSSStyleSheet) {
      let s = nu.get(i);
      if (s)
        return e[rl] = s;
      this.sheet = new r.CSSStyleSheet(), nu.set(i, this);
    } else
      this.styleTag = i.createElement("style"), t && this.styleTag.setAttribute("nonce", t);
    this.modules = [], e[rl] = this;
  }
  mount(e, t) {
    let i = this.sheet, r = 0, s = 0;
    for (let o = 0; o < e.length; o++) {
      let l = e[o], a = this.modules.indexOf(l);
      if (a < s && a > -1 && (this.modules.splice(a, 1), s--, a = -1), a == -1) {
        if (this.modules.splice(s++, 0, l), i)
          for (let u = 0; u < l.rules.length; u++)
            i.insertRule(l.rules[u], r++);
      } else {
        for (; s < a; )
          r += this.modules[s++].rules.length;
        r += l.rules.length, s++;
      }
    }
    if (i)
      t.adoptedStyleSheets.indexOf(this.sheet) < 0 && (t.adoptedStyleSheets = [this.sheet, ...t.adoptedStyleSheets]);
    else {
      let o = "";
      for (let a = 0; a < this.modules.length; a++)
        o += this.modules[a].getRules() + `
`;
      this.styleTag.textContent = o;
      let l = t.head || t;
      this.styleTag.parentNode != l && l.insertBefore(this.styleTag, l.firstChild);
    }
  }
  setNonce(e) {
    this.styleTag && this.styleTag.getAttribute("nonce") != e && this.styleTag.setAttribute("nonce", e);
  }
}
var mn = {
  8: "Backspace",
  9: "Tab",
  10: "Enter",
  12: "NumLock",
  13: "Enter",
  16: "Shift",
  17: "Control",
  18: "Alt",
  20: "CapsLock",
  27: "Escape",
  32: " ",
  33: "PageUp",
  34: "PageDown",
  35: "End",
  36: "Home",
  37: "ArrowLeft",
  38: "ArrowUp",
  39: "ArrowRight",
  40: "ArrowDown",
  44: "PrintScreen",
  45: "Insert",
  46: "Delete",
  59: ";",
  61: "=",
  91: "Meta",
  92: "Meta",
  106: "*",
  107: "+",
  108: ",",
  109: "-",
  110: ".",
  111: "/",
  144: "NumLock",
  145: "ScrollLock",
  160: "Shift",
  161: "Shift",
  162: "Control",
  163: "Control",
  164: "Alt",
  165: "Alt",
  173: "-",
  186: ";",
  187: "=",
  188: ",",
  189: "-",
  190: ".",
  191: "/",
  192: "`",
  219: "[",
  220: "\\",
  221: "]",
  222: "'"
}, Ki = {
  48: ")",
  49: "!",
  50: "@",
  51: "#",
  52: "$",
  53: "%",
  54: "^",
  55: "&",
  56: "*",
  57: "(",
  59: ":",
  61: "+",
  173: "_",
  186: ":",
  187: "+",
  188: "<",
  189: "_",
  190: ">",
  191: "?",
  192: "~",
  219: "{",
  220: "|",
  221: "}",
  222: '"'
}, ag = typeof navigator < "u" && /Mac/.test(navigator.platform), ug = typeof navigator < "u" && /MSIE \d|Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(navigator.userAgent);
for (var Ie = 0; Ie < 10; Ie++)
  mn[48 + Ie] = mn[96 + Ie] = String(Ie);
for (var Ie = 1; Ie <= 24; Ie++)
  mn[Ie + 111] = "F" + Ie;
for (var Ie = 65; Ie <= 90; Ie++)
  mn[Ie] = String.fromCharCode(Ie + 32), Ki[Ie] = String.fromCharCode(Ie);
for (var no in mn)
  Ki.hasOwnProperty(no) || (Ki[no] = mn[no]);
function cg(n) {
  var e = ag && n.metaKey && n.shiftKey && !n.ctrlKey && !n.altKey || ug && n.shiftKey && n.key && n.key.length == 1 || n.key == "Unidentified", t = !e && n.key || (n.shiftKey ? Ki : mn)[n.keyCode] || n.key || "Unidentified";
  return t == "Esc" && (t = "Escape"), t == "Del" && (t = "Delete"), t == "Left" && (t = "ArrowLeft"), t == "Up" && (t = "ArrowUp"), t == "Right" && (t = "ArrowRight"), t == "Down" && (t = "ArrowDown"), t;
}
function rs(n) {
  let e;
  return n.nodeType == 11 ? e = n.getSelection ? n : n.ownerDocument : e = n, e.getSelection();
}
function sl(n, e) {
  return e ? n == e || n.contains(e.nodeType != 1 ? e.parentNode : e) : !1;
}
function hg(n) {
  let e = n.activeElement;
  for (; e && e.shadowRoot; )
    e = e.shadowRoot.activeElement;
  return e;
}
function Ur(n, e) {
  if (!e.anchorNode)
    return !1;
  try {
    return sl(n, e.anchorNode);
  } catch {
    return !1;
  }
}
function oi(n) {
  return n.nodeType == 3 ? Rn(n, 0, n.nodeValue.length).getClientRects() : n.nodeType == 1 ? n.getClientRects() : [];
}
function Hi(n, e, t, i) {
  return t ? iu(n, e, t, i, -1) || iu(n, e, t, i, 1) : !1;
}
function Bn(n) {
  for (var e = 0; ; e++)
    if (n = n.previousSibling, !n)
      return e;
}
function ss(n) {
  return n.nodeType == 1 && /^(DIV|P|LI|UL|OL|BLOCKQUOTE|DD|DT|H\d|SECTION|PRE)$/.test(n.nodeName);
}
function iu(n, e, t, i, r) {
  for (; ; ) {
    if (n == t && e == i)
      return !0;
    if (e == (r < 0 ? 0 : Kt(n))) {
      if (n.nodeName == "DIV")
        return !1;
      let s = n.parentNode;
      if (!s || s.nodeType != 1)
        return !1;
      e = Bn(n) + (r < 0 ? 0 : 1), n = s;
    } else if (n.nodeType == 1) {
      if (n = n.childNodes[e + (r < 0 ? -1 : 0)], n.nodeType == 1 && n.contentEditable == "false")
        return !1;
      e = r < 0 ? Kt(n) : 0;
    } else
      return !1;
  }
}
function Kt(n) {
  return n.nodeType == 3 ? n.nodeValue.length : n.childNodes.length;
}
function Ps(n, e) {
  let t = e ? n.left : n.right;
  return { left: t, right: t, top: n.top, bottom: n.bottom };
}
function fg(n) {
  let e = n.visualViewport;
  return e ? {
    left: 0,
    right: e.width,
    top: 0,
    bottom: e.height
  } : {
    left: 0,
    right: n.innerWidth,
    top: 0,
    bottom: n.innerHeight
  };
}
function $h(n, e) {
  let t = e.width / n.offsetWidth, i = e.height / n.offsetHeight;
  return (t > 0.995 && t < 1.005 || !isFinite(t) || Math.abs(e.width - n.offsetWidth) < 1) && (t = 1), (i > 0.995 && i < 1.005 || !isFinite(i) || Math.abs(e.height - n.offsetHeight) < 1) && (i = 1), { scaleX: t, scaleY: i };
}
function dg(n, e, t, i, r, s, o, l) {
  let a = n.ownerDocument, u = a.defaultView || window;
  for (let c = n, h = !1; c && !h; )
    if (c.nodeType == 1) {
      let f, d = c == a.body, p = 1, g = 1;
      if (d)
        f = fg(u);
      else {
        if (/^(fixed|sticky)$/.test(getComputedStyle(c).position) && (h = !0), c.scrollHeight <= c.clientHeight && c.scrollWidth <= c.clientWidth) {
          c = c.assignedSlot || c.parentNode;
          continue;
        }
        let v = c.getBoundingClientRect();
        ({ scaleX: p, scaleY: g } = $h(c, v)), f = {
          left: v.left,
          right: v.left + c.clientWidth * p,
          top: v.top,
          bottom: v.top + c.clientHeight * g
        };
      }
      let m = 0, y = 0;
      if (r == "nearest")
        e.top < f.top ? (y = -(f.top - e.top + o), t > 0 && e.bottom > f.bottom + y && (y = e.bottom - f.bottom + y + o)) : e.bottom > f.bottom && (y = e.bottom - f.bottom + o, t < 0 && e.top - y < f.top && (y = -(f.top + y - e.top + o)));
      else {
        let v = e.bottom - e.top, C = f.bottom - f.top;
        y = (r == "center" && v <= C ? e.top + v / 2 - C / 2 : r == "start" || r == "center" && t < 0 ? e.top - o : e.bottom - C + o) - f.top;
      }
      if (i == "nearest" ? e.left < f.left ? (m = -(f.left - e.left + s), t > 0 && e.right > f.right + m && (m = e.right - f.right + m + s)) : e.right > f.right && (m = e.right - f.right + s, t < 0 && e.left < f.left + m && (m = -(f.left + m - e.left + s))) : m = (i == "center" ? e.left + (e.right - e.left) / 2 - (f.right - f.left) / 2 : i == "start" == l ? e.left - s : e.right - (f.right - f.left) + s) - f.left, m || y)
        if (d)
          u.scrollBy(m, y);
        else {
          let v = 0, C = 0;
          if (y) {
            let O = c.scrollTop;
            c.scrollTop += y / g, C = (c.scrollTop - O) * g;
          }
          if (m) {
            let O = c.scrollLeft;
            c.scrollLeft += m / p, v = (c.scrollLeft - O) * p;
          }
          e = {
            left: e.left - v,
            top: e.top - C,
            right: e.right - v,
            bottom: e.bottom - C
          }, v && Math.abs(v - m) < 1 && (i = "nearest"), C && Math.abs(C - y) < 1 && (r = "nearest");
        }
      if (d)
        break;
      c = c.assignedSlot || c.parentNode;
    } else if (c.nodeType == 11)
      c = c.host;
    else
      break;
}
function pg(n) {
  let e = n.ownerDocument;
  for (let t = n.parentNode; t && t != e.body; )
    if (t.nodeType == 1) {
      if (t.scrollHeight > t.clientHeight || t.scrollWidth > t.clientWidth)
        return t;
      t = t.assignedSlot || t.parentNode;
    } else if (t.nodeType == 11)
      t = t.host;
    else
      break;
  return null;
}
class mg {
  constructor() {
    this.anchorNode = null, this.anchorOffset = 0, this.focusNode = null, this.focusOffset = 0;
  }
  eq(e) {
    return this.anchorNode == e.anchorNode && this.anchorOffset == e.anchorOffset && this.focusNode == e.focusNode && this.focusOffset == e.focusOffset;
  }
  setRange(e) {
    let { anchorNode: t, focusNode: i } = e;
    this.set(t, Math.min(e.anchorOffset, t ? Kt(t) : 0), i, Math.min(e.focusOffset, i ? Kt(i) : 0));
  }
  set(e, t, i, r) {
    this.anchorNode = e, this.anchorOffset = t, this.focusNode = i, this.focusOffset = r;
  }
}
let jn = null;
function jh(n) {
  if (n.setActive)
    return n.setActive();
  if (jn)
    return n.focus(jn);
  let e = [];
  for (let t = n; t && (e.push(t, t.scrollTop, t.scrollLeft), t != t.ownerDocument); t = t.parentNode)
    ;
  if (n.focus(jn == null ? {
    get preventScroll() {
      return jn = { preventScroll: !0 }, !0;
    }
  } : void 0), !jn) {
    jn = !1;
    for (let t = 0; t < e.length; ) {
      let i = e[t++], r = e[t++], s = e[t++];
      i.scrollTop != r && (i.scrollTop = r), i.scrollLeft != s && (i.scrollLeft = s);
    }
  }
}
let ru;
function Rn(n, e, t = e) {
  let i = ru || (ru = document.createRange());
  return i.setEnd(n, t), i.setStart(n, e), i;
}
function Zn(n, e, t, i) {
  let r = { key: e, code: e, keyCode: t, which: t, cancelable: !0 };
  i && ({ altKey: r.altKey, ctrlKey: r.ctrlKey, shiftKey: r.shiftKey, metaKey: r.metaKey } = i);
  let s = new KeyboardEvent("keydown", r);
  s.synthetic = !0, n.dispatchEvent(s);
  let o = new KeyboardEvent("keyup", r);
  return o.synthetic = !0, n.dispatchEvent(o), s.defaultPrevented || o.defaultPrevented;
}
function gg(n) {
  for (; n; ) {
    if (n && (n.nodeType == 9 || n.nodeType == 11 && n.host))
      return n;
    n = n.assignedSlot || n.parentNode;
  }
  return null;
}
function Wh(n) {
  for (; n.attributes.length; )
    n.removeAttributeNode(n.attributes[0]);
}
function yg(n, e) {
  let t = e.focusNode, i = e.focusOffset;
  if (!t || e.anchorNode != t || e.anchorOffset != i)
    return !1;
  for (i = Math.min(i, Kt(t)); ; )
    if (i) {
      if (t.nodeType != 1)
        return !1;
      let r = t.childNodes[i - 1];
      r.contentEditable == "false" ? i-- : (t = r, i = Kt(t));
    } else {
      if (t == n)
        return !0;
      i = Bn(t), t = t.parentNode;
    }
}
function qh(n) {
  return n.scrollTop > Math.max(1, n.scrollHeight - n.clientHeight - 4);
}
function Uh(n, e) {
  for (let t = n, i = e; ; ) {
    if (t.nodeType == 3 && i > 0)
      return { node: t, offset: i };
    if (t.nodeType == 1 && i > 0) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[i - 1], i = Kt(t);
    } else if (t.parentNode && !ss(t))
      i = Bn(t), t = t.parentNode;
    else
      return null;
  }
}
function Kh(n, e) {
  for (let t = n, i = e; ; ) {
    if (t.nodeType == 3 && i < t.nodeValue.length)
      return { node: t, offset: i };
    if (t.nodeType == 1 && i < t.childNodes.length) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[i], i = 0;
    } else if (t.parentNode && !ss(t))
      i = Bn(t) + 1, t = t.parentNode;
    else
      return null;
  }
}
class ze {
  constructor(e, t, i = !0) {
    this.node = e, this.offset = t, this.precise = i;
  }
  static before(e, t) {
    return new ze(e.parentNode, Bn(e), t);
  }
  static after(e, t) {
    return new ze(e.parentNode, Bn(e) + 1, t);
  }
}
const na = [];
class he {
  constructor() {
    this.parent = null, this.dom = null, this.flags = 2;
  }
  get overrideDOMText() {
    return null;
  }
  get posAtStart() {
    return this.parent ? this.parent.posBefore(this) : 0;
  }
  get posAtEnd() {
    return this.posAtStart + this.length;
  }
  posBefore(e) {
    let t = this.posAtStart;
    for (let i of this.children) {
      if (i == e)
        return t;
      t += i.length + i.breakAfter;
    }
    throw new RangeError("Invalid child in posBefore");
  }
  posAfter(e) {
    return this.posBefore(e) + e.length;
  }
  sync(e, t) {
    if (this.flags & 2) {
      let i = this.dom, r = null, s;
      for (let o of this.children) {
        if (o.flags & 7) {
          if (!o.dom && (s = r ? r.nextSibling : i.firstChild)) {
            let l = he.get(s);
            (!l || !l.parent && l.canReuseDOM(o)) && o.reuseDOM(s);
          }
          o.sync(e, t), o.flags &= -8;
        }
        if (s = r ? r.nextSibling : i.firstChild, t && !t.written && t.node == i && s != o.dom && (t.written = !0), o.dom.parentNode == i)
          for (; s && s != o.dom; )
            s = su(s);
        else
          i.insertBefore(o.dom, s);
        r = o.dom;
      }
      for (s = r ? r.nextSibling : i.firstChild, s && t && t.node == i && (t.written = !0); s; )
        s = su(s);
    } else if (this.flags & 1)
      for (let i of this.children)
        i.flags & 7 && (i.sync(e, t), i.flags &= -8);
  }
  reuseDOM(e) {
  }
  localPosFromDOM(e, t) {
    let i;
    if (e == this.dom)
      i = this.dom.childNodes[t];
    else {
      let r = Kt(e) == 0 ? 0 : t == 0 ? -1 : 1;
      for (; ; ) {
        let s = e.parentNode;
        if (s == this.dom)
          break;
        r == 0 && s.firstChild != s.lastChild && (e == s.firstChild ? r = -1 : r = 1), e = s;
      }
      r < 0 ? i = e : i = e.nextSibling;
    }
    if (i == this.dom.firstChild)
      return 0;
    for (; i && !he.get(i); )
      i = i.nextSibling;
    if (!i)
      return this.length;
    for (let r = 0, s = 0; ; r++) {
      let o = this.children[r];
      if (o.dom == i)
        return s;
      s += o.length + o.breakAfter;
    }
  }
  domBoundsAround(e, t, i = 0) {
    let r = -1, s = -1, o = -1, l = -1;
    for (let a = 0, u = i, c = i; a < this.children.length; a++) {
      let h = this.children[a], f = u + h.length;
      if (u < e && f > t)
        return h.domBoundsAround(e, t, u);
      if (f >= e && r == -1 && (r = a, s = u), u > t && h.dom.parentNode == this.dom) {
        o = a, l = c;
        break;
      }
      c = f, u = f + h.breakAfter;
    }
    return {
      from: s,
      to: l < 0 ? i + this.length : l,
      startDOM: (r ? this.children[r - 1].dom.nextSibling : null) || this.dom.firstChild,
      endDOM: o < this.children.length && o >= 0 ? this.children[o].dom : null
    };
  }
  markDirty(e = !1) {
    this.flags |= 2, this.markParentsDirty(e);
  }
  markParentsDirty(e) {
    for (let t = this.parent; t; t = t.parent) {
      if (e && (t.flags |= 2), t.flags & 1)
        return;
      t.flags |= 1, e = !1;
    }
  }
  setParent(e) {
    this.parent != e && (this.parent = e, this.flags & 7 && this.markParentsDirty(!0));
  }
  setDOM(e) {
    this.dom != e && (this.dom && (this.dom.cmView = null), this.dom = e, e.cmView = this);
  }
  get rootView() {
    for (let e = this; ; ) {
      let t = e.parent;
      if (!t)
        return e;
      e = t;
    }
  }
  replaceChildren(e, t, i = na) {
    this.markDirty();
    for (let r = e; r < t; r++) {
      let s = this.children[r];
      s.parent == this && i.indexOf(s) < 0 && s.destroy();
    }
    this.children.splice(e, t - e, ...i);
    for (let r = 0; r < i.length; r++)
      i[r].setParent(this);
  }
  ignoreMutation(e) {
    return !1;
  }
  ignoreEvent(e) {
    return !1;
  }
  childCursor(e = this.length) {
    return new Gh(this.children, e, this.children.length);
  }
  childPos(e, t = 1) {
    return this.childCursor().findPos(e, t);
  }
  toString() {
    let e = this.constructor.name.replace("View", "");
    return e + (this.children.length ? "(" + this.children.join() + ")" : this.length ? "[" + (e == "Text" ? this.text : this.length) + "]" : "") + (this.breakAfter ? "#" : "");
  }
  static get(e) {
    return e.cmView;
  }
  get isEditable() {
    return !0;
  }
  get isWidget() {
    return !1;
  }
  get isHidden() {
    return !1;
  }
  merge(e, t, i, r, s, o) {
    return !1;
  }
  become(e) {
    return !1;
  }
  canReuseDOM(e) {
    return e.constructor == this.constructor && !((this.flags | e.flags) & 8);
  }
  // When this is a zero-length view with a side, this should return a
  // number <= 0 to indicate it is before its position, or a
  // number > 0 when after its position.
  getSide() {
    return 0;
  }
  destroy() {
    for (let e of this.children)
      e.parent == this && e.destroy();
    this.parent = null;
  }
}
he.prototype.breakAfter = 0;
function su(n) {
  let e = n.nextSibling;
  return n.parentNode.removeChild(n), e;
}
class Gh {
  constructor(e, t, i) {
    this.children = e, this.pos = t, this.i = i, this.off = 0;
  }
  findPos(e, t = 1) {
    for (; ; ) {
      if (e > this.pos || e == this.pos && (t > 0 || this.i == 0 || this.children[this.i - 1].breakAfter))
        return this.off = e - this.pos, this;
      let i = this.children[--this.i];
      this.pos -= i.length + i.breakAfter;
    }
  }
}
function Yh(n, e, t, i, r, s, o, l, a) {
  let { children: u } = n, c = u.length ? u[e] : null, h = s.length ? s[s.length - 1] : null, f = h ? h.breakAfter : o;
  if (!(e == i && c && !o && !f && s.length < 2 && c.merge(t, r, s.length ? h : null, t == 0, l, a))) {
    if (i < u.length) {
      let d = u[i];
      d && (r < d.length || d.breakAfter && (h != null && h.breakAfter)) ? (e == i && (d = d.split(r), r = 0), !f && h && d.merge(0, r, h, !0, 0, a) ? s[s.length - 1] = d : ((r || d.children.length && !d.children[0].length) && d.merge(0, r, null, !1, 0, a), s.push(d))) : d != null && d.breakAfter && (h ? h.breakAfter = 1 : o = 1), i++;
    }
    for (c && (c.breakAfter = o, t > 0 && (!o && s.length && c.merge(t, c.length, s[0], !1, l, 0) ? c.breakAfter = s.shift().breakAfter : (t < c.length || c.children.length && c.children[c.children.length - 1].length == 0) && c.merge(t, c.length, null, !1, l, 0), e++)); e < i && s.length; )
      if (u[i - 1].become(s[s.length - 1]))
        i--, s.pop(), a = s.length ? 0 : l;
      else if (u[e].become(s[0]))
        e++, s.shift(), l = s.length ? 0 : a;
      else
        break;
    !s.length && e && i < u.length && !u[e - 1].breakAfter && u[i].merge(0, 0, u[e - 1], !1, l, a) && e--, (e < i || s.length) && n.replaceChildren(e, i, s);
  }
}
function Xh(n, e, t, i, r, s) {
  let o = n.childCursor(), { i: l, off: a } = o.findPos(t, 1), { i: u, off: c } = o.findPos(e, -1), h = e - t;
  for (let f of i)
    h += f.length;
  n.length += h, Yh(n, u, c, l, a, i, 0, r, s);
}
let rt = typeof navigator < "u" ? navigator : { userAgent: "", vendor: "", platform: "" }, ol = typeof document < "u" ? document : { documentElement: { style: {} } };
const ll = /* @__PURE__ */ /Edge\/(\d+)/.exec(rt.userAgent), Jh = /* @__PURE__ */ /MSIE \d/.test(rt.userAgent), al = /* @__PURE__ */ /Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(rt.userAgent), Bs = !!(Jh || al || ll), ou = !Bs && /* @__PURE__ */ /gecko\/(\d+)/i.test(rt.userAgent), io = !Bs && /* @__PURE__ */ /Chrome\/(\d+)/.exec(rt.userAgent), lu = "webkitFontSmoothing" in ol.documentElement.style, Qh = !Bs && /* @__PURE__ */ /Apple Computer/.test(rt.vendor), au = Qh && (/* @__PURE__ */ /Mobile\/\w+/.test(rt.userAgent) || rt.maxTouchPoints > 2);
var $ = {
  mac: au || /* @__PURE__ */ /Mac/.test(rt.platform),
  windows: /* @__PURE__ */ /Win/.test(rt.platform),
  linux: /* @__PURE__ */ /Linux|X11/.test(rt.platform),
  ie: Bs,
  ie_version: Jh ? ol.documentMode || 6 : al ? +al[1] : ll ? +ll[1] : 0,
  gecko: ou,
  gecko_version: ou ? +(/* @__PURE__ */ /Firefox\/(\d+)/.exec(rt.userAgent) || [0, 0])[1] : 0,
  chrome: !!io,
  chrome_version: io ? +io[1] : 0,
  ios: au,
  android: /* @__PURE__ */ /Android\b/.test(rt.userAgent),
  webkit: lu,
  safari: Qh,
  webkit_version: lu ? +(/* @__PURE__ */ /\bAppleWebKit\/(\d+)/.exec(navigator.userAgent) || [0, 0])[1] : 0,
  tabSize: ol.documentElement.style.tabSize != null ? "tab-size" : "-moz-tab-size"
};
const bg = 256;
class Ct extends he {
  constructor(e) {
    super(), this.text = e;
  }
  get length() {
    return this.text.length;
  }
  createDOM(e) {
    this.setDOM(e || document.createTextNode(this.text));
  }
  sync(e, t) {
    this.dom || this.createDOM(), this.dom.nodeValue != this.text && (t && t.node == this.dom && (t.written = !0), this.dom.nodeValue = this.text);
  }
  reuseDOM(e) {
    e.nodeType == 3 && this.createDOM(e);
  }
  merge(e, t, i) {
    return this.flags & 8 || i && (!(i instanceof Ct) || this.length - (t - e) + i.length > bg || i.flags & 8) ? !1 : (this.text = this.text.slice(0, e) + (i ? i.text : "") + this.text.slice(t), this.markDirty(), !0);
  }
  split(e) {
    let t = new Ct(this.text.slice(e));
    return this.text = this.text.slice(0, e), this.markDirty(), t.flags |= this.flags & 8, t;
  }
  localPosFromDOM(e, t) {
    return e == this.dom ? t : t ? this.text.length : 0;
  }
  domAtPos(e) {
    return new ze(this.dom, e);
  }
  domBoundsAround(e, t, i) {
    return { from: i, to: i + this.length, startDOM: this.dom, endDOM: this.dom.nextSibling };
  }
  coordsAt(e, t) {
    return xg(this.dom, e, t);
  }
}
class Gt extends he {
  constructor(e, t = [], i = 0) {
    super(), this.mark = e, this.children = t, this.length = i;
    for (let r of t)
      r.setParent(this);
  }
  setAttrs(e) {
    if (Wh(e), this.mark.class && (e.className = this.mark.class), this.mark.attrs)
      for (let t in this.mark.attrs)
        e.setAttribute(t, this.mark.attrs[t]);
    return e;
  }
  canReuseDOM(e) {
    return super.canReuseDOM(e) && !((this.flags | e.flags) & 8);
  }
  reuseDOM(e) {
    e.nodeName == this.mark.tagName.toUpperCase() && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    this.dom ? this.flags & 4 && this.setAttrs(this.dom) : this.setDOM(this.setAttrs(document.createElement(this.mark.tagName))), super.sync(e, t);
  }
  merge(e, t, i, r, s, o) {
    return i && (!(i instanceof Gt && i.mark.eq(this.mark)) || e && s <= 0 || t < this.length && o <= 0) ? !1 : (Xh(this, e, t, i ? i.children.slice() : [], s - 1, o - 1), this.markDirty(), !0);
  }
  split(e) {
    let t = [], i = 0, r = -1, s = 0;
    for (let l of this.children) {
      let a = i + l.length;
      a > e && t.push(i < e ? l.split(e - i) : l), r < 0 && i >= e && (r = s), i = a, s++;
    }
    let o = this.length - e;
    return this.length = e, r > -1 && (this.children.length = r, this.markDirty()), new Gt(this.mark, t, o);
  }
  domAtPos(e) {
    return Zh(this, e);
  }
  coordsAt(e, t) {
    return tf(this, e, t);
  }
}
function xg(n, e, t) {
  let i = n.nodeValue.length;
  e > i && (e = i);
  let r = e, s = e, o = 0;
  e == 0 && t < 0 || e == i && t >= 0 ? $.chrome || $.gecko || (e ? (r--, o = 1) : s < i && (s++, o = -1)) : t < 0 ? r-- : s < i && s++;
  let l = Rn(n, r, s).getClientRects();
  if (!l.length)
    return null;
  let a = l[(o ? o < 0 : t >= 0) ? 0 : l.length - 1];
  return $.safari && !o && a.width == 0 && (a = Array.prototype.find.call(l, (u) => u.width) || a), o ? Ps(a, o < 0) : a || null;
}
class ln extends he {
  static create(e, t, i) {
    return new ln(e, t, i);
  }
  constructor(e, t, i) {
    super(), this.widget = e, this.length = t, this.side = i, this.prevWidget = null;
  }
  split(e) {
    let t = ln.create(this.widget, this.length - e, this.side);
    return this.length -= e, t;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  getSide() {
    return this.side;
  }
  merge(e, t, i, r, s, o) {
    return i && (!(i instanceof ln) || !this.widget.compare(i.widget) || e > 0 && s <= 0 || t < this.length && o <= 0) ? !1 : (this.length = e + (i ? i.length : 0) + (this.length - t), !0);
  }
  become(e) {
    return e instanceof ln && e.side == this.side && this.widget.constructor == e.widget.constructor ? (this.widget.compare(e.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get overrideDOMText() {
    if (this.length == 0)
      return re.empty;
    let e = this;
    for (; e.parent; )
      e = e.parent;
    let { view: t } = e, i = t && t.state.doc, r = this.posAtStart;
    return i ? i.slice(r, r + this.length) : re.empty;
  }
  domAtPos(e) {
    return (this.length ? e == 0 : this.side > 0) ? ze.before(this.dom) : ze.after(this.dom, e == this.length);
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e, t) {
    let i = this.widget.coordsAt(this.dom, e, t);
    if (i)
      return i;
    let r = this.dom.getClientRects(), s = null;
    if (!r.length)
      return null;
    let o = this.side ? this.side < 0 : e > 0;
    for (let l = o ? r.length - 1 : 0; s = r[l], !(e > 0 ? l == 0 : l == r.length - 1 || s.top < s.bottom); l += o ? -1 : 1)
      ;
    return Ps(s, !o);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  get isHidden() {
    return this.widget.isHidden;
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
}
class li extends he {
  constructor(e) {
    super(), this.side = e;
  }
  get length() {
    return 0;
  }
  merge() {
    return !1;
  }
  become(e) {
    return e instanceof li && e.side == this.side;
  }
  split() {
    return new li(this.side);
  }
  sync() {
    if (!this.dom) {
      let e = document.createElement("img");
      e.className = "cm-widgetBuffer", e.setAttribute("aria-hidden", "true"), this.setDOM(e);
    }
  }
  getSide() {
    return this.side;
  }
  domAtPos(e) {
    return this.side > 0 ? ze.before(this.dom) : ze.after(this.dom);
  }
  localPosFromDOM() {
    return 0;
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e) {
    return this.dom.getBoundingClientRect();
  }
  get overrideDOMText() {
    return re.empty;
  }
  get isHidden() {
    return !0;
  }
}
Ct.prototype.children = ln.prototype.children = li.prototype.children = na;
function Zh(n, e) {
  let t = n.dom, { children: i } = n, r = 0;
  for (let s = 0; r < i.length; r++) {
    let o = i[r], l = s + o.length;
    if (!(l == s && o.getSide() <= 0)) {
      if (e > s && e < l && o.dom.parentNode == t)
        return o.domAtPos(e - s);
      if (e <= s)
        break;
      s = l;
    }
  }
  for (let s = r; s > 0; s--) {
    let o = i[s - 1];
    if (o.dom.parentNode == t)
      return o.domAtPos(o.length);
  }
  for (let s = r; s < i.length; s++) {
    let o = i[s];
    if (o.dom.parentNode == t)
      return o.domAtPos(0);
  }
  return new ze(t, 0);
}
function ef(n, e, t) {
  let i, { children: r } = n;
  t > 0 && e instanceof Gt && r.length && (i = r[r.length - 1]) instanceof Gt && i.mark.eq(e.mark) ? ef(i, e.children[0], t - 1) : (r.push(e), e.setParent(n)), n.length += e.length;
}
function tf(n, e, t) {
  let i = null, r = -1, s = null, o = -1;
  function l(u, c) {
    for (let h = 0, f = 0; h < u.children.length && f <= c; h++) {
      let d = u.children[h], p = f + d.length;
      p >= c && (d.children.length ? l(d, c - f) : (!s || s.isHidden && t > 0) && (p > c || f == p && d.getSide() > 0) ? (s = d, o = c - f) : (f < c || f == p && d.getSide() < 0 && !d.isHidden) && (i = d, r = c - f)), f = p;
    }
  }
  l(n, e);
  let a = (t < 0 ? i : s) || i || s;
  return a ? a.coordsAt(Math.max(0, a == i ? r : o), t) : wg(n);
}
function wg(n) {
  let e = n.dom.lastChild;
  if (!e)
    return n.dom.getBoundingClientRect();
  let t = oi(e);
  return t[t.length - 1] || null;
}
function ul(n, e) {
  for (let t in n)
    t == "class" && e.class ? e.class += " " + n.class : t == "style" && e.style ? e.style += ";" + n.style : e[t] = n[t];
  return e;
}
const uu = /* @__PURE__ */ Object.create(null);
function ia(n, e, t) {
  if (n == e)
    return !0;
  n || (n = uu), e || (e = uu);
  let i = Object.keys(n), r = Object.keys(e);
  if (i.length - (t && i.indexOf(t) > -1 ? 1 : 0) != r.length - (t && r.indexOf(t) > -1 ? 1 : 0))
    return !1;
  for (let s of i)
    if (s != t && (r.indexOf(s) == -1 || n[s] !== e[s]))
      return !1;
  return !0;
}
function cl(n, e, t) {
  let i = !1;
  if (e)
    for (let r in e)
      t && r in t || (i = !0, r == "style" ? n.style.cssText = "" : n.removeAttribute(r));
  if (t)
    for (let r in t)
      e && e[r] == t[r] || (i = !0, r == "style" ? n.style.cssText = t[r] : n.setAttribute(r, t[r]));
  return i;
}
function kg(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t = 0; t < n.attributes.length; t++) {
    let i = n.attributes[t];
    e[i.name] = i.value;
  }
  return e;
}
class Me extends he {
  constructor() {
    super(...arguments), this.children = [], this.length = 0, this.prevAttrs = void 0, this.attrs = null, this.breakAfter = 0;
  }
  // Consumes source
  merge(e, t, i, r, s, o) {
    if (i) {
      if (!(i instanceof Me))
        return !1;
      this.dom || i.transferDOM(this);
    }
    return r && this.setDeco(i ? i.attrs : null), Xh(this, e, t, i ? i.children.slice() : [], s, o), !0;
  }
  split(e) {
    let t = new Me();
    if (t.breakAfter = this.breakAfter, this.length == 0)
      return t;
    let { i, off: r } = this.childPos(e);
    r && (t.append(this.children[i].split(r), 0), this.children[i].merge(r, this.children[i].length, null, !1, 0, 0), i++);
    for (let s = i; s < this.children.length; s++)
      t.append(this.children[s], 0);
    for (; i > 0 && this.children[i - 1].length == 0; )
      this.children[--i].destroy();
    return this.children.length = i, this.markDirty(), this.length = e, t;
  }
  transferDOM(e) {
    this.dom && (this.markDirty(), e.setDOM(this.dom), e.prevAttrs = this.prevAttrs === void 0 ? this.attrs : this.prevAttrs, this.prevAttrs = void 0, this.dom = null);
  }
  setDeco(e) {
    ia(this.attrs, e) || (this.dom && (this.prevAttrs = this.attrs, this.markDirty()), this.attrs = e);
  }
  append(e, t) {
    ef(this, e, t);
  }
  // Only called when building a line view in ContentBuilder
  addLineDeco(e) {
    let t = e.spec.attributes, i = e.spec.class;
    t && (this.attrs = ul(t, this.attrs || {})), i && (this.attrs = ul({ class: i }, this.attrs || {}));
  }
  domAtPos(e) {
    return Zh(this, e);
  }
  reuseDOM(e) {
    e.nodeName == "DIV" && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    var i;
    this.dom ? this.flags & 4 && (Wh(this.dom), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0) : (this.setDOM(document.createElement("div")), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0), this.prevAttrs !== void 0 && (cl(this.dom, this.prevAttrs, this.attrs), this.dom.classList.add("cm-line"), this.prevAttrs = void 0), super.sync(e, t);
    let r = this.dom.lastChild;
    for (; r && he.get(r) instanceof Gt; )
      r = r.lastChild;
    if (!r || !this.length || r.nodeName != "BR" && ((i = he.get(r)) === null || i === void 0 ? void 0 : i.isEditable) == !1 && (!$.ios || !this.children.some((s) => s instanceof Ct))) {
      let s = document.createElement("BR");
      s.cmIgnore = !0, this.dom.appendChild(s);
    }
  }
  measureTextSize() {
    if (this.children.length == 0 || this.length > 20)
      return null;
    let e = 0, t;
    for (let i of this.children) {
      if (!(i instanceof Ct) || /[^ -~]/.test(i.text))
        return null;
      let r = oi(i.dom);
      if (r.length != 1)
        return null;
      e += r[0].width, t = r[0].height;
    }
    return e ? {
      lineHeight: this.dom.getBoundingClientRect().height,
      charWidth: e / this.length,
      textHeight: t
    } : null;
  }
  coordsAt(e, t) {
    let i = tf(this, e, t);
    if (!this.children.length && i && this.parent) {
      let { heightOracle: r } = this.parent.view.viewState, s = i.bottom - i.top;
      if (Math.abs(s - r.lineHeight) < 2 && r.textHeight < s) {
        let o = (s - r.textHeight) / 2;
        return { top: i.top + o, bottom: i.bottom - o, left: i.left, right: i.left };
      }
    }
    return i;
  }
  become(e) {
    return !1;
  }
  covers() {
    return !0;
  }
  static find(e, t) {
    for (let i = 0, r = 0; i < e.children.length; i++) {
      let s = e.children[i], o = r + s.length;
      if (o >= t) {
        if (s instanceof Me)
          return s;
        if (o > t)
          break;
      }
      r = o + s.breakAfter;
    }
    return null;
  }
}
class cn extends he {
  constructor(e, t, i) {
    super(), this.widget = e, this.length = t, this.deco = i, this.breakAfter = 0, this.prevWidget = null;
  }
  merge(e, t, i, r, s, o) {
    return i && (!(i instanceof cn) || !this.widget.compare(i.widget) || e > 0 && s <= 0 || t < this.length && o <= 0) ? !1 : (this.length = e + (i ? i.length : 0) + (this.length - t), !0);
  }
  domAtPos(e) {
    return e == 0 ? ze.before(this.dom) : ze.after(this.dom, e == this.length);
  }
  split(e) {
    let t = this.length - e;
    this.length = e;
    let i = new cn(this.widget, t, this.deco);
    return i.breakAfter = this.breakAfter, i;
  }
  get children() {
    return na;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  get overrideDOMText() {
    return this.parent ? this.parent.view.state.doc.slice(this.posAtStart, this.posAtEnd) : re.empty;
  }
  domBoundsAround() {
    return null;
  }
  become(e) {
    return e instanceof cn && e.widget.constructor == this.widget.constructor ? (e.widget.compare(this.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, this.deco = e.deco, this.breakAfter = e.breakAfter, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  coordsAt(e, t) {
    return this.widget.coordsAt(this.dom, e, t);
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
  covers(e) {
    let { startSide: t, endSide: i } = this.deco;
    return t == i ? !1 : e < 0 ? t < 0 : i > 0;
  }
}
class Jt {
  /**
  Compare this instance to another instance of the same type.
  (TypeScript can't express this, but only instances of the same
  specific class will be passed to this method.) This is used to
  avoid redrawing widgets when they are replaced by a new
  decoration of the same type. The default implementation just
  returns `false`, which will cause new instances of the widget to
  always be redrawn.
  */
  eq(e) {
    return !1;
  }
  /**
  Update a DOM element created by a widget of the same type (but
  different, non-`eq` content) to reflect this widget. May return
  true to indicate that it could update, false to indicate it
  couldn't (in which case the widget will be redrawn). The default
  implementation just returns false.
  */
  updateDOM(e, t) {
    return !1;
  }
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  The estimated height this widget will have, to be used when
  estimating the height of content that hasn't been drawn. May
  return -1 to indicate you don't know. The default implementation
  returns -1.
  */
  get estimatedHeight() {
    return -1;
  }
  /**
  For inline widgets that are displayed inline (as opposed to
  `inline-block`) and introduce line breaks (through `<br>` tags
  or textual newlines), this must indicate the amount of line
  breaks they introduce. Defaults to 0.
  */
  get lineBreaks() {
    return 0;
  }
  /**
  Can be used to configure which kinds of events inside the widget
  should be ignored by the editor. The default is to ignore all
  events.
  */
  ignoreEvent(e) {
    return !0;
  }
  /**
  Override the way screen coordinates for positions at/in the
  widget are found. `pos` will be the offset into the widget, and
  `side` the side of the position that is being queried—less than
  zero for before, greater than zero for after, and zero for
  directly at that position.
  */
  coordsAt(e, t, i) {
    return null;
  }
  /**
  @internal
  */
  get isHidden() {
    return !1;
  }
  /**
  @internal
  */
  get editable() {
    return !1;
  }
  /**
  This is called when the an instance of the widget is removed
  from the editor view.
  */
  destroy(e) {
  }
}
var Ke = /* @__PURE__ */ function(n) {
  return n[n.Text = 0] = "Text", n[n.WidgetBefore = 1] = "WidgetBefore", n[n.WidgetAfter = 2] = "WidgetAfter", n[n.WidgetRange = 3] = "WidgetRange", n;
}(Ke || (Ke = {}));
class q extends Pn {
  constructor(e, t, i, r) {
    super(), this.startSide = e, this.endSide = t, this.widget = i, this.spec = r;
  }
  /**
  @internal
  */
  get heightRelevant() {
    return !1;
  }
  /**
  Create a mark decoration, which influences the styling of the
  content in its range. Nested mark decorations will cause nested
  DOM elements to be created. Nesting order is determined by
  precedence of the [facet](https://codemirror.net/6/docs/ref/#view.EditorView^decorations), with
  the higher-precedence decorations creating the inner DOM nodes.
  Such elements are split on line boundaries and on the boundaries
  of lower-precedence decorations.
  */
  static mark(e) {
    return new rr(e);
  }
  /**
  Create a widget decoration, which displays a DOM element at the
  given position.
  */
  static widget(e) {
    let t = Math.max(-1e4, Math.min(1e4, e.side || 0)), i = !!e.block;
    return t += i && !e.inlineOrder ? t > 0 ? 3e8 : -4e8 : t > 0 ? 1e8 : -1e8, new gn(e, t, t, i, e.widget || null, !1);
  }
  /**
  Create a replace decoration which replaces the given range with
  a widget, or simply hides it.
  */
  static replace(e) {
    let t = !!e.block, i, r;
    if (e.isBlockGap)
      i = -5e8, r = 4e8;
    else {
      let { start: s, end: o } = nf(e, t);
      i = (s ? t ? -3e8 : -1 : 5e8) - 1, r = (o ? t ? 2e8 : 1 : -6e8) + 1;
    }
    return new gn(e, i, r, t, e.widget || null, !0);
  }
  /**
  Create a line decoration, which can add DOM attributes to the
  line starting at the given position.
  */
  static line(e) {
    return new sr(e);
  }
  /**
  Build a [`DecorationSet`](https://codemirror.net/6/docs/ref/#view.DecorationSet) from the given
  decorated range or ranges. If the ranges aren't already sorted,
  pass `true` for `sort` to make the library sort them for you.
  */
  static set(e, t = !1) {
    return ie.of(e, t);
  }
  /**
  @internal
  */
  hasHeight() {
    return this.widget ? this.widget.estimatedHeight > -1 : !1;
  }
}
q.none = ie.empty;
class rr extends q {
  constructor(e) {
    let { start: t, end: i } = nf(e);
    super(t ? -1 : 5e8, i ? 1 : -6e8, null, e), this.tagName = e.tagName || "span", this.class = e.class || "", this.attrs = e.attributes || null;
  }
  eq(e) {
    var t, i;
    return this == e || e instanceof rr && this.tagName == e.tagName && (this.class || ((t = this.attrs) === null || t === void 0 ? void 0 : t.class)) == (e.class || ((i = e.attrs) === null || i === void 0 ? void 0 : i.class)) && ia(this.attrs, e.attrs, "class");
  }
  range(e, t = e) {
    if (e >= t)
      throw new RangeError("Mark decorations may not be empty");
    return super.range(e, t);
  }
}
rr.prototype.point = !1;
class sr extends q {
  constructor(e) {
    super(-2e8, -2e8, null, e);
  }
  eq(e) {
    return e instanceof sr && this.spec.class == e.spec.class && ia(this.spec.attributes, e.spec.attributes);
  }
  range(e, t = e) {
    if (t != e)
      throw new RangeError("Line decoration ranges must be zero-length");
    return super.range(e, t);
  }
}
sr.prototype.mapMode = qe.TrackBefore;
sr.prototype.point = !0;
class gn extends q {
  constructor(e, t, i, r, s, o) {
    super(t, i, s, e), this.block = r, this.isReplace = o, this.mapMode = r ? t <= 0 ? qe.TrackBefore : qe.TrackAfter : qe.TrackDel;
  }
  // Only relevant when this.block == true
  get type() {
    return this.startSide != this.endSide ? Ke.WidgetRange : this.startSide <= 0 ? Ke.WidgetBefore : Ke.WidgetAfter;
  }
  get heightRelevant() {
    return this.block || !!this.widget && (this.widget.estimatedHeight >= 5 || this.widget.lineBreaks > 0);
  }
  eq(e) {
    return e instanceof gn && vg(this.widget, e.widget) && this.block == e.block && this.startSide == e.startSide && this.endSide == e.endSide;
  }
  range(e, t = e) {
    if (this.isReplace && (e > t || e == t && this.startSide > 0 && this.endSide <= 0))
      throw new RangeError("Invalid range for replacement decoration");
    if (!this.isReplace && t != e)
      throw new RangeError("Widget decorations can only have zero-length ranges");
    return super.range(e, t);
  }
}
gn.prototype.point = !0;
function nf(n, e = !1) {
  let { inclusiveStart: t, inclusiveEnd: i } = n;
  return t == null && (t = n.inclusive), i == null && (i = n.inclusive), { start: t ?? e, end: i ?? e };
}
function vg(n, e) {
  return n == e || !!(n && e && n.compare(e));
}
function hl(n, e, t, i = 0) {
  let r = t.length - 1;
  r >= 0 && t[r] + i >= n ? t[r] = Math.max(t[r], e) : t.push(n, e);
}
class Vi {
  constructor(e, t, i, r) {
    this.doc = e, this.pos = t, this.end = i, this.disallowBlockEffectsFor = r, this.content = [], this.curLine = null, this.breakAtStart = 0, this.pendingBuffer = 0, this.bufferMarks = [], this.atCursorPos = !0, this.openStart = -1, this.openEnd = -1, this.text = "", this.textOff = 0, this.cursor = e.iter(), this.skip = t;
  }
  posCovered() {
    if (this.content.length == 0)
      return !this.breakAtStart && this.doc.lineAt(this.pos).from != this.pos;
    let e = this.content[this.content.length - 1];
    return !(e.breakAfter || e instanceof cn && e.deco.endSide < 0);
  }
  getLine() {
    return this.curLine || (this.content.push(this.curLine = new Me()), this.atCursorPos = !0), this.curLine;
  }
  flushBuffer(e = this.bufferMarks) {
    this.pendingBuffer && (this.curLine.append(gr(new li(-1), e), e.length), this.pendingBuffer = 0);
  }
  addBlockWidget(e) {
    this.flushBuffer(), this.curLine = null, this.content.push(e);
  }
  finish(e) {
    this.pendingBuffer && e <= this.bufferMarks.length ? this.flushBuffer() : this.pendingBuffer = 0, !this.posCovered() && !(e && this.content.length && this.content[this.content.length - 1] instanceof cn) && this.getLine();
  }
  buildText(e, t, i) {
    for (; e > 0; ) {
      if (this.textOff == this.text.length) {
        let { value: s, lineBreak: o, done: l } = this.cursor.next(this.skip);
        if (this.skip = 0, l)
          throw new Error("Ran out of text content when drawing inline views");
        if (o) {
          this.posCovered() || this.getLine(), this.content.length ? this.content[this.content.length - 1].breakAfter = 1 : this.breakAtStart = 1, this.flushBuffer(), this.curLine = null, this.atCursorPos = !0, e--;
          continue;
        } else
          this.text = s, this.textOff = 0;
      }
      let r = Math.min(
        this.text.length - this.textOff,
        e,
        512
        /* T.Chunk */
      );
      this.flushBuffer(t.slice(t.length - i)), this.getLine().append(gr(new Ct(this.text.slice(this.textOff, this.textOff + r)), t), i), this.atCursorPos = !0, this.textOff += r, e -= r, i = 0;
    }
  }
  span(e, t, i, r) {
    this.buildText(t - e, i, r), this.pos = t, this.openStart < 0 && (this.openStart = r);
  }
  point(e, t, i, r, s, o) {
    if (this.disallowBlockEffectsFor[o] && i instanceof gn) {
      if (i.block)
        throw new RangeError("Block decorations may not be specified via plugins");
      if (t > this.doc.lineAt(this.pos).to)
        throw new RangeError("Decorations that replace line breaks may not be specified via plugins");
    }
    let l = t - e;
    if (i instanceof gn)
      if (i.block)
        i.startSide > 0 && !this.posCovered() && this.getLine(), this.addBlockWidget(new cn(i.widget || ai.block, l, i));
      else {
        let a = ln.create(i.widget || ai.inline, l, l ? 0 : i.startSide), u = this.atCursorPos && !a.isEditable && s <= r.length && (e < t || i.startSide > 0), c = !a.isEditable && (e < t || s > r.length || i.startSide <= 0), h = this.getLine();
        this.pendingBuffer == 2 && !u && !a.isEditable && (this.pendingBuffer = 0), this.flushBuffer(r), u && (h.append(gr(new li(1), r), s), s = r.length + Math.max(0, s - r.length)), h.append(gr(a, r), s), this.atCursorPos = c, this.pendingBuffer = c ? e < t || s > r.length ? 1 : 2 : 0, this.pendingBuffer && (this.bufferMarks = r.slice());
      }
    else
      this.doc.lineAt(this.pos).from == this.pos && this.getLine().addLineDeco(i);
    l && (this.textOff + l <= this.text.length ? this.textOff += l : (this.skip += l - (this.text.length - this.textOff), this.text = "", this.textOff = 0), this.pos = t), this.openStart < 0 && (this.openStart = s);
  }
  static build(e, t, i, r, s) {
    let o = new Vi(e, t, i, s);
    return o.openEnd = ie.spans(r, t, i, o), o.openStart < 0 && (o.openStart = o.openEnd), o.finish(o.openEnd), o;
  }
}
function gr(n, e) {
  for (let t of e)
    n = new Gt(t, [n], n.length);
  return n;
}
class ai extends Jt {
  constructor(e) {
    super(), this.tag = e;
  }
  eq(e) {
    return e.tag == this.tag;
  }
  toDOM() {
    return document.createElement(this.tag);
  }
  updateDOM(e) {
    return e.nodeName.toLowerCase() == this.tag;
  }
  get isHidden() {
    return !0;
  }
}
ai.inline = /* @__PURE__ */ new ai("span");
ai.block = /* @__PURE__ */ new ai("div");
var ye = /* @__PURE__ */ function(n) {
  return n[n.LTR = 0] = "LTR", n[n.RTL = 1] = "RTL", n;
}(ye || (ye = {}));
const Nn = ye.LTR, ra = ye.RTL;
function rf(n) {
  let e = [];
  for (let t = 0; t < n.length; t++)
    e.push(1 << +n[t]);
  return e;
}
const Sg = /* @__PURE__ */ rf("88888888888888888888888888888888888666888888787833333333337888888000000000000000000000000008888880000000000000000000000000088888888888888888888888888888888888887866668888088888663380888308888800000000000000000000000800000000000000000000000000000008"), Cg = /* @__PURE__ */ rf("4444448826627288999999999992222222222222222222222222222222222222222222222229999999999999999999994444444444644222822222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222999999949999999229989999223333333333"), fl = /* @__PURE__ */ Object.create(null), Tt = [];
for (let n of ["()", "[]", "{}"]) {
  let e = /* @__PURE__ */ n.charCodeAt(0), t = /* @__PURE__ */ n.charCodeAt(1);
  fl[e] = t, fl[t] = -e;
}
function sf(n) {
  return n <= 247 ? Sg[n] : 1424 <= n && n <= 1524 ? 2 : 1536 <= n && n <= 1785 ? Cg[n - 1536] : 1774 <= n && n <= 2220 ? 4 : 8192 <= n && n <= 8204 ? 256 : 64336 <= n && n <= 65023 ? 4 : 1;
}
const Ag = /[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac\ufb50-\ufdff]/;
class an {
  /**
  The direction of this span.
  */
  get dir() {
    return this.level % 2 ? ra : Nn;
  }
  /**
  @internal
  */
  constructor(e, t, i) {
    this.from = e, this.to = t, this.level = i;
  }
  /**
  @internal
  */
  side(e, t) {
    return this.dir == t == e ? this.to : this.from;
  }
  /**
  @internal
  */
  forward(e, t) {
    return e == (this.dir == t);
  }
  /**
  @internal
  */
  static find(e, t, i, r) {
    let s = -1;
    for (let o = 0; o < e.length; o++) {
      let l = e[o];
      if (l.from <= t && l.to >= t) {
        if (l.level == i)
          return o;
        (s < 0 || (r != 0 ? r < 0 ? l.from < t : l.to > t : e[s].level > l.level)) && (s = o);
      }
    }
    if (s < 0)
      throw new RangeError("Index out of range");
    return s;
  }
}
function of(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++) {
    let i = n[t], r = e[t];
    if (i.from != r.from || i.to != r.to || i.direction != r.direction || !of(i.inner, r.inner))
      return !1;
  }
  return !0;
}
const ce = [];
function Mg(n, e, t, i, r) {
  for (let s = 0; s <= i.length; s++) {
    let o = s ? i[s - 1].to : e, l = s < i.length ? i[s].from : t, a = s ? 256 : r;
    for (let u = o, c = a, h = a; u < l; u++) {
      let f = sf(n.charCodeAt(u));
      f == 512 ? f = c : f == 8 && h == 4 && (f = 16), ce[u] = f == 4 ? 2 : f, f & 7 && (h = f), c = f;
    }
    for (let u = o, c = a, h = a; u < l; u++) {
      let f = ce[u];
      if (f == 128)
        u < l - 1 && c == ce[u + 1] && c & 24 ? f = ce[u] = c : ce[u] = 256;
      else if (f == 64) {
        let d = u + 1;
        for (; d < l && ce[d] == 64; )
          d++;
        let p = u && c == 8 || d < t && ce[d] == 8 ? h == 1 ? 1 : 8 : 256;
        for (let g = u; g < d; g++)
          ce[g] = p;
        u = d - 1;
      } else
        f == 8 && h == 1 && (ce[u] = 1);
      c = f, f & 7 && (h = f);
    }
  }
}
function Tg(n, e, t, i, r) {
  let s = r == 1 ? 2 : 1;
  for (let o = 0, l = 0, a = 0; o <= i.length; o++) {
    let u = o ? i[o - 1].to : e, c = o < i.length ? i[o].from : t;
    for (let h = u, f, d, p; h < c; h++)
      if (d = fl[f = n.charCodeAt(h)])
        if (d < 0) {
          for (let g = l - 3; g >= 0; g -= 3)
            if (Tt[g + 1] == -d) {
              let m = Tt[g + 2], y = m & 2 ? r : m & 4 ? m & 1 ? s : r : 0;
              y && (ce[h] = ce[Tt[g]] = y), l = g;
              break;
            }
        } else {
          if (Tt.length == 189)
            break;
          Tt[l++] = h, Tt[l++] = f, Tt[l++] = a;
        }
      else if ((p = ce[h]) == 2 || p == 1) {
        let g = p == r;
        a = g ? 0 : 1;
        for (let m = l - 3; m >= 0; m -= 3) {
          let y = Tt[m + 2];
          if (y & 2)
            break;
          if (g)
            Tt[m + 2] |= 2;
          else {
            if (y & 4)
              break;
            Tt[m + 2] |= 4;
          }
        }
      }
  }
}
function Og(n, e, t, i) {
  for (let r = 0, s = i; r <= t.length; r++) {
    let o = r ? t[r - 1].to : n, l = r < t.length ? t[r].from : e;
    for (let a = o; a < l; ) {
      let u = ce[a];
      if (u == 256) {
        let c = a + 1;
        for (; ; )
          if (c == l) {
            if (r == t.length)
              break;
            c = t[r++].to, l = r < t.length ? t[r].from : e;
          } else if (ce[c] == 256)
            c++;
          else
            break;
        let h = s == 1, f = (c < e ? ce[c] : i) == 1, d = h == f ? h ? 1 : 2 : i;
        for (let p = c, g = r, m = g ? t[g - 1].to : n; p > a; )
          p == m && (p = t[--g].from, m = g ? t[g - 1].to : n), ce[--p] = d;
        a = c;
      } else
        s = u, a++;
    }
  }
}
function dl(n, e, t, i, r, s, o) {
  let l = i % 2 ? 2 : 1;
  if (i % 2 == r % 2)
    for (let a = e, u = 0; a < t; ) {
      let c = !0, h = !1;
      if (u == s.length || a < s[u].from) {
        let g = ce[a];
        g != l && (c = !1, h = g == 16);
      }
      let f = !c && l == 1 ? [] : null, d = c ? i : i + 1, p = a;
      e:
        for (; ; )
          if (u < s.length && p == s[u].from) {
            if (h)
              break e;
            let g = s[u];
            if (!c)
              for (let m = g.to, y = u + 1; ; ) {
                if (m == t)
                  break e;
                if (y < s.length && s[y].from == m)
                  m = s[y++].to;
                else {
                  if (ce[m] == l)
                    break e;
                  break;
                }
              }
            if (u++, f)
              f.push(g);
            else {
              g.from > a && o.push(new an(a, g.from, d));
              let m = g.direction == Nn != !(d % 2);
              pl(n, m ? i + 1 : i, r, g.inner, g.from, g.to, o), a = g.to;
            }
            p = g.to;
          } else {
            if (p == t || (c ? ce[p] != l : ce[p] == l))
              break;
            p++;
          }
      f ? dl(n, a, p, i + 1, r, f, o) : a < p && o.push(new an(a, p, d)), a = p;
    }
  else
    for (let a = t, u = s.length; a > e; ) {
      let c = !0, h = !1;
      if (!u || a > s[u - 1].to) {
        let g = ce[a - 1];
        g != l && (c = !1, h = g == 16);
      }
      let f = !c && l == 1 ? [] : null, d = c ? i : i + 1, p = a;
      e:
        for (; ; )
          if (u && p == s[u - 1].to) {
            if (h)
              break e;
            let g = s[--u];
            if (!c)
              for (let m = g.from, y = u; ; ) {
                if (m == e)
                  break e;
                if (y && s[y - 1].to == m)
                  m = s[--y].from;
                else {
                  if (ce[m - 1] == l)
                    break e;
                  break;
                }
              }
            if (f)
              f.push(g);
            else {
              g.to < a && o.push(new an(g.to, a, d));
              let m = g.direction == Nn != !(d % 2);
              pl(n, m ? i + 1 : i, r, g.inner, g.from, g.to, o), a = g.from;
            }
            p = g.from;
          } else {
            if (p == e || (c ? ce[p - 1] != l : ce[p - 1] == l))
              break;
            p--;
          }
      f ? dl(n, p, a, i + 1, r, f, o) : p < a && o.push(new an(p, a, d)), a = p;
    }
}
function pl(n, e, t, i, r, s, o) {
  let l = e % 2 ? 2 : 1;
  Mg(n, r, s, i, l), Tg(n, r, s, i, l), Og(r, s, i, l), dl(n, r, s, e, t, i, o);
}
function Dg(n, e, t) {
  if (!n)
    return [new an(0, 0, e == ra ? 1 : 0)];
  if (e == Nn && !t.length && !Ag.test(n))
    return lf(n.length);
  if (t.length)
    for (; n.length > ce.length; )
      ce[ce.length] = 256;
  let i = [], r = e == Nn ? 0 : 1;
  return pl(n, r, r, t, 0, n.length, i), i;
}
function lf(n) {
  return [new an(0, n, 0)];
}
let af = "";
function Eg(n, e, t, i, r) {
  var s;
  let o = i.head - n.from, l = an.find(e, o, (s = i.bidiLevel) !== null && s !== void 0 ? s : -1, i.assoc), a = e[l], u = a.side(r, t);
  if (o == u) {
    let f = l += r ? 1 : -1;
    if (f < 0 || f >= e.length)
      return null;
    a = e[l = f], o = a.side(!r, t), u = a.side(r, t);
  }
  let c = Re(n.text, o, a.forward(r, t));
  (c < a.from || c > a.to) && (c = u), af = n.text.slice(Math.min(o, c), Math.max(o, c));
  let h = l == (r ? e.length - 1 : 0) ? null : e[l + (r ? 1 : -1)];
  return h && c == u && h.level + (r ? 0 : 1) < a.level ? T.cursor(h.side(!r, t) + n.from, h.forward(r, t) ? 1 : -1, h.level) : T.cursor(c + n.from, a.forward(r, t) ? -1 : 1, a.level);
}
function Lg(n, e, t) {
  for (let i = e; i < t; i++) {
    let r = sf(n.charCodeAt(i));
    if (r == 1)
      return Nn;
    if (r == 2 || r == 4)
      return ra;
  }
  return Nn;
}
const uf = /* @__PURE__ */ j.define(), cf = /* @__PURE__ */ j.define(), hf = /* @__PURE__ */ j.define(), ff = /* @__PURE__ */ j.define(), ml = /* @__PURE__ */ j.define(), df = /* @__PURE__ */ j.define(), pf = /* @__PURE__ */ j.define(), mf = /* @__PURE__ */ j.define({
  combine: (n) => n.some((e) => e)
}), gf = /* @__PURE__ */ j.define({
  combine: (n) => n.some((e) => e)
}), yf = /* @__PURE__ */ j.define();
class ei {
  constructor(e, t = "nearest", i = "nearest", r = 5, s = 5, o = !1) {
    this.range = e, this.y = t, this.x = i, this.yMargin = r, this.xMargin = s, this.isSnapshot = o;
  }
  map(e) {
    return e.empty ? this : new ei(this.range.map(e), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
  clip(e) {
    return this.range.to <= e.doc.length ? this : new ei(T.cursor(e.doc.length), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
}
const yr = /* @__PURE__ */ X.define({ map: (n, e) => n.map(e) });
function Je(n, e, t) {
  let i = n.facet(ff);
  i.length ? i[0](e) : window.onerror ? window.onerror(String(e), t, void 0, void 0, e) : t ? console.error(t + ":", e) : console.error(e);
}
const Rs = /* @__PURE__ */ j.define({ combine: (n) => n.length ? n[0] : !0 });
let Ig = 0;
const Ei = /* @__PURE__ */ j.define();
class ke {
  constructor(e, t, i, r, s) {
    this.id = e, this.create = t, this.domEventHandlers = i, this.domEventObservers = r, this.extension = s(this);
  }
  /**
  Define a plugin from a constructor function that creates the
  plugin's value, given an editor view.
  */
  static define(e, t) {
    const { eventHandlers: i, eventObservers: r, provide: s, decorations: o } = t || {};
    return new ke(Ig++, e, i, r, (l) => {
      let a = [Ei.of(l)];
      return o && a.push(Gi.of((u) => {
        let c = u.plugin(l);
        return c ? o(c) : q.none;
      })), s && a.push(s(l)), a;
    });
  }
  /**
  Create a plugin for a class whose constructor takes a single
  editor view as argument.
  */
  static fromClass(e, t) {
    return ke.define((i) => new e(i), t);
  }
}
class ro {
  constructor(e) {
    this.spec = e, this.mustUpdate = null, this.value = null;
  }
  update(e) {
    if (this.value) {
      if (this.mustUpdate) {
        let t = this.mustUpdate;
        if (this.mustUpdate = null, this.value.update)
          try {
            this.value.update(t);
          } catch (i) {
            if (Je(t.state, i, "CodeMirror plugin crashed"), this.value.destroy)
              try {
                this.value.destroy();
              } catch {
              }
            this.deactivate();
          }
      }
    } else if (this.spec)
      try {
        this.value = this.spec.create(e);
      } catch (t) {
        Je(e.state, t, "CodeMirror plugin crashed"), this.deactivate();
      }
    return this;
  }
  destroy(e) {
    var t;
    if (!((t = this.value) === null || t === void 0) && t.destroy)
      try {
        this.value.destroy();
      } catch (i) {
        Je(e.state, i, "CodeMirror plugin crashed");
      }
  }
  deactivate() {
    this.spec = this.value = null;
  }
}
const bf = /* @__PURE__ */ j.define(), sa = /* @__PURE__ */ j.define(), Gi = /* @__PURE__ */ j.define(), xf = /* @__PURE__ */ j.define(), oa = /* @__PURE__ */ j.define(), wf = /* @__PURE__ */ j.define();
function cu(n, e) {
  let t = n.state.facet(wf);
  if (!t.length)
    return t;
  let i = t.map((s) => s instanceof Function ? s(n) : s), r = [];
  return ie.spans(i, e.from, e.to, {
    point() {
    },
    span(s, o, l, a) {
      let u = s - e.from, c = o - e.from, h = r;
      for (let f = l.length - 1; f >= 0; f--, a--) {
        let d = l[f].spec.bidiIsolate, p;
        if (d == null && (d = Lg(e.text, u, c)), a > 0 && h.length && (p = h[h.length - 1]).to == u && p.direction == d)
          p.to = c, h = p.inner;
        else {
          let g = { from: u, to: c, direction: d, inner: [] };
          h.push(g), h = g.inner;
        }
      }
    }
  }), r;
}
const kf = /* @__PURE__ */ j.define();
function vf(n) {
  let e = 0, t = 0, i = 0, r = 0;
  for (let s of n.state.facet(kf)) {
    let o = s(n);
    o && (o.left != null && (e = Math.max(e, o.left)), o.right != null && (t = Math.max(t, o.right)), o.top != null && (i = Math.max(i, o.top)), o.bottom != null && (r = Math.max(r, o.bottom)));
  }
  return { left: e, right: t, top: i, bottom: r };
}
const Li = /* @__PURE__ */ j.define();
class pt {
  constructor(e, t, i, r) {
    this.fromA = e, this.toA = t, this.fromB = i, this.toB = r;
  }
  join(e) {
    return new pt(Math.min(this.fromA, e.fromA), Math.max(this.toA, e.toA), Math.min(this.fromB, e.fromB), Math.max(this.toB, e.toB));
  }
  addToSet(e) {
    let t = e.length, i = this;
    for (; t > 0; t--) {
      let r = e[t - 1];
      if (!(r.fromA > i.toA)) {
        if (r.toA < i.fromA)
          break;
        i = i.join(r), e.splice(t - 1, 1);
      }
    }
    return e.splice(t, 0, i), e;
  }
  static extendWithRanges(e, t) {
    if (t.length == 0)
      return e;
    let i = [];
    for (let r = 0, s = 0, o = 0, l = 0; ; r++) {
      let a = r == e.length ? null : e[r], u = o - l, c = a ? a.fromB : 1e9;
      for (; s < t.length && t[s] < c; ) {
        let h = t[s], f = t[s + 1], d = Math.max(l, h), p = Math.min(c, f);
        if (d <= p && new pt(d + u, p + u, d, p).addToSet(i), f > c)
          break;
        s += 2;
      }
      if (!a)
        return i;
      new pt(a.fromA, a.toA, a.fromB, a.toB).addToSet(i), o = a.toA, l = a.toB;
    }
  }
}
class os {
  constructor(e, t, i) {
    this.view = e, this.state = t, this.transactions = i, this.flags = 0, this.startState = e.state, this.changes = Te.empty(this.startState.doc.length);
    for (let s of i)
      this.changes = this.changes.compose(s.changes);
    let r = [];
    this.changes.iterChangedRanges((s, o, l, a) => r.push(new pt(s, o, l, a))), this.changedRanges = r;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new os(e, t, i);
  }
  /**
  Tells you whether the [viewport](https://codemirror.net/6/docs/ref/#view.EditorView.viewport) or
  [visible ranges](https://codemirror.net/6/docs/ref/#view.EditorView.visibleRanges) changed in this
  update.
  */
  get viewportChanged() {
    return (this.flags & 4) > 0;
  }
  /**
  Indicates whether the height of a block element in the editor
  changed in this update.
  */
  get heightChanged() {
    return (this.flags & 2) > 0;
  }
  /**
  Returns true when the document was modified or the size of the
  editor, or elements within the editor, changed.
  */
  get geometryChanged() {
    return this.docChanged || (this.flags & 10) > 0;
  }
  /**
  True when this update indicates a focus change.
  */
  get focusChanged() {
    return (this.flags & 1) > 0;
  }
  /**
  Whether the document changed in this update.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Whether the selection was explicitly set in this update.
  */
  get selectionSet() {
    return this.transactions.some((e) => e.selection);
  }
  /**
  @internal
  */
  get empty() {
    return this.flags == 0 && this.transactions.length == 0;
  }
}
class hu extends he {
  get length() {
    return this.view.state.doc.length;
  }
  constructor(e) {
    super(), this.view = e, this.decorations = [], this.dynamicDecorationMap = [], this.domChanged = null, this.hasComposition = null, this.markedForComposition = /* @__PURE__ */ new Set(), this.lastCompositionAfterCursor = !1, this.minWidth = 0, this.minWidthFrom = 0, this.minWidthTo = 0, this.impreciseAnchor = null, this.impreciseHead = null, this.forceSelection = !1, this.lastUpdate = Date.now(), this.setDOM(e.contentDOM), this.children = [new Me()], this.children[0].setParent(this), this.updateDeco(), this.updateInner([new pt(0, 0, 0, e.state.doc.length)], 0, null);
  }
  // Update the document view to a given state.
  update(e) {
    var t;
    let i = e.changedRanges;
    this.minWidth > 0 && i.length && (i.every(({ fromA: u, toA: c }) => c < this.minWidthFrom || u > this.minWidthTo) ? (this.minWidthFrom = e.changes.mapPos(this.minWidthFrom, 1), this.minWidthTo = e.changes.mapPos(this.minWidthTo, 1)) : this.minWidth = this.minWidthFrom = this.minWidthTo = 0);
    let r = -1;
    this.view.inputState.composing >= 0 && (!((t = this.domChanged) === null || t === void 0) && t.newSel ? r = this.domChanged.newSel.head : !Hg(e.changes, this.hasComposition) && !e.selectionSet && (r = e.state.selection.main.head));
    let s = r > -1 ? Bg(this.view, e.changes, r) : null;
    if (this.domChanged = null, this.hasComposition) {
      this.markedForComposition.clear();
      let { from: u, to: c } = this.hasComposition;
      i = new pt(u, c, e.changes.mapPos(u, -1), e.changes.mapPos(c, 1)).addToSet(i.slice());
    }
    this.hasComposition = s ? { from: s.range.fromB, to: s.range.toB } : null, ($.ie || $.chrome) && !s && e && e.state.doc.lines != e.startState.doc.lines && (this.forceSelection = !0);
    let o = this.decorations, l = this.updateDeco(), a = Fg(o, l, e.changes);
    return i = pt.extendWithRanges(i, a), !(this.flags & 7) && i.length == 0 ? !1 : (this.updateInner(i, e.startState.doc.length, s), e.transactions.length && (this.lastUpdate = Date.now()), !0);
  }
  // Used by update and the constructor do perform the actual DOM
  // update
  updateInner(e, t, i) {
    this.view.viewState.mustMeasureContent = !0, this.updateChildren(e, t, i);
    let { observer: r } = this.view;
    r.ignore(() => {
      this.dom.style.height = this.view.viewState.contentHeight / this.view.scaleY + "px", this.dom.style.flexBasis = this.minWidth ? this.minWidth + "px" : "";
      let o = $.chrome || $.ios ? { node: r.selectionRange.focusNode, written: !1 } : void 0;
      this.sync(this.view, o), this.flags &= -8, o && (o.written || r.selectionRange.focusNode != o.node) && (this.forceSelection = !0), this.dom.style.height = "";
    }), this.markedForComposition.forEach(
      (o) => o.flags &= -9
      /* ViewFlag.Composition */
    );
    let s = [];
    if (this.view.viewport.from || this.view.viewport.to < this.view.state.doc.length)
      for (let o of this.children)
        o instanceof cn && o.widget instanceof fu && s.push(o.dom);
    r.updateGaps(s);
  }
  updateChildren(e, t, i) {
    let r = i ? i.range.addToSet(e.slice()) : e, s = this.childCursor(t);
    for (let o = r.length - 1; ; o--) {
      let l = o >= 0 ? r[o] : null;
      if (!l)
        break;
      let { fromA: a, toA: u, fromB: c, toB: h } = l, f, d, p, g;
      if (i && i.range.fromB < h && i.range.toB > c) {
        let O = Vi.build(this.view.state.doc, c, i.range.fromB, this.decorations, this.dynamicDecorationMap), A = Vi.build(this.view.state.doc, i.range.toB, h, this.decorations, this.dynamicDecorationMap);
        d = O.breakAtStart, p = O.openStart, g = A.openEnd;
        let b = this.compositionView(i);
        A.breakAtStart ? b.breakAfter = 1 : A.content.length && b.merge(b.length, b.length, A.content[0], !1, A.openStart, 0) && (b.breakAfter = A.content[0].breakAfter, A.content.shift()), O.content.length && b.merge(0, 0, O.content[O.content.length - 1], !0, 0, O.openEnd) && O.content.pop(), f = O.content.concat(b).concat(A.content);
      } else
        ({ content: f, breakAtStart: d, openStart: p, openEnd: g } = Vi.build(this.view.state.doc, c, h, this.decorations, this.dynamicDecorationMap));
      let { i: m, off: y } = s.findPos(u, 1), { i: v, off: C } = s.findPos(a, -1);
      Yh(this, v, C, m, y, f, d, p, g);
    }
    i && this.fixCompositionDOM(i);
  }
  compositionView(e) {
    let t = new Ct(e.text.nodeValue);
    t.flags |= 8;
    for (let { deco: r } of e.marks)
      t = new Gt(r, [t], t.length);
    let i = new Me();
    return i.append(t, 0), i;
  }
  fixCompositionDOM(e) {
    let t = (s, o) => {
      o.flags |= 8 | (o.children.some(
        (a) => a.flags & 7
        /* ViewFlag.Dirty */
      ) ? 1 : 0), this.markedForComposition.add(o);
      let l = he.get(s);
      l && l != o && (l.dom = null), o.setDOM(s);
    }, i = this.childPos(e.range.fromB, 1), r = this.children[i.i];
    t(e.line, r);
    for (let s = e.marks.length - 1; s >= -1; s--)
      i = r.childPos(i.off, 1), r = r.children[i.i], t(s >= 0 ? e.marks[s].node : e.text, r);
  }
  // Sync the DOM selection to this.state.selection
  updateSelection(e = !1, t = !1) {
    (e || !this.view.observer.selectionRange.focusNode) && this.view.observer.readSelectionRange();
    let i = this.view.root.activeElement, r = i == this.dom, s = !r && Ur(this.dom, this.view.observer.selectionRange) && !(i && this.dom.contains(i));
    if (!(r || t || s))
      return;
    let o = this.forceSelection;
    this.forceSelection = !1;
    let l = this.view.state.selection.main, a = this.moveToLine(this.domAtPos(l.anchor)), u = l.empty ? a : this.moveToLine(this.domAtPos(l.head));
    if ($.gecko && l.empty && !this.hasComposition && Pg(a)) {
      let h = document.createTextNode("");
      this.view.observer.ignore(() => a.node.insertBefore(h, a.node.childNodes[a.offset] || null)), a = u = new ze(h, 0), o = !0;
    }
    let c = this.view.observer.selectionRange;
    (o || !c.focusNode || (!Hi(a.node, a.offset, c.anchorNode, c.anchorOffset) || !Hi(u.node, u.offset, c.focusNode, c.focusOffset)) && !this.suppressWidgetCursorChange(c, l)) && (this.view.observer.ignore(() => {
      $.android && $.chrome && this.dom.contains(c.focusNode) && zg(c.focusNode, this.dom) && (this.dom.blur(), this.dom.focus({ preventScroll: !0 }));
      let h = rs(this.view.root);
      if (h)
        if (l.empty) {
          if ($.gecko) {
            let f = Rg(a.node, a.offset);
            if (f && f != 3) {
              let d = (f == 1 ? Uh : Kh)(a.node, a.offset);
              d && (a = new ze(d.node, d.offset));
            }
          }
          h.collapse(a.node, a.offset), l.bidiLevel != null && h.caretBidiLevel !== void 0 && (h.caretBidiLevel = l.bidiLevel);
        } else if (h.extend) {
          h.collapse(a.node, a.offset);
          try {
            h.extend(u.node, u.offset);
          } catch {
          }
        } else {
          let f = document.createRange();
          l.anchor > l.head && ([a, u] = [u, a]), f.setEnd(u.node, u.offset), f.setStart(a.node, a.offset), h.removeAllRanges(), h.addRange(f);
        }
      s && this.view.root.activeElement == this.dom && (this.dom.blur(), i && i.focus());
    }), this.view.observer.setSelectionRange(a, u)), this.impreciseAnchor = a.precise ? null : new ze(c.anchorNode, c.anchorOffset), this.impreciseHead = u.precise ? null : new ze(c.focusNode, c.focusOffset);
  }
  // If a zero-length widget is inserted next to the cursor during
  // composition, avoid moving it across it and disrupting the
  // composition.
  suppressWidgetCursorChange(e, t) {
    return this.hasComposition && t.empty && Hi(e.focusNode, e.focusOffset, e.anchorNode, e.anchorOffset) && this.posFromDOM(e.focusNode, e.focusOffset) == t.head;
  }
  enforceCursorAssoc() {
    if (this.hasComposition)
      return;
    let { view: e } = this, t = e.state.selection.main, i = rs(e.root), { anchorNode: r, anchorOffset: s } = e.observer.selectionRange;
    if (!i || !t.empty || !t.assoc || !i.modify)
      return;
    let o = Me.find(this, t.head);
    if (!o)
      return;
    let l = o.posAtStart;
    if (t.head == l || t.head == l + o.length)
      return;
    let a = this.coordsAt(t.head, -1), u = this.coordsAt(t.head, 1);
    if (!a || !u || a.bottom > u.top)
      return;
    let c = this.domAtPos(t.head + t.assoc);
    i.collapse(c.node, c.offset), i.modify("move", t.assoc < 0 ? "forward" : "backward", "lineboundary"), e.observer.readSelectionRange();
    let h = e.observer.selectionRange;
    e.docView.posFromDOM(h.anchorNode, h.anchorOffset) != t.from && i.collapse(r, s);
  }
  // If a position is in/near a block widget, move it to a nearby text
  // line, since we don't want the cursor inside a block widget.
  moveToLine(e) {
    let t = this.dom, i;
    if (e.node != t)
      return e;
    for (let r = e.offset; !i && r < t.childNodes.length; r++) {
      let s = he.get(t.childNodes[r]);
      s instanceof Me && (i = s.domAtPos(0));
    }
    for (let r = e.offset - 1; !i && r >= 0; r--) {
      let s = he.get(t.childNodes[r]);
      s instanceof Me && (i = s.domAtPos(s.length));
    }
    return i ? new ze(i.node, i.offset, !0) : e;
  }
  nearest(e) {
    for (let t = e; t; ) {
      let i = he.get(t);
      if (i && i.rootView == this)
        return i;
      t = t.parentNode;
    }
    return null;
  }
  posFromDOM(e, t) {
    let i = this.nearest(e);
    if (!i)
      throw new RangeError("Trying to find position for a DOM position outside of the document");
    return i.localPosFromDOM(e, t) + i.posAtStart;
  }
  domAtPos(e) {
    let { i: t, off: i } = this.childCursor().findPos(e, -1);
    for (; t < this.children.length - 1; ) {
      let r = this.children[t];
      if (i < r.length || r instanceof Me)
        break;
      t++, i = 0;
    }
    return this.children[t].domAtPos(i);
  }
  coordsAt(e, t) {
    let i = null, r = 0;
    for (let s = this.length, o = this.children.length - 1; o >= 0; o--) {
      let l = this.children[o], a = s - l.breakAfter, u = a - l.length;
      if (a < e)
        break;
      u <= e && (u < e || l.covers(-1)) && (a > e || l.covers(1)) && (!i || l instanceof Me && !(i instanceof Me && t >= 0)) && (i = l, r = u), s = u;
    }
    return i ? i.coordsAt(e - r, t) : null;
  }
  coordsForChar(e) {
    let { i: t, off: i } = this.childPos(e, 1), r = this.children[t];
    if (!(r instanceof Me))
      return null;
    for (; r.children.length; ) {
      let { i: l, off: a } = r.childPos(i, 1);
      for (; ; l++) {
        if (l == r.children.length)
          return null;
        if ((r = r.children[l]).length)
          break;
      }
      i = a;
    }
    if (!(r instanceof Ct))
      return null;
    let s = Re(r.text, i);
    if (s == i)
      return null;
    let o = Rn(r.dom, i, s).getClientRects();
    for (let l = 0; l < o.length; l++) {
      let a = o[l];
      if (l == o.length - 1 || a.top < a.bottom && a.left < a.right)
        return a;
    }
    return null;
  }
  measureVisibleLineHeights(e) {
    let t = [], { from: i, to: r } = e, s = this.view.contentDOM.clientWidth, o = s > Math.max(this.view.scrollDOM.clientWidth, this.minWidth) + 1, l = -1, a = this.view.textDirection == ye.LTR;
    for (let u = 0, c = 0; c < this.children.length; c++) {
      let h = this.children[c], f = u + h.length;
      if (f > r)
        break;
      if (u >= i) {
        let d = h.dom.getBoundingClientRect();
        if (t.push(d.height), o) {
          let p = h.dom.lastChild, g = p ? oi(p) : [];
          if (g.length) {
            let m = g[g.length - 1], y = a ? m.right - d.left : d.right - m.left;
            y > l && (l = y, this.minWidth = s, this.minWidthFrom = u, this.minWidthTo = f);
          }
        }
      }
      u = f + h.breakAfter;
    }
    return t;
  }
  textDirectionAt(e) {
    let { i: t } = this.childPos(e, 1);
    return getComputedStyle(this.children[t].dom).direction == "rtl" ? ye.RTL : ye.LTR;
  }
  measureTextSize() {
    for (let s of this.children)
      if (s instanceof Me) {
        let o = s.measureTextSize();
        if (o)
          return o;
      }
    let e = document.createElement("div"), t, i, r;
    return e.className = "cm-line", e.style.width = "99999px", e.style.position = "absolute", e.textContent = "abc def ghi jkl mno pqr stu", this.view.observer.ignore(() => {
      this.dom.appendChild(e);
      let s = oi(e.firstChild)[0];
      t = e.getBoundingClientRect().height, i = s ? s.width / 27 : 7, r = s ? s.height : t, e.remove();
    }), { lineHeight: t, charWidth: i, textHeight: r };
  }
  childCursor(e = this.length) {
    let t = this.children.length;
    return t && (e -= this.children[--t].length), new Gh(this.children, e, t);
  }
  computeBlockGapDeco() {
    let e = [], t = this.view.viewState;
    for (let i = 0, r = 0; ; r++) {
      let s = r == t.viewports.length ? null : t.viewports[r], o = s ? s.from - 1 : this.length;
      if (o > i) {
        let l = (t.lineBlockAt(o).bottom - t.lineBlockAt(i).top) / this.view.scaleY;
        e.push(q.replace({
          widget: new fu(l),
          block: !0,
          inclusive: !0,
          isBlockGap: !0
        }).range(i, o));
      }
      if (!s)
        break;
      i = s.to + 1;
    }
    return q.set(e);
  }
  updateDeco() {
    let e = 0, t = this.view.state.facet(Gi).map((s) => (this.dynamicDecorationMap[e++] = typeof s == "function") ? s(this.view) : s), i = !1, r = this.view.state.facet(xf).map((s, o) => {
      let l = typeof s == "function";
      return l && (i = !0), l ? s(this.view) : s;
    });
    for (r.length && (this.dynamicDecorationMap[e++] = i, t.push(ie.join(r))), this.decorations = [
      ...t,
      this.computeBlockGapDeco(),
      this.view.viewState.lineGapDeco
    ]; e < this.decorations.length; )
      this.dynamicDecorationMap[e++] = !1;
    return this.decorations;
  }
  scrollIntoView(e) {
    if (e.isSnapshot) {
      let u = this.view.viewState.lineBlockAt(e.range.head);
      this.view.scrollDOM.scrollTop = u.top - e.yMargin, this.view.scrollDOM.scrollLeft = e.xMargin;
      return;
    }
    for (let u of this.view.state.facet(yf))
      try {
        if (u(this.view, e.range, e))
          return !0;
      } catch (c) {
        Je(this.view.state, c, "scroll handler");
      }
    let { range: t } = e, i = this.coordsAt(t.head, t.empty ? t.assoc : t.head > t.anchor ? -1 : 1), r;
    if (!i)
      return;
    !t.empty && (r = this.coordsAt(t.anchor, t.anchor > t.head ? -1 : 1)) && (i = {
      left: Math.min(i.left, r.left),
      top: Math.min(i.top, r.top),
      right: Math.max(i.right, r.right),
      bottom: Math.max(i.bottom, r.bottom)
    });
    let s = vf(this.view), o = {
      left: i.left - s.left,
      top: i.top - s.top,
      right: i.right + s.right,
      bottom: i.bottom + s.bottom
    }, { offsetWidth: l, offsetHeight: a } = this.view.scrollDOM;
    dg(this.view.scrollDOM, o, t.head < t.anchor ? -1 : 1, e.x, e.y, Math.max(Math.min(e.xMargin, l), -l), Math.max(Math.min(e.yMargin, a), -a), this.view.textDirection == ye.LTR);
  }
}
function Pg(n) {
  return n.node.nodeType == 1 && n.node.firstChild && (n.offset == 0 || n.node.childNodes[n.offset - 1].contentEditable == "false") && (n.offset == n.node.childNodes.length || n.node.childNodes[n.offset].contentEditable == "false");
}
class fu extends Jt {
  constructor(e) {
    super(), this.height = e;
  }
  toDOM() {
    let e = document.createElement("div");
    return e.className = "cm-gap", this.updateDOM(e), e;
  }
  eq(e) {
    return e.height == this.height;
  }
  updateDOM(e) {
    return e.style.height = this.height + "px", !0;
  }
  get editable() {
    return !0;
  }
  get estimatedHeight() {
    return this.height;
  }
  ignoreEvent() {
    return !1;
  }
}
function Sf(n, e) {
  let t = n.observer.selectionRange;
  if (!t.focusNode)
    return null;
  let i = Uh(t.focusNode, t.focusOffset), r = Kh(t.focusNode, t.focusOffset), s = i || r;
  if (r && i && r.node != i.node) {
    let l = he.get(r.node);
    if (!l || l instanceof Ct && l.text != r.node.nodeValue)
      s = r;
    else if (n.docView.lastCompositionAfterCursor) {
      let a = he.get(i.node);
      !a || a instanceof Ct && a.text != i.node.nodeValue || (s = r);
    }
  }
  if (n.docView.lastCompositionAfterCursor = s != i, !s)
    return null;
  let o = e - s.offset;
  return { from: o, to: o + s.node.nodeValue.length, node: s.node };
}
function Bg(n, e, t) {
  let i = Sf(n, t);
  if (!i)
    return null;
  let { node: r, from: s, to: o } = i, l = r.nodeValue;
  if (/[\n\r]/.test(l) || n.state.doc.sliceString(i.from, i.to) != l)
    return null;
  let a = e.invertedDesc, u = new pt(a.mapPos(s), a.mapPos(o), s, o), c = [];
  for (let h = r.parentNode; ; h = h.parentNode) {
    let f = he.get(h);
    if (f instanceof Gt)
      c.push({ node: h, deco: f.mark });
    else {
      if (f instanceof Me || h.nodeName == "DIV" && h.parentNode == n.contentDOM)
        return { range: u, text: r, marks: c, line: h };
      if (h != n.contentDOM)
        c.push({ node: h, deco: new rr({
          inclusive: !0,
          attributes: kg(h),
          tagName: h.tagName.toLowerCase()
        }) });
      else
        return null;
    }
  }
}
function Rg(n, e) {
  return n.nodeType != 1 ? 0 : (e && n.childNodes[e - 1].contentEditable == "false" ? 1 : 0) | (e < n.childNodes.length && n.childNodes[e].contentEditable == "false" ? 2 : 0);
}
let Ng = class {
  constructor() {
    this.changes = [];
  }
  compareRange(e, t) {
    hl(e, t, this.changes);
  }
  comparePoint(e, t) {
    hl(e, t, this.changes);
  }
};
function Fg(n, e, t) {
  let i = new Ng();
  return ie.compare(n, e, t, i), i.changes;
}
function zg(n, e) {
  for (let t = n; t && t != e; t = t.assignedSlot || t.parentNode)
    if (t.nodeType == 1 && t.contentEditable == "false")
      return !0;
  return !1;
}
function Hg(n, e) {
  let t = !1;
  return e && n.iterChangedRanges((i, r) => {
    i < e.to && r > e.from && (t = !0);
  }), t;
}
function Vg(n, e, t = 1) {
  let i = n.charCategorizer(e), r = n.doc.lineAt(e), s = e - r.from;
  if (r.length == 0)
    return T.cursor(e);
  s == 0 ? t = 1 : s == r.length && (t = -1);
  let o = s, l = s;
  t < 0 ? o = Re(r.text, s, !1) : l = Re(r.text, s);
  let a = i(r.text.slice(o, l));
  for (; o > 0; ) {
    let u = Re(r.text, o, !1);
    if (i(r.text.slice(u, o)) != a)
      break;
    o = u;
  }
  for (; l < r.length; ) {
    let u = Re(r.text, l);
    if (i(r.text.slice(l, u)) != a)
      break;
    l = u;
  }
  return T.range(o + r.from, l + r.from);
}
function _g(n, e) {
  return e.left > n ? e.left - n : Math.max(0, n - e.right);
}
function $g(n, e) {
  return e.top > n ? e.top - n : Math.max(0, n - e.bottom);
}
function so(n, e) {
  return n.top < e.bottom - 1 && n.bottom > e.top + 1;
}
function du(n, e) {
  return e < n.top ? { top: e, left: n.left, right: n.right, bottom: n.bottom } : n;
}
function pu(n, e) {
  return e > n.bottom ? { top: n.top, left: n.left, right: n.right, bottom: e } : n;
}
function gl(n, e, t) {
  let i, r, s, o, l = !1, a, u, c, h;
  for (let p = n.firstChild; p; p = p.nextSibling) {
    let g = oi(p);
    for (let m = 0; m < g.length; m++) {
      let y = g[m];
      r && so(r, y) && (y = du(pu(y, r.bottom), r.top));
      let v = _g(e, y), C = $g(t, y);
      if (v == 0 && C == 0)
        return p.nodeType == 3 ? mu(p, e, t) : gl(p, e, t);
      if (!i || o > C || o == C && s > v) {
        i = p, r = y, s = v, o = C;
        let O = C ? t < y.top ? -1 : 1 : v ? e < y.left ? -1 : 1 : 0;
        l = !O || (O > 0 ? m < g.length - 1 : m > 0);
      }
      v == 0 ? t > y.bottom && (!c || c.bottom < y.bottom) ? (a = p, c = y) : t < y.top && (!h || h.top > y.top) && (u = p, h = y) : c && so(c, y) ? c = pu(c, y.bottom) : h && so(h, y) && (h = du(h, y.top));
    }
  }
  if (c && c.bottom >= t ? (i = a, r = c) : h && h.top <= t && (i = u, r = h), !i)
    return { node: n, offset: 0 };
  let f = Math.max(r.left, Math.min(r.right, e));
  if (i.nodeType == 3)
    return mu(i, f, t);
  if (l && i.contentEditable != "false")
    return gl(i, f, t);
  let d = Array.prototype.indexOf.call(n.childNodes, i) + (e >= (r.left + r.right) / 2 ? 1 : 0);
  return { node: n, offset: d };
}
function mu(n, e, t) {
  let i = n.nodeValue.length, r = -1, s = 1e9, o = 0;
  for (let l = 0; l < i; l++) {
    let a = Rn(n, l, l + 1).getClientRects();
    for (let u = 0; u < a.length; u++) {
      let c = a[u];
      if (c.top == c.bottom)
        continue;
      o || (o = e - c.left);
      let h = (c.top > t ? c.top - t : t - c.bottom) - 1;
      if (c.left - 1 <= e && c.right + 1 >= e && h < s) {
        let f = e >= (c.left + c.right) / 2, d = f;
        if (($.chrome || $.gecko) && Rn(n, l).getBoundingClientRect().left == c.right && (d = !f), h <= 0)
          return { node: n, offset: l + (d ? 1 : 0) };
        r = l + (d ? 1 : 0), s = h;
      }
    }
  }
  return { node: n, offset: r > -1 ? r : o > 0 ? n.nodeValue.length : 0 };
}
function Cf(n, e, t, i = -1) {
  var r, s;
  let o = n.contentDOM.getBoundingClientRect(), l = o.top + n.viewState.paddingTop, a, { docHeight: u } = n.viewState, { x: c, y: h } = e, f = h - l;
  if (f < 0)
    return 0;
  if (f > u)
    return n.state.doc.length;
  for (let O = n.viewState.heightOracle.textHeight / 2, A = !1; a = n.elementAtHeight(f), a.type != Ke.Text; )
    for (; f = i > 0 ? a.bottom + O : a.top - O, !(f >= 0 && f <= u); ) {
      if (A)
        return t ? null : 0;
      A = !0, i = -i;
    }
  h = l + f;
  let d = a.from;
  if (d < n.viewport.from)
    return n.viewport.from == 0 ? 0 : t ? null : gu(n, o, a, c, h);
  if (d > n.viewport.to)
    return n.viewport.to == n.state.doc.length ? n.state.doc.length : t ? null : gu(n, o, a, c, h);
  let p = n.dom.ownerDocument, g = n.root.elementFromPoint ? n.root : p, m = g.elementFromPoint(c, h);
  m && !n.contentDOM.contains(m) && (m = null), m || (c = Math.max(o.left + 1, Math.min(o.right - 1, c)), m = g.elementFromPoint(c, h), m && !n.contentDOM.contains(m) && (m = null));
  let y, v = -1;
  if (m && ((r = n.docView.nearest(m)) === null || r === void 0 ? void 0 : r.isEditable) != !1) {
    if (p.caretPositionFromPoint) {
      let O = p.caretPositionFromPoint(c, h);
      O && ({ offsetNode: y, offset: v } = O);
    } else if (p.caretRangeFromPoint) {
      let O = p.caretRangeFromPoint(c, h);
      O && ({ startContainer: y, startOffset: v } = O, (!n.contentDOM.contains(y) || $.safari && jg(y, v, c) || $.chrome && Wg(y, v, c)) && (y = void 0));
    }
  }
  if (!y || !n.docView.dom.contains(y)) {
    let O = Me.find(n.docView, d);
    if (!O)
      return f > a.top + a.height / 2 ? a.to : a.from;
    ({ node: y, offset: v } = gl(O.dom, c, h));
  }
  let C = n.docView.nearest(y);
  if (!C)
    return null;
  if (C.isWidget && ((s = C.dom) === null || s === void 0 ? void 0 : s.nodeType) == 1) {
    let O = C.dom.getBoundingClientRect();
    return e.y < O.top || e.y <= O.bottom && e.x <= (O.left + O.right) / 2 ? C.posAtStart : C.posAtEnd;
  } else
    return C.localPosFromDOM(y, v) + C.posAtStart;
}
function gu(n, e, t, i, r) {
  let s = Math.round((i - e.left) * n.defaultCharacterWidth);
  if (n.lineWrapping && t.height > n.defaultLineHeight * 1.5) {
    let l = n.viewState.heightOracle.textHeight, a = Math.floor((r - t.top - (n.defaultLineHeight - l) * 0.5) / l);
    s += a * n.viewState.heightOracle.lineLength;
  }
  let o = n.state.sliceDoc(t.from, t.to);
  return t.from + nl(o, s, n.state.tabSize);
}
function jg(n, e, t) {
  let i;
  if (n.nodeType != 3 || e != (i = n.nodeValue.length))
    return !1;
  for (let r = n.nextSibling; r; r = r.nextSibling)
    if (r.nodeType != 1 || r.nodeName != "BR")
      return !1;
  return Rn(n, i - 1, i).getBoundingClientRect().left > t;
}
function Wg(n, e, t) {
  if (e != 0)
    return !1;
  for (let r = n; ; ) {
    let s = r.parentNode;
    if (!s || s.nodeType != 1 || s.firstChild != r)
      return !1;
    if (s.classList.contains("cm-line"))
      break;
    r = s;
  }
  let i = n.nodeType == 1 ? n.getBoundingClientRect() : Rn(n, 0, Math.max(n.nodeValue.length, 1)).getBoundingClientRect();
  return t - i.left > 5;
}
function yl(n, e) {
  let t = n.lineBlockAt(e);
  if (Array.isArray(t.type)) {
    for (let i of t.type)
      if (i.to > e || i.to == e && (i.to == t.to || i.type == Ke.Text))
        return i;
  }
  return t;
}
function qg(n, e, t, i) {
  let r = yl(n, e.head), s = !i || r.type != Ke.Text || !(n.lineWrapping || r.widgetLineBreaks) ? null : n.coordsAtPos(e.assoc < 0 && e.head > r.from ? e.head - 1 : e.head);
  if (s) {
    let o = n.dom.getBoundingClientRect(), l = n.textDirectionAt(r.from), a = n.posAtCoords({
      x: t == (l == ye.LTR) ? o.right - 1 : o.left + 1,
      y: (s.top + s.bottom) / 2
    });
    if (a != null)
      return T.cursor(a, t ? -1 : 1);
  }
  return T.cursor(t ? r.to : r.from, t ? -1 : 1);
}
function yu(n, e, t, i) {
  let r = n.state.doc.lineAt(e.head), s = n.bidiSpans(r), o = n.textDirectionAt(r.from);
  for (let l = e, a = null; ; ) {
    let u = Eg(r, s, o, l, t), c = af;
    if (!u) {
      if (r.number == (t ? n.state.doc.lines : 1))
        return l;
      c = `
`, r = n.state.doc.line(r.number + (t ? 1 : -1)), s = n.bidiSpans(r), u = n.visualLineSide(r, !t);
    }
    if (a) {
      if (!a(c))
        return l;
    } else {
      if (!i)
        return u;
      a = i(c);
    }
    l = u;
  }
}
function Ug(n, e, t) {
  let i = n.state.charCategorizer(e), r = i(t);
  return (s) => {
    let o = i(s);
    return r == be.Space && (r = o), r == o;
  };
}
function Kg(n, e, t, i) {
  let r = e.head, s = t ? 1 : -1;
  if (r == (t ? n.state.doc.length : 0))
    return T.cursor(r, e.assoc);
  let o = e.goalColumn, l, a = n.contentDOM.getBoundingClientRect(), u = n.coordsAtPos(r, e.assoc || -1), c = n.documentTop;
  if (u)
    o == null && (o = u.left - a.left), l = s < 0 ? u.top : u.bottom;
  else {
    let d = n.viewState.lineBlockAt(r);
    o == null && (o = Math.min(a.right - a.left, n.defaultCharacterWidth * (r - d.from))), l = (s < 0 ? d.top : d.bottom) + c;
  }
  let h = a.left + o, f = i ?? n.viewState.heightOracle.textHeight >> 1;
  for (let d = 0; ; d += 10) {
    let p = l + (f + d) * s, g = Cf(n, { x: h, y: p }, !1, s);
    if (p < a.top || p > a.bottom || (s < 0 ? g < r : g > r)) {
      let m = n.docView.coordsForChar(g), y = !m || p < m.top ? -1 : 1;
      return T.cursor(g, y, void 0, o);
    }
  }
}
function Kr(n, e, t) {
  for (; ; ) {
    let i = 0;
    for (let r of n)
      r.between(e - 1, e + 1, (s, o, l) => {
        if (e > s && e < o) {
          let a = i || t || (e - s < o - e ? -1 : 1);
          e = a < 0 ? s : o, i = a;
        }
      });
    if (!i)
      return e;
  }
}
function oo(n, e, t) {
  let i = Kr(n.state.facet(oa).map((r) => r(n)), t.from, e.head > t.from ? -1 : 1);
  return i == t.from ? t : T.cursor(i, i < t.from ? 1 : -1);
}
class Gg {
  setSelectionOrigin(e) {
    this.lastSelectionOrigin = e, this.lastSelectionTime = Date.now();
  }
  constructor(e) {
    this.view = e, this.lastKeyCode = 0, this.lastKeyTime = 0, this.lastTouchTime = 0, this.lastFocusTime = 0, this.lastScrollTop = 0, this.lastScrollLeft = 0, this.pendingIOSKey = void 0, this.lastSelectionOrigin = null, this.lastSelectionTime = 0, this.lastEscPress = 0, this.lastContextMenu = 0, this.scrollHandlers = [], this.handlers = /* @__PURE__ */ Object.create(null), this.composing = -1, this.compositionFirstChange = null, this.compositionEndedAt = 0, this.compositionPendingKey = !1, this.compositionPendingChange = !1, this.mouseSelection = null, this.draggedContent = null, this.handleEvent = this.handleEvent.bind(this), this.notifiedFocused = e.hasFocus, $.safari && e.contentDOM.addEventListener("input", () => null), $.gecko && c0(e.contentDOM.ownerDocument);
  }
  handleEvent(e) {
    !n0(this.view, e) || this.ignoreDuringComposition(e) || e.type == "keydown" && this.keydown(e) || this.runHandlers(e.type, e);
  }
  runHandlers(e, t) {
    let i = this.handlers[e];
    if (i) {
      for (let r of i.observers)
        r(this.view, t);
      for (let r of i.handlers) {
        if (t.defaultPrevented)
          break;
        if (r(this.view, t)) {
          t.preventDefault();
          break;
        }
      }
    }
  }
  ensureHandlers(e) {
    let t = Yg(e), i = this.handlers, r = this.view.contentDOM;
    for (let s in t)
      if (s != "scroll") {
        let o = !t[s].handlers.length, l = i[s];
        l && o != !l.handlers.length && (r.removeEventListener(s, this.handleEvent), l = null), l || r.addEventListener(s, this.handleEvent, { passive: o });
      }
    for (let s in i)
      s != "scroll" && !t[s] && r.removeEventListener(s, this.handleEvent);
    this.handlers = t;
  }
  keydown(e) {
    if (this.lastKeyCode = e.keyCode, this.lastKeyTime = Date.now(), e.keyCode == 9 && Date.now() < this.lastEscPress + 2e3)
      return !0;
    if (e.keyCode != 27 && Mf.indexOf(e.keyCode) < 0 && (this.view.inputState.lastEscPress = 0), $.android && $.chrome && !e.synthetic && (e.keyCode == 13 || e.keyCode == 8))
      return this.view.observer.delayAndroidKey(e.key, e.keyCode), !0;
    let t;
    return $.ios && !e.synthetic && !e.altKey && !e.metaKey && ((t = Af.find((i) => i.keyCode == e.keyCode)) && !e.ctrlKey || Xg.indexOf(e.key) > -1 && e.ctrlKey && !e.shiftKey) ? (this.pendingIOSKey = t || e, setTimeout(() => this.flushIOSKey(), 250), !0) : (e.keyCode != 229 && this.view.observer.forceFlush(), !1);
  }
  flushIOSKey(e) {
    let t = this.pendingIOSKey;
    return !t || t.key == "Enter" && e && e.from < e.to && /^\S+$/.test(e.insert.toString()) ? !1 : (this.pendingIOSKey = void 0, Zn(this.view.contentDOM, t.key, t.keyCode, t instanceof KeyboardEvent ? t : void 0));
  }
  ignoreDuringComposition(e) {
    return /^key/.test(e.type) ? this.composing > 0 ? !0 : $.safari && !$.ios && this.compositionPendingKey && Date.now() - this.compositionEndedAt < 100 ? (this.compositionPendingKey = !1, !0) : !1 : !1;
  }
  startMouseSelection(e) {
    this.mouseSelection && this.mouseSelection.destroy(), this.mouseSelection = e;
  }
  update(e) {
    this.mouseSelection && this.mouseSelection.update(e), this.draggedContent && e.docChanged && (this.draggedContent = this.draggedContent.map(e.changes)), e.transactions.length && (this.lastKeyCode = this.lastSelectionTime = 0);
  }
  destroy() {
    this.mouseSelection && this.mouseSelection.destroy();
  }
}
function bu(n, e) {
  return (t, i) => {
    try {
      return e.call(n, i, t);
    } catch (r) {
      Je(t.state, r);
    }
  };
}
function Yg(n) {
  let e = /* @__PURE__ */ Object.create(null);
  function t(i) {
    return e[i] || (e[i] = { observers: [], handlers: [] });
  }
  for (let i of n) {
    let r = i.spec;
    if (r && r.domEventHandlers)
      for (let s in r.domEventHandlers) {
        let o = r.domEventHandlers[s];
        o && t(s).handlers.push(bu(i.value, o));
      }
    if (r && r.domEventObservers)
      for (let s in r.domEventObservers) {
        let o = r.domEventObservers[s];
        o && t(s).observers.push(bu(i.value, o));
      }
  }
  for (let i in At)
    t(i).handlers.push(At[i]);
  for (let i in yt)
    t(i).observers.push(yt[i]);
  return e;
}
const Af = [
  { key: "Backspace", keyCode: 8, inputType: "deleteContentBackward" },
  { key: "Enter", keyCode: 13, inputType: "insertParagraph" },
  { key: "Enter", keyCode: 13, inputType: "insertLineBreak" },
  { key: "Delete", keyCode: 46, inputType: "deleteContentForward" }
], Xg = "dthko", Mf = [16, 17, 18, 20, 91, 92, 224, 225], br = 6;
function xr(n) {
  return Math.max(0, n) * 0.7 + 8;
}
function Jg(n, e) {
  return Math.max(Math.abs(n.clientX - e.clientX), Math.abs(n.clientY - e.clientY));
}
class Qg {
  constructor(e, t, i, r) {
    this.view = e, this.startEvent = t, this.style = i, this.mustSelect = r, this.scrollSpeed = { x: 0, y: 0 }, this.scrolling = -1, this.lastEvent = t, this.scrollParent = pg(e.contentDOM), this.atoms = e.state.facet(oa).map((o) => o(e));
    let s = e.contentDOM.ownerDocument;
    s.addEventListener("mousemove", this.move = this.move.bind(this)), s.addEventListener("mouseup", this.up = this.up.bind(this)), this.extend = t.shiftKey, this.multiple = e.state.facet(Q.allowMultipleSelections) && Zg(e, t), this.dragging = t0(e, t) && Ef(t) == 1 ? null : !1;
  }
  start(e) {
    this.dragging === !1 && this.select(e);
  }
  move(e) {
    var t;
    if (e.buttons == 0)
      return this.destroy();
    if (this.dragging || this.dragging == null && Jg(this.startEvent, e) < 10)
      return;
    this.select(this.lastEvent = e);
    let i = 0, r = 0, s = ((t = this.scrollParent) === null || t === void 0 ? void 0 : t.getBoundingClientRect()) || { left: 0, top: 0, right: this.view.win.innerWidth, bottom: this.view.win.innerHeight }, o = vf(this.view);
    e.clientX - o.left <= s.left + br ? i = -xr(s.left - e.clientX) : e.clientX + o.right >= s.right - br && (i = xr(e.clientX - s.right)), e.clientY - o.top <= s.top + br ? r = -xr(s.top - e.clientY) : e.clientY + o.bottom >= s.bottom - br && (r = xr(e.clientY - s.bottom)), this.setScrollSpeed(i, r);
  }
  up(e) {
    this.dragging == null && this.select(this.lastEvent), this.dragging || e.preventDefault(), this.destroy();
  }
  destroy() {
    this.setScrollSpeed(0, 0);
    let e = this.view.contentDOM.ownerDocument;
    e.removeEventListener("mousemove", this.move), e.removeEventListener("mouseup", this.up), this.view.inputState.mouseSelection = this.view.inputState.draggedContent = null;
  }
  setScrollSpeed(e, t) {
    this.scrollSpeed = { x: e, y: t }, e || t ? this.scrolling < 0 && (this.scrolling = setInterval(() => this.scroll(), 50)) : this.scrolling > -1 && (clearInterval(this.scrolling), this.scrolling = -1);
  }
  scroll() {
    this.scrollParent ? (this.scrollParent.scrollLeft += this.scrollSpeed.x, this.scrollParent.scrollTop += this.scrollSpeed.y) : this.view.win.scrollBy(this.scrollSpeed.x, this.scrollSpeed.y), this.dragging === !1 && this.select(this.lastEvent);
  }
  skipAtoms(e) {
    let t = null;
    for (let i = 0; i < e.ranges.length; i++) {
      let r = e.ranges[i], s = null;
      if (r.empty) {
        let o = Kr(this.atoms, r.from, 0);
        o != r.from && (s = T.cursor(o, -1));
      } else {
        let o = Kr(this.atoms, r.from, -1), l = Kr(this.atoms, r.to, 1);
        (o != r.from || l != r.to) && (s = T.range(r.from == r.anchor ? o : l, r.from == r.head ? o : l));
      }
      s && (t || (t = e.ranges.slice()), t[i] = s);
    }
    return t ? T.create(t, e.mainIndex) : e;
  }
  select(e) {
    let { view: t } = this, i = this.skipAtoms(this.style.get(e, this.extend, this.multiple));
    (this.mustSelect || !i.eq(t.state.selection, this.dragging === !1)) && this.view.dispatch({
      selection: i,
      userEvent: "select.pointer"
    }), this.mustSelect = !1;
  }
  update(e) {
    this.style.update(e) && setTimeout(() => this.select(this.lastEvent), 20);
  }
}
function Zg(n, e) {
  let t = n.state.facet(uf);
  return t.length ? t[0](e) : $.mac ? e.metaKey : e.ctrlKey;
}
function e0(n, e) {
  let t = n.state.facet(cf);
  return t.length ? t[0](e) : $.mac ? !e.altKey : !e.ctrlKey;
}
function t0(n, e) {
  let { main: t } = n.state.selection;
  if (t.empty)
    return !1;
  let i = rs(n.root);
  if (!i || i.rangeCount == 0)
    return !0;
  let r = i.getRangeAt(0).getClientRects();
  for (let s = 0; s < r.length; s++) {
    let o = r[s];
    if (o.left <= e.clientX && o.right >= e.clientX && o.top <= e.clientY && o.bottom >= e.clientY)
      return !0;
  }
  return !1;
}
function n0(n, e) {
  if (!e.bubbles)
    return !0;
  if (e.defaultPrevented)
    return !1;
  for (let t = e.target, i; t != n.contentDOM; t = t.parentNode)
    if (!t || t.nodeType == 11 || (i = he.get(t)) && i.ignoreEvent(e))
      return !1;
  return !0;
}
const At = /* @__PURE__ */ Object.create(null), yt = /* @__PURE__ */ Object.create(null), Tf = $.ie && $.ie_version < 15 || $.ios && $.webkit_version < 604;
function i0(n) {
  let e = n.dom.parentNode;
  if (!e)
    return;
  let t = e.appendChild(document.createElement("textarea"));
  t.style.cssText = "position: fixed; left: -10000px; top: 10px", t.focus(), setTimeout(() => {
    n.focus(), t.remove(), Of(n, t.value);
  }, 50);
}
function Of(n, e) {
  let { state: t } = n, i, r = 1, s = t.toText(e), o = s.lines == t.selection.ranges.length;
  if (bl != null && t.selection.ranges.every((a) => a.empty) && bl == s.toString()) {
    let a = -1;
    i = t.changeByRange((u) => {
      let c = t.doc.lineAt(u.from);
      if (c.from == a)
        return { range: u };
      a = c.from;
      let h = t.toText((o ? s.line(r++).text : e) + t.lineBreak);
      return {
        changes: { from: c.from, insert: h },
        range: T.cursor(u.from + h.length)
      };
    });
  } else
    o ? i = t.changeByRange((a) => {
      let u = s.line(r++);
      return {
        changes: { from: a.from, to: a.to, insert: u.text },
        range: T.cursor(a.from + u.length)
      };
    }) : i = t.replaceSelection(s);
  n.dispatch(i, {
    userEvent: "input.paste",
    scrollIntoView: !0
  });
}
yt.scroll = (n) => {
  n.inputState.lastScrollTop = n.scrollDOM.scrollTop, n.inputState.lastScrollLeft = n.scrollDOM.scrollLeft;
};
At.keydown = (n, e) => (n.inputState.setSelectionOrigin("select"), e.keyCode == 27 && (n.inputState.lastEscPress = Date.now()), !1);
yt.touchstart = (n, e) => {
  n.inputState.lastTouchTime = Date.now(), n.inputState.setSelectionOrigin("select.pointer");
};
yt.touchmove = (n) => {
  n.inputState.setSelectionOrigin("select.pointer");
};
At.mousedown = (n, e) => {
  if (n.observer.flush(), n.inputState.lastTouchTime > Date.now() - 2e3)
    return !1;
  let t = null;
  for (let i of n.state.facet(hf))
    if (t = i(n, e), t)
      break;
  if (!t && e.button == 0 && (t = o0(n, e)), t) {
    let i = !n.hasFocus;
    n.inputState.startMouseSelection(new Qg(n, e, t, i)), i && n.observer.ignore(() => jh(n.contentDOM));
    let r = n.inputState.mouseSelection;
    if (r)
      return r.start(e), r.dragging === !1;
  }
  return !1;
};
function xu(n, e, t, i) {
  if (i == 1)
    return T.cursor(e, t);
  if (i == 2)
    return Vg(n.state, e, t);
  {
    let r = Me.find(n.docView, e), s = n.state.doc.lineAt(r ? r.posAtEnd : e), o = r ? r.posAtStart : s.from, l = r ? r.posAtEnd : s.to;
    return l < n.state.doc.length && l == s.to && l++, T.range(o, l);
  }
}
let Df = (n, e) => n >= e.top && n <= e.bottom, wu = (n, e, t) => Df(e, t) && n >= t.left && n <= t.right;
function r0(n, e, t, i) {
  let r = Me.find(n.docView, e);
  if (!r)
    return 1;
  let s = e - r.posAtStart;
  if (s == 0)
    return 1;
  if (s == r.length)
    return -1;
  let o = r.coordsAt(s, -1);
  if (o && wu(t, i, o))
    return -1;
  let l = r.coordsAt(s, 1);
  return l && wu(t, i, l) ? 1 : o && Df(i, o) ? -1 : 1;
}
function ku(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1);
  return { pos: t, bias: r0(n, t, e.clientX, e.clientY) };
}
const s0 = $.ie && $.ie_version <= 11;
let vu = null, Su = 0, Cu = 0;
function Ef(n) {
  if (!s0)
    return n.detail;
  let e = vu, t = Cu;
  return vu = n, Cu = Date.now(), Su = !e || t > Date.now() - 400 && Math.abs(e.clientX - n.clientX) < 2 && Math.abs(e.clientY - n.clientY) < 2 ? (Su + 1) % 3 : 1;
}
function o0(n, e) {
  let t = ku(n, e), i = Ef(e), r = n.state.selection;
  return {
    update(s) {
      s.docChanged && (t.pos = s.changes.mapPos(t.pos), r = r.map(s.changes));
    },
    get(s, o, l) {
      let a = ku(n, s), u, c = xu(n, a.pos, a.bias, i);
      if (t.pos != a.pos && !o) {
        let h = xu(n, t.pos, t.bias, i), f = Math.min(h.from, c.from), d = Math.max(h.to, c.to);
        c = f < c.from ? T.range(f, d) : T.range(d, f);
      }
      return o ? r.replaceRange(r.main.extend(c.from, c.to)) : l && i == 1 && r.ranges.length > 1 && (u = l0(r, a.pos)) ? u : l ? r.addRange(c) : T.create([c]);
    }
  };
}
function l0(n, e) {
  for (let t = 0; t < n.ranges.length; t++) {
    let { from: i, to: r } = n.ranges[t];
    if (i <= e && r >= e)
      return T.create(n.ranges.slice(0, t).concat(n.ranges.slice(t + 1)), n.mainIndex == t ? 0 : n.mainIndex - (n.mainIndex > t ? 1 : 0));
  }
  return null;
}
At.dragstart = (n, e) => {
  let { selection: { main: t } } = n.state;
  if (e.target.draggable) {
    let r = n.docView.nearest(e.target);
    if (r && r.isWidget) {
      let s = r.posAtStart, o = s + r.length;
      (s >= t.to || o <= t.from) && (t = T.range(s, o));
    }
  }
  let { inputState: i } = n;
  return i.mouseSelection && (i.mouseSelection.dragging = !0), i.draggedContent = t, e.dataTransfer && (e.dataTransfer.setData("Text", n.state.sliceDoc(t.from, t.to)), e.dataTransfer.effectAllowed = "copyMove"), !1;
};
At.dragend = (n) => (n.inputState.draggedContent = null, !1);
function Au(n, e, t, i) {
  if (!t)
    return;
  let r = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), { draggedContent: s } = n.inputState, o = i && s && e0(n, e) ? { from: s.from, to: s.to } : null, l = { from: r, insert: t }, a = n.state.changes(o ? [o, l] : l);
  n.focus(), n.dispatch({
    changes: a,
    selection: { anchor: a.mapPos(r, -1), head: a.mapPos(r, 1) },
    userEvent: o ? "move.drop" : "input.drop"
  }), n.inputState.draggedContent = null;
}
At.drop = (n, e) => {
  if (!e.dataTransfer)
    return !1;
  if (n.state.readOnly)
    return !0;
  let t = e.dataTransfer.files;
  if (t && t.length) {
    let i = Array(t.length), r = 0, s = () => {
      ++r == t.length && Au(n, e, i.filter((o) => o != null).join(n.state.lineBreak), !1);
    };
    for (let o = 0; o < t.length; o++) {
      let l = new FileReader();
      l.onerror = s, l.onload = () => {
        /[\x00-\x08\x0e-\x1f]{2}/.test(l.result) || (i[o] = l.result), s();
      }, l.readAsText(t[o]);
    }
    return !0;
  } else {
    let i = e.dataTransfer.getData("Text");
    if (i)
      return Au(n, e, i, !0), !0;
  }
  return !1;
};
At.paste = (n, e) => {
  if (n.state.readOnly)
    return !0;
  n.observer.flush();
  let t = Tf ? null : e.clipboardData;
  return t ? (Of(n, t.getData("text/plain") || t.getData("text/uri-list")), !0) : (i0(n), !1);
};
function a0(n, e) {
  let t = n.dom.parentNode;
  if (!t)
    return;
  let i = t.appendChild(document.createElement("textarea"));
  i.style.cssText = "position: fixed; left: -10000px; top: 10px", i.value = e, i.focus(), i.selectionEnd = e.length, i.selectionStart = 0, setTimeout(() => {
    i.remove(), n.focus();
  }, 50);
}
function u0(n) {
  let e = [], t = [], i = !1;
  for (let r of n.selection.ranges)
    r.empty || (e.push(n.sliceDoc(r.from, r.to)), t.push(r));
  if (!e.length) {
    let r = -1;
    for (let { from: s } of n.selection.ranges) {
      let o = n.doc.lineAt(s);
      o.number > r && (e.push(o.text), t.push({ from: o.from, to: Math.min(n.doc.length, o.to + 1) })), r = o.number;
    }
    i = !0;
  }
  return { text: e.join(n.lineBreak), ranges: t, linewise: i };
}
let bl = null;
At.copy = At.cut = (n, e) => {
  let { text: t, ranges: i, linewise: r } = u0(n.state);
  if (!t && !r)
    return !1;
  bl = r ? t : null, e.type == "cut" && !n.state.readOnly && n.dispatch({
    changes: i,
    scrollIntoView: !0,
    userEvent: "delete.cut"
  });
  let s = Tf ? null : e.clipboardData;
  return s ? (s.clearData(), s.setData("text/plain", t), !0) : (a0(n, t), !1);
};
const Lf = /* @__PURE__ */ Xt.define();
function If(n, e) {
  let t = [];
  for (let i of n.facet(pf)) {
    let r = i(n, e);
    r && t.push(r);
  }
  return t ? n.update({ effects: t, annotations: Lf.of(!0) }) : null;
}
function Pf(n) {
  setTimeout(() => {
    let e = n.hasFocus;
    if (e != n.inputState.notifiedFocused) {
      let t = If(n.state, e);
      t ? n.dispatch(t) : n.update([]);
    }
  }, 10);
}
yt.focus = (n) => {
  n.inputState.lastFocusTime = Date.now(), !n.scrollDOM.scrollTop && (n.inputState.lastScrollTop || n.inputState.lastScrollLeft) && (n.scrollDOM.scrollTop = n.inputState.lastScrollTop, n.scrollDOM.scrollLeft = n.inputState.lastScrollLeft), Pf(n);
};
yt.blur = (n) => {
  n.observer.clearSelectionRange(), Pf(n);
};
yt.compositionstart = yt.compositionupdate = (n) => {
  n.inputState.compositionFirstChange == null && (n.inputState.compositionFirstChange = !0), n.inputState.composing < 0 && (n.inputState.composing = 0);
};
yt.compositionend = (n) => {
  n.inputState.composing = -1, n.inputState.compositionEndedAt = Date.now(), n.inputState.compositionPendingKey = !0, n.inputState.compositionPendingChange = n.observer.pendingRecords().length > 0, n.inputState.compositionFirstChange = null, $.chrome && $.android ? n.observer.flushSoon() : n.inputState.compositionPendingChange ? Promise.resolve().then(() => n.observer.flush()) : setTimeout(() => {
    n.inputState.composing < 0 && n.docView.hasComposition && n.update([]);
  }, 50);
};
yt.contextmenu = (n) => {
  n.inputState.lastContextMenu = Date.now();
};
At.beforeinput = (n, e) => {
  var t;
  let i;
  if ($.chrome && $.android && (i = Af.find((r) => r.inputType == e.inputType)) && (n.observer.delayAndroidKey(i.key, i.keyCode), i.key == "Backspace" || i.key == "Delete")) {
    let r = ((t = window.visualViewport) === null || t === void 0 ? void 0 : t.height) || 0;
    setTimeout(() => {
      var s;
      (((s = window.visualViewport) === null || s === void 0 ? void 0 : s.height) || 0) > r + 10 && n.hasFocus && (n.contentDOM.blur(), n.focus());
    }, 100);
  }
  return $.ios && e.inputType == "deleteContentForward" && n.observer.flushSoon(), $.safari && e.inputType == "insertText" && n.inputState.composing >= 0 && setTimeout(() => yt.compositionend(n, e), 20), !1;
};
const Mu = /* @__PURE__ */ new Set();
function c0(n) {
  Mu.has(n) || (Mu.add(n), n.addEventListener("copy", () => {
  }), n.addEventListener("cut", () => {
  }));
}
const Tu = ["pre-wrap", "normal", "pre-line", "break-spaces"];
class h0 {
  constructor(e) {
    this.lineWrapping = e, this.doc = re.empty, this.heightSamples = {}, this.lineHeight = 14, this.charWidth = 7, this.textHeight = 14, this.lineLength = 30, this.heightChanged = !1;
  }
  heightForGap(e, t) {
    let i = this.doc.lineAt(t).number - this.doc.lineAt(e).number + 1;
    return this.lineWrapping && (i += Math.max(0, Math.ceil((t - e - i * this.lineLength * 0.5) / this.lineLength))), this.lineHeight * i;
  }
  heightForLine(e) {
    return this.lineWrapping ? (1 + Math.max(0, Math.ceil((e - this.lineLength) / (this.lineLength - 5)))) * this.lineHeight : this.lineHeight;
  }
  setDoc(e) {
    return this.doc = e, this;
  }
  mustRefreshForWrapping(e) {
    return Tu.indexOf(e) > -1 != this.lineWrapping;
  }
  mustRefreshForHeights(e) {
    let t = !1;
    for (let i = 0; i < e.length; i++) {
      let r = e[i];
      r < 0 ? i++ : this.heightSamples[Math.floor(r * 10)] || (t = !0, this.heightSamples[Math.floor(r * 10)] = !0);
    }
    return t;
  }
  refresh(e, t, i, r, s, o) {
    let l = Tu.indexOf(e) > -1, a = Math.round(t) != Math.round(this.lineHeight) || this.lineWrapping != l;
    if (this.lineWrapping = l, this.lineHeight = t, this.charWidth = i, this.textHeight = r, this.lineLength = s, a) {
      this.heightSamples = {};
      for (let u = 0; u < o.length; u++) {
        let c = o[u];
        c < 0 ? u++ : this.heightSamples[Math.floor(c * 10)] = !0;
      }
    }
    return a;
  }
}
class f0 {
  constructor(e, t) {
    this.from = e, this.heights = t, this.index = 0;
  }
  get more() {
    return this.index < this.heights.length;
  }
}
class Bt {
  /**
  @internal
  */
  constructor(e, t, i, r, s) {
    this.from = e, this.length = t, this.top = i, this.height = r, this._content = s;
  }
  /**
  The type of element this is. When querying lines, this may be
  an array of all the blocks that make up the line.
  */
  get type() {
    return typeof this._content == "number" ? Ke.Text : Array.isArray(this._content) ? this._content : this._content.type;
  }
  /**
  The end of the element as a document position.
  */
  get to() {
    return this.from + this.length;
  }
  /**
  The bottom position of the element.
  */
  get bottom() {
    return this.top + this.height;
  }
  /**
  If this is a widget block, this will return the widget
  associated with it.
  */
  get widget() {
    return this._content instanceof gn ? this._content.widget : null;
  }
  /**
  If this is a textblock, this holds the number of line breaks
  that appear in widgets inside the block.
  */
  get widgetLineBreaks() {
    return typeof this._content == "number" ? this._content : 0;
  }
  /**
  @internal
  */
  join(e) {
    let t = (Array.isArray(this._content) ? this._content : [this]).concat(Array.isArray(e._content) ? e._content : [e]);
    return new Bt(this.from, this.length + e.length, this.top, this.height + e.height, t);
  }
}
var ge = /* @__PURE__ */ function(n) {
  return n[n.ByPos = 0] = "ByPos", n[n.ByHeight = 1] = "ByHeight", n[n.ByPosNoHeight = 2] = "ByPosNoHeight", n;
}(ge || (ge = {}));
const Gr = 1e-3;
class Ge {
  constructor(e, t, i = 2) {
    this.length = e, this.height = t, this.flags = i;
  }
  get outdated() {
    return (this.flags & 2) > 0;
  }
  set outdated(e) {
    this.flags = (e ? 2 : 0) | this.flags & -3;
  }
  setHeight(e, t) {
    this.height != t && (Math.abs(this.height - t) > Gr && (e.heightChanged = !0), this.height = t);
  }
  // Base case is to replace a leaf node, which simply builds a tree
  // from the new nodes and returns that (HeightMapBranch and
  // HeightMapGap override this to actually use from/to)
  replace(e, t, i) {
    return Ge.of(i);
  }
  // Again, these are base cases, and are overridden for branch and gap nodes.
  decomposeLeft(e, t) {
    t.push(this);
  }
  decomposeRight(e, t) {
    t.push(this);
  }
  applyChanges(e, t, i, r) {
    let s = this, o = i.doc;
    for (let l = r.length - 1; l >= 0; l--) {
      let { fromA: a, toA: u, fromB: c, toB: h } = r[l], f = s.lineAt(a, ge.ByPosNoHeight, i.setDoc(t), 0, 0), d = f.to >= u ? f : s.lineAt(u, ge.ByPosNoHeight, i, 0, 0);
      for (h += d.to - u, u = d.to; l > 0 && f.from <= r[l - 1].toA; )
        a = r[l - 1].fromA, c = r[l - 1].fromB, l--, a < f.from && (f = s.lineAt(a, ge.ByPosNoHeight, i, 0, 0));
      c += f.from - a, a = f.from;
      let p = la.build(i.setDoc(o), e, c, h);
      s = s.replace(a, u, p);
    }
    return s.updateHeight(i, 0);
  }
  static empty() {
    return new it(0, 0);
  }
  // nodes uses null values to indicate the position of line breaks.
  // There are never line breaks at the start or end of the array, or
  // two line breaks next to each other, and the array isn't allowed
  // to be empty (same restrictions as return value from the builder).
  static of(e) {
    if (e.length == 1)
      return e[0];
    let t = 0, i = e.length, r = 0, s = 0;
    for (; ; )
      if (t == i)
        if (r > s * 2) {
          let l = e[t - 1];
          l.break ? e.splice(--t, 1, l.left, null, l.right) : e.splice(--t, 1, l.left, l.right), i += 1 + l.break, r -= l.size;
        } else if (s > r * 2) {
          let l = e[i];
          l.break ? e.splice(i, 1, l.left, null, l.right) : e.splice(i, 1, l.left, l.right), i += 2 + l.break, s -= l.size;
        } else
          break;
      else if (r < s) {
        let l = e[t++];
        l && (r += l.size);
      } else {
        let l = e[--i];
        l && (s += l.size);
      }
    let o = 0;
    return e[t - 1] == null ? (o = 1, t--) : e[t] == null && (o = 1, i++), new d0(Ge.of(e.slice(0, t)), o, Ge.of(e.slice(i)));
  }
}
Ge.prototype.size = 1;
class Bf extends Ge {
  constructor(e, t, i) {
    super(e, t), this.deco = i;
  }
  blockAt(e, t, i, r) {
    return new Bt(r, this.length, i, this.height, this.deco || 0);
  }
  lineAt(e, t, i, r, s) {
    return this.blockAt(0, i, r, s);
  }
  forEachLine(e, t, i, r, s, o) {
    e <= s + this.length && t >= s && o(this.blockAt(0, i, r, s));
  }
  updateHeight(e, t = 0, i = !1, r) {
    return r && r.from <= t && r.more && this.setHeight(e, r.heights[r.index++]), this.outdated = !1, this;
  }
  toString() {
    return `block(${this.length})`;
  }
}
class it extends Bf {
  constructor(e, t) {
    super(e, t, null), this.collapsed = 0, this.widgetHeight = 0, this.breaks = 0;
  }
  blockAt(e, t, i, r) {
    return new Bt(r, this.length, i, this.height, this.breaks);
  }
  replace(e, t, i) {
    let r = i[0];
    return i.length == 1 && (r instanceof it || r instanceof Ee && r.flags & 4) && Math.abs(this.length - r.length) < 10 ? (r instanceof Ee ? r = new it(r.length, this.height) : r.height = this.height, this.outdated || (r.outdated = !1), r) : Ge.of(i);
  }
  updateHeight(e, t = 0, i = !1, r) {
    return r && r.from <= t && r.more ? this.setHeight(e, r.heights[r.index++]) : (i || this.outdated) && this.setHeight(e, Math.max(this.widgetHeight, e.heightForLine(this.length - this.collapsed)) + this.breaks * e.lineHeight), this.outdated = !1, this;
  }
  toString() {
    return `line(${this.length}${this.collapsed ? -this.collapsed : ""}${this.widgetHeight ? ":" + this.widgetHeight : ""})`;
  }
}
class Ee extends Ge {
  constructor(e) {
    super(e, 0);
  }
  heightMetrics(e, t) {
    let i = e.doc.lineAt(t).number, r = e.doc.lineAt(t + this.length).number, s = r - i + 1, o, l = 0;
    if (e.lineWrapping) {
      let a = Math.min(this.height, e.lineHeight * s);
      o = a / s, this.length > s + 1 && (l = (this.height - a) / (this.length - s - 1));
    } else
      o = this.height / s;
    return { firstLine: i, lastLine: r, perLine: o, perChar: l };
  }
  blockAt(e, t, i, r) {
    let { firstLine: s, lastLine: o, perLine: l, perChar: a } = this.heightMetrics(t, r);
    if (t.lineWrapping) {
      let u = r + (e < t.lineHeight ? 0 : Math.round(Math.max(0, Math.min(1, (e - i) / this.height)) * this.length)), c = t.doc.lineAt(u), h = l + c.length * a, f = Math.max(i, e - h / 2);
      return new Bt(c.from, c.length, f, h, 0);
    } else {
      let u = Math.max(0, Math.min(o - s, Math.floor((e - i) / l))), { from: c, length: h } = t.doc.line(s + u);
      return new Bt(c, h, i + l * u, l, 0);
    }
  }
  lineAt(e, t, i, r, s) {
    if (t == ge.ByHeight)
      return this.blockAt(e, i, r, s);
    if (t == ge.ByPosNoHeight) {
      let { from: d, to: p } = i.doc.lineAt(e);
      return new Bt(d, p - d, 0, 0, 0);
    }
    let { firstLine: o, perLine: l, perChar: a } = this.heightMetrics(i, s), u = i.doc.lineAt(e), c = l + u.length * a, h = u.number - o, f = r + l * h + a * (u.from - s - h);
    return new Bt(u.from, u.length, Math.max(r, Math.min(f, r + this.height - c)), c, 0);
  }
  forEachLine(e, t, i, r, s, o) {
    e = Math.max(e, s), t = Math.min(t, s + this.length);
    let { firstLine: l, perLine: a, perChar: u } = this.heightMetrics(i, s);
    for (let c = e, h = r; c <= t; ) {
      let f = i.doc.lineAt(c);
      if (c == e) {
        let p = f.number - l;
        h += a * p + u * (e - s - p);
      }
      let d = a + u * f.length;
      o(new Bt(f.from, f.length, h, d, 0)), h += d, c = f.to + 1;
    }
  }
  replace(e, t, i) {
    let r = this.length - t;
    if (r > 0) {
      let s = i[i.length - 1];
      s instanceof Ee ? i[i.length - 1] = new Ee(s.length + r) : i.push(null, new Ee(r - 1));
    }
    if (e > 0) {
      let s = i[0];
      s instanceof Ee ? i[0] = new Ee(e + s.length) : i.unshift(new Ee(e - 1), null);
    }
    return Ge.of(i);
  }
  decomposeLeft(e, t) {
    t.push(new Ee(e - 1), null);
  }
  decomposeRight(e, t) {
    t.push(null, new Ee(this.length - e - 1));
  }
  updateHeight(e, t = 0, i = !1, r) {
    let s = t + this.length;
    if (r && r.from <= t + this.length && r.more) {
      let o = [], l = Math.max(t, r.from), a = -1;
      for (r.from > t && o.push(new Ee(r.from - t - 1).updateHeight(e, t)); l <= s && r.more; ) {
        let c = e.doc.lineAt(l).length;
        o.length && o.push(null);
        let h = r.heights[r.index++];
        a == -1 ? a = h : Math.abs(h - a) >= Gr && (a = -2);
        let f = new it(c, h);
        f.outdated = !1, o.push(f), l += c + 1;
      }
      l <= s && o.push(null, new Ee(s - l).updateHeight(e, l));
      let u = Ge.of(o);
      return (a < 0 || Math.abs(u.height - this.height) >= Gr || Math.abs(a - this.heightMetrics(e, t).perLine) >= Gr) && (e.heightChanged = !0), u;
    } else
      (i || this.outdated) && (this.setHeight(e, e.heightForGap(t, t + this.length)), this.outdated = !1);
    return this;
  }
  toString() {
    return `gap(${this.length})`;
  }
}
class d0 extends Ge {
  constructor(e, t, i) {
    super(e.length + t + i.length, e.height + i.height, t | (e.outdated || i.outdated ? 2 : 0)), this.left = e, this.right = i, this.size = e.size + i.size;
  }
  get break() {
    return this.flags & 1;
  }
  blockAt(e, t, i, r) {
    let s = i + this.left.height;
    return e < s ? this.left.blockAt(e, t, i, r) : this.right.blockAt(e, t, s, r + this.left.length + this.break);
  }
  lineAt(e, t, i, r, s) {
    let o = r + this.left.height, l = s + this.left.length + this.break, a = t == ge.ByHeight ? e < o : e < l, u = a ? this.left.lineAt(e, t, i, r, s) : this.right.lineAt(e, t, i, o, l);
    if (this.break || (a ? u.to < l : u.from > l))
      return u;
    let c = t == ge.ByPosNoHeight ? ge.ByPosNoHeight : ge.ByPos;
    return a ? u.join(this.right.lineAt(l, c, i, o, l)) : this.left.lineAt(l, c, i, r, s).join(u);
  }
  forEachLine(e, t, i, r, s, o) {
    let l = r + this.left.height, a = s + this.left.length + this.break;
    if (this.break)
      e < a && this.left.forEachLine(e, t, i, r, s, o), t >= a && this.right.forEachLine(e, t, i, l, a, o);
    else {
      let u = this.lineAt(a, ge.ByPos, i, r, s);
      e < u.from && this.left.forEachLine(e, u.from - 1, i, r, s, o), u.to >= e && u.from <= t && o(u), t > u.to && this.right.forEachLine(u.to + 1, t, i, l, a, o);
    }
  }
  replace(e, t, i) {
    let r = this.left.length + this.break;
    if (t < r)
      return this.balanced(this.left.replace(e, t, i), this.right);
    if (e > this.left.length)
      return this.balanced(this.left, this.right.replace(e - r, t - r, i));
    let s = [];
    e > 0 && this.decomposeLeft(e, s);
    let o = s.length;
    for (let l of i)
      s.push(l);
    if (e > 0 && Ou(s, o - 1), t < this.length) {
      let l = s.length;
      this.decomposeRight(t, s), Ou(s, l);
    }
    return Ge.of(s);
  }
  decomposeLeft(e, t) {
    let i = this.left.length;
    if (e <= i)
      return this.left.decomposeLeft(e, t);
    t.push(this.left), this.break && (i++, e >= i && t.push(null)), e > i && this.right.decomposeLeft(e - i, t);
  }
  decomposeRight(e, t) {
    let i = this.left.length, r = i + this.break;
    if (e >= r)
      return this.right.decomposeRight(e - r, t);
    e < i && this.left.decomposeRight(e, t), this.break && e < r && t.push(null), t.push(this.right);
  }
  balanced(e, t) {
    return e.size > 2 * t.size || t.size > 2 * e.size ? Ge.of(this.break ? [e, null, t] : [e, t]) : (this.left = e, this.right = t, this.height = e.height + t.height, this.outdated = e.outdated || t.outdated, this.size = e.size + t.size, this.length = e.length + this.break + t.length, this);
  }
  updateHeight(e, t = 0, i = !1, r) {
    let { left: s, right: o } = this, l = t + s.length + this.break, a = null;
    return r && r.from <= t + s.length && r.more ? a = s = s.updateHeight(e, t, i, r) : s.updateHeight(e, t, i), r && r.from <= l + o.length && r.more ? a = o = o.updateHeight(e, l, i, r) : o.updateHeight(e, l, i), a ? this.balanced(s, o) : (this.height = this.left.height + this.right.height, this.outdated = !1, this);
  }
  toString() {
    return this.left + (this.break ? " " : "-") + this.right;
  }
}
function Ou(n, e) {
  let t, i;
  n[e] == null && (t = n[e - 1]) instanceof Ee && (i = n[e + 1]) instanceof Ee && n.splice(e - 1, 3, new Ee(t.length + 1 + i.length));
}
const p0 = 5;
class la {
  constructor(e, t) {
    this.pos = e, this.oracle = t, this.nodes = [], this.lineStart = -1, this.lineEnd = -1, this.covering = null, this.writtenTo = e;
  }
  get isCovered() {
    return this.covering && this.nodes[this.nodes.length - 1] == this.covering;
  }
  span(e, t) {
    if (this.lineStart > -1) {
      let i = Math.min(t, this.lineEnd), r = this.nodes[this.nodes.length - 1];
      r instanceof it ? r.length += i - this.pos : (i > this.pos || !this.isCovered) && this.nodes.push(new it(i - this.pos, -1)), this.writtenTo = i, t > i && (this.nodes.push(null), this.writtenTo++, this.lineStart = -1);
    }
    this.pos = t;
  }
  point(e, t, i) {
    if (e < t || i.heightRelevant) {
      let r = i.widget ? i.widget.estimatedHeight : 0, s = i.widget ? i.widget.lineBreaks : 0;
      r < 0 && (r = this.oracle.lineHeight);
      let o = t - e;
      i.block ? this.addBlock(new Bf(o, r, i)) : (o || s || r >= p0) && this.addLineDeco(r, s, o);
    } else
      t > e && this.span(e, t);
    this.lineEnd > -1 && this.lineEnd < this.pos && (this.lineEnd = this.oracle.doc.lineAt(this.pos).to);
  }
  enterLine() {
    if (this.lineStart > -1)
      return;
    let { from: e, to: t } = this.oracle.doc.lineAt(this.pos);
    this.lineStart = e, this.lineEnd = t, this.writtenTo < e && ((this.writtenTo < e - 1 || this.nodes[this.nodes.length - 1] == null) && this.nodes.push(this.blankContent(this.writtenTo, e - 1)), this.nodes.push(null)), this.pos > e && this.nodes.push(new it(this.pos - e, -1)), this.writtenTo = this.pos;
  }
  blankContent(e, t) {
    let i = new Ee(t - e);
    return this.oracle.doc.lineAt(e).to == t && (i.flags |= 4), i;
  }
  ensureLine() {
    this.enterLine();
    let e = this.nodes.length ? this.nodes[this.nodes.length - 1] : null;
    if (e instanceof it)
      return e;
    let t = new it(0, -1);
    return this.nodes.push(t), t;
  }
  addBlock(e) {
    this.enterLine();
    let t = e.deco;
    t && t.startSide > 0 && !this.isCovered && this.ensureLine(), this.nodes.push(e), this.writtenTo = this.pos = this.pos + e.length, t && t.endSide > 0 && (this.covering = e);
  }
  addLineDeco(e, t, i) {
    let r = this.ensureLine();
    r.length += i, r.collapsed += i, r.widgetHeight = Math.max(r.widgetHeight, e), r.breaks += t, this.writtenTo = this.pos = this.pos + i;
  }
  finish(e) {
    let t = this.nodes.length == 0 ? null : this.nodes[this.nodes.length - 1];
    this.lineStart > -1 && !(t instanceof it) && !this.isCovered ? this.nodes.push(new it(0, -1)) : (this.writtenTo < this.pos || t == null) && this.nodes.push(this.blankContent(this.writtenTo, this.pos));
    let i = e;
    for (let r of this.nodes)
      r instanceof it && r.updateHeight(this.oracle, i), i += r ? r.length : 1;
    return this.nodes;
  }
  // Always called with a region that on both sides either stretches
  // to a line break or the end of the document.
  // The returned array uses null to indicate line breaks, but never
  // starts or ends in a line break, or has multiple line breaks next
  // to each other.
  static build(e, t, i, r) {
    let s = new la(i, e);
    return ie.spans(t, i, r, s, 0), s.finish(i);
  }
}
function m0(n, e, t) {
  let i = new g0();
  return ie.compare(n, e, t, i, 0), i.changes;
}
class g0 {
  constructor() {
    this.changes = [];
  }
  compareRange() {
  }
  comparePoint(e, t, i, r) {
    (e < t || i && i.heightRelevant || r && r.heightRelevant) && hl(e, t, this.changes, 5);
  }
}
function y0(n, e) {
  let t = n.getBoundingClientRect(), i = n.ownerDocument, r = i.defaultView || window, s = Math.max(0, t.left), o = Math.min(r.innerWidth, t.right), l = Math.max(0, t.top), a = Math.min(r.innerHeight, t.bottom);
  for (let u = n.parentNode; u && u != i.body; )
    if (u.nodeType == 1) {
      let c = u, h = window.getComputedStyle(c);
      if ((c.scrollHeight > c.clientHeight || c.scrollWidth > c.clientWidth) && h.overflow != "visible") {
        let f = c.getBoundingClientRect();
        s = Math.max(s, f.left), o = Math.min(o, f.right), l = Math.max(l, f.top), a = u == n.parentNode ? f.bottom : Math.min(a, f.bottom);
      }
      u = h.position == "absolute" || h.position == "fixed" ? c.offsetParent : c.parentNode;
    } else if (u.nodeType == 11)
      u = u.host;
    else
      break;
  return {
    left: s - t.left,
    right: Math.max(s, o) - t.left,
    top: l - (t.top + e),
    bottom: Math.max(l, a) - (t.top + e)
  };
}
function b0(n, e) {
  let t = n.getBoundingClientRect();
  return {
    left: 0,
    right: t.right - t.left,
    top: e,
    bottom: t.bottom - (t.top + e)
  };
}
class lo {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.size = i;
  }
  static same(e, t) {
    if (e.length != t.length)
      return !1;
    for (let i = 0; i < e.length; i++) {
      let r = e[i], s = t[i];
      if (r.from != s.from || r.to != s.to || r.size != s.size)
        return !1;
    }
    return !0;
  }
  draw(e, t) {
    return q.replace({
      widget: new x0(this.size * (t ? e.scaleY : e.scaleX), t)
    }).range(this.from, this.to);
  }
}
class x0 extends Jt {
  constructor(e, t) {
    super(), this.size = e, this.vertical = t;
  }
  eq(e) {
    return e.size == this.size && e.vertical == this.vertical;
  }
  toDOM() {
    let e = document.createElement("div");
    return this.vertical ? e.style.height = this.size + "px" : (e.style.width = this.size + "px", e.style.height = "2px", e.style.display = "inline-block"), e;
  }
  get estimatedHeight() {
    return this.vertical ? this.size : -1;
  }
}
class Du {
  constructor(e) {
    this.state = e, this.pixelViewport = { left: 0, right: window.innerWidth, top: 0, bottom: 0 }, this.inView = !0, this.paddingTop = 0, this.paddingBottom = 0, this.contentDOMWidth = 0, this.contentDOMHeight = 0, this.editorHeight = 0, this.editorWidth = 0, this.scrollTop = 0, this.scrolledToBottom = !1, this.scaleX = 1, this.scaleY = 1, this.scrollAnchorPos = 0, this.scrollAnchorHeight = -1, this.scaler = Eu, this.scrollTarget = null, this.printing = !1, this.mustMeasureContent = !0, this.defaultTextDirection = ye.LTR, this.visibleRanges = [], this.mustEnforceCursorAssoc = !1;
    let t = e.facet(sa).some((i) => typeof i != "function" && i.class == "cm-lineWrapping");
    this.heightOracle = new h0(t), this.stateDeco = e.facet(Gi).filter((i) => typeof i != "function"), this.heightMap = Ge.empty().applyChanges(this.stateDeco, re.empty, this.heightOracle.setDoc(e.doc), [new pt(0, 0, 0, e.doc.length)]), this.viewport = this.getViewport(0, null), this.updateViewportLines(), this.updateForViewport(), this.lineGaps = this.ensureLineGaps([]), this.lineGapDeco = q.set(this.lineGaps.map((i) => i.draw(this, !1))), this.computeVisibleRanges();
  }
  updateForViewport() {
    let e = [this.viewport], { main: t } = this.state.selection;
    for (let i = 0; i <= 1; i++) {
      let r = i ? t.head : t.anchor;
      if (!e.some(({ from: s, to: o }) => r >= s && r <= o)) {
        let { from: s, to: o } = this.lineBlockAt(r);
        e.push(new wr(s, o));
      }
    }
    this.viewports = e.sort((i, r) => i.from - r.from), this.scaler = this.heightMap.height <= 7e6 ? Eu : new v0(this.heightOracle, this.heightMap, this.viewports);
  }
  updateViewportLines() {
    this.viewportLines = [], this.heightMap.forEachLine(this.viewport.from, this.viewport.to, this.heightOracle.setDoc(this.state.doc), 0, 0, (e) => {
      this.viewportLines.push(this.scaler.scale == 1 ? e : Ii(e, this.scaler));
    });
  }
  update(e, t = null) {
    this.state = e.state;
    let i = this.stateDeco;
    this.stateDeco = this.state.facet(Gi).filter((c) => typeof c != "function");
    let r = e.changedRanges, s = pt.extendWithRanges(r, m0(i, this.stateDeco, e ? e.changes : Te.empty(this.state.doc.length))), o = this.heightMap.height, l = this.scrolledToBottom ? null : this.scrollAnchorAt(this.scrollTop);
    this.heightMap = this.heightMap.applyChanges(this.stateDeco, e.startState.doc, this.heightOracle.setDoc(this.state.doc), s), this.heightMap.height != o && (e.flags |= 2), l ? (this.scrollAnchorPos = e.changes.mapPos(l.from, -1), this.scrollAnchorHeight = l.top) : (this.scrollAnchorPos = -1, this.scrollAnchorHeight = this.heightMap.height);
    let a = s.length ? this.mapViewport(this.viewport, e.changes) : this.viewport;
    (t && (t.range.head < a.from || t.range.head > a.to) || !this.viewportIsAppropriate(a)) && (a = this.getViewport(0, t));
    let u = !e.changes.empty || e.flags & 2 || a.from != this.viewport.from || a.to != this.viewport.to;
    this.viewport = a, this.updateForViewport(), u && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(this.mapLineGaps(this.lineGaps, e.changes))), e.flags |= this.computeVisibleRanges(), t && (this.scrollTarget = t), !this.mustEnforceCursorAssoc && e.selectionSet && e.view.lineWrapping && e.state.selection.main.empty && e.state.selection.main.assoc && !e.state.facet(gf) && (this.mustEnforceCursorAssoc = !0);
  }
  measure(e) {
    let t = e.contentDOM, i = window.getComputedStyle(t), r = this.heightOracle, s = i.whiteSpace;
    this.defaultTextDirection = i.direction == "rtl" ? ye.RTL : ye.LTR;
    let o = this.heightOracle.mustRefreshForWrapping(s), l = t.getBoundingClientRect(), a = o || this.mustMeasureContent || this.contentDOMHeight != l.height;
    this.contentDOMHeight = l.height, this.mustMeasureContent = !1;
    let u = 0, c = 0;
    if (l.width && l.height) {
      let { scaleX: O, scaleY: A } = $h(t, l);
      (O > 5e-3 && Math.abs(this.scaleX - O) > 5e-3 || A > 5e-3 && Math.abs(this.scaleY - A) > 5e-3) && (this.scaleX = O, this.scaleY = A, u |= 8, o = a = !0);
    }
    let h = (parseInt(i.paddingTop) || 0) * this.scaleY, f = (parseInt(i.paddingBottom) || 0) * this.scaleY;
    (this.paddingTop != h || this.paddingBottom != f) && (this.paddingTop = h, this.paddingBottom = f, u |= 10), this.editorWidth != e.scrollDOM.clientWidth && (r.lineWrapping && (a = !0), this.editorWidth = e.scrollDOM.clientWidth, u |= 8);
    let d = e.scrollDOM.scrollTop * this.scaleY;
    this.scrollTop != d && (this.scrollAnchorHeight = -1, this.scrollTop = d), this.scrolledToBottom = qh(e.scrollDOM);
    let p = (this.printing ? b0 : y0)(t, this.paddingTop), g = p.top - this.pixelViewport.top, m = p.bottom - this.pixelViewport.bottom;
    this.pixelViewport = p;
    let y = this.pixelViewport.bottom > this.pixelViewport.top && this.pixelViewport.right > this.pixelViewport.left;
    if (y != this.inView && (this.inView = y, y && (a = !0)), !this.inView && !this.scrollTarget)
      return 0;
    let v = l.width;
    if ((this.contentDOMWidth != v || this.editorHeight != e.scrollDOM.clientHeight) && (this.contentDOMWidth = l.width, this.editorHeight = e.scrollDOM.clientHeight, u |= 8), a) {
      let O = e.docView.measureVisibleLineHeights(this.viewport);
      if (r.mustRefreshForHeights(O) && (o = !0), o || r.lineWrapping && Math.abs(v - this.contentDOMWidth) > r.charWidth) {
        let { lineHeight: A, charWidth: b, textHeight: S } = e.docView.measureTextSize();
        o = A > 0 && r.refresh(s, A, b, S, v / b, O), o && (e.docView.minWidth = 0, u |= 8);
      }
      g > 0 && m > 0 ? c = Math.max(g, m) : g < 0 && m < 0 && (c = Math.min(g, m)), r.heightChanged = !1;
      for (let A of this.viewports) {
        let b = A.from == this.viewport.from ? O : e.docView.measureVisibleLineHeights(A);
        this.heightMap = (o ? Ge.empty().applyChanges(this.stateDeco, re.empty, this.heightOracle, [new pt(0, 0, 0, e.state.doc.length)]) : this.heightMap).updateHeight(r, 0, o, new f0(A.from, b));
      }
      r.heightChanged && (u |= 2);
    }
    let C = !this.viewportIsAppropriate(this.viewport, c) || this.scrollTarget && (this.scrollTarget.range.head < this.viewport.from || this.scrollTarget.range.head > this.viewport.to);
    return C && (this.viewport = this.getViewport(c, this.scrollTarget)), this.updateForViewport(), (u & 2 || C) && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(o ? [] : this.lineGaps, e)), u |= this.computeVisibleRanges(), this.mustEnforceCursorAssoc && (this.mustEnforceCursorAssoc = !1, e.docView.enforceCursorAssoc()), u;
  }
  get visibleTop() {
    return this.scaler.fromDOM(this.pixelViewport.top);
  }
  get visibleBottom() {
    return this.scaler.fromDOM(this.pixelViewport.bottom);
  }
  getViewport(e, t) {
    let i = 0.5 - Math.max(-0.5, Math.min(0.5, e / 1e3 / 2)), r = this.heightMap, s = this.heightOracle, { visibleTop: o, visibleBottom: l } = this, a = new wr(r.lineAt(o - i * 1e3, ge.ByHeight, s, 0, 0).from, r.lineAt(l + (1 - i) * 1e3, ge.ByHeight, s, 0, 0).to);
    if (t) {
      let { head: u } = t.range;
      if (u < a.from || u > a.to) {
        let c = Math.min(this.editorHeight, this.pixelViewport.bottom - this.pixelViewport.top), h = r.lineAt(u, ge.ByPos, s, 0, 0), f;
        t.y == "center" ? f = (h.top + h.bottom) / 2 - c / 2 : t.y == "start" || t.y == "nearest" && u < a.from ? f = h.top : f = h.bottom - c, a = new wr(r.lineAt(f - 1e3 / 2, ge.ByHeight, s, 0, 0).from, r.lineAt(f + c + 1e3 / 2, ge.ByHeight, s, 0, 0).to);
      }
    }
    return a;
  }
  mapViewport(e, t) {
    let i = t.mapPos(e.from, -1), r = t.mapPos(e.to, 1);
    return new wr(this.heightMap.lineAt(i, ge.ByPos, this.heightOracle, 0, 0).from, this.heightMap.lineAt(r, ge.ByPos, this.heightOracle, 0, 0).to);
  }
  // Checks if a given viewport covers the visible part of the
  // document and not too much beyond that.
  viewportIsAppropriate({ from: e, to: t }, i = 0) {
    if (!this.inView)
      return !0;
    let { top: r } = this.heightMap.lineAt(e, ge.ByPos, this.heightOracle, 0, 0), { bottom: s } = this.heightMap.lineAt(t, ge.ByPos, this.heightOracle, 0, 0), { visibleTop: o, visibleBottom: l } = this;
    return (e == 0 || r <= o - Math.max(10, Math.min(
      -i,
      250
      /* VP.MaxCoverMargin */
    ))) && (t == this.state.doc.length || s >= l + Math.max(10, Math.min(
      i,
      250
      /* VP.MaxCoverMargin */
    ))) && r > o - 2 * 1e3 && s < l + 2 * 1e3;
  }
  mapLineGaps(e, t) {
    if (!e.length || t.empty)
      return e;
    let i = [];
    for (let r of e)
      t.touchesRange(r.from, r.to) || i.push(new lo(t.mapPos(r.from), t.mapPos(r.to), r.size));
    return i;
  }
  // Computes positions in the viewport where the start or end of a
  // line should be hidden, trying to reuse existing line gaps when
  // appropriate to avoid unneccesary redraws.
  // Uses crude character-counting for the positioning and sizing,
  // since actual DOM coordinates aren't always available and
  // predictable. Relies on generous margins (see LG.Margin) to hide
  // the artifacts this might produce from the user.
  ensureLineGaps(e, t) {
    let i = this.heightOracle.lineWrapping, r = i ? 1e4 : 2e3, s = r >> 1, o = r << 1;
    if (this.defaultTextDirection != ye.LTR && !i)
      return [];
    let l = [], a = (u, c, h, f) => {
      if (c - u < s)
        return;
      let d = this.state.selection.main, p = [d.from];
      d.empty || p.push(d.to);
      for (let m of p)
        if (m > u && m < c) {
          a(u, m - 10, h, f), a(m + 10, c, h, f);
          return;
        }
      let g = k0(e, (m) => m.from >= h.from && m.to <= h.to && Math.abs(m.from - u) < s && Math.abs(m.to - c) < s && !p.some((y) => m.from < y && m.to > y));
      if (!g) {
        if (c < h.to && t && i && t.visibleRanges.some((m) => m.from <= c && m.to >= c)) {
          let m = t.moveToLineBoundary(T.cursor(c), !1, !0).head;
          m > u && (c = m);
        }
        g = new lo(u, c, this.gapSize(h, u, c, f));
      }
      l.push(g);
    };
    for (let u of this.viewportLines) {
      if (u.length < o)
        continue;
      let c = w0(u.from, u.to, this.stateDeco);
      if (c.total < o)
        continue;
      let h = this.scrollTarget ? this.scrollTarget.range.head : null, f, d;
      if (i) {
        let p = r / this.heightOracle.lineLength * this.heightOracle.lineHeight, g, m;
        if (h != null) {
          let y = vr(c, h), v = ((this.visibleBottom - this.visibleTop) / 2 + p) / u.height;
          g = y - v, m = y + v;
        } else
          g = (this.visibleTop - u.top - p) / u.height, m = (this.visibleBottom - u.top + p) / u.height;
        f = kr(c, g), d = kr(c, m);
      } else {
        let p = c.total * this.heightOracle.charWidth, g = r * this.heightOracle.charWidth, m, y;
        if (h != null) {
          let v = vr(c, h), C = ((this.pixelViewport.right - this.pixelViewport.left) / 2 + g) / p;
          m = v - C, y = v + C;
        } else
          m = (this.pixelViewport.left - g) / p, y = (this.pixelViewport.right + g) / p;
        f = kr(c, m), d = kr(c, y);
      }
      f > u.from && a(u.from, f, u, c), d < u.to && a(d, u.to, u, c);
    }
    return l;
  }
  gapSize(e, t, i, r) {
    let s = vr(r, i) - vr(r, t);
    return this.heightOracle.lineWrapping ? e.height * s : r.total * this.heightOracle.charWidth * s;
  }
  updateLineGaps(e) {
    lo.same(e, this.lineGaps) || (this.lineGaps = e, this.lineGapDeco = q.set(e.map((t) => t.draw(this, this.heightOracle.lineWrapping))));
  }
  computeVisibleRanges() {
    let e = this.stateDeco;
    this.lineGaps.length && (e = e.concat(this.lineGapDeco));
    let t = [];
    ie.spans(e, this.viewport.from, this.viewport.to, {
      span(r, s) {
        t.push({ from: r, to: s });
      },
      point() {
      }
    }, 20);
    let i = t.length != this.visibleRanges.length || this.visibleRanges.some((r, s) => r.from != t[s].from || r.to != t[s].to);
    return this.visibleRanges = t, i ? 4 : 0;
  }
  lineBlockAt(e) {
    return e >= this.viewport.from && e <= this.viewport.to && this.viewportLines.find((t) => t.from <= e && t.to >= e) || Ii(this.heightMap.lineAt(e, ge.ByPos, this.heightOracle, 0, 0), this.scaler);
  }
  lineBlockAtHeight(e) {
    return Ii(this.heightMap.lineAt(this.scaler.fromDOM(e), ge.ByHeight, this.heightOracle, 0, 0), this.scaler);
  }
  scrollAnchorAt(e) {
    let t = this.lineBlockAtHeight(e + 8);
    return t.from >= this.viewport.from || this.viewportLines[0].top - e > 200 ? t : this.viewportLines[0];
  }
  elementAtHeight(e) {
    return Ii(this.heightMap.blockAt(this.scaler.fromDOM(e), this.heightOracle, 0, 0), this.scaler);
  }
  get docHeight() {
    return this.scaler.toDOM(this.heightMap.height);
  }
  get contentHeight() {
    return this.docHeight + this.paddingTop + this.paddingBottom;
  }
}
class wr {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
function w0(n, e, t) {
  let i = [], r = n, s = 0;
  return ie.spans(t, n, e, {
    span() {
    },
    point(o, l) {
      o > r && (i.push({ from: r, to: o }), s += o - r), r = l;
    }
  }, 20), r < e && (i.push({ from: r, to: e }), s += e - r), { total: s, ranges: i };
}
function kr({ total: n, ranges: e }, t) {
  if (t <= 0)
    return e[0].from;
  if (t >= 1)
    return e[e.length - 1].to;
  let i = Math.floor(n * t);
  for (let r = 0; ; r++) {
    let { from: s, to: o } = e[r], l = o - s;
    if (i <= l)
      return s + i;
    i -= l;
  }
}
function vr(n, e) {
  let t = 0;
  for (let { from: i, to: r } of n.ranges) {
    if (e <= r) {
      t += e - i;
      break;
    }
    t += r - i;
  }
  return t / n.total;
}
function k0(n, e) {
  for (let t of n)
    if (e(t))
      return t;
}
const Eu = {
  toDOM(n) {
    return n;
  },
  fromDOM(n) {
    return n;
  },
  scale: 1
};
class v0 {
  constructor(e, t, i) {
    let r = 0, s = 0, o = 0;
    this.viewports = i.map(({ from: l, to: a }) => {
      let u = t.lineAt(l, ge.ByPos, e, 0, 0).top, c = t.lineAt(a, ge.ByPos, e, 0, 0).bottom;
      return r += c - u, { from: l, to: a, top: u, bottom: c, domTop: 0, domBottom: 0 };
    }), this.scale = (7e6 - r) / (t.height - r);
    for (let l of this.viewports)
      l.domTop = o + (l.top - s) * this.scale, o = l.domBottom = l.domTop + (l.bottom - l.top), s = l.bottom;
  }
  toDOM(e) {
    for (let t = 0, i = 0, r = 0; ; t++) {
      let s = t < this.viewports.length ? this.viewports[t] : null;
      if (!s || e < s.top)
        return r + (e - i) * this.scale;
      if (e <= s.bottom)
        return s.domTop + (e - s.top);
      i = s.bottom, r = s.domBottom;
    }
  }
  fromDOM(e) {
    for (let t = 0, i = 0, r = 0; ; t++) {
      let s = t < this.viewports.length ? this.viewports[t] : null;
      if (!s || e < s.domTop)
        return i + (e - r) / this.scale;
      if (e <= s.domBottom)
        return s.top + (e - s.domTop);
      i = s.bottom, r = s.domBottom;
    }
  }
}
function Ii(n, e) {
  if (e.scale == 1)
    return n;
  let t = e.toDOM(n.top), i = e.toDOM(n.bottom);
  return new Bt(n.from, n.length, t, i - t, Array.isArray(n._content) ? n._content.map((r) => Ii(r, e)) : n._content);
}
const Sr = /* @__PURE__ */ j.define({ combine: (n) => n.join(" ") }), xl = /* @__PURE__ */ j.define({ combine: (n) => n.indexOf(!0) > -1 }), wl = /* @__PURE__ */ pn.newName(), Rf = /* @__PURE__ */ pn.newName(), Nf = /* @__PURE__ */ pn.newName(), Ff = { "&light": "." + Rf, "&dark": "." + Nf };
function kl(n, e, t) {
  return new pn(e, {
    finish(i) {
      return /&/.test(i) ? i.replace(/&\w*/, (r) => {
        if (r == "&")
          return n;
        if (!t || !t[r])
          throw new RangeError(`Unsupported selector: ${r}`);
        return t[r];
      }) : n + " " + i;
    }
  });
}
const S0 = /* @__PURE__ */ kl("." + wl, {
  "&": {
    position: "relative !important",
    boxSizing: "border-box",
    "&.cm-focused": {
      // Provide a simple default outline to make sure a focused
      // editor is visually distinct. Can't leave the default behavior
      // because that will apply to the content element, which is
      // inside the scrollable container and doesn't include the
      // gutters. We also can't use an 'auto' outline, since those
      // are, for some reason, drawn behind the element content, which
      // will cause things like the active line background to cover
      // the outline (#297).
      outline: "1px dotted #212121"
    },
    display: "flex !important",
    flexDirection: "column"
  },
  ".cm-scroller": {
    display: "flex !important",
    alignItems: "flex-start !important",
    fontFamily: "monospace",
    lineHeight: 1.4,
    height: "100%",
    overflowX: "auto",
    position: "relative",
    zIndex: 0
  },
  ".cm-content": {
    margin: 0,
    flexGrow: 2,
    flexShrink: 0,
    display: "block",
    whiteSpace: "pre",
    wordWrap: "normal",
    // https://github.com/codemirror/dev/issues/456
    boxSizing: "border-box",
    minHeight: "100%",
    padding: "4px 0",
    outline: "none",
    "&[contenteditable=true]": {
      WebkitUserModify: "read-write-plaintext-only"
    }
  },
  ".cm-lineWrapping": {
    whiteSpace_fallback: "pre-wrap",
    // For IE
    whiteSpace: "break-spaces",
    wordBreak: "break-word",
    // For Safari, which doesn't support overflow-wrap: anywhere
    overflowWrap: "anywhere",
    flexShrink: 1
  },
  "&light .cm-content": { caretColor: "black" },
  "&dark .cm-content": { caretColor: "white" },
  ".cm-line": {
    display: "block",
    padding: "0 2px 0 6px"
  },
  ".cm-layer": {
    position: "absolute",
    left: 0,
    top: 0,
    contain: "size style",
    "& > *": {
      position: "absolute"
    }
  },
  "&light .cm-selectionBackground": {
    background: "#d9d9d9"
  },
  "&dark .cm-selectionBackground": {
    background: "#222"
  },
  "&light.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#d7d4f0"
  },
  "&dark.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#233"
  },
  ".cm-cursorLayer": {
    pointerEvents: "none"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer": {
    animation: "steps(1) cm-blink 1.2s infinite"
  },
  // Two animations defined so that we can switch between them to
  // restart the animation without forcing another style
  // recomputation.
  "@keyframes cm-blink": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  "@keyframes cm-blink2": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  ".cm-cursor, .cm-dropCursor": {
    borderLeft: "1.2px solid black",
    marginLeft: "-0.6px",
    pointerEvents: "none"
  },
  ".cm-cursor": {
    display: "none"
  },
  "&dark .cm-cursor": {
    borderLeftColor: "#444"
  },
  ".cm-dropCursor": {
    position: "absolute"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer .cm-cursor": {
    display: "block"
  },
  ".cm-iso": {
    unicodeBidi: "isolate"
  },
  ".cm-announced": {
    position: "fixed",
    top: "-10000px"
  },
  "@media print": {
    ".cm-announced": { display: "none" }
  },
  "&light .cm-activeLine": { backgroundColor: "#cceeff44" },
  "&dark .cm-activeLine": { backgroundColor: "#99eeff33" },
  "&light .cm-specialChar": { color: "red" },
  "&dark .cm-specialChar": { color: "#f78" },
  ".cm-gutters": {
    flexShrink: 0,
    display: "flex",
    height: "100%",
    boxSizing: "border-box",
    insetInlineStart: 0,
    zIndex: 200
  },
  "&light .cm-gutters": {
    backgroundColor: "#f5f5f5",
    color: "#6c6c6c",
    borderRight: "1px solid #ddd"
  },
  "&dark .cm-gutters": {
    backgroundColor: "#333338",
    color: "#ccc"
  },
  ".cm-gutter": {
    display: "flex !important",
    // Necessary -- prevents margin collapsing
    flexDirection: "column",
    flexShrink: 0,
    boxSizing: "border-box",
    minHeight: "100%",
    overflow: "hidden"
  },
  ".cm-gutterElement": {
    boxSizing: "border-box"
  },
  ".cm-lineNumbers .cm-gutterElement": {
    padding: "0 3px 0 5px",
    minWidth: "20px",
    textAlign: "right",
    whiteSpace: "nowrap"
  },
  "&light .cm-activeLineGutter": {
    backgroundColor: "#e2f2ff"
  },
  "&dark .cm-activeLineGutter": {
    backgroundColor: "#222227"
  },
  ".cm-panels": {
    boxSizing: "border-box",
    position: "sticky",
    left: 0,
    right: 0
  },
  "&light .cm-panels": {
    backgroundColor: "#f5f5f5",
    color: "black"
  },
  "&light .cm-panels-top": {
    borderBottom: "1px solid #ddd"
  },
  "&light .cm-panels-bottom": {
    borderTop: "1px solid #ddd"
  },
  "&dark .cm-panels": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tab": {
    display: "inline-block",
    overflow: "hidden",
    verticalAlign: "bottom"
  },
  ".cm-widgetBuffer": {
    verticalAlign: "text-top",
    height: "1em",
    width: 0,
    display: "inline"
  },
  ".cm-placeholder": {
    color: "#888",
    display: "inline-block",
    verticalAlign: "top"
  },
  ".cm-highlightSpace:before": {
    content: "attr(data-display)",
    position: "absolute",
    pointerEvents: "none",
    color: "#888"
  },
  ".cm-highlightTab": {
    backgroundImage: `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="200" height="20"><path stroke="%23888" stroke-width="1" fill="none" d="M1 10H196L190 5M190 15L196 10M197 4L197 16"/></svg>')`,
    backgroundSize: "auto 100%",
    backgroundPosition: "right 90%",
    backgroundRepeat: "no-repeat"
  },
  ".cm-trailingSpace": {
    backgroundColor: "#ff332255"
  },
  ".cm-button": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    padding: ".2em 1em",
    borderRadius: "1px"
  },
  "&light .cm-button": {
    backgroundImage: "linear-gradient(#eff1f5, #d9d9df)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#b4b4b4, #d0d3d6)"
    }
  },
  "&dark .cm-button": {
    backgroundImage: "linear-gradient(#393939, #111)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#111, #333)"
    }
  },
  ".cm-textfield": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    border: "1px solid silver",
    padding: ".2em .5em"
  },
  "&light .cm-textfield": {
    backgroundColor: "white"
  },
  "&dark .cm-textfield": {
    border: "1px solid #555",
    backgroundColor: "inherit"
  }
}, Ff), Pi = "￿";
class C0 {
  constructor(e, t) {
    this.points = e, this.text = "", this.lineSeparator = t.facet(Q.lineSeparator);
  }
  append(e) {
    this.text += e;
  }
  lineBreak() {
    this.text += Pi;
  }
  readRange(e, t) {
    if (!e)
      return this;
    let i = e.parentNode;
    for (let r = e; ; ) {
      this.findPointBefore(i, r);
      let s = this.text.length;
      this.readNode(r);
      let o = r.nextSibling;
      if (o == t)
        break;
      let l = he.get(r), a = he.get(o);
      (l && a ? l.breakAfter : (l ? l.breakAfter : ss(r)) || ss(o) && (r.nodeName != "BR" || r.cmIgnore) && this.text.length > s) && this.lineBreak(), r = o;
    }
    return this.findPointBefore(i, t), this;
  }
  readTextNode(e) {
    let t = e.nodeValue;
    for (let i of this.points)
      i.node == e && (i.pos = this.text.length + Math.min(i.offset, t.length));
    for (let i = 0, r = this.lineSeparator ? null : /\r\n?|\n/g; ; ) {
      let s = -1, o = 1, l;
      if (this.lineSeparator ? (s = t.indexOf(this.lineSeparator, i), o = this.lineSeparator.length) : (l = r.exec(t)) && (s = l.index, o = l[0].length), this.append(t.slice(i, s < 0 ? t.length : s)), s < 0)
        break;
      if (this.lineBreak(), o > 1)
        for (let a of this.points)
          a.node == e && a.pos > this.text.length && (a.pos -= o - 1);
      i = s + o;
    }
  }
  readNode(e) {
    if (e.cmIgnore)
      return;
    let t = he.get(e), i = t && t.overrideDOMText;
    if (i != null) {
      this.findPointInside(e, i.length);
      for (let r = i.iter(); !r.next().done; )
        r.lineBreak ? this.lineBreak() : this.append(r.value);
    } else
      e.nodeType == 3 ? this.readTextNode(e) : e.nodeName == "BR" ? e.nextSibling && this.lineBreak() : e.nodeType == 1 && this.readRange(e.firstChild, null);
  }
  findPointBefore(e, t) {
    for (let i of this.points)
      i.node == e && e.childNodes[i.offset] == t && (i.pos = this.text.length);
  }
  findPointInside(e, t) {
    for (let i of this.points)
      (e.nodeType == 3 ? i.node == e : e.contains(i.node)) && (i.pos = this.text.length + (A0(e, i.node, i.offset) ? t : 0));
  }
}
function A0(n, e, t) {
  for (; ; ) {
    if (!e || t < Kt(e))
      return !1;
    if (e == n)
      return !0;
    t = Bn(e) + 1, e = e.parentNode;
  }
}
class Lu {
  constructor(e, t) {
    this.node = e, this.offset = t, this.pos = -1;
  }
}
class M0 {
  constructor(e, t, i, r) {
    this.typeOver = r, this.bounds = null, this.text = "";
    let { impreciseHead: s, impreciseAnchor: o } = e.docView;
    if (e.state.readOnly && t > -1)
      this.newSel = null;
    else if (t > -1 && (this.bounds = e.docView.domBoundsAround(t, i, 0))) {
      let l = s || o ? [] : D0(e), a = new C0(l, e.state);
      a.readRange(this.bounds.startDOM, this.bounds.endDOM), this.text = a.text, this.newSel = E0(l, this.bounds.from);
    } else {
      let l = e.observer.selectionRange, a = s && s.node == l.focusNode && s.offset == l.focusOffset || !sl(e.contentDOM, l.focusNode) ? e.state.selection.main.head : e.docView.posFromDOM(l.focusNode, l.focusOffset), u = o && o.node == l.anchorNode && o.offset == l.anchorOffset || !sl(e.contentDOM, l.anchorNode) ? e.state.selection.main.anchor : e.docView.posFromDOM(l.anchorNode, l.anchorOffset), c = e.viewport;
      if (($.ios || $.chrome) && e.state.selection.main.empty && a != u && (c.from > 0 || c.to < e.state.doc.length)) {
        let h = Math.min(a, u), f = Math.max(a, u), d = c.from - h, p = c.to - f;
        (d == 0 || d == 1 || h == 0) && (p == 0 || p == -1 || f == e.state.doc.length) && (a = 0, u = e.state.doc.length);
      }
      this.newSel = T.single(u, a);
    }
  }
}
function zf(n, e) {
  let t, { newSel: i } = e, r = n.state.selection.main, s = n.inputState.lastKeyTime > Date.now() - 100 ? n.inputState.lastKeyCode : -1;
  if (e.bounds) {
    let { from: o, to: l } = e.bounds, a = r.from, u = null;
    (s === 8 || $.android && e.text.length < l - o) && (a = r.to, u = "end");
    let c = O0(n.state.doc.sliceString(o, l, Pi), e.text, a - o, u);
    c && ($.chrome && s == 13 && c.toB == c.from + 2 && e.text.slice(c.from, c.toB) == Pi + Pi && c.toB--, t = {
      from: o + c.from,
      to: o + c.toA,
      insert: re.of(e.text.slice(c.from, c.toB).split(Pi))
    });
  } else
    i && (!n.hasFocus && n.state.facet(Rs) || i.main.eq(r)) && (i = null);
  if (!t && !i)
    return !1;
  if (!t && e.typeOver && !r.empty && i && i.main.empty ? t = { from: r.from, to: r.to, insert: n.state.doc.slice(r.from, r.to) } : t && t.from >= r.from && t.to <= r.to && (t.from != r.from || t.to != r.to) && r.to - r.from - (t.to - t.from) <= 4 ? t = {
    from: r.from,
    to: r.to,
    insert: n.state.doc.slice(r.from, t.from).append(t.insert).append(n.state.doc.slice(t.to, r.to))
  } : ($.mac || $.android) && t && t.from == t.to && t.from == r.head - 1 && /^\. ?$/.test(t.insert.toString()) && n.contentDOM.getAttribute("autocorrect") == "off" ? (i && t.insert.length == 2 && (i = T.single(i.main.anchor - 1, i.main.head - 1)), t = { from: r.from, to: r.to, insert: re.of([" "]) }) : $.chrome && t && t.from == t.to && t.from == r.head && t.insert.toString() == `
 ` && n.lineWrapping && (i && (i = T.single(i.main.anchor - 1, i.main.head - 1)), t = { from: r.from, to: r.to, insert: re.of([" "]) }), t) {
    if ($.ios && n.inputState.flushIOSKey(t) || $.android && (t.to == r.to && // GBoard will sometimes remove a space it just inserted
    // after a completion when you press enter
    (t.from == r.from || t.from == r.from - 1 && n.state.sliceDoc(t.from, r.from) == " ") && t.insert.length == 1 && t.insert.lines == 2 && Zn(n.contentDOM, "Enter", 13) || (t.from == r.from - 1 && t.to == r.to && t.insert.length == 0 || s == 8 && t.insert.length < t.to - t.from && t.to > r.head) && Zn(n.contentDOM, "Backspace", 8) || t.from == r.from && t.to == r.to + 1 && t.insert.length == 0 && Zn(n.contentDOM, "Delete", 46)))
      return !0;
    let o = t.insert.toString();
    n.inputState.composing >= 0 && n.inputState.composing++;
    let l, a = () => l || (l = T0(n, t, i));
    return n.state.facet(df).some((u) => u(n, t.from, t.to, o, a)) || n.dispatch(a()), !0;
  } else if (i && !i.main.eq(r)) {
    let o = !1, l = "select";
    return n.inputState.lastSelectionTime > Date.now() - 50 && (n.inputState.lastSelectionOrigin == "select" && (o = !0), l = n.inputState.lastSelectionOrigin), n.dispatch({ selection: i, scrollIntoView: o, userEvent: l }), !0;
  } else
    return !1;
}
function T0(n, e, t) {
  let i, r = n.state, s = r.selection.main;
  if (e.from >= s.from && e.to <= s.to && e.to - e.from >= (s.to - s.from) / 3 && (!t || t.main.empty && t.main.from == e.from + e.insert.length) && n.inputState.composing < 0) {
    let l = s.from < e.from ? r.sliceDoc(s.from, e.from) : "", a = s.to > e.to ? r.sliceDoc(e.to, s.to) : "";
    i = r.replaceSelection(n.state.toText(l + e.insert.sliceString(0, void 0, n.state.lineBreak) + a));
  } else {
    let l = r.changes(e), a = t && t.main.to <= l.newLength ? t.main : void 0;
    if (r.selection.ranges.length > 1 && n.inputState.composing >= 0 && e.to <= s.to && e.to >= s.to - 10) {
      let u = n.state.sliceDoc(e.from, e.to), c, h = t && Sf(n, t.main.head);
      if (h) {
        let p = e.insert.length - (e.to - e.from);
        c = { from: h.from, to: h.to - p };
      } else
        c = n.state.doc.lineAt(s.head);
      let f = s.to - e.to, d = s.to - s.from;
      i = r.changeByRange((p) => {
        if (p.from == s.from && p.to == s.to)
          return { changes: l, range: a || p.map(l) };
        let g = p.to - f, m = g - u.length;
        if (p.to - p.from != d || n.state.sliceDoc(m, g) != u || // Unfortunately, there's no way to make multiple
        // changes in the same node work without aborting
        // composition, so cursors in the composition range are
        // ignored.
        p.to >= c.from && p.from <= c.to)
          return { range: p };
        let y = r.changes({ from: m, to: g, insert: e.insert }), v = p.to - s.to;
        return {
          changes: y,
          range: a ? T.range(Math.max(0, a.anchor + v), Math.max(0, a.head + v)) : p.map(y)
        };
      });
    } else
      i = {
        changes: l,
        selection: a && r.selection.replaceRange(a)
      };
  }
  let o = "input.type";
  return (n.composing || n.inputState.compositionPendingChange && n.inputState.compositionEndedAt > Date.now() - 50) && (n.inputState.compositionPendingChange = !1, o += ".compose", n.inputState.compositionFirstChange && (o += ".start", n.inputState.compositionFirstChange = !1)), r.update(i, { userEvent: o, scrollIntoView: !0 });
}
function O0(n, e, t, i) {
  let r = Math.min(n.length, e.length), s = 0;
  for (; s < r && n.charCodeAt(s) == e.charCodeAt(s); )
    s++;
  if (s == r && n.length == e.length)
    return null;
  let o = n.length, l = e.length;
  for (; o > 0 && l > 0 && n.charCodeAt(o - 1) == e.charCodeAt(l - 1); )
    o--, l--;
  if (i == "end") {
    let a = Math.max(0, s - Math.min(o, l));
    t -= o + a - s;
  }
  if (o < s && n.length < e.length) {
    let a = t <= s && t >= o ? s - t : 0;
    s -= a, l = s + (l - o), o = s;
  } else if (l < s) {
    let a = t <= s && t >= l ? s - t : 0;
    s -= a, o = s + (o - l), l = s;
  }
  return { from: s, toA: o, toB: l };
}
function D0(n) {
  let e = [];
  if (n.root.activeElement != n.contentDOM)
    return e;
  let { anchorNode: t, anchorOffset: i, focusNode: r, focusOffset: s } = n.observer.selectionRange;
  return t && (e.push(new Lu(t, i)), (r != t || s != i) && e.push(new Lu(r, s))), e;
}
function E0(n, e) {
  if (n.length == 0)
    return null;
  let t = n[0].pos, i = n.length == 2 ? n[1].pos : t;
  return t > -1 && i > -1 ? T.single(t + e, i + e) : null;
}
const L0 = {
  childList: !0,
  characterData: !0,
  subtree: !0,
  attributes: !0,
  characterDataOldValue: !0
}, ao = $.ie && $.ie_version <= 11;
class I0 {
  constructor(e) {
    this.view = e, this.active = !1, this.selectionRange = new mg(), this.selectionChanged = !1, this.delayedFlush = -1, this.resizeTimeout = -1, this.queue = [], this.delayedAndroidKey = null, this.flushingAndroidKey = -1, this.lastChange = 0, this.scrollTargets = [], this.intersection = null, this.resizeScroll = null, this.intersecting = !1, this.gapIntersection = null, this.gaps = [], this.printQuery = null, this.parentCheck = -1, this.dom = e.contentDOM, this.observer = new MutationObserver((t) => {
      for (let i of t)
        this.queue.push(i);
      ($.ie && $.ie_version <= 11 || $.ios && e.composing) && t.some((i) => i.type == "childList" && i.removedNodes.length || i.type == "characterData" && i.oldValue.length > i.target.nodeValue.length) ? this.flushSoon() : this.flush();
    }), ao && (this.onCharData = (t) => {
      this.queue.push({
        target: t.target,
        type: "characterData",
        oldValue: t.prevValue
      }), this.flushSoon();
    }), this.onSelectionChange = this.onSelectionChange.bind(this), this.onResize = this.onResize.bind(this), this.onPrint = this.onPrint.bind(this), this.onScroll = this.onScroll.bind(this), window.matchMedia && (this.printQuery = window.matchMedia("print")), typeof ResizeObserver == "function" && (this.resizeScroll = new ResizeObserver(() => {
      var t;
      ((t = this.view.docView) === null || t === void 0 ? void 0 : t.lastUpdate) < Date.now() - 75 && this.onResize();
    }), this.resizeScroll.observe(e.scrollDOM)), this.addWindowListeners(this.win = e.win), this.start(), typeof IntersectionObserver == "function" && (this.intersection = new IntersectionObserver((t) => {
      this.parentCheck < 0 && (this.parentCheck = setTimeout(this.listenForScroll.bind(this), 1e3)), t.length > 0 && t[t.length - 1].intersectionRatio > 0 != this.intersecting && (this.intersecting = !this.intersecting, this.intersecting != this.view.inView && this.onScrollChanged(document.createEvent("Event")));
    }, { threshold: [0, 1e-3] }), this.intersection.observe(this.dom), this.gapIntersection = new IntersectionObserver((t) => {
      t.length > 0 && t[t.length - 1].intersectionRatio > 0 && this.onScrollChanged(document.createEvent("Event"));
    }, {})), this.listenForScroll(), this.readSelectionRange();
  }
  onScrollChanged(e) {
    this.view.inputState.runHandlers("scroll", e), this.intersecting && this.view.measure();
  }
  onScroll(e) {
    this.intersecting && this.flush(!1), this.onScrollChanged(e);
  }
  onResize() {
    this.resizeTimeout < 0 && (this.resizeTimeout = setTimeout(() => {
      this.resizeTimeout = -1, this.view.requestMeasure();
    }, 50));
  }
  onPrint(e) {
    e.type == "change" && !e.matches || (this.view.viewState.printing = !0, this.view.measure(), setTimeout(() => {
      this.view.viewState.printing = !1, this.view.requestMeasure();
    }, 500));
  }
  updateGaps(e) {
    if (this.gapIntersection && (e.length != this.gaps.length || this.gaps.some((t, i) => t != e[i]))) {
      this.gapIntersection.disconnect();
      for (let t of e)
        this.gapIntersection.observe(t);
      this.gaps = e;
    }
  }
  onSelectionChange(e) {
    let t = this.selectionChanged;
    if (!this.readSelectionRange() || this.delayedAndroidKey)
      return;
    let { view: i } = this, r = this.selectionRange;
    if (i.state.facet(Rs) ? i.root.activeElement != this.dom : !Ur(i.dom, r))
      return;
    let s = r.anchorNode && i.docView.nearest(r.anchorNode);
    if (s && s.ignoreEvent(e)) {
      t || (this.selectionChanged = !1);
      return;
    }
    ($.ie && $.ie_version <= 11 || $.android && $.chrome) && !i.state.selection.main.empty && // (Selection.isCollapsed isn't reliable on IE)
    r.focusNode && Hi(r.focusNode, r.focusOffset, r.anchorNode, r.anchorOffset) ? this.flushSoon() : this.flush(!1);
  }
  readSelectionRange() {
    let { view: e } = this, t = rs(e.root);
    if (!t)
      return !1;
    let i = $.safari && e.root.nodeType == 11 && hg(this.dom.ownerDocument) == this.dom && P0(this.view, t) || t;
    if (!i || this.selectionRange.eq(i))
      return !1;
    let r = Ur(this.dom, i);
    return r && !this.selectionChanged && e.inputState.lastFocusTime > Date.now() - 200 && e.inputState.lastTouchTime < Date.now() - 300 && yg(this.dom, i) ? (this.view.inputState.lastFocusTime = 0, e.docView.updateSelection(), !1) : (this.selectionRange.setRange(i), r && (this.selectionChanged = !0), !0);
  }
  setSelectionRange(e, t) {
    this.selectionRange.set(e.node, e.offset, t.node, t.offset), this.selectionChanged = !1;
  }
  clearSelectionRange() {
    this.selectionRange.set(null, 0, null, 0);
  }
  listenForScroll() {
    this.parentCheck = -1;
    let e = 0, t = null;
    for (let i = this.dom; i; )
      if (i.nodeType == 1)
        !t && e < this.scrollTargets.length && this.scrollTargets[e] == i ? e++ : t || (t = this.scrollTargets.slice(0, e)), t && t.push(i), i = i.assignedSlot || i.parentNode;
      else if (i.nodeType == 11)
        i = i.host;
      else
        break;
    if (e < this.scrollTargets.length && !t && (t = this.scrollTargets.slice(0, e)), t) {
      for (let i of this.scrollTargets)
        i.removeEventListener("scroll", this.onScroll);
      for (let i of this.scrollTargets = t)
        i.addEventListener("scroll", this.onScroll);
    }
  }
  ignore(e) {
    if (!this.active)
      return e();
    try {
      return this.stop(), e();
    } finally {
      this.start(), this.clear();
    }
  }
  start() {
    this.active || (this.observer.observe(this.dom, L0), ao && this.dom.addEventListener("DOMCharacterDataModified", this.onCharData), this.active = !0);
  }
  stop() {
    this.active && (this.active = !1, this.observer.disconnect(), ao && this.dom.removeEventListener("DOMCharacterDataModified", this.onCharData));
  }
  // Throw away any pending changes
  clear() {
    this.processRecords(), this.queue.length = 0, this.selectionChanged = !1;
  }
  // Chrome Android, especially in combination with GBoard, not only
  // doesn't reliably fire regular key events, but also often
  // surrounds the effect of enter or backspace with a bunch of
  // composition events that, when interrupted, cause text duplication
  // or other kinds of corruption. This hack makes the editor back off
  // from handling DOM changes for a moment when such a key is
  // detected (via beforeinput or keydown), and then tries to flush
  // them or, if that has no effect, dispatches the given key.
  delayAndroidKey(e, t) {
    var i;
    if (!this.delayedAndroidKey) {
      let r = () => {
        let s = this.delayedAndroidKey;
        s && (this.clearDelayedAndroidKey(), this.view.inputState.lastKeyCode = s.keyCode, this.view.inputState.lastKeyTime = Date.now(), !this.flush() && s.force && Zn(this.dom, s.key, s.keyCode));
      };
      this.flushingAndroidKey = this.view.win.requestAnimationFrame(r);
    }
    (!this.delayedAndroidKey || e == "Enter") && (this.delayedAndroidKey = {
      key: e,
      keyCode: t,
      // Only run the key handler when no changes are detected if
      // this isn't coming right after another change, in which case
      // it is probably part of a weird chain of updates, and should
      // be ignored if it returns the DOM to its previous state.
      force: this.lastChange < Date.now() - 50 || !!(!((i = this.delayedAndroidKey) === null || i === void 0) && i.force)
    });
  }
  clearDelayedAndroidKey() {
    this.win.cancelAnimationFrame(this.flushingAndroidKey), this.delayedAndroidKey = null, this.flushingAndroidKey = -1;
  }
  flushSoon() {
    this.delayedFlush < 0 && (this.delayedFlush = this.view.win.requestAnimationFrame(() => {
      this.delayedFlush = -1, this.flush();
    }));
  }
  forceFlush() {
    this.delayedFlush >= 0 && (this.view.win.cancelAnimationFrame(this.delayedFlush), this.delayedFlush = -1), this.flush();
  }
  pendingRecords() {
    for (let e of this.observer.takeRecords())
      this.queue.push(e);
    return this.queue;
  }
  processRecords() {
    let e = this.pendingRecords();
    e.length && (this.queue = []);
    let t = -1, i = -1, r = !1;
    for (let s of e) {
      let o = this.readMutation(s);
      o && (o.typeOver && (r = !0), t == -1 ? { from: t, to: i } = o : (t = Math.min(o.from, t), i = Math.max(o.to, i)));
    }
    return { from: t, to: i, typeOver: r };
  }
  readChange() {
    let { from: e, to: t, typeOver: i } = this.processRecords(), r = this.selectionChanged && Ur(this.dom, this.selectionRange);
    if (e < 0 && !r)
      return null;
    e > -1 && (this.lastChange = Date.now()), this.view.inputState.lastFocusTime = 0, this.selectionChanged = !1;
    let s = new M0(this.view, e, t, i);
    return this.view.docView.domChanged = { newSel: s.newSel ? s.newSel.main : null }, s;
  }
  // Apply pending changes, if any
  flush(e = !0) {
    if (this.delayedFlush >= 0 || this.delayedAndroidKey)
      return !1;
    e && this.readSelectionRange();
    let t = this.readChange();
    if (!t)
      return this.view.requestMeasure(), !1;
    let i = this.view.state, r = zf(this.view, t);
    return this.view.state == i && this.view.update([]), r;
  }
  readMutation(e) {
    let t = this.view.docView.nearest(e.target);
    if (!t || t.ignoreMutation(e))
      return null;
    if (t.markDirty(e.type == "attributes"), e.type == "attributes" && (t.flags |= 4), e.type == "childList") {
      let i = Iu(t, e.previousSibling || e.target.previousSibling, -1), r = Iu(t, e.nextSibling || e.target.nextSibling, 1);
      return {
        from: i ? t.posAfter(i) : t.posAtStart,
        to: r ? t.posBefore(r) : t.posAtEnd,
        typeOver: !1
      };
    } else
      return e.type == "characterData" ? { from: t.posAtStart, to: t.posAtEnd, typeOver: e.target.nodeValue == e.oldValue } : null;
  }
  setWindow(e) {
    e != this.win && (this.removeWindowListeners(this.win), this.win = e, this.addWindowListeners(this.win));
  }
  addWindowListeners(e) {
    e.addEventListener("resize", this.onResize), this.printQuery ? this.printQuery.addEventListener("change", this.onPrint) : e.addEventListener("beforeprint", this.onPrint), e.addEventListener("scroll", this.onScroll), e.document.addEventListener("selectionchange", this.onSelectionChange);
  }
  removeWindowListeners(e) {
    e.removeEventListener("scroll", this.onScroll), e.removeEventListener("resize", this.onResize), this.printQuery ? this.printQuery.removeEventListener("change", this.onPrint) : e.removeEventListener("beforeprint", this.onPrint), e.document.removeEventListener("selectionchange", this.onSelectionChange);
  }
  destroy() {
    var e, t, i;
    this.stop(), (e = this.intersection) === null || e === void 0 || e.disconnect(), (t = this.gapIntersection) === null || t === void 0 || t.disconnect(), (i = this.resizeScroll) === null || i === void 0 || i.disconnect();
    for (let r of this.scrollTargets)
      r.removeEventListener("scroll", this.onScroll);
    this.removeWindowListeners(this.win), clearTimeout(this.parentCheck), clearTimeout(this.resizeTimeout), this.win.cancelAnimationFrame(this.delayedFlush), this.win.cancelAnimationFrame(this.flushingAndroidKey);
  }
}
function Iu(n, e, t) {
  for (; e; ) {
    let i = he.get(e);
    if (i && i.parent == n)
      return i;
    let r = e.parentNode;
    e = r != n.dom ? r : t > 0 ? e.nextSibling : e.previousSibling;
  }
  return null;
}
function Pu(n, e) {
  let t = e.startContainer, i = e.startOffset, r = e.endContainer, s = e.endOffset, o = n.docView.domAtPos(n.state.selection.main.anchor);
  return Hi(o.node, o.offset, r, s) && ([t, i, r, s] = [r, s, t, i]), { anchorNode: t, anchorOffset: i, focusNode: r, focusOffset: s };
}
function P0(n, e) {
  if (e.getComposedRanges) {
    let r = e.getComposedRanges(n.root)[0];
    if (r)
      return Pu(n, r);
  }
  let t = null;
  function i(r) {
    r.preventDefault(), r.stopImmediatePropagation(), t = r.getTargetRanges()[0];
  }
  return n.contentDOM.addEventListener("beforeinput", i, !0), n.dom.ownerDocument.execCommand("indent"), n.contentDOM.removeEventListener("beforeinput", i, !0), t ? Pu(n, t) : null;
}
class V {
  /**
  The current editor state.
  */
  get state() {
    return this.viewState.state;
  }
  /**
  To be able to display large documents without consuming too much
  memory or overloading the browser, CodeMirror only draws the
  code that is visible (plus a margin around it) to the DOM. This
  property tells you the extent of the current drawn viewport, in
  document positions.
  */
  get viewport() {
    return this.viewState.viewport;
  }
  /**
  When there are, for example, large collapsed ranges in the
  viewport, its size can be a lot bigger than the actual visible
  content. Thus, if you are doing something like styling the
  content in the viewport, it is preferable to only do so for
  these ranges, which are the subset of the viewport that is
  actually drawn.
  */
  get visibleRanges() {
    return this.viewState.visibleRanges;
  }
  /**
  Returns false when the editor is entirely scrolled out of view
  or otherwise hidden.
  */
  get inView() {
    return this.viewState.inView;
  }
  /**
  Indicates whether the user is currently composing text via
  [IME](https://en.wikipedia.org/wiki/Input_method), and at least
  one change has been made in the current composition.
  */
  get composing() {
    return this.inputState.composing > 0;
  }
  /**
  Indicates whether the user is currently in composing state. Note
  that on some platforms, like Android, this will be the case a
  lot, since just putting the cursor on a word starts a
  composition there.
  */
  get compositionStarted() {
    return this.inputState.composing >= 0;
  }
  /**
  The document or shadow root that the view lives in.
  */
  get root() {
    return this._root;
  }
  /**
  @internal
  */
  get win() {
    return this.dom.ownerDocument.defaultView || window;
  }
  /**
  Construct a new view. You'll want to either provide a `parent`
  option, or put `view.dom` into your document after creating a
  view, so that the user can see the editor.
  */
  constructor(e = {}) {
    this.plugins = [], this.pluginMap = /* @__PURE__ */ new Map(), this.editorAttrs = {}, this.contentAttrs = {}, this.bidiCache = [], this.destroyed = !1, this.updateState = 2, this.measureScheduled = -1, this.measureRequests = [], this.contentDOM = document.createElement("div"), this.scrollDOM = document.createElement("div"), this.scrollDOM.tabIndex = -1, this.scrollDOM.className = "cm-scroller", this.scrollDOM.appendChild(this.contentDOM), this.announceDOM = document.createElement("div"), this.announceDOM.className = "cm-announced", this.announceDOM.setAttribute("aria-live", "polite"), this.dom = document.createElement("div"), this.dom.appendChild(this.announceDOM), this.dom.appendChild(this.scrollDOM), e.parent && e.parent.appendChild(this.dom);
    let { dispatch: t } = e;
    this.dispatchTransactions = e.dispatchTransactions || t && ((i) => i.forEach((r) => t(r, this))) || ((i) => this.update(i)), this.dispatch = this.dispatch.bind(this), this._root = e.root || gg(e.parent) || document, this.viewState = new Du(e.state || Q.create(e)), e.scrollTo && e.scrollTo.is(yr) && (this.viewState.scrollTarget = e.scrollTo.value.clip(this.viewState.state)), this.plugins = this.state.facet(Ei).map((i) => new ro(i));
    for (let i of this.plugins)
      i.update(this);
    this.observer = new I0(this), this.inputState = new Gg(this), this.inputState.ensureHandlers(this.plugins), this.docView = new hu(this), this.mountStyles(), this.updateAttrs(), this.updateState = 0, this.requestMeasure();
  }
  dispatch(...e) {
    let t = e.length == 1 && e[0] instanceof Oe ? e : e.length == 1 && Array.isArray(e[0]) ? e[0] : [this.state.update(...e)];
    this.dispatchTransactions(t, this);
  }
  /**
  Update the view for the given array of transactions. This will
  update the visible document and selection to match the state
  produced by the transactions, and notify view plugins of the
  change. You should usually call
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead, which uses this
  as a primitive.
  */
  update(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.update are not allowed while an update is in progress");
    let t = !1, i = !1, r, s = this.state;
    for (let f of e) {
      if (f.startState != s)
        throw new RangeError("Trying to update state with a transaction that doesn't start from the previous state.");
      s = f.state;
    }
    if (this.destroyed) {
      this.viewState.state = s;
      return;
    }
    let o = this.hasFocus, l = 0, a = null;
    e.some((f) => f.annotation(Lf)) ? (this.inputState.notifiedFocused = o, l = 1) : o != this.inputState.notifiedFocused && (this.inputState.notifiedFocused = o, a = If(s, o), a || (l = 1));
    let u = this.observer.delayedAndroidKey, c = null;
    if (u ? (this.observer.clearDelayedAndroidKey(), c = this.observer.readChange(), (c && !this.state.doc.eq(s.doc) || !this.state.selection.eq(s.selection)) && (c = null)) : this.observer.clear(), s.facet(Q.phrases) != this.state.facet(Q.phrases))
      return this.setState(s);
    r = os.create(this, s, e), r.flags |= l;
    let h = this.viewState.scrollTarget;
    try {
      this.updateState = 2;
      for (let f of e) {
        if (h && (h = h.map(f.changes)), f.scrollIntoView) {
          let { main: d } = f.state.selection;
          h = new ei(d.empty ? d : T.cursor(d.head, d.head > d.anchor ? -1 : 1));
        }
        for (let d of f.effects)
          d.is(yr) && (h = d.value.clip(this.state));
      }
      this.viewState.update(r, h), this.bidiCache = ls.update(this.bidiCache, r.changes), r.empty || (this.updatePlugins(r), this.inputState.update(r)), t = this.docView.update(r), this.state.facet(Li) != this.styleModules && this.mountStyles(), i = this.updateAttrs(), this.showAnnouncements(e), this.docView.updateSelection(t, e.some((f) => f.isUserEvent("select.pointer")));
    } finally {
      this.updateState = 0;
    }
    if (r.startState.facet(Sr) != r.state.facet(Sr) && (this.viewState.mustMeasureContent = !0), (t || i || h || this.viewState.mustEnforceCursorAssoc || this.viewState.mustMeasureContent) && this.requestMeasure(), t && this.docViewUpdate(), !r.empty)
      for (let f of this.state.facet(ml))
        try {
          f(r);
        } catch (d) {
          Je(this.state, d, "update listener");
        }
    (a || c) && Promise.resolve().then(() => {
      a && this.state == a.startState && this.dispatch(a), c && !zf(this, c) && u.force && Zn(this.contentDOM, u.key, u.keyCode);
    });
  }
  /**
  Reset the view to the given state. (This will cause the entire
  document to be redrawn and all view plugins to be reinitialized,
  so you should probably only use it when the new state isn't
  derived from the old state. Otherwise, use
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead.)
  */
  setState(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.setState are not allowed while an update is in progress");
    if (this.destroyed) {
      this.viewState.state = e;
      return;
    }
    this.updateState = 2;
    let t = this.hasFocus;
    try {
      for (let i of this.plugins)
        i.destroy(this);
      this.viewState = new Du(e), this.plugins = e.facet(Ei).map((i) => new ro(i)), this.pluginMap.clear();
      for (let i of this.plugins)
        i.update(this);
      this.docView.destroy(), this.docView = new hu(this), this.inputState.ensureHandlers(this.plugins), this.mountStyles(), this.updateAttrs(), this.bidiCache = [];
    } finally {
      this.updateState = 0;
    }
    t && this.focus(), this.requestMeasure();
  }
  updatePlugins(e) {
    let t = e.startState.facet(Ei), i = e.state.facet(Ei);
    if (t != i) {
      let r = [];
      for (let s of i) {
        let o = t.indexOf(s);
        if (o < 0)
          r.push(new ro(s));
        else {
          let l = this.plugins[o];
          l.mustUpdate = e, r.push(l);
        }
      }
      for (let s of this.plugins)
        s.mustUpdate != e && s.destroy(this);
      this.plugins = r, this.pluginMap.clear();
    } else
      for (let r of this.plugins)
        r.mustUpdate = e;
    for (let r = 0; r < this.plugins.length; r++)
      this.plugins[r].update(this);
    t != i && this.inputState.ensureHandlers(this.plugins);
  }
  docViewUpdate() {
    for (let e of this.plugins) {
      let t = e.value;
      if (t && t.docViewUpdate)
        try {
          t.docViewUpdate(this);
        } catch (i) {
          Je(this.state, i, "doc view update listener");
        }
    }
  }
  /**
  @internal
  */
  measure(e = !0) {
    if (this.destroyed)
      return;
    if (this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.observer.delayedAndroidKey) {
      this.measureScheduled = -1, this.requestMeasure();
      return;
    }
    this.measureScheduled = 0, e && this.observer.forceFlush();
    let t = null, i = this.scrollDOM, r = i.scrollTop * this.scaleY, { scrollAnchorPos: s, scrollAnchorHeight: o } = this.viewState;
    Math.abs(r - this.viewState.scrollTop) > 1 && (o = -1), this.viewState.scrollAnchorHeight = -1;
    try {
      for (let l = 0; ; l++) {
        if (o < 0)
          if (qh(i))
            s = -1, o = this.viewState.heightMap.height;
          else {
            let d = this.viewState.scrollAnchorAt(r);
            s = d.from, o = d.top;
          }
        this.updateState = 1;
        let a = this.viewState.measure(this);
        if (!a && !this.measureRequests.length && this.viewState.scrollTarget == null)
          break;
        if (l > 5) {
          console.warn(this.measureRequests.length ? "Measure loop restarted more than 5 times" : "Viewport failed to stabilize");
          break;
        }
        let u = [];
        a & 4 || ([this.measureRequests, u] = [u, this.measureRequests]);
        let c = u.map((d) => {
          try {
            return d.read(this);
          } catch (p) {
            return Je(this.state, p), Bu;
          }
        }), h = os.create(this, this.state, []), f = !1;
        h.flags |= a, t ? t.flags |= a : t = h, this.updateState = 2, h.empty || (this.updatePlugins(h), this.inputState.update(h), this.updateAttrs(), f = this.docView.update(h), f && this.docViewUpdate());
        for (let d = 0; d < u.length; d++)
          if (c[d] != Bu)
            try {
              let p = u[d];
              p.write && p.write(c[d], this);
            } catch (p) {
              Je(this.state, p);
            }
        if (f && this.docView.updateSelection(!0), !h.viewportChanged && this.measureRequests.length == 0) {
          if (this.viewState.editorHeight)
            if (this.viewState.scrollTarget) {
              this.docView.scrollIntoView(this.viewState.scrollTarget), this.viewState.scrollTarget = null, o = -1;
              continue;
            } else {
              let p = (s < 0 ? this.viewState.heightMap.height : this.viewState.lineBlockAt(s).top) - o;
              if (p > 1 || p < -1) {
                r = r + p, i.scrollTop = r / this.scaleY, o = -1;
                continue;
              }
            }
          break;
        }
      }
    } finally {
      this.updateState = 0, this.measureScheduled = -1;
    }
    if (t && !t.empty)
      for (let l of this.state.facet(ml))
        l(t);
  }
  /**
  Get the CSS classes for the currently active editor themes.
  */
  get themeClasses() {
    return wl + " " + (this.state.facet(xl) ? Nf : Rf) + " " + this.state.facet(Sr);
  }
  updateAttrs() {
    let e = Ru(this, bf, {
      class: "cm-editor" + (this.hasFocus ? " cm-focused " : " ") + this.themeClasses
    }), t = {
      spellcheck: "false",
      autocorrect: "off",
      autocapitalize: "off",
      translate: "no",
      contenteditable: this.state.facet(Rs) ? "true" : "false",
      class: "cm-content",
      style: `${$.tabSize}: ${this.state.tabSize}`,
      role: "textbox",
      "aria-multiline": "true"
    };
    this.state.readOnly && (t["aria-readonly"] = "true"), Ru(this, sa, t);
    let i = this.observer.ignore(() => {
      let r = cl(this.contentDOM, this.contentAttrs, t), s = cl(this.dom, this.editorAttrs, e);
      return r || s;
    });
    return this.editorAttrs = e, this.contentAttrs = t, i;
  }
  showAnnouncements(e) {
    let t = !0;
    for (let i of e)
      for (let r of i.effects)
        if (r.is(V.announce)) {
          t && (this.announceDOM.textContent = ""), t = !1;
          let s = this.announceDOM.appendChild(document.createElement("div"));
          s.textContent = r.value;
        }
  }
  mountStyles() {
    this.styleModules = this.state.facet(Li);
    let e = this.state.facet(V.cspNonce);
    pn.mount(this.root, this.styleModules.concat(S0).reverse(), e ? { nonce: e } : void 0);
  }
  readMeasured() {
    if (this.updateState == 2)
      throw new Error("Reading the editor layout isn't allowed during an update");
    this.updateState == 0 && this.measureScheduled > -1 && this.measure(!1);
  }
  /**
  Schedule a layout measurement, optionally providing callbacks to
  do custom DOM measuring followed by a DOM write phase. Using
  this is preferable reading DOM layout directly from, for
  example, an event handler, because it'll make sure measuring and
  drawing done by other components is synchronized, avoiding
  unnecessary DOM layout computations.
  */
  requestMeasure(e) {
    if (this.measureScheduled < 0 && (this.measureScheduled = this.win.requestAnimationFrame(() => this.measure())), e) {
      if (this.measureRequests.indexOf(e) > -1)
        return;
      if (e.key != null) {
        for (let t = 0; t < this.measureRequests.length; t++)
          if (this.measureRequests[t].key === e.key) {
            this.measureRequests[t] = e;
            return;
          }
      }
      this.measureRequests.push(e);
    }
  }
  /**
  Get the value of a specific plugin, if present. Note that
  plugins that crash can be dropped from a view, so even when you
  know you registered a given plugin, it is recommended to check
  the return value of this method.
  */
  plugin(e) {
    let t = this.pluginMap.get(e);
    return (t === void 0 || t && t.spec != e) && this.pluginMap.set(e, t = this.plugins.find((i) => i.spec == e) || null), t && t.update(this).value;
  }
  /**
  The top position of the document, in screen coordinates. This
  may be negative when the editor is scrolled down. Points
  directly to the top of the first line, not above the padding.
  */
  get documentTop() {
    return this.contentDOM.getBoundingClientRect().top + this.viewState.paddingTop;
  }
  /**
  Reports the padding above and below the document.
  */
  get documentPadding() {
    return { top: this.viewState.paddingTop, bottom: this.viewState.paddingBottom };
  }
  /**
  If the editor is transformed with CSS, this provides the scale
  along the X axis. Otherwise, it will just be 1. Note that
  transforms other than translation and scaling are not supported.
  */
  get scaleX() {
    return this.viewState.scaleX;
  }
  /**
  Provide the CSS transformed scale along the Y axis.
  */
  get scaleY() {
    return this.viewState.scaleY;
  }
  /**
  Find the text line or block widget at the given vertical
  position (which is interpreted as relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop)).
  */
  elementAtHeight(e) {
    return this.readMeasured(), this.viewState.elementAtHeight(e);
  }
  /**
  Find the line block (see
  [`lineBlockAt`](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) at the given
  height, again interpreted relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop).
  */
  lineBlockAtHeight(e) {
    return this.readMeasured(), this.viewState.lineBlockAtHeight(e);
  }
  /**
  Get the extent and vertical position of all [line
  blocks](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) in the viewport. Positions
  are relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop);
  */
  get viewportLineBlocks() {
    return this.viewState.viewportLines;
  }
  /**
  Find the line block around the given document position. A line
  block is a range delimited on both sides by either a
  non-[hidden](https://codemirror.net/6/docs/ref/#view.Decoration^replace) line breaks, or the
  start/end of the document. It will usually just hold a line of
  text, but may be broken into multiple textblocks by block
  widgets.
  */
  lineBlockAt(e) {
    return this.viewState.lineBlockAt(e);
  }
  /**
  The editor's total content height.
  */
  get contentHeight() {
    return this.viewState.contentHeight;
  }
  /**
  Move a cursor position by [grapheme
  cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak). `forward` determines whether
  the motion is away from the line start, or towards it. In
  bidirectional text, the line is traversed in visual order, using
  the editor's [text direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection).
  When the start position was the last one on the line, the
  returned position will be across the line break. If there is no
  further line, the original position is returned.
  
  By default, this method moves over a single cluster. The
  optional `by` argument can be used to move across more. It will
  be called with the first cluster as argument, and should return
  a predicate that determines, for each subsequent cluster,
  whether it should also be moved over.
  */
  moveByChar(e, t, i) {
    return oo(this, e, yu(this, e, t, i));
  }
  /**
  Move a cursor position across the next group of either
  [letters](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) or non-letter
  non-whitespace characters.
  */
  moveByGroup(e, t) {
    return oo(this, e, yu(this, e, t, (i) => Ug(this, e.head, i)));
  }
  /**
  Get the cursor position visually at the start or end of a line.
  Note that this may differ from the _logical_ position at its
  start or end (which is simply at `line.from`/`line.to`) if text
  at the start or end goes against the line's base text direction.
  */
  visualLineSide(e, t) {
    let i = this.bidiSpans(e), r = this.textDirectionAt(e.from), s = i[t ? i.length - 1 : 0];
    return T.cursor(s.side(t, r) + e.from, s.forward(!t, r) ? 1 : -1);
  }
  /**
  Move to the next line boundary in the given direction. If
  `includeWrap` is true, line wrapping is on, and there is a
  further wrap point on the current line, the wrap point will be
  returned. Otherwise this function will return the start or end
  of the line.
  */
  moveToLineBoundary(e, t, i = !0) {
    return qg(this, e, t, i);
  }
  /**
  Move a cursor position vertically. When `distance` isn't given,
  it defaults to moving to the next line (including wrapped
  lines). Otherwise, `distance` should provide a positive distance
  in pixels.
  
  When `start` has a
  [`goalColumn`](https://codemirror.net/6/docs/ref/#state.SelectionRange.goalColumn), the vertical
  motion will use that as a target horizontal position. Otherwise,
  the cursor's own horizontal position is used. The returned
  cursor will have its goal column set to whichever column was
  used.
  */
  moveVertically(e, t, i) {
    return oo(this, e, Kg(this, e, t, i));
  }
  /**
  Find the DOM parent node and offset (child offset if `node` is
  an element, character offset when it is a text node) at the
  given document position.
  
  Note that for positions that aren't currently in
  `visibleRanges`, the resulting DOM position isn't necessarily
  meaningful (it may just point before or after a placeholder
  element).
  */
  domAtPos(e) {
    return this.docView.domAtPos(e);
  }
  /**
  Find the document position at the given DOM node. Can be useful
  for associating positions with DOM events. Will raise an error
  when `node` isn't part of the editor content.
  */
  posAtDOM(e, t = 0) {
    return this.docView.posFromDOM(e, t);
  }
  posAtCoords(e, t = !0) {
    return this.readMeasured(), Cf(this, e, t);
  }
  /**
  Get the screen coordinates at the given document position.
  `side` determines whether the coordinates are based on the
  element before (-1) or after (1) the position (if no element is
  available on the given side, the method will transparently use
  another strategy to get reasonable coordinates).
  */
  coordsAtPos(e, t = 1) {
    this.readMeasured();
    let i = this.docView.coordsAt(e, t);
    if (!i || i.left == i.right)
      return i;
    let r = this.state.doc.lineAt(e), s = this.bidiSpans(r), o = s[an.find(s, e - r.from, -1, t)];
    return Ps(i, o.dir == ye.LTR == t > 0);
  }
  /**
  Return the rectangle around a given character. If `pos` does not
  point in front of a character that is in the viewport and
  rendered (i.e. not replaced, not a line break), this will return
  null. For space characters that are a line wrap point, this will
  return the position before the line break.
  */
  coordsForChar(e) {
    return this.readMeasured(), this.docView.coordsForChar(e);
  }
  /**
  The default width of a character in the editor. May not
  accurately reflect the width of all characters (given variable
  width fonts or styling of invididual ranges).
  */
  get defaultCharacterWidth() {
    return this.viewState.heightOracle.charWidth;
  }
  /**
  The default height of a line in the editor. May not be accurate
  for all lines.
  */
  get defaultLineHeight() {
    return this.viewState.heightOracle.lineHeight;
  }
  /**
  The text direction
  ([`direction`](https://developer.mozilla.org/en-US/docs/Web/CSS/direction)
  CSS property) of the editor's content element.
  */
  get textDirection() {
    return this.viewState.defaultTextDirection;
  }
  /**
  Find the text direction of the block at the given position, as
  assigned by CSS. If
  [`perLineTextDirection`](https://codemirror.net/6/docs/ref/#view.EditorView^perLineTextDirection)
  isn't enabled, or the given position is outside of the viewport,
  this will always return the same as
  [`textDirection`](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection). Note that
  this may trigger a DOM layout.
  */
  textDirectionAt(e) {
    return !this.state.facet(mf) || e < this.viewport.from || e > this.viewport.to ? this.textDirection : (this.readMeasured(), this.docView.textDirectionAt(e));
  }
  /**
  Whether this editor [wraps lines](https://codemirror.net/6/docs/ref/#view.EditorView.lineWrapping)
  (as determined by the
  [`white-space`](https://developer.mozilla.org/en-US/docs/Web/CSS/white-space)
  CSS property of its content element).
  */
  get lineWrapping() {
    return this.viewState.heightOracle.lineWrapping;
  }
  /**
  Returns the bidirectional text structure of the given line
  (which should be in the current document) as an array of span
  objects. The order of these spans matches the [text
  direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection)—if that is
  left-to-right, the leftmost spans come first, otherwise the
  rightmost spans come first.
  */
  bidiSpans(e) {
    if (e.length > B0)
      return lf(e.length);
    let t = this.textDirectionAt(e.from), i;
    for (let s of this.bidiCache)
      if (s.from == e.from && s.dir == t && (s.fresh || of(s.isolates, i = cu(this, e))))
        return s.order;
    i || (i = cu(this, e));
    let r = Dg(e.text, t, i);
    return this.bidiCache.push(new ls(e.from, e.to, t, i, !0, r)), r;
  }
  /**
  Check whether the editor has focus.
  */
  get hasFocus() {
    var e;
    return (this.dom.ownerDocument.hasFocus() || $.safari && ((e = this.inputState) === null || e === void 0 ? void 0 : e.lastContextMenu) > Date.now() - 3e4) && this.root.activeElement == this.contentDOM;
  }
  /**
  Put focus on the editor.
  */
  focus() {
    this.observer.ignore(() => {
      jh(this.contentDOM), this.docView.updateSelection();
    });
  }
  /**
  Update the [root](https://codemirror.net/6/docs/ref/##view.EditorViewConfig.root) in which the editor lives. This is only
  necessary when moving the editor's existing DOM to a new window or shadow root.
  */
  setRoot(e) {
    this._root != e && (this._root = e, this.observer.setWindow((e.nodeType == 9 ? e : e.ownerDocument).defaultView || window), this.mountStyles());
  }
  /**
  Clean up this editor view, removing its element from the
  document, unregistering event handlers, and notifying
  plugins. The view instance can no longer be used after
  calling this.
  */
  destroy() {
    for (let e of this.plugins)
      e.destroy(this);
    this.plugins = [], this.inputState.destroy(), this.docView.destroy(), this.dom.remove(), this.observer.destroy(), this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.destroyed = !0;
  }
  /**
  Returns an effect that can be
  [added](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) to a transaction to
  cause it to scroll the given position or range into view.
  */
  static scrollIntoView(e, t = {}) {
    return yr.of(new ei(typeof e == "number" ? T.cursor(e) : e, t.y, t.x, t.yMargin, t.xMargin));
  }
  /**
  Return an effect that resets the editor to its current (at the
  time this method was called) scroll position. Note that this
  only affects the editor's own scrollable element, not parents.
  See also
  [`EditorViewConfig.scrollTo`](https://codemirror.net/6/docs/ref/#view.EditorViewConfig.scrollTo).
  
  The effect should be used with a document identical to the one
  it was created for. Failing to do so is not an error, but may
  not scroll to the expected position. You can
  [map](https://codemirror.net/6/docs/ref/#state.StateEffect.map) the effect to account for changes.
  */
  scrollSnapshot() {
    let { scrollTop: e, scrollLeft: t } = this.scrollDOM, i = this.viewState.scrollAnchorAt(e);
    return yr.of(new ei(T.cursor(i.from), "start", "start", i.top - e, t, !0));
  }
  /**
  Returns an extension that can be used to add DOM event handlers.
  The value should be an object mapping event names to handler
  functions. For any given event, such functions are ordered by
  extension precedence, and the first handler to return true will
  be assumed to have handled that event, and no other handlers or
  built-in behavior will be activated for it. These are registered
  on the [content element](https://codemirror.net/6/docs/ref/#view.EditorView.contentDOM), except
  for `scroll` handlers, which will be called any time the
  editor's [scroll element](https://codemirror.net/6/docs/ref/#view.EditorView.scrollDOM) or one of
  its parent nodes is scrolled.
  */
  static domEventHandlers(e) {
    return ke.define(() => ({}), { eventHandlers: e });
  }
  /**
  Create an extension that registers DOM event observers. Contrary
  to event [handlers](https://codemirror.net/6/docs/ref/#view.EditorView^domEventHandlers),
  observers can't be prevented from running by a higher-precedence
  handler returning true. They also don't prevent other handlers
  and observers from running when they return true, and should not
  call `preventDefault`.
  */
  static domEventObservers(e) {
    return ke.define(() => ({}), { eventObservers: e });
  }
  /**
  Create a theme extension. The first argument can be a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)
  style spec providing the styles for the theme. These will be
  prefixed with a generated class for the style.
  
  Because the selectors will be prefixed with a scope class, rule
  that directly match the editor's [wrapper
  element](https://codemirror.net/6/docs/ref/#view.EditorView.dom)—to which the scope class will be
  added—need to be explicitly differentiated by adding an `&` to
  the selector for that element—for example
  `&.cm-focused`.
  
  When `dark` is set to true, the theme will be marked as dark,
  which will cause the `&dark` rules from [base
  themes](https://codemirror.net/6/docs/ref/#view.EditorView^baseTheme) to be used (as opposed to
  `&light` when a light theme is active).
  */
  static theme(e, t) {
    let i = pn.newName(), r = [Sr.of(i), Li.of(kl(`.${i}`, e))];
    return t && t.dark && r.push(xl.of(!0)), r;
  }
  /**
  Create an extension that adds styles to the base theme. Like
  with [`theme`](https://codemirror.net/6/docs/ref/#view.EditorView^theme), use `&` to indicate the
  place of the editor wrapper element when directly targeting
  that. You can also use `&dark` or `&light` instead to only
  target editors with a dark or light theme.
  */
  static baseTheme(e) {
    return Hn.lowest(Li.of(kl("." + wl, e, Ff)));
  }
  /**
  Retrieve an editor view instance from the view's DOM
  representation.
  */
  static findFromDOM(e) {
    var t;
    let i = e.querySelector(".cm-content"), r = i && he.get(i) || he.get(e);
    return ((t = r == null ? void 0 : r.rootView) === null || t === void 0 ? void 0 : t.view) || null;
  }
}
V.styleModule = Li;
V.inputHandler = df;
V.scrollHandler = yf;
V.focusChangeEffect = pf;
V.perLineTextDirection = mf;
V.exceptionSink = ff;
V.updateListener = ml;
V.editable = Rs;
V.mouseSelectionStyle = hf;
V.dragMovesSelection = cf;
V.clickAddsSelectionRange = uf;
V.decorations = Gi;
V.outerDecorations = xf;
V.atomicRanges = oa;
V.bidiIsolatedRanges = wf;
V.scrollMargins = kf;
V.darkTheme = xl;
V.cspNonce = /* @__PURE__ */ j.define({ combine: (n) => n.length ? n[0] : "" });
V.contentAttributes = sa;
V.editorAttributes = bf;
V.lineWrapping = /* @__PURE__ */ V.contentAttributes.of({ class: "cm-lineWrapping" });
V.announce = /* @__PURE__ */ X.define();
const B0 = 4096, Bu = {};
class ls {
  constructor(e, t, i, r, s, o) {
    this.from = e, this.to = t, this.dir = i, this.isolates = r, this.fresh = s, this.order = o;
  }
  static update(e, t) {
    if (t.empty && !e.some((s) => s.fresh))
      return e;
    let i = [], r = e.length ? e[e.length - 1].dir : ye.LTR;
    for (let s = Math.max(0, e.length - 10); s < e.length; s++) {
      let o = e[s];
      o.dir == r && !t.touchesRange(o.from, o.to) && i.push(new ls(t.mapPos(o.from, 1), t.mapPos(o.to, -1), o.dir, o.isolates, !1, o.order));
    }
    return i;
  }
}
function Ru(n, e, t) {
  for (let i = n.state.facet(e), r = i.length - 1; r >= 0; r--) {
    let s = i[r], o = typeof s == "function" ? s(n) : s;
    o && ul(o, t);
  }
  return t;
}
const R0 = $.mac ? "mac" : $.windows ? "win" : $.linux ? "linux" : "key";
function N0(n, e) {
  const t = n.split(/-(?!$)/);
  let i = t[t.length - 1];
  i == "Space" && (i = " ");
  let r, s, o, l;
  for (let a = 0; a < t.length - 1; ++a) {
    const u = t[a];
    if (/^(cmd|meta|m)$/i.test(u))
      l = !0;
    else if (/^a(lt)?$/i.test(u))
      r = !0;
    else if (/^(c|ctrl|control)$/i.test(u))
      s = !0;
    else if (/^s(hift)?$/i.test(u))
      o = !0;
    else if (/^mod$/i.test(u))
      e == "mac" ? l = !0 : s = !0;
    else
      throw new Error("Unrecognized modifier name: " + u);
  }
  return r && (i = "Alt-" + i), s && (i = "Ctrl-" + i), l && (i = "Meta-" + i), o && (i = "Shift-" + i), i;
}
function Cr(n, e, t) {
  return e.altKey && (n = "Alt-" + n), e.ctrlKey && (n = "Ctrl-" + n), e.metaKey && (n = "Meta-" + n), t !== !1 && e.shiftKey && (n = "Shift-" + n), n;
}
const F0 = /* @__PURE__ */ Hn.default(/* @__PURE__ */ V.domEventHandlers({
  keydown(n, e) {
    return Vf(Hf(e.state), n, e, "editor");
  }
})), Ns = /* @__PURE__ */ j.define({ enables: F0 }), Nu = /* @__PURE__ */ new WeakMap();
function Hf(n) {
  let e = n.facet(Ns), t = Nu.get(e);
  return t || Nu.set(e, t = V0(e.reduce((i, r) => i.concat(r), []))), t;
}
function z0(n, e, t) {
  return Vf(Hf(n.state), e, n, t);
}
let rn = null;
const H0 = 4e3;
function V0(n, e = R0) {
  let t = /* @__PURE__ */ Object.create(null), i = /* @__PURE__ */ Object.create(null), r = (o, l) => {
    let a = i[o];
    if (a == null)
      i[o] = l;
    else if (a != l)
      throw new Error("Key binding " + o + " is used both as a regular binding and as a multi-stroke prefix");
  }, s = (o, l, a, u, c) => {
    var h, f;
    let d = t[o] || (t[o] = /* @__PURE__ */ Object.create(null)), p = l.split(/ (?!$)/).map((y) => N0(y, e));
    for (let y = 1; y < p.length; y++) {
      let v = p.slice(0, y).join(" ");
      r(v, !0), d[v] || (d[v] = {
        preventDefault: !0,
        stopPropagation: !1,
        run: [(C) => {
          let O = rn = { view: C, prefix: v, scope: o };
          return setTimeout(() => {
            rn == O && (rn = null);
          }, H0), !0;
        }]
      });
    }
    let g = p.join(" ");
    r(g, !1);
    let m = d[g] || (d[g] = {
      preventDefault: !1,
      stopPropagation: !1,
      run: ((f = (h = d._any) === null || h === void 0 ? void 0 : h.run) === null || f === void 0 ? void 0 : f.slice()) || []
    });
    a && m.run.push(a), u && (m.preventDefault = !0), c && (m.stopPropagation = !0);
  };
  for (let o of n) {
    let l = o.scope ? o.scope.split(" ") : ["editor"];
    if (o.any)
      for (let u of l) {
        let c = t[u] || (t[u] = /* @__PURE__ */ Object.create(null));
        c._any || (c._any = { preventDefault: !1, stopPropagation: !1, run: [] });
        for (let h in c)
          c[h].run.push(o.any);
      }
    let a = o[e] || o.key;
    if (a)
      for (let u of l)
        s(u, a, o.run, o.preventDefault, o.stopPropagation), o.shift && s(u, "Shift-" + a, o.shift, o.preventDefault, o.stopPropagation);
  }
  return t;
}
function Vf(n, e, t, i) {
  let r = cg(e), s = Le(r, 0), o = ht(s) == r.length && r != " ", l = "", a = !1, u = !1, c = !1;
  rn && rn.view == t && rn.scope == i && (l = rn.prefix + " ", Mf.indexOf(e.keyCode) < 0 && (u = !0, rn = null));
  let h = /* @__PURE__ */ new Set(), f = (m) => {
    if (m) {
      for (let y of m.run)
        if (!h.has(y) && (h.add(y), y(t, e)))
          return m.stopPropagation && (c = !0), !0;
      m.preventDefault && (m.stopPropagation && (c = !0), u = !0);
    }
    return !1;
  }, d = n[i], p, g;
  return d && (f(d[l + Cr(r, e, !o)]) ? a = !0 : o && (e.altKey || e.metaKey || e.ctrlKey) && // Ctrl-Alt may be used for AltGr on Windows
  !($.windows && e.ctrlKey && e.altKey) && (p = mn[e.keyCode]) && p != r ? (f(d[l + Cr(p, e, !0)]) || e.shiftKey && (g = Ki[e.keyCode]) != r && g != p && f(d[l + Cr(g, e, !1)])) && (a = !0) : o && e.shiftKey && f(d[l + Cr(r, e, !0)]) && (a = !0), !a && f(d._any) && (a = !0)), u && (a = !0), a && c && e.stopPropagation(), a;
}
class or {
  /**
  Create a marker with the given class and dimensions. If `width`
  is null, the DOM element will get no width style.
  */
  constructor(e, t, i, r, s) {
    this.className = e, this.left = t, this.top = i, this.width = r, this.height = s;
  }
  draw() {
    let e = document.createElement("div");
    return e.className = this.className, this.adjust(e), e;
  }
  update(e, t) {
    return t.className != this.className ? !1 : (this.adjust(e), !0);
  }
  adjust(e) {
    e.style.left = this.left + "px", e.style.top = this.top + "px", this.width != null && (e.style.width = this.width + "px"), e.style.height = this.height + "px";
  }
  eq(e) {
    return this.left == e.left && this.top == e.top && this.width == e.width && this.height == e.height && this.className == e.className;
  }
  /**
  Create a set of rectangles for the given selection range,
  assigning them theclass`className`. Will create a single
  rectangle for empty ranges, and a set of selection-style
  rectangles covering the range's content (in a bidi-aware
  way) for non-empty ones.
  */
  static forRange(e, t, i) {
    if (i.empty) {
      let r = e.coordsAtPos(i.head, i.assoc || 1);
      if (!r)
        return [];
      let s = _f(e);
      return [new or(t, r.left - s.left, r.top - s.top, null, r.bottom - r.top)];
    } else
      return _0(e, t, i);
  }
}
function _f(n) {
  let e = n.scrollDOM.getBoundingClientRect();
  return { left: (n.textDirection == ye.LTR ? e.left : e.right - n.scrollDOM.clientWidth * n.scaleX) - n.scrollDOM.scrollLeft * n.scaleX, top: e.top - n.scrollDOM.scrollTop * n.scaleY };
}
function Fu(n, e, t) {
  let i = T.cursor(e);
  return {
    from: Math.max(t.from, n.moveToLineBoundary(i, !1, !0).from),
    to: Math.min(t.to, n.moveToLineBoundary(i, !0, !0).from),
    type: Ke.Text
  };
}
function _0(n, e, t) {
  if (t.to <= n.viewport.from || t.from >= n.viewport.to)
    return [];
  let i = Math.max(t.from, n.viewport.from), r = Math.min(t.to, n.viewport.to), s = n.textDirection == ye.LTR, o = n.contentDOM, l = o.getBoundingClientRect(), a = _f(n), u = o.querySelector(".cm-line"), c = u && window.getComputedStyle(u), h = l.left + (c ? parseInt(c.paddingLeft) + Math.min(0, parseInt(c.textIndent)) : 0), f = l.right - (c ? parseInt(c.paddingRight) : 0), d = yl(n, i), p = yl(n, r), g = d.type == Ke.Text ? d : null, m = p.type == Ke.Text ? p : null;
  if (g && (n.lineWrapping || d.widgetLineBreaks) && (g = Fu(n, i, g)), m && (n.lineWrapping || p.widgetLineBreaks) && (m = Fu(n, r, m)), g && m && g.from == m.from)
    return v(C(t.from, t.to, g));
  {
    let A = g ? C(t.from, null, g) : O(d, !1), b = m ? C(null, t.to, m) : O(p, !0), S = [];
    return (g || d).to < (m || p).from - (g && m ? 1 : 0) || d.widgetLineBreaks > 1 && A.bottom + n.defaultLineHeight / 2 < b.top ? S.push(y(h, A.bottom, f, b.top)) : A.bottom < b.top && n.elementAtHeight((A.bottom + b.top) / 2).type == Ke.Text && (A.bottom = b.top = (A.bottom + b.top) / 2), v(A).concat(S).concat(v(b));
  }
  function y(A, b, S, L) {
    return new or(
      e,
      A - a.left,
      b - a.top - 0.01,
      S - A,
      L - b + 0.01
      /* C.Epsilon */
    );
  }
  function v({ top: A, bottom: b, horizontal: S }) {
    let L = [];
    for (let P = 0; P < S.length; P += 2)
      L.push(y(S[P], A, S[P + 1], b));
    return L;
  }
  function C(A, b, S) {
    let L = 1e9, P = -1e9, k = [];
    function M(_, z, K, U, ne) {
      let ue = n.coordsAtPos(_, _ == S.to ? -2 : 2), x = n.coordsAtPos(K, K == S.from ? 2 : -2);
      !ue || !x || (L = Math.min(ue.top, x.top, L), P = Math.max(ue.bottom, x.bottom, P), ne == ye.LTR ? k.push(s && z ? h : ue.left, s && U ? f : x.right) : k.push(!s && U ? h : x.left, !s && z ? f : ue.right));
    }
    let D = A ?? S.from, R = b ?? S.to;
    for (let _ of n.visibleRanges)
      if (_.to > D && _.from < R)
        for (let z = Math.max(_.from, D), K = Math.min(_.to, R); ; ) {
          let U = n.state.doc.lineAt(z);
          for (let ne of n.bidiSpans(U)) {
            let ue = ne.from + U.from, x = ne.to + U.from;
            if (ue >= K)
              break;
            x > z && M(Math.max(ue, z), A == null && ue <= D, Math.min(x, K), b == null && x >= R, ne.dir);
          }
          if (z = U.to + 1, z >= K)
            break;
        }
    return k.length == 0 && M(D, A == null, R, b == null, n.textDirection), { top: L, bottom: P, horizontal: k };
  }
  function O(A, b) {
    let S = l.top + (b ? A.top : A.bottom);
    return { top: S, bottom: S, horizontal: [] };
  }
}
function $0(n, e) {
  return n.constructor == e.constructor && n.eq(e);
}
class j0 {
  constructor(e, t) {
    this.view = e, this.layer = t, this.drawn = [], this.scaleX = 1, this.scaleY = 1, this.measureReq = { read: this.measure.bind(this), write: this.draw.bind(this) }, this.dom = e.scrollDOM.appendChild(document.createElement("div")), this.dom.classList.add("cm-layer"), t.above && this.dom.classList.add("cm-layer-above"), t.class && this.dom.classList.add(t.class), this.scale(), this.dom.setAttribute("aria-hidden", "true"), this.setOrder(e.state), e.requestMeasure(this.measureReq), t.mount && t.mount(this.dom, e);
  }
  update(e) {
    e.startState.facet(Yr) != e.state.facet(Yr) && this.setOrder(e.state), (this.layer.update(e, this.dom) || e.geometryChanged) && (this.scale(), e.view.requestMeasure(this.measureReq));
  }
  docViewUpdate(e) {
    this.layer.updateOnDocViewUpdate !== !1 && e.requestMeasure(this.measureReq);
  }
  setOrder(e) {
    let t = 0, i = e.facet(Yr);
    for (; t < i.length && i[t] != this.layer; )
      t++;
    this.dom.style.zIndex = String((this.layer.above ? 150 : -1) - t);
  }
  measure() {
    return this.layer.markers(this.view);
  }
  scale() {
    let { scaleX: e, scaleY: t } = this.view;
    (e != this.scaleX || t != this.scaleY) && (this.scaleX = e, this.scaleY = t, this.dom.style.transform = `scale(${1 / e}, ${1 / t})`);
  }
  draw(e) {
    if (e.length != this.drawn.length || e.some((t, i) => !$0(t, this.drawn[i]))) {
      let t = this.dom.firstChild, i = 0;
      for (let r of e)
        r.update && t && r.constructor && this.drawn[i].constructor && r.update(t, this.drawn[i]) ? (t = t.nextSibling, i++) : this.dom.insertBefore(r.draw(), t);
      for (; t; ) {
        let r = t.nextSibling;
        t.remove(), t = r;
      }
      this.drawn = e;
    }
  }
  destroy() {
    this.layer.destroy && this.layer.destroy(this.dom, this.view), this.dom.remove();
  }
}
const Yr = /* @__PURE__ */ j.define();
function $f(n) {
  return [
    ke.define((e) => new j0(e, n)),
    Yr.of(n)
  ];
}
const jf = !$.ios, Yi = /* @__PURE__ */ j.define({
  combine(n) {
    return Vt(n, {
      cursorBlinkRate: 1200,
      drawRangeCursor: !0
    }, {
      cursorBlinkRate: (e, t) => Math.min(e, t),
      drawRangeCursor: (e, t) => e || t
    });
  }
});
function W0(n = {}) {
  return [
    Yi.of(n),
    q0,
    U0,
    K0,
    gf.of(!0)
  ];
}
function Wf(n) {
  return n.startState.facet(Yi) != n.state.facet(Yi);
}
const q0 = /* @__PURE__ */ $f({
  above: !0,
  markers(n) {
    let { state: e } = n, t = e.facet(Yi), i = [];
    for (let r of e.selection.ranges) {
      let s = r == e.selection.main;
      if (r.empty ? !s || jf : t.drawRangeCursor) {
        let o = s ? "cm-cursor cm-cursor-primary" : "cm-cursor cm-cursor-secondary", l = r.empty ? r : T.cursor(r.head, r.head > r.anchor ? -1 : 1);
        for (let a of or.forRange(n, o, l))
          i.push(a);
      }
    }
    return i;
  },
  update(n, e) {
    n.transactions.some((i) => i.selection) && (e.style.animationName = e.style.animationName == "cm-blink" ? "cm-blink2" : "cm-blink");
    let t = Wf(n);
    return t && zu(n.state, e), n.docChanged || n.selectionSet || t;
  },
  mount(n, e) {
    zu(e.state, n);
  },
  class: "cm-cursorLayer"
});
function zu(n, e) {
  e.style.animationDuration = n.facet(Yi).cursorBlinkRate + "ms";
}
const U0 = /* @__PURE__ */ $f({
  above: !1,
  markers(n) {
    return n.state.selection.ranges.map((e) => e.empty ? [] : or.forRange(n, "cm-selectionBackground", e)).reduce((e, t) => e.concat(t));
  },
  update(n, e) {
    return n.docChanged || n.selectionSet || n.viewportChanged || Wf(n);
  },
  class: "cm-selectionLayer"
}), vl = {
  ".cm-line": {
    "& ::selection": { backgroundColor: "transparent !important" },
    "&::selection": { backgroundColor: "transparent !important" }
  }
};
jf && (vl[".cm-line"].caretColor = "transparent !important", vl[".cm-content"] = { caretColor: "transparent !important" });
const K0 = /* @__PURE__ */ Hn.highest(/* @__PURE__ */ V.theme(vl)), qf = /* @__PURE__ */ X.define({
  map(n, e) {
    return n == null ? null : e.mapPos(n);
  }
}), Bi = /* @__PURE__ */ Ne.define({
  create() {
    return null;
  },
  update(n, e) {
    return n != null && (n = e.changes.mapPos(n)), e.effects.reduce((t, i) => i.is(qf) ? i.value : t, n);
  }
}), G0 = /* @__PURE__ */ ke.fromClass(class {
  constructor(n) {
    this.view = n, this.cursor = null, this.measureReq = { read: this.readPos.bind(this), write: this.drawCursor.bind(this) };
  }
  update(n) {
    var e;
    let t = n.state.field(Bi);
    t == null ? this.cursor != null && ((e = this.cursor) === null || e === void 0 || e.remove(), this.cursor = null) : (this.cursor || (this.cursor = this.view.scrollDOM.appendChild(document.createElement("div")), this.cursor.className = "cm-dropCursor"), (n.startState.field(Bi) != t || n.docChanged || n.geometryChanged) && this.view.requestMeasure(this.measureReq));
  }
  readPos() {
    let { view: n } = this, e = n.state.field(Bi), t = e != null && n.coordsAtPos(e);
    if (!t)
      return null;
    let i = n.scrollDOM.getBoundingClientRect();
    return {
      left: t.left - i.left + n.scrollDOM.scrollLeft * n.scaleX,
      top: t.top - i.top + n.scrollDOM.scrollTop * n.scaleY,
      height: t.bottom - t.top
    };
  }
  drawCursor(n) {
    if (this.cursor) {
      let { scaleX: e, scaleY: t } = this.view;
      n ? (this.cursor.style.left = n.left / e + "px", this.cursor.style.top = n.top / t + "px", this.cursor.style.height = n.height / t + "px") : this.cursor.style.left = "-100000px";
    }
  }
  destroy() {
    this.cursor && this.cursor.remove();
  }
  setDropPos(n) {
    this.view.state.field(Bi) != n && this.view.dispatch({ effects: qf.of(n) });
  }
}, {
  eventObservers: {
    dragover(n) {
      this.setDropPos(this.view.posAtCoords({ x: n.clientX, y: n.clientY }));
    },
    dragleave(n) {
      (n.target == this.view.contentDOM || !this.view.contentDOM.contains(n.relatedTarget)) && this.setDropPos(null);
    },
    dragend() {
      this.setDropPos(null);
    },
    drop() {
      this.setDropPos(null);
    }
  }
});
function Y0() {
  return [Bi, G0];
}
function Hu(n, e, t, i, r) {
  e.lastIndex = 0;
  for (let s = n.iterRange(t, i), o = t, l; !s.next().done; o += s.value.length)
    if (!s.lineBreak)
      for (; l = e.exec(s.value); )
        r(o + l.index, l);
}
function X0(n, e) {
  let t = n.visibleRanges;
  if (t.length == 1 && t[0].from == n.viewport.from && t[0].to == n.viewport.to)
    return t;
  let i = [];
  for (let { from: r, to: s } of t)
    r = Math.max(n.state.doc.lineAt(r).from, r - e), s = Math.min(n.state.doc.lineAt(s).to, s + e), i.length && i[i.length - 1].to >= r ? i[i.length - 1].to = s : i.push({ from: r, to: s });
  return i;
}
class J0 {
  /**
  Create a decorator.
  */
  constructor(e) {
    const { regexp: t, decoration: i, decorate: r, boundary: s, maxLength: o = 1e3 } = e;
    if (!t.global)
      throw new RangeError("The regular expression given to MatchDecorator should have its 'g' flag set");
    if (this.regexp = t, r)
      this.addMatch = (l, a, u, c) => r(c, u, u + l[0].length, l, a);
    else if (typeof i == "function")
      this.addMatch = (l, a, u, c) => {
        let h = i(l, a, u);
        h && c(u, u + l[0].length, h);
      };
    else if (i)
      this.addMatch = (l, a, u, c) => c(u, u + l[0].length, i);
    else
      throw new RangeError("Either 'decorate' or 'decoration' should be provided to MatchDecorator");
    this.boundary = s, this.maxLength = o;
  }
  /**
  Compute the full set of decorations for matches in the given
  view's viewport. You'll want to call this when initializing your
  plugin.
  */
  createDeco(e) {
    let t = new dn(), i = t.add.bind(t);
    for (let { from: r, to: s } of X0(e, this.maxLength))
      Hu(e.state.doc, this.regexp, r, s, (o, l) => this.addMatch(l, e, o, i));
    return t.finish();
  }
  /**
  Update a set of decorations for a view update. `deco` _must_ be
  the set of decorations produced by _this_ `MatchDecorator` for
  the view state before the update.
  */
  updateDeco(e, t) {
    let i = 1e9, r = -1;
    return e.docChanged && e.changes.iterChanges((s, o, l, a) => {
      a > e.view.viewport.from && l < e.view.viewport.to && (i = Math.min(l, i), r = Math.max(a, r));
    }), e.viewportChanged || r - i > 1e3 ? this.createDeco(e.view) : r > -1 ? this.updateRange(e.view, t.map(e.changes), i, r) : t;
  }
  updateRange(e, t, i, r) {
    for (let s of e.visibleRanges) {
      let o = Math.max(s.from, i), l = Math.min(s.to, r);
      if (l > o) {
        let a = e.state.doc.lineAt(o), u = a.to < l ? e.state.doc.lineAt(l) : a, c = Math.max(s.from, a.from), h = Math.min(s.to, u.to);
        if (this.boundary) {
          for (; o > a.from; o--)
            if (this.boundary.test(a.text[o - 1 - a.from])) {
              c = o;
              break;
            }
          for (; l < u.to; l++)
            if (this.boundary.test(u.text[l - u.from])) {
              h = l;
              break;
            }
        }
        let f = [], d, p = (g, m, y) => f.push(y.range(g, m));
        if (a == u)
          for (this.regexp.lastIndex = c - a.from; (d = this.regexp.exec(a.text)) && d.index < h - a.from; )
            this.addMatch(d, e, d.index + a.from, p);
        else
          Hu(e.state.doc, this.regexp, c, h, (g, m) => this.addMatch(m, e, g, p));
        t = t.update({ filterFrom: c, filterTo: h, filter: (g, m) => g < c || m > h, add: f });
      }
    }
    return t;
  }
}
const Sl = /x/.unicode != null ? "gu" : "g", Q0 = /* @__PURE__ */ new RegExp(`[\0-\b
--­؜​‎‏\u2028\u2029‭‮⁦⁧⁩\uFEFF￹-￼]`, Sl), Z0 = {
  0: "null",
  7: "bell",
  8: "backspace",
  10: "newline",
  11: "vertical tab",
  13: "carriage return",
  27: "escape",
  8203: "zero width space",
  8204: "zero width non-joiner",
  8205: "zero width joiner",
  8206: "left-to-right mark",
  8207: "right-to-left mark",
  8232: "line separator",
  8237: "left-to-right override",
  8238: "right-to-left override",
  8294: "left-to-right isolate",
  8295: "right-to-left isolate",
  8297: "pop directional isolate",
  8233: "paragraph separator",
  65279: "zero width no-break space",
  65532: "object replacement"
};
let uo = null;
function e1() {
  var n;
  if (uo == null && typeof document < "u" && document.body) {
    let e = document.body.style;
    uo = ((n = e.tabSize) !== null && n !== void 0 ? n : e.MozTabSize) != null;
  }
  return uo || !1;
}
const Xr = /* @__PURE__ */ j.define({
  combine(n) {
    let e = Vt(n, {
      render: null,
      specialChars: Q0,
      addSpecialChars: null
    });
    return (e.replaceTabs = !e1()) && (e.specialChars = new RegExp("	|" + e.specialChars.source, Sl)), e.addSpecialChars && (e.specialChars = new RegExp(e.specialChars.source + "|" + e.addSpecialChars.source, Sl)), e;
  }
});
function t1(n = {}) {
  return [Xr.of(n), n1()];
}
let Vu = null;
function n1() {
  return Vu || (Vu = ke.fromClass(class {
    constructor(n) {
      this.view = n, this.decorations = q.none, this.decorationCache = /* @__PURE__ */ Object.create(null), this.decorator = this.makeDecorator(n.state.facet(Xr)), this.decorations = this.decorator.createDeco(n);
    }
    makeDecorator(n) {
      return new J0({
        regexp: n.specialChars,
        decoration: (e, t, i) => {
          let { doc: r } = t.state, s = Le(e[0], 0);
          if (s == 9) {
            let o = r.lineAt(i), l = t.state.tabSize, a = di(o.text, l, i - o.from);
            return q.replace({
              widget: new o1((l - a % l) * this.view.defaultCharacterWidth / this.view.scaleX)
            });
          }
          return this.decorationCache[s] || (this.decorationCache[s] = q.replace({ widget: new s1(n, s) }));
        },
        boundary: n.replaceTabs ? void 0 : /[^]/
      });
    }
    update(n) {
      let e = n.state.facet(Xr);
      n.startState.facet(Xr) != e ? (this.decorator = this.makeDecorator(e), this.decorations = this.decorator.createDeco(n.view)) : this.decorations = this.decorator.updateDeco(n, this.decorations);
    }
  }, {
    decorations: (n) => n.decorations
  }));
}
const i1 = "•";
function r1(n) {
  return n >= 32 ? i1 : n == 10 ? "␤" : String.fromCharCode(9216 + n);
}
class s1 extends Jt {
  constructor(e, t) {
    super(), this.options = e, this.code = t;
  }
  eq(e) {
    return e.code == this.code;
  }
  toDOM(e) {
    let t = r1(this.code), i = e.state.phrase("Control character") + " " + (Z0[this.code] || "0x" + this.code.toString(16)), r = this.options.render && this.options.render(this.code, i, t);
    if (r)
      return r;
    let s = document.createElement("span");
    return s.textContent = t, s.title = i, s.setAttribute("aria-label", i), s.className = "cm-specialChar", s;
  }
  ignoreEvent() {
    return !1;
  }
}
class o1 extends Jt {
  constructor(e) {
    super(), this.width = e;
  }
  eq(e) {
    return e.width == this.width;
  }
  toDOM() {
    let e = document.createElement("span");
    return e.textContent = "	", e.className = "cm-tab", e.style.width = this.width + "px", e;
  }
  ignoreEvent() {
    return !1;
  }
}
function l1() {
  return u1;
}
const a1 = /* @__PURE__ */ q.line({ class: "cm-activeLine" }), u1 = /* @__PURE__ */ ke.fromClass(class {
  constructor(n) {
    this.decorations = this.getDeco(n);
  }
  update(n) {
    (n.docChanged || n.selectionSet) && (this.decorations = this.getDeco(n.view));
  }
  getDeco(n) {
    let e = -1, t = [];
    for (let i of n.state.selection.ranges) {
      let r = n.lineBlockAt(i.head);
      r.from > e && (t.push(a1.range(r.from)), e = r.from);
    }
    return q.set(t);
  }
}, {
  decorations: (n) => n.decorations
});
class c1 extends Jt {
  constructor(e) {
    super(), this.content = e;
  }
  toDOM() {
    let e = document.createElement("span");
    return e.className = "cm-placeholder", e.style.pointerEvents = "none", e.appendChild(typeof this.content == "string" ? document.createTextNode(this.content) : this.content), typeof this.content == "string" ? e.setAttribute("aria-label", "placeholder " + this.content) : e.setAttribute("aria-hidden", "true"), e;
  }
  coordsAt(e) {
    let t = e.firstChild ? oi(e.firstChild) : [];
    if (!t.length)
      return null;
    let i = window.getComputedStyle(e.parentNode), r = Ps(t[0], i.direction != "rtl"), s = parseInt(i.lineHeight);
    return r.bottom - r.top > s * 1.5 ? { left: r.left, right: r.right, top: r.top, bottom: r.top + s } : r;
  }
  ignoreEvent() {
    return !1;
  }
}
function h1(n) {
  return ke.fromClass(class {
    constructor(e) {
      this.view = e, this.placeholder = n ? q.set([q.widget({ widget: new c1(n), side: 1 }).range(0)]) : q.none;
    }
    get decorations() {
      return this.view.state.doc.length ? q.none : this.placeholder;
    }
  }, { decorations: (e) => e.decorations });
}
const Cl = 2e3;
function f1(n, e, t) {
  let i = Math.min(e.line, t.line), r = Math.max(e.line, t.line), s = [];
  if (e.off > Cl || t.off > Cl || e.col < 0 || t.col < 0) {
    let o = Math.min(e.off, t.off), l = Math.max(e.off, t.off);
    for (let a = i; a <= r; a++) {
      let u = n.doc.line(a);
      u.length <= l && s.push(T.range(u.from + o, u.to + l));
    }
  } else {
    let o = Math.min(e.col, t.col), l = Math.max(e.col, t.col);
    for (let a = i; a <= r; a++) {
      let u = n.doc.line(a), c = nl(u.text, o, n.tabSize, !0);
      if (c < 0)
        s.push(T.cursor(u.to));
      else {
        let h = nl(u.text, l, n.tabSize);
        s.push(T.range(u.from + c, u.from + h));
      }
    }
  }
  return s;
}
function d1(n, e) {
  let t = n.coordsAtPos(n.viewport.from);
  return t ? Math.round(Math.abs((t.left - e) / n.defaultCharacterWidth)) : -1;
}
function _u(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), i = n.state.doc.lineAt(t), r = t - i.from, s = r > Cl ? -1 : r == i.length ? d1(n, e.clientX) : di(i.text, n.state.tabSize, t - i.from);
  return { line: i.number, col: s, off: r };
}
function p1(n, e) {
  let t = _u(n, e), i = n.state.selection;
  return t ? {
    update(r) {
      if (r.docChanged) {
        let s = r.changes.mapPos(r.startState.doc.line(t.line).from), o = r.state.doc.lineAt(s);
        t = { line: o.number, col: t.col, off: Math.min(t.off, o.length) }, i = i.map(r.changes);
      }
    },
    get(r, s, o) {
      let l = _u(n, r);
      if (!l)
        return i;
      let a = f1(n.state, t, l);
      return a.length ? o ? T.create(a.concat(i.ranges)) : T.create(a) : i;
    }
  } : null;
}
function m1(n) {
  let e = (t) => t.altKey && t.button == 0;
  return V.mouseSelectionStyle.of((t, i) => e(i) ? p1(t, i) : null);
}
const g1 = {
  Alt: [18, (n) => !!n.altKey],
  Control: [17, (n) => !!n.ctrlKey],
  Shift: [16, (n) => !!n.shiftKey],
  Meta: [91, (n) => !!n.metaKey]
}, y1 = { style: "cursor: crosshair" };
function b1(n = {}) {
  let [e, t] = g1[n.key || "Alt"], i = ke.fromClass(class {
    constructor(r) {
      this.view = r, this.isDown = !1;
    }
    set(r) {
      this.isDown != r && (this.isDown = r, this.view.update([]));
    }
  }, {
    eventObservers: {
      keydown(r) {
        this.set(r.keyCode == e || t(r));
      },
      keyup(r) {
        (r.keyCode == e || !t(r)) && this.set(!1);
      },
      mousemove(r) {
        this.set(t(r));
      }
    }
  });
  return [
    i,
    V.contentAttributes.of((r) => {
      var s;
      return !((s = r.plugin(i)) === null || s === void 0) && s.isDown ? y1 : null;
    })
  ];
}
const Si = "-10000px";
class Uf {
  constructor(e, t, i, r) {
    this.facet = t, this.createTooltipView = i, this.removeTooltipView = r, this.input = e.state.facet(t), this.tooltips = this.input.filter((o) => o);
    let s = null;
    this.tooltipViews = this.tooltips.map((o) => s = i(o, s));
  }
  update(e, t) {
    var i;
    let r = e.state.facet(this.facet), s = r.filter((a) => a);
    if (r === this.input) {
      for (let a of this.tooltipViews)
        a.update && a.update(e);
      return !1;
    }
    let o = [], l = t ? [] : null;
    for (let a = 0; a < s.length; a++) {
      let u = s[a], c = -1;
      if (u) {
        for (let h = 0; h < this.tooltips.length; h++) {
          let f = this.tooltips[h];
          f && f.create == u.create && (c = h);
        }
        if (c < 0)
          o[a] = this.createTooltipView(u, a ? o[a - 1] : null), l && (l[a] = !!u.above);
        else {
          let h = o[a] = this.tooltipViews[c];
          l && (l[a] = t[c]), h.update && h.update(e);
        }
      }
    }
    for (let a of this.tooltipViews)
      o.indexOf(a) < 0 && (this.removeTooltipView(a), (i = a.destroy) === null || i === void 0 || i.call(a));
    return t && (l.forEach((a, u) => t[u] = a), t.length = l.length), this.input = r, this.tooltips = s, this.tooltipViews = o, !0;
  }
}
function x1(n) {
  let { win: e } = n;
  return { top: 0, left: 0, bottom: e.innerHeight, right: e.innerWidth };
}
const co = /* @__PURE__ */ j.define({
  combine: (n) => {
    var e, t, i;
    return {
      position: $.ios ? "absolute" : ((e = n.find((r) => r.position)) === null || e === void 0 ? void 0 : e.position) || "fixed",
      parent: ((t = n.find((r) => r.parent)) === null || t === void 0 ? void 0 : t.parent) || null,
      tooltipSpace: ((i = n.find((r) => r.tooltipSpace)) === null || i === void 0 ? void 0 : i.tooltipSpace) || x1
    };
  }
}), $u = /* @__PURE__ */ new WeakMap(), aa = /* @__PURE__ */ ke.fromClass(class {
  constructor(n) {
    this.view = n, this.above = [], this.inView = !0, this.madeAbsolute = !1, this.lastTransaction = 0, this.measureTimeout = -1;
    let e = n.state.facet(co);
    this.position = e.position, this.parent = e.parent, this.classes = n.themeClasses, this.createContainer(), this.measureReq = { read: this.readMeasure.bind(this), write: this.writeMeasure.bind(this), key: this }, this.resizeObserver = typeof ResizeObserver == "function" ? new ResizeObserver(() => this.measureSoon()) : null, this.manager = new Uf(n, ua, (t, i) => this.createTooltip(t, i), (t) => {
      this.resizeObserver && this.resizeObserver.unobserve(t.dom), t.dom.remove();
    }), this.above = this.manager.tooltips.map((t) => !!t.above), this.intersectionObserver = typeof IntersectionObserver == "function" ? new IntersectionObserver((t) => {
      Date.now() > this.lastTransaction - 50 && t.length > 0 && t[t.length - 1].intersectionRatio < 1 && this.measureSoon();
    }, { threshold: [1] }) : null, this.observeIntersection(), n.win.addEventListener("resize", this.measureSoon = this.measureSoon.bind(this)), this.maybeMeasure();
  }
  createContainer() {
    this.parent ? (this.container = document.createElement("div"), this.container.style.position = "relative", this.container.className = this.view.themeClasses, this.parent.appendChild(this.container)) : this.container = this.view.dom;
  }
  observeIntersection() {
    if (this.intersectionObserver) {
      this.intersectionObserver.disconnect();
      for (let n of this.manager.tooltipViews)
        this.intersectionObserver.observe(n.dom);
    }
  }
  measureSoon() {
    this.measureTimeout < 0 && (this.measureTimeout = setTimeout(() => {
      this.measureTimeout = -1, this.maybeMeasure();
    }, 50));
  }
  update(n) {
    n.transactions.length && (this.lastTransaction = Date.now());
    let e = this.manager.update(n, this.above);
    e && this.observeIntersection();
    let t = e || n.geometryChanged, i = n.state.facet(co);
    if (i.position != this.position && !this.madeAbsolute) {
      this.position = i.position;
      for (let r of this.manager.tooltipViews)
        r.dom.style.position = this.position;
      t = !0;
    }
    if (i.parent != this.parent) {
      this.parent && this.container.remove(), this.parent = i.parent, this.createContainer();
      for (let r of this.manager.tooltipViews)
        this.container.appendChild(r.dom);
      t = !0;
    } else
      this.parent && this.view.themeClasses != this.classes && (this.classes = this.container.className = this.view.themeClasses);
    t && this.maybeMeasure();
  }
  createTooltip(n, e) {
    let t = n.create(this.view), i = e ? e.dom : null;
    if (t.dom.classList.add("cm-tooltip"), n.arrow && !t.dom.querySelector(".cm-tooltip > .cm-tooltip-arrow")) {
      let r = document.createElement("div");
      r.className = "cm-tooltip-arrow", t.dom.appendChild(r);
    }
    return t.dom.style.position = this.position, t.dom.style.top = Si, t.dom.style.left = "0px", this.container.insertBefore(t.dom, i), t.mount && t.mount(this.view), this.resizeObserver && this.resizeObserver.observe(t.dom), t;
  }
  destroy() {
    var n, e, t;
    this.view.win.removeEventListener("resize", this.measureSoon);
    for (let i of this.manager.tooltipViews)
      i.dom.remove(), (n = i.destroy) === null || n === void 0 || n.call(i);
    this.parent && this.container.remove(), (e = this.resizeObserver) === null || e === void 0 || e.disconnect(), (t = this.intersectionObserver) === null || t === void 0 || t.disconnect(), clearTimeout(this.measureTimeout);
  }
  readMeasure() {
    let n = this.view.dom.getBoundingClientRect(), e = 1, t = 1, i = !1;
    if (this.position == "fixed" && this.manager.tooltipViews.length) {
      let { dom: r } = this.manager.tooltipViews[0];
      if ($.gecko)
        i = r.offsetParent != this.container.ownerDocument.body;
      else if (r.style.top == Si && r.style.left == "0px") {
        let s = r.getBoundingClientRect();
        i = Math.abs(s.top + 1e4) > 1 || Math.abs(s.left) > 1;
      }
    }
    if (i || this.position == "absolute")
      if (this.parent) {
        let r = this.parent.getBoundingClientRect();
        r.width && r.height && (e = r.width / this.parent.offsetWidth, t = r.height / this.parent.offsetHeight);
      } else
        ({ scaleX: e, scaleY: t } = this.view.viewState);
    return {
      editor: n,
      parent: this.parent ? this.container.getBoundingClientRect() : n,
      pos: this.manager.tooltips.map((r, s) => {
        let o = this.manager.tooltipViews[s];
        return o.getCoords ? o.getCoords(r.pos) : this.view.coordsAtPos(r.pos);
      }),
      size: this.manager.tooltipViews.map(({ dom: r }) => r.getBoundingClientRect()),
      space: this.view.state.facet(co).tooltipSpace(this.view),
      scaleX: e,
      scaleY: t,
      makeAbsolute: i
    };
  }
  writeMeasure(n) {
    var e;
    if (n.makeAbsolute) {
      this.madeAbsolute = !0, this.position = "absolute";
      for (let l of this.manager.tooltipViews)
        l.dom.style.position = "absolute";
    }
    let { editor: t, space: i, scaleX: r, scaleY: s } = n, o = [];
    for (let l = 0; l < this.manager.tooltips.length; l++) {
      let a = this.manager.tooltips[l], u = this.manager.tooltipViews[l], { dom: c } = u, h = n.pos[l], f = n.size[l];
      if (!h || h.bottom <= Math.max(t.top, i.top) || h.top >= Math.min(t.bottom, i.bottom) || h.right < Math.max(t.left, i.left) - 0.1 || h.left > Math.min(t.right, i.right) + 0.1) {
        c.style.top = Si;
        continue;
      }
      let d = a.arrow ? u.dom.querySelector(".cm-tooltip-arrow") : null, p = d ? 7 : 0, g = f.right - f.left, m = (e = $u.get(u)) !== null && e !== void 0 ? e : f.bottom - f.top, y = u.offset || k1, v = this.view.textDirection == ye.LTR, C = f.width > i.right - i.left ? v ? i.left : i.right - f.width : v ? Math.min(h.left - (d ? 14 : 0) + y.x, i.right - g) : Math.max(i.left, h.left - g + (d ? 14 : 0) - y.x), O = this.above[l];
      !a.strictSide && (O ? h.top - (f.bottom - f.top) - y.y < i.top : h.bottom + (f.bottom - f.top) + y.y > i.bottom) && O == i.bottom - h.bottom > h.top - i.top && (O = this.above[l] = !O);
      let A = (O ? h.top - i.top : i.bottom - h.bottom) - p;
      if (A < m && u.resize !== !1) {
        if (A < this.view.defaultLineHeight) {
          c.style.top = Si;
          continue;
        }
        $u.set(u, m), c.style.height = (m = A) / s + "px";
      } else
        c.style.height && (c.style.height = "");
      let b = O ? h.top - m - p - y.y : h.bottom + p + y.y, S = C + g;
      if (u.overlap !== !0)
        for (let L of o)
          L.left < S && L.right > C && L.top < b + m && L.bottom > b && (b = O ? L.top - m - 2 - p : L.bottom + p + 2);
      if (this.position == "absolute" ? (c.style.top = (b - n.parent.top) / s + "px", c.style.left = (C - n.parent.left) / r + "px") : (c.style.top = b / s + "px", c.style.left = C / r + "px"), d) {
        let L = h.left + (v ? y.x : -y.x) - (C + 14 - 7);
        d.style.left = L / r + "px";
      }
      u.overlap !== !0 && o.push({ left: C, top: b, right: S, bottom: b + m }), c.classList.toggle("cm-tooltip-above", O), c.classList.toggle("cm-tooltip-below", !O), u.positioned && u.positioned(n.space);
    }
  }
  maybeMeasure() {
    if (this.manager.tooltips.length && (this.view.inView && this.view.requestMeasure(this.measureReq), this.inView != this.view.inView && (this.inView = this.view.inView, !this.inView)))
      for (let n of this.manager.tooltipViews)
        n.dom.style.top = Si;
  }
}, {
  eventObservers: {
    scroll() {
      this.maybeMeasure();
    }
  }
}), w1 = /* @__PURE__ */ V.baseTheme({
  ".cm-tooltip": {
    zIndex: 100,
    boxSizing: "border-box"
  },
  "&light .cm-tooltip": {
    border: "1px solid #bbb",
    backgroundColor: "#f5f5f5"
  },
  "&light .cm-tooltip-section:not(:first-child)": {
    borderTop: "1px solid #bbb"
  },
  "&dark .cm-tooltip": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tooltip-arrow": {
    height: "7px",
    width: `${7 * 2}px`,
    position: "absolute",
    zIndex: -1,
    overflow: "hidden",
    "&:before, &:after": {
      content: "''",
      position: "absolute",
      width: 0,
      height: 0,
      borderLeft: "7px solid transparent",
      borderRight: "7px solid transparent"
    },
    ".cm-tooltip-above &": {
      bottom: "-7px",
      "&:before": {
        borderTop: "7px solid #bbb"
      },
      "&:after": {
        borderTop: "7px solid #f5f5f5",
        bottom: "1px"
      }
    },
    ".cm-tooltip-below &": {
      top: "-7px",
      "&:before": {
        borderBottom: "7px solid #bbb"
      },
      "&:after": {
        borderBottom: "7px solid #f5f5f5",
        top: "1px"
      }
    }
  },
  "&dark .cm-tooltip .cm-tooltip-arrow": {
    "&:before": {
      borderTopColor: "#333338",
      borderBottomColor: "#333338"
    },
    "&:after": {
      borderTopColor: "transparent",
      borderBottomColor: "transparent"
    }
  }
}), k1 = { x: 0, y: 0 }, ua = /* @__PURE__ */ j.define({
  enables: [aa, w1]
}), as = /* @__PURE__ */ j.define({
  combine: (n) => n.reduce((e, t) => e.concat(t), [])
});
class Fs {
  // Needs to be static so that host tooltip instances always match
  static create(e) {
    return new Fs(e);
  }
  constructor(e) {
    this.view = e, this.mounted = !1, this.dom = document.createElement("div"), this.dom.classList.add("cm-tooltip-hover"), this.manager = new Uf(e, as, (t, i) => this.createHostedView(t, i), (t) => t.dom.remove());
  }
  createHostedView(e, t) {
    let i = e.create(this.view);
    return i.dom.classList.add("cm-tooltip-section"), this.dom.insertBefore(i.dom, t ? t.dom.nextSibling : this.dom.firstChild), this.mounted && i.mount && i.mount(this.view), i;
  }
  mount(e) {
    for (let t of this.manager.tooltipViews)
      t.mount && t.mount(e);
    this.mounted = !0;
  }
  positioned(e) {
    for (let t of this.manager.tooltipViews)
      t.positioned && t.positioned(e);
  }
  update(e) {
    this.manager.update(e);
  }
  destroy() {
    var e;
    for (let t of this.manager.tooltipViews)
      (e = t.destroy) === null || e === void 0 || e.call(t);
  }
  passProp(e) {
    let t;
    for (let i of this.manager.tooltipViews) {
      let r = i[e];
      if (r !== void 0) {
        if (t === void 0)
          t = r;
        else if (t !== r)
          return;
      }
    }
    return t;
  }
  get offset() {
    return this.passProp("offset");
  }
  get getCoords() {
    return this.passProp("getCoords");
  }
  get overlap() {
    return this.passProp("overlap");
  }
  get resize() {
    return this.passProp("resize");
  }
}
const v1 = /* @__PURE__ */ ua.compute([as], (n) => {
  let e = n.facet(as);
  return e.length === 0 ? null : {
    pos: Math.min(...e.map((t) => t.pos)),
    end: Math.max(...e.map((t) => {
      var i;
      return (i = t.end) !== null && i !== void 0 ? i : t.pos;
    })),
    create: Fs.create,
    above: e[0].above,
    arrow: e.some((t) => t.arrow)
  };
});
class S1 {
  constructor(e, t, i, r, s) {
    this.view = e, this.source = t, this.field = i, this.setHover = r, this.hoverTime = s, this.hoverTimeout = -1, this.restartTimeout = -1, this.pending = null, this.lastMove = { x: 0, y: 0, target: e.dom, time: 0 }, this.checkHover = this.checkHover.bind(this), e.dom.addEventListener("mouseleave", this.mouseleave = this.mouseleave.bind(this)), e.dom.addEventListener("mousemove", this.mousemove = this.mousemove.bind(this));
  }
  update() {
    this.pending && (this.pending = null, clearTimeout(this.restartTimeout), this.restartTimeout = setTimeout(() => this.startHover(), 20));
  }
  get active() {
    return this.view.state.field(this.field);
  }
  checkHover() {
    if (this.hoverTimeout = -1, this.active.length)
      return;
    let e = Date.now() - this.lastMove.time;
    e < this.hoverTime ? this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime - e) : this.startHover();
  }
  startHover() {
    clearTimeout(this.restartTimeout);
    let { view: e, lastMove: t } = this, i = e.docView.nearest(t.target);
    if (!i)
      return;
    let r, s = 1;
    if (i instanceof ln)
      r = i.posAtStart;
    else {
      if (r = e.posAtCoords(t), r == null)
        return;
      let l = e.coordsAtPos(r);
      if (!l || t.y < l.top || t.y > l.bottom || t.x < l.left - e.defaultCharacterWidth || t.x > l.right + e.defaultCharacterWidth)
        return;
      let a = e.bidiSpans(e.state.doc.lineAt(r)).find((c) => c.from <= r && c.to >= r), u = a && a.dir == ye.RTL ? -1 : 1;
      s = t.x < l.left ? -u : u;
    }
    let o = this.source(e, r, s);
    if (o != null && o.then) {
      let l = this.pending = { pos: r };
      o.then((a) => {
        this.pending == l && (this.pending = null, a && !(Array.isArray(a) && !a.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(a) ? a : [a]) }));
      }, (a) => Je(e.state, a, "hover tooltip"));
    } else
      o && !(Array.isArray(o) && !o.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(o) ? o : [o]) });
  }
  get tooltip() {
    let e = this.view.plugin(aa), t = e ? e.manager.tooltips.findIndex((i) => i.create == Fs.create) : -1;
    return t > -1 ? e.manager.tooltipViews[t] : null;
  }
  mousemove(e) {
    var t, i;
    this.lastMove = { x: e.clientX, y: e.clientY, target: e.target, time: Date.now() }, this.hoverTimeout < 0 && (this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime));
    let { active: r, tooltip: s } = this;
    if (r.length && s && !C1(s.dom, e) || this.pending) {
      let { pos: o } = r[0] || this.pending, l = (i = (t = r[0]) === null || t === void 0 ? void 0 : t.end) !== null && i !== void 0 ? i : o;
      (o == l ? this.view.posAtCoords(this.lastMove) != o : !A1(this.view, o, l, e.clientX, e.clientY)) && (this.view.dispatch({ effects: this.setHover.of([]) }), this.pending = null);
    }
  }
  mouseleave(e) {
    clearTimeout(this.hoverTimeout), this.hoverTimeout = -1;
    let { active: t } = this;
    if (t.length) {
      let { tooltip: i } = this;
      i && i.dom.contains(e.relatedTarget) ? this.watchTooltipLeave(i.dom) : this.view.dispatch({ effects: this.setHover.of([]) });
    }
  }
  watchTooltipLeave(e) {
    let t = (i) => {
      e.removeEventListener("mouseleave", t), this.active.length && !this.view.dom.contains(i.relatedTarget) && this.view.dispatch({ effects: this.setHover.of([]) });
    };
    e.addEventListener("mouseleave", t);
  }
  destroy() {
    clearTimeout(this.hoverTimeout), this.view.dom.removeEventListener("mouseleave", this.mouseleave), this.view.dom.removeEventListener("mousemove", this.mousemove);
  }
}
const Ar = 4;
function C1(n, e) {
  let t = n.getBoundingClientRect();
  return e.clientX >= t.left - Ar && e.clientX <= t.right + Ar && e.clientY >= t.top - Ar && e.clientY <= t.bottom + Ar;
}
function A1(n, e, t, i, r, s) {
  let o = n.scrollDOM.getBoundingClientRect(), l = n.documentTop + n.documentPadding.top + n.contentHeight;
  if (o.left > i || o.right < i || o.top > r || Math.min(o.bottom, l) < r)
    return !1;
  let a = n.posAtCoords({ x: i, y: r }, !1);
  return a >= e && a <= t;
}
function M1(n, e = {}) {
  let t = X.define(), i = Ne.define({
    create() {
      return [];
    },
    update(r, s) {
      if (r.length && (e.hideOnChange && (s.docChanged || s.selection) ? r = [] : e.hideOn && (r = r.filter((o) => !e.hideOn(s, o))), s.docChanged)) {
        let o = [];
        for (let l of r) {
          let a = s.changes.mapPos(l.pos, -1, qe.TrackDel);
          if (a != null) {
            let u = Object.assign(/* @__PURE__ */ Object.create(null), l);
            u.pos = a, u.end != null && (u.end = s.changes.mapPos(u.end)), o.push(u);
          }
        }
        r = o;
      }
      for (let o of s.effects)
        o.is(t) && (r = o.value), o.is(T1) && (r = []);
      return r;
    },
    provide: (r) => as.from(r)
  });
  return [
    i,
    ke.define((r) => new S1(
      r,
      n,
      i,
      t,
      e.hoverTime || 300
      /* Hover.Time */
    )),
    v1
  ];
}
function Kf(n, e) {
  let t = n.plugin(aa);
  if (!t)
    return null;
  let i = t.manager.tooltips.indexOf(e);
  return i < 0 ? null : t.manager.tooltipViews[i];
}
const T1 = /* @__PURE__ */ X.define(), ju = /* @__PURE__ */ j.define({
  combine(n) {
    let e, t;
    for (let i of n)
      e = e || i.topContainer, t = t || i.bottomContainer;
    return { topContainer: e, bottomContainer: t };
  }
});
function Xi(n, e) {
  let t = n.plugin(Gf), i = t ? t.specs.indexOf(e) : -1;
  return i > -1 ? t.panels[i] : null;
}
const Gf = /* @__PURE__ */ ke.fromClass(class {
  constructor(n) {
    this.input = n.state.facet(Ji), this.specs = this.input.filter((t) => t), this.panels = this.specs.map((t) => t(n));
    let e = n.state.facet(ju);
    this.top = new Mr(n, !0, e.topContainer), this.bottom = new Mr(n, !1, e.bottomContainer), this.top.sync(this.panels.filter((t) => t.top)), this.bottom.sync(this.panels.filter((t) => !t.top));
    for (let t of this.panels)
      t.dom.classList.add("cm-panel"), t.mount && t.mount();
  }
  update(n) {
    let e = n.state.facet(ju);
    this.top.container != e.topContainer && (this.top.sync([]), this.top = new Mr(n.view, !0, e.topContainer)), this.bottom.container != e.bottomContainer && (this.bottom.sync([]), this.bottom = new Mr(n.view, !1, e.bottomContainer)), this.top.syncClasses(), this.bottom.syncClasses();
    let t = n.state.facet(Ji);
    if (t != this.input) {
      let i = t.filter((a) => a), r = [], s = [], o = [], l = [];
      for (let a of i) {
        let u = this.specs.indexOf(a), c;
        u < 0 ? (c = a(n.view), l.push(c)) : (c = this.panels[u], c.update && c.update(n)), r.push(c), (c.top ? s : o).push(c);
      }
      this.specs = i, this.panels = r, this.top.sync(s), this.bottom.sync(o);
      for (let a of l)
        a.dom.classList.add("cm-panel"), a.mount && a.mount();
    } else
      for (let i of this.panels)
        i.update && i.update(n);
  }
  destroy() {
    this.top.sync([]), this.bottom.sync([]);
  }
}, {
  provide: (n) => V.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return t && { top: t.top.scrollMargin(), bottom: t.bottom.scrollMargin() };
  })
});
class Mr {
  constructor(e, t, i) {
    this.view = e, this.top = t, this.container = i, this.dom = void 0, this.classes = "", this.panels = [], this.syncClasses();
  }
  sync(e) {
    for (let t of this.panels)
      t.destroy && e.indexOf(t) < 0 && t.destroy();
    this.panels = e, this.syncDOM();
  }
  syncDOM() {
    if (this.panels.length == 0) {
      this.dom && (this.dom.remove(), this.dom = void 0);
      return;
    }
    if (!this.dom) {
      this.dom = document.createElement("div"), this.dom.className = this.top ? "cm-panels cm-panels-top" : "cm-panels cm-panels-bottom", this.dom.style[this.top ? "top" : "bottom"] = "0";
      let t = this.container || this.view.dom;
      t.insertBefore(this.dom, this.top ? t.firstChild : null);
    }
    let e = this.dom.firstChild;
    for (let t of this.panels)
      if (t.dom.parentNode == this.dom) {
        for (; e != t.dom; )
          e = Wu(e);
        e = e.nextSibling;
      } else
        this.dom.insertBefore(t.dom, e);
    for (; e; )
      e = Wu(e);
  }
  scrollMargin() {
    return !this.dom || this.container ? 0 : Math.max(0, this.top ? this.dom.getBoundingClientRect().bottom - Math.max(0, this.view.scrollDOM.getBoundingClientRect().top) : Math.min(innerHeight, this.view.scrollDOM.getBoundingClientRect().bottom) - this.dom.getBoundingClientRect().top);
  }
  syncClasses() {
    if (!(!this.container || this.classes == this.view.themeClasses)) {
      for (let e of this.classes.split(" "))
        e && this.container.classList.remove(e);
      for (let e of (this.classes = this.view.themeClasses).split(" "))
        e && this.container.classList.add(e);
    }
  }
}
function Wu(n) {
  let e = n.nextSibling;
  return n.remove(), e;
}
const Ji = /* @__PURE__ */ j.define({
  enables: Gf
});
class Yt extends Pn {
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  Compare this marker to another marker of the same type.
  */
  eq(e) {
    return !1;
  }
  /**
  Called if the marker has a `toDOM` method and its representation
  was removed from a gutter.
  */
  destroy(e) {
  }
}
Yt.prototype.elementClass = "";
Yt.prototype.toDOM = void 0;
Yt.prototype.mapMode = qe.TrackBefore;
Yt.prototype.startSide = Yt.prototype.endSide = -1;
Yt.prototype.point = !0;
const Jr = /* @__PURE__ */ j.define(), O1 = {
  class: "",
  renderEmptyElements: !1,
  elementStyle: "",
  markers: () => ie.empty,
  lineMarker: () => null,
  widgetMarker: () => null,
  lineMarkerChange: null,
  initialSpacer: null,
  updateSpacer: null,
  domEventHandlers: {}
}, _i = /* @__PURE__ */ j.define();
function D1(n) {
  return [Yf(), _i.of(Object.assign(Object.assign({}, O1), n))];
}
const qu = /* @__PURE__ */ j.define({
  combine: (n) => n.some((e) => e)
});
function Yf(n) {
  return [
    E1
  ];
}
const E1 = /* @__PURE__ */ ke.fromClass(class {
  constructor(n) {
    this.view = n, this.prevViewport = n.viewport, this.dom = document.createElement("div"), this.dom.className = "cm-gutters", this.dom.setAttribute("aria-hidden", "true"), this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px", this.gutters = n.state.facet(_i).map((e) => new Ku(n, e));
    for (let e of this.gutters)
      this.dom.appendChild(e.dom);
    this.fixed = !n.state.facet(qu), this.fixed && (this.dom.style.position = "sticky"), this.syncGutters(!1), n.scrollDOM.insertBefore(this.dom, n.contentDOM);
  }
  update(n) {
    if (this.updateGutters(n)) {
      let e = this.prevViewport, t = n.view.viewport, i = Math.min(e.to, t.to) - Math.max(e.from, t.from);
      this.syncGutters(i < (t.to - t.from) * 0.8);
    }
    n.geometryChanged && (this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px"), this.view.state.facet(qu) != !this.fixed && (this.fixed = !this.fixed, this.dom.style.position = this.fixed ? "sticky" : ""), this.prevViewport = n.view.viewport;
  }
  syncGutters(n) {
    let e = this.dom.nextSibling;
    n && this.dom.remove();
    let t = ie.iter(this.view.state.facet(Jr), this.view.viewport.from), i = [], r = this.gutters.map((s) => new L1(s, this.view.viewport, -this.view.documentPadding.top));
    for (let s of this.view.viewportLineBlocks)
      if (i.length && (i = []), Array.isArray(s.type)) {
        let o = !0;
        for (let l of s.type)
          if (l.type == Ke.Text && o) {
            Al(t, i, l.from);
            for (let a of r)
              a.line(this.view, l, i);
            o = !1;
          } else if (l.widget)
            for (let a of r)
              a.widget(this.view, l);
      } else if (s.type == Ke.Text) {
        Al(t, i, s.from);
        for (let o of r)
          o.line(this.view, s, i);
      } else if (s.widget)
        for (let o of r)
          o.widget(this.view, s);
    for (let s of r)
      s.finish();
    n && this.view.scrollDOM.insertBefore(this.dom, e);
  }
  updateGutters(n) {
    let e = n.startState.facet(_i), t = n.state.facet(_i), i = n.docChanged || n.heightChanged || n.viewportChanged || !ie.eq(n.startState.facet(Jr), n.state.facet(Jr), n.view.viewport.from, n.view.viewport.to);
    if (e == t)
      for (let r of this.gutters)
        r.update(n) && (i = !0);
    else {
      i = !0;
      let r = [];
      for (let s of t) {
        let o = e.indexOf(s);
        o < 0 ? r.push(new Ku(this.view, s)) : (this.gutters[o].update(n), r.push(this.gutters[o]));
      }
      for (let s of this.gutters)
        s.dom.remove(), r.indexOf(s) < 0 && s.destroy();
      for (let s of r)
        this.dom.appendChild(s.dom);
      this.gutters = r;
    }
    return i;
  }
  destroy() {
    for (let n of this.gutters)
      n.destroy();
    this.dom.remove();
  }
}, {
  provide: (n) => V.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return !t || t.gutters.length == 0 || !t.fixed ? null : e.textDirection == ye.LTR ? { left: t.dom.offsetWidth * e.scaleX } : { right: t.dom.offsetWidth * e.scaleX };
  })
});
function Uu(n) {
  return Array.isArray(n) ? n : [n];
}
function Al(n, e, t) {
  for (; n.value && n.from <= t; )
    n.from == t && e.push(n.value), n.next();
}
class L1 {
  constructor(e, t, i) {
    this.gutter = e, this.height = i, this.i = 0, this.cursor = ie.iter(e.markers, t.from);
  }
  addElement(e, t, i) {
    let { gutter: r } = this, s = (t.top - this.height) / e.scaleY, o = t.height / e.scaleY;
    if (this.i == r.elements.length) {
      let l = new Xf(e, o, s, i);
      r.elements.push(l), r.dom.appendChild(l.dom);
    } else
      r.elements[this.i].update(e, o, s, i);
    this.height = t.bottom, this.i++;
  }
  line(e, t, i) {
    let r = [];
    Al(this.cursor, r, t.from), i.length && (r = r.concat(i));
    let s = this.gutter.config.lineMarker(e, t, r);
    s && r.unshift(s);
    let o = this.gutter;
    r.length == 0 && !o.config.renderEmptyElements || this.addElement(e, t, r);
  }
  widget(e, t) {
    let i = this.gutter.config.widgetMarker(e, t.widget, t);
    i && this.addElement(e, t, [i]);
  }
  finish() {
    let e = this.gutter;
    for (; e.elements.length > this.i; ) {
      let t = e.elements.pop();
      e.dom.removeChild(t.dom), t.destroy();
    }
  }
}
class Ku {
  constructor(e, t) {
    this.view = e, this.config = t, this.elements = [], this.spacer = null, this.dom = document.createElement("div"), this.dom.className = "cm-gutter" + (this.config.class ? " " + this.config.class : "");
    for (let i in t.domEventHandlers)
      this.dom.addEventListener(i, (r) => {
        let s = r.target, o;
        if (s != this.dom && this.dom.contains(s)) {
          for (; s.parentNode != this.dom; )
            s = s.parentNode;
          let a = s.getBoundingClientRect();
          o = (a.top + a.bottom) / 2;
        } else
          o = r.clientY;
        let l = e.lineBlockAtHeight(o - e.documentTop);
        t.domEventHandlers[i](e, l, r) && r.preventDefault();
      });
    this.markers = Uu(t.markers(e)), t.initialSpacer && (this.spacer = new Xf(e, 0, 0, [t.initialSpacer(e)]), this.dom.appendChild(this.spacer.dom), this.spacer.dom.style.cssText += "visibility: hidden; pointer-events: none");
  }
  update(e) {
    let t = this.markers;
    if (this.markers = Uu(this.config.markers(e.view)), this.spacer && this.config.updateSpacer) {
      let r = this.config.updateSpacer(this.spacer.markers[0], e);
      r != this.spacer.markers[0] && this.spacer.update(e.view, 0, 0, [r]);
    }
    let i = e.view.viewport;
    return !ie.eq(this.markers, t, i.from, i.to) || (this.config.lineMarkerChange ? this.config.lineMarkerChange(e) : !1);
  }
  destroy() {
    for (let e of this.elements)
      e.destroy();
  }
}
class Xf {
  constructor(e, t, i, r) {
    this.height = -1, this.above = 0, this.markers = [], this.dom = document.createElement("div"), this.dom.className = "cm-gutterElement", this.update(e, t, i, r);
  }
  update(e, t, i, r) {
    this.height != t && (this.height = t, this.dom.style.height = t + "px"), this.above != i && (this.dom.style.marginTop = (this.above = i) ? i + "px" : ""), I1(this.markers, r) || this.setMarkers(e, r);
  }
  setMarkers(e, t) {
    let i = "cm-gutterElement", r = this.dom.firstChild;
    for (let s = 0, o = 0; ; ) {
      let l = o, a = s < t.length ? t[s++] : null, u = !1;
      if (a) {
        let c = a.elementClass;
        c && (i += " " + c);
        for (let h = o; h < this.markers.length; h++)
          if (this.markers[h].compare(a)) {
            l = h, u = !0;
            break;
          }
      } else
        l = this.markers.length;
      for (; o < l; ) {
        let c = this.markers[o++];
        if (c.toDOM) {
          c.destroy(r);
          let h = r.nextSibling;
          r.remove(), r = h;
        }
      }
      if (!a)
        break;
      a.toDOM && (u ? r = r.nextSibling : this.dom.insertBefore(a.toDOM(e), r)), u && o++;
    }
    this.dom.className = i, this.markers = t;
  }
  destroy() {
    this.setMarkers(null, []);
  }
}
function I1(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (!n[t].compare(e[t]))
      return !1;
  return !0;
}
const P1 = /* @__PURE__ */ j.define(), Yn = /* @__PURE__ */ j.define({
  combine(n) {
    return Vt(n, { formatNumber: String, domEventHandlers: {} }, {
      domEventHandlers(e, t) {
        let i = Object.assign({}, e);
        for (let r in t) {
          let s = i[r], o = t[r];
          i[r] = s ? (l, a, u) => s(l, a, u) || o(l, a, u) : o;
        }
        return i;
      }
    });
  }
});
class ho extends Yt {
  constructor(e) {
    super(), this.number = e;
  }
  eq(e) {
    return this.number == e.number;
  }
  toDOM() {
    return document.createTextNode(this.number);
  }
}
function fo(n, e) {
  return n.state.facet(Yn).formatNumber(e, n.state);
}
const B1 = /* @__PURE__ */ _i.compute([Yn], (n) => ({
  class: "cm-lineNumbers",
  renderEmptyElements: !1,
  markers(e) {
    return e.state.facet(P1);
  },
  lineMarker(e, t, i) {
    return i.some((r) => r.toDOM) ? null : new ho(fo(e, e.state.doc.lineAt(t.from).number));
  },
  widgetMarker: () => null,
  lineMarkerChange: (e) => e.startState.facet(Yn) != e.state.facet(Yn),
  initialSpacer(e) {
    return new ho(fo(e, Gu(e.state.doc.lines)));
  },
  updateSpacer(e, t) {
    let i = fo(t.view, Gu(t.view.state.doc.lines));
    return i == e.number ? e : new ho(i);
  },
  domEventHandlers: n.facet(Yn).domEventHandlers
}));
function R1(n = {}) {
  return [
    Yn.of(n),
    Yf(),
    B1
  ];
}
function Gu(n) {
  let e = 9;
  for (; e < n; )
    e = e * 10 + 9;
  return e;
}
const N1 = /* @__PURE__ */ new class extends Yt {
  constructor() {
    super(...arguments), this.elementClass = "cm-activeLineGutter";
  }
}(), F1 = /* @__PURE__ */ Jr.compute(["selection"], (n) => {
  let e = [], t = -1;
  for (let i of n.selection.ranges) {
    let r = n.doc.lineAt(i.head).from;
    r > t && (t = r, e.push(N1.range(r)));
  }
  return ie.of(e);
});
function z1() {
  return F1;
}
const H1 = 1024;
let V1 = 0;
class po {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
class ee {
  /**
  Create a new node prop type.
  */
  constructor(e = {}) {
    this.id = V1++, this.perNode = !!e.perNode, this.deserialize = e.deserialize || (() => {
      throw new Error("This node type doesn't define a deserialize function");
    });
  }
  /**
  This is meant to be used with
  [`NodeSet.extend`](#common.NodeSet.extend) or
  [`LRParser.configure`](#lr.ParserConfig.props) to compute
  prop values for each node type in the set. Takes a [match
  object](#common.NodeType^match) or function that returns undefined
  if the node type doesn't get this prop, and the prop's value if
  it does.
  */
  add(e) {
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e != "function" && (e = bt.match(e)), (t) => {
      let i = e(t);
      return i === void 0 ? null : [this, i];
    };
  }
}
ee.closedBy = new ee({ deserialize: (n) => n.split(" ") });
ee.openedBy = new ee({ deserialize: (n) => n.split(" ") });
ee.group = new ee({ deserialize: (n) => n.split(" ") });
ee.isolate = new ee({ deserialize: (n) => {
  if (n && n != "rtl" && n != "ltr" && n != "auto")
    throw new RangeError("Invalid value for isolate: " + n);
  return n || "auto";
} });
ee.contextHash = new ee({ perNode: !0 });
ee.lookAhead = new ee({ perNode: !0 });
ee.mounted = new ee({ perNode: !0 });
class us {
  constructor(e, t, i) {
    this.tree = e, this.overlay = t, this.parser = i;
  }
  /**
  @internal
  */
  static get(e) {
    return e && e.props && e.props[ee.mounted.id];
  }
}
const _1 = /* @__PURE__ */ Object.create(null);
class bt {
  /**
  @internal
  */
  constructor(e, t, i, r = 0) {
    this.name = e, this.props = t, this.id = i, this.flags = r;
  }
  /**
  Define a node type.
  */
  static define(e) {
    let t = e.props && e.props.length ? /* @__PURE__ */ Object.create(null) : _1, i = (e.top ? 1 : 0) | (e.skipped ? 2 : 0) | (e.error ? 4 : 0) | (e.name == null ? 8 : 0), r = new bt(e.name || "", t, e.id, i);
    if (e.props) {
      for (let s of e.props)
        if (Array.isArray(s) || (s = s(r)), s) {
          if (s[0].perNode)
            throw new RangeError("Can't store a per-node prop on a node type");
          t[s[0].id] = s[1];
        }
    }
    return r;
  }
  /**
  Retrieves a node prop for this type. Will return `undefined` if
  the prop isn't present on this node.
  */
  prop(e) {
    return this.props[e.id];
  }
  /**
  True when this is the top node of a grammar.
  */
  get isTop() {
    return (this.flags & 1) > 0;
  }
  /**
  True when this node is produced by a skip rule.
  */
  get isSkipped() {
    return (this.flags & 2) > 0;
  }
  /**
  Indicates whether this is an error node.
  */
  get isError() {
    return (this.flags & 4) > 0;
  }
  /**
  When true, this node type doesn't correspond to a user-declared
  named node, for example because it is used to cache repetition.
  */
  get isAnonymous() {
    return (this.flags & 8) > 0;
  }
  /**
  Returns true when this node's name or one of its
  [groups](#common.NodeProp^group) matches the given string.
  */
  is(e) {
    if (typeof e == "string") {
      if (this.name == e)
        return !0;
      let t = this.prop(ee.group);
      return t ? t.indexOf(e) > -1 : !1;
    }
    return this.id == e;
  }
  /**
  Create a function from node types to arbitrary values by
  specifying an object whose property names are node or
  [group](#common.NodeProp^group) names. Often useful with
  [`NodeProp.add`](#common.NodeProp.add). You can put multiple
  names, separated by spaces, in a single property name to map
  multiple node names to a single value.
  */
  static match(e) {
    let t = /* @__PURE__ */ Object.create(null);
    for (let i in e)
      for (let r of i.split(" "))
        t[r] = e[i];
    return (i) => {
      for (let r = i.prop(ee.group), s = -1; s < (r ? r.length : 0); s++) {
        let o = t[s < 0 ? i.name : r[s]];
        if (o)
          return o;
      }
    };
  }
}
bt.none = new bt(
  "",
  /* @__PURE__ */ Object.create(null),
  0,
  8
  /* NodeFlag.Anonymous */
);
const Tr = /* @__PURE__ */ new WeakMap(), Yu = /* @__PURE__ */ new WeakMap();
var Pe;
(function(n) {
  n[n.ExcludeBuffers = 1] = "ExcludeBuffers", n[n.IncludeAnonymous = 2] = "IncludeAnonymous", n[n.IgnoreMounts = 4] = "IgnoreMounts", n[n.IgnoreOverlays = 8] = "IgnoreOverlays";
})(Pe || (Pe = {}));
class He {
  /**
  Construct a new tree. See also [`Tree.build`](#common.Tree^build).
  */
  constructor(e, t, i, r, s) {
    if (this.type = e, this.children = t, this.positions = i, this.length = r, this.props = null, s && s.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      for (let [o, l] of s)
        this.props[typeof o == "number" ? o : o.id] = l;
    }
  }
  /**
  @internal
  */
  toString() {
    let e = us.get(this);
    if (e && !e.overlay)
      return e.tree.toString();
    let t = "";
    for (let i of this.children) {
      let r = i.toString();
      r && (t && (t += ","), t += r);
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (t.length ? "(" + t + ")" : "") : t;
  }
  /**
  Get a [tree cursor](#common.TreeCursor) positioned at the top of
  the tree. Mode can be used to [control](#common.IterMode) which
  nodes the cursor visits.
  */
  cursor(e = 0) {
    return new Tl(this.topNode, e);
  }
  /**
  Get a [tree cursor](#common.TreeCursor) pointing into this tree
  at the given position and side (see
  [`moveTo`](#common.TreeCursor.moveTo).
  */
  cursorAt(e, t = 0, i = 0) {
    let r = Tr.get(this) || this.topNode, s = new Tl(r);
    return s.moveTo(e, t), Tr.set(this, s._tree), s;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) object for the top of the
  tree.
  */
  get topNode() {
    return new mt(this, 0, 0, null);
  }
  /**
  Get the [syntax node](#common.SyntaxNode) at the given position.
  If `side` is -1, this will move into nodes that end at the
  position. If 1, it'll move into nodes that start at the
  position. With 0, it'll only enter nodes that cover the position
  from both sides.
  
  Note that this will not enter
  [overlays](#common.MountedTree.overlay), and you often want
  [`resolveInner`](#common.Tree.resolveInner) instead.
  */
  resolve(e, t = 0) {
    let i = Qi(Tr.get(this) || this.topNode, e, t, !1);
    return Tr.set(this, i), i;
  }
  /**
  Like [`resolve`](#common.Tree.resolve), but will enter
  [overlaid](#common.MountedTree.overlay) nodes, producing a syntax node
  pointing into the innermost overlaid tree at the given position
  (with parent links going through all parent structure, including
  the host trees).
  */
  resolveInner(e, t = 0) {
    let i = Qi(Yu.get(this) || this.topNode, e, t, !0);
    return Yu.set(this, i), i;
  }
  /**
  In some situations, it can be useful to iterate through all
  nodes around a position, including those in overlays that don't
  directly cover the position. This method gives you an iterator
  that will produce all nodes, from small to big, around the given
  position.
  */
  resolveStack(e, t = 0) {
    return W1(this, e, t);
  }
  /**
  Iterate over the tree and its children, calling `enter` for any
  node that touches the `from`/`to` region (if given) before
  running over such a node's children, and `leave` (if given) when
  leaving the node. When `enter` returns `false`, that node will
  not have its children iterated over (or `leave` called).
  */
  iterate(e) {
    let { enter: t, leave: i, from: r = 0, to: s = this.length } = e, o = e.mode || 0, l = (o & Pe.IncludeAnonymous) > 0;
    for (let a = this.cursor(o | Pe.IncludeAnonymous); ; ) {
      let u = !1;
      if (a.from <= s && a.to >= r && (!l && a.type.isAnonymous || t(a) !== !1)) {
        if (a.firstChild())
          continue;
        u = !0;
      }
      for (; u && i && (l || !a.type.isAnonymous) && i(a), !a.nextSibling(); ) {
        if (!a.parent())
          return;
        u = !0;
      }
    }
  }
  /**
  Get the value of the given [node prop](#common.NodeProp) for this
  node. Works with both per-node and per-type props.
  */
  prop(e) {
    return e.perNode ? this.props ? this.props[e.id] : void 0 : this.type.prop(e);
  }
  /**
  Returns the node's [per-node props](#common.NodeProp.perNode) in a
  format that can be passed to the [`Tree`](#common.Tree)
  constructor.
  */
  get propValues() {
    let e = [];
    if (this.props)
      for (let t in this.props)
        e.push([+t, this.props[t]]);
    return e;
  }
  /**
  Balance the direct children of this tree, producing a copy of
  which may have children grouped into subtrees with type
  [`NodeType.none`](#common.NodeType^none).
  */
  balance(e = {}) {
    return this.children.length <= 8 ? this : fa(bt.none, this.children, this.positions, 0, this.children.length, 0, this.length, (t, i, r) => new He(this.type, t, i, r, this.propValues), e.makeTree || ((t, i, r) => new He(bt.none, t, i, r)));
  }
  /**
  Build a tree from a postfix-ordered buffer of node information,
  or a cursor over such a buffer.
  */
  static build(e) {
    return q1(e);
  }
}
He.empty = new He(bt.none, [], [], 0);
class ca {
  constructor(e, t) {
    this.buffer = e, this.index = t;
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  get pos() {
    return this.index;
  }
  next() {
    this.index -= 4;
  }
  fork() {
    return new ca(this.buffer, this.index);
  }
}
class yn {
  /**
  Create a tree buffer.
  */
  constructor(e, t, i) {
    this.buffer = e, this.length = t, this.set = i;
  }
  /**
  @internal
  */
  get type() {
    return bt.none;
  }
  /**
  @internal
  */
  toString() {
    let e = [];
    for (let t = 0; t < this.buffer.length; )
      e.push(this.childString(t)), t = this.buffer[t + 3];
    return e.join(",");
  }
  /**
  @internal
  */
  childString(e) {
    let t = this.buffer[e], i = this.buffer[e + 3], r = this.set.types[t], s = r.name;
    if (/\W/.test(s) && !r.isError && (s = JSON.stringify(s)), e += 4, i == e)
      return s;
    let o = [];
    for (; e < i; )
      o.push(this.childString(e)), e = this.buffer[e + 3];
    return s + "(" + o.join(",") + ")";
  }
  /**
  @internal
  */
  findChild(e, t, i, r, s) {
    let { buffer: o } = this, l = -1;
    for (let a = e; a != t && !(Jf(s, r, o[a + 1], o[a + 2]) && (l = a, i > 0)); a = o[a + 3])
      ;
    return l;
  }
  /**
  @internal
  */
  slice(e, t, i) {
    let r = this.buffer, s = new Uint16Array(t - e), o = 0;
    for (let l = e, a = 0; l < t; ) {
      s[a++] = r[l++], s[a++] = r[l++] - i;
      let u = s[a++] = r[l++] - i;
      s[a++] = r[l++] - e, o = Math.max(o, u);
    }
    return new yn(s, o, this.set);
  }
}
function Jf(n, e, t, i) {
  switch (n) {
    case -2:
      return t < e;
    case -1:
      return i >= e && t < e;
    case 0:
      return t < e && i > e;
    case 1:
      return t <= e && i > e;
    case 2:
      return i > e;
    case 4:
      return !0;
  }
}
function Qi(n, e, t, i) {
  for (var r; n.from == n.to || (t < 1 ? n.from >= e : n.from > e) || (t > -1 ? n.to <= e : n.to < e); ) {
    let o = !i && n instanceof mt && n.index < 0 ? null : n.parent;
    if (!o)
      return n;
    n = o;
  }
  let s = i ? 0 : Pe.IgnoreOverlays;
  if (i)
    for (let o = n, l = o.parent; l; o = l, l = o.parent)
      o instanceof mt && o.index < 0 && ((r = l.enter(e, t, s)) === null || r === void 0 ? void 0 : r.from) != o.from && (n = l);
  for (; ; ) {
    let o = n.enter(e, t, s);
    if (!o)
      return n;
    n = o;
  }
}
class Qf {
  cursor(e = 0) {
    return new Tl(this, e);
  }
  getChild(e, t = null, i = null) {
    let r = Xu(this, e, t, i);
    return r.length ? r[0] : null;
  }
  getChildren(e, t = null, i = null) {
    return Xu(this, e, t, i);
  }
  resolve(e, t = 0) {
    return Qi(this, e, t, !1);
  }
  resolveInner(e, t = 0) {
    return Qi(this, e, t, !0);
  }
  matchContext(e) {
    return Ml(this, e);
  }
  enterUnfinishedNodesBefore(e) {
    let t = this.childBefore(e), i = this;
    for (; t; ) {
      let r = t.lastChild;
      if (!r || r.to != t.to)
        break;
      r.type.isError && r.from == r.to ? (i = t, t = r.prevSibling) : t = r;
    }
    return i;
  }
  get node() {
    return this;
  }
  get next() {
    return this.parent;
  }
}
class mt extends Qf {
  constructor(e, t, i, r) {
    super(), this._tree = e, this.from = t, this.index = i, this._parent = r;
  }
  get type() {
    return this._tree.type;
  }
  get name() {
    return this._tree.type.name;
  }
  get to() {
    return this.from + this._tree.length;
  }
  nextChild(e, t, i, r, s = 0) {
    for (let o = this; ; ) {
      for (let { children: l, positions: a } = o._tree, u = t > 0 ? l.length : -1; e != u; e += t) {
        let c = l[e], h = a[e] + o.from;
        if (Jf(r, i, h, h + c.length)) {
          if (c instanceof yn) {
            if (s & Pe.ExcludeBuffers)
              continue;
            let f = c.findChild(0, c.buffer.length, t, i - h, r);
            if (f > -1)
              return new un(new $1(o, c, e, h), null, f);
          } else if (s & Pe.IncludeAnonymous || !c.type.isAnonymous || ha(c)) {
            let f;
            if (!(s & Pe.IgnoreMounts) && (f = us.get(c)) && !f.overlay)
              return new mt(f.tree, h, e, o);
            let d = new mt(c, h, e, o);
            return s & Pe.IncludeAnonymous || !d.type.isAnonymous ? d : d.nextChild(t < 0 ? c.children.length - 1 : 0, t, i, r);
          }
        }
      }
      if (s & Pe.IncludeAnonymous || !o.type.isAnonymous || (o.index >= 0 ? e = o.index + t : e = t < 0 ? -1 : o._parent._tree.children.length, o = o._parent, !o))
        return null;
    }
  }
  get firstChild() {
    return this.nextChild(
      0,
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.nextChild(
      0,
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, i = 0) {
    let r;
    if (!(i & Pe.IgnoreOverlays) && (r = us.get(this._tree)) && r.overlay) {
      let s = e - this.from;
      for (let { from: o, to: l } of r.overlay)
        if ((t > 0 ? o <= s : o < s) && (t < 0 ? l >= s : l > s))
          return new mt(r.tree, r.overlay[0].from + this.from, -1, this);
    }
    return this.nextChild(0, 1, e, t, i);
  }
  nextSignificantParent() {
    let e = this;
    for (; e.type.isAnonymous && e._parent; )
      e = e._parent;
    return e;
  }
  get parent() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  }
  get nextSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index + 1,
      1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get prevSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get tree() {
    return this._tree;
  }
  toTree() {
    return this._tree;
  }
  /**
  @internal
  */
  toString() {
    return this._tree.toString();
  }
}
function Xu(n, e, t, i) {
  let r = n.cursor(), s = [];
  if (!r.firstChild())
    return s;
  if (t != null) {
    for (let o = !1; !o; )
      if (o = r.type.is(t), !r.nextSibling())
        return s;
  }
  for (; ; ) {
    if (i != null && r.type.is(i))
      return s;
    if (r.type.is(e) && s.push(r.node), !r.nextSibling())
      return i == null ? s : [];
  }
}
function Ml(n, e, t = e.length - 1) {
  for (let i = n.parent; t >= 0; i = i.parent) {
    if (!i)
      return !1;
    if (!i.type.isAnonymous) {
      if (e[t] && e[t] != i.name)
        return !1;
      t--;
    }
  }
  return !0;
}
class $1 {
  constructor(e, t, i, r) {
    this.parent = e, this.buffer = t, this.index = i, this.start = r;
  }
}
class un extends Qf {
  get name() {
    return this.type.name;
  }
  get from() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  }
  get to() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  }
  constructor(e, t, i) {
    super(), this.context = e, this._parent = t, this.index = i, this.type = e.buffer.set.types[e.buffer.buffer[i]];
  }
  child(e, t, i) {
    let { buffer: r } = this.context, s = r.findChild(this.index + 4, r.buffer[this.index + 3], e, t - this.context.start, i);
    return s < 0 ? null : new un(this.context, this, s);
  }
  get firstChild() {
    return this.child(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.child(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.child(
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.child(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, i = 0) {
    if (i & Pe.ExcludeBuffers)
      return null;
    let { buffer: r } = this.context, s = r.findChild(this.index + 4, r.buffer[this.index + 3], t > 0 ? 1 : -1, e - this.context.start, t);
    return s < 0 ? null : new un(this.context, this, s);
  }
  get parent() {
    return this._parent || this.context.parent.nextSignificantParent();
  }
  externalSibling(e) {
    return this._parent ? null : this.context.parent.nextChild(
      this.context.index + e,
      e,
      0,
      4
      /* Side.DontCare */
    );
  }
  get nextSibling() {
    let { buffer: e } = this.context, t = e.buffer[this.index + 3];
    return t < (this._parent ? e.buffer[this._parent.index + 3] : e.buffer.length) ? new un(this.context, this._parent, t) : this.externalSibling(1);
  }
  get prevSibling() {
    let { buffer: e } = this.context, t = this._parent ? this._parent.index + 4 : 0;
    return this.index == t ? this.externalSibling(-1) : new un(this.context, this._parent, e.findChild(
      t,
      this.index,
      -1,
      0,
      4
      /* Side.DontCare */
    ));
  }
  get tree() {
    return null;
  }
  toTree() {
    let e = [], t = [], { buffer: i } = this.context, r = this.index + 4, s = i.buffer[this.index + 3];
    if (s > r) {
      let o = i.buffer[this.index + 1];
      e.push(i.slice(r, s, o)), t.push(0);
    }
    return new He(this.type, e, t, this.to - this.from);
  }
  /**
  @internal
  */
  toString() {
    return this.context.buffer.childString(this.index);
  }
}
function Zf(n) {
  if (!n.length)
    return null;
  let e = 0, t = n[0];
  for (let s = 1; s < n.length; s++) {
    let o = n[s];
    (o.from > t.from || o.to < t.to) && (t = o, e = s);
  }
  let i = t instanceof mt && t.index < 0 ? null : t.parent, r = n.slice();
  return i ? r[e] = i : r.splice(e, 1), new j1(r, t);
}
class j1 {
  constructor(e, t) {
    this.heads = e, this.node = t;
  }
  get next() {
    return Zf(this.heads);
  }
}
function W1(n, e, t) {
  let i = n.resolveInner(e, t), r = null;
  for (let s = i instanceof mt ? i : i.context.parent; s; s = s.parent)
    if (s.index < 0) {
      let o = s.parent;
      (r || (r = [i])).push(o.resolve(e, t)), s = o;
    } else {
      let o = us.get(s.tree);
      if (o && o.overlay && o.overlay[0].from <= e && o.overlay[o.overlay.length - 1].to >= e) {
        let l = new mt(o.tree, o.overlay[0].from + s.from, -1, s);
        (r || (r = [i])).push(Qi(l, e, t, !1));
      }
    }
  return r ? Zf(r) : i;
}
class Tl {
  /**
  Shorthand for `.type.name`.
  */
  get name() {
    return this.type.name;
  }
  /**
  @internal
  */
  constructor(e, t = 0) {
    if (this.mode = t, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, e instanceof mt)
      this.yieldNode(e);
    else {
      this._tree = e.context.parent, this.buffer = e.context;
      for (let i = e._parent; i; i = i._parent)
        this.stack.unshift(i.index);
      this.bufferNode = e, this.yieldBuf(e.index);
    }
  }
  yieldNode(e) {
    return e ? (this._tree = e, this.type = e.type, this.from = e.from, this.to = e.to, !0) : !1;
  }
  yieldBuf(e, t) {
    this.index = e;
    let { start: i, buffer: r } = this.buffer;
    return this.type = t || r.set.types[r.buffer[e]], this.from = i + r.buffer[e + 1], this.to = i + r.buffer[e + 2], !0;
  }
  /**
  @internal
  */
  yield(e) {
    return e ? e instanceof mt ? (this.buffer = null, this.yieldNode(e)) : (this.buffer = e.context, this.yieldBuf(e.index, e.type)) : !1;
  }
  /**
  @internal
  */
  toString() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  }
  /**
  @internal
  */
  enterChild(e, t, i) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e < 0 ? this._tree._tree.children.length - 1 : 0, e, t, i, this.mode));
    let { buffer: r } = this.buffer, s = r.findChild(this.index + 4, r.buffer[this.index + 3], e, t - this.buffer.start, i);
    return s < 0 ? !1 : (this.stack.push(this.index), this.yieldBuf(s));
  }
  /**
  Move the cursor to this node's first child. When this returns
  false, the node has no child, and the cursor has not been moved.
  */
  firstChild() {
    return this.enterChild(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to this node's last child.
  */
  lastChild() {
    return this.enterChild(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to the first child that ends after `pos`.
  */
  childAfter(e) {
    return this.enterChild(
      1,
      e,
      2
      /* Side.After */
    );
  }
  /**
  Move to the last child that starts before `pos`.
  */
  childBefore(e) {
    return this.enterChild(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  /**
  Move the cursor to the child around `pos`. If side is -1 the
  child may end at that position, when 1 it may start there. This
  will also enter [overlaid](#common.MountedTree.overlay)
  [mounted](#common.NodeProp^mounted) trees unless `overlays` is
  set to false.
  */
  enter(e, t, i = this.mode) {
    return this.buffer ? i & Pe.ExcludeBuffers ? !1 : this.enterChild(1, e, t) : this.yield(this._tree.enter(e, t, i));
  }
  /**
  Move to the node's parent node, if this isn't the top node.
  */
  parent() {
    if (!this.buffer)
      return this.yieldNode(this.mode & Pe.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    let e = this.mode & Pe.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e);
  }
  /**
  @internal
  */
  sibling(e) {
    if (!this.buffer)
      return this._tree._parent ? this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e, e, 0, 4, this.mode)) : !1;
    let { buffer: t } = this.buffer, i = this.stack.length - 1;
    if (e < 0) {
      let r = i < 0 ? 0 : this.stack[i] + 4;
      if (this.index != r)
        return this.yieldBuf(t.findChild(
          r,
          this.index,
          -1,
          0,
          4
          /* Side.DontCare */
        ));
    } else {
      let r = t.buffer[this.index + 3];
      if (r < (i < 0 ? t.buffer.length : t.buffer[this.stack[i] + 3]))
        return this.yieldBuf(r);
    }
    return i < 0 ? this.yield(this.buffer.parent.nextChild(this.buffer.index + e, e, 0, 4, this.mode)) : !1;
  }
  /**
  Move to this node's next sibling, if any.
  */
  nextSibling() {
    return this.sibling(1);
  }
  /**
  Move to this node's previous sibling, if any.
  */
  prevSibling() {
    return this.sibling(-1);
  }
  atLastNode(e) {
    let t, i, { buffer: r } = this;
    if (r) {
      if (e > 0) {
        if (this.index < r.buffer.buffer.length)
          return !1;
      } else
        for (let s = 0; s < this.index; s++)
          if (r.buffer.buffer[s + 3] < this.index)
            return !1;
      ({ index: t, parent: i } = r);
    } else
      ({ index: t, _parent: i } = this._tree);
    for (; i; { index: t, _parent: i } = i)
      if (t > -1)
        for (let s = t + e, o = e < 0 ? -1 : i._tree.children.length; s != o; s += e) {
          let l = i._tree.children[s];
          if (this.mode & Pe.IncludeAnonymous || l instanceof yn || !l.type.isAnonymous || ha(l))
            return !1;
        }
    return !0;
  }
  move(e, t) {
    if (t && this.enterChild(
      e,
      0,
      4
      /* Side.DontCare */
    ))
      return !0;
    for (; ; ) {
      if (this.sibling(e))
        return !0;
      if (this.atLastNode(e) || !this.parent())
        return !1;
    }
  }
  /**
  Move to the next node in a
  [pre-order](https://en.wikipedia.org/wiki/Tree_traversal#Pre-order,_NLR)
  traversal, going from a node to its first child or, if the
  current node is empty or `enter` is false, its next sibling or
  the next sibling of the first parent node that has one.
  */
  next(e = !0) {
    return this.move(1, e);
  }
  /**
  Move to the next node in a last-to-first pre-order traveral. A
  node is followed by its last child or, if it has none, its
  previous sibling or the previous sibling of the first parent
  node that has one.
  */
  prev(e = !0) {
    return this.move(-1, e);
  }
  /**
  Move the cursor to the innermost node that covers `pos`. If
  `side` is -1, it will enter nodes that end at `pos`. If it is 1,
  it will enter nodes that start at `pos`.
  */
  moveTo(e, t = 0) {
    for (; (this.from == this.to || (t < 1 ? this.from >= e : this.from > e) || (t > -1 ? this.to <= e : this.to < e)) && this.parent(); )
      ;
    for (; this.enterChild(1, e, t); )
      ;
    return this;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) at the cursor's current
  position.
  */
  get node() {
    if (!this.buffer)
      return this._tree;
    let e = this.bufferNode, t = null, i = 0;
    if (e && e.context == this.buffer)
      e:
        for (let r = this.index, s = this.stack.length; s >= 0; ) {
          for (let o = e; o; o = o._parent)
            if (o.index == r) {
              if (r == this.index)
                return o;
              t = o, i = s + 1;
              break e;
            }
          r = this.stack[--s];
        }
    for (let r = i; r < this.stack.length; r++)
      t = new un(this.buffer, t, this.stack[r]);
    return this.bufferNode = new un(this.buffer, t, this.index);
  }
  /**
  Get the [tree](#common.Tree) that represents the current node, if
  any. Will return null when the node is in a [tree
  buffer](#common.TreeBuffer).
  */
  get tree() {
    return this.buffer ? null : this._tree._tree;
  }
  /**
  Iterate over the current node and all its descendants, calling
  `enter` when entering a node and `leave`, if given, when leaving
  one. When `enter` returns `false`, any children of that node are
  skipped, and `leave` isn't called for it.
  */
  iterate(e, t) {
    for (let i = 0; ; ) {
      let r = !1;
      if (this.type.isAnonymous || e(this) !== !1) {
        if (this.firstChild()) {
          i++;
          continue;
        }
        this.type.isAnonymous || (r = !0);
      }
      for (; r && t && t(this), r = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!i)
          return;
        this.parent(), i--, r = !0;
      }
    }
  }
  /**
  Test whether the current node matches a given context—a sequence
  of direct parent node names. Empty strings in the context array
  are treated as wildcards.
  */
  matchContext(e) {
    if (!this.buffer)
      return Ml(this.node, e);
    let { buffer: t } = this.buffer, { types: i } = t.set;
    for (let r = e.length - 1, s = this.stack.length - 1; r >= 0; s--) {
      if (s < 0)
        return Ml(this.node, e, r);
      let o = i[t.buffer[this.stack[s]]];
      if (!o.isAnonymous) {
        if (e[r] && e[r] != o.name)
          return !1;
        r--;
      }
    }
    return !0;
  }
}
function ha(n) {
  return n.children.some((e) => e instanceof yn || !e.type.isAnonymous || ha(e));
}
function q1(n) {
  var e;
  let { buffer: t, nodeSet: i, maxBufferLength: r = H1, reused: s = [], minRepeatType: o = i.types.length } = n, l = Array.isArray(t) ? new ca(t, t.length) : t, a = i.types, u = 0, c = 0;
  function h(A, b, S, L, P, k) {
    let { id: M, start: D, end: R, size: _ } = l, z = c;
    for (; _ < 0; )
      if (l.next(), _ == -1) {
        let x = s[M];
        S.push(x), L.push(D - A);
        return;
      } else if (_ == -3) {
        u = M;
        return;
      } else if (_ == -4) {
        c = M;
        return;
      } else
        throw new RangeError(`Unrecognized record size: ${_}`);
    let K = a[M], U, ne, ue = D - A;
    if (R - D <= r && (ne = m(l.pos - b, P))) {
      let x = new Uint16Array(ne.size - ne.skip), le = l.pos - ne.size, me = x.length;
      for (; l.pos > le; )
        me = y(ne.start, x, me);
      U = new yn(x, R - ne.start, i), ue = ne.start - A;
    } else {
      let x = l.pos - _;
      l.next();
      let le = [], me = [], w = M >= o ? M : -1, Se = 0, at = R;
      for (; l.pos > x; )
        w >= 0 && l.id == w && l.size >= 0 ? (l.end <= at - r && (p(le, me, D, Se, l.end, at, w, z), Se = le.length, at = l.end), l.next()) : k > 2500 ? f(D, x, le, me) : h(D, x, le, me, w, k + 1);
      if (w >= 0 && Se > 0 && Se < le.length && p(le, me, D, Se, D, at, w, z), le.reverse(), me.reverse(), w > -1 && Se > 0) {
        let Ce = d(K);
        U = fa(K, le, me, 0, le.length, 0, R - D, Ce, Ce);
      } else
        U = g(K, le, me, R - D, z - R);
    }
    S.push(U), L.push(ue);
  }
  function f(A, b, S, L) {
    let P = [], k = 0, M = -1;
    for (; l.pos > b; ) {
      let { id: D, start: R, end: _, size: z } = l;
      if (z > 4)
        l.next();
      else {
        if (M > -1 && R < M)
          break;
        M < 0 && (M = _ - r), P.push(D, R, _), k++, l.next();
      }
    }
    if (k) {
      let D = new Uint16Array(k * 4), R = P[P.length - 2];
      for (let _ = P.length - 3, z = 0; _ >= 0; _ -= 3)
        D[z++] = P[_], D[z++] = P[_ + 1] - R, D[z++] = P[_ + 2] - R, D[z++] = z;
      S.push(new yn(D, P[2] - R, i)), L.push(R - A);
    }
  }
  function d(A) {
    return (b, S, L) => {
      let P = 0, k = b.length - 1, M, D;
      if (k >= 0 && (M = b[k]) instanceof He) {
        if (!k && M.type == A && M.length == L)
          return M;
        (D = M.prop(ee.lookAhead)) && (P = S[k] + M.length + D);
      }
      return g(A, b, S, L, P);
    };
  }
  function p(A, b, S, L, P, k, M, D) {
    let R = [], _ = [];
    for (; A.length > L; )
      R.push(A.pop()), _.push(b.pop() + S - P);
    A.push(g(i.types[M], R, _, k - P, D - k)), b.push(P - S);
  }
  function g(A, b, S, L, P = 0, k) {
    if (u) {
      let M = [ee.contextHash, u];
      k = k ? [M].concat(k) : [M];
    }
    if (P > 25) {
      let M = [ee.lookAhead, P];
      k = k ? [M].concat(k) : [M];
    }
    return new He(A, b, S, L, k);
  }
  function m(A, b) {
    let S = l.fork(), L = 0, P = 0, k = 0, M = S.end - r, D = { size: 0, start: 0, skip: 0 };
    e:
      for (let R = S.pos - A; S.pos > R; ) {
        let _ = S.size;
        if (S.id == b && _ >= 0) {
          D.size = L, D.start = P, D.skip = k, k += 4, L += 4, S.next();
          continue;
        }
        let z = S.pos - _;
        if (_ < 0 || z < R || S.start < M)
          break;
        let K = S.id >= o ? 4 : 0, U = S.start;
        for (S.next(); S.pos > z; ) {
          if (S.size < 0)
            if (S.size == -3)
              K += 4;
            else
              break e;
          else
            S.id >= o && (K += 4);
          S.next();
        }
        P = U, L += _, k += K;
      }
    return (b < 0 || L == A) && (D.size = L, D.start = P, D.skip = k), D.size > 4 ? D : void 0;
  }
  function y(A, b, S) {
    let { id: L, start: P, end: k, size: M } = l;
    if (l.next(), M >= 0 && L < o) {
      let D = S;
      if (M > 4) {
        let R = l.pos - (M - 4);
        for (; l.pos > R; )
          S = y(A, b, S);
      }
      b[--S] = D, b[--S] = k - A, b[--S] = P - A, b[--S] = L;
    } else
      M == -3 ? u = L : M == -4 && (c = L);
    return S;
  }
  let v = [], C = [];
  for (; l.pos > 0; )
    h(n.start || 0, n.bufferStart || 0, v, C, -1, 0);
  let O = (e = n.length) !== null && e !== void 0 ? e : v.length ? C[0] + v[0].length : 0;
  return new He(a[n.topID], v.reverse(), C.reverse(), O);
}
const Ju = /* @__PURE__ */ new WeakMap();
function Qr(n, e) {
  if (!n.isAnonymous || e instanceof yn || e.type != n)
    return 1;
  let t = Ju.get(e);
  if (t == null) {
    t = 1;
    for (let i of e.children) {
      if (i.type != n || !(i instanceof He)) {
        t = 1;
        break;
      }
      t += Qr(n, i);
    }
    Ju.set(e, t);
  }
  return t;
}
function fa(n, e, t, i, r, s, o, l, a) {
  let u = 0;
  for (let p = i; p < r; p++)
    u += Qr(n, e[p]);
  let c = Math.ceil(
    u * 1.5 / 8
    /* Balance.BranchFactor */
  ), h = [], f = [];
  function d(p, g, m, y, v) {
    for (let C = m; C < y; ) {
      let O = C, A = g[C], b = Qr(n, p[C]);
      for (C++; C < y; C++) {
        let S = Qr(n, p[C]);
        if (b + S >= c)
          break;
        b += S;
      }
      if (C == O + 1) {
        if (b > c) {
          let S = p[O];
          d(S.children, S.positions, 0, S.children.length, g[O] + v);
          continue;
        }
        h.push(p[O]);
      } else {
        let S = g[C - 1] + p[C - 1].length - A;
        h.push(fa(n, p, g, O, C, A, S, null, a));
      }
      f.push(A + v - s);
    }
  }
  return d(e, t, i, r, 0), (l || a)(h, f, o);
}
class Ln {
  /**
  Construct a tree fragment. You'll usually want to use
  [`addTree`](#common.TreeFragment^addTree) and
  [`applyChanges`](#common.TreeFragment^applyChanges) instead of
  calling this directly.
  */
  constructor(e, t, i, r, s = !1, o = !1) {
    this.from = e, this.to = t, this.tree = i, this.offset = r, this.open = (s ? 1 : 0) | (o ? 2 : 0);
  }
  /**
  Whether the start of the fragment represents the start of a
  parse, or the end of a change. (In the second case, it may not
  be safe to reuse some nodes at the start, depending on the
  parsing algorithm.)
  */
  get openStart() {
    return (this.open & 1) > 0;
  }
  /**
  Whether the end of the fragment represents the end of a
  full-document parse, or the start of a change.
  */
  get openEnd() {
    return (this.open & 2) > 0;
  }
  /**
  Create a set of fragments from a freshly parsed tree, or update
  an existing set of fragments by replacing the ones that overlap
  with a tree with content from the new tree. When `partial` is
  true, the parse is treated as incomplete, and the resulting
  fragment has [`openEnd`](#common.TreeFragment.openEnd) set to
  true.
  */
  static addTree(e, t = [], i = !1) {
    let r = [new Ln(0, e.length, e, 0, !1, i)];
    for (let s of t)
      s.to > e.length && r.push(s);
    return r;
  }
  /**
  Apply a set of edits to an array of fragments, removing or
  splitting fragments as necessary to remove edited ranges, and
  adjusting offsets for fragments that moved.
  */
  static applyChanges(e, t, i = 128) {
    if (!t.length)
      return e;
    let r = [], s = 1, o = e.length ? e[0] : null;
    for (let l = 0, a = 0, u = 0; ; l++) {
      let c = l < t.length ? t[l] : null, h = c ? c.fromA : 1e9;
      if (h - a >= i)
        for (; o && o.from < h; ) {
          let f = o;
          if (a >= f.from || h <= f.to || u) {
            let d = Math.max(f.from, a) - u, p = Math.min(f.to, h) - u;
            f = d >= p ? null : new Ln(d, p, f.tree, f.offset + u, l > 0, !!c);
          }
          if (f && r.push(f), o.to > h)
            break;
          o = s < e.length ? e[s++] : null;
        }
      if (!c)
        break;
      a = c.toA, u = c.toA - c.toB;
    }
    return r;
  }
}
class U1 {
  /**
  Start a parse, returning a [partial parse](#common.PartialParse)
  object. [`fragments`](#common.TreeFragment) can be passed in to
  make the parse incremental.
  
  By default, the entire input is parsed. You can pass `ranges`,
  which should be a sorted array of non-empty, non-overlapping
  ranges, to parse only those ranges. The tree returned in that
  case will start at `ranges[0].from`.
  */
  startParse(e, t, i) {
    return typeof e == "string" && (e = new K1(e)), i = i ? i.length ? i.map((r) => new po(r.from, r.to)) : [new po(0, 0)] : [new po(0, e.length)], this.createParse(e, t || [], i);
  }
  /**
  Run a full parse, returning the resulting tree.
  */
  parse(e, t, i) {
    let r = this.startParse(e, t, i);
    for (; ; ) {
      let s = r.advance();
      if (s)
        return s;
    }
  }
}
class K1 {
  constructor(e) {
    this.string = e;
  }
  get length() {
    return this.string.length;
  }
  chunk(e) {
    return this.string.slice(e);
  }
  get lineChunks() {
    return !1;
  }
  read(e, t) {
    return this.string.slice(e, t);
  }
}
new ee({ perNode: !0 });
let G1 = 0;
class It {
  /**
  @internal
  */
  constructor(e, t, i) {
    this.set = e, this.base = t, this.modified = i, this.id = G1++;
  }
  /**
  Define a new tag. If `parent` is given, the tag is treated as a
  sub-tag of that parent, and
  [highlighters](#highlight.tagHighlighter) that don't mention
  this tag will try to fall back to the parent tag (or grandparent
  tag, etc).
  */
  static define(e) {
    if (e != null && e.base)
      throw new Error("Can not derive from a modified tag");
    let t = new It([], null, []);
    if (t.set.push(t), e)
      for (let i of e.set)
        t.set.push(i);
    return t;
  }
  /**
  Define a tag _modifier_, which is a function that, given a tag,
  will return a tag that is a subtag of the original. Applying the
  same modifier to a twice tag will return the same value (`m1(t1)
  == m1(t1)`) and applying multiple modifiers will, regardless or
  order, produce the same tag (`m1(m2(t1)) == m2(m1(t1))`).
  
  When multiple modifiers are applied to a given base tag, each
  smaller set of modifiers is registered as a parent, so that for
  example `m1(m2(m3(t1)))` is a subtype of `m1(m2(t1))`,
  `m1(m3(t1)`, and so on.
  */
  static defineModifier() {
    let e = new cs();
    return (t) => t.modified.indexOf(e) > -1 ? t : cs.get(t.base || t, t.modified.concat(e).sort((i, r) => i.id - r.id));
  }
}
let Y1 = 0;
class cs {
  constructor() {
    this.instances = [], this.id = Y1++;
  }
  static get(e, t) {
    if (!t.length)
      return e;
    let i = t[0].instances.find((l) => l.base == e && X1(t, l.modified));
    if (i)
      return i;
    let r = [], s = new It(r, e, t);
    for (let l of t)
      l.instances.push(s);
    let o = J1(t);
    for (let l of e.set)
      if (!l.modified.length)
        for (let a of o)
          r.push(cs.get(l, a));
    return s;
  }
}
function X1(n, e) {
  return n.length == e.length && n.every((t, i) => t == e[i]);
}
function J1(n) {
  let e = [[]];
  for (let t = 0; t < n.length; t++)
    for (let i = 0, r = e.length; i < r; i++)
      e.push(e[i].concat(n[t]));
  return e.sort((t, i) => i.length - t.length);
}
function Q1(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t in n) {
    let i = n[t];
    Array.isArray(i) || (i = [i]);
    for (let r of t.split(" "))
      if (r) {
        let s = [], o = 2, l = r;
        for (let h = 0; ; ) {
          if (l == "..." && h > 0 && h + 3 == r.length) {
            o = 1;
            break;
          }
          let f = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(l);
          if (!f)
            throw new RangeError("Invalid path: " + r);
          if (s.push(f[0] == "*" ? "" : f[0][0] == '"' ? JSON.parse(f[0]) : f[0]), h += f[0].length, h == r.length)
            break;
          let d = r[h++];
          if (h == r.length && d == "!") {
            o = 0;
            break;
          }
          if (d != "/")
            throw new RangeError("Invalid path: " + r);
          l = r.slice(h);
        }
        let a = s.length - 1, u = s[a];
        if (!u)
          throw new RangeError("Invalid path: " + r);
        let c = new hs(i, o, a > 0 ? s.slice(0, a) : null);
        e[u] = c.sort(e[u]);
      }
  }
  return ed.add(e);
}
const ed = new ee();
class hs {
  constructor(e, t, i, r) {
    this.tags = e, this.mode = t, this.context = i, this.next = r;
  }
  get opaque() {
    return this.mode == 0;
  }
  get inherit() {
    return this.mode == 1;
  }
  sort(e) {
    return !e || e.depth < this.depth ? (this.next = e, this) : (e.next = this.sort(e.next), e);
  }
  get depth() {
    return this.context ? this.context.length : 0;
  }
}
hs.empty = new hs([], 2, null);
function td(n, e) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let s of n)
    if (!Array.isArray(s.tag))
      t[s.tag.id] = s.class;
    else
      for (let o of s.tag)
        t[o.id] = s.class;
  let { scope: i, all: r = null } = e || {};
  return {
    style: (s) => {
      let o = r;
      for (let l of s)
        for (let a of l.set) {
          let u = t[a.id];
          if (u) {
            o = o ? o + " " + u : u;
            break;
          }
        }
      return o;
    },
    scope: i
  };
}
function Z1(n, e) {
  let t = null;
  for (let i of n) {
    let r = i.style(e);
    r && (t = t ? t + " " + r : r);
  }
  return t;
}
function ey(n, e, t, i = 0, r = n.length) {
  let s = new ty(i, Array.isArray(e) ? e : [e], t);
  s.highlightRange(n.cursor(), i, r, "", s.highlighters), s.flush(r);
}
class ty {
  constructor(e, t, i) {
    this.at = e, this.highlighters = t, this.span = i, this.class = "";
  }
  startSpan(e, t) {
    t != this.class && (this.flush(e), e > this.at && (this.at = e), this.class = t);
  }
  flush(e) {
    e > this.at && this.class && this.span(this.at, e, this.class);
  }
  highlightRange(e, t, i, r, s) {
    let { type: o, from: l, to: a } = e;
    if (l >= i || a <= t)
      return;
    o.isTop && (s = this.highlighters.filter((d) => !d.scope || d.scope(o)));
    let u = r, c = ny(e) || hs.empty, h = Z1(s, c.tags);
    if (h && (u && (u += " "), u += h, c.mode == 1 && (r += (r ? " " : "") + h)), this.startSpan(Math.max(t, l), u), c.opaque)
      return;
    let f = e.tree && e.tree.prop(ee.mounted);
    if (f && f.overlay) {
      let d = e.node.enter(f.overlay[0].from + l, 1), p = this.highlighters.filter((m) => !m.scope || m.scope(f.tree.type)), g = e.firstChild();
      for (let m = 0, y = l; ; m++) {
        let v = m < f.overlay.length ? f.overlay[m] : null, C = v ? v.from + l : a, O = Math.max(t, y), A = Math.min(i, C);
        if (O < A && g)
          for (; e.from < A && (this.highlightRange(e, O, A, r, s), this.startSpan(Math.min(A, e.to), u), !(e.to >= C || !e.nextSibling())); )
            ;
        if (!v || C > i)
          break;
        y = v.to + l, y > t && (this.highlightRange(d.cursor(), Math.max(t, v.from + l), Math.min(i, y), "", p), this.startSpan(Math.min(i, y), u));
      }
      g && e.parent();
    } else if (e.firstChild()) {
      f && (r = "");
      do
        if (!(e.to <= t)) {
          if (e.from >= i)
            break;
          this.highlightRange(e, t, i, r, s), this.startSpan(Math.min(i, e.to), u);
        }
      while (e.nextSibling());
      e.parent();
    }
  }
}
function ny(n) {
  let e = n.type.prop(ed);
  for (; e && e.context && !n.matchContext(e.context); )
    e = e.next;
  return e || null;
}
const N = It.define, Or = N(), tn = N(), Qu = N(tn), Zu = N(tn), nn = N(), Dr = N(nn), mo = N(nn), Et = N(), Cn = N(Et), Ot = N(), Dt = N(), Ol = N(), Ci = N(Ol), Er = N(), H = {
  /**
  A comment.
  */
  comment: Or,
  /**
  A line [comment](#highlight.tags.comment).
  */
  lineComment: N(Or),
  /**
  A block [comment](#highlight.tags.comment).
  */
  blockComment: N(Or),
  /**
  A documentation [comment](#highlight.tags.comment).
  */
  docComment: N(Or),
  /**
  Any kind of identifier.
  */
  name: tn,
  /**
  The [name](#highlight.tags.name) of a variable.
  */
  variableName: N(tn),
  /**
  A type [name](#highlight.tags.name).
  */
  typeName: Qu,
  /**
  A tag name (subtag of [`typeName`](#highlight.tags.typeName)).
  */
  tagName: N(Qu),
  /**
  A property or field [name](#highlight.tags.name).
  */
  propertyName: Zu,
  /**
  An attribute name (subtag of [`propertyName`](#highlight.tags.propertyName)).
  */
  attributeName: N(Zu),
  /**
  The [name](#highlight.tags.name) of a class.
  */
  className: N(tn),
  /**
  A label [name](#highlight.tags.name).
  */
  labelName: N(tn),
  /**
  A namespace [name](#highlight.tags.name).
  */
  namespace: N(tn),
  /**
  The [name](#highlight.tags.name) of a macro.
  */
  macroName: N(tn),
  /**
  A literal value.
  */
  literal: nn,
  /**
  A string [literal](#highlight.tags.literal).
  */
  string: Dr,
  /**
  A documentation [string](#highlight.tags.string).
  */
  docString: N(Dr),
  /**
  A character literal (subtag of [string](#highlight.tags.string)).
  */
  character: N(Dr),
  /**
  An attribute value (subtag of [string](#highlight.tags.string)).
  */
  attributeValue: N(Dr),
  /**
  A number [literal](#highlight.tags.literal).
  */
  number: mo,
  /**
  An integer [number](#highlight.tags.number) literal.
  */
  integer: N(mo),
  /**
  A floating-point [number](#highlight.tags.number) literal.
  */
  float: N(mo),
  /**
  A boolean [literal](#highlight.tags.literal).
  */
  bool: N(nn),
  /**
  Regular expression [literal](#highlight.tags.literal).
  */
  regexp: N(nn),
  /**
  An escape [literal](#highlight.tags.literal), for example a
  backslash escape in a string.
  */
  escape: N(nn),
  /**
  A color [literal](#highlight.tags.literal).
  */
  color: N(nn),
  /**
  A URL [literal](#highlight.tags.literal).
  */
  url: N(nn),
  /**
  A language keyword.
  */
  keyword: Ot,
  /**
  The [keyword](#highlight.tags.keyword) for the self or this
  object.
  */
  self: N(Ot),
  /**
  The [keyword](#highlight.tags.keyword) for null.
  */
  null: N(Ot),
  /**
  A [keyword](#highlight.tags.keyword) denoting some atomic value.
  */
  atom: N(Ot),
  /**
  A [keyword](#highlight.tags.keyword) that represents a unit.
  */
  unit: N(Ot),
  /**
  A modifier [keyword](#highlight.tags.keyword).
  */
  modifier: N(Ot),
  /**
  A [keyword](#highlight.tags.keyword) that acts as an operator.
  */
  operatorKeyword: N(Ot),
  /**
  A control-flow related [keyword](#highlight.tags.keyword).
  */
  controlKeyword: N(Ot),
  /**
  A [keyword](#highlight.tags.keyword) that defines something.
  */
  definitionKeyword: N(Ot),
  /**
  A [keyword](#highlight.tags.keyword) related to defining or
  interfacing with modules.
  */
  moduleKeyword: N(Ot),
  /**
  An operator.
  */
  operator: Dt,
  /**
  An [operator](#highlight.tags.operator) that dereferences something.
  */
  derefOperator: N(Dt),
  /**
  Arithmetic-related [operator](#highlight.tags.operator).
  */
  arithmeticOperator: N(Dt),
  /**
  Logical [operator](#highlight.tags.operator).
  */
  logicOperator: N(Dt),
  /**
  Bit [operator](#highlight.tags.operator).
  */
  bitwiseOperator: N(Dt),
  /**
  Comparison [operator](#highlight.tags.operator).
  */
  compareOperator: N(Dt),
  /**
  [Operator](#highlight.tags.operator) that updates its operand.
  */
  updateOperator: N(Dt),
  /**
  [Operator](#highlight.tags.operator) that defines something.
  */
  definitionOperator: N(Dt),
  /**
  Type-related [operator](#highlight.tags.operator).
  */
  typeOperator: N(Dt),
  /**
  Control-flow [operator](#highlight.tags.operator).
  */
  controlOperator: N(Dt),
  /**
  Program or markup punctuation.
  */
  punctuation: Ol,
  /**
  [Punctuation](#highlight.tags.punctuation) that separates
  things.
  */
  separator: N(Ol),
  /**
  Bracket-style [punctuation](#highlight.tags.punctuation).
  */
  bracket: Ci,
  /**
  Angle [brackets](#highlight.tags.bracket) (usually `<` and `>`
  tokens).
  */
  angleBracket: N(Ci),
  /**
  Square [brackets](#highlight.tags.bracket) (usually `[` and `]`
  tokens).
  */
  squareBracket: N(Ci),
  /**
  Parentheses (usually `(` and `)` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  paren: N(Ci),
  /**
  Braces (usually `{` and `}` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  brace: N(Ci),
  /**
  Content, for example plain text in XML or markup documents.
  */
  content: Et,
  /**
  [Content](#highlight.tags.content) that represents a heading.
  */
  heading: Cn,
  /**
  A level 1 [heading](#highlight.tags.heading).
  */
  heading1: N(Cn),
  /**
  A level 2 [heading](#highlight.tags.heading).
  */
  heading2: N(Cn),
  /**
  A level 3 [heading](#highlight.tags.heading).
  */
  heading3: N(Cn),
  /**
  A level 4 [heading](#highlight.tags.heading).
  */
  heading4: N(Cn),
  /**
  A level 5 [heading](#highlight.tags.heading).
  */
  heading5: N(Cn),
  /**
  A level 6 [heading](#highlight.tags.heading).
  */
  heading6: N(Cn),
  /**
  A prose separator (such as a horizontal rule).
  */
  contentSeparator: N(Et),
  /**
  [Content](#highlight.tags.content) that represents a list.
  */
  list: N(Et),
  /**
  [Content](#highlight.tags.content) that represents a quote.
  */
  quote: N(Et),
  /**
  [Content](#highlight.tags.content) that is emphasized.
  */
  emphasis: N(Et),
  /**
  [Content](#highlight.tags.content) that is styled strong.
  */
  strong: N(Et),
  /**
  [Content](#highlight.tags.content) that is part of a link.
  */
  link: N(Et),
  /**
  [Content](#highlight.tags.content) that is styled as code or
  monospace.
  */
  monospace: N(Et),
  /**
  [Content](#highlight.tags.content) that has a strike-through
  style.
  */
  strikethrough: N(Et),
  /**
  Inserted text in a change-tracking format.
  */
  inserted: N(),
  /**
  Deleted text.
  */
  deleted: N(),
  /**
  Changed text.
  */
  changed: N(),
  /**
  An invalid or unsyntactic element.
  */
  invalid: N(),
  /**
  Metadata or meta-instruction.
  */
  meta: Er,
  /**
  [Metadata](#highlight.tags.meta) that applies to the entire
  document.
  */
  documentMeta: N(Er),
  /**
  [Metadata](#highlight.tags.meta) that annotates or adds
  attributes to a given syntactic element.
  */
  annotation: N(Er),
  /**
  Processing instruction or preprocessor directive. Subtag of
  [meta](#highlight.tags.meta).
  */
  processingInstruction: N(Er),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that a
  given element is being defined. Expected to be used with the
  various [name](#highlight.tags.name) tags.
  */
  definition: It.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that
  something is constant. Mostly expected to be used with
  [variable names](#highlight.tags.variableName).
  */
  constant: It.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) used to indicate that
  a [variable](#highlight.tags.variableName) or [property
  name](#highlight.tags.propertyName) is being called or defined
  as a function.
  */
  function: It.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that can be applied to
  [names](#highlight.tags.name) to indicate that they belong to
  the language's standard environment.
  */
  standard: It.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates a given
  [names](#highlight.tags.name) is local to some scope.
  */
  local: It.defineModifier(),
  /**
  A generic variant [modifier](#highlight.Tag^defineModifier) that
  can be used to tag language-specific alternative variants of
  some common tag. It is recommended for themes to define special
  forms of at least the [string](#highlight.tags.string) and
  [variable name](#highlight.tags.variableName) tags, since those
  come up a lot.
  */
  special: It.defineModifier()
};
td([
  { tag: H.link, class: "tok-link" },
  { tag: H.heading, class: "tok-heading" },
  { tag: H.emphasis, class: "tok-emphasis" },
  { tag: H.strong, class: "tok-strong" },
  { tag: H.keyword, class: "tok-keyword" },
  { tag: H.atom, class: "tok-atom" },
  { tag: H.bool, class: "tok-bool" },
  { tag: H.url, class: "tok-url" },
  { tag: H.labelName, class: "tok-labelName" },
  { tag: H.inserted, class: "tok-inserted" },
  { tag: H.deleted, class: "tok-deleted" },
  { tag: H.literal, class: "tok-literal" },
  { tag: H.string, class: "tok-string" },
  { tag: H.number, class: "tok-number" },
  { tag: [H.regexp, H.escape, H.special(H.string)], class: "tok-string2" },
  { tag: H.variableName, class: "tok-variableName" },
  { tag: H.local(H.variableName), class: "tok-variableName tok-local" },
  { tag: H.definition(H.variableName), class: "tok-variableName tok-definition" },
  { tag: H.special(H.variableName), class: "tok-variableName2" },
  { tag: H.definition(H.propertyName), class: "tok-propertyName tok-definition" },
  { tag: H.typeName, class: "tok-typeName" },
  { tag: H.namespace, class: "tok-namespace" },
  { tag: H.className, class: "tok-className" },
  { tag: H.macroName, class: "tok-macroName" },
  { tag: H.propertyName, class: "tok-propertyName" },
  { tag: H.operator, class: "tok-operator" },
  { tag: H.comment, class: "tok-comment" },
  { tag: H.meta, class: "tok-meta" },
  { tag: H.invalid, class: "tok-invalid" },
  { tag: H.punctuation, class: "tok-punctuation" }
]);
var go;
const Ri = /* @__PURE__ */ new ee(), iy = /* @__PURE__ */ new ee();
class Rt {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(e, t, i = [], r = "") {
    this.data = e, this.name = r, Q.prototype.hasOwnProperty("tree") || Object.defineProperty(Q.prototype, "tree", { get() {
      return _e(this);
    } }), this.parser = t, this.extension = [
      bn.of(this),
      Q.languageData.of((s, o, l) => {
        let a = ec(s, o, l), u = a.type.prop(Ri);
        if (!u)
          return [];
        let c = s.facet(u), h = a.type.prop(iy);
        if (h) {
          let f = a.resolve(o - a.from, l);
          for (let d of h)
            if (d.test(f, s)) {
              let p = s.facet(d.facet);
              return d.type == "replace" ? p : p.concat(c);
            }
        }
        return c;
      })
    ].concat(i);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(e, t, i = -1) {
    return ec(e, t, i).type.prop(Ri) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(e) {
    let t = e.facet(bn);
    if ((t == null ? void 0 : t.data) == this.data)
      return [{ from: 0, to: e.doc.length }];
    if (!t || !t.allowsNesting)
      return [];
    let i = [], r = (s, o) => {
      if (s.prop(Ri) == this.data) {
        i.push({ from: o, to: o + s.length });
        return;
      }
      let l = s.prop(ee.mounted);
      if (l) {
        if (l.tree.prop(Ri) == this.data) {
          if (l.overlay)
            for (let a of l.overlay)
              i.push({ from: a.from + o, to: a.to + o });
          else
            i.push({ from: o, to: o + s.length });
          return;
        } else if (l.overlay) {
          let a = i.length;
          if (r(l.tree, l.overlay[0].from + o), i.length > a)
            return;
        }
      }
      for (let a = 0; a < s.children.length; a++) {
        let u = s.children[a];
        u instanceof He && r(u, s.positions[a] + o);
      }
    };
    return r(_e(e), 0), i;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
Rt.setState = /* @__PURE__ */ X.define();
function ec(n, e, t) {
  let i = n.facet(bn), r = _e(n).topNode;
  if (!i || i.allowsNesting)
    for (let s = r; s; s = s.enter(e, t, Pe.ExcludeBuffers))
      s.type.isTop && (r = s);
  return r;
}
function _e(n) {
  let e = n.field(Rt.state, !1);
  return e ? e.tree : He.empty;
}
class ry {
  /**
  Create an input object for the given document.
  */
  constructor(e) {
    this.doc = e, this.cursorPos = 0, this.string = "", this.cursor = e.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(e) {
    return this.string = this.cursor.next(e - this.cursorPos).value, this.cursorPos = e + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(e) {
    return this.syncTo(e), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(e, t) {
    let i = this.cursorPos - this.string.length;
    return e < i || t >= this.cursorPos ? this.doc.sliceString(e, t) : this.string.slice(e - i, t - i);
  }
}
let Ai = null;
class fs {
  constructor(e, t, i = [], r, s, o, l, a) {
    this.parser = e, this.state = t, this.fragments = i, this.tree = r, this.treeLen = s, this.viewport = o, this.skipped = l, this.scheduleOn = a, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new fs(e, t, [], He.empty, 0, i, [], null);
  }
  startParse() {
    return this.parser.startParse(new ry(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(e, t) {
    return t != null && t >= this.state.doc.length && (t = void 0), this.tree != He.empty && this.isDone(t ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var i;
      if (typeof e == "number") {
        let r = Date.now() + e;
        e = () => Date.now() > r;
      }
      for (this.parse || (this.parse = this.startParse()), t != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > t) && t < this.state.doc.length && this.parse.stopAt(t); ; ) {
        let r = this.parse.advance();
        if (r)
          if (this.fragments = this.withoutTempSkipped(Ln.addTree(r, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (i = this.parse.stoppedAt) !== null && i !== void 0 ? i : this.state.doc.length, this.tree = r, this.parse = null, this.treeLen < (t ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (e())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let e, t;
    this.parse && (e = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > e) && this.parse.stopAt(e), this.withContext(() => {
      for (; !(t = this.parse.advance()); )
        ;
    }), this.treeLen = e, this.tree = t, this.fragments = this.withoutTempSkipped(Ln.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(e) {
    let t = Ai;
    Ai = this;
    try {
      return e();
    } finally {
      Ai = t;
    }
  }
  withoutTempSkipped(e) {
    for (let t; t = this.tempSkipped.pop(); )
      e = tc(e, t.from, t.to);
    return e;
  }
  /**
  @internal
  */
  changes(e, t) {
    let { fragments: i, tree: r, treeLen: s, viewport: o, skipped: l } = this;
    if (this.takeTree(), !e.empty) {
      let a = [];
      if (e.iterChangedRanges((u, c, h, f) => a.push({ fromA: u, toA: c, fromB: h, toB: f })), i = Ln.applyChanges(i, a), r = He.empty, s = 0, o = { from: e.mapPos(o.from, -1), to: e.mapPos(o.to, 1) }, this.skipped.length) {
        l = [];
        for (let u of this.skipped) {
          let c = e.mapPos(u.from, 1), h = e.mapPos(u.to, -1);
          c < h && l.push({ from: c, to: h });
        }
      }
    }
    return new fs(this.parser, t, i, r, s, o, l, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(e) {
    if (this.viewport.from == e.from && this.viewport.to == e.to)
      return !1;
    this.viewport = e;
    let t = this.skipped.length;
    for (let i = 0; i < this.skipped.length; i++) {
      let { from: r, to: s } = this.skipped[i];
      r < e.to && s > e.from && (this.fragments = tc(this.fragments, r, s), this.skipped.splice(i--, 1));
    }
    return this.skipped.length >= t ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(e, t) {
    this.skipped.push({ from: e, to: t });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(e) {
    return new class extends U1 {
      createParse(t, i, r) {
        let s = r[0].from, o = r[r.length - 1].to;
        return {
          parsedPos: s,
          advance() {
            let a = Ai;
            if (a) {
              for (let u of r)
                a.tempSkipped.push(u);
              e && (a.scheduleOn = a.scheduleOn ? Promise.all([a.scheduleOn, e]) : e);
            }
            return this.parsedPos = o, new He(bt.none, [], [], o - s);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(e) {
    e = Math.min(e, this.state.doc.length);
    let t = this.fragments;
    return this.treeLen >= e && t.length && t[0].from == 0 && t[0].to >= e;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return Ai;
  }
}
function tc(n, e, t) {
  return Ln.applyChanges(n, [{ fromA: e, toA: t, fromB: e, toB: t }]);
}
class ui {
  constructor(e) {
    this.context = e, this.tree = e.tree;
  }
  apply(e) {
    if (!e.docChanged && this.tree == this.context.tree)
      return this;
    let t = this.context.changes(e.changes, e.state), i = this.context.treeLen == e.startState.doc.length ? void 0 : Math.max(e.changes.mapPos(this.context.treeLen), t.viewport.to);
    return t.work(20, i) || t.takeTree(), new ui(t);
  }
  static init(e) {
    let t = Math.min(3e3, e.doc.length), i = fs.create(e.facet(bn).parser, e, { from: 0, to: t });
    return i.work(20, t) || i.takeTree(), new ui(i);
  }
}
Rt.state = /* @__PURE__ */ Ne.define({
  create: ui.init,
  update(n, e) {
    for (let t of e.effects)
      if (t.is(Rt.setState))
        return t.value;
    return e.startState.facet(bn) != e.state.facet(bn) ? ui.init(e.state) : n.apply(e);
  }
});
let nd = (n) => {
  let e = setTimeout(
    () => n(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(e);
};
typeof requestIdleCallback < "u" && (nd = (n) => {
  let e = -1, t = setTimeout(
    () => {
      e = requestIdleCallback(n, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => e < 0 ? clearTimeout(t) : cancelIdleCallback(e);
});
const yo = typeof navigator < "u" && (!((go = navigator.scheduling) === null || go === void 0) && go.isInputPending) ? () => navigator.scheduling.isInputPending() : null, sy = /* @__PURE__ */ ke.fromClass(class {
  constructor(e) {
    this.view = e, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(e) {
    let t = this.view.state.field(Rt.state).context;
    (t.updateViewport(e.view.viewport) || this.view.viewport.to > t.treeLen) && this.scheduleWork(), (e.docChanged || e.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(t);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: e } = this.view, t = e.field(Rt.state);
    (t.tree != t.context.tree || !t.context.isDone(e.doc.length)) && (this.working = nd(this.work));
  }
  work(e) {
    this.working = null;
    let t = Date.now();
    if (this.chunkEnd < t && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = t + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: i, viewport: { to: r } } = this.view, s = i.field(Rt.state);
    if (s.tree == s.context.tree && s.context.isDone(
      r + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let o = Date.now() + Math.min(this.chunkBudget, 100, e && !yo ? Math.max(25, e.timeRemaining() - 5) : 1e9), l = s.context.treeLen < r && i.doc.length > r + 1e3, a = s.context.work(() => yo && yo() || Date.now() > o, r + (l ? 0 : 1e5));
    this.chunkBudget -= Date.now() - t, (a || this.chunkBudget <= 0) && (s.context.takeTree(), this.view.dispatch({ effects: Rt.setState.of(new ui(s.context)) })), this.chunkBudget > 0 && !(a && !l) && this.scheduleWork(), this.checkAsyncSchedule(s.context);
  }
  checkAsyncSchedule(e) {
    e.scheduleOn && (this.workScheduled++, e.scheduleOn.then(() => this.scheduleWork()).catch((t) => Je(this.view.state, t)).then(() => this.workScheduled--), e.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), bn = /* @__PURE__ */ j.define({
  combine(n) {
    return n.length ? n[0] : null;
  },
  enables: (n) => [
    Rt.state,
    sy,
    V.contentAttributes.compute([n], (e) => {
      let t = e.facet(n);
      return t && t.name ? { "data-language": t.name } : {};
    })
  ]
}), oy = /* @__PURE__ */ j.define(), zs = /* @__PURE__ */ j.define({
  combine: (n) => {
    if (!n.length)
      return "  ";
    let e = n[0];
    if (!e || /\S/.test(e) || Array.from(e).some((t) => t != e[0]))
      throw new Error("Invalid indent unit: " + JSON.stringify(n[0]));
    return e;
  }
});
function ds(n) {
  let e = n.facet(zs);
  return e.charCodeAt(0) == 9 ? n.tabSize * e.length : e.length;
}
function Zi(n, e) {
  let t = "", i = n.tabSize, r = n.facet(zs)[0];
  if (r == "	") {
    for (; e >= i; )
      t += "	", e -= i;
    r = " ";
  }
  for (let s = 0; s < e; s++)
    t += r;
  return t;
}
function da(n, e) {
  n instanceof Q && (n = new Hs(n));
  for (let i of n.state.facet(oy)) {
    let r = i(n, e);
    if (r !== void 0)
      return r;
  }
  let t = _e(n.state);
  return t.length >= e ? ay(n, t, e) : null;
}
class Hs {
  /**
  Create an indent context.
  */
  constructor(e, t = {}) {
    this.state = e, this.options = t, this.unit = ds(e);
  }
  /**
  Get a description of the line at the given position, taking
  [simulated line
  breaks](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  into account. If there is such a break at `pos`, the `bias`
  argument determines whether the part of the line line before or
  after the break is used.
  */
  lineAt(e, t = 1) {
    let i = this.state.doc.lineAt(e), { simulateBreak: r, simulateDoubleBreak: s } = this.options;
    return r != null && r >= i.from && r <= i.to ? s && r == e ? { text: "", from: e } : (t < 0 ? r < e : r <= e) ? { text: i.text.slice(r - i.from), from: r } : { text: i.text.slice(0, r - i.from), from: i.from } : i;
  }
  /**
  Get the text directly after `pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  textAfterPos(e, t = 1) {
    if (this.options.simulateDoubleBreak && e == this.options.simulateBreak)
      return "";
    let { text: i, from: r } = this.lineAt(e, t);
    return i.slice(e - r, Math.min(i.length, e + 100 - r));
  }
  /**
  Find the column for the given position.
  */
  column(e, t = 1) {
    let { text: i, from: r } = this.lineAt(e, t), s = this.countColumn(i, e - r), o = this.options.overrideIndentation ? this.options.overrideIndentation(r) : -1;
    return o > -1 && (s += o - this.countColumn(i, i.search(/\S|$/))), s;
  }
  /**
  Find the column position (taking tabs into account) of the given
  position in the given string.
  */
  countColumn(e, t = e.length) {
    return di(e, this.state.tabSize, t);
  }
  /**
  Find the indentation column of the line at the given point.
  */
  lineIndent(e, t = 1) {
    let { text: i, from: r } = this.lineAt(e, t), s = this.options.overrideIndentation;
    if (s) {
      let o = s(r);
      if (o > -1)
        return o;
    }
    return this.countColumn(i, i.search(/\S|$/));
  }
  /**
  Returns the [simulated line
  break](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  for this context, if any.
  */
  get simulatedBreak() {
    return this.options.simulateBreak || null;
  }
}
const ly = /* @__PURE__ */ new ee();
function ay(n, e, t) {
  let i = e.resolveStack(t), r = i.node.enterUnfinishedNodesBefore(t);
  if (r != i.node) {
    let s = [];
    for (let o = r; o != i.node; o = o.parent)
      s.push(o);
    for (let o = s.length - 1; o >= 0; o--)
      i = { node: s[o], next: i };
  }
  return id(i, n, t);
}
function id(n, e, t) {
  for (let i = n; i; i = i.next) {
    let r = cy(i.node);
    if (r)
      return r(pa.create(e, t, i));
  }
  return 0;
}
function uy(n) {
  return n.pos == n.options.simulateBreak && n.options.simulateDoubleBreak;
}
function cy(n) {
  let e = n.type.prop(ly);
  if (e)
    return e;
  let t = n.firstChild, i;
  if (t && (i = t.type.prop(ee.closedBy))) {
    let r = n.lastChild, s = r && i.indexOf(r.name) > -1;
    return (o) => py(o, !0, 1, void 0, s && !uy(o) ? r.from : void 0);
  }
  return n.parent == null ? hy : null;
}
function hy() {
  return 0;
}
class pa extends Hs {
  constructor(e, t, i) {
    super(e.state, e.options), this.base = e, this.pos = t, this.context = i;
  }
  /**
  The syntax tree node to which the indentation strategy
  applies.
  */
  get node() {
    return this.context.node;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new pa(e, t, i);
  }
  /**
  Get the text directly after `this.pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  get textAfter() {
    return this.textAfterPos(this.pos);
  }
  /**
  Get the indentation at the reference line for `this.node`, which
  is the line on which it starts, unless there is a node that is
  _not_ a parent of this node covering the start of that line. If
  so, the line at the start of that node is tried, again skipping
  on if it is covered by another such node.
  */
  get baseIndent() {
    return this.baseIndentFor(this.node);
  }
  /**
  Get the indentation for the reference line of the given node
  (see [`baseIndent`](https://codemirror.net/6/docs/ref/#language.TreeIndentContext.baseIndent)).
  */
  baseIndentFor(e) {
    let t = this.state.doc.lineAt(e.from);
    for (; ; ) {
      let i = e.resolve(t.from);
      for (; i.parent && i.parent.from == i.from; )
        i = i.parent;
      if (fy(i, e))
        break;
      t = this.state.doc.lineAt(i.from);
    }
    return this.lineIndent(t.from);
  }
  /**
  Continue looking for indentations in the node's parent nodes,
  and return the result of that.
  */
  continue() {
    return id(this.context.next, this.base, this.pos);
  }
}
function fy(n, e) {
  for (let t = e; t; t = t.parent)
    if (n == t)
      return !0;
  return !1;
}
function dy(n) {
  let e = n.node, t = e.childAfter(e.from), i = e.lastChild;
  if (!t)
    return null;
  let r = n.options.simulateBreak, s = n.state.doc.lineAt(t.from), o = r == null || r <= s.from ? s.to : Math.min(s.to, r);
  for (let l = t.to; ; ) {
    let a = e.childAfter(l);
    if (!a || a == i)
      return null;
    if (!a.type.isSkipped)
      return a.from < o ? t : null;
    l = a.to;
  }
}
function py(n, e, t, i, r) {
  let s = n.textAfter, o = s.match(/^\s*/)[0].length, l = r == n.pos + o, a = dy(n);
  return a ? l ? n.column(a.from) : n.column(a.to) : n.baseIndent + (l ? 0 : n.unit * t);
}
const my = 200;
function gy() {
  return Q.transactionFilter.of((n) => {
    if (!n.docChanged || !n.isUserEvent("input.type") && !n.isUserEvent("input.complete"))
      return n;
    let e = n.startState.languageDataAt("indentOnInput", n.startState.selection.main.head);
    if (!e.length)
      return n;
    let t = n.newDoc, { head: i } = n.newSelection.main, r = t.lineAt(i);
    if (i > r.from + my)
      return n;
    let s = t.sliceString(r.from, i);
    if (!e.some((u) => u.test(s)))
      return n;
    let { state: o } = n, l = -1, a = [];
    for (let { head: u } of o.selection.ranges) {
      let c = o.doc.lineAt(u);
      if (c.from == l)
        continue;
      l = c.from;
      let h = da(o, c.from);
      if (h == null)
        continue;
      let f = /^\s*/.exec(c.text)[0], d = Zi(o, h);
      f != d && a.push({ from: c.from, to: c.from + f.length, insert: d });
    }
    return a.length ? [n, { changes: a, sequential: !0 }] : n;
  });
}
const yy = /* @__PURE__ */ j.define(), by = /* @__PURE__ */ new ee();
function xy(n, e, t) {
  let i = _e(n);
  if (i.length < t)
    return null;
  let r = i.resolveStack(t, 1), s = null;
  for (let o = r; o; o = o.next) {
    let l = o.node;
    if (l.to <= t || l.from > t)
      continue;
    if (s && l.from < e)
      break;
    let a = l.type.prop(by);
    if (a && (l.to < i.length - 50 || i.length == n.doc.length || !wy(l))) {
      let u = a(l, n);
      u && u.from <= t && u.from >= e && u.to > t && (s = u);
    }
  }
  return s;
}
function wy(n) {
  let e = n.lastChild;
  return e && e.to == n.to && e.type.isError;
}
function ps(n, e, t) {
  for (let i of n.facet(yy)) {
    let r = i(n, e, t);
    if (r)
      return r;
  }
  return xy(n, e, t);
}
function rd(n, e) {
  let t = e.mapPos(n.from, 1), i = e.mapPos(n.to, -1);
  return t >= i ? void 0 : { from: t, to: i };
}
const Vs = /* @__PURE__ */ X.define({ map: rd }), lr = /* @__PURE__ */ X.define({ map: rd });
function sd(n) {
  let e = [];
  for (let { head: t } of n.state.selection.ranges)
    e.some((i) => i.from <= t && i.to >= t) || e.push(n.lineBlockAt(t));
  return e;
}
const Fn = /* @__PURE__ */ Ne.define({
  create() {
    return q.none;
  },
  update(n, e) {
    n = n.map(e.changes);
    for (let t of e.effects)
      if (t.is(Vs) && !ky(n, t.value.from, t.value.to)) {
        let { preparePlaceholder: i } = e.state.facet(ad), r = i ? q.replace({ widget: new Oy(i(e.state, t.value)) }) : nc;
        n = n.update({ add: [r.range(t.value.from, t.value.to)] });
      } else
        t.is(lr) && (n = n.update({
          filter: (i, r) => t.value.from != i || t.value.to != r,
          filterFrom: t.value.from,
          filterTo: t.value.to
        }));
    if (e.selection) {
      let t = !1, { head: i } = e.selection.main;
      n.between(i, i, (r, s) => {
        r < i && s > i && (t = !0);
      }), t && (n = n.update({
        filterFrom: i,
        filterTo: i,
        filter: (r, s) => s <= i || r >= i
      }));
    }
    return n;
  },
  provide: (n) => V.decorations.from(n),
  toJSON(n, e) {
    let t = [];
    return n.between(0, e.doc.length, (i, r) => {
      t.push(i, r);
    }), t;
  },
  fromJSON(n) {
    if (!Array.isArray(n) || n.length % 2)
      throw new RangeError("Invalid JSON for fold state");
    let e = [];
    for (let t = 0; t < n.length; ) {
      let i = n[t++], r = n[t++];
      if (typeof i != "number" || typeof r != "number")
        throw new RangeError("Invalid JSON for fold state");
      e.push(nc.range(i, r));
    }
    return q.set(e, !0);
  }
});
function ms(n, e, t) {
  var i;
  let r = null;
  return (i = n.field(Fn, !1)) === null || i === void 0 || i.between(e, t, (s, o) => {
    (!r || r.from > s) && (r = { from: s, to: o });
  }), r;
}
function ky(n, e, t) {
  let i = !1;
  return n.between(e, e, (r, s) => {
    r == e && s == t && (i = !0);
  }), i;
}
function od(n, e) {
  return n.field(Fn, !1) ? e : e.concat(X.appendConfig.of(ud()));
}
const vy = (n) => {
  for (let e of sd(n)) {
    let t = ps(n.state, e.from, e.to);
    if (t)
      return n.dispatch({ effects: od(n.state, [Vs.of(t), ld(n, t)]) }), !0;
  }
  return !1;
}, Sy = (n) => {
  if (!n.state.field(Fn, !1))
    return !1;
  let e = [];
  for (let t of sd(n)) {
    let i = ms(n.state, t.from, t.to);
    i && e.push(lr.of(i), ld(n, i, !1));
  }
  return e.length && n.dispatch({ effects: e }), e.length > 0;
};
function ld(n, e, t = !0) {
  let i = n.state.doc.lineAt(e.from).number, r = n.state.doc.lineAt(e.to).number;
  return V.announce.of(`${n.state.phrase(t ? "Folded lines" : "Unfolded lines")} ${i} ${n.state.phrase("to")} ${r}.`);
}
const Cy = (n) => {
  let { state: e } = n, t = [];
  for (let i = 0; i < e.doc.length; ) {
    let r = n.lineBlockAt(i), s = ps(e, r.from, r.to);
    s && t.push(Vs.of(s)), i = (s ? n.lineBlockAt(s.to) : r).to + 1;
  }
  return t.length && n.dispatch({ effects: od(n.state, t) }), !!t.length;
}, Ay = (n) => {
  let e = n.state.field(Fn, !1);
  if (!e || !e.size)
    return !1;
  let t = [];
  return e.between(0, n.state.doc.length, (i, r) => {
    t.push(lr.of({ from: i, to: r }));
  }), n.dispatch({ effects: t }), !0;
}, My = [
  { key: "Ctrl-Shift-[", mac: "Cmd-Alt-[", run: vy },
  { key: "Ctrl-Shift-]", mac: "Cmd-Alt-]", run: Sy },
  { key: "Ctrl-Alt-[", run: Cy },
  { key: "Ctrl-Alt-]", run: Ay }
], Ty = {
  placeholderDOM: null,
  preparePlaceholder: null,
  placeholderText: "…"
}, ad = /* @__PURE__ */ j.define({
  combine(n) {
    return Vt(n, Ty);
  }
});
function ud(n) {
  return [Fn, Ly];
}
function cd(n, e) {
  let { state: t } = n, i = t.facet(ad), r = (o) => {
    let l = n.lineBlockAt(n.posAtDOM(o.target)), a = ms(n.state, l.from, l.to);
    a && n.dispatch({ effects: lr.of(a) }), o.preventDefault();
  };
  if (i.placeholderDOM)
    return i.placeholderDOM(n, r, e);
  let s = document.createElement("span");
  return s.textContent = i.placeholderText, s.setAttribute("aria-label", t.phrase("folded code")), s.title = t.phrase("unfold"), s.className = "cm-foldPlaceholder", s.onclick = r, s;
}
const nc = /* @__PURE__ */ q.replace({ widget: /* @__PURE__ */ new class extends Jt {
  toDOM(n) {
    return cd(n, null);
  }
}() });
class Oy extends Jt {
  constructor(e) {
    super(), this.value = e;
  }
  eq(e) {
    return this.value == e.value;
  }
  toDOM(e) {
    return cd(e, this.value);
  }
}
const Dy = {
  openText: "⌄",
  closedText: "›",
  markerDOM: null,
  domEventHandlers: {},
  foldingChanged: () => !1
};
class bo extends Yt {
  constructor(e, t) {
    super(), this.config = e, this.open = t;
  }
  eq(e) {
    return this.config == e.config && this.open == e.open;
  }
  toDOM(e) {
    if (this.config.markerDOM)
      return this.config.markerDOM(this.open);
    let t = document.createElement("span");
    return t.textContent = this.open ? this.config.openText : this.config.closedText, t.title = e.state.phrase(this.open ? "Fold line" : "Unfold line"), t;
  }
}
function Ey(n = {}) {
  let e = Object.assign(Object.assign({}, Dy), n), t = new bo(e, !0), i = new bo(e, !1), r = ke.fromClass(class {
    constructor(o) {
      this.from = o.viewport.from, this.markers = this.buildMarkers(o);
    }
    update(o) {
      (o.docChanged || o.viewportChanged || o.startState.facet(bn) != o.state.facet(bn) || o.startState.field(Fn, !1) != o.state.field(Fn, !1) || _e(o.startState) != _e(o.state) || e.foldingChanged(o)) && (this.markers = this.buildMarkers(o.view));
    }
    buildMarkers(o) {
      let l = new dn();
      for (let a of o.viewportLineBlocks) {
        let u = ms(o.state, a.from, a.to) ? i : ps(o.state, a.from, a.to) ? t : null;
        u && l.add(a.from, a.from, u);
      }
      return l.finish();
    }
  }), { domEventHandlers: s } = e;
  return [
    r,
    D1({
      class: "cm-foldGutter",
      markers(o) {
        var l;
        return ((l = o.plugin(r)) === null || l === void 0 ? void 0 : l.markers) || ie.empty;
      },
      initialSpacer() {
        return new bo(e, !1);
      },
      domEventHandlers: Object.assign(Object.assign({}, s), { click: (o, l, a) => {
        if (s.click && s.click(o, l, a))
          return !0;
        let u = ms(o.state, l.from, l.to);
        if (u)
          return o.dispatch({ effects: lr.of(u) }), !0;
        let c = ps(o.state, l.from, l.to);
        return c ? (o.dispatch({ effects: Vs.of(c) }), !0) : !1;
      } })
    }),
    ud()
  ];
}
const Ly = /* @__PURE__ */ V.baseTheme({
  ".cm-foldPlaceholder": {
    backgroundColor: "#eee",
    border: "1px solid #ddd",
    color: "#888",
    borderRadius: ".2em",
    margin: "0 1px",
    padding: "0 1px",
    cursor: "pointer"
  },
  ".cm-foldGutter span": {
    padding: "0 1px",
    cursor: "pointer"
  }
});
class _s {
  constructor(e, t) {
    this.specs = e;
    let i;
    function r(l) {
      let a = pn.newName();
      return (i || (i = /* @__PURE__ */ Object.create(null)))["." + a] = l, a;
    }
    const s = typeof t.all == "string" ? t.all : t.all ? r(t.all) : void 0, o = t.scope;
    this.scope = o instanceof Rt ? (l) => l.prop(Ri) == o.data : o ? (l) => l == o : void 0, this.style = td(e.map((l) => ({
      tag: l.tag,
      class: l.class || r(Object.assign({}, l, { tag: null }))
    })), {
      all: s
    }).style, this.module = i ? new pn(i) : null, this.themeType = t.themeType;
  }
  /**
  Create a highlighter style that associates the given styles to
  the given tags. The specs must be objects that hold a style tag
  or array of tags in their `tag` property, and either a single
  `class` property providing a static CSS class (for highlighter
  that rely on external styling), or a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)-style
  set of CSS properties (which define the styling for those tags).
  
  The CSS rules created for a highlighter will be emitted in the
  order of the spec's properties. That means that for elements that
  have multiple tags associated with them, styles defined further
  down in the list will have a higher CSS precedence than styles
  defined earlier.
  */
  static define(e, t) {
    return new _s(e, t || {});
  }
}
const Dl = /* @__PURE__ */ j.define(), hd = /* @__PURE__ */ j.define({
  combine(n) {
    return n.length ? [n[0]] : null;
  }
});
function xo(n) {
  let e = n.facet(Dl);
  return e.length ? e : n.facet(hd);
}
function Iy(n, e) {
  let t = [By], i;
  return n instanceof _s && (n.module && t.push(V.styleModule.of(n.module)), i = n.themeType), e != null && e.fallback ? t.push(hd.of(n)) : i ? t.push(Dl.computeN([V.darkTheme], (r) => r.facet(V.darkTheme) == (i == "dark") ? [n] : [])) : t.push(Dl.of(n)), t;
}
class Py {
  constructor(e) {
    this.markCache = /* @__PURE__ */ Object.create(null), this.tree = _e(e.state), this.decorations = this.buildDeco(e, xo(e.state)), this.decoratedTo = e.viewport.to;
  }
  update(e) {
    let t = _e(e.state), i = xo(e.state), r = i != xo(e.startState), { viewport: s } = e.view, o = e.changes.mapPos(this.decoratedTo, 1);
    t.length < s.to && !r && t.type == this.tree.type && o >= s.to ? (this.decorations = this.decorations.map(e.changes), this.decoratedTo = o) : (t != this.tree || e.viewportChanged || r) && (this.tree = t, this.decorations = this.buildDeco(e.view, i), this.decoratedTo = s.to);
  }
  buildDeco(e, t) {
    if (!t || !this.tree.length)
      return q.none;
    let i = new dn();
    for (let { from: r, to: s } of e.visibleRanges)
      ey(this.tree, t, (o, l, a) => {
        i.add(o, l, this.markCache[a] || (this.markCache[a] = q.mark({ class: a })));
      }, r, s);
    return i.finish();
  }
}
const By = /* @__PURE__ */ Hn.high(/* @__PURE__ */ ke.fromClass(Py, {
  decorations: (n) => n.decorations
})), Ry = /* @__PURE__ */ _s.define([
  {
    tag: H.meta,
    color: "#404740"
  },
  {
    tag: H.link,
    textDecoration: "underline"
  },
  {
    tag: H.heading,
    textDecoration: "underline",
    fontWeight: "bold"
  },
  {
    tag: H.emphasis,
    fontStyle: "italic"
  },
  {
    tag: H.strong,
    fontWeight: "bold"
  },
  {
    tag: H.strikethrough,
    textDecoration: "line-through"
  },
  {
    tag: H.keyword,
    color: "#708"
  },
  {
    tag: [H.atom, H.bool, H.url, H.contentSeparator, H.labelName],
    color: "#219"
  },
  {
    tag: [H.literal, H.inserted],
    color: "#164"
  },
  {
    tag: [H.string, H.deleted],
    color: "#a11"
  },
  {
    tag: [H.regexp, H.escape, /* @__PURE__ */ H.special(H.string)],
    color: "#e40"
  },
  {
    tag: /* @__PURE__ */ H.definition(H.variableName),
    color: "#00f"
  },
  {
    tag: /* @__PURE__ */ H.local(H.variableName),
    color: "#30a"
  },
  {
    tag: [H.typeName, H.namespace],
    color: "#085"
  },
  {
    tag: H.className,
    color: "#167"
  },
  {
    tag: [/* @__PURE__ */ H.special(H.variableName), H.macroName],
    color: "#256"
  },
  {
    tag: /* @__PURE__ */ H.definition(H.propertyName),
    color: "#00c"
  },
  {
    tag: H.comment,
    color: "#940"
  },
  {
    tag: H.invalid,
    color: "#f00"
  }
]), Ny = /* @__PURE__ */ V.baseTheme({
  "&.cm-focused .cm-matchingBracket": { backgroundColor: "#328c8252" },
  "&.cm-focused .cm-nonmatchingBracket": { backgroundColor: "#bb555544" }
}), fd = 1e4, dd = "()[]{}", pd = /* @__PURE__ */ j.define({
  combine(n) {
    return Vt(n, {
      afterCursor: !0,
      brackets: dd,
      maxScanDistance: fd,
      renderMatch: Hy
    });
  }
}), Fy = /* @__PURE__ */ q.mark({ class: "cm-matchingBracket" }), zy = /* @__PURE__ */ q.mark({ class: "cm-nonmatchingBracket" });
function Hy(n) {
  let e = [], t = n.matched ? Fy : zy;
  return e.push(t.range(n.start.from, n.start.to)), n.end && e.push(t.range(n.end.from, n.end.to)), e;
}
const Vy = /* @__PURE__ */ Ne.define({
  create() {
    return q.none;
  },
  update(n, e) {
    if (!e.docChanged && !e.selection)
      return n;
    let t = [], i = e.state.facet(pd);
    for (let r of e.state.selection.ranges) {
      if (!r.empty)
        continue;
      let s = Nt(e.state, r.head, -1, i) || r.head > 0 && Nt(e.state, r.head - 1, 1, i) || i.afterCursor && (Nt(e.state, r.head, 1, i) || r.head < e.state.doc.length && Nt(e.state, r.head + 1, -1, i));
      s && (t = t.concat(i.renderMatch(s, e.state)));
    }
    return q.set(t, !0);
  },
  provide: (n) => V.decorations.from(n)
}), _y = [
  Vy,
  Ny
];
function $y(n = {}) {
  return [pd.of(n), _y];
}
const jy = /* @__PURE__ */ new ee();
function El(n, e, t) {
  let i = n.prop(e < 0 ? ee.openedBy : ee.closedBy);
  if (i)
    return i;
  if (n.name.length == 1) {
    let r = t.indexOf(n.name);
    if (r > -1 && r % 2 == (e < 0 ? 1 : 0))
      return [t[r + e]];
  }
  return null;
}
function Ll(n) {
  let e = n.type.prop(jy);
  return e ? e(n.node) : n;
}
function Nt(n, e, t, i = {}) {
  let r = i.maxScanDistance || fd, s = i.brackets || dd, o = _e(n), l = o.resolveInner(e, t);
  for (let a = l; a; a = a.parent) {
    let u = El(a.type, t, s);
    if (u && a.from < a.to) {
      let c = Ll(a);
      if (c && (t > 0 ? e >= c.from && e < c.to : e > c.from && e <= c.to))
        return Wy(n, e, t, a, c, u, s);
    }
  }
  return qy(n, e, t, o, l.type, r, s);
}
function Wy(n, e, t, i, r, s, o) {
  let l = i.parent, a = { from: r.from, to: r.to }, u = 0, c = l == null ? void 0 : l.cursor();
  if (c && (t < 0 ? c.childBefore(i.from) : c.childAfter(i.to)))
    do
      if (t < 0 ? c.to <= i.from : c.from >= i.to) {
        if (u == 0 && s.indexOf(c.type.name) > -1 && c.from < c.to) {
          let h = Ll(c);
          return { start: a, end: h ? { from: h.from, to: h.to } : void 0, matched: !0 };
        } else if (El(c.type, t, o))
          u++;
        else if (El(c.type, -t, o)) {
          if (u == 0) {
            let h = Ll(c);
            return {
              start: a,
              end: h && h.from < h.to ? { from: h.from, to: h.to } : void 0,
              matched: !1
            };
          }
          u--;
        }
      }
    while (t < 0 ? c.prevSibling() : c.nextSibling());
  return { start: a, matched: !1 };
}
function qy(n, e, t, i, r, s, o) {
  let l = t < 0 ? n.sliceDoc(e - 1, e) : n.sliceDoc(e, e + 1), a = o.indexOf(l);
  if (a < 0 || a % 2 == 0 != t > 0)
    return null;
  let u = { from: t < 0 ? e - 1 : e, to: t > 0 ? e + 1 : e }, c = n.doc.iterRange(e, t > 0 ? n.doc.length : 0), h = 0;
  for (let f = 0; !c.next().done && f <= s; ) {
    let d = c.value;
    t < 0 && (f += d.length);
    let p = e + f * t;
    for (let g = t > 0 ? 0 : d.length - 1, m = t > 0 ? d.length : -1; g != m; g += t) {
      let y = o.indexOf(d[g]);
      if (!(y < 0 || i.resolveInner(p + g, 1).type != r))
        if (y % 2 == 0 == t > 0)
          h++;
        else {
          if (h == 1)
            return { start: u, end: { from: p + g, to: p + g + 1 }, matched: y >> 1 == a >> 1 };
          h--;
        }
    }
    t > 0 && (f += d.length);
  }
  return c.done ? { start: u, matched: !1 } : null;
}
const Uy = /* @__PURE__ */ Object.create(null), ic = [bt.none], rc = [], sc = /* @__PURE__ */ Object.create(null), Ky = /* @__PURE__ */ Object.create(null);
for (let [n, e] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  Ky[n] = /* @__PURE__ */ Gy(Uy, e);
function wo(n, e) {
  rc.indexOf(n) > -1 || (rc.push(n), console.warn(e));
}
function Gy(n, e) {
  let t = [];
  for (let l of e.split(" ")) {
    let a = [];
    for (let u of l.split(".")) {
      let c = n[u] || H[u];
      c ? typeof c == "function" ? a.length ? a = a.map(c) : wo(u, `Modifier ${u} used at start of tag`) : a.length ? wo(u, `Tag ${u} used as modifier`) : a = Array.isArray(c) ? c : [c] : wo(u, `Unknown highlighting tag ${u}`);
    }
    for (let u of a)
      t.push(u);
  }
  if (!t.length)
    return 0;
  let i = e.replace(/ /g, "_"), r = i + " " + t.map((l) => l.id), s = sc[r];
  if (s)
    return s.id;
  let o = sc[r] = bt.define({
    id: ic.length,
    name: i,
    props: [Q1({ [i]: t })]
  });
  return ic.push(o), o.id;
}
ye.RTL, ye.LTR;
const Yy = (n) => {
  let { state: e } = n, t = e.doc.lineAt(e.selection.main.from), i = ga(n.state, t.from);
  return i.line ? Xy(n) : i.block ? Qy(n) : !1;
};
function ma(n, e) {
  return ({ state: t, dispatch: i }) => {
    if (t.readOnly)
      return !1;
    let r = n(e, t);
    return r ? (i(t.update(r)), !0) : !1;
  };
}
const Xy = /* @__PURE__ */ ma(
  tb,
  0
  /* CommentOption.Toggle */
), Jy = /* @__PURE__ */ ma(
  md,
  0
  /* CommentOption.Toggle */
), Qy = /* @__PURE__ */ ma(
  (n, e) => md(n, e, eb(e)),
  0
  /* CommentOption.Toggle */
);
function ga(n, e) {
  let t = n.languageDataAt("commentTokens", e);
  return t.length ? t[0] : {};
}
const Mi = 50;
function Zy(n, { open: e, close: t }, i, r) {
  let s = n.sliceDoc(i - Mi, i), o = n.sliceDoc(r, r + Mi), l = /\s*$/.exec(s)[0].length, a = /^\s*/.exec(o)[0].length, u = s.length - l;
  if (s.slice(u - e.length, u) == e && o.slice(a, a + t.length) == t)
    return {
      open: { pos: i - l, margin: l && 1 },
      close: { pos: r + a, margin: a && 1 }
    };
  let c, h;
  r - i <= 2 * Mi ? c = h = n.sliceDoc(i, r) : (c = n.sliceDoc(i, i + Mi), h = n.sliceDoc(r - Mi, r));
  let f = /^\s*/.exec(c)[0].length, d = /\s*$/.exec(h)[0].length, p = h.length - d - t.length;
  return c.slice(f, f + e.length) == e && h.slice(p, p + t.length) == t ? {
    open: {
      pos: i + f + e.length,
      margin: /\s/.test(c.charAt(f + e.length)) ? 1 : 0
    },
    close: {
      pos: r - d - t.length,
      margin: /\s/.test(h.charAt(p - 1)) ? 1 : 0
    }
  } : null;
}
function eb(n) {
  let e = [];
  for (let t of n.selection.ranges) {
    let i = n.doc.lineAt(t.from), r = t.to <= i.to ? i : n.doc.lineAt(t.to), s = e.length - 1;
    s >= 0 && e[s].to > i.from ? e[s].to = r.to : e.push({ from: i.from + /^\s*/.exec(i.text)[0].length, to: r.to });
  }
  return e;
}
function md(n, e, t = e.selection.ranges) {
  let i = t.map((s) => ga(e, s.from).block);
  if (!i.every((s) => s))
    return null;
  let r = t.map((s, o) => Zy(e, i[o], s.from, s.to));
  if (n != 2 && !r.every((s) => s))
    return { changes: e.changes(t.map((s, o) => r[o] ? [] : [{ from: s.from, insert: i[o].open + " " }, { from: s.to, insert: " " + i[o].close }])) };
  if (n != 1 && r.some((s) => s)) {
    let s = [];
    for (let o = 0, l; o < r.length; o++)
      if (l = r[o]) {
        let a = i[o], { open: u, close: c } = l;
        s.push({ from: u.pos - a.open.length, to: u.pos + u.margin }, { from: c.pos - c.margin, to: c.pos + a.close.length });
      }
    return { changes: s };
  }
  return null;
}
function tb(n, e, t = e.selection.ranges) {
  let i = [], r = -1;
  for (let { from: s, to: o } of t) {
    let l = i.length, a = 1e9, u = ga(e, s).line;
    if (u) {
      for (let c = s; c <= o; ) {
        let h = e.doc.lineAt(c);
        if (h.from > r && (s == o || o > h.from)) {
          r = h.from;
          let f = /^\s*/.exec(h.text)[0].length, d = f == h.length, p = h.text.slice(f, f + u.length) == u ? f : -1;
          f < h.text.length && f < a && (a = f), i.push({ line: h, comment: p, token: u, indent: f, empty: d, single: !1 });
        }
        c = h.to + 1;
      }
      if (a < 1e9)
        for (let c = l; c < i.length; c++)
          i[c].indent < i[c].line.text.length && (i[c].indent = a);
      i.length == l + 1 && (i[l].single = !0);
    }
  }
  if (n != 2 && i.some((s) => s.comment < 0 && (!s.empty || s.single))) {
    let s = [];
    for (let { line: l, token: a, indent: u, empty: c, single: h } of i)
      (h || !c) && s.push({ from: l.from + u, insert: a + " " });
    let o = e.changes(s);
    return { changes: o, selection: e.selection.map(o, 1) };
  } else if (n != 1 && i.some((s) => s.comment >= 0)) {
    let s = [];
    for (let { line: o, comment: l, token: a } of i)
      if (l >= 0) {
        let u = o.from + l, c = u + a.length;
        o.text[c - o.from] == " " && c++, s.push({ from: u, to: c });
      }
    return { changes: s };
  }
  return null;
}
const Il = /* @__PURE__ */ Xt.define(), nb = /* @__PURE__ */ Xt.define(), ib = /* @__PURE__ */ j.define(), gd = /* @__PURE__ */ j.define({
  combine(n) {
    return Vt(n, {
      minDepth: 100,
      newGroupDelay: 500,
      joinToEvent: (e, t) => t
    }, {
      minDepth: Math.max,
      newGroupDelay: Math.min,
      joinToEvent: (e, t) => (i, r) => e(i, r) || t(i, r)
    });
  }
}), yd = /* @__PURE__ */ Ne.define({
  create() {
    return Ft.empty;
  },
  update(n, e) {
    let t = e.state.facet(gd), i = e.annotation(Il);
    if (i) {
      let a = Qe.fromTransaction(e, i.selection), u = i.side, c = u == 0 ? n.undone : n.done;
      return a ? c = gs(c, c.length, t.minDepth, a) : c = wd(c, e.startState.selection), new Ft(u == 0 ? i.rest : c, u == 0 ? c : i.rest);
    }
    let r = e.annotation(nb);
    if ((r == "full" || r == "before") && (n = n.isolate()), e.annotation(Oe.addToHistory) === !1)
      return e.changes.empty ? n : n.addMapping(e.changes.desc);
    let s = Qe.fromTransaction(e), o = e.annotation(Oe.time), l = e.annotation(Oe.userEvent);
    return s ? n = n.addChanges(s, o, l, t, e) : e.selection && (n = n.addSelection(e.startState.selection, o, l, t.newGroupDelay)), (r == "full" || r == "after") && (n = n.isolate()), n;
  },
  toJSON(n) {
    return { done: n.done.map((e) => e.toJSON()), undone: n.undone.map((e) => e.toJSON()) };
  },
  fromJSON(n) {
    return new Ft(n.done.map(Qe.fromJSON), n.undone.map(Qe.fromJSON));
  }
});
function rb(n = {}) {
  return [
    yd,
    gd.of(n),
    V.domEventHandlers({
      beforeinput(e, t) {
        let i = e.inputType == "historyUndo" ? bd : e.inputType == "historyRedo" ? Pl : null;
        return i ? (e.preventDefault(), i(t)) : !1;
      }
    })
  ];
}
function $s(n, e) {
  return function({ state: t, dispatch: i }) {
    if (!e && t.readOnly)
      return !1;
    let r = t.field(yd, !1);
    if (!r)
      return !1;
    let s = r.pop(n, t, e);
    return s ? (i(s), !0) : !1;
  };
}
const bd = /* @__PURE__ */ $s(0, !1), Pl = /* @__PURE__ */ $s(1, !1), sb = /* @__PURE__ */ $s(0, !0), ob = /* @__PURE__ */ $s(1, !0);
class Qe {
  constructor(e, t, i, r, s) {
    this.changes = e, this.effects = t, this.mapped = i, this.startSelection = r, this.selectionsAfter = s;
  }
  setSelAfter(e) {
    return new Qe(this.changes, this.effects, this.mapped, this.startSelection, e);
  }
  toJSON() {
    var e, t, i;
    return {
      changes: (e = this.changes) === null || e === void 0 ? void 0 : e.toJSON(),
      mapped: (t = this.mapped) === null || t === void 0 ? void 0 : t.toJSON(),
      startSelection: (i = this.startSelection) === null || i === void 0 ? void 0 : i.toJSON(),
      selectionsAfter: this.selectionsAfter.map((r) => r.toJSON())
    };
  }
  static fromJSON(e) {
    return new Qe(e.changes && Te.fromJSON(e.changes), [], e.mapped && Ht.fromJSON(e.mapped), e.startSelection && T.fromJSON(e.startSelection), e.selectionsAfter.map(T.fromJSON));
  }
  // This does not check `addToHistory` and such, it assumes the
  // transaction needs to be converted to an item. Returns null when
  // there are no changes or effects in the transaction.
  static fromTransaction(e, t) {
    let i = ft;
    for (let r of e.startState.facet(ib)) {
      let s = r(e);
      s.length && (i = i.concat(s));
    }
    return !i.length && e.changes.empty ? null : new Qe(e.changes.invert(e.startState.doc), i, void 0, t || e.startState.selection, ft);
  }
  static selection(e) {
    return new Qe(void 0, ft, void 0, void 0, e);
  }
}
function gs(n, e, t, i) {
  let r = e + 1 > t + 20 ? e - t - 1 : 0, s = n.slice(r, e);
  return s.push(i), s;
}
function lb(n, e) {
  let t = [], i = !1;
  return n.iterChangedRanges((r, s) => t.push(r, s)), e.iterChangedRanges((r, s, o, l) => {
    for (let a = 0; a < t.length; ) {
      let u = t[a++], c = t[a++];
      l >= u && o <= c && (i = !0);
    }
  }), i;
}
function ab(n, e) {
  return n.ranges.length == e.ranges.length && n.ranges.filter((t, i) => t.empty != e.ranges[i].empty).length === 0;
}
function xd(n, e) {
  return n.length ? e.length ? n.concat(e) : n : e;
}
const ft = [], ub = 200;
function wd(n, e) {
  if (n.length) {
    let t = n[n.length - 1], i = t.selectionsAfter.slice(Math.max(0, t.selectionsAfter.length - ub));
    return i.length && i[i.length - 1].eq(e) ? n : (i.push(e), gs(n, n.length - 1, 1e9, t.setSelAfter(i)));
  } else
    return [Qe.selection([e])];
}
function cb(n) {
  let e = n[n.length - 1], t = n.slice();
  return t[n.length - 1] = e.setSelAfter(e.selectionsAfter.slice(0, e.selectionsAfter.length - 1)), t;
}
function ko(n, e) {
  if (!n.length)
    return n;
  let t = n.length, i = ft;
  for (; t; ) {
    let r = hb(n[t - 1], e, i);
    if (r.changes && !r.changes.empty || r.effects.length) {
      let s = n.slice(0, t);
      return s[t - 1] = r, s;
    } else
      e = r.mapped, t--, i = r.selectionsAfter;
  }
  return i.length ? [Qe.selection(i)] : ft;
}
function hb(n, e, t) {
  let i = xd(n.selectionsAfter.length ? n.selectionsAfter.map((l) => l.map(e)) : ft, t);
  if (!n.changes)
    return Qe.selection(i);
  let r = n.changes.map(e), s = e.mapDesc(n.changes, !0), o = n.mapped ? n.mapped.composeDesc(s) : s;
  return new Qe(r, X.mapEffects(n.effects, e), o, n.startSelection.map(s), i);
}
const fb = /^(input\.type|delete)($|\.)/;
class Ft {
  constructor(e, t, i = 0, r = void 0) {
    this.done = e, this.undone = t, this.prevTime = i, this.prevUserEvent = r;
  }
  isolate() {
    return this.prevTime ? new Ft(this.done, this.undone) : this;
  }
  addChanges(e, t, i, r, s) {
    let o = this.done, l = o[o.length - 1];
    return l && l.changes && !l.changes.empty && e.changes && (!i || fb.test(i)) && (!l.selectionsAfter.length && t - this.prevTime < r.newGroupDelay && r.joinToEvent(s, lb(l.changes, e.changes)) || // For compose (but not compose.start) events, always join with previous event
    i == "input.type.compose") ? o = gs(o, o.length - 1, r.minDepth, new Qe(e.changes.compose(l.changes), xd(e.effects, l.effects), l.mapped, l.startSelection, ft)) : o = gs(o, o.length, r.minDepth, e), new Ft(o, ft, t, i);
  }
  addSelection(e, t, i, r) {
    let s = this.done.length ? this.done[this.done.length - 1].selectionsAfter : ft;
    return s.length > 0 && t - this.prevTime < r && i == this.prevUserEvent && i && /^select($|\.)/.test(i) && ab(s[s.length - 1], e) ? this : new Ft(wd(this.done, e), this.undone, t, i);
  }
  addMapping(e) {
    return new Ft(ko(this.done, e), ko(this.undone, e), this.prevTime, this.prevUserEvent);
  }
  pop(e, t, i) {
    let r = e == 0 ? this.done : this.undone;
    if (r.length == 0)
      return null;
    let s = r[r.length - 1], o = s.selectionsAfter[0] || t.selection;
    if (i && s.selectionsAfter.length)
      return t.update({
        selection: s.selectionsAfter[s.selectionsAfter.length - 1],
        annotations: Il.of({ side: e, rest: cb(r), selection: o }),
        userEvent: e == 0 ? "select.undo" : "select.redo",
        scrollIntoView: !0
      });
    if (s.changes) {
      let l = r.length == 1 ? ft : r.slice(0, r.length - 1);
      return s.mapped && (l = ko(l, s.mapped)), t.update({
        changes: s.changes,
        selection: s.startSelection,
        effects: s.effects,
        annotations: Il.of({ side: e, rest: l, selection: o }),
        filter: !1,
        userEvent: e == 0 ? "undo" : "redo",
        scrollIntoView: !0
      });
    } else
      return null;
  }
}
Ft.empty = /* @__PURE__ */ new Ft(ft, ft);
const db = [
  { key: "Mod-z", run: bd, preventDefault: !0 },
  { key: "Mod-y", mac: "Mod-Shift-z", run: Pl, preventDefault: !0 },
  { linux: "Ctrl-Shift-z", run: Pl, preventDefault: !0 },
  { key: "Mod-u", run: sb, preventDefault: !0 },
  { key: "Alt-u", mac: "Mod-Shift-u", run: ob, preventDefault: !0 }
];
function pi(n, e) {
  return T.create(n.ranges.map(e), n.mainIndex);
}
function _t(n, e) {
  return n.update({ selection: e, scrollIntoView: !0, userEvent: "select" });
}
function Mt({ state: n, dispatch: e }, t) {
  let i = pi(n.selection, t);
  return i.eq(n.selection, !0) ? !1 : (e(_t(n, i)), !0);
}
function js(n, e) {
  return T.cursor(e ? n.to : n.from);
}
function kd(n, e) {
  return Mt(n, (t) => t.empty ? n.moveByChar(t, e) : js(t, e));
}
function $e(n) {
  return n.textDirectionAt(n.state.selection.main.head) == ye.LTR;
}
const vd = (n) => kd(n, !$e(n)), Sd = (n) => kd(n, $e(n));
function Cd(n, e) {
  return Mt(n, (t) => t.empty ? n.moveByGroup(t, e) : js(t, e));
}
const pb = (n) => Cd(n, !$e(n)), mb = (n) => Cd(n, $e(n));
function gb(n, e, t) {
  if (e.type.prop(t))
    return !0;
  let i = e.to - e.from;
  return i && (i > 2 || /[^\s,.;:]/.test(n.sliceDoc(e.from, e.to))) || e.firstChild;
}
function Ws(n, e, t) {
  let i = _e(n).resolveInner(e.head), r = t ? ee.closedBy : ee.openedBy;
  for (let a = e.head; ; ) {
    let u = t ? i.childAfter(a) : i.childBefore(a);
    if (!u)
      break;
    gb(n, u, r) ? i = u : a = t ? u.to : u.from;
  }
  let s = i.type.prop(r), o, l;
  return s && (o = t ? Nt(n, i.from, 1) : Nt(n, i.to, -1)) && o.matched ? l = t ? o.end.to : o.end.from : l = t ? i.to : i.from, T.cursor(l, t ? -1 : 1);
}
const yb = (n) => Mt(n, (e) => Ws(n.state, e, !$e(n))), bb = (n) => Mt(n, (e) => Ws(n.state, e, $e(n)));
function Ad(n, e) {
  return Mt(n, (t) => {
    if (!t.empty)
      return js(t, e);
    let i = n.moveVertically(t, e);
    return i.head != t.head ? i : n.moveToLineBoundary(t, e);
  });
}
const Md = (n) => Ad(n, !1), Td = (n) => Ad(n, !0);
function Od(n) {
  let e = n.scrollDOM.clientHeight < n.scrollDOM.scrollHeight - 2, t = 0, i = 0, r;
  if (e) {
    for (let s of n.state.facet(V.scrollMargins)) {
      let o = s(n);
      o != null && o.top && (t = Math.max(o == null ? void 0 : o.top, t)), o != null && o.bottom && (i = Math.max(o == null ? void 0 : o.bottom, i));
    }
    r = n.scrollDOM.clientHeight - t - i;
  } else
    r = (n.dom.ownerDocument.defaultView || window).innerHeight;
  return {
    marginTop: t,
    marginBottom: i,
    selfScroll: e,
    height: Math.max(n.defaultLineHeight, r - 5)
  };
}
function Dd(n, e) {
  let t = Od(n), { state: i } = n, r = pi(i.selection, (o) => o.empty ? n.moveVertically(o, e, t.height) : js(o, e));
  if (r.eq(i.selection))
    return !1;
  let s;
  if (t.selfScroll) {
    let o = n.coordsAtPos(i.selection.main.head), l = n.scrollDOM.getBoundingClientRect(), a = l.top + t.marginTop, u = l.bottom - t.marginBottom;
    o && o.top > a && o.bottom < u && (s = V.scrollIntoView(r.main.head, { y: "start", yMargin: o.top - a }));
  }
  return n.dispatch(_t(i, r), { effects: s }), !0;
}
const oc = (n) => Dd(n, !1), Bl = (n) => Dd(n, !0);
function wn(n, e, t) {
  let i = n.lineBlockAt(e.head), r = n.moveToLineBoundary(e, t);
  if (r.head == e.head && r.head != (t ? i.to : i.from) && (r = n.moveToLineBoundary(e, t, !1)), !t && r.head == i.from && i.length) {
    let s = /^\s*/.exec(n.state.sliceDoc(i.from, Math.min(i.from + 100, i.to)))[0].length;
    s && e.head != i.from + s && (r = T.cursor(i.from + s));
  }
  return r;
}
const xb = (n) => Mt(n, (e) => wn(n, e, !0)), wb = (n) => Mt(n, (e) => wn(n, e, !1)), kb = (n) => Mt(n, (e) => wn(n, e, !$e(n))), vb = (n) => Mt(n, (e) => wn(n, e, $e(n))), Sb = (n) => Mt(n, (e) => T.cursor(n.lineBlockAt(e.head).from, 1)), Cb = (n) => Mt(n, (e) => T.cursor(n.lineBlockAt(e.head).to, -1));
function Ab(n, e, t) {
  let i = !1, r = pi(n.selection, (s) => {
    let o = Nt(n, s.head, -1) || Nt(n, s.head, 1) || s.head > 0 && Nt(n, s.head - 1, 1) || s.head < n.doc.length && Nt(n, s.head + 1, -1);
    if (!o || !o.end)
      return s;
    i = !0;
    let l = o.start.from == s.head ? o.end.to : o.end.from;
    return T.cursor(l);
  });
  return i ? (e(_t(n, r)), !0) : !1;
}
const Mb = ({ state: n, dispatch: e }) => Ab(n, e);
function wt(n, e) {
  let t = pi(n.state.selection, (i) => {
    let r = e(i);
    return T.range(i.anchor, r.head, r.goalColumn, r.bidiLevel || void 0);
  });
  return t.eq(n.state.selection) ? !1 : (n.dispatch(_t(n.state, t)), !0);
}
function Ed(n, e) {
  return wt(n, (t) => n.moveByChar(t, e));
}
const Ld = (n) => Ed(n, !$e(n)), Id = (n) => Ed(n, $e(n));
function Pd(n, e) {
  return wt(n, (t) => n.moveByGroup(t, e));
}
const Tb = (n) => Pd(n, !$e(n)), Ob = (n) => Pd(n, $e(n)), Db = (n) => wt(n, (e) => Ws(n.state, e, !$e(n))), Eb = (n) => wt(n, (e) => Ws(n.state, e, $e(n)));
function Bd(n, e) {
  return wt(n, (t) => n.moveVertically(t, e));
}
const Rd = (n) => Bd(n, !1), Nd = (n) => Bd(n, !0);
function Fd(n, e) {
  return wt(n, (t) => n.moveVertically(t, e, Od(n).height));
}
const lc = (n) => Fd(n, !1), ac = (n) => Fd(n, !0), Lb = (n) => wt(n, (e) => wn(n, e, !0)), Ib = (n) => wt(n, (e) => wn(n, e, !1)), Pb = (n) => wt(n, (e) => wn(n, e, !$e(n))), Bb = (n) => wt(n, (e) => wn(n, e, $e(n))), Rb = (n) => wt(n, (e) => T.cursor(n.lineBlockAt(e.head).from)), Nb = (n) => wt(n, (e) => T.cursor(n.lineBlockAt(e.head).to)), uc = ({ state: n, dispatch: e }) => (e(_t(n, { anchor: 0 })), !0), cc = ({ state: n, dispatch: e }) => (e(_t(n, { anchor: n.doc.length })), !0), hc = ({ state: n, dispatch: e }) => (e(_t(n, { anchor: n.selection.main.anchor, head: 0 })), !0), fc = ({ state: n, dispatch: e }) => (e(_t(n, { anchor: n.selection.main.anchor, head: n.doc.length })), !0), Fb = ({ state: n, dispatch: e }) => (e(n.update({ selection: { anchor: 0, head: n.doc.length }, userEvent: "select" })), !0), zb = ({ state: n, dispatch: e }) => {
  let t = qs(n).map(({ from: i, to: r }) => T.range(i, Math.min(r + 1, n.doc.length)));
  return e(n.update({ selection: T.create(t), userEvent: "select" })), !0;
}, Hb = ({ state: n, dispatch: e }) => {
  let t = pi(n.selection, (i) => {
    var r;
    let s = _e(n).resolveStack(i.from, 1);
    for (let o = s; o; o = o.next) {
      let { node: l } = o;
      if ((l.from < i.from && l.to >= i.to || l.to > i.to && l.from <= i.from) && (!((r = l.parent) === null || r === void 0) && r.parent))
        return T.range(l.to, l.from);
    }
    return i;
  });
  return e(_t(n, t)), !0;
}, Vb = ({ state: n, dispatch: e }) => {
  let t = n.selection, i = null;
  return t.ranges.length > 1 ? i = T.create([t.main]) : t.main.empty || (i = T.create([T.cursor(t.main.head)])), i ? (e(_t(n, i)), !0) : !1;
};
function ar(n, e) {
  if (n.state.readOnly)
    return !1;
  let t = "delete.selection", { state: i } = n, r = i.changeByRange((s) => {
    let { from: o, to: l } = s;
    if (o == l) {
      let a = e(s);
      a < o ? (t = "delete.backward", a = Lr(n, a, !1)) : a > o && (t = "delete.forward", a = Lr(n, a, !0)), o = Math.min(o, a), l = Math.max(l, a);
    } else
      o = Lr(n, o, !1), l = Lr(n, l, !0);
    return o == l ? { range: s } : { changes: { from: o, to: l }, range: T.cursor(o, o < s.head ? -1 : 1) };
  });
  return r.changes.empty ? !1 : (n.dispatch(i.update(r, {
    scrollIntoView: !0,
    userEvent: t,
    effects: t == "delete.selection" ? V.announce.of(i.phrase("Selection deleted")) : void 0
  })), !0);
}
function Lr(n, e, t) {
  if (n instanceof V)
    for (let i of n.state.facet(V.atomicRanges).map((r) => r(n)))
      i.between(e, e, (r, s) => {
        r < e && s > e && (e = t ? s : r);
      });
  return e;
}
const zd = (n, e, t) => ar(n, (i) => {
  let r = i.from, { state: s } = n, o = s.doc.lineAt(r), l, a;
  if (t && !e && r > o.from && r < o.from + 200 && !/[^ \t]/.test(l = o.text.slice(0, r - o.from))) {
    if (l[l.length - 1] == "	")
      return r - 1;
    let u = di(l, s.tabSize), c = u % ds(s) || ds(s);
    for (let h = 0; h < c && l[l.length - 1 - h] == " "; h++)
      r--;
    a = r;
  } else
    a = Re(o.text, r - o.from, e, e) + o.from, a == r && o.number != (e ? s.doc.lines : 1) ? a += e ? 1 : -1 : !e && /[\ufe00-\ufe0f]/.test(o.text.slice(a - o.from, r - o.from)) && (a = Re(o.text, a - o.from, !1, !1) + o.from);
  return a;
}), Rl = (n) => zd(n, !1, !0), Hd = (n) => zd(n, !0, !1), Vd = (n, e) => ar(n, (t) => {
  let i = t.head, { state: r } = n, s = r.doc.lineAt(i), o = r.charCategorizer(i);
  for (let l = null; ; ) {
    if (i == (e ? s.to : s.from)) {
      i == t.head && s.number != (e ? r.doc.lines : 1) && (i += e ? 1 : -1);
      break;
    }
    let a = Re(s.text, i - s.from, e) + s.from, u = s.text.slice(Math.min(i, a) - s.from, Math.max(i, a) - s.from), c = o(u);
    if (l != null && c != l)
      break;
    (u != " " || i != t.head) && (l = c), i = a;
  }
  return i;
}), _d = (n) => Vd(n, !1), _b = (n) => Vd(n, !0), $b = (n) => ar(n, (e) => {
  let t = n.lineBlockAt(e.head).to;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), jb = (n) => ar(n, (e) => {
  let t = n.moveToLineBoundary(e, !1).head;
  return e.head > t ? t : Math.max(0, e.head - 1);
}), Wb = (n) => ar(n, (e) => {
  let t = n.moveToLineBoundary(e, !0).head;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), qb = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((i) => ({
    changes: { from: i.from, to: i.to, insert: re.of(["", ""]) },
    range: T.cursor(i.from)
  }));
  return e(n.update(t, { scrollIntoView: !0, userEvent: "input" })), !0;
}, Ub = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((i) => {
    if (!i.empty || i.from == 0 || i.from == n.doc.length)
      return { range: i };
    let r = i.from, s = n.doc.lineAt(r), o = r == s.from ? r - 1 : Re(s.text, r - s.from, !1) + s.from, l = r == s.to ? r + 1 : Re(s.text, r - s.from, !0) + s.from;
    return {
      changes: { from: o, to: l, insert: n.doc.slice(r, l).append(n.doc.slice(o, r)) },
      range: T.cursor(l)
    };
  });
  return t.changes.empty ? !1 : (e(n.update(t, { scrollIntoView: !0, userEvent: "move.character" })), !0);
};
function qs(n) {
  let e = [], t = -1;
  for (let i of n.selection.ranges) {
    let r = n.doc.lineAt(i.from), s = n.doc.lineAt(i.to);
    if (!i.empty && i.to == s.from && (s = n.doc.lineAt(i.to - 1)), t >= r.number) {
      let o = e[e.length - 1];
      o.to = s.to, o.ranges.push(i);
    } else
      e.push({ from: r.from, to: s.to, ranges: [i] });
    t = s.number + 1;
  }
  return e;
}
function $d(n, e, t) {
  if (n.readOnly)
    return !1;
  let i = [], r = [];
  for (let s of qs(n)) {
    if (t ? s.to == n.doc.length : s.from == 0)
      continue;
    let o = n.doc.lineAt(t ? s.to + 1 : s.from - 1), l = o.length + 1;
    if (t) {
      i.push({ from: s.to, to: o.to }, { from: s.from, insert: o.text + n.lineBreak });
      for (let a of s.ranges)
        r.push(T.range(Math.min(n.doc.length, a.anchor + l), Math.min(n.doc.length, a.head + l)));
    } else {
      i.push({ from: o.from, to: s.from }, { from: s.to, insert: n.lineBreak + o.text });
      for (let a of s.ranges)
        r.push(T.range(a.anchor - l, a.head - l));
    }
  }
  return i.length ? (e(n.update({
    changes: i,
    scrollIntoView: !0,
    selection: T.create(r, n.selection.mainIndex),
    userEvent: "move.line"
  })), !0) : !1;
}
const Kb = ({ state: n, dispatch: e }) => $d(n, e, !1), Gb = ({ state: n, dispatch: e }) => $d(n, e, !0);
function jd(n, e, t) {
  if (n.readOnly)
    return !1;
  let i = [];
  for (let r of qs(n))
    t ? i.push({ from: r.from, insert: n.doc.slice(r.from, r.to) + n.lineBreak }) : i.push({ from: r.to, insert: n.lineBreak + n.doc.slice(r.from, r.to) });
  return e(n.update({ changes: i, scrollIntoView: !0, userEvent: "input.copyline" })), !0;
}
const Yb = ({ state: n, dispatch: e }) => jd(n, e, !1), Xb = ({ state: n, dispatch: e }) => jd(n, e, !0), Jb = (n) => {
  if (n.state.readOnly)
    return !1;
  let { state: e } = n, t = e.changes(qs(e).map(({ from: r, to: s }) => (r > 0 ? r-- : s < e.doc.length && s++, { from: r, to: s }))), i = pi(e.selection, (r) => {
    let s;
    if (n.lineWrapping) {
      let o = n.lineBlockAt(r.head), l = n.coordsAtPos(r.head, r.assoc || 1);
      l && (s = o.bottom + n.documentTop - l.bottom + n.defaultLineHeight / 2);
    }
    return n.moveVertically(r, !0, s);
  }).map(t);
  return n.dispatch({ changes: t, selection: i, scrollIntoView: !0, userEvent: "delete.line" }), !0;
};
function Qb(n, e) {
  if (/\(\)|\[\]|\{\}/.test(n.sliceDoc(e - 1, e + 1)))
    return { from: e, to: e };
  let t = _e(n).resolveInner(e), i = t.childBefore(e), r = t.childAfter(e), s;
  return i && r && i.to <= e && r.from >= e && (s = i.type.prop(ee.closedBy)) && s.indexOf(r.name) > -1 && n.doc.lineAt(i.to).from == n.doc.lineAt(r.from).from && !/\S/.test(n.sliceDoc(i.to, r.from)) ? { from: i.to, to: r.from } : null;
}
const Zb = /* @__PURE__ */ Wd(!1), ex = /* @__PURE__ */ Wd(!0);
function Wd(n) {
  return ({ state: e, dispatch: t }) => {
    if (e.readOnly)
      return !1;
    let i = e.changeByRange((r) => {
      let { from: s, to: o } = r, l = e.doc.lineAt(s), a = !n && s == o && Qb(e, s);
      n && (s = o = (o <= l.to ? l : e.doc.lineAt(o)).to);
      let u = new Hs(e, { simulateBreak: s, simulateDoubleBreak: !!a }), c = da(u, s);
      for (c == null && (c = di(/^\s*/.exec(e.doc.lineAt(s).text)[0], e.tabSize)); o < l.to && /\s/.test(l.text[o - l.from]); )
        o++;
      a ? { from: s, to: o } = a : s > l.from && s < l.from + 100 && !/\S/.test(l.text.slice(0, s)) && (s = l.from);
      let h = ["", Zi(e, c)];
      return a && h.push(Zi(e, u.lineIndent(l.from, -1))), {
        changes: { from: s, to: o, insert: re.of(h) },
        range: T.cursor(s + 1 + h[1].length)
      };
    });
    return t(e.update(i, { scrollIntoView: !0, userEvent: "input" })), !0;
  };
}
function ya(n, e) {
  let t = -1;
  return n.changeByRange((i) => {
    let r = [];
    for (let o = i.from; o <= i.to; ) {
      let l = n.doc.lineAt(o);
      l.number > t && (i.empty || i.to > l.from) && (e(l, r, i), t = l.number), o = l.to + 1;
    }
    let s = n.changes(r);
    return {
      changes: r,
      range: T.range(s.mapPos(i.anchor, 1), s.mapPos(i.head, 1))
    };
  });
}
const tx = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = /* @__PURE__ */ Object.create(null), i = new Hs(n, { overrideIndentation: (s) => {
    let o = t[s];
    return o ?? -1;
  } }), r = ya(n, (s, o, l) => {
    let a = da(i, s.from);
    if (a == null)
      return;
    /\S/.test(s.text) || (a = 0);
    let u = /^\s*/.exec(s.text)[0], c = Zi(n, a);
    (u != c || l.from < s.from + u.length) && (t[s.from] = a, o.push({ from: s.from, to: s.from + u.length, insert: c }));
  });
  return r.changes.empty || e(n.update(r, { userEvent: "indent" })), !0;
}, qd = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(ya(n, (t, i) => {
  i.push({ from: t.from, insert: n.facet(zs) });
}), { userEvent: "input.indent" })), !0), Ud = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(ya(n, (t, i) => {
  let r = /^\s*/.exec(t.text)[0];
  if (!r)
    return;
  let s = di(r, n.tabSize), o = 0, l = Zi(n, Math.max(0, s - ds(n)));
  for (; o < r.length && o < l.length && r.charCodeAt(o) == l.charCodeAt(o); )
    o++;
  i.push({ from: t.from + o, to: t.from + r.length, insert: l.slice(o) });
}), { userEvent: "delete.dedent" })), !0), nx = [
  { key: "Ctrl-b", run: vd, shift: Ld, preventDefault: !0 },
  { key: "Ctrl-f", run: Sd, shift: Id },
  { key: "Ctrl-p", run: Md, shift: Rd },
  { key: "Ctrl-n", run: Td, shift: Nd },
  { key: "Ctrl-a", run: Sb, shift: Rb },
  { key: "Ctrl-e", run: Cb, shift: Nb },
  { key: "Ctrl-d", run: Hd },
  { key: "Ctrl-h", run: Rl },
  { key: "Ctrl-k", run: $b },
  { key: "Ctrl-Alt-h", run: _d },
  { key: "Ctrl-o", run: qb },
  { key: "Ctrl-t", run: Ub },
  { key: "Ctrl-v", run: Bl }
], ix = /* @__PURE__ */ [
  { key: "ArrowLeft", run: vd, shift: Ld, preventDefault: !0 },
  { key: "Mod-ArrowLeft", mac: "Alt-ArrowLeft", run: pb, shift: Tb, preventDefault: !0 },
  { mac: "Cmd-ArrowLeft", run: kb, shift: Pb, preventDefault: !0 },
  { key: "ArrowRight", run: Sd, shift: Id, preventDefault: !0 },
  { key: "Mod-ArrowRight", mac: "Alt-ArrowRight", run: mb, shift: Ob, preventDefault: !0 },
  { mac: "Cmd-ArrowRight", run: vb, shift: Bb, preventDefault: !0 },
  { key: "ArrowUp", run: Md, shift: Rd, preventDefault: !0 },
  { mac: "Cmd-ArrowUp", run: uc, shift: hc },
  { mac: "Ctrl-ArrowUp", run: oc, shift: lc },
  { key: "ArrowDown", run: Td, shift: Nd, preventDefault: !0 },
  { mac: "Cmd-ArrowDown", run: cc, shift: fc },
  { mac: "Ctrl-ArrowDown", run: Bl, shift: ac },
  { key: "PageUp", run: oc, shift: lc },
  { key: "PageDown", run: Bl, shift: ac },
  { key: "Home", run: wb, shift: Ib, preventDefault: !0 },
  { key: "Mod-Home", run: uc, shift: hc },
  { key: "End", run: xb, shift: Lb, preventDefault: !0 },
  { key: "Mod-End", run: cc, shift: fc },
  { key: "Enter", run: Zb },
  { key: "Mod-a", run: Fb },
  { key: "Backspace", run: Rl, shift: Rl },
  { key: "Delete", run: Hd },
  { key: "Mod-Backspace", mac: "Alt-Backspace", run: _d },
  { key: "Mod-Delete", mac: "Alt-Delete", run: _b },
  { mac: "Mod-Backspace", run: jb },
  { mac: "Mod-Delete", run: Wb }
].concat(/* @__PURE__ */ nx.map((n) => ({ mac: n.key, run: n.run, shift: n.shift }))), rx = /* @__PURE__ */ [
  { key: "Alt-ArrowLeft", mac: "Ctrl-ArrowLeft", run: yb, shift: Db },
  { key: "Alt-ArrowRight", mac: "Ctrl-ArrowRight", run: bb, shift: Eb },
  { key: "Alt-ArrowUp", run: Kb },
  { key: "Shift-Alt-ArrowUp", run: Yb },
  { key: "Alt-ArrowDown", run: Gb },
  { key: "Shift-Alt-ArrowDown", run: Xb },
  { key: "Escape", run: Vb },
  { key: "Mod-Enter", run: ex },
  { key: "Alt-l", mac: "Ctrl-l", run: zb },
  { key: "Mod-i", run: Hb, preventDefault: !0 },
  { key: "Mod-[", run: Ud },
  { key: "Mod-]", run: qd },
  { key: "Mod-Alt-\\", run: tx },
  { key: "Shift-Mod-k", run: Jb },
  { key: "Shift-Mod-\\", run: Mb },
  { key: "Mod-/", run: Yy },
  { key: "Alt-A", run: Jy }
].concat(ix), sx = { key: "Tab", run: qd, shift: Ud };
function pe() {
  var n = arguments[0];
  typeof n == "string" && (n = document.createElement(n));
  var e = 1, t = arguments[1];
  if (t && typeof t == "object" && t.nodeType == null && !Array.isArray(t)) {
    for (var i in t)
      if (Object.prototype.hasOwnProperty.call(t, i)) {
        var r = t[i];
        typeof r == "string" ? n.setAttribute(i, r) : r != null && (n[i] = r);
      }
    e++;
  }
  for (; e < arguments.length; e++)
    Kd(n, arguments[e]);
  return n;
}
function Kd(n, e) {
  if (typeof e == "string")
    n.appendChild(document.createTextNode(e));
  else if (e != null)
    if (e.nodeType != null)
      n.appendChild(e);
    else if (Array.isArray(e))
      for (var t = 0; t < e.length; t++)
        Kd(n, e[t]);
    else
      throw new RangeError("Unsupported child node: " + e);
}
const dc = typeof String.prototype.normalize == "function" ? (n) => n.normalize("NFKD") : (n) => n;
class ci {
  /**
  Create a text cursor. The query is the search string, `from` to
  `to` provides the region to search.
  
  When `normalize` is given, it will be called, on both the query
  string and the content it is matched against, before comparing.
  You can, for example, create a case-insensitive search by
  passing `s => s.toLowerCase()`.
  
  Text is always normalized with
  [`.normalize("NFKD")`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/normalize)
  (when supported).
  */
  constructor(e, t, i = 0, r = e.length, s, o) {
    this.test = o, this.value = { from: 0, to: 0 }, this.done = !1, this.matches = [], this.buffer = "", this.bufferPos = 0, this.iter = e.iterRange(i, r), this.bufferStart = i, this.normalize = s ? (l) => s(dc(l)) : dc, this.query = this.normalize(t);
  }
  peek() {
    if (this.bufferPos == this.buffer.length) {
      if (this.bufferStart += this.buffer.length, this.iter.next(), this.iter.done)
        return -1;
      this.bufferPos = 0, this.buffer = this.iter.value;
    }
    return Le(this.buffer, this.bufferPos);
  }
  /**
  Look for the next match. Updates the iterator's
  [`value`](https://codemirror.net/6/docs/ref/#search.SearchCursor.value) and
  [`done`](https://codemirror.net/6/docs/ref/#search.SearchCursor.done) properties. Should be called
  at least once before using the cursor.
  */
  next() {
    for (; this.matches.length; )
      this.matches.pop();
    return this.nextOverlapping();
  }
  /**
  The `next` method will ignore matches that partially overlap a
  previous match. This method behaves like `next`, but includes
  such matches.
  */
  nextOverlapping() {
    for (; ; ) {
      let e = this.peek();
      if (e < 0)
        return this.done = !0, this;
      let t = Ql(e), i = this.bufferStart + this.bufferPos;
      this.bufferPos += ht(e);
      let r = this.normalize(t);
      for (let s = 0, o = i; ; s++) {
        let l = r.charCodeAt(s), a = this.match(l, o, this.bufferPos + this.bufferStart);
        if (s == r.length - 1) {
          if (a)
            return this.value = a, this;
          break;
        }
        o == i && s < t.length && t.charCodeAt(s) == l && o++;
      }
    }
  }
  match(e, t, i) {
    let r = null;
    for (let s = 0; s < this.matches.length; s += 2) {
      let o = this.matches[s], l = !1;
      this.query.charCodeAt(o) == e && (o == this.query.length - 1 ? r = { from: this.matches[s + 1], to: i } : (this.matches[s]++, l = !0)), l || (this.matches.splice(s, 2), s -= 2);
    }
    return this.query.charCodeAt(0) == e && (this.query.length == 1 ? r = { from: t, to: i } : this.matches.push(1, t)), r && this.test && !this.test(r.from, r.to, this.buffer, this.bufferStart) && (r = null), r;
  }
}
typeof Symbol < "u" && (ci.prototype[Symbol.iterator] = function() {
  return this;
});
const Gd = { from: -1, to: -1, match: /* @__PURE__ */ /.*/.exec("") }, ba = "gm" + (/x/.unicode == null ? "" : "u");
class Yd {
  /**
  Create a cursor that will search the given range in the given
  document. `query` should be the raw pattern (as you'd pass it to
  `new RegExp`).
  */
  constructor(e, t, i, r = 0, s = e.length) {
    if (this.text = e, this.to = s, this.curLine = "", this.done = !1, this.value = Gd, /\\[sWDnr]|\n|\r|\[\^/.test(t))
      return new Xd(e, t, i, r, s);
    this.re = new RegExp(t, ba + (i != null && i.ignoreCase ? "i" : "")), this.test = i == null ? void 0 : i.test, this.iter = e.iter();
    let o = e.lineAt(r);
    this.curLineStart = o.from, this.matchPos = ys(e, r), this.getLine(this.curLineStart);
  }
  getLine(e) {
    this.iter.next(e), this.iter.lineBreak ? this.curLine = "" : (this.curLine = this.iter.value, this.curLineStart + this.curLine.length > this.to && (this.curLine = this.curLine.slice(0, this.to - this.curLineStart)), this.iter.next());
  }
  nextLine() {
    this.curLineStart = this.curLineStart + this.curLine.length + 1, this.curLineStart > this.to ? this.curLine = "" : this.getLine(0);
  }
  /**
  Move to the next match, if there is one.
  */
  next() {
    for (let e = this.matchPos - this.curLineStart; ; ) {
      this.re.lastIndex = e;
      let t = this.matchPos <= this.to && this.re.exec(this.curLine);
      if (t) {
        let i = this.curLineStart + t.index, r = i + t[0].length;
        if (this.matchPos = ys(this.text, r + (i == r ? 1 : 0)), i == this.curLineStart + this.curLine.length && this.nextLine(), (i < r || i > this.value.to) && (!this.test || this.test(i, r, t)))
          return this.value = { from: i, to: r, match: t }, this;
        e = this.matchPos - this.curLineStart;
      } else if (this.curLineStart + this.curLine.length < this.to)
        this.nextLine(), e = 0;
      else
        return this.done = !0, this;
    }
  }
}
const vo = /* @__PURE__ */ new WeakMap();
class ti {
  constructor(e, t) {
    this.from = e, this.text = t;
  }
  get to() {
    return this.from + this.text.length;
  }
  static get(e, t, i) {
    let r = vo.get(e);
    if (!r || r.from >= i || r.to <= t) {
      let l = new ti(t, e.sliceString(t, i));
      return vo.set(e, l), l;
    }
    if (r.from == t && r.to == i)
      return r;
    let { text: s, from: o } = r;
    return o > t && (s = e.sliceString(t, o) + s, o = t), r.to < i && (s += e.sliceString(r.to, i)), vo.set(e, new ti(o, s)), new ti(t, s.slice(t - o, i - o));
  }
}
class Xd {
  constructor(e, t, i, r, s) {
    this.text = e, this.to = s, this.done = !1, this.value = Gd, this.matchPos = ys(e, r), this.re = new RegExp(t, ba + (i != null && i.ignoreCase ? "i" : "")), this.test = i == null ? void 0 : i.test, this.flat = ti.get(e, r, this.chunkEnd(
      r + 5e3
      /* Chunk.Base */
    ));
  }
  chunkEnd(e) {
    return e >= this.to ? this.to : this.text.lineAt(e).to;
  }
  next() {
    for (; ; ) {
      let e = this.re.lastIndex = this.matchPos - this.flat.from, t = this.re.exec(this.flat.text);
      if (t && !t[0] && t.index == e && (this.re.lastIndex = e + 1, t = this.re.exec(this.flat.text)), t) {
        let i = this.flat.from + t.index, r = i + t[0].length;
        if ((this.flat.to >= this.to || t.index + t[0].length <= this.flat.text.length - 10) && (!this.test || this.test(i, r, t)))
          return this.value = { from: i, to: r, match: t }, this.matchPos = ys(this.text, r + (i == r ? 1 : 0)), this;
      }
      if (this.flat.to == this.to)
        return this.done = !0, this;
      this.flat = ti.get(this.text, this.flat.from, this.chunkEnd(this.flat.from + this.flat.text.length * 2));
    }
  }
}
typeof Symbol < "u" && (Yd.prototype[Symbol.iterator] = Xd.prototype[Symbol.iterator] = function() {
  return this;
});
function ox(n) {
  try {
    return new RegExp(n, ba), !0;
  } catch {
    return !1;
  }
}
function ys(n, e) {
  if (e >= n.length)
    return e;
  let t = n.lineAt(e), i;
  for (; e < t.to && (i = t.text.charCodeAt(e - t.from)) >= 56320 && i < 57344; )
    e++;
  return e;
}
function Nl(n) {
  let e = String(n.state.doc.lineAt(n.state.selection.main.head).number), t = pe("input", { class: "cm-textfield", name: "line", value: e }), i = pe("form", {
    class: "cm-gotoLine",
    onkeydown: (s) => {
      s.keyCode == 27 ? (s.preventDefault(), n.dispatch({ effects: bs.of(!1) }), n.focus()) : s.keyCode == 13 && (s.preventDefault(), r());
    },
    onsubmit: (s) => {
      s.preventDefault(), r();
    }
  }, pe("label", n.state.phrase("Go to line"), ": ", t), " ", pe("button", { class: "cm-button", type: "submit" }, n.state.phrase("go")));
  function r() {
    let s = /^([+-])?(\d+)?(:\d+)?(%)?$/.exec(t.value);
    if (!s)
      return;
    let { state: o } = n, l = o.doc.lineAt(o.selection.main.head), [, a, u, c, h] = s, f = c ? +c.slice(1) : 0, d = u ? +u : l.number;
    if (u && h) {
      let m = d / 100;
      a && (m = m * (a == "-" ? -1 : 1) + l.number / o.doc.lines), d = Math.round(o.doc.lines * m);
    } else
      u && a && (d = d * (a == "-" ? -1 : 1) + l.number);
    let p = o.doc.line(Math.max(1, Math.min(o.doc.lines, d))), g = T.cursor(p.from + Math.max(0, Math.min(f, p.length)));
    n.dispatch({
      effects: [bs.of(!1), V.scrollIntoView(g.from, { y: "center" })],
      selection: g
    }), n.focus();
  }
  return { dom: i };
}
const bs = /* @__PURE__ */ X.define(), pc = /* @__PURE__ */ Ne.define({
  create() {
    return !0;
  },
  update(n, e) {
    for (let t of e.effects)
      t.is(bs) && (n = t.value);
    return n;
  },
  provide: (n) => Ji.from(n, (e) => e ? Nl : null)
}), lx = (n) => {
  let e = Xi(n, Nl);
  if (!e) {
    let t = [bs.of(!0)];
    n.state.field(pc, !1) == null && t.push(X.appendConfig.of([pc, ax])), n.dispatch({ effects: t }), e = Xi(n, Nl);
  }
  return e && e.dom.querySelector("input").select(), !0;
}, ax = /* @__PURE__ */ V.baseTheme({
  ".cm-panel.cm-gotoLine": {
    padding: "2px 6px 4px",
    "& label": { fontSize: "80%" }
  }
}), ux = {
  highlightWordAroundCursor: !1,
  minSelectionLength: 1,
  maxMatches: 100,
  wholeWords: !1
}, cx = /* @__PURE__ */ j.define({
  combine(n) {
    return Vt(n, ux, {
      highlightWordAroundCursor: (e, t) => e || t,
      minSelectionLength: Math.min,
      maxMatches: Math.min
    });
  }
});
function hx(n) {
  return [gx, mx];
}
const fx = /* @__PURE__ */ q.mark({ class: "cm-selectionMatch" }), dx = /* @__PURE__ */ q.mark({ class: "cm-selectionMatch cm-selectionMatch-main" });
function mc(n, e, t, i) {
  return (t == 0 || n(e.sliceDoc(t - 1, t)) != be.Word) && (i == e.doc.length || n(e.sliceDoc(i, i + 1)) != be.Word);
}
function px(n, e, t, i) {
  return n(e.sliceDoc(t, t + 1)) == be.Word && n(e.sliceDoc(i - 1, i)) == be.Word;
}
const mx = /* @__PURE__ */ ke.fromClass(class {
  constructor(n) {
    this.decorations = this.getDeco(n);
  }
  update(n) {
    (n.selectionSet || n.docChanged || n.viewportChanged) && (this.decorations = this.getDeco(n.view));
  }
  getDeco(n) {
    let e = n.state.facet(cx), { state: t } = n, i = t.selection;
    if (i.ranges.length > 1)
      return q.none;
    let r = i.main, s, o = null;
    if (r.empty) {
      if (!e.highlightWordAroundCursor)
        return q.none;
      let a = t.wordAt(r.head);
      if (!a)
        return q.none;
      o = t.charCategorizer(r.head), s = t.sliceDoc(a.from, a.to);
    } else {
      let a = r.to - r.from;
      if (a < e.minSelectionLength || a > 200)
        return q.none;
      if (e.wholeWords) {
        if (s = t.sliceDoc(r.from, r.to), o = t.charCategorizer(r.head), !(mc(o, t, r.from, r.to) && px(o, t, r.from, r.to)))
          return q.none;
      } else if (s = t.sliceDoc(r.from, r.to), !s)
        return q.none;
    }
    let l = [];
    for (let a of n.visibleRanges) {
      let u = new ci(t.doc, s, a.from, a.to);
      for (; !u.next().done; ) {
        let { from: c, to: h } = u.value;
        if ((!o || mc(o, t, c, h)) && (r.empty && c <= r.from && h >= r.to ? l.push(dx.range(c, h)) : (c >= r.to || h <= r.from) && l.push(fx.range(c, h)), l.length > e.maxMatches))
          return q.none;
      }
    }
    return q.set(l);
  }
}, {
  decorations: (n) => n.decorations
}), gx = /* @__PURE__ */ V.baseTheme({
  ".cm-selectionMatch": { backgroundColor: "#99ff7780" },
  ".cm-searchMatch .cm-selectionMatch": { backgroundColor: "transparent" }
}), yx = ({ state: n, dispatch: e }) => {
  let { selection: t } = n, i = T.create(t.ranges.map((r) => n.wordAt(r.head) || T.cursor(r.head)), t.mainIndex);
  return i.eq(t) ? !1 : (e(n.update({ selection: i })), !0);
};
function bx(n, e) {
  let { main: t, ranges: i } = n.selection, r = n.wordAt(t.head), s = r && r.from == t.from && r.to == t.to;
  for (let o = !1, l = new ci(n.doc, e, i[i.length - 1].to); ; )
    if (l.next(), l.done) {
      if (o)
        return null;
      l = new ci(n.doc, e, 0, Math.max(0, i[i.length - 1].from - 1)), o = !0;
    } else {
      if (o && i.some((a) => a.from == l.value.from))
        continue;
      if (s) {
        let a = n.wordAt(l.value.from);
        if (!a || a.from != l.value.from || a.to != l.value.to)
          continue;
      }
      return l.value;
    }
}
const xx = ({ state: n, dispatch: e }) => {
  let { ranges: t } = n.selection;
  if (t.some((s) => s.from === s.to))
    return yx({ state: n, dispatch: e });
  let i = n.sliceDoc(t[0].from, t[0].to);
  if (n.selection.ranges.some((s) => n.sliceDoc(s.from, s.to) != i))
    return !1;
  let r = bx(n, i);
  return r ? (e(n.update({
    selection: n.selection.addRange(T.range(r.from, r.to), !1),
    effects: V.scrollIntoView(r.to)
  })), !0) : !1;
}, mi = /* @__PURE__ */ j.define({
  combine(n) {
    return Vt(n, {
      top: !1,
      caseSensitive: !1,
      literal: !1,
      regexp: !1,
      wholeWord: !1,
      createPanel: (e) => new Lx(e),
      scrollToMatch: (e) => V.scrollIntoView(e)
    });
  }
});
class Jd {
  /**
  Create a query object.
  */
  constructor(e) {
    this.search = e.search, this.caseSensitive = !!e.caseSensitive, this.literal = !!e.literal, this.regexp = !!e.regexp, this.replace = e.replace || "", this.valid = !!this.search && (!this.regexp || ox(this.search)), this.unquoted = this.unquote(this.search), this.wholeWord = !!e.wholeWord;
  }
  /**
  @internal
  */
  unquote(e) {
    return this.literal ? e : e.replace(/\\([nrt\\])/g, (t, i) => i == "n" ? `
` : i == "r" ? "\r" : i == "t" ? "	" : "\\");
  }
  /**
  Compare this query to another query.
  */
  eq(e) {
    return this.search == e.search && this.replace == e.replace && this.caseSensitive == e.caseSensitive && this.regexp == e.regexp && this.wholeWord == e.wholeWord;
  }
  /**
  @internal
  */
  create() {
    return this.regexp ? new Sx(this) : new kx(this);
  }
  /**
  Get a search cursor for this query, searching through the given
  range in the given state.
  */
  getCursor(e, t = 0, i) {
    let r = e.doc ? e : Q.create({ doc: e });
    return i == null && (i = r.doc.length), this.regexp ? Un(this, r, t, i) : qn(this, r, t, i);
  }
}
class Qd {
  constructor(e) {
    this.spec = e;
  }
}
function qn(n, e, t, i) {
  return new ci(e.doc, n.unquoted, t, i, n.caseSensitive ? void 0 : (r) => r.toLowerCase(), n.wholeWord ? wx(e.doc, e.charCategorizer(e.selection.main.head)) : void 0);
}
function wx(n, e) {
  return (t, i, r, s) => ((s > t || s + r.length < i) && (s = Math.max(0, t - 2), r = n.sliceString(s, Math.min(n.length, i + 2))), (e(xs(r, t - s)) != be.Word || e(ws(r, t - s)) != be.Word) && (e(ws(r, i - s)) != be.Word || e(xs(r, i - s)) != be.Word));
}
class kx extends Qd {
  constructor(e) {
    super(e);
  }
  nextMatch(e, t, i) {
    let r = qn(this.spec, e, i, e.doc.length).nextOverlapping();
    return r.done && (r = qn(this.spec, e, 0, t).nextOverlapping()), r.done ? null : r.value;
  }
  // Searching in reverse is, rather than implementing an inverted search
  // cursor, done by scanning chunk after chunk forward.
  prevMatchInRange(e, t, i) {
    for (let r = i; ; ) {
      let s = Math.max(t, r - 1e4 - this.spec.unquoted.length), o = qn(this.spec, e, s, r), l = null;
      for (; !o.nextOverlapping().done; )
        l = o.value;
      if (l)
        return l;
      if (s == t)
        return null;
      r -= 1e4;
    }
  }
  prevMatch(e, t, i) {
    return this.prevMatchInRange(e, 0, t) || this.prevMatchInRange(e, i, e.doc.length);
  }
  getReplacement(e) {
    return this.spec.unquote(this.spec.replace);
  }
  matchAll(e, t) {
    let i = qn(this.spec, e, 0, e.doc.length), r = [];
    for (; !i.next().done; ) {
      if (r.length >= t)
        return null;
      r.push(i.value);
    }
    return r;
  }
  highlight(e, t, i, r) {
    let s = qn(this.spec, e, Math.max(0, t - this.spec.unquoted.length), Math.min(i + this.spec.unquoted.length, e.doc.length));
    for (; !s.next().done; )
      r(s.value.from, s.value.to);
  }
}
function Un(n, e, t, i) {
  return new Yd(e.doc, n.search, {
    ignoreCase: !n.caseSensitive,
    test: n.wholeWord ? vx(e.charCategorizer(e.selection.main.head)) : void 0
  }, t, i);
}
function xs(n, e) {
  return n.slice(Re(n, e, !1), e);
}
function ws(n, e) {
  return n.slice(e, Re(n, e));
}
function vx(n) {
  return (e, t, i) => !i[0].length || (n(xs(i.input, i.index)) != be.Word || n(ws(i.input, i.index)) != be.Word) && (n(ws(i.input, i.index + i[0].length)) != be.Word || n(xs(i.input, i.index + i[0].length)) != be.Word);
}
class Sx extends Qd {
  nextMatch(e, t, i) {
    let r = Un(this.spec, e, i, e.doc.length).next();
    return r.done && (r = Un(this.spec, e, 0, t).next()), r.done ? null : r.value;
  }
  prevMatchInRange(e, t, i) {
    for (let r = 1; ; r++) {
      let s = Math.max(
        t,
        i - r * 1e4
        /* FindPrev.ChunkSize */
      ), o = Un(this.spec, e, s, i), l = null;
      for (; !o.next().done; )
        l = o.value;
      if (l && (s == t || l.from > s + 10))
        return l;
      if (s == t)
        return null;
    }
  }
  prevMatch(e, t, i) {
    return this.prevMatchInRange(e, 0, t) || this.prevMatchInRange(e, i, e.doc.length);
  }
  getReplacement(e) {
    return this.spec.unquote(this.spec.replace).replace(/\$([$&\d+])/g, (t, i) => i == "$" ? "$" : i == "&" ? e.match[0] : i != "0" && +i < e.match.length ? e.match[i] : t);
  }
  matchAll(e, t) {
    let i = Un(this.spec, e, 0, e.doc.length), r = [];
    for (; !i.next().done; ) {
      if (r.length >= t)
        return null;
      r.push(i.value);
    }
    return r;
  }
  highlight(e, t, i, r) {
    let s = Un(this.spec, e, Math.max(
      0,
      t - 250
      /* RegExp.HighlightMargin */
    ), Math.min(i + 250, e.doc.length));
    for (; !s.next().done; )
      r(s.value.from, s.value.to);
  }
}
const er = /* @__PURE__ */ X.define(), xa = /* @__PURE__ */ X.define(), hn = /* @__PURE__ */ Ne.define({
  create(n) {
    return new So(Fl(n).create(), null);
  },
  update(n, e) {
    for (let t of e.effects)
      t.is(er) ? n = new So(t.value.create(), n.panel) : t.is(xa) && (n = new So(n.query, t.value ? wa : null));
    return n;
  },
  provide: (n) => Ji.from(n, (e) => e.panel)
});
class So {
  constructor(e, t) {
    this.query = e, this.panel = t;
  }
}
const Cx = /* @__PURE__ */ q.mark({ class: "cm-searchMatch" }), Ax = /* @__PURE__ */ q.mark({ class: "cm-searchMatch cm-searchMatch-selected" }), Mx = /* @__PURE__ */ ke.fromClass(class {
  constructor(n) {
    this.view = n, this.decorations = this.highlight(n.state.field(hn));
  }
  update(n) {
    let e = n.state.field(hn);
    (e != n.startState.field(hn) || n.docChanged || n.selectionSet || n.viewportChanged) && (this.decorations = this.highlight(e));
  }
  highlight({ query: n, panel: e }) {
    if (!e || !n.spec.valid)
      return q.none;
    let { view: t } = this, i = new dn();
    for (let r = 0, s = t.visibleRanges, o = s.length; r < o; r++) {
      let { from: l, to: a } = s[r];
      for (; r < o - 1 && a > s[r + 1].from - 2 * 250; )
        a = s[++r].to;
      n.highlight(t.state, l, a, (u, c) => {
        let h = t.state.selection.ranges.some((f) => f.from == u && f.to == c);
        i.add(u, c, h ? Ax : Cx);
      });
    }
    return i.finish();
  }
}, {
  decorations: (n) => n.decorations
});
function ur(n) {
  return (e) => {
    let t = e.state.field(hn, !1);
    return t && t.query.spec.valid ? n(e, t) : tp(e);
  };
}
const ks = /* @__PURE__ */ ur((n, { query: e }) => {
  let { to: t } = n.state.selection.main, i = e.nextMatch(n.state, t, t);
  if (!i)
    return !1;
  let r = T.single(i.from, i.to), s = n.state.facet(mi);
  return n.dispatch({
    selection: r,
    effects: [ka(n, i), s.scrollToMatch(r.main, n)],
    userEvent: "select.search"
  }), ep(n), !0;
}), vs = /* @__PURE__ */ ur((n, { query: e }) => {
  let { state: t } = n, { from: i } = t.selection.main, r = e.prevMatch(t, i, i);
  if (!r)
    return !1;
  let s = T.single(r.from, r.to), o = n.state.facet(mi);
  return n.dispatch({
    selection: s,
    effects: [ka(n, r), o.scrollToMatch(s.main, n)],
    userEvent: "select.search"
  }), ep(n), !0;
}), Tx = /* @__PURE__ */ ur((n, { query: e }) => {
  let t = e.matchAll(n.state, 1e3);
  return !t || !t.length ? !1 : (n.dispatch({
    selection: T.create(t.map((i) => T.range(i.from, i.to))),
    userEvent: "select.search.matches"
  }), !0);
}), Ox = ({ state: n, dispatch: e }) => {
  let t = n.selection;
  if (t.ranges.length > 1 || t.main.empty)
    return !1;
  let { from: i, to: r } = t.main, s = [], o = 0;
  for (let l = new ci(n.doc, n.sliceDoc(i, r)); !l.next().done; ) {
    if (s.length > 1e3)
      return !1;
    l.value.from == i && (o = s.length), s.push(T.range(l.value.from, l.value.to));
  }
  return e(n.update({
    selection: T.create(s, o),
    userEvent: "select.search.matches"
  })), !0;
}, gc = /* @__PURE__ */ ur((n, { query: e }) => {
  let { state: t } = n, { from: i, to: r } = t.selection.main;
  if (t.readOnly)
    return !1;
  let s = e.nextMatch(t, i, i);
  if (!s)
    return !1;
  let o = [], l, a, u = [];
  if (s.from == i && s.to == r && (a = t.toText(e.getReplacement(s)), o.push({ from: s.from, to: s.to, insert: a }), s = e.nextMatch(t, s.from, s.to), u.push(V.announce.of(t.phrase("replaced match on line $", t.doc.lineAt(i).number) + "."))), s) {
    let c = o.length == 0 || o[0].from >= s.to ? 0 : s.to - s.from - a.length;
    l = T.single(s.from - c, s.to - c), u.push(ka(n, s)), u.push(t.facet(mi).scrollToMatch(l.main, n));
  }
  return n.dispatch({
    changes: o,
    selection: l,
    effects: u,
    userEvent: "input.replace"
  }), !0;
}), Dx = /* @__PURE__ */ ur((n, { query: e }) => {
  if (n.state.readOnly)
    return !1;
  let t = e.matchAll(n.state, 1e9).map((r) => {
    let { from: s, to: o } = r;
    return { from: s, to: o, insert: e.getReplacement(r) };
  });
  if (!t.length)
    return !1;
  let i = n.state.phrase("replaced $ matches", t.length) + ".";
  return n.dispatch({
    changes: t,
    effects: V.announce.of(i),
    userEvent: "input.replace.all"
  }), !0;
});
function wa(n) {
  return n.state.facet(mi).createPanel(n);
}
function Fl(n, e) {
  var t, i, r, s, o;
  let l = n.selection.main, a = l.empty || l.to > l.from + 100 ? "" : n.sliceDoc(l.from, l.to);
  if (e && !a)
    return e;
  let u = n.facet(mi);
  return new Jd({
    search: ((t = e == null ? void 0 : e.literal) !== null && t !== void 0 ? t : u.literal) ? a : a.replace(/\n/g, "\\n"),
    caseSensitive: (i = e == null ? void 0 : e.caseSensitive) !== null && i !== void 0 ? i : u.caseSensitive,
    literal: (r = e == null ? void 0 : e.literal) !== null && r !== void 0 ? r : u.literal,
    regexp: (s = e == null ? void 0 : e.regexp) !== null && s !== void 0 ? s : u.regexp,
    wholeWord: (o = e == null ? void 0 : e.wholeWord) !== null && o !== void 0 ? o : u.wholeWord
  });
}
function Zd(n) {
  let e = Xi(n, wa);
  return e && e.dom.querySelector("[main-field]");
}
function ep(n) {
  let e = Zd(n);
  e && e == n.root.activeElement && e.select();
}
const tp = (n) => {
  let e = n.state.field(hn, !1);
  if (e && e.panel) {
    let t = Zd(n);
    if (t && t != n.root.activeElement) {
      let i = Fl(n.state, e.query.spec);
      i.valid && n.dispatch({ effects: er.of(i) }), t.focus(), t.select();
    }
  } else
    n.dispatch({ effects: [
      xa.of(!0),
      e ? er.of(Fl(n.state, e.query.spec)) : X.appendConfig.of(Px)
    ] });
  return !0;
}, np = (n) => {
  let e = n.state.field(hn, !1);
  if (!e || !e.panel)
    return !1;
  let t = Xi(n, wa);
  return t && t.dom.contains(n.root.activeElement) && n.focus(), n.dispatch({ effects: xa.of(!1) }), !0;
}, Ex = [
  { key: "Mod-f", run: tp, scope: "editor search-panel" },
  { key: "F3", run: ks, shift: vs, scope: "editor search-panel", preventDefault: !0 },
  { key: "Mod-g", run: ks, shift: vs, scope: "editor search-panel", preventDefault: !0 },
  { key: "Escape", run: np, scope: "editor search-panel" },
  { key: "Mod-Shift-l", run: Ox },
  { key: "Mod-Alt-g", run: lx },
  { key: "Mod-d", run: xx, preventDefault: !0 }
];
class Lx {
  constructor(e) {
    this.view = e;
    let t = this.query = e.state.field(hn).query.spec;
    this.commit = this.commit.bind(this), this.searchField = pe("input", {
      value: t.search,
      placeholder: tt(e, "Find"),
      "aria-label": tt(e, "Find"),
      class: "cm-textfield",
      name: "search",
      form: "",
      "main-field": "true",
      onchange: this.commit,
      onkeyup: this.commit
    }), this.replaceField = pe("input", {
      value: t.replace,
      placeholder: tt(e, "Replace"),
      "aria-label": tt(e, "Replace"),
      class: "cm-textfield",
      name: "replace",
      form: "",
      onchange: this.commit,
      onkeyup: this.commit
    }), this.caseField = pe("input", {
      type: "checkbox",
      name: "case",
      form: "",
      checked: t.caseSensitive,
      onchange: this.commit
    }), this.reField = pe("input", {
      type: "checkbox",
      name: "re",
      form: "",
      checked: t.regexp,
      onchange: this.commit
    }), this.wordField = pe("input", {
      type: "checkbox",
      name: "word",
      form: "",
      checked: t.wholeWord,
      onchange: this.commit
    });
    function i(r, s, o) {
      return pe("button", { class: "cm-button", name: r, onclick: s, type: "button" }, o);
    }
    this.dom = pe("div", { onkeydown: (r) => this.keydown(r), class: "cm-search" }, [
      this.searchField,
      i("next", () => ks(e), [tt(e, "next")]),
      i("prev", () => vs(e), [tt(e, "previous")]),
      i("select", () => Tx(e), [tt(e, "all")]),
      pe("label", null, [this.caseField, tt(e, "match case")]),
      pe("label", null, [this.reField, tt(e, "regexp")]),
      pe("label", null, [this.wordField, tt(e, "by word")]),
      ...e.state.readOnly ? [] : [
        pe("br"),
        this.replaceField,
        i("replace", () => gc(e), [tt(e, "replace")]),
        i("replaceAll", () => Dx(e), [tt(e, "replace all")])
      ],
      pe("button", {
        name: "close",
        onclick: () => np(e),
        "aria-label": tt(e, "close"),
        type: "button"
      }, ["×"])
    ]);
  }
  commit() {
    let e = new Jd({
      search: this.searchField.value,
      caseSensitive: this.caseField.checked,
      regexp: this.reField.checked,
      wholeWord: this.wordField.checked,
      replace: this.replaceField.value
    });
    e.eq(this.query) || (this.query = e, this.view.dispatch({ effects: er.of(e) }));
  }
  keydown(e) {
    z0(this.view, e, "search-panel") ? e.preventDefault() : e.keyCode == 13 && e.target == this.searchField ? (e.preventDefault(), (e.shiftKey ? vs : ks)(this.view)) : e.keyCode == 13 && e.target == this.replaceField && (e.preventDefault(), gc(this.view));
  }
  update(e) {
    for (let t of e.transactions)
      for (let i of t.effects)
        i.is(er) && !i.value.eq(this.query) && this.setQuery(i.value);
  }
  setQuery(e) {
    this.query = e, this.searchField.value = e.search, this.replaceField.value = e.replace, this.caseField.checked = e.caseSensitive, this.reField.checked = e.regexp, this.wordField.checked = e.wholeWord;
  }
  mount() {
    this.searchField.select();
  }
  get pos() {
    return 80;
  }
  get top() {
    return this.view.state.facet(mi).top;
  }
}
function tt(n, e) {
  return n.state.phrase(e);
}
const Ir = 30, Pr = /[\s\.,:;?!]/;
function ka(n, { from: e, to: t }) {
  let i = n.state.doc.lineAt(e), r = n.state.doc.lineAt(t).to, s = Math.max(i.from, e - Ir), o = Math.min(r, t + Ir), l = n.state.sliceDoc(s, o);
  if (s != i.from) {
    for (let a = 0; a < Ir; a++)
      if (!Pr.test(l[a + 1]) && Pr.test(l[a])) {
        l = l.slice(a);
        break;
      }
  }
  if (o != r) {
    for (let a = l.length - 1; a > l.length - Ir; a--)
      if (!Pr.test(l[a - 1]) && Pr.test(l[a])) {
        l = l.slice(0, a);
        break;
      }
  }
  return V.announce.of(`${n.state.phrase("current match")}. ${l} ${n.state.phrase("on line")} ${i.number}.`);
}
const Ix = /* @__PURE__ */ V.baseTheme({
  ".cm-panel.cm-search": {
    padding: "2px 6px 4px",
    position: "relative",
    "& [name=close]": {
      position: "absolute",
      top: "0",
      right: "4px",
      backgroundColor: "inherit",
      border: "none",
      font: "inherit",
      padding: 0,
      margin: 0
    },
    "& input, & button, & label": {
      margin: ".2em .6em .2em 0"
    },
    "& input[type=checkbox]": {
      marginRight: ".2em"
    },
    "& label": {
      fontSize: "80%",
      whiteSpace: "pre"
    }
  },
  "&light .cm-searchMatch": { backgroundColor: "#ffff0054" },
  "&dark .cm-searchMatch": { backgroundColor: "#00ffff8a" },
  "&light .cm-searchMatch-selected": { backgroundColor: "#ff6a0054" },
  "&dark .cm-searchMatch-selected": { backgroundColor: "#ff00ff8a" }
}), Px = [
  hn,
  /* @__PURE__ */ Hn.low(Mx),
  Ix
];
class ip {
  /**
  Create a new completion context. (Mostly useful for testing
  completion sources—in the editor, the extension will create
  these for you.)
  */
  constructor(e, t, i) {
    this.state = e, this.pos = t, this.explicit = i, this.abortListeners = [];
  }
  /**
  Get the extent, content, and (if there is a token) type of the
  token before `this.pos`.
  */
  tokenBefore(e) {
    let t = _e(this.state).resolveInner(this.pos, -1);
    for (; t && e.indexOf(t.name) < 0; )
      t = t.parent;
    return t ? {
      from: t.from,
      to: this.pos,
      text: this.state.sliceDoc(t.from, this.pos),
      type: t.type
    } : null;
  }
  /**
  Get the match of the given expression directly before the
  cursor.
  */
  matchBefore(e) {
    let t = this.state.doc.lineAt(this.pos), i = Math.max(t.from, this.pos - 250), r = t.text.slice(i - t.from, this.pos - t.from), s = r.search(rp(e, !1));
    return s < 0 ? null : { from: i + s, to: this.pos, text: r.slice(s) };
  }
  /**
  Yields true when the query has been aborted. Can be useful in
  asynchronous queries to avoid doing work that will be ignored.
  */
  get aborted() {
    return this.abortListeners == null;
  }
  /**
  Allows you to register abort handlers, which will be called when
  the query is
  [aborted](https://codemirror.net/6/docs/ref/#autocomplete.CompletionContext.aborted).
  */
  addEventListener(e, t) {
    e == "abort" && this.abortListeners && this.abortListeners.push(t);
  }
}
function yc(n) {
  let e = Object.keys(n).join(""), t = /\w/.test(e);
  return t && (e = e.replace(/\w/g, "")), `[${t ? "\\w" : ""}${e.replace(/[^\w\s]/g, "\\$&")}]`;
}
function Bx(n) {
  let e = /* @__PURE__ */ Object.create(null), t = /* @__PURE__ */ Object.create(null);
  for (let { label: r } of n) {
    e[r[0]] = !0;
    for (let s = 1; s < r.length; s++)
      t[r[s]] = !0;
  }
  let i = yc(e) + yc(t) + "*$";
  return [new RegExp("^" + i), new RegExp(i)];
}
function Rx(n) {
  let e = n.map((r) => typeof r == "string" ? { label: r } : r), [t, i] = e.every((r) => /^\w+$/.test(r.label)) ? [/\w*$/, /\w+$/] : Bx(e);
  return (r) => {
    let s = r.matchBefore(i);
    return s || r.explicit ? { from: s ? s.from : r.pos, options: e, validFor: t } : null;
  };
}
class bc {
  constructor(e, t, i, r) {
    this.completion = e, this.source = t, this.match = i, this.score = r;
  }
}
function fn(n) {
  return n.selection.main.from;
}
function rp(n, e) {
  var t;
  let { source: i } = n, r = e && i[0] != "^", s = i[i.length - 1] != "$";
  return !r && !s ? n : new RegExp(`${r ? "^" : ""}(?:${i})${s ? "$" : ""}`, (t = n.flags) !== null && t !== void 0 ? t : n.ignoreCase ? "i" : "");
}
const sp = /* @__PURE__ */ Xt.define();
function Nx(n, e, t, i) {
  let { main: r } = n.selection, s = t - r.from, o = i - r.from;
  return Object.assign(Object.assign({}, n.changeByRange((l) => l != r && t != i && n.sliceDoc(l.from + s, l.from + o) != n.sliceDoc(t, i) ? { range: l } : {
    changes: { from: l.from + s, to: i == r.from ? l.to : l.from + o, insert: e },
    range: T.cursor(l.from + s + e.length)
  })), { scrollIntoView: !0, userEvent: "input.complete" });
}
const xc = /* @__PURE__ */ new WeakMap();
function Fx(n) {
  if (!Array.isArray(n))
    return n;
  let e = xc.get(n);
  return e || xc.set(n, e = Rx(n)), e;
}
const Ss = /* @__PURE__ */ X.define(), tr = /* @__PURE__ */ X.define();
class zx {
  constructor(e) {
    this.pattern = e, this.chars = [], this.folded = [], this.any = [], this.precise = [], this.byWord = [], this.score = 0, this.matched = [];
    for (let t = 0; t < e.length; ) {
      let i = Le(e, t), r = ht(i);
      this.chars.push(i);
      let s = e.slice(t, t + r), o = s.toUpperCase();
      this.folded.push(Le(o == s ? s.toLowerCase() : o, 0)), t += r;
    }
    this.astral = e.length != this.chars.length;
  }
  ret(e, t) {
    return this.score = e, this.matched = t, this;
  }
  // Matches a given word (completion) against the pattern (input).
  // Will return a boolean indicating whether there was a match and,
  // on success, set `this.score` to the score, `this.matched` to an
  // array of `from, to` pairs indicating the matched parts of `word`.
  //
  // The score is a number that is more negative the worse the match
  // is. See `Penalty` above.
  match(e) {
    if (this.pattern.length == 0)
      return this.ret(-100, []);
    if (e.length < this.pattern.length)
      return null;
    let { chars: t, folded: i, any: r, precise: s, byWord: o } = this;
    if (t.length == 1) {
      let v = Le(e, 0), C = ht(v), O = C == e.length ? 0 : -100;
      if (v != t[0])
        if (v == i[0])
          O += -200;
        else
          return null;
      return this.ret(O, [0, C]);
    }
    let l = e.indexOf(this.pattern);
    if (l == 0)
      return this.ret(e.length == this.pattern.length ? 0 : -100, [0, this.pattern.length]);
    let a = t.length, u = 0;
    if (l < 0) {
      for (let v = 0, C = Math.min(e.length, 200); v < C && u < a; ) {
        let O = Le(e, v);
        (O == t[u] || O == i[u]) && (r[u++] = v), v += ht(O);
      }
      if (u < a)
        return null;
    }
    let c = 0, h = 0, f = !1, d = 0, p = -1, g = -1, m = /[a-z]/.test(e), y = !0;
    for (let v = 0, C = Math.min(e.length, 200), O = 0; v < C && h < a; ) {
      let A = Le(e, v);
      l < 0 && (c < a && A == t[c] && (s[c++] = v), d < a && (A == t[d] || A == i[d] ? (d == 0 && (p = v), g = v + 1, d++) : d = 0));
      let b, S = A < 255 ? A >= 48 && A <= 57 || A >= 97 && A <= 122 ? 2 : A >= 65 && A <= 90 ? 1 : 0 : (b = Ql(A)) != b.toLowerCase() ? 1 : b != b.toUpperCase() ? 2 : 0;
      (!v || S == 1 && m || O == 0 && S != 0) && (t[h] == A || i[h] == A && (f = !0) ? o[h++] = v : o.length && (y = !1)), O = S, v += ht(A);
    }
    return h == a && o[0] == 0 && y ? this.result(-100 + (f ? -200 : 0), o, e) : d == a && p == 0 ? this.ret(-200 - e.length + (g == e.length ? 0 : -100), [0, g]) : l > -1 ? this.ret(-700 - e.length, [l, l + this.pattern.length]) : d == a ? this.ret(-900 - e.length, [p, g]) : h == a ? this.result(-100 + (f ? -200 : 0) + -700 + (y ? 0 : -1100), o, e) : t.length == 2 ? null : this.result((r[0] ? -700 : 0) + -200 + -1100, r, e);
  }
  result(e, t, i) {
    let r = [], s = 0;
    for (let o of t) {
      let l = o + (this.astral ? ht(Le(i, o)) : 1);
      s && r[s - 1] == o ? r[s - 1] = l : (r[s++] = o, r[s++] = l);
    }
    return this.ret(e - i.length, r);
  }
}
class Hx {
  constructor(e) {
    this.pattern = e, this.matched = [], this.score = 0, this.folded = e.toLowerCase();
  }
  match(e) {
    if (e.length < this.pattern.length)
      return null;
    let t = e.slice(0, this.pattern.length), i = t == this.pattern ? 0 : t.toLowerCase() == this.folded ? -200 : null;
    return i == null ? null : (this.matched = [0, t.length], this.score = i + (e.length == this.pattern.length ? 0 : -100), this);
  }
}
const Be = /* @__PURE__ */ j.define({
  combine(n) {
    return Vt(n, {
      activateOnTyping: !0,
      activateOnCompletion: () => !1,
      activateOnTypingDelay: 100,
      selectOnOpen: !0,
      override: null,
      closeOnBlur: !0,
      maxRenderedOptions: 100,
      defaultKeymap: !0,
      tooltipClass: () => "",
      optionClass: () => "",
      aboveCursor: !1,
      icons: !0,
      addToOptions: [],
      positionInfo: Vx,
      filterStrict: !1,
      compareCompletions: (e, t) => e.label.localeCompare(t.label),
      interactionDelay: 75,
      updateSyncTime: 100
    }, {
      defaultKeymap: (e, t) => e && t,
      closeOnBlur: (e, t) => e && t,
      icons: (e, t) => e && t,
      tooltipClass: (e, t) => (i) => wc(e(i), t(i)),
      optionClass: (e, t) => (i) => wc(e(i), t(i)),
      addToOptions: (e, t) => e.concat(t),
      filterStrict: (e, t) => e || t
    });
  }
});
function wc(n, e) {
  return n ? e ? n + " " + e : n : e;
}
function Vx(n, e, t, i, r, s) {
  let o = n.textDirection == ye.RTL, l = o, a = !1, u = "top", c, h, f = e.left - r.left, d = r.right - e.right, p = i.right - i.left, g = i.bottom - i.top;
  if (l && f < Math.min(p, d) ? l = !1 : !l && d < Math.min(p, f) && (l = !0), p <= (l ? f : d))
    c = Math.max(r.top, Math.min(t.top, r.bottom - g)) - e.top, h = Math.min(400, l ? f : d);
  else {
    a = !0, h = Math.min(
      400,
      (o ? e.right : r.right - e.left) - 30
      /* Info.Margin */
    );
    let v = r.bottom - e.bottom;
    v >= g || v > e.top ? c = t.bottom - e.top : (u = "bottom", c = e.bottom - t.top);
  }
  let m = (e.bottom - e.top) / s.offsetHeight, y = (e.right - e.left) / s.offsetWidth;
  return {
    style: `${u}: ${c / m}px; max-width: ${h / y}px`,
    class: "cm-completionInfo-" + (a ? o ? "left-narrow" : "right-narrow" : l ? "left" : "right")
  };
}
function _x(n) {
  let e = n.addToOptions.slice();
  return n.icons && e.push({
    render(t) {
      let i = document.createElement("div");
      return i.classList.add("cm-completionIcon"), t.type && i.classList.add(...t.type.split(/\s+/g).map((r) => "cm-completionIcon-" + r)), i.setAttribute("aria-hidden", "true"), i;
    },
    position: 20
  }), e.push({
    render(t, i, r, s) {
      let o = document.createElement("span");
      o.className = "cm-completionLabel";
      let l = t.displayLabel || t.label, a = 0;
      for (let u = 0; u < s.length; ) {
        let c = s[u++], h = s[u++];
        c > a && o.appendChild(document.createTextNode(l.slice(a, c)));
        let f = o.appendChild(document.createElement("span"));
        f.appendChild(document.createTextNode(l.slice(c, h))), f.className = "cm-completionMatchedText", a = h;
      }
      return a < l.length && o.appendChild(document.createTextNode(l.slice(a))), o;
    },
    position: 50
  }, {
    render(t) {
      if (!t.detail)
        return null;
      let i = document.createElement("span");
      return i.className = "cm-completionDetail", i.textContent = t.detail, i;
    },
    position: 80
  }), e.sort((t, i) => t.position - i.position).map((t) => t.render);
}
function Co(n, e, t) {
  if (n <= t)
    return { from: 0, to: n };
  if (e < 0 && (e = 0), e <= n >> 1) {
    let r = Math.floor(e / t);
    return { from: r * t, to: (r + 1) * t };
  }
  let i = Math.floor((n - e) / t);
  return { from: n - (i + 1) * t, to: n - i * t };
}
class $x {
  constructor(e, t, i) {
    this.view = e, this.stateField = t, this.applyCompletion = i, this.info = null, this.infoDestroy = null, this.placeInfoReq = {
      read: () => this.measureInfo(),
      write: (a) => this.placeInfo(a),
      key: this
    }, this.space = null, this.currentClass = "";
    let r = e.state.field(t), { options: s, selected: o } = r.open, l = e.state.facet(Be);
    this.optionContent = _x(l), this.optionClass = l.optionClass, this.tooltipClass = l.tooltipClass, this.range = Co(s.length, o, l.maxRenderedOptions), this.dom = document.createElement("div"), this.dom.className = "cm-tooltip-autocomplete", this.updateTooltipClass(e.state), this.dom.addEventListener("mousedown", (a) => {
      let { options: u } = e.state.field(t).open;
      for (let c = a.target, h; c && c != this.dom; c = c.parentNode)
        if (c.nodeName == "LI" && (h = /-(\d+)$/.exec(c.id)) && +h[1] < u.length) {
          this.applyCompletion(e, u[+h[1]]), a.preventDefault();
          return;
        }
    }), this.dom.addEventListener("focusout", (a) => {
      let u = e.state.field(this.stateField, !1);
      u && u.tooltip && e.state.facet(Be).closeOnBlur && a.relatedTarget != e.contentDOM && e.dispatch({ effects: tr.of(null) });
    }), this.showOptions(s, r.id);
  }
  mount() {
    this.updateSel();
  }
  showOptions(e, t) {
    this.list && this.list.remove(), this.list = this.dom.appendChild(this.createListBox(e, t, this.range)), this.list.addEventListener("scroll", () => {
      this.info && this.view.requestMeasure(this.placeInfoReq);
    });
  }
  update(e) {
    var t;
    let i = e.state.field(this.stateField), r = e.startState.field(this.stateField);
    if (this.updateTooltipClass(e.state), i != r) {
      let { options: s, selected: o, disabled: l } = i.open;
      (!r.open || r.open.options != s) && (this.range = Co(s.length, o, e.state.facet(Be).maxRenderedOptions), this.showOptions(s, i.id)), this.updateSel(), l != ((t = r.open) === null || t === void 0 ? void 0 : t.disabled) && this.dom.classList.toggle("cm-tooltip-autocomplete-disabled", !!l);
    }
  }
  updateTooltipClass(e) {
    let t = this.tooltipClass(e);
    if (t != this.currentClass) {
      for (let i of this.currentClass.split(" "))
        i && this.dom.classList.remove(i);
      for (let i of t.split(" "))
        i && this.dom.classList.add(i);
      this.currentClass = t;
    }
  }
  positioned(e) {
    this.space = e, this.info && this.view.requestMeasure(this.placeInfoReq);
  }
  updateSel() {
    let e = this.view.state.field(this.stateField), t = e.open;
    if ((t.selected > -1 && t.selected < this.range.from || t.selected >= this.range.to) && (this.range = Co(t.options.length, t.selected, this.view.state.facet(Be).maxRenderedOptions), this.showOptions(t.options, e.id)), this.updateSelectedOption(t.selected)) {
      this.destroyInfo();
      let { completion: i } = t.options[t.selected], { info: r } = i;
      if (!r)
        return;
      let s = typeof r == "string" ? document.createTextNode(r) : r(i);
      if (!s)
        return;
      "then" in s ? s.then((o) => {
        o && this.view.state.field(this.stateField, !1) == e && this.addInfoPane(o, i);
      }).catch((o) => Je(this.view.state, o, "completion info")) : this.addInfoPane(s, i);
    }
  }
  addInfoPane(e, t) {
    this.destroyInfo();
    let i = this.info = document.createElement("div");
    if (i.className = "cm-tooltip cm-completionInfo", e.nodeType != null)
      i.appendChild(e), this.infoDestroy = null;
    else {
      let { dom: r, destroy: s } = e;
      i.appendChild(r), this.infoDestroy = s || null;
    }
    this.dom.appendChild(i), this.view.requestMeasure(this.placeInfoReq);
  }
  updateSelectedOption(e) {
    let t = null;
    for (let i = this.list.firstChild, r = this.range.from; i; i = i.nextSibling, r++)
      i.nodeName != "LI" || !i.id ? r-- : r == e ? i.hasAttribute("aria-selected") || (i.setAttribute("aria-selected", "true"), t = i) : i.hasAttribute("aria-selected") && i.removeAttribute("aria-selected");
    return t && Wx(this.list, t), t;
  }
  measureInfo() {
    let e = this.dom.querySelector("[aria-selected]");
    if (!e || !this.info)
      return null;
    let t = this.dom.getBoundingClientRect(), i = this.info.getBoundingClientRect(), r = e.getBoundingClientRect(), s = this.space;
    if (!s) {
      let o = this.dom.ownerDocument.defaultView || window;
      s = { left: 0, top: 0, right: o.innerWidth, bottom: o.innerHeight };
    }
    return r.top > Math.min(s.bottom, t.bottom) - 10 || r.bottom < Math.max(s.top, t.top) + 10 ? null : this.view.state.facet(Be).positionInfo(this.view, t, r, i, s, this.dom);
  }
  placeInfo(e) {
    this.info && (e ? (e.style && (this.info.style.cssText = e.style), this.info.className = "cm-tooltip cm-completionInfo " + (e.class || "")) : this.info.style.cssText = "top: -1e6px");
  }
  createListBox(e, t, i) {
    const r = document.createElement("ul");
    r.id = t, r.setAttribute("role", "listbox"), r.setAttribute("aria-expanded", "true"), r.setAttribute("aria-label", this.view.state.phrase("Completions"));
    let s = null;
    for (let o = i.from; o < i.to; o++) {
      let { completion: l, match: a } = e[o], { section: u } = l;
      if (u) {
        let f = typeof u == "string" ? u : u.name;
        if (f != s && (o > i.from || i.from == 0))
          if (s = f, typeof u != "string" && u.header)
            r.appendChild(u.header(u));
          else {
            let d = r.appendChild(document.createElement("completion-section"));
            d.textContent = f;
          }
      }
      const c = r.appendChild(document.createElement("li"));
      c.id = t + "-" + o, c.setAttribute("role", "option");
      let h = this.optionClass(l);
      h && (c.className = h);
      for (let f of this.optionContent) {
        let d = f(l, this.view.state, this.view, a);
        d && c.appendChild(d);
      }
    }
    return i.from && r.classList.add("cm-completionListIncompleteTop"), i.to < e.length && r.classList.add("cm-completionListIncompleteBottom"), r;
  }
  destroyInfo() {
    this.info && (this.infoDestroy && this.infoDestroy(), this.info.remove(), this.info = null);
  }
  destroy() {
    this.destroyInfo();
  }
}
function jx(n, e) {
  return (t) => new $x(t, n, e);
}
function Wx(n, e) {
  let t = n.getBoundingClientRect(), i = e.getBoundingClientRect(), r = t.height / n.offsetHeight;
  i.top < t.top ? n.scrollTop -= (t.top - i.top) / r : i.bottom > t.bottom && (n.scrollTop += (i.bottom - t.bottom) / r);
}
function kc(n) {
  return (n.boost || 0) * 100 + (n.apply ? 10 : 0) + (n.info ? 5 : 0) + (n.type ? 1 : 0);
}
function qx(n, e) {
  let t = [], i = null, r = (u) => {
    t.push(u);
    let { section: c } = u.completion;
    if (c) {
      i || (i = []);
      let h = typeof c == "string" ? c : c.name;
      i.some((f) => f.name == h) || i.push(typeof c == "string" ? { name: h } : c);
    }
  }, s = e.facet(Be);
  for (let u of n)
    if (u.hasResult()) {
      let c = u.result.getMatch;
      if (u.result.filter === !1)
        for (let h of u.result.options)
          r(new bc(h, u.source, c ? c(h) : [], 1e9 - t.length));
      else {
        let h = e.sliceDoc(u.from, u.to), f, d = s.filterStrict ? new Hx(h) : new zx(h);
        for (let p of u.result.options)
          if (f = d.match(p.label)) {
            let g = p.displayLabel ? c ? c(p, f.matched) : [] : f.matched;
            r(new bc(p, u.source, g, f.score + (p.boost || 0)));
          }
      }
    }
  if (i) {
    let u = /* @__PURE__ */ Object.create(null), c = 0, h = (f, d) => {
      var p, g;
      return ((p = f.rank) !== null && p !== void 0 ? p : 1e9) - ((g = d.rank) !== null && g !== void 0 ? g : 1e9) || (f.name < d.name ? -1 : 1);
    };
    for (let f of i.sort(h))
      c -= 1e5, u[f.name] = c;
    for (let f of t) {
      let { section: d } = f.completion;
      d && (f.score += u[typeof d == "string" ? d : d.name]);
    }
  }
  let o = [], l = null, a = s.compareCompletions;
  for (let u of t.sort((c, h) => h.score - c.score || a(c.completion, h.completion))) {
    let c = u.completion;
    !l || l.label != c.label || l.detail != c.detail || l.type != null && c.type != null && l.type != c.type || l.apply != c.apply || l.boost != c.boost ? o.push(u) : kc(u.completion) > kc(l) && (o[o.length - 1] = u), l = u.completion;
  }
  return o;
}
class Xn {
  constructor(e, t, i, r, s, o) {
    this.options = e, this.attrs = t, this.tooltip = i, this.timestamp = r, this.selected = s, this.disabled = o;
  }
  setSelected(e, t) {
    return e == this.selected || e >= this.options.length ? this : new Xn(this.options, vc(t, e), this.tooltip, this.timestamp, e, this.disabled);
  }
  static build(e, t, i, r, s) {
    let o = qx(e, t);
    if (!o.length)
      return r && e.some(
        (a) => a.state == 1
        /* State.Pending */
      ) ? new Xn(r.options, r.attrs, r.tooltip, r.timestamp, r.selected, !0) : null;
    let l = t.facet(Be).selectOnOpen ? 0 : -1;
    if (r && r.selected != l && r.selected != -1) {
      let a = r.options[r.selected].completion;
      for (let u = 0; u < o.length; u++)
        if (o[u].completion == a) {
          l = u;
          break;
        }
    }
    return new Xn(o, vc(i, l), {
      pos: e.reduce((a, u) => u.hasResult() ? Math.min(a, u.from) : a, 1e8),
      create: Xx,
      above: s.aboveCursor
    }, r ? r.timestamp : Date.now(), l, !1);
  }
  map(e) {
    return new Xn(this.options, this.attrs, Object.assign(Object.assign({}, this.tooltip), { pos: e.mapPos(this.tooltip.pos) }), this.timestamp, this.selected, this.disabled);
  }
}
class Cs {
  constructor(e, t, i) {
    this.active = e, this.id = t, this.open = i;
  }
  static start() {
    return new Cs(Gx, "cm-ac-" + Math.floor(Math.random() * 2e6).toString(36), null);
  }
  update(e) {
    let { state: t } = e, i = t.facet(Be), s = (i.override || t.languageDataAt("autocomplete", fn(t)).map(Fx)).map((l) => (this.active.find((u) => u.source == l) || new je(
      l,
      this.active.some(
        (u) => u.state != 0
        /* State.Inactive */
      ) ? 1 : 0
      /* State.Inactive */
    )).update(e, i));
    s.length == this.active.length && s.every((l, a) => l == this.active[a]) && (s = this.active);
    let o = this.open;
    o && e.docChanged && (o = o.map(e.changes)), e.selection || s.some((l) => l.hasResult() && e.changes.touchesRange(l.from, l.to)) || !Ux(s, this.active) ? o = Xn.build(s, t, this.id, o, i) : o && o.disabled && !s.some(
      (l) => l.state == 1
      /* State.Pending */
    ) && (o = null), !o && s.every(
      (l) => l.state != 1
      /* State.Pending */
    ) && s.some((l) => l.hasResult()) && (s = s.map((l) => l.hasResult() ? new je(
      l.source,
      0
      /* State.Inactive */
    ) : l));
    for (let l of e.effects)
      l.is(lp) && (o = o && o.setSelected(l.value, this.id));
    return s == this.active && o == this.open ? this : new Cs(s, this.id, o);
  }
  get tooltip() {
    return this.open ? this.open.tooltip : null;
  }
  get attrs() {
    return this.open ? this.open.attrs : Kx;
  }
}
function Ux(n, e) {
  if (n == e)
    return !0;
  for (let t = 0, i = 0; ; ) {
    for (; t < n.length && !n[t].hasResult; )
      t++;
    for (; i < e.length && !e[i].hasResult; )
      i++;
    let r = t == n.length, s = i == e.length;
    if (r || s)
      return r == s;
    if (n[t++].result != e[i++].result)
      return !1;
  }
}
const Kx = {
  "aria-autocomplete": "list"
};
function vc(n, e) {
  let t = {
    "aria-autocomplete": "list",
    "aria-haspopup": "listbox",
    "aria-controls": n
  };
  return e > -1 && (t["aria-activedescendant"] = n + "-" + e), t;
}
const Gx = [];
function zl(n, e) {
  if (n.isUserEvent("input.complete")) {
    let t = n.annotation(sp);
    if (t && e.activateOnCompletion(t))
      return "input";
  }
  return n.isUserEvent("input.type") ? "input" : n.isUserEvent("delete.backward") ? "delete" : null;
}
class je {
  constructor(e, t, i = -1) {
    this.source = e, this.state = t, this.explicitPos = i;
  }
  hasResult() {
    return !1;
  }
  update(e, t) {
    let i = zl(e, t), r = this;
    i ? r = r.handleUserEvent(e, i, t) : e.docChanged ? r = r.handleChange(e) : e.selection && r.state != 0 && (r = new je(
      r.source,
      0
      /* State.Inactive */
    ));
    for (let s of e.effects)
      if (s.is(Ss))
        r = new je(r.source, 1, s.value ? fn(e.state) : -1);
      else if (s.is(tr))
        r = new je(
          r.source,
          0
          /* State.Inactive */
        );
      else if (s.is(op))
        for (let o of s.value)
          o.source == r.source && (r = o);
    return r;
  }
  handleUserEvent(e, t, i) {
    return t == "delete" || !i.activateOnTyping ? this.map(e.changes) : new je(
      this.source,
      1
      /* State.Pending */
    );
  }
  handleChange(e) {
    return e.changes.touchesRange(fn(e.startState)) ? new je(
      this.source,
      0
      /* State.Inactive */
    ) : this.map(e.changes);
  }
  map(e) {
    return e.empty || this.explicitPos < 0 ? this : new je(this.source, this.state, e.mapPos(this.explicitPos));
  }
}
class ni extends je {
  constructor(e, t, i, r, s) {
    super(e, 2, t), this.result = i, this.from = r, this.to = s;
  }
  hasResult() {
    return !0;
  }
  handleUserEvent(e, t, i) {
    var r;
    let s = this.result;
    s.map && !e.changes.empty && (s = s.map(s, e.changes));
    let o = e.changes.mapPos(this.from), l = e.changes.mapPos(this.to, 1), a = fn(e.state);
    if ((this.explicitPos < 0 ? a <= o : a < this.from) || a > l || !s || t == "delete" && fn(e.startState) == this.from)
      return new je(
        this.source,
        t == "input" && i.activateOnTyping ? 1 : 0
        /* State.Inactive */
      );
    let u = this.explicitPos < 0 ? -1 : e.changes.mapPos(this.explicitPos);
    return Yx(s.validFor, e.state, o, l) ? new ni(this.source, u, s, o, l) : s.update && (s = s.update(s, o, l, new ip(e.state, a, u >= 0))) ? new ni(this.source, u, s, s.from, (r = s.to) !== null && r !== void 0 ? r : fn(e.state)) : new je(this.source, 1, u);
  }
  handleChange(e) {
    return e.changes.touchesRange(this.from, this.to) ? new je(
      this.source,
      0
      /* State.Inactive */
    ) : this.map(e.changes);
  }
  map(e) {
    return e.empty ? this : (this.result.map ? this.result.map(this.result, e) : this.result) ? new ni(this.source, this.explicitPos < 0 ? -1 : e.mapPos(this.explicitPos), this.result, e.mapPos(this.from), e.mapPos(this.to, 1)) : new je(
      this.source,
      0
      /* State.Inactive */
    );
  }
}
function Yx(n, e, t, i) {
  if (!n)
    return !1;
  let r = e.sliceDoc(t, i);
  return typeof n == "function" ? n(r, t, i, e) : rp(n, !0).test(r);
}
const op = /* @__PURE__ */ X.define({
  map(n, e) {
    return n.map((t) => t.map(e));
  }
}), lp = /* @__PURE__ */ X.define(), Xe = /* @__PURE__ */ Ne.define({
  create() {
    return Cs.start();
  },
  update(n, e) {
    return n.update(e);
  },
  provide: (n) => [
    ua.from(n, (e) => e.tooltip),
    V.contentAttributes.from(n, (e) => e.attrs)
  ]
});
function va(n, e) {
  const t = e.completion.apply || e.completion.label;
  let i = n.state.field(Xe).active.find((r) => r.source == e.source);
  return i instanceof ni ? (typeof t == "string" ? n.dispatch(Object.assign(Object.assign({}, Nx(n.state, t, i.from, i.to)), { annotations: sp.of(e.completion) })) : t(n, e.completion, i.from, i.to), !0) : !1;
}
const Xx = /* @__PURE__ */ jx(Xe, va);
function Br(n, e = "option") {
  return (t) => {
    let i = t.state.field(Xe, !1);
    if (!i || !i.open || i.open.disabled || Date.now() - i.open.timestamp < t.state.facet(Be).interactionDelay)
      return !1;
    let r = 1, s;
    e == "page" && (s = Kf(t, i.open.tooltip)) && (r = Math.max(2, Math.floor(s.dom.offsetHeight / s.dom.querySelector("li").offsetHeight) - 1));
    let { length: o } = i.open.options, l = i.open.selected > -1 ? i.open.selected + r * (n ? 1 : -1) : n ? 0 : o - 1;
    return l < 0 ? l = e == "page" ? 0 : o - 1 : l >= o && (l = e == "page" ? o - 1 : 0), t.dispatch({ effects: lp.of(l) }), !0;
  };
}
const Jx = (n) => {
  let e = n.state.field(Xe, !1);
  return n.state.readOnly || !e || !e.open || e.open.selected < 0 || e.open.disabled || Date.now() - e.open.timestamp < n.state.facet(Be).interactionDelay ? !1 : va(n, e.open.options[e.open.selected]);
}, Qx = (n) => n.state.field(Xe, !1) ? (n.dispatch({ effects: Ss.of(!0) }), !0) : !1, Zx = (n) => {
  let e = n.state.field(Xe, !1);
  return !e || !e.active.some(
    (t) => t.state != 0
    /* State.Inactive */
  ) ? !1 : (n.dispatch({ effects: tr.of(null) }), !0);
};
class ew {
  constructor(e, t) {
    this.active = e, this.context = t, this.time = Date.now(), this.updates = [], this.done = void 0;
  }
}
const tw = 50, nw = 1e3, iw = /* @__PURE__ */ ke.fromClass(class {
  constructor(n) {
    this.view = n, this.debounceUpdate = -1, this.running = [], this.debounceAccept = -1, this.pendingStart = !1, this.composing = 0;
    for (let e of n.state.field(Xe).active)
      e.state == 1 && this.startQuery(e);
  }
  update(n) {
    let e = n.state.field(Xe), t = n.state.facet(Be);
    if (!n.selectionSet && !n.docChanged && n.startState.field(Xe) == e)
      return;
    let i = n.transactions.some((s) => (s.selection || s.docChanged) && !zl(s, t));
    for (let s = 0; s < this.running.length; s++) {
      let o = this.running[s];
      if (i || o.updates.length + n.transactions.length > tw && Date.now() - o.time > nw) {
        for (let l of o.context.abortListeners)
          try {
            l();
          } catch (a) {
            Je(this.view.state, a);
          }
        o.context.abortListeners = null, this.running.splice(s--, 1);
      } else
        o.updates.push(...n.transactions);
    }
    this.debounceUpdate > -1 && clearTimeout(this.debounceUpdate), n.transactions.some((s) => s.effects.some((o) => o.is(Ss))) && (this.pendingStart = !0);
    let r = this.pendingStart ? 50 : t.activateOnTypingDelay;
    if (this.debounceUpdate = e.active.some((s) => s.state == 1 && !this.running.some((o) => o.active.source == s.source)) ? setTimeout(() => this.startUpdate(), r) : -1, this.composing != 0)
      for (let s of n.transactions)
        zl(s, t) == "input" ? this.composing = 2 : this.composing == 2 && s.selection && (this.composing = 3);
  }
  startUpdate() {
    this.debounceUpdate = -1, this.pendingStart = !1;
    let { state: n } = this.view, e = n.field(Xe);
    for (let t of e.active)
      t.state == 1 && !this.running.some((i) => i.active.source == t.source) && this.startQuery(t);
  }
  startQuery(n) {
    let { state: e } = this.view, t = fn(e), i = new ip(e, t, n.explicitPos == t), r = new ew(n, i);
    this.running.push(r), Promise.resolve(n.source(i)).then((s) => {
      r.context.aborted || (r.done = s || null, this.scheduleAccept());
    }, (s) => {
      this.view.dispatch({ effects: tr.of(null) }), Je(this.view.state, s);
    });
  }
  scheduleAccept() {
    this.running.every((n) => n.done !== void 0) ? this.accept() : this.debounceAccept < 0 && (this.debounceAccept = setTimeout(() => this.accept(), this.view.state.facet(Be).updateSyncTime));
  }
  // For each finished query in this.running, try to create a result
  // or, if appropriate, restart the query.
  accept() {
    var n;
    this.debounceAccept > -1 && clearTimeout(this.debounceAccept), this.debounceAccept = -1;
    let e = [], t = this.view.state.facet(Be);
    for (let i = 0; i < this.running.length; i++) {
      let r = this.running[i];
      if (r.done === void 0)
        continue;
      if (this.running.splice(i--, 1), r.done) {
        let o = new ni(r.active.source, r.active.explicitPos, r.done, r.done.from, (n = r.done.to) !== null && n !== void 0 ? n : fn(r.updates.length ? r.updates[0].startState : this.view.state));
        for (let l of r.updates)
          o = o.update(l, t);
        if (o.hasResult()) {
          e.push(o);
          continue;
        }
      }
      let s = this.view.state.field(Xe).active.find((o) => o.source == r.active.source);
      if (s && s.state == 1)
        if (r.done == null) {
          let o = new je(
            r.active.source,
            0
            /* State.Inactive */
          );
          for (let l of r.updates)
            o = o.update(l, t);
          o.state != 1 && e.push(o);
        } else
          this.startQuery(s);
    }
    e.length && this.view.dispatch({ effects: op.of(e) });
  }
}, {
  eventHandlers: {
    blur(n) {
      let e = this.view.state.field(Xe, !1);
      if (e && e.tooltip && this.view.state.facet(Be).closeOnBlur) {
        let t = e.open && Kf(this.view, e.open.tooltip);
        (!t || !t.dom.contains(n.relatedTarget)) && setTimeout(() => this.view.dispatch({ effects: tr.of(null) }), 10);
      }
    },
    compositionstart() {
      this.composing = 1;
    },
    compositionend() {
      this.composing == 3 && setTimeout(() => this.view.dispatch({ effects: Ss.of(!1) }), 20), this.composing = 0;
    }
  }
}), rw = typeof navigator == "object" && /* @__PURE__ */ /Win/.test(navigator.platform), sw = /* @__PURE__ */ Hn.highest(/* @__PURE__ */ V.domEventHandlers({
  keydown(n, e) {
    let t = e.state.field(Xe, !1);
    if (!t || !t.open || t.open.disabled || t.open.selected < 0 || n.key.length > 1 || n.ctrlKey && !(rw && n.altKey) || n.metaKey)
      return !1;
    let i = t.open.options[t.open.selected], r = t.active.find((o) => o.source == i.source), s = i.completion.commitCharacters || r.result.commitCharacters;
    return s && s.indexOf(n.key) > -1 && va(e, i), !1;
  }
})), ow = /* @__PURE__ */ V.baseTheme({
  ".cm-tooltip.cm-tooltip-autocomplete": {
    "& > ul": {
      fontFamily: "monospace",
      whiteSpace: "nowrap",
      overflow: "hidden auto",
      maxWidth_fallback: "700px",
      maxWidth: "min(700px, 95vw)",
      minWidth: "250px",
      maxHeight: "10em",
      height: "100%",
      listStyle: "none",
      margin: 0,
      padding: 0,
      "& > li, & > completion-section": {
        padding: "1px 3px",
        lineHeight: 1.2
      },
      "& > li": {
        overflowX: "hidden",
        textOverflow: "ellipsis",
        cursor: "pointer"
      },
      "& > completion-section": {
        display: "list-item",
        borderBottom: "1px solid silver",
        paddingLeft: "0.5em",
        opacity: 0.7
      }
    }
  },
  "&light .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#17c",
    color: "white"
  },
  "&light .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#777"
  },
  "&dark .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#347",
    color: "white"
  },
  "&dark .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#444"
  },
  ".cm-completionListIncompleteTop:before, .cm-completionListIncompleteBottom:after": {
    content: '"···"',
    opacity: 0.5,
    display: "block",
    textAlign: "center"
  },
  ".cm-tooltip.cm-completionInfo": {
    position: "absolute",
    padding: "3px 9px",
    width: "max-content",
    maxWidth: "400px",
    boxSizing: "border-box"
  },
  ".cm-completionInfo.cm-completionInfo-left": { right: "100%" },
  ".cm-completionInfo.cm-completionInfo-right": { left: "100%" },
  ".cm-completionInfo.cm-completionInfo-left-narrow": { right: "30px" },
  ".cm-completionInfo.cm-completionInfo-right-narrow": { left: "30px" },
  "&light .cm-snippetField": { backgroundColor: "#00000022" },
  "&dark .cm-snippetField": { backgroundColor: "#ffffff22" },
  ".cm-snippetFieldPosition": {
    verticalAlign: "text-top",
    width: 0,
    height: "1.15em",
    display: "inline-block",
    margin: "0 -0.7px -.7em",
    borderLeft: "1.4px dotted #888"
  },
  ".cm-completionMatchedText": {
    textDecoration: "underline"
  },
  ".cm-completionDetail": {
    marginLeft: "0.5em",
    fontStyle: "italic"
  },
  ".cm-completionIcon": {
    fontSize: "90%",
    width: ".8em",
    display: "inline-block",
    textAlign: "center",
    paddingRight: ".6em",
    opacity: "0.6",
    boxSizing: "content-box"
  },
  ".cm-completionIcon-function, .cm-completionIcon-method": {
    "&:after": { content: "'ƒ'" }
  },
  ".cm-completionIcon-class": {
    "&:after": { content: "'○'" }
  },
  ".cm-completionIcon-interface": {
    "&:after": { content: "'◌'" }
  },
  ".cm-completionIcon-variable": {
    "&:after": { content: "'𝑥'" }
  },
  ".cm-completionIcon-constant": {
    "&:after": { content: "'𝐶'" }
  },
  ".cm-completionIcon-type": {
    "&:after": { content: "'𝑡'" }
  },
  ".cm-completionIcon-enum": {
    "&:after": { content: "'∪'" }
  },
  ".cm-completionIcon-property": {
    "&:after": { content: "'□'" }
  },
  ".cm-completionIcon-keyword": {
    "&:after": { content: "'🔑︎'" }
    // Disable emoji rendering
  },
  ".cm-completionIcon-namespace": {
    "&:after": { content: "'▢'" }
  },
  ".cm-completionIcon-text": {
    "&:after": { content: "'abc'", fontSize: "50%", verticalAlign: "middle" }
  }
}), nr = {
  brackets: ["(", "[", "{", "'", '"'],
  before: ")]}:;>",
  stringPrefixes: []
}, En = /* @__PURE__ */ X.define({
  map(n, e) {
    let t = e.mapPos(n, -1, qe.TrackAfter);
    return t ?? void 0;
  }
}), Sa = /* @__PURE__ */ new class extends Pn {
}();
Sa.startSide = 1;
Sa.endSide = -1;
const ap = /* @__PURE__ */ Ne.define({
  create() {
    return ie.empty;
  },
  update(n, e) {
    if (n = n.map(e.changes), e.selection) {
      let t = e.state.doc.lineAt(e.selection.main.head);
      n = n.update({ filter: (i) => i >= t.from && i <= t.to });
    }
    for (let t of e.effects)
      t.is(En) && (n = n.update({ add: [Sa.range(t.value, t.value + 1)] }));
    return n;
  }
});
function lw() {
  return [uw, ap];
}
const Ao = "()[]{}<>";
function up(n) {
  for (let e = 0; e < Ao.length; e += 2)
    if (Ao.charCodeAt(e) == n)
      return Ao.charAt(e + 1);
  return Ql(n < 128 ? n : n + 1);
}
function cp(n, e) {
  return n.languageDataAt("closeBrackets", e)[0] || nr;
}
const aw = typeof navigator == "object" && /* @__PURE__ */ /Android\b/.test(navigator.userAgent), uw = /* @__PURE__ */ V.inputHandler.of((n, e, t, i) => {
  if ((aw ? n.composing : n.compositionStarted) || n.state.readOnly)
    return !1;
  let r = n.state.selection.main;
  if (i.length > 2 || i.length == 2 && ht(Le(i, 0)) == 1 || e != r.from || t != r.to)
    return !1;
  let s = fw(n.state, i);
  return s ? (n.dispatch(s), !0) : !1;
}), cw = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let i = cp(n, n.selection.main.head).brackets || nr.brackets, r = null, s = n.changeByRange((o) => {
    if (o.empty) {
      let l = dw(n.doc, o.head);
      for (let a of i)
        if (a == l && Us(n.doc, o.head) == up(Le(a, 0)))
          return {
            changes: { from: o.head - a.length, to: o.head + a.length },
            range: T.cursor(o.head - a.length)
          };
    }
    return { range: r = o };
  });
  return r || e(n.update(s, { scrollIntoView: !0, userEvent: "delete.backward" })), !r;
}, hw = [
  { key: "Backspace", run: cw }
];
function fw(n, e) {
  let t = cp(n, n.selection.main.head), i = t.brackets || nr.brackets;
  for (let r of i) {
    let s = up(Le(r, 0));
    if (e == r)
      return s == r ? gw(n, r, i.indexOf(r + r + r) > -1, t) : pw(n, r, s, t.before || nr.before);
    if (e == s && hp(n, n.selection.main.from))
      return mw(n, r, s);
  }
  return null;
}
function hp(n, e) {
  let t = !1;
  return n.field(ap).between(0, n.doc.length, (i) => {
    i == e && (t = !0);
  }), t;
}
function Us(n, e) {
  let t = n.sliceString(e, e + 2);
  return t.slice(0, ht(Le(t, 0)));
}
function dw(n, e) {
  let t = n.sliceString(e - 2, e);
  return ht(Le(t, 0)) == t.length ? t : t.slice(1);
}
function pw(n, e, t, i) {
  let r = null, s = n.changeByRange((o) => {
    if (!o.empty)
      return {
        changes: [{ insert: e, from: o.from }, { insert: t, from: o.to }],
        effects: En.of(o.to + e.length),
        range: T.range(o.anchor + e.length, o.head + e.length)
      };
    let l = Us(n.doc, o.head);
    return !l || /\s/.test(l) || i.indexOf(l) > -1 ? {
      changes: { insert: e + t, from: o.head },
      effects: En.of(o.head + e.length),
      range: T.cursor(o.head + e.length)
    } : { range: r = o };
  });
  return r ? null : n.update(s, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function mw(n, e, t) {
  let i = null, r = n.changeByRange((s) => s.empty && Us(n.doc, s.head) == t ? {
    changes: { from: s.head, to: s.head + t.length, insert: t },
    range: T.cursor(s.head + t.length)
  } : i = { range: s });
  return i ? null : n.update(r, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function gw(n, e, t, i) {
  let r = i.stringPrefixes || nr.stringPrefixes, s = null, o = n.changeByRange((l) => {
    if (!l.empty)
      return {
        changes: [{ insert: e, from: l.from }, { insert: e, from: l.to }],
        effects: En.of(l.to + e.length),
        range: T.range(l.anchor + e.length, l.head + e.length)
      };
    let a = l.head, u = Us(n.doc, a), c;
    if (u == e) {
      if (Sc(n, a))
        return {
          changes: { insert: e + e, from: a },
          effects: En.of(a + e.length),
          range: T.cursor(a + e.length)
        };
      if (hp(n, a)) {
        let f = t && n.sliceDoc(a, a + e.length * 3) == e + e + e ? e + e + e : e;
        return {
          changes: { from: a, to: a + f.length, insert: f },
          range: T.cursor(a + f.length)
        };
      }
    } else {
      if (t && n.sliceDoc(a - 2 * e.length, a) == e + e && (c = Cc(n, a - 2 * e.length, r)) > -1 && Sc(n, c))
        return {
          changes: { insert: e + e + e + e, from: a },
          effects: En.of(a + e.length),
          range: T.cursor(a + e.length)
        };
      if (n.charCategorizer(a)(u) != be.Word && Cc(n, a, r) > -1 && !yw(n, a, e, r))
        return {
          changes: { insert: e + e, from: a },
          effects: En.of(a + e.length),
          range: T.cursor(a + e.length)
        };
    }
    return { range: s = l };
  });
  return s ? null : n.update(o, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function Sc(n, e) {
  let t = _e(n).resolveInner(e + 1);
  return t.parent && t.from == e;
}
function yw(n, e, t, i) {
  let r = _e(n).resolveInner(e, -1), s = i.reduce((o, l) => Math.max(o, l.length), 0);
  for (let o = 0; o < 5; o++) {
    let l = n.sliceDoc(r.from, Math.min(r.to, r.from + t.length + s)), a = l.indexOf(t);
    if (!a || a > -1 && i.indexOf(l.slice(0, a)) > -1) {
      let c = r.firstChild;
      for (; c && c.from == r.from && c.to - c.from > t.length + a; ) {
        if (n.sliceDoc(c.to - t.length, c.to) == t)
          return !1;
        c = c.firstChild;
      }
      return !0;
    }
    let u = r.to == e && r.parent;
    if (!u)
      break;
    r = u;
  }
  return !1;
}
function Cc(n, e, t) {
  let i = n.charCategorizer(e);
  if (i(n.sliceDoc(e - 1, e)) != be.Word)
    return e;
  for (let r of t) {
    let s = e - r.length;
    if (n.sliceDoc(s, e) == r && i(n.sliceDoc(s - 1, s)) != be.Word)
      return s;
  }
  return -1;
}
function bw(n = {}) {
  return [
    sw,
    Xe,
    Be.of(n),
    iw,
    xw,
    ow
  ];
}
const fp = [
  { key: "Ctrl-Space", run: Qx },
  { key: "Escape", run: Zx },
  { key: "ArrowDown", run: /* @__PURE__ */ Br(!0) },
  { key: "ArrowUp", run: /* @__PURE__ */ Br(!1) },
  { key: "PageDown", run: /* @__PURE__ */ Br(!0, "page") },
  { key: "PageUp", run: /* @__PURE__ */ Br(!1, "page") },
  { key: "Enter", run: Jx }
], xw = /* @__PURE__ */ Hn.highest(/* @__PURE__ */ Ns.computeN([Be], (n) => n.facet(Be).defaultKeymap ? [fp] : []));
class ww {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.diagnostic = i;
  }
}
class Tn {
  constructor(e, t, i) {
    this.diagnostics = e, this.panel = t, this.selected = i;
  }
  static init(e, t, i) {
    let r = e, s = i.facet(Aa).markerFilter;
    s && (r = s(r, i));
    let o = q.set(r.map((l) => l.from == l.to || l.from == l.to - 1 && i.doc.lineAt(l.from).to == l.from ? q.widget({
      widget: new Dw(l),
      diagnostic: l
    }).range(l.from) : q.mark({
      attributes: { class: "cm-lintRange cm-lintRange-" + l.severity + (l.markClass ? " " + l.markClass : "") },
      diagnostic: l,
      inclusive: !0
    }).range(l.from, l.to)), !0);
    return new Tn(o, t, hi(o));
  }
}
function hi(n, e = null, t = 0) {
  let i = null;
  return n.between(t, 1e9, (r, s, { spec: o }) => {
    if (!(e && o.diagnostic != e))
      return i = new ww(r, s, o.diagnostic), !1;
  }), i;
}
function kw(n, e) {
  let t = e.pos, i = e.end || t, r = n.state.facet(Aa).hideOn(n, t, i);
  if (r != null)
    return r;
  let s = n.startState.doc.lineAt(e.pos);
  return !!(n.effects.some((o) => o.is(dp)) || n.changes.touchesRange(s.from, Math.max(s.to, i)));
}
function vw(n, e) {
  return n.field(st, !1) ? e : e.concat(X.appendConfig.of(Iw));
}
const dp = /* @__PURE__ */ X.define(), Ca = /* @__PURE__ */ X.define(), pp = /* @__PURE__ */ X.define(), st = /* @__PURE__ */ Ne.define({
  create() {
    return new Tn(q.none, null, null);
  },
  update(n, e) {
    if (e.docChanged) {
      let t = n.diagnostics.map(e.changes), i = null;
      if (n.selected) {
        let r = e.changes.mapPos(n.selected.from, 1);
        i = hi(t, n.selected.diagnostic, r) || hi(t, null, r);
      }
      n = new Tn(t, n.panel, i);
    }
    for (let t of e.effects)
      t.is(dp) ? n = Tn.init(t.value, n.panel, e.state) : t.is(Ca) ? n = new Tn(n.diagnostics, t.value ? Ks.open : null, n.selected) : t.is(pp) && (n = new Tn(n.diagnostics, n.panel, t.value));
    return n;
  },
  provide: (n) => [
    Ji.from(n, (e) => e.panel),
    V.decorations.from(n, (e) => e.diagnostics)
  ]
}), Sw = /* @__PURE__ */ q.mark({ class: "cm-lintRange cm-lintRange-active", inclusive: !0 });
function Cw(n, e, t) {
  let { diagnostics: i } = n.state.field(st), r = [], s = 2e8, o = 0;
  i.between(e - (t < 0 ? 1 : 0), e + (t > 0 ? 1 : 0), (a, u, { spec: c }) => {
    e >= a && e <= u && (a == u || (e > a || t > 0) && (e < u || t < 0)) && (r.push(c.diagnostic), s = Math.min(a, s), o = Math.max(u, o));
  });
  let l = n.state.facet(Aa).tooltipFilter;
  return l && (r = l(r, n.state)), r.length ? {
    pos: s,
    end: o,
    above: n.state.doc.lineAt(s).to < o,
    create() {
      return { dom: Aw(n, r) };
    }
  } : null;
}
function Aw(n, e) {
  return pe("ul", { class: "cm-tooltip-lint" }, e.map((t) => gp(n, t, !1)));
}
const Mw = (n) => {
  let e = n.state.field(st, !1);
  (!e || !e.panel) && n.dispatch({ effects: vw(n.state, [Ca.of(!0)]) });
  let t = Xi(n, Ks.open);
  return t && t.dom.querySelector(".cm-panel-lint ul").focus(), !0;
}, Ac = (n) => {
  let e = n.state.field(st, !1);
  return !e || !e.panel ? !1 : (n.dispatch({ effects: Ca.of(!1) }), !0);
}, Tw = (n) => {
  let e = n.state.field(st, !1);
  if (!e)
    return !1;
  let t = n.state.selection.main, i = e.diagnostics.iter(t.to + 1);
  return !i.value && (i = e.diagnostics.iter(0), !i.value || i.from == t.from && i.to == t.to) ? !1 : (n.dispatch({ selection: { anchor: i.from, head: i.to }, scrollIntoView: !0 }), !0);
}, Ow = [
  { key: "Mod-Shift-m", run: Mw, preventDefault: !0 },
  { key: "F8", run: Tw }
], Aa = /* @__PURE__ */ j.define({
  combine(n) {
    return Object.assign({ sources: n.map((e) => e.source).filter((e) => e != null) }, Vt(n.map((e) => e.config), {
      delay: 750,
      markerFilter: null,
      tooltipFilter: null,
      needsRefresh: null,
      hideOn: () => null
    }, {
      needsRefresh: (e, t) => e ? t ? (i) => e(i) || t(i) : e : t
    }));
  }
});
function mp(n) {
  let e = [];
  if (n)
    e:
      for (let { name: t } of n) {
        for (let i = 0; i < t.length; i++) {
          let r = t[i];
          if (/[a-zA-Z]/.test(r) && !e.some((s) => s.toLowerCase() == r.toLowerCase())) {
            e.push(r);
            continue e;
          }
        }
        e.push("");
      }
  return e;
}
function gp(n, e, t) {
  var i;
  let r = t ? mp(e.actions) : [];
  return pe("li", { class: "cm-diagnostic cm-diagnostic-" + e.severity }, pe("span", { class: "cm-diagnosticText" }, e.renderMessage ? e.renderMessage(n) : e.message), (i = e.actions) === null || i === void 0 ? void 0 : i.map((s, o) => {
    let l = !1, a = (f) => {
      if (f.preventDefault(), l)
        return;
      l = !0;
      let d = hi(n.state.field(st).diagnostics, e);
      d && s.apply(n, d.from, d.to);
    }, { name: u } = s, c = r[o] ? u.indexOf(r[o]) : -1, h = c < 0 ? u : [
      u.slice(0, c),
      pe("u", u.slice(c, c + 1)),
      u.slice(c + 1)
    ];
    return pe("button", {
      type: "button",
      class: "cm-diagnosticAction",
      onclick: a,
      onmousedown: a,
      "aria-label": ` Action: ${u}${c < 0 ? "" : ` (access key "${r[o]})"`}.`
    }, h);
  }), e.source && pe("div", { class: "cm-diagnosticSource" }, e.source));
}
class Dw extends Jt {
  constructor(e) {
    super(), this.diagnostic = e;
  }
  eq(e) {
    return e.diagnostic == this.diagnostic;
  }
  toDOM() {
    return pe("span", { class: "cm-lintPoint cm-lintPoint-" + this.diagnostic.severity });
  }
}
class Mc {
  constructor(e, t) {
    this.diagnostic = t, this.id = "item_" + Math.floor(Math.random() * 4294967295).toString(16), this.dom = gp(e, t, !0), this.dom.id = this.id, this.dom.setAttribute("role", "option");
  }
}
class Ks {
  constructor(e) {
    this.view = e, this.items = [];
    let t = (r) => {
      if (r.keyCode == 27)
        Ac(this.view), this.view.focus();
      else if (r.keyCode == 38 || r.keyCode == 33)
        this.moveSelection((this.selectedIndex - 1 + this.items.length) % this.items.length);
      else if (r.keyCode == 40 || r.keyCode == 34)
        this.moveSelection((this.selectedIndex + 1) % this.items.length);
      else if (r.keyCode == 36)
        this.moveSelection(0);
      else if (r.keyCode == 35)
        this.moveSelection(this.items.length - 1);
      else if (r.keyCode == 13)
        this.view.focus();
      else if (r.keyCode >= 65 && r.keyCode <= 90 && this.selectedIndex >= 0) {
        let { diagnostic: s } = this.items[this.selectedIndex], o = mp(s.actions);
        for (let l = 0; l < o.length; l++)
          if (o[l].toUpperCase().charCodeAt(0) == r.keyCode) {
            let a = hi(this.view.state.field(st).diagnostics, s);
            a && s.actions[l].apply(e, a.from, a.to);
          }
      } else
        return;
      r.preventDefault();
    }, i = (r) => {
      for (let s = 0; s < this.items.length; s++)
        this.items[s].dom.contains(r.target) && this.moveSelection(s);
    };
    this.list = pe("ul", {
      tabIndex: 0,
      role: "listbox",
      "aria-label": this.view.state.phrase("Diagnostics"),
      onkeydown: t,
      onclick: i
    }), this.dom = pe("div", { class: "cm-panel-lint" }, this.list, pe("button", {
      type: "button",
      name: "close",
      "aria-label": this.view.state.phrase("close"),
      onclick: () => Ac(this.view)
    }, "×")), this.update();
  }
  get selectedIndex() {
    let e = this.view.state.field(st).selected;
    if (!e)
      return -1;
    for (let t = 0; t < this.items.length; t++)
      if (this.items[t].diagnostic == e.diagnostic)
        return t;
    return -1;
  }
  update() {
    let { diagnostics: e, selected: t } = this.view.state.field(st), i = 0, r = !1, s = null;
    for (e.between(0, this.view.state.doc.length, (o, l, { spec: a }) => {
      let u = -1, c;
      for (let h = i; h < this.items.length; h++)
        if (this.items[h].diagnostic == a.diagnostic) {
          u = h;
          break;
        }
      u < 0 ? (c = new Mc(this.view, a.diagnostic), this.items.splice(i, 0, c), r = !0) : (c = this.items[u], u > i && (this.items.splice(i, u - i), r = !0)), t && c.diagnostic == t.diagnostic ? c.dom.hasAttribute("aria-selected") || (c.dom.setAttribute("aria-selected", "true"), s = c) : c.dom.hasAttribute("aria-selected") && c.dom.removeAttribute("aria-selected"), i++;
    }); i < this.items.length && !(this.items.length == 1 && this.items[0].diagnostic.from < 0); )
      r = !0, this.items.pop();
    this.items.length == 0 && (this.items.push(new Mc(this.view, {
      from: -1,
      to: -1,
      severity: "info",
      message: this.view.state.phrase("No diagnostics")
    })), r = !0), s ? (this.list.setAttribute("aria-activedescendant", s.id), this.view.requestMeasure({
      key: this,
      read: () => ({ sel: s.dom.getBoundingClientRect(), panel: this.list.getBoundingClientRect() }),
      write: ({ sel: o, panel: l }) => {
        let a = l.height / this.list.offsetHeight;
        o.top < l.top ? this.list.scrollTop -= (l.top - o.top) / a : o.bottom > l.bottom && (this.list.scrollTop += (o.bottom - l.bottom) / a);
      }
    })) : this.selectedIndex < 0 && this.list.removeAttribute("aria-activedescendant"), r && this.sync();
  }
  sync() {
    let e = this.list.firstChild;
    function t() {
      let i = e;
      e = i.nextSibling, i.remove();
    }
    for (let i of this.items)
      if (i.dom.parentNode == this.list) {
        for (; e != i.dom; )
          t();
        e = i.dom.nextSibling;
      } else
        this.list.insertBefore(i.dom, e);
    for (; e; )
      t();
  }
  moveSelection(e) {
    if (this.selectedIndex < 0)
      return;
    let t = this.view.state.field(st), i = hi(t.diagnostics, this.items[e].diagnostic);
    i && this.view.dispatch({
      selection: { anchor: i.from, head: i.to },
      scrollIntoView: !0,
      effects: pp.of(i)
    });
  }
  static open(e) {
    return new Ks(e);
  }
}
function Ew(n, e = 'viewBox="0 0 40 40"') {
  return `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" ${e}>${encodeURIComponent(n)}</svg>')`;
}
function Rr(n) {
  return Ew(`<path d="m0 2.5 l2 -1.5 l1 0 l2 1.5 l1 0" stroke="${n}" fill="none" stroke-width=".7"/>`, 'width="6" height="3"');
}
const Lw = /* @__PURE__ */ V.baseTheme({
  ".cm-diagnostic": {
    padding: "3px 6px 3px 8px",
    marginLeft: "-1px",
    display: "block",
    whiteSpace: "pre-wrap"
  },
  ".cm-diagnostic-error": { borderLeft: "5px solid #d11" },
  ".cm-diagnostic-warning": { borderLeft: "5px solid orange" },
  ".cm-diagnostic-info": { borderLeft: "5px solid #999" },
  ".cm-diagnostic-hint": { borderLeft: "5px solid #66d" },
  ".cm-diagnosticAction": {
    font: "inherit",
    border: "none",
    padding: "2px 4px",
    backgroundColor: "#444",
    color: "white",
    borderRadius: "3px",
    marginLeft: "8px",
    cursor: "pointer"
  },
  ".cm-diagnosticSource": {
    fontSize: "70%",
    opacity: 0.7
  },
  ".cm-lintRange": {
    backgroundPosition: "left bottom",
    backgroundRepeat: "repeat-x",
    paddingBottom: "0.7px"
  },
  ".cm-lintRange-error": { backgroundImage: /* @__PURE__ */ Rr("#d11") },
  ".cm-lintRange-warning": { backgroundImage: /* @__PURE__ */ Rr("orange") },
  ".cm-lintRange-info": { backgroundImage: /* @__PURE__ */ Rr("#999") },
  ".cm-lintRange-hint": { backgroundImage: /* @__PURE__ */ Rr("#66d") },
  ".cm-lintRange-active": { backgroundColor: "#ffdd9980" },
  ".cm-tooltip-lint": {
    padding: 0,
    margin: 0
  },
  ".cm-lintPoint": {
    position: "relative",
    "&:after": {
      content: '""',
      position: "absolute",
      bottom: 0,
      left: "-2px",
      borderLeft: "3px solid transparent",
      borderRight: "3px solid transparent",
      borderBottom: "4px solid #d11"
    }
  },
  ".cm-lintPoint-warning": {
    "&:after": { borderBottomColor: "orange" }
  },
  ".cm-lintPoint-info": {
    "&:after": { borderBottomColor: "#999" }
  },
  ".cm-lintPoint-hint": {
    "&:after": { borderBottomColor: "#66d" }
  },
  ".cm-panel.cm-panel-lint": {
    position: "relative",
    "& ul": {
      maxHeight: "100px",
      overflowY: "auto",
      "& [aria-selected]": {
        backgroundColor: "#ddd",
        "& u": { textDecoration: "underline" }
      },
      "&:focus [aria-selected]": {
        background_fallback: "#bdf",
        backgroundColor: "Highlight",
        color_fallback: "white",
        color: "HighlightText"
      },
      "& u": { textDecoration: "none" },
      padding: 0,
      margin: 0
    },
    "& [name=close]": {
      position: "absolute",
      top: "0",
      right: "2px",
      background: "inherit",
      border: "none",
      font: "inherit",
      padding: 0,
      margin: 0
    }
  }
}), Iw = [
  st,
  /* @__PURE__ */ V.decorations.compute([st], (n) => {
    let { selected: e, panel: t } = n.field(st);
    return !e || !t || e.from == e.to ? q.none : q.set([
      Sw.range(e.from, e.to)
    ]);
  }),
  /* @__PURE__ */ M1(Cw, { hideOn: kw }),
  Lw
], Pw = [
  R1(),
  z1(),
  t1(),
  rb(),
  Ey(),
  W0(),
  Y0(),
  Q.allowMultipleSelections.of(!0),
  gy(),
  Iy(Ry, { fallback: !0 }),
  $y(),
  lw(),
  bw(),
  m1(),
  b1(),
  l1(),
  hx(),
  Ns.of([
    ...hw,
    ...rx,
    ...Ex,
    ...db,
    ...My,
    ...fp,
    ...Ow
  ])
];
/*!
* VueCodemirror v6.1.1
* Copyright (c) Surmon. All rights reserved.
* Released under the MIT License.
* Surmon
*/
var Bw = Object.freeze({ autofocus: !1, disabled: !1, indentWithTab: !0, tabSize: 2, placeholder: "", autoDestroy: !0, extensions: [Pw] }), Rw = Symbol("vue-codemirror-global-config"), We, Nw = function(n) {
  var e = n.onUpdate, t = n.onChange, i = n.onFocus, r = n.onBlur, s = function(o, l) {
    var a = {};
    for (var u in o)
      Object.prototype.hasOwnProperty.call(o, u) && l.indexOf(u) < 0 && (a[u] = o[u]);
    if (o != null && typeof Object.getOwnPropertySymbols == "function") {
      var c = 0;
      for (u = Object.getOwnPropertySymbols(o); c < u.length; c++)
        l.indexOf(u[c]) < 0 && Object.prototype.propertyIsEnumerable.call(o, u[c]) && (a[u[c]] = o[u[c]]);
    }
    return a;
  }(n, ["onUpdate", "onChange", "onFocus", "onBlur"]);
  return Q.create({ doc: s.doc, selection: s.selection, extensions: (Array.isArray(s.extensions) ? s.extensions : [s.extensions]).concat([V.updateListener.of(function(o) {
    e(o), o.docChanged && t(o.state.doc.toString(), o), o.focusChanged && (o.view.hasFocus ? i(o) : r(o));
  })]) });
}, Kn = function(n) {
  var e = new ir();
  return { compartment: e, run: function(t) {
    e.get(n.state) ? n.dispatch({ effects: e.reconfigure(t) }) : n.dispatch({ effects: X.appendConfig.of(e.of(t)) });
  } };
}, Tc = function(n, e) {
  var t = Kn(n), i = t.compartment, r = t.run;
  return function(s) {
    var o = i.get(n.state);
    r(s ?? o !== e ? e : []);
  };
}, Nr = { type: Boolean, default: void 0 }, Fw = { autofocus: Nr, disabled: Nr, indentWithTab: Nr, tabSize: Number, placeholder: String, style: Object, autoDestroy: Nr, phrases: Object, root: Object, extensions: Array, selection: Object }, zw = { modelValue: { type: String, default: "" } }, Hw = Object.assign(Object.assign({}, Fw), zw);
(function(n) {
  n.Change = "change", n.Update = "update", n.Focus = "focus", n.Blur = "blur", n.Ready = "ready", n.ModelUpdate = "update:modelValue";
})(We || (We = {}));
var On = {};
On[We.Change] = function(n, e) {
  return !0;
}, On[We.Update] = function(n) {
  return !0;
}, On[We.Focus] = function(n) {
  return !0;
}, On[We.Blur] = function(n) {
  return !0;
}, On[We.Ready] = function(n) {
  return !0;
};
var yp = {};
yp[We.ModelUpdate] = On[We.Change];
var Vw = Object.assign(Object.assign({}, On), yp), _w = lt({ name: "VueCodemirror", props: Object.assign({}, Hw), emits: Object.assign({}, Vw), setup: function(n, e) {
  var t = eo(), i = eo(), r = eo(), s = Object.assign(Object.assign({}, Bw), vh(Rw, {})), o = Fm(function() {
    var l = {};
    return Object.keys(zm(n)).forEach(function(a) {
      var u;
      a !== "modelValue" && (l[a] = (u = n[a]) !== null && u !== void 0 ? u : s[a]);
    }), l;
  });
  return Xl(function() {
    var l;
    i.value = Nw({ doc: n.modelValue, selection: o.value.selection, extensions: (l = s.extensions) !== null && l !== void 0 ? l : [], onFocus: function(u) {
      return e.emit(We.Focus, u);
    }, onBlur: function(u) {
      return e.emit(We.Blur, u);
    }, onUpdate: function(u) {
      return e.emit(We.Update, u);
    }, onChange: function(u, c) {
      u !== n.modelValue && (e.emit(We.Change, u, c), e.emit(We.ModelUpdate, u, c));
    } }), r.value = function(u) {
      return new V(Object.assign({}, u));
    }({ state: i.value, parent: t.value, root: o.value.root });
    var a = function(u) {
      var c = function() {
        return u.state.doc.toString();
      }, h = Kn(u).run, f = Tc(u, [V.editable.of(!1), Q.readOnly.of(!0)]), d = Tc(u, Ns.of([sx])), p = Kn(u).run, g = Kn(u).run, m = Kn(u).run, y = Kn(u).run;
      return { focus: function() {
        return u.focus();
      }, getDoc: c, setDoc: function(v) {
        v !== c() && u.dispatch({ changes: { from: 0, to: u.state.doc.length, insert: v } });
      }, reExtensions: h, toggleDisabled: f, toggleIndentWithTab: d, setTabSize: function(v) {
        p([Q.tabSize.of(v), zs.of(" ".repeat(v))]);
      }, setPhrases: function(v) {
        g([Q.phrases.of(v)]);
      }, setPlaceholder: function(v) {
        m(h1(v));
      }, setStyle: function(v) {
        v === void 0 && (v = {}), y(V.theme({ "&": Object.assign({}, v) }));
      } };
    }(r.value);
    ut(function() {
      return n.modelValue;
    }, function(u) {
      u !== a.getDoc() && a.setDoc(u);
    }), ut(function() {
      return n.extensions;
    }, function(u) {
      return a.reExtensions(u || []);
    }, { immediate: !0 }), ut(function() {
      return o.value.disabled;
    }, function(u) {
      return a.toggleDisabled(u);
    }, { immediate: !0 }), ut(function() {
      return o.value.indentWithTab;
    }, function(u) {
      return a.toggleIndentWithTab(u);
    }, { immediate: !0 }), ut(function() {
      return o.value.tabSize;
    }, function(u) {
      return a.setTabSize(u);
    }, { immediate: !0 }), ut(function() {
      return o.value.phrases;
    }, function(u) {
      return a.setPhrases(u || {});
    }, { immediate: !0 }), ut(function() {
      return o.value.placeholder;
    }, function(u) {
      return a.setPlaceholder(u);
    }, { immediate: !0 }), ut(function() {
      return o.value.style;
    }, function(u) {
      return a.setStyle(u);
    }, { immediate: !0 }), o.value.autofocus && a.focus(), e.emit(We.Ready, { state: i.value, view: r.value, container: t.value });
  }), Hm(function() {
    o.value.autoDestroy && r.value && function(l) {
      l.destroy();
    }(r.value);
  }), function() {
    return Vm("div", { class: "v-codemirror", style: { display: "contents" }, ref: t });
  };
} }), $w = _w;
const jw = /* @__PURE__ */ lt({
  __name: "MEditor",
  props: /* @__PURE__ */ ts({
    plugins: {}
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    const e = n, t = Jl(n, "modelValue"), i = [
      V.lineWrapping,
      V.theme({
        "&.cm-focused": {
          outline: "none"
        },
        "&.cm-editor": {
          height: "100%"
        }
      }),
      ...e.plugins.codemirror || []
    ];
    return (r, s) => (se(), xn(Wi($w), {
      modelValue: t.value,
      "onUpdate:modelValue": s[0] || (s[0] = (o) => t.value = o),
      extensions: i
    }, null, 8, ["modelValue"]));
  }
});
function Oc(n) {
  if (n)
    throw n;
}
function Ww(n) {
  return n && n.__esModule && Object.prototype.hasOwnProperty.call(n, "default") ? n.default : n;
}
var Zr = Object.prototype.hasOwnProperty, bp = Object.prototype.toString, Dc = Object.defineProperty, Ec = Object.getOwnPropertyDescriptor, Lc = function(e) {
  return typeof Array.isArray == "function" ? Array.isArray(e) : bp.call(e) === "[object Array]";
}, Ic = function(e) {
  if (!e || bp.call(e) !== "[object Object]")
    return !1;
  var t = Zr.call(e, "constructor"), i = e.constructor && e.constructor.prototype && Zr.call(e.constructor.prototype, "isPrototypeOf");
  if (e.constructor && !t && !i)
    return !1;
  var r;
  for (r in e)
    ;
  return typeof r > "u" || Zr.call(e, r);
}, Pc = function(e, t) {
  Dc && t.name === "__proto__" ? Dc(e, t.name, {
    enumerable: !0,
    configurable: !0,
    value: t.newValue,
    writable: !0
  }) : e[t.name] = t.newValue;
}, Bc = function(e, t) {
  if (t === "__proto__")
    if (Zr.call(e, t)) {
      if (Ec)
        return Ec(e, t).value;
    } else
      return;
  return e[t];
}, qw = function n() {
  var e, t, i, r, s, o, l = arguments[0], a = 1, u = arguments.length, c = !1;
  for (typeof l == "boolean" && (c = l, l = arguments[1] || {}, a = 2), (l == null || typeof l != "object" && typeof l != "function") && (l = {}); a < u; ++a)
    if (e = arguments[a], e != null)
      for (t in e)
        i = Bc(l, t), r = Bc(e, t), l !== r && (c && r && (Ic(r) || (s = Lc(r))) ? (s ? (s = !1, o = i && Lc(i) ? i : []) : o = i && Ic(i) ? i : {}, Pc(l, { name: t, newValue: n(c, o, r) })) : typeof r < "u" && Pc(l, { name: t, newValue: r }));
  return l;
};
const Mo = /* @__PURE__ */ Ww(qw);
function Hl(n) {
  if (typeof n != "object" || n === null)
    return !1;
  const e = Object.getPrototypeOf(n);
  return (e === null || e === Object.prototype || Object.getPrototypeOf(e) === null) && !(Symbol.toStringTag in n) && !(Symbol.iterator in n);
}
function Uw() {
  const n = [], e = { run: t, use: i };
  return e;
  function t(...r) {
    let s = -1;
    const o = r.pop();
    if (typeof o != "function")
      throw new TypeError("Expected function as last argument, not " + o);
    l(null, ...r);
    function l(a, ...u) {
      const c = n[++s];
      let h = -1;
      if (a) {
        o(a);
        return;
      }
      for (; ++h < r.length; )
        (u[h] === null || u[h] === void 0) && (u[h] = r[h]);
      r = u, c ? Kw(c, l)(...u) : o(null, ...u);
    }
  }
  function i(r) {
    if (typeof r != "function")
      throw new TypeError(
        "Expected `middelware` to be a function, not " + r
      );
    return n.push(r), e;
  }
}
function Kw(n, e) {
  let t;
  return i;
  function i(...o) {
    const l = n.length > o.length;
    let a;
    l && o.push(r);
    try {
      a = n.apply(this, o);
    } catch (u) {
      const c = (
        /** @type {Error} */
        u
      );
      if (l && t)
        throw c;
      return r(c);
    }
    l || (a && a.then && typeof a.then == "function" ? a.then(s, r) : a instanceof Error ? r(a) : s(a));
  }
  function r(o, ...l) {
    t || (t = !0, e(o, ...l));
  }
  function s(o) {
    r(null, o);
  }
}
function $i(n) {
  return !n || typeof n != "object" ? "" : "position" in n || "type" in n ? Rc(n.position) : "start" in n || "end" in n ? Rc(n) : "line" in n || "column" in n ? Vl(n) : "";
}
function Vl(n) {
  return Nc(n && n.line) + ":" + Nc(n && n.column);
}
function Rc(n) {
  return Vl(n && n.start) + "-" + Vl(n && n.end);
}
function Nc(n) {
  return n && typeof n == "number" ? n : 1;
}
class Ze extends Error {
  /**
   * Create a message for `reason`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {Options | null | undefined} [options]
   * @returns
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | Options | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns
   *   Instance of `VFileMessage`.
   */
  // eslint-disable-next-line complexity
  constructor(e, t, i) {
    super(), typeof t == "string" && (i = t, t = void 0);
    let r = "", s = {}, o = !1;
    if (t && ("line" in t && "column" in t ? s = { place: t } : "start" in t && "end" in t ? s = { place: t } : "type" in t ? s = {
      ancestors: [t],
      place: t.position
    } : s = { ...t }), typeof e == "string" ? r = e : !s.cause && e && (o = !0, r = e.message, s.cause = e), !s.ruleId && !s.source && typeof i == "string") {
      const a = i.indexOf(":");
      a === -1 ? s.ruleId = i : (s.source = i.slice(0, a), s.ruleId = i.slice(a + 1));
    }
    if (!s.place && s.ancestors && s.ancestors) {
      const a = s.ancestors[s.ancestors.length - 1];
      a && (s.place = a.position);
    }
    const l = s.place && "start" in s.place ? s.place.start : s.place;
    this.ancestors = s.ancestors || void 0, this.cause = s.cause || void 0, this.column = l ? l.column : void 0, this.fatal = void 0, this.file, this.message = r, this.line = l ? l.line : void 0, this.name = $i(s.place) || "1:1", this.place = s.place || void 0, this.reason = this.message, this.ruleId = s.ruleId || void 0, this.source = s.source || void 0, this.stack = o && s.cause && typeof s.cause.stack == "string" ? s.cause.stack : "", this.actual, this.expected, this.note, this.url;
  }
}
Ze.prototype.file = "";
Ze.prototype.name = "";
Ze.prototype.reason = "";
Ze.prototype.message = "";
Ze.prototype.stack = "";
Ze.prototype.column = void 0;
Ze.prototype.line = void 0;
Ze.prototype.ancestors = void 0;
Ze.prototype.cause = void 0;
Ze.prototype.fatal = void 0;
Ze.prototype.place = void 0;
Ze.prototype.ruleId = void 0;
Ze.prototype.source = void 0;
const Lt = { basename: Gw, dirname: Yw, extname: Xw, join: Jw, sep: "/" };
function Gw(n, e) {
  if (e !== void 0 && typeof e != "string")
    throw new TypeError('"ext" argument must be a string');
  cr(n);
  let t = 0, i = -1, r = n.length, s;
  if (e === void 0 || e.length === 0 || e.length > n.length) {
    for (; r--; )
      if (n.codePointAt(r) === 47) {
        if (s) {
          t = r + 1;
          break;
        }
      } else
        i < 0 && (s = !0, i = r + 1);
    return i < 0 ? "" : n.slice(t, i);
  }
  if (e === n)
    return "";
  let o = -1, l = e.length - 1;
  for (; r--; )
    if (n.codePointAt(r) === 47) {
      if (s) {
        t = r + 1;
        break;
      }
    } else
      o < 0 && (s = !0, o = r + 1), l > -1 && (n.codePointAt(r) === e.codePointAt(l--) ? l < 0 && (i = r) : (l = -1, i = o));
  return t === i ? i = o : i < 0 && (i = n.length), n.slice(t, i);
}
function Yw(n) {
  if (cr(n), n.length === 0)
    return ".";
  let e = -1, t = n.length, i;
  for (; --t; )
    if (n.codePointAt(t) === 47) {
      if (i) {
        e = t;
        break;
      }
    } else
      i || (i = !0);
  return e < 0 ? n.codePointAt(0) === 47 ? "/" : "." : e === 1 && n.codePointAt(0) === 47 ? "//" : n.slice(0, e);
}
function Xw(n) {
  cr(n);
  let e = n.length, t = -1, i = 0, r = -1, s = 0, o;
  for (; e--; ) {
    const l = n.codePointAt(e);
    if (l === 47) {
      if (o) {
        i = e + 1;
        break;
      }
      continue;
    }
    t < 0 && (o = !0, t = e + 1), l === 46 ? r < 0 ? r = e : s !== 1 && (s = 1) : r > -1 && (s = -1);
  }
  return r < 0 || t < 0 || // We saw a non-dot character immediately before the dot.
  s === 0 || // The (right-most) trimmed path component is exactly `..`.
  s === 1 && r === t - 1 && r === i + 1 ? "" : n.slice(r, t);
}
function Jw(...n) {
  let e = -1, t;
  for (; ++e < n.length; )
    cr(n[e]), n[e] && (t = t === void 0 ? n[e] : t + "/" + n[e]);
  return t === void 0 ? "." : Qw(t);
}
function Qw(n) {
  cr(n);
  const e = n.codePointAt(0) === 47;
  let t = Zw(n, !e);
  return t.length === 0 && !e && (t = "."), t.length > 0 && n.codePointAt(n.length - 1) === 47 && (t += "/"), e ? "/" + t : t;
}
function Zw(n, e) {
  let t = "", i = 0, r = -1, s = 0, o = -1, l, a;
  for (; ++o <= n.length; ) {
    if (o < n.length)
      l = n.codePointAt(o);
    else {
      if (l === 47)
        break;
      l = 47;
    }
    if (l === 47) {
      if (!(r === o - 1 || s === 1))
        if (r !== o - 1 && s === 2) {
          if (t.length < 2 || i !== 2 || t.codePointAt(t.length - 1) !== 46 || t.codePointAt(t.length - 2) !== 46) {
            if (t.length > 2) {
              if (a = t.lastIndexOf("/"), a !== t.length - 1) {
                a < 0 ? (t = "", i = 0) : (t = t.slice(0, a), i = t.length - 1 - t.lastIndexOf("/")), r = o, s = 0;
                continue;
              }
            } else if (t.length > 0) {
              t = "", i = 0, r = o, s = 0;
              continue;
            }
          }
          e && (t = t.length > 0 ? t + "/.." : "..", i = 2);
        } else
          t.length > 0 ? t += "/" + n.slice(r + 1, o) : t = n.slice(r + 1, o), i = o - r - 1;
      r = o, s = 0;
    } else
      l === 46 && s > -1 ? s++ : s = -1;
  }
  return t;
}
function cr(n) {
  if (typeof n != "string")
    throw new TypeError(
      "Path must be a string. Received " + JSON.stringify(n)
    );
}
const e2 = { cwd: t2 };
function t2() {
  return "/";
}
function _l(n) {
  return !!(n !== null && typeof n == "object" && "href" in n && n.href && "protocol" in n && n.protocol && // @ts-expect-error: indexing is fine.
  n.auth === void 0);
}
function n2(n) {
  if (typeof n == "string")
    n = new URL(n);
  else if (!_l(n)) {
    const e = new TypeError(
      'The "path" argument must be of type string or an instance of URL. Received `' + n + "`"
    );
    throw e.code = "ERR_INVALID_ARG_TYPE", e;
  }
  if (n.protocol !== "file:") {
    const e = new TypeError("The URL must be of scheme file");
    throw e.code = "ERR_INVALID_URL_SCHEME", e;
  }
  return i2(n);
}
function i2(n) {
  if (n.hostname !== "") {
    const i = new TypeError(
      'File URL host must be "localhost" or empty on darwin'
    );
    throw i.code = "ERR_INVALID_FILE_URL_HOST", i;
  }
  const e = n.pathname;
  let t = -1;
  for (; ++t < e.length; )
    if (e.codePointAt(t) === 37 && e.codePointAt(t + 1) === 50) {
      const i = e.codePointAt(t + 2);
      if (i === 70 || i === 102) {
        const r = new TypeError(
          "File URL path must not include encoded / characters"
        );
        throw r.code = "ERR_INVALID_FILE_URL_PATH", r;
      }
    }
  return decodeURIComponent(e);
}
const To = (
  /** @type {const} */
  [
    "history",
    "path",
    "basename",
    "stem",
    "extname",
    "dirname"
  ]
);
class r2 {
  /**
   * Create a new virtual file.
   *
   * `options` is treated as:
   *
   * *   `string` or `Uint8Array` — `{value: options}`
   * *   `URL` — `{path: options}`
   * *   `VFile` — shallow copies its data over to the new file
   * *   `object` — all fields are shallow copied over to the new file
   *
   * Path related fields are set in the following order (least specific to
   * most specific): `history`, `path`, `basename`, `stem`, `extname`,
   * `dirname`.
   *
   * You cannot set `dirname` or `extname` without setting either `history`,
   * `path`, `basename`, or `stem` too.
   *
   * @param {Compatible | null | undefined} [value]
   *   File value.
   * @returns
   *   New instance.
   */
  constructor(e) {
    let t;
    e ? _l(e) ? t = { path: e } : typeof e == "string" || s2(e) ? t = { value: e } : t = e : t = {}, this.cwd = e2.cwd(), this.data = {}, this.history = [], this.messages = [], this.value, this.map, this.result, this.stored;
    let i = -1;
    for (; ++i < To.length; ) {
      const s = To[i];
      s in t && t[s] !== void 0 && t[s] !== null && (this[s] = s === "history" ? [...t[s]] : t[s]);
    }
    let r;
    for (r in t)
      To.includes(r) || (this[r] = t[r]);
  }
  /**
   * Get the basename (including extname) (example: `'index.min.js'`).
   *
   * @returns {string | undefined}
   *   Basename.
   */
  get basename() {
    return typeof this.path == "string" ? Lt.basename(this.path) : void 0;
  }
  /**
   * Set basename (including extname) (`'index.min.js'`).
   *
   * Cannot contain path separators (`'/'` on unix, macOS, and browsers, `'\'`
   * on windows).
   * Cannot be nullified (use `file.path = file.dirname` instead).
   *
   * @param {string} basename
   *   Basename.
   * @returns {undefined}
   *   Nothing.
   */
  set basename(e) {
    Do(e, "basename"), Oo(e, "basename"), this.path = Lt.join(this.dirname || "", e);
  }
  /**
   * Get the parent path (example: `'~'`).
   *
   * @returns {string | undefined}
   *   Dirname.
   */
  get dirname() {
    return typeof this.path == "string" ? Lt.dirname(this.path) : void 0;
  }
  /**
   * Set the parent path (example: `'~'`).
   *
   * Cannot be set if there’s no `path` yet.
   *
   * @param {string | undefined} dirname
   *   Dirname.
   * @returns {undefined}
   *   Nothing.
   */
  set dirname(e) {
    Fc(this.basename, "dirname"), this.path = Lt.join(e || "", this.basename);
  }
  /**
   * Get the extname (including dot) (example: `'.js'`).
   *
   * @returns {string | undefined}
   *   Extname.
   */
  get extname() {
    return typeof this.path == "string" ? Lt.extname(this.path) : void 0;
  }
  /**
   * Set the extname (including dot) (example: `'.js'`).
   *
   * Cannot contain path separators (`'/'` on unix, macOS, and browsers, `'\'`
   * on windows).
   * Cannot be set if there’s no `path` yet.
   *
   * @param {string | undefined} extname
   *   Extname.
   * @returns {undefined}
   *   Nothing.
   */
  set extname(e) {
    if (Oo(e, "extname"), Fc(this.dirname, "extname"), e) {
      if (e.codePointAt(0) !== 46)
        throw new Error("`extname` must start with `.`");
      if (e.includes(".", 1))
        throw new Error("`extname` cannot contain multiple dots");
    }
    this.path = Lt.join(this.dirname, this.stem + (e || ""));
  }
  /**
   * Get the full path (example: `'~/index.min.js'`).
   *
   * @returns {string}
   *   Path.
   */
  get path() {
    return this.history[this.history.length - 1];
  }
  /**
   * Set the full path (example: `'~/index.min.js'`).
   *
   * Cannot be nullified.
   * You can set a file URL (a `URL` object with a `file:` protocol) which will
   * be turned into a path with `url.fileURLToPath`.
   *
   * @param {URL | string} path
   *   Path.
   * @returns {undefined}
   *   Nothing.
   */
  set path(e) {
    _l(e) && (e = n2(e)), Do(e, "path"), this.path !== e && this.history.push(e);
  }
  /**
   * Get the stem (basename w/o extname) (example: `'index.min'`).
   *
   * @returns {string | undefined}
   *   Stem.
   */
  get stem() {
    return typeof this.path == "string" ? Lt.basename(this.path, this.extname) : void 0;
  }
  /**
   * Set the stem (basename w/o extname) (example: `'index.min'`).
   *
   * Cannot contain path separators (`'/'` on unix, macOS, and browsers, `'\'`
   * on windows).
   * Cannot be nullified (use `file.path = file.dirname` instead).
   *
   * @param {string} stem
   *   Stem.
   * @returns {undefined}
   *   Nothing.
   */
  set stem(e) {
    Do(e, "stem"), Oo(e, "stem"), this.path = Lt.join(this.dirname || "", e + (this.extname || ""));
  }
  // Normal prototypal methods.
  /**
   * Create a fatal message for `reason` associated with the file.
   *
   * The `fatal` field of the message is set to `true` (error; file not usable)
   * and the `file` field is set to the current file path.
   * The message is added to the `messages` field on `file`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {MessageOptions | null | undefined} [options]
   * @returns {never}
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns {never}
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | MessageOptions | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns {never}
   *   Never.
   * @throws {VFileMessage}
   *   Message.
   */
  fail(e, t, i) {
    const r = this.message(e, t, i);
    throw r.fatal = !0, r;
  }
  /**
   * Create an info message for `reason` associated with the file.
   *
   * The `fatal` field of the message is set to `undefined` (info; change
   * likely not needed) and the `file` field is set to the current file path.
   * The message is added to the `messages` field on `file`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {MessageOptions | null | undefined} [options]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | MessageOptions | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns {VFileMessage}
   *   Message.
   */
  info(e, t, i) {
    const r = this.message(e, t, i);
    return r.fatal = void 0, r;
  }
  /**
   * Create a message for `reason` associated with the file.
   *
   * The `fatal` field of the message is set to `false` (warning; change may be
   * needed) and the `file` field is set to the current file path.
   * The message is added to the `messages` field on `file`.
   *
   * > 🪦 **Note**: also has obsolete signatures.
   *
   * @overload
   * @param {string} reason
   * @param {MessageOptions | null | undefined} [options]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {string} reason
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Node | NodeLike | null | undefined} parent
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {Point | Position | null | undefined} place
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @overload
   * @param {Error | VFileMessage} cause
   * @param {string | null | undefined} [origin]
   * @returns {VFileMessage}
   *
   * @param {Error | VFileMessage | string} causeOrReason
   *   Reason for message, should use markdown.
   * @param {Node | NodeLike | MessageOptions | Point | Position | string | null | undefined} [optionsOrParentOrPlace]
   *   Configuration (optional).
   * @param {string | null | undefined} [origin]
   *   Place in code where the message originates (example:
   *   `'my-package:my-rule'` or `'my-rule'`).
   * @returns {VFileMessage}
   *   Message.
   */
  message(e, t, i) {
    const r = new Ze(
      // @ts-expect-error: the overloads are fine.
      e,
      t,
      i
    );
    return this.path && (r.name = this.path + ":" + r.name, r.file = this.path), r.fatal = !1, this.messages.push(r), r;
  }
  /**
   * Serialize the file.
   *
   * > **Note**: which encodings are supported depends on the engine.
   * > For info on Node.js, see:
   * > <https://nodejs.org/api/util.html#whatwg-supported-encodings>.
   *
   * @param {string | null | undefined} [encoding='utf8']
   *   Character encoding to understand `value` as when it’s a `Uint8Array`
   *   (default: `'utf-8'`).
   * @returns {string}
   *   Serialized file.
   */
  toString(e) {
    return this.value === void 0 ? "" : typeof this.value == "string" ? this.value : new TextDecoder(e || void 0).decode(this.value);
  }
}
function Oo(n, e) {
  if (n && n.includes(Lt.sep))
    throw new Error(
      "`" + e + "` cannot be a path: did not expect `" + Lt.sep + "`"
    );
}
function Do(n, e) {
  if (!n)
    throw new Error("`" + e + "` cannot be empty");
}
function Fc(n, e) {
  if (!n)
    throw new Error("Setting `" + e + "` requires `path` to be set too");
}
function s2(n) {
  return !!(n && typeof n == "object" && "byteLength" in n && "byteOffset" in n);
}
const o2 = (
  /**
   * @type {new <Parameters extends Array<unknown>, Result>(property: string | symbol) => (...parameters: Parameters) => Result}
   */
  /** @type {unknown} */
  /**
   * @this {Function}
   * @param {string | symbol} property
   * @returns {(...parameters: Array<unknown>) => unknown}
   */
  function(n) {
    const i = (
      /** @type {Record<string | symbol, Function>} */
      // Prototypes do exist.
      // type-coverage:ignore-next-line
      this.constructor.prototype
    ), r = i[n], s = function() {
      return r.apply(s, arguments);
    };
    Object.setPrototypeOf(s, i);
    const o = Object.getOwnPropertyNames(r);
    for (const l of o) {
      const a = Object.getOwnPropertyDescriptor(r, l);
      a && Object.defineProperty(s, l, a);
    }
    return s;
  }
), l2 = {}.hasOwnProperty;
class Ma extends o2 {
  /**
   * Create a processor.
   */
  constructor() {
    super("copy"), this.Compiler = void 0, this.Parser = void 0, this.attachers = [], this.compiler = void 0, this.freezeIndex = -1, this.frozen = void 0, this.namespace = {}, this.parser = void 0, this.transformers = Uw();
  }
  /**
   * Copy a processor.
   *
   * @deprecated
   *   This is a private internal method and should not be used.
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *   New *unfrozen* processor ({@link Processor `Processor`}) that is
   *   configured to work the same as its ancestor.
   *   When the descendant processor is configured in the future it does not
   *   affect the ancestral processor.
   */
  copy() {
    const e = (
      /** @type {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>} */
      new Ma()
    );
    let t = -1;
    for (; ++t < this.attachers.length; ) {
      const i = this.attachers[t];
      e.use(...i);
    }
    return e.data(Mo(!0, {}, this.namespace)), e;
  }
  /**
   * Configure the processor with info available to all plugins.
   * Information is stored in an object.
   *
   * Typically, options can be given to a specific plugin, but sometimes it
   * makes sense to have information shared with several plugins.
   * For example, a list of HTML elements that are self-closing, which is
   * needed during all phases.
   *
   * > 👉 **Note**: setting information cannot occur on *frozen* processors.
   * > Call the processor first to create a new unfrozen processor.
   *
   * > 👉 **Note**: to register custom data in TypeScript, augment the
   * > {@link Data `Data`} interface.
   *
   * @example
   *   This example show how to get and set info:
   *
   *   ```js
   *   import {unified} from 'unified'
   *
   *   const processor = unified().data('alpha', 'bravo')
   *
   *   processor.data('alpha') // => 'bravo'
   *
   *   processor.data() // => {alpha: 'bravo'}
   *
   *   processor.data({charlie: 'delta'})
   *
   *   processor.data() // => {charlie: 'delta'}
   *   ```
   *
   * @template {keyof Data} Key
   *
   * @overload
   * @returns {Data}
   *
   * @overload
   * @param {Data} dataset
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @overload
   * @param {Key} key
   * @returns {Data[Key]}
   *
   * @overload
   * @param {Key} key
   * @param {Data[Key]} value
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @param {Data | Key} [key]
   *   Key to get or set, or entire dataset to set, or nothing to get the
   *   entire dataset (optional).
   * @param {Data[Key]} [value]
   *   Value to set (optional).
   * @returns {unknown}
   *   The current processor when setting, the value at `key` when getting, or
   *   the entire dataset when getting without key.
   */
  data(e, t) {
    return typeof e == "string" ? arguments.length === 2 ? (Io("data", this.frozen), this.namespace[e] = t, this) : l2.call(this.namespace, e) && this.namespace[e] || void 0 : e ? (Io("data", this.frozen), this.namespace = e, this) : this.namespace;
  }
  /**
   * Freeze a processor.
   *
   * Frozen processors are meant to be extended and not to be configured
   * directly.
   *
   * When a processor is frozen it cannot be unfrozen.
   * New processors working the same way can be created by calling the
   * processor.
   *
   * It’s possible to freeze processors explicitly by calling `.freeze()`.
   * Processors freeze automatically when `.parse()`, `.run()`, `.runSync()`,
   * `.stringify()`, `.process()`, or `.processSync()` are called.
   *
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *   The current processor.
   */
  freeze() {
    if (this.frozen)
      return this;
    const e = (
      /** @type {Processor} */
      /** @type {unknown} */
      this
    );
    for (; ++this.freezeIndex < this.attachers.length; ) {
      const [t, ...i] = this.attachers[this.freezeIndex];
      if (i[0] === !1)
        continue;
      i[0] === !0 && (i[0] = void 0);
      const r = t.call(e, ...i);
      typeof r == "function" && this.transformers.use(r);
    }
    return this.frozen = !0, this.freezeIndex = Number.POSITIVE_INFINITY, this;
  }
  /**
   * Parse text to a syntax tree.
   *
   * > 👉 **Note**: `parse` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `parse` performs the parse phase, not the run phase or other
   * > phases.
   *
   * @param {Compatible | undefined} [file]
   *   file to parse (optional); typically `string` or `VFile`; any value
   *   accepted as `x` in `new VFile(x)`.
   * @returns {ParseTree extends undefined ? Node : ParseTree}
   *   Syntax tree representing `file`.
   */
  parse(e) {
    this.freeze();
    const t = Fr(e), i = this.parser || this.Parser;
    return Eo("parse", i), i(String(t), t);
  }
  /**
   * Process the given file as configured on the processor.
   *
   * > 👉 **Note**: `process` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `process` performs the parse, run, and stringify phases.
   *
   * @overload
   * @param {Compatible | undefined} file
   * @param {ProcessCallback<VFileWithOutput<CompileResult>>} done
   * @returns {undefined}
   *
   * @overload
   * @param {Compatible | undefined} [file]
   * @returns {Promise<VFileWithOutput<CompileResult>>}
   *
   * @param {Compatible | undefined} [file]
   *   File (optional); typically `string` or `VFile`]; any value accepted as
   *   `x` in `new VFile(x)`.
   * @param {ProcessCallback<VFileWithOutput<CompileResult>> | undefined} [done]
   *   Callback (optional).
   * @returns {Promise<VFile> | undefined}
   *   Nothing if `done` is given.
   *   Otherwise a promise, rejected with a fatal error or resolved with the
   *   processed file.
   *
   *   The parsed, transformed, and compiled value is available at
   *   `file.value` (see note).
   *
   *   > 👉 **Note**: unified typically compiles by serializing: most
   *   > compilers return `string` (or `Uint8Array`).
   *   > Some compilers, such as the one configured with
   *   > [`rehype-react`][rehype-react], return other values (in this case, a
   *   > React tree).
   *   > If you’re using a compiler that doesn’t serialize, expect different
   *   > result values.
   *   >
   *   > To register custom results in TypeScript, add them to
   *   > {@link CompileResultMap `CompileResultMap`}.
   *
   *   [rehype-react]: https://github.com/rehypejs/rehype-react
   */
  process(e, t) {
    const i = this;
    return this.freeze(), Eo("process", this.parser || this.Parser), Lo("process", this.compiler || this.Compiler), t ? r(void 0, t) : new Promise(r);
    function r(s, o) {
      const l = Fr(e), a = (
        /** @type {HeadTree extends undefined ? Node : HeadTree} */
        /** @type {unknown} */
        i.parse(l)
      );
      i.run(a, l, function(c, h, f) {
        if (c || !h || !f)
          return u(c);
        const d = (
          /** @type {CompileTree extends undefined ? Node : CompileTree} */
          /** @type {unknown} */
          h
        ), p = i.stringify(d, f);
        c2(p) ? f.value = p : f.result = p, u(
          c,
          /** @type {VFileWithOutput<CompileResult>} */
          f
        );
      });
      function u(c, h) {
        c || !h ? o(c) : s ? s(h) : t(void 0, h);
      }
    }
  }
  /**
   * Process the given file as configured on the processor.
   *
   * An error is thrown if asynchronous transforms are configured.
   *
   * > 👉 **Note**: `processSync` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `processSync` performs the parse, run, and stringify phases.
   *
   * @param {Compatible | undefined} [file]
   *   File (optional); typically `string` or `VFile`; any value accepted as
   *   `x` in `new VFile(x)`.
   * @returns {VFileWithOutput<CompileResult>}
   *   The processed file.
   *
   *   The parsed, transformed, and compiled value is available at
   *   `file.value` (see note).
   *
   *   > 👉 **Note**: unified typically compiles by serializing: most
   *   > compilers return `string` (or `Uint8Array`).
   *   > Some compilers, such as the one configured with
   *   > [`rehype-react`][rehype-react], return other values (in this case, a
   *   > React tree).
   *   > If you’re using a compiler that doesn’t serialize, expect different
   *   > result values.
   *   >
   *   > To register custom results in TypeScript, add them to
   *   > {@link CompileResultMap `CompileResultMap`}.
   *
   *   [rehype-react]: https://github.com/rehypejs/rehype-react
   */
  processSync(e) {
    let t = !1, i;
    return this.freeze(), Eo("processSync", this.parser || this.Parser), Lo("processSync", this.compiler || this.Compiler), this.process(e, r), Hc("processSync", "process", t), i;
    function r(s, o) {
      t = !0, Oc(s), i = o;
    }
  }
  /**
   * Run *transformers* on a syntax tree.
   *
   * > 👉 **Note**: `run` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `run` performs the run phase, not other phases.
   *
   * @overload
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   * @param {RunCallback<TailTree extends undefined ? Node : TailTree>} done
   * @returns {undefined}
   *
   * @overload
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   * @param {Compatible | undefined} file
   * @param {RunCallback<TailTree extends undefined ? Node : TailTree>} done
   * @returns {undefined}
   *
   * @overload
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   * @param {Compatible | undefined} [file]
   * @returns {Promise<TailTree extends undefined ? Node : TailTree>}
   *
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   *   Tree to transform and inspect.
   * @param {(
   *   RunCallback<TailTree extends undefined ? Node : TailTree> |
   *   Compatible
   * )} [file]
   *   File associated with `node` (optional); any value accepted as `x` in
   *   `new VFile(x)`.
   * @param {RunCallback<TailTree extends undefined ? Node : TailTree>} [done]
   *   Callback (optional).
   * @returns {Promise<TailTree extends undefined ? Node : TailTree> | undefined}
   *   Nothing if `done` is given.
   *   Otherwise, a promise rejected with a fatal error or resolved with the
   *   transformed tree.
   */
  run(e, t, i) {
    zc(e), this.freeze();
    const r = this.transformers;
    return !i && typeof t == "function" && (i = t, t = void 0), i ? s(void 0, i) : new Promise(s);
    function s(o, l) {
      const a = Fr(t);
      r.run(e, a, u);
      function u(c, h, f) {
        const d = (
          /** @type {TailTree extends undefined ? Node : TailTree} */
          h || e
        );
        c ? l(c) : o ? o(d) : i(void 0, d, f);
      }
    }
  }
  /**
   * Run *transformers* on a syntax tree.
   *
   * An error is thrown if asynchronous transforms are configured.
   *
   * > 👉 **Note**: `runSync` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `runSync` performs the run phase, not other phases.
   *
   * @param {HeadTree extends undefined ? Node : HeadTree} tree
   *   Tree to transform and inspect.
   * @param {Compatible | undefined} [file]
   *   File associated with `node` (optional); any value accepted as `x` in
   *   `new VFile(x)`.
   * @returns {TailTree extends undefined ? Node : TailTree}
   *   Transformed tree.
   */
  runSync(e, t) {
    let i = !1, r;
    return this.run(e, t, s), Hc("runSync", "run", i), r;
    function s(o, l) {
      Oc(o), r = l, i = !0;
    }
  }
  /**
   * Compile a syntax tree.
   *
   * > 👉 **Note**: `stringify` freezes the processor if not already *frozen*.
   *
   * > 👉 **Note**: `stringify` performs the stringify phase, not the run phase
   * > or other phases.
   *
   * @param {CompileTree extends undefined ? Node : CompileTree} tree
   *   Tree to compile.
   * @param {Compatible | undefined} [file]
   *   File associated with `node` (optional); any value accepted as `x` in
   *   `new VFile(x)`.
   * @returns {CompileResult extends undefined ? Value : CompileResult}
   *   Textual representation of the tree (see note).
   *
   *   > 👉 **Note**: unified typically compiles by serializing: most compilers
   *   > return `string` (or `Uint8Array`).
   *   > Some compilers, such as the one configured with
   *   > [`rehype-react`][rehype-react], return other values (in this case, a
   *   > React tree).
   *   > If you’re using a compiler that doesn’t serialize, expect different
   *   > result values.
   *   >
   *   > To register custom results in TypeScript, add them to
   *   > {@link CompileResultMap `CompileResultMap`}.
   *
   *   [rehype-react]: https://github.com/rehypejs/rehype-react
   */
  stringify(e, t) {
    this.freeze();
    const i = Fr(t), r = this.compiler || this.Compiler;
    return Lo("stringify", r), zc(e), r(e, i);
  }
  /**
   * Configure the processor to use a plugin, a list of usable values, or a
   * preset.
   *
   * If the processor is already using a plugin, the previous plugin
   * configuration is changed based on the options that are passed in.
   * In other words, the plugin is not added a second time.
   *
   * > 👉 **Note**: `use` cannot be called on *frozen* processors.
   * > Call the processor first to create a new unfrozen processor.
   *
   * @example
   *   There are many ways to pass plugins to `.use()`.
   *   This example gives an overview:
   *
   *   ```js
   *   import {unified} from 'unified'
   *
   *   unified()
   *     // Plugin with options:
   *     .use(pluginA, {x: true, y: true})
   *     // Passing the same plugin again merges configuration (to `{x: true, y: false, z: true}`):
   *     .use(pluginA, {y: false, z: true})
   *     // Plugins:
   *     .use([pluginB, pluginC])
   *     // Two plugins, the second with options:
   *     .use([pluginD, [pluginE, {}]])
   *     // Preset with plugins and settings:
   *     .use({plugins: [pluginF, [pluginG, {}]], settings: {position: false}})
   *     // Settings only:
   *     .use({settings: {position: false}})
   *   ```
   *
   * @template {Array<unknown>} [Parameters=[]]
   * @template {Node | string | undefined} [Input=undefined]
   * @template [Output=Input]
   *
   * @overload
   * @param {Preset | null | undefined} [preset]
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @overload
   * @param {PluggableList} list
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *
   * @overload
   * @param {Plugin<Parameters, Input, Output>} plugin
   * @param {...(Parameters | [boolean])} parameters
   * @returns {UsePlugin<ParseTree, HeadTree, TailTree, CompileTree, CompileResult, Input, Output>}
   *
   * @param {PluggableList | Plugin | Preset | null | undefined} value
   *   Usable value.
   * @param {...unknown} parameters
   *   Parameters, when a plugin is given as a usable value.
   * @returns {Processor<ParseTree, HeadTree, TailTree, CompileTree, CompileResult>}
   *   Current processor.
   */
  use(e, ...t) {
    const i = this.attachers, r = this.namespace;
    if (Io("use", this.frozen), e != null)
      if (typeof e == "function")
        a(e, t);
      else if (typeof e == "object")
        Array.isArray(e) ? l(e) : o(e);
      else
        throw new TypeError("Expected usable value, not `" + e + "`");
    return this;
    function s(u) {
      if (typeof u == "function")
        a(u, []);
      else if (typeof u == "object")
        if (Array.isArray(u)) {
          const [c, ...h] = (
            /** @type {PluginTuple<Array<unknown>>} */
            u
          );
          a(c, h);
        } else
          o(u);
      else
        throw new TypeError("Expected usable value, not `" + u + "`");
    }
    function o(u) {
      if (!("plugins" in u) && !("settings" in u))
        throw new Error(
          "Expected usable value but received an empty preset, which is probably a mistake: presets typically come with `plugins` and sometimes with `settings`, but this has neither"
        );
      l(u.plugins), u.settings && (r.settings = Mo(!0, r.settings, u.settings));
    }
    function l(u) {
      let c = -1;
      if (u != null)
        if (Array.isArray(u))
          for (; ++c < u.length; ) {
            const h = u[c];
            s(h);
          }
        else
          throw new TypeError("Expected a list of plugins, not `" + u + "`");
    }
    function a(u, c) {
      let h = -1, f = -1;
      for (; ++h < i.length; )
        if (i[h][0] === u) {
          f = h;
          break;
        }
      if (f === -1)
        i.push([u, ...c]);
      else if (c.length > 0) {
        let [d, ...p] = c;
        const g = i[f][1];
        Hl(g) && Hl(d) && (d = Mo(!0, g, d)), i[f] = [u, d, ...p];
      }
    }
  }
}
const a2 = new Ma().freeze();
function Eo(n, e) {
  if (typeof e != "function")
    throw new TypeError("Cannot `" + n + "` without `parser`");
}
function Lo(n, e) {
  if (typeof e != "function")
    throw new TypeError("Cannot `" + n + "` without `compiler`");
}
function Io(n, e) {
  if (e)
    throw new Error(
      "Cannot call `" + n + "` on a frozen processor.\nCreate a new processor first, by calling it: use `processor()` instead of `processor`."
    );
}
function zc(n) {
  if (!Hl(n) || typeof n.type != "string")
    throw new TypeError("Expected node, got `" + n + "`");
}
function Hc(n, e, t) {
  if (!t)
    throw new Error(
      "`" + n + "` finished async. Use `" + e + "` instead"
    );
}
function Fr(n) {
  return u2(n) ? n : new r2(n);
}
function u2(n) {
  return !!(n && typeof n == "object" && "message" in n && "messages" in n);
}
function c2(n) {
  return typeof n == "string" || h2(n);
}
function h2(n) {
  return !!(n && typeof n == "object" && "byteLength" in n && "byteOffset" in n);
}
const f2 = {};
function Ta(n, e) {
  const t = f2, i = typeof t.includeImageAlt == "boolean" ? t.includeImageAlt : !0, r = typeof t.includeHtml == "boolean" ? t.includeHtml : !0;
  return xp(n, i, r);
}
function xp(n, e, t) {
  if (d2(n)) {
    if ("value" in n)
      return n.type === "html" && !t ? "" : n.value;
    if (e && "alt" in n && n.alt)
      return n.alt;
    if ("children" in n)
      return Vc(n.children, e, t);
  }
  return Array.isArray(n) ? Vc(n, e, t) : "";
}
function Vc(n, e, t) {
  const i = [];
  let r = -1;
  for (; ++r < n.length; )
    i[r] = xp(n[r], e, t);
  return i.join("");
}
function d2(n) {
  return !!(n && typeof n == "object");
}
const _c = document.createElement("i");
function Oa(n) {
  const e = "&" + n + ";";
  _c.innerHTML = e;
  const t = _c.textContent;
  return t.charCodeAt(t.length - 1) === 59 && n !== "semi" || t === e ? !1 : t;
}
function gt(n, e, t, i) {
  const r = n.length;
  let s = 0, o;
  if (e < 0 ? e = -e > r ? 0 : r + e : e = e > r ? r : e, t = t > 0 ? t : 0, i.length < 1e4)
    o = Array.from(i), o.unshift(e, t), n.splice(...o);
  else
    for (t && n.splice(e, t); s < i.length; )
      o = i.slice(s, s + 1e4), o.unshift(e, 0), n.splice(...o), s += 1e4, e += 1e4;
}
function ct(n, e) {
  return n.length > 0 ? (gt(n, n.length, 0, e), n) : e;
}
const $c = {}.hasOwnProperty;
function wp(n) {
  const e = {};
  let t = -1;
  for (; ++t < n.length; )
    p2(e, n[t]);
  return e;
}
function p2(n, e) {
  let t;
  for (t in e) {
    const r = ($c.call(n, t) ? n[t] : void 0) || (n[t] = {}), s = e[t];
    let o;
    if (s)
      for (o in s) {
        $c.call(r, o) || (r[o] = []);
        const l = s[o];
        m2(
          // @ts-expect-error Looks like a list.
          r[o],
          Array.isArray(l) ? l : l ? [l] : []
        );
      }
  }
}
function m2(n, e) {
  let t = -1;
  const i = [];
  for (; ++t < e.length; )
    (e[t].add === "after" ? n : i).push(e[t]);
  gt(n, 0, 0, i);
}
function kp(n, e) {
  const t = Number.parseInt(n, e);
  return (
    // C0 except for HT, LF, FF, CR, space.
    t < 9 || t === 11 || t > 13 && t < 32 || // Control character (DEL) of C0, and C1 controls.
    t > 126 && t < 160 || // Lone high surrogates and low surrogates.
    t > 55295 && t < 57344 || // Noncharacters.
    t > 64975 && t < 65008 || /* eslint-disable no-bitwise */
    (t & 65535) === 65535 || (t & 65535) === 65534 || /* eslint-enable no-bitwise */
    // Out of range
    t > 1114111 ? "�" : String.fromCodePoint(t)
  );
}
function St(n) {
  return n.replace(/[\t\n\r ]+/g, " ").replace(/^ | $/g, "").toLowerCase().toUpperCase();
}
const Ue = kn(/[A-Za-z]/), Ve = kn(/[\dA-Za-z]/), g2 = kn(/[#-'*+\--9=?A-Z^-~]/);
function As(n) {
  return (
    // Special whitespace codes (which have negative values), C0 and Control
    // character DEL
    n !== null && (n < 32 || n === 127)
  );
}
const $l = kn(/\d/), y2 = kn(/[\dA-Fa-f]/), b2 = kn(/[!-/:-@[-`{-~]/);
function W(n) {
  return n !== null && n < -2;
}
function fe(n) {
  return n !== null && (n < 0 || n === 32);
}
function J(n) {
  return n === -2 || n === -1 || n === 32;
}
const Gs = kn(new RegExp("\\p{P}|\\p{S}", "u")), zn = kn(/\s/);
function kn(n) {
  return e;
  function e(t) {
    return t !== null && t > -1 && n.test(String.fromCharCode(t));
  }
}
function gi(n) {
  const e = [];
  let t = -1, i = 0, r = 0;
  for (; ++t < n.length; ) {
    const s = n.charCodeAt(t);
    let o = "";
    if (s === 37 && Ve(n.charCodeAt(t + 1)) && Ve(n.charCodeAt(t + 2)))
      r = 2;
    else if (s < 128)
      /[!#$&-;=?-Z_a-z~]/.test(String.fromCharCode(s)) || (o = String.fromCharCode(s));
    else if (s > 55295 && s < 57344) {
      const l = n.charCodeAt(t + 1);
      s < 56320 && l > 56319 && l < 57344 ? (o = String.fromCharCode(s, l), r = 1) : o = "�";
    } else
      o = String.fromCharCode(s);
    o && (e.push(n.slice(i, t), encodeURIComponent(o)), i = t + r + 1, o = ""), r && (t += r, r = 0);
  }
  return e.join("") + n.slice(i);
}
function te(n, e, t, i) {
  const r = i ? i - 1 : Number.POSITIVE_INFINITY;
  let s = 0;
  return o;
  function o(a) {
    return J(a) ? (n.enter(t), l(a)) : e(a);
  }
  function l(a) {
    return J(a) && s++ < r ? (n.consume(a), l) : (n.exit(t), e(a));
  }
}
const x2 = {
  tokenize: w2
};
function w2(n) {
  const e = n.attempt(
    this.parser.constructs.contentInitial,
    i,
    r
  );
  let t;
  return e;
  function i(l) {
    if (l === null) {
      n.consume(l);
      return;
    }
    return n.enter("lineEnding"), n.consume(l), n.exit("lineEnding"), te(n, e, "linePrefix");
  }
  function r(l) {
    return n.enter("paragraph"), s(l);
  }
  function s(l) {
    const a = n.enter("chunkText", {
      contentType: "text",
      previous: t
    });
    return t && (t.next = a), t = a, o(l);
  }
  function o(l) {
    if (l === null) {
      n.exit("chunkText"), n.exit("paragraph"), n.consume(l);
      return;
    }
    return W(l) ? (n.consume(l), n.exit("chunkText"), s) : (n.consume(l), o);
  }
}
const k2 = {
  tokenize: v2
}, jc = {
  tokenize: S2
};
function v2(n) {
  const e = this, t = [];
  let i = 0, r, s, o;
  return l;
  function l(C) {
    if (i < t.length) {
      const O = t[i];
      return e.containerState = O[1], n.attempt(
        O[0].continuation,
        a,
        u
      )(C);
    }
    return u(C);
  }
  function a(C) {
    if (i++, e.containerState._closeFlow) {
      e.containerState._closeFlow = void 0, r && v();
      const O = e.events.length;
      let A = O, b;
      for (; A--; )
        if (e.events[A][0] === "exit" && e.events[A][1].type === "chunkFlow") {
          b = e.events[A][1].end;
          break;
        }
      y(i);
      let S = O;
      for (; S < e.events.length; )
        e.events[S][1].end = Object.assign({}, b), S++;
      return gt(
        e.events,
        A + 1,
        0,
        e.events.slice(O)
      ), e.events.length = S, u(C);
    }
    return l(C);
  }
  function u(C) {
    if (i === t.length) {
      if (!r)
        return f(C);
      if (r.currentConstruct && r.currentConstruct.concrete)
        return p(C);
      e.interrupt = !!(r.currentConstruct && !r._gfmTableDynamicInterruptHack);
    }
    return e.containerState = {}, n.check(
      jc,
      c,
      h
    )(C);
  }
  function c(C) {
    return r && v(), y(i), f(C);
  }
  function h(C) {
    return e.parser.lazy[e.now().line] = i !== t.length, o = e.now().offset, p(C);
  }
  function f(C) {
    return e.containerState = {}, n.attempt(
      jc,
      d,
      p
    )(C);
  }
  function d(C) {
    return i++, t.push([e.currentConstruct, e.containerState]), f(C);
  }
  function p(C) {
    if (C === null) {
      r && v(), y(0), n.consume(C);
      return;
    }
    return r = r || e.parser.flow(e.now()), n.enter("chunkFlow", {
      contentType: "flow",
      previous: s,
      _tokenizer: r
    }), g(C);
  }
  function g(C) {
    if (C === null) {
      m(n.exit("chunkFlow"), !0), y(0), n.consume(C);
      return;
    }
    return W(C) ? (n.consume(C), m(n.exit("chunkFlow")), i = 0, e.interrupt = void 0, l) : (n.consume(C), g);
  }
  function m(C, O) {
    const A = e.sliceStream(C);
    if (O && A.push(null), C.previous = s, s && (s.next = C), s = C, r.defineSkip(C.start), r.write(A), e.parser.lazy[C.start.line]) {
      let b = r.events.length;
      for (; b--; )
        if (
          // The token starts before the line ending…
          r.events[b][1].start.offset < o && // …and either is not ended yet…
          (!r.events[b][1].end || // …or ends after it.
          r.events[b][1].end.offset > o)
        )
          return;
      const S = e.events.length;
      let L = S, P, k;
      for (; L--; )
        if (e.events[L][0] === "exit" && e.events[L][1].type === "chunkFlow") {
          if (P) {
            k = e.events[L][1].end;
            break;
          }
          P = !0;
        }
      for (y(i), b = S; b < e.events.length; )
        e.events[b][1].end = Object.assign({}, k), b++;
      gt(
        e.events,
        L + 1,
        0,
        e.events.slice(S)
      ), e.events.length = b;
    }
  }
  function y(C) {
    let O = t.length;
    for (; O-- > C; ) {
      const A = t[O];
      e.containerState = A[1], A[0].exit.call(e, n);
    }
    t.length = C;
  }
  function v() {
    r.write([null]), s = void 0, r = void 0, e.containerState._closeFlow = void 0;
  }
}
function S2(n, e, t) {
  return te(
    n,
    n.attempt(this.parser.constructs.document, e, t),
    "linePrefix",
    this.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
  );
}
function Ms(n) {
  if (n === null || fe(n) || zn(n))
    return 1;
  if (Gs(n))
    return 2;
}
function Ys(n, e, t) {
  const i = [];
  let r = -1;
  for (; ++r < n.length; ) {
    const s = n[r].resolveAll;
    s && !i.includes(s) && (e = s(e, t), i.push(s));
  }
  return e;
}
const jl = {
  name: "attention",
  tokenize: A2,
  resolveAll: C2
};
function C2(n, e) {
  let t = -1, i, r, s, o, l, a, u, c;
  for (; ++t < n.length; )
    if (n[t][0] === "enter" && n[t][1].type === "attentionSequence" && n[t][1]._close) {
      for (i = t; i--; )
        if (n[i][0] === "exit" && n[i][1].type === "attentionSequence" && n[i][1]._open && // If the markers are the same:
        e.sliceSerialize(n[i][1]).charCodeAt(0) === e.sliceSerialize(n[t][1]).charCodeAt(0)) {
          if ((n[i][1]._close || n[t][1]._open) && (n[t][1].end.offset - n[t][1].start.offset) % 3 && !((n[i][1].end.offset - n[i][1].start.offset + n[t][1].end.offset - n[t][1].start.offset) % 3))
            continue;
          a = n[i][1].end.offset - n[i][1].start.offset > 1 && n[t][1].end.offset - n[t][1].start.offset > 1 ? 2 : 1;
          const h = Object.assign({}, n[i][1].end), f = Object.assign({}, n[t][1].start);
          Wc(h, -a), Wc(f, a), o = {
            type: a > 1 ? "strongSequence" : "emphasisSequence",
            start: h,
            end: Object.assign({}, n[i][1].end)
          }, l = {
            type: a > 1 ? "strongSequence" : "emphasisSequence",
            start: Object.assign({}, n[t][1].start),
            end: f
          }, s = {
            type: a > 1 ? "strongText" : "emphasisText",
            start: Object.assign({}, n[i][1].end),
            end: Object.assign({}, n[t][1].start)
          }, r = {
            type: a > 1 ? "strong" : "emphasis",
            start: Object.assign({}, o.start),
            end: Object.assign({}, l.end)
          }, n[i][1].end = Object.assign({}, o.start), n[t][1].start = Object.assign({}, l.end), u = [], n[i][1].end.offset - n[i][1].start.offset && (u = ct(u, [["enter", n[i][1], e], ["exit", n[i][1], e]])), u = ct(u, [["enter", r, e], ["enter", o, e], ["exit", o, e], ["enter", s, e]]), u = ct(u, Ys(e.parser.constructs.insideSpan.null, n.slice(i + 1, t), e)), u = ct(u, [["exit", s, e], ["enter", l, e], ["exit", l, e], ["exit", r, e]]), n[t][1].end.offset - n[t][1].start.offset ? (c = 2, u = ct(u, [["enter", n[t][1], e], ["exit", n[t][1], e]])) : c = 0, gt(n, i - 1, t - i + 3, u), t = i + u.length - c - 2;
          break;
        }
    }
  for (t = -1; ++t < n.length; )
    n[t][1].type === "attentionSequence" && (n[t][1].type = "data");
  return n;
}
function A2(n, e) {
  const t = this.parser.constructs.attentionMarkers.null, i = this.previous, r = Ms(i);
  let s;
  return o;
  function o(a) {
    return s = a, n.enter("attentionSequence"), l(a);
  }
  function l(a) {
    if (a === s)
      return n.consume(a), l;
    const u = n.exit("attentionSequence"), c = Ms(a), h = !c || c === 2 && r || t.includes(a), f = !r || r === 2 && c || t.includes(i);
    return u._open = !!(s === 42 ? h : h && (r || !f)), u._close = !!(s === 42 ? f : f && (c || !h)), e(a);
  }
}
function Wc(n, e) {
  n.column += e, n.offset += e, n._bufferIndex += e;
}
const M2 = {
  name: "autolink",
  tokenize: T2
};
function T2(n, e, t) {
  let i = 0;
  return r;
  function r(d) {
    return n.enter("autolink"), n.enter("autolinkMarker"), n.consume(d), n.exit("autolinkMarker"), n.enter("autolinkProtocol"), s;
  }
  function s(d) {
    return Ue(d) ? (n.consume(d), o) : d === 64 ? t(d) : u(d);
  }
  function o(d) {
    return d === 43 || d === 45 || d === 46 || Ve(d) ? (i = 1, l(d)) : u(d);
  }
  function l(d) {
    return d === 58 ? (n.consume(d), i = 0, a) : (d === 43 || d === 45 || d === 46 || Ve(d)) && i++ < 32 ? (n.consume(d), l) : (i = 0, u(d));
  }
  function a(d) {
    return d === 62 ? (n.exit("autolinkProtocol"), n.enter("autolinkMarker"), n.consume(d), n.exit("autolinkMarker"), n.exit("autolink"), e) : d === null || d === 32 || d === 60 || As(d) ? t(d) : (n.consume(d), a);
  }
  function u(d) {
    return d === 64 ? (n.consume(d), c) : g2(d) ? (n.consume(d), u) : t(d);
  }
  function c(d) {
    return Ve(d) ? h(d) : t(d);
  }
  function h(d) {
    return d === 46 ? (n.consume(d), i = 0, c) : d === 62 ? (n.exit("autolinkProtocol").type = "autolinkEmail", n.enter("autolinkMarker"), n.consume(d), n.exit("autolinkMarker"), n.exit("autolink"), e) : f(d);
  }
  function f(d) {
    if ((d === 45 || Ve(d)) && i++ < 63) {
      const p = d === 45 ? f : h;
      return n.consume(d), p;
    }
    return t(d);
  }
}
const hr = {
  tokenize: O2,
  partial: !0
};
function O2(n, e, t) {
  return i;
  function i(s) {
    return J(s) ? te(n, r, "linePrefix")(s) : r(s);
  }
  function r(s) {
    return s === null || W(s) ? e(s) : t(s);
  }
}
const vp = {
  name: "blockQuote",
  tokenize: D2,
  continuation: {
    tokenize: E2
  },
  exit: L2
};
function D2(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    if (o === 62) {
      const l = i.containerState;
      return l.open || (n.enter("blockQuote", {
        _container: !0
      }), l.open = !0), n.enter("blockQuotePrefix"), n.enter("blockQuoteMarker"), n.consume(o), n.exit("blockQuoteMarker"), s;
    }
    return t(o);
  }
  function s(o) {
    return J(o) ? (n.enter("blockQuotePrefixWhitespace"), n.consume(o), n.exit("blockQuotePrefixWhitespace"), n.exit("blockQuotePrefix"), e) : (n.exit("blockQuotePrefix"), e(o));
  }
}
function E2(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return J(o) ? te(n, s, "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(o) : s(o);
  }
  function s(o) {
    return n.attempt(vp, e, t)(o);
  }
}
function L2(n) {
  n.exit("blockQuote");
}
const Sp = {
  name: "characterEscape",
  tokenize: I2
};
function I2(n, e, t) {
  return i;
  function i(s) {
    return n.enter("characterEscape"), n.enter("escapeMarker"), n.consume(s), n.exit("escapeMarker"), r;
  }
  function r(s) {
    return b2(s) ? (n.enter("characterEscapeValue"), n.consume(s), n.exit("characterEscapeValue"), n.exit("characterEscape"), e) : t(s);
  }
}
const Cp = {
  name: "characterReference",
  tokenize: P2
};
function P2(n, e, t) {
  const i = this;
  let r = 0, s, o;
  return l;
  function l(h) {
    return n.enter("characterReference"), n.enter("characterReferenceMarker"), n.consume(h), n.exit("characterReferenceMarker"), a;
  }
  function a(h) {
    return h === 35 ? (n.enter("characterReferenceMarkerNumeric"), n.consume(h), n.exit("characterReferenceMarkerNumeric"), u) : (n.enter("characterReferenceValue"), s = 31, o = Ve, c(h));
  }
  function u(h) {
    return h === 88 || h === 120 ? (n.enter("characterReferenceMarkerHexadecimal"), n.consume(h), n.exit("characterReferenceMarkerHexadecimal"), n.enter("characterReferenceValue"), s = 6, o = y2, c) : (n.enter("characterReferenceValue"), s = 7, o = $l, c(h));
  }
  function c(h) {
    if (h === 59 && r) {
      const f = n.exit("characterReferenceValue");
      return o === Ve && !Oa(i.sliceSerialize(f)) ? t(h) : (n.enter("characterReferenceMarker"), n.consume(h), n.exit("characterReferenceMarker"), n.exit("characterReference"), e);
    }
    return o(h) && r++ < s ? (n.consume(h), c) : t(h);
  }
}
const qc = {
  tokenize: R2,
  partial: !0
}, Uc = {
  name: "codeFenced",
  tokenize: B2,
  concrete: !0
};
function B2(n, e, t) {
  const i = this, r = {
    tokenize: A,
    partial: !0
  };
  let s = 0, o = 0, l;
  return a;
  function a(b) {
    return u(b);
  }
  function u(b) {
    const S = i.events[i.events.length - 1];
    return s = S && S[1].type === "linePrefix" ? S[2].sliceSerialize(S[1], !0).length : 0, l = b, n.enter("codeFenced"), n.enter("codeFencedFence"), n.enter("codeFencedFenceSequence"), c(b);
  }
  function c(b) {
    return b === l ? (o++, n.consume(b), c) : o < 3 ? t(b) : (n.exit("codeFencedFenceSequence"), J(b) ? te(n, h, "whitespace")(b) : h(b));
  }
  function h(b) {
    return b === null || W(b) ? (n.exit("codeFencedFence"), i.interrupt ? e(b) : n.check(qc, g, O)(b)) : (n.enter("codeFencedFenceInfo"), n.enter("chunkString", {
      contentType: "string"
    }), f(b));
  }
  function f(b) {
    return b === null || W(b) ? (n.exit("chunkString"), n.exit("codeFencedFenceInfo"), h(b)) : J(b) ? (n.exit("chunkString"), n.exit("codeFencedFenceInfo"), te(n, d, "whitespace")(b)) : b === 96 && b === l ? t(b) : (n.consume(b), f);
  }
  function d(b) {
    return b === null || W(b) ? h(b) : (n.enter("codeFencedFenceMeta"), n.enter("chunkString", {
      contentType: "string"
    }), p(b));
  }
  function p(b) {
    return b === null || W(b) ? (n.exit("chunkString"), n.exit("codeFencedFenceMeta"), h(b)) : b === 96 && b === l ? t(b) : (n.consume(b), p);
  }
  function g(b) {
    return n.attempt(r, O, m)(b);
  }
  function m(b) {
    return n.enter("lineEnding"), n.consume(b), n.exit("lineEnding"), y;
  }
  function y(b) {
    return s > 0 && J(b) ? te(n, v, "linePrefix", s + 1)(b) : v(b);
  }
  function v(b) {
    return b === null || W(b) ? n.check(qc, g, O)(b) : (n.enter("codeFlowValue"), C(b));
  }
  function C(b) {
    return b === null || W(b) ? (n.exit("codeFlowValue"), v(b)) : (n.consume(b), C);
  }
  function O(b) {
    return n.exit("codeFenced"), e(b);
  }
  function A(b, S, L) {
    let P = 0;
    return k;
    function k(z) {
      return b.enter("lineEnding"), b.consume(z), b.exit("lineEnding"), M;
    }
    function M(z) {
      return b.enter("codeFencedFence"), J(z) ? te(b, D, "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(z) : D(z);
    }
    function D(z) {
      return z === l ? (b.enter("codeFencedFenceSequence"), R(z)) : L(z);
    }
    function R(z) {
      return z === l ? (P++, b.consume(z), R) : P >= o ? (b.exit("codeFencedFenceSequence"), J(z) ? te(b, _, "whitespace")(z) : _(z)) : L(z);
    }
    function _(z) {
      return z === null || W(z) ? (b.exit("codeFencedFence"), S(z)) : L(z);
    }
  }
}
function R2(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return o === null ? t(o) : (n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), s);
  }
  function s(o) {
    return i.parser.lazy[i.now().line] ? t(o) : e(o);
  }
}
const Po = {
  name: "codeIndented",
  tokenize: F2
}, N2 = {
  tokenize: z2,
  partial: !0
};
function F2(n, e, t) {
  const i = this;
  return r;
  function r(u) {
    return n.enter("codeIndented"), te(n, s, "linePrefix", 5)(u);
  }
  function s(u) {
    const c = i.events[i.events.length - 1];
    return c && c[1].type === "linePrefix" && c[2].sliceSerialize(c[1], !0).length >= 4 ? o(u) : t(u);
  }
  function o(u) {
    return u === null ? a(u) : W(u) ? n.attempt(N2, o, a)(u) : (n.enter("codeFlowValue"), l(u));
  }
  function l(u) {
    return u === null || W(u) ? (n.exit("codeFlowValue"), o(u)) : (n.consume(u), l);
  }
  function a(u) {
    return n.exit("codeIndented"), e(u);
  }
}
function z2(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return i.parser.lazy[i.now().line] ? t(o) : W(o) ? (n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), r) : te(n, s, "linePrefix", 5)(o);
  }
  function s(o) {
    const l = i.events[i.events.length - 1];
    return l && l[1].type === "linePrefix" && l[2].sliceSerialize(l[1], !0).length >= 4 ? e(o) : W(o) ? r(o) : t(o);
  }
}
const H2 = {
  name: "codeText",
  tokenize: $2,
  resolve: V2,
  previous: _2
};
function V2(n) {
  let e = n.length - 4, t = 3, i, r;
  if ((n[t][1].type === "lineEnding" || n[t][1].type === "space") && (n[e][1].type === "lineEnding" || n[e][1].type === "space")) {
    for (i = t; ++i < e; )
      if (n[i][1].type === "codeTextData") {
        n[t][1].type = "codeTextPadding", n[e][1].type = "codeTextPadding", t += 2, e -= 2;
        break;
      }
  }
  for (i = t - 1, e++; ++i <= e; )
    r === void 0 ? i !== e && n[i][1].type !== "lineEnding" && (r = i) : (i === e || n[i][1].type === "lineEnding") && (n[r][1].type = "codeTextData", i !== r + 2 && (n[r][1].end = n[i - 1][1].end, n.splice(r + 2, i - r - 2), e -= i - r - 2, i = r + 2), r = void 0);
  return n;
}
function _2(n) {
  return n !== 96 || this.events[this.events.length - 1][1].type === "characterEscape";
}
function $2(n, e, t) {
  let i = 0, r, s;
  return o;
  function o(h) {
    return n.enter("codeText"), n.enter("codeTextSequence"), l(h);
  }
  function l(h) {
    return h === 96 ? (n.consume(h), i++, l) : (n.exit("codeTextSequence"), a(h));
  }
  function a(h) {
    return h === null ? t(h) : h === 32 ? (n.enter("space"), n.consume(h), n.exit("space"), a) : h === 96 ? (s = n.enter("codeTextSequence"), r = 0, c(h)) : W(h) ? (n.enter("lineEnding"), n.consume(h), n.exit("lineEnding"), a) : (n.enter("codeTextData"), u(h));
  }
  function u(h) {
    return h === null || h === 32 || h === 96 || W(h) ? (n.exit("codeTextData"), a(h)) : (n.consume(h), u);
  }
  function c(h) {
    return h === 96 ? (n.consume(h), r++, c) : r === i ? (n.exit("codeTextSequence"), n.exit("codeText"), e(h)) : (s.type = "codeTextData", u(h));
  }
}
class j2 {
  /**
   * @param {ReadonlyArray<T> | null | undefined} [initial]
   *   Initial items (optional).
   * @returns
   *   Splice buffer.
   */
  constructor(e) {
    this.left = e ? [...e] : [], this.right = [];
  }
  /**
   * Array access;
   * does not move the cursor.
   *
   * @param {number} index
   *   Index.
   * @return {T}
   *   Item.
   */
  get(e) {
    if (e < 0 || e >= this.left.length + this.right.length)
      throw new RangeError("Cannot access index `" + e + "` in a splice buffer of size `" + (this.left.length + this.right.length) + "`");
    return e < this.left.length ? this.left[e] : this.right[this.right.length - e + this.left.length - 1];
  }
  /**
   * The length of the splice buffer, one greater than the largest index in the
   * array.
   */
  get length() {
    return this.left.length + this.right.length;
  }
  /**
   * Remove and return `list[0]`;
   * moves the cursor to `0`.
   *
   * @returns {T | undefined}
   *   Item, optional.
   */
  shift() {
    return this.setCursor(0), this.right.pop();
  }
  /**
   * Slice the buffer to get an array;
   * does not move the cursor.
   *
   * @param {number} start
   *   Start.
   * @param {number | null | undefined} [end]
   *   End (optional).
   * @returns {Array<T>}
   *   Array of items.
   */
  slice(e, t) {
    const i = t ?? Number.POSITIVE_INFINITY;
    return i < this.left.length ? this.left.slice(e, i) : e > this.left.length ? this.right.slice(this.right.length - i + this.left.length, this.right.length - e + this.left.length).reverse() : this.left.slice(e).concat(this.right.slice(this.right.length - i + this.left.length).reverse());
  }
  /**
   * Mimics the behavior of Array.prototype.splice() except for the change of
   * interface necessary to avoid segfaults when patching in very large arrays.
   *
   * This operation moves cursor is moved to `start` and results in the cursor
   * placed after any inserted items.
   *
   * @param {number} start
   *   Start;
   *   zero-based index at which to start changing the array;
   *   negative numbers count backwards from the end of the array and values
   *   that are out-of bounds are clamped to the appropriate end of the array.
   * @param {number | null | undefined} [deleteCount=0]
   *   Delete count (default: `0`);
   *   maximum number of elements to delete, starting from start.
   * @param {Array<T> | null | undefined} [items=[]]
   *   Items to include in place of the deleted items (default: `[]`).
   * @return {Array<T>}
   *   Any removed items.
   */
  splice(e, t, i) {
    const r = t || 0;
    this.setCursor(Math.trunc(e));
    const s = this.right.splice(this.right.length - r, Number.POSITIVE_INFINITY);
    return i && Ti(this.left, i), s.reverse();
  }
  /**
   * Remove and return the highest-numbered item in the array, so
   * `list[list.length - 1]`;
   * Moves the cursor to `length`.
   *
   * @returns {T | undefined}
   *   Item, optional.
   */
  pop() {
    return this.setCursor(Number.POSITIVE_INFINITY), this.left.pop();
  }
  /**
   * Inserts a single item to the high-numbered side of the array;
   * moves the cursor to `length`.
   *
   * @param {T} item
   *   Item.
   * @returns {undefined}
   *   Nothing.
   */
  push(e) {
    this.setCursor(Number.POSITIVE_INFINITY), this.left.push(e);
  }
  /**
   * Inserts many items to the high-numbered side of the array.
   * Moves the cursor to `length`.
   *
   * @param {Array<T>} items
   *   Items.
   * @returns {undefined}
   *   Nothing.
   */
  pushMany(e) {
    this.setCursor(Number.POSITIVE_INFINITY), Ti(this.left, e);
  }
  /**
   * Inserts a single item to the low-numbered side of the array;
   * Moves the cursor to `0`.
   *
   * @param {T} item
   *   Item.
   * @returns {undefined}
   *   Nothing.
   */
  unshift(e) {
    this.setCursor(0), this.right.push(e);
  }
  /**
   * Inserts many items to the low-numbered side of the array;
   * moves the cursor to `0`.
   *
   * @param {Array<T>} items
   *   Items.
   * @returns {undefined}
   *   Nothing.
   */
  unshiftMany(e) {
    this.setCursor(0), Ti(this.right, e.reverse());
  }
  /**
   * Move the cursor to a specific position in the array. Requires
   * time proportional to the distance moved.
   *
   * If `n < 0`, the cursor will end up at the beginning.
   * If `n > length`, the cursor will end up at the end.
   *
   * @param {number} n
   *   Position.
   * @return {undefined}
   *   Nothing.
   */
  setCursor(e) {
    if (!(e === this.left.length || e > this.left.length && this.right.length === 0 || e < 0 && this.left.length === 0))
      if (e < this.left.length) {
        const t = this.left.splice(e, Number.POSITIVE_INFINITY);
        Ti(this.right, t.reverse());
      } else {
        const t = this.right.splice(this.left.length + this.right.length - e, Number.POSITIVE_INFINITY);
        Ti(this.left, t.reverse());
      }
  }
}
function Ti(n, e) {
  let t = 0;
  if (e.length < 1e4)
    n.push(...e);
  else
    for (; t < e.length; )
      n.push(...e.slice(t, t + 1e4)), t += 1e4;
}
function Ap(n) {
  const e = {};
  let t = -1, i, r, s, o, l, a, u;
  const c = new j2(n);
  for (; ++t < c.length; ) {
    for (; t in e; )
      t = e[t];
    if (i = c.get(t), t && i[1].type === "chunkFlow" && c.get(t - 1)[1].type === "listItemPrefix" && (a = i[1]._tokenizer.events, s = 0, s < a.length && a[s][1].type === "lineEndingBlank" && (s += 2), s < a.length && a[s][1].type === "content"))
      for (; ++s < a.length && a[s][1].type !== "content"; )
        a[s][1].type === "chunkText" && (a[s][1]._isInFirstContentOfListItem = !0, s++);
    if (i[0] === "enter")
      i[1].contentType && (Object.assign(e, W2(c, t)), t = e[t], u = !0);
    else if (i[1]._container) {
      for (s = t, r = void 0; s-- && (o = c.get(s), o[1].type === "lineEnding" || o[1].type === "lineEndingBlank"); )
        o[0] === "enter" && (r && (c.get(r)[1].type = "lineEndingBlank"), o[1].type = "lineEnding", r = s);
      r && (i[1].end = Object.assign({}, c.get(r)[1].start), l = c.slice(r, t), l.unshift(i), c.splice(r, t - r + 1, l));
    }
  }
  return gt(n, 0, Number.POSITIVE_INFINITY, c.slice(0)), !u;
}
function W2(n, e) {
  const t = n.get(e)[1], i = n.get(e)[2];
  let r = e - 1;
  const s = [], o = t._tokenizer || i.parser[t.contentType](t.start), l = o.events, a = [], u = {};
  let c, h, f = -1, d = t, p = 0, g = 0;
  const m = [g];
  for (; d; ) {
    for (; n.get(++r)[1] !== d; )
      ;
    s.push(r), d._tokenizer || (c = i.sliceStream(d), d.next || c.push(null), h && o.defineSkip(d.start), d._isInFirstContentOfListItem && (o._gfmTasklistFirstContentOfListItem = !0), o.write(c), d._isInFirstContentOfListItem && (o._gfmTasklistFirstContentOfListItem = void 0)), h = d, d = d.next;
  }
  for (d = t; ++f < l.length; )
    // Find a void token that includes a break.
    l[f][0] === "exit" && l[f - 1][0] === "enter" && l[f][1].type === l[f - 1][1].type && l[f][1].start.line !== l[f][1].end.line && (g = f + 1, m.push(g), d._tokenizer = void 0, d.previous = void 0, d = d.next);
  for (o.events = [], d ? (d._tokenizer = void 0, d.previous = void 0) : m.pop(), f = m.length; f--; ) {
    const y = l.slice(m[f], m[f + 1]), v = s.pop();
    a.push([v, v + y.length - 1]), n.splice(v, 2, y);
  }
  for (a.reverse(), f = -1; ++f < a.length; )
    u[p + a[f][0]] = p + a[f][1], p += a[f][1] - a[f][0] - 1;
  return u;
}
const q2 = {
  tokenize: G2,
  resolve: K2
}, U2 = {
  tokenize: Y2,
  partial: !0
};
function K2(n) {
  return Ap(n), n;
}
function G2(n, e) {
  let t;
  return i;
  function i(l) {
    return n.enter("content"), t = n.enter("chunkContent", {
      contentType: "content"
    }), r(l);
  }
  function r(l) {
    return l === null ? s(l) : W(l) ? n.check(U2, o, s)(l) : (n.consume(l), r);
  }
  function s(l) {
    return n.exit("chunkContent"), n.exit("content"), e(l);
  }
  function o(l) {
    return n.consume(l), n.exit("chunkContent"), t.next = n.enter("chunkContent", {
      contentType: "content",
      previous: t
    }), t = t.next, r;
  }
}
function Y2(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return n.exit("chunkContent"), n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), te(n, s, "linePrefix");
  }
  function s(o) {
    if (o === null || W(o))
      return t(o);
    const l = i.events[i.events.length - 1];
    return !i.parser.constructs.disable.null.includes("codeIndented") && l && l[1].type === "linePrefix" && l[2].sliceSerialize(l[1], !0).length >= 4 ? e(o) : n.interrupt(i.parser.constructs.flow, t, e)(o);
  }
}
function Mp(n, e, t, i, r, s, o, l, a) {
  const u = a || Number.POSITIVE_INFINITY;
  let c = 0;
  return h;
  function h(y) {
    return y === 60 ? (n.enter(i), n.enter(r), n.enter(s), n.consume(y), n.exit(s), f) : y === null || y === 32 || y === 41 || As(y) ? t(y) : (n.enter(i), n.enter(o), n.enter(l), n.enter("chunkString", {
      contentType: "string"
    }), g(y));
  }
  function f(y) {
    return y === 62 ? (n.enter(s), n.consume(y), n.exit(s), n.exit(r), n.exit(i), e) : (n.enter(l), n.enter("chunkString", {
      contentType: "string"
    }), d(y));
  }
  function d(y) {
    return y === 62 ? (n.exit("chunkString"), n.exit(l), f(y)) : y === null || y === 60 || W(y) ? t(y) : (n.consume(y), y === 92 ? p : d);
  }
  function p(y) {
    return y === 60 || y === 62 || y === 92 ? (n.consume(y), d) : d(y);
  }
  function g(y) {
    return !c && (y === null || y === 41 || fe(y)) ? (n.exit("chunkString"), n.exit(l), n.exit(o), n.exit(i), e(y)) : c < u && y === 40 ? (n.consume(y), c++, g) : y === 41 ? (n.consume(y), c--, g) : y === null || y === 32 || y === 40 || As(y) ? t(y) : (n.consume(y), y === 92 ? m : g);
  }
  function m(y) {
    return y === 40 || y === 41 || y === 92 ? (n.consume(y), g) : g(y);
  }
}
function Tp(n, e, t, i, r, s) {
  const o = this;
  let l = 0, a;
  return u;
  function u(d) {
    return n.enter(i), n.enter(r), n.consume(d), n.exit(r), n.enter(s), c;
  }
  function c(d) {
    return l > 999 || d === null || d === 91 || d === 93 && !a || // To do: remove in the future once we’ve switched from
    // `micromark-extension-footnote` to `micromark-extension-gfm-footnote`,
    // which doesn’t need this.
    // Hidden footnotes hook.
    /* c8 ignore next 3 */
    d === 94 && !l && "_hiddenFootnoteSupport" in o.parser.constructs ? t(d) : d === 93 ? (n.exit(s), n.enter(r), n.consume(d), n.exit(r), n.exit(i), e) : W(d) ? (n.enter("lineEnding"), n.consume(d), n.exit("lineEnding"), c) : (n.enter("chunkString", {
      contentType: "string"
    }), h(d));
  }
  function h(d) {
    return d === null || d === 91 || d === 93 || W(d) || l++ > 999 ? (n.exit("chunkString"), c(d)) : (n.consume(d), a || (a = !J(d)), d === 92 ? f : h);
  }
  function f(d) {
    return d === 91 || d === 92 || d === 93 ? (n.consume(d), l++, h) : h(d);
  }
}
function Op(n, e, t, i, r, s) {
  let o;
  return l;
  function l(f) {
    return f === 34 || f === 39 || f === 40 ? (n.enter(i), n.enter(r), n.consume(f), n.exit(r), o = f === 40 ? 41 : f, a) : t(f);
  }
  function a(f) {
    return f === o ? (n.enter(r), n.consume(f), n.exit(r), n.exit(i), e) : (n.enter(s), u(f));
  }
  function u(f) {
    return f === o ? (n.exit(s), a(o)) : f === null ? t(f) : W(f) ? (n.enter("lineEnding"), n.consume(f), n.exit("lineEnding"), te(n, u, "linePrefix")) : (n.enter("chunkString", {
      contentType: "string"
    }), c(f));
  }
  function c(f) {
    return f === o || f === null || W(f) ? (n.exit("chunkString"), u(f)) : (n.consume(f), f === 92 ? h : c);
  }
  function h(f) {
    return f === o || f === 92 ? (n.consume(f), c) : c(f);
  }
}
function ji(n, e) {
  let t;
  return i;
  function i(r) {
    return W(r) ? (n.enter("lineEnding"), n.consume(r), n.exit("lineEnding"), t = !0, i) : J(r) ? te(
      n,
      i,
      t ? "linePrefix" : "lineSuffix"
    )(r) : e(r);
  }
}
const X2 = {
  name: "definition",
  tokenize: Q2
}, J2 = {
  tokenize: Z2,
  partial: !0
};
function Q2(n, e, t) {
  const i = this;
  let r;
  return s;
  function s(d) {
    return n.enter("definition"), o(d);
  }
  function o(d) {
    return Tp.call(
      i,
      n,
      l,
      // Note: we don’t need to reset the way `markdown-rs` does.
      t,
      "definitionLabel",
      "definitionLabelMarker",
      "definitionLabelString"
    )(d);
  }
  function l(d) {
    return r = St(i.sliceSerialize(i.events[i.events.length - 1][1]).slice(1, -1)), d === 58 ? (n.enter("definitionMarker"), n.consume(d), n.exit("definitionMarker"), a) : t(d);
  }
  function a(d) {
    return fe(d) ? ji(n, u)(d) : u(d);
  }
  function u(d) {
    return Mp(
      n,
      c,
      // Note: we don’t need to reset the way `markdown-rs` does.
      t,
      "definitionDestination",
      "definitionDestinationLiteral",
      "definitionDestinationLiteralMarker",
      "definitionDestinationRaw",
      "definitionDestinationString"
    )(d);
  }
  function c(d) {
    return n.attempt(J2, h, h)(d);
  }
  function h(d) {
    return J(d) ? te(n, f, "whitespace")(d) : f(d);
  }
  function f(d) {
    return d === null || W(d) ? (n.exit("definition"), i.parser.defined.push(r), e(d)) : t(d);
  }
}
function Z2(n, e, t) {
  return i;
  function i(l) {
    return fe(l) ? ji(n, r)(l) : t(l);
  }
  function r(l) {
    return Op(n, s, t, "definitionTitle", "definitionTitleMarker", "definitionTitleString")(l);
  }
  function s(l) {
    return J(l) ? te(n, o, "whitespace")(l) : o(l);
  }
  function o(l) {
    return l === null || W(l) ? e(l) : t(l);
  }
}
const ek = {
  name: "hardBreakEscape",
  tokenize: tk
};
function tk(n, e, t) {
  return i;
  function i(s) {
    return n.enter("hardBreakEscape"), n.consume(s), r;
  }
  function r(s) {
    return W(s) ? (n.exit("hardBreakEscape"), e(s)) : t(s);
  }
}
const nk = {
  name: "headingAtx",
  tokenize: rk,
  resolve: ik
};
function ik(n, e) {
  let t = n.length - 2, i = 3, r, s;
  return n[i][1].type === "whitespace" && (i += 2), t - 2 > i && n[t][1].type === "whitespace" && (t -= 2), n[t][1].type === "atxHeadingSequence" && (i === t - 1 || t - 4 > i && n[t - 2][1].type === "whitespace") && (t -= i + 1 === t ? 2 : 4), t > i && (r = {
    type: "atxHeadingText",
    start: n[i][1].start,
    end: n[t][1].end
  }, s = {
    type: "chunkText",
    start: n[i][1].start,
    end: n[t][1].end,
    contentType: "text"
  }, gt(n, i, t - i + 1, [["enter", r, e], ["enter", s, e], ["exit", s, e], ["exit", r, e]])), n;
}
function rk(n, e, t) {
  let i = 0;
  return r;
  function r(c) {
    return n.enter("atxHeading"), s(c);
  }
  function s(c) {
    return n.enter("atxHeadingSequence"), o(c);
  }
  function o(c) {
    return c === 35 && i++ < 6 ? (n.consume(c), o) : c === null || fe(c) ? (n.exit("atxHeadingSequence"), l(c)) : t(c);
  }
  function l(c) {
    return c === 35 ? (n.enter("atxHeadingSequence"), a(c)) : c === null || W(c) ? (n.exit("atxHeading"), e(c)) : J(c) ? te(n, l, "whitespace")(c) : (n.enter("atxHeadingText"), u(c));
  }
  function a(c) {
    return c === 35 ? (n.consume(c), a) : (n.exit("atxHeadingSequence"), l(c));
  }
  function u(c) {
    return c === null || c === 35 || fe(c) ? (n.exit("atxHeadingText"), l(c)) : (n.consume(c), u);
  }
}
const sk = [
  "address",
  "article",
  "aside",
  "base",
  "basefont",
  "blockquote",
  "body",
  "caption",
  "center",
  "col",
  "colgroup",
  "dd",
  "details",
  "dialog",
  "dir",
  "div",
  "dl",
  "dt",
  "fieldset",
  "figcaption",
  "figure",
  "footer",
  "form",
  "frame",
  "frameset",
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "head",
  "header",
  "hr",
  "html",
  "iframe",
  "legend",
  "li",
  "link",
  "main",
  "menu",
  "menuitem",
  "nav",
  "noframes",
  "ol",
  "optgroup",
  "option",
  "p",
  "param",
  "search",
  "section",
  "summary",
  "table",
  "tbody",
  "td",
  "tfoot",
  "th",
  "thead",
  "title",
  "tr",
  "track",
  "ul"
], Kc = ["pre", "script", "style", "textarea"], ok = {
  name: "htmlFlow",
  tokenize: ck,
  resolveTo: uk,
  concrete: !0
}, lk = {
  tokenize: fk,
  partial: !0
}, ak = {
  tokenize: hk,
  partial: !0
};
function uk(n) {
  let e = n.length;
  for (; e-- && !(n[e][0] === "enter" && n[e][1].type === "htmlFlow"); )
    ;
  return e > 1 && n[e - 2][1].type === "linePrefix" && (n[e][1].start = n[e - 2][1].start, n[e + 1][1].start = n[e - 2][1].start, n.splice(e - 2, 2)), n;
}
function ck(n, e, t) {
  const i = this;
  let r, s, o, l, a;
  return u;
  function u(w) {
    return c(w);
  }
  function c(w) {
    return n.enter("htmlFlow"), n.enter("htmlFlowData"), n.consume(w), h;
  }
  function h(w) {
    return w === 33 ? (n.consume(w), f) : w === 47 ? (n.consume(w), s = !0, g) : w === 63 ? (n.consume(w), r = 3, i.interrupt ? e : x) : Ue(w) ? (n.consume(w), o = String.fromCharCode(w), m) : t(w);
  }
  function f(w) {
    return w === 45 ? (n.consume(w), r = 2, d) : w === 91 ? (n.consume(w), r = 5, l = 0, p) : Ue(w) ? (n.consume(w), r = 4, i.interrupt ? e : x) : t(w);
  }
  function d(w) {
    return w === 45 ? (n.consume(w), i.interrupt ? e : x) : t(w);
  }
  function p(w) {
    const Se = "CDATA[";
    return w === Se.charCodeAt(l++) ? (n.consume(w), l === Se.length ? i.interrupt ? e : D : p) : t(w);
  }
  function g(w) {
    return Ue(w) ? (n.consume(w), o = String.fromCharCode(w), m) : t(w);
  }
  function m(w) {
    if (w === null || w === 47 || w === 62 || fe(w)) {
      const Se = w === 47, at = o.toLowerCase();
      return !Se && !s && Kc.includes(at) ? (r = 1, i.interrupt ? e(w) : D(w)) : sk.includes(o.toLowerCase()) ? (r = 6, Se ? (n.consume(w), y) : i.interrupt ? e(w) : D(w)) : (r = 7, i.interrupt && !i.parser.lazy[i.now().line] ? t(w) : s ? v(w) : C(w));
    }
    return w === 45 || Ve(w) ? (n.consume(w), o += String.fromCharCode(w), m) : t(w);
  }
  function y(w) {
    return w === 62 ? (n.consume(w), i.interrupt ? e : D) : t(w);
  }
  function v(w) {
    return J(w) ? (n.consume(w), v) : k(w);
  }
  function C(w) {
    return w === 47 ? (n.consume(w), k) : w === 58 || w === 95 || Ue(w) ? (n.consume(w), O) : J(w) ? (n.consume(w), C) : k(w);
  }
  function O(w) {
    return w === 45 || w === 46 || w === 58 || w === 95 || Ve(w) ? (n.consume(w), O) : A(w);
  }
  function A(w) {
    return w === 61 ? (n.consume(w), b) : J(w) ? (n.consume(w), A) : C(w);
  }
  function b(w) {
    return w === null || w === 60 || w === 61 || w === 62 || w === 96 ? t(w) : w === 34 || w === 39 ? (n.consume(w), a = w, S) : J(w) ? (n.consume(w), b) : L(w);
  }
  function S(w) {
    return w === a ? (n.consume(w), a = null, P) : w === null || W(w) ? t(w) : (n.consume(w), S);
  }
  function L(w) {
    return w === null || w === 34 || w === 39 || w === 47 || w === 60 || w === 61 || w === 62 || w === 96 || fe(w) ? A(w) : (n.consume(w), L);
  }
  function P(w) {
    return w === 47 || w === 62 || J(w) ? C(w) : t(w);
  }
  function k(w) {
    return w === 62 ? (n.consume(w), M) : t(w);
  }
  function M(w) {
    return w === null || W(w) ? D(w) : J(w) ? (n.consume(w), M) : t(w);
  }
  function D(w) {
    return w === 45 && r === 2 ? (n.consume(w), K) : w === 60 && r === 1 ? (n.consume(w), U) : w === 62 && r === 4 ? (n.consume(w), le) : w === 63 && r === 3 ? (n.consume(w), x) : w === 93 && r === 5 ? (n.consume(w), ue) : W(w) && (r === 6 || r === 7) ? (n.exit("htmlFlowData"), n.check(lk, me, R)(w)) : w === null || W(w) ? (n.exit("htmlFlowData"), R(w)) : (n.consume(w), D);
  }
  function R(w) {
    return n.check(ak, _, me)(w);
  }
  function _(w) {
    return n.enter("lineEnding"), n.consume(w), n.exit("lineEnding"), z;
  }
  function z(w) {
    return w === null || W(w) ? R(w) : (n.enter("htmlFlowData"), D(w));
  }
  function K(w) {
    return w === 45 ? (n.consume(w), x) : D(w);
  }
  function U(w) {
    return w === 47 ? (n.consume(w), o = "", ne) : D(w);
  }
  function ne(w) {
    if (w === 62) {
      const Se = o.toLowerCase();
      return Kc.includes(Se) ? (n.consume(w), le) : D(w);
    }
    return Ue(w) && o.length < 8 ? (n.consume(w), o += String.fromCharCode(w), ne) : D(w);
  }
  function ue(w) {
    return w === 93 ? (n.consume(w), x) : D(w);
  }
  function x(w) {
    return w === 62 ? (n.consume(w), le) : w === 45 && r === 2 ? (n.consume(w), x) : D(w);
  }
  function le(w) {
    return w === null || W(w) ? (n.exit("htmlFlowData"), me(w)) : (n.consume(w), le);
  }
  function me(w) {
    return n.exit("htmlFlow"), e(w);
  }
}
function hk(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return W(o) ? (n.enter("lineEnding"), n.consume(o), n.exit("lineEnding"), s) : t(o);
  }
  function s(o) {
    return i.parser.lazy[i.now().line] ? t(o) : e(o);
  }
}
function fk(n, e, t) {
  return i;
  function i(r) {
    return n.enter("lineEnding"), n.consume(r), n.exit("lineEnding"), n.attempt(hr, e, t);
  }
}
const dk = {
  name: "htmlText",
  tokenize: pk
};
function pk(n, e, t) {
  const i = this;
  let r, s, o;
  return l;
  function l(x) {
    return n.enter("htmlText"), n.enter("htmlTextData"), n.consume(x), a;
  }
  function a(x) {
    return x === 33 ? (n.consume(x), u) : x === 47 ? (n.consume(x), A) : x === 63 ? (n.consume(x), C) : Ue(x) ? (n.consume(x), L) : t(x);
  }
  function u(x) {
    return x === 45 ? (n.consume(x), c) : x === 91 ? (n.consume(x), s = 0, p) : Ue(x) ? (n.consume(x), v) : t(x);
  }
  function c(x) {
    return x === 45 ? (n.consume(x), d) : t(x);
  }
  function h(x) {
    return x === null ? t(x) : x === 45 ? (n.consume(x), f) : W(x) ? (o = h, U(x)) : (n.consume(x), h);
  }
  function f(x) {
    return x === 45 ? (n.consume(x), d) : h(x);
  }
  function d(x) {
    return x === 62 ? K(x) : x === 45 ? f(x) : h(x);
  }
  function p(x) {
    const le = "CDATA[";
    return x === le.charCodeAt(s++) ? (n.consume(x), s === le.length ? g : p) : t(x);
  }
  function g(x) {
    return x === null ? t(x) : x === 93 ? (n.consume(x), m) : W(x) ? (o = g, U(x)) : (n.consume(x), g);
  }
  function m(x) {
    return x === 93 ? (n.consume(x), y) : g(x);
  }
  function y(x) {
    return x === 62 ? K(x) : x === 93 ? (n.consume(x), y) : g(x);
  }
  function v(x) {
    return x === null || x === 62 ? K(x) : W(x) ? (o = v, U(x)) : (n.consume(x), v);
  }
  function C(x) {
    return x === null ? t(x) : x === 63 ? (n.consume(x), O) : W(x) ? (o = C, U(x)) : (n.consume(x), C);
  }
  function O(x) {
    return x === 62 ? K(x) : C(x);
  }
  function A(x) {
    return Ue(x) ? (n.consume(x), b) : t(x);
  }
  function b(x) {
    return x === 45 || Ve(x) ? (n.consume(x), b) : S(x);
  }
  function S(x) {
    return W(x) ? (o = S, U(x)) : J(x) ? (n.consume(x), S) : K(x);
  }
  function L(x) {
    return x === 45 || Ve(x) ? (n.consume(x), L) : x === 47 || x === 62 || fe(x) ? P(x) : t(x);
  }
  function P(x) {
    return x === 47 ? (n.consume(x), K) : x === 58 || x === 95 || Ue(x) ? (n.consume(x), k) : W(x) ? (o = P, U(x)) : J(x) ? (n.consume(x), P) : K(x);
  }
  function k(x) {
    return x === 45 || x === 46 || x === 58 || x === 95 || Ve(x) ? (n.consume(x), k) : M(x);
  }
  function M(x) {
    return x === 61 ? (n.consume(x), D) : W(x) ? (o = M, U(x)) : J(x) ? (n.consume(x), M) : P(x);
  }
  function D(x) {
    return x === null || x === 60 || x === 61 || x === 62 || x === 96 ? t(x) : x === 34 || x === 39 ? (n.consume(x), r = x, R) : W(x) ? (o = D, U(x)) : J(x) ? (n.consume(x), D) : (n.consume(x), _);
  }
  function R(x) {
    return x === r ? (n.consume(x), r = void 0, z) : x === null ? t(x) : W(x) ? (o = R, U(x)) : (n.consume(x), R);
  }
  function _(x) {
    return x === null || x === 34 || x === 39 || x === 60 || x === 61 || x === 96 ? t(x) : x === 47 || x === 62 || fe(x) ? P(x) : (n.consume(x), _);
  }
  function z(x) {
    return x === 47 || x === 62 || fe(x) ? P(x) : t(x);
  }
  function K(x) {
    return x === 62 ? (n.consume(x), n.exit("htmlTextData"), n.exit("htmlText"), e) : t(x);
  }
  function U(x) {
    return n.exit("htmlTextData"), n.enter("lineEnding"), n.consume(x), n.exit("lineEnding"), ne;
  }
  function ne(x) {
    return J(x) ? te(n, ue, "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(x) : ue(x);
  }
  function ue(x) {
    return n.enter("htmlTextData"), o(x);
  }
}
const Da = {
  name: "labelEnd",
  tokenize: wk,
  resolveTo: xk,
  resolveAll: bk
}, mk = {
  tokenize: kk
}, gk = {
  tokenize: vk
}, yk = {
  tokenize: Sk
};
function bk(n) {
  let e = -1;
  for (; ++e < n.length; ) {
    const t = n[e][1];
    (t.type === "labelImage" || t.type === "labelLink" || t.type === "labelEnd") && (n.splice(e + 1, t.type === "labelImage" ? 4 : 2), t.type = "data", e++);
  }
  return n;
}
function xk(n, e) {
  let t = n.length, i = 0, r, s, o, l;
  for (; t--; )
    if (r = n[t][1], s) {
      if (r.type === "link" || r.type === "labelLink" && r._inactive)
        break;
      n[t][0] === "enter" && r.type === "labelLink" && (r._inactive = !0);
    } else if (o) {
      if (n[t][0] === "enter" && (r.type === "labelImage" || r.type === "labelLink") && !r._balanced && (s = t, r.type !== "labelLink")) {
        i = 2;
        break;
      }
    } else
      r.type === "labelEnd" && (o = t);
  const a = {
    type: n[s][1].type === "labelLink" ? "link" : "image",
    start: Object.assign({}, n[s][1].start),
    end: Object.assign({}, n[n.length - 1][1].end)
  }, u = {
    type: "label",
    start: Object.assign({}, n[s][1].start),
    end: Object.assign({}, n[o][1].end)
  }, c = {
    type: "labelText",
    start: Object.assign({}, n[s + i + 2][1].end),
    end: Object.assign({}, n[o - 2][1].start)
  };
  return l = [["enter", a, e], ["enter", u, e]], l = ct(l, n.slice(s + 1, s + i + 3)), l = ct(l, [["enter", c, e]]), l = ct(l, Ys(e.parser.constructs.insideSpan.null, n.slice(s + i + 4, o - 3), e)), l = ct(l, [["exit", c, e], n[o - 2], n[o - 1], ["exit", u, e]]), l = ct(l, n.slice(o + 1)), l = ct(l, [["exit", a, e]]), gt(n, s, n.length, l), n;
}
function wk(n, e, t) {
  const i = this;
  let r = i.events.length, s, o;
  for (; r--; )
    if ((i.events[r][1].type === "labelImage" || i.events[r][1].type === "labelLink") && !i.events[r][1]._balanced) {
      s = i.events[r][1];
      break;
    }
  return l;
  function l(f) {
    return s ? s._inactive ? h(f) : (o = i.parser.defined.includes(St(i.sliceSerialize({
      start: s.end,
      end: i.now()
    }))), n.enter("labelEnd"), n.enter("labelMarker"), n.consume(f), n.exit("labelMarker"), n.exit("labelEnd"), a) : t(f);
  }
  function a(f) {
    return f === 40 ? n.attempt(mk, c, o ? c : h)(f) : f === 91 ? n.attempt(gk, c, o ? u : h)(f) : o ? c(f) : h(f);
  }
  function u(f) {
    return n.attempt(yk, c, h)(f);
  }
  function c(f) {
    return e(f);
  }
  function h(f) {
    return s._balanced = !0, t(f);
  }
}
function kk(n, e, t) {
  return i;
  function i(h) {
    return n.enter("resource"), n.enter("resourceMarker"), n.consume(h), n.exit("resourceMarker"), r;
  }
  function r(h) {
    return fe(h) ? ji(n, s)(h) : s(h);
  }
  function s(h) {
    return h === 41 ? c(h) : Mp(n, o, l, "resourceDestination", "resourceDestinationLiteral", "resourceDestinationLiteralMarker", "resourceDestinationRaw", "resourceDestinationString", 32)(h);
  }
  function o(h) {
    return fe(h) ? ji(n, a)(h) : c(h);
  }
  function l(h) {
    return t(h);
  }
  function a(h) {
    return h === 34 || h === 39 || h === 40 ? Op(n, u, t, "resourceTitle", "resourceTitleMarker", "resourceTitleString")(h) : c(h);
  }
  function u(h) {
    return fe(h) ? ji(n, c)(h) : c(h);
  }
  function c(h) {
    return h === 41 ? (n.enter("resourceMarker"), n.consume(h), n.exit("resourceMarker"), n.exit("resource"), e) : t(h);
  }
}
function vk(n, e, t) {
  const i = this;
  return r;
  function r(l) {
    return Tp.call(i, n, s, o, "reference", "referenceMarker", "referenceString")(l);
  }
  function s(l) {
    return i.parser.defined.includes(St(i.sliceSerialize(i.events[i.events.length - 1][1]).slice(1, -1))) ? e(l) : t(l);
  }
  function o(l) {
    return t(l);
  }
}
function Sk(n, e, t) {
  return i;
  function i(s) {
    return n.enter("reference"), n.enter("referenceMarker"), n.consume(s), n.exit("referenceMarker"), r;
  }
  function r(s) {
    return s === 93 ? (n.enter("referenceMarker"), n.consume(s), n.exit("referenceMarker"), n.exit("reference"), e) : t(s);
  }
}
const Ck = {
  name: "labelStartImage",
  tokenize: Ak,
  resolveAll: Da.resolveAll
};
function Ak(n, e, t) {
  const i = this;
  return r;
  function r(l) {
    return n.enter("labelImage"), n.enter("labelImageMarker"), n.consume(l), n.exit("labelImageMarker"), s;
  }
  function s(l) {
    return l === 91 ? (n.enter("labelMarker"), n.consume(l), n.exit("labelMarker"), n.exit("labelImage"), o) : t(l);
  }
  function o(l) {
    return l === 94 && "_hiddenFootnoteSupport" in i.parser.constructs ? t(l) : e(l);
  }
}
const Mk = {
  name: "labelStartLink",
  tokenize: Tk,
  resolveAll: Da.resolveAll
};
function Tk(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return n.enter("labelLink"), n.enter("labelMarker"), n.consume(o), n.exit("labelMarker"), n.exit("labelLink"), s;
  }
  function s(o) {
    return o === 94 && "_hiddenFootnoteSupport" in i.parser.constructs ? t(o) : e(o);
  }
}
const Bo = {
  name: "lineEnding",
  tokenize: Ok
};
function Ok(n, e) {
  return t;
  function t(i) {
    return n.enter("lineEnding"), n.consume(i), n.exit("lineEnding"), te(n, e, "linePrefix");
  }
}
const es = {
  name: "thematicBreak",
  tokenize: Dk
};
function Dk(n, e, t) {
  let i = 0, r;
  return s;
  function s(u) {
    return n.enter("thematicBreak"), o(u);
  }
  function o(u) {
    return r = u, l(u);
  }
  function l(u) {
    return u === r ? (n.enter("thematicBreakSequence"), a(u)) : i >= 3 && (u === null || W(u)) ? (n.exit("thematicBreak"), e(u)) : t(u);
  }
  function a(u) {
    return u === r ? (n.consume(u), i++, a) : (n.exit("thematicBreakSequence"), J(u) ? te(n, l, "whitespace")(u) : l(u));
  }
}
const Ye = {
  name: "list",
  tokenize: Ik,
  continuation: {
    tokenize: Pk
  },
  exit: Rk
}, Ek = {
  tokenize: Nk,
  partial: !0
}, Lk = {
  tokenize: Bk,
  partial: !0
};
function Ik(n, e, t) {
  const i = this, r = i.events[i.events.length - 1];
  let s = r && r[1].type === "linePrefix" ? r[2].sliceSerialize(r[1], !0).length : 0, o = 0;
  return l;
  function l(d) {
    const p = i.containerState.type || (d === 42 || d === 43 || d === 45 ? "listUnordered" : "listOrdered");
    if (p === "listUnordered" ? !i.containerState.marker || d === i.containerState.marker : $l(d)) {
      if (i.containerState.type || (i.containerState.type = p, n.enter(p, {
        _container: !0
      })), p === "listUnordered")
        return n.enter("listItemPrefix"), d === 42 || d === 45 ? n.check(es, t, u)(d) : u(d);
      if (!i.interrupt || d === 49)
        return n.enter("listItemPrefix"), n.enter("listItemValue"), a(d);
    }
    return t(d);
  }
  function a(d) {
    return $l(d) && ++o < 10 ? (n.consume(d), a) : (!i.interrupt || o < 2) && (i.containerState.marker ? d === i.containerState.marker : d === 41 || d === 46) ? (n.exit("listItemValue"), u(d)) : t(d);
  }
  function u(d) {
    return n.enter("listItemMarker"), n.consume(d), n.exit("listItemMarker"), i.containerState.marker = i.containerState.marker || d, n.check(
      hr,
      // Can’t be empty when interrupting.
      i.interrupt ? t : c,
      n.attempt(Ek, f, h)
    );
  }
  function c(d) {
    return i.containerState.initialBlankLine = !0, s++, f(d);
  }
  function h(d) {
    return J(d) ? (n.enter("listItemPrefixWhitespace"), n.consume(d), n.exit("listItemPrefixWhitespace"), f) : t(d);
  }
  function f(d) {
    return i.containerState.size = s + i.sliceSerialize(n.exit("listItemPrefix"), !0).length, e(d);
  }
}
function Pk(n, e, t) {
  const i = this;
  return i.containerState._closeFlow = void 0, n.check(hr, r, s);
  function r(l) {
    return i.containerState.furtherBlankLines = i.containerState.furtherBlankLines || i.containerState.initialBlankLine, te(n, e, "listItemIndent", i.containerState.size + 1)(l);
  }
  function s(l) {
    return i.containerState.furtherBlankLines || !J(l) ? (i.containerState.furtherBlankLines = void 0, i.containerState.initialBlankLine = void 0, o(l)) : (i.containerState.furtherBlankLines = void 0, i.containerState.initialBlankLine = void 0, n.attempt(Lk, e, o)(l));
  }
  function o(l) {
    return i.containerState._closeFlow = !0, i.interrupt = void 0, te(n, n.attempt(Ye, e, t), "linePrefix", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4)(l);
  }
}
function Bk(n, e, t) {
  const i = this;
  return te(n, r, "listItemIndent", i.containerState.size + 1);
  function r(s) {
    const o = i.events[i.events.length - 1];
    return o && o[1].type === "listItemIndent" && o[2].sliceSerialize(o[1], !0).length === i.containerState.size ? e(s) : t(s);
  }
}
function Rk(n) {
  n.exit(this.containerState.type);
}
function Nk(n, e, t) {
  const i = this;
  return te(n, r, "listItemPrefixWhitespace", i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 5);
  function r(s) {
    const o = i.events[i.events.length - 1];
    return !J(s) && o && o[1].type === "listItemPrefixWhitespace" ? e(s) : t(s);
  }
}
const Gc = {
  name: "setextUnderline",
  tokenize: zk,
  resolveTo: Fk
};
function Fk(n, e) {
  let t = n.length, i, r, s;
  for (; t--; )
    if (n[t][0] === "enter") {
      if (n[t][1].type === "content") {
        i = t;
        break;
      }
      n[t][1].type === "paragraph" && (r = t);
    } else
      n[t][1].type === "content" && n.splice(t, 1), !s && n[t][1].type === "definition" && (s = t);
  const o = {
    type: "setextHeading",
    start: Object.assign({}, n[r][1].start),
    end: Object.assign({}, n[n.length - 1][1].end)
  };
  return n[r][1].type = "setextHeadingText", s ? (n.splice(r, 0, ["enter", o, e]), n.splice(s + 1, 0, ["exit", n[i][1], e]), n[i][1].end = Object.assign({}, n[s][1].end)) : n[i][1] = o, n.push(["exit", o, e]), n;
}
function zk(n, e, t) {
  const i = this;
  let r;
  return s;
  function s(u) {
    let c = i.events.length, h;
    for (; c--; )
      if (i.events[c][1].type !== "lineEnding" && i.events[c][1].type !== "linePrefix" && i.events[c][1].type !== "content") {
        h = i.events[c][1].type === "paragraph";
        break;
      }
    return !i.parser.lazy[i.now().line] && (i.interrupt || h) ? (n.enter("setextHeadingLine"), r = u, o(u)) : t(u);
  }
  function o(u) {
    return n.enter("setextHeadingLineSequence"), l(u);
  }
  function l(u) {
    return u === r ? (n.consume(u), l) : (n.exit("setextHeadingLineSequence"), J(u) ? te(n, a, "lineSuffix")(u) : a(u));
  }
  function a(u) {
    return u === null || W(u) ? (n.exit("setextHeadingLine"), e(u)) : t(u);
  }
}
const Hk = {
  tokenize: Vk
};
function Vk(n) {
  const e = this, t = n.attempt(
    // Try to parse a blank line.
    hr,
    i,
    // Try to parse initial flow (essentially, only code).
    n.attempt(
      this.parser.constructs.flowInitial,
      r,
      te(
        n,
        n.attempt(
          this.parser.constructs.flow,
          r,
          n.attempt(q2, r)
        ),
        "linePrefix"
      )
    )
  );
  return t;
  function i(s) {
    if (s === null) {
      n.consume(s);
      return;
    }
    return n.enter("lineEndingBlank"), n.consume(s), n.exit("lineEndingBlank"), e.currentConstruct = void 0, t;
  }
  function r(s) {
    if (s === null) {
      n.consume(s);
      return;
    }
    return n.enter("lineEnding"), n.consume(s), n.exit("lineEnding"), e.currentConstruct = void 0, t;
  }
}
const _k = {
  resolveAll: Ep()
}, $k = Dp("string"), jk = Dp("text");
function Dp(n) {
  return {
    tokenize: e,
    resolveAll: Ep(
      n === "text" ? Wk : void 0
    )
  };
  function e(t) {
    const i = this, r = this.parser.constructs[n], s = t.attempt(r, o, l);
    return o;
    function o(c) {
      return u(c) ? s(c) : l(c);
    }
    function l(c) {
      if (c === null) {
        t.consume(c);
        return;
      }
      return t.enter("data"), t.consume(c), a;
    }
    function a(c) {
      return u(c) ? (t.exit("data"), s(c)) : (t.consume(c), a);
    }
    function u(c) {
      if (c === null)
        return !0;
      const h = r[c];
      let f = -1;
      if (h)
        for (; ++f < h.length; ) {
          const d = h[f];
          if (!d.previous || d.previous.call(i, i.previous))
            return !0;
        }
      return !1;
    }
  }
}
function Ep(n) {
  return e;
  function e(t, i) {
    let r = -1, s;
    for (; ++r <= t.length; )
      s === void 0 ? t[r] && t[r][1].type === "data" && (s = r, r++) : (!t[r] || t[r][1].type !== "data") && (r !== s + 2 && (t[s][1].end = t[r - 1][1].end, t.splice(s + 2, r - s - 2), r = s + 2), s = void 0);
    return n ? n(t, i) : t;
  }
}
function Wk(n, e) {
  let t = 0;
  for (; ++t <= n.length; )
    if ((t === n.length || n[t][1].type === "lineEnding") && n[t - 1][1].type === "data") {
      const i = n[t - 1][1], r = e.sliceStream(i);
      let s = r.length, o = -1, l = 0, a;
      for (; s--; ) {
        const u = r[s];
        if (typeof u == "string") {
          for (o = u.length; u.charCodeAt(o - 1) === 32; )
            l++, o--;
          if (o)
            break;
          o = -1;
        } else if (u === -2)
          a = !0, l++;
        else if (u !== -1) {
          s++;
          break;
        }
      }
      if (l) {
        const u = {
          type: t === n.length || a || l < 2 ? "lineSuffix" : "hardBreakTrailing",
          start: {
            line: i.end.line,
            column: i.end.column - l,
            offset: i.end.offset - l,
            _index: i.start._index + s,
            _bufferIndex: s ? o : i.start._bufferIndex + o
          },
          end: Object.assign({}, i.end)
        };
        i.end = Object.assign({}, u.start), i.start.offset === i.end.offset ? Object.assign(i, u) : (n.splice(
          t,
          0,
          ["enter", u, e],
          ["exit", u, e]
        ), t += 2);
      }
      t++;
    }
  return n;
}
function qk(n, e, t) {
  let i = Object.assign(
    t ? Object.assign({}, t) : {
      line: 1,
      column: 1,
      offset: 0
    },
    {
      _index: 0,
      _bufferIndex: -1
    }
  );
  const r = {}, s = [];
  let o = [], l = [];
  const a = {
    consume: v,
    enter: C,
    exit: O,
    attempt: S(A),
    check: S(b),
    interrupt: S(b, {
      interrupt: !0
    })
  }, u = {
    previous: null,
    code: null,
    containerState: {},
    events: [],
    parser: n,
    sliceStream: d,
    sliceSerialize: f,
    now: p,
    defineSkip: g,
    write: h
  };
  let c = e.tokenize.call(u, a);
  return e.resolveAll && s.push(e), u;
  function h(M) {
    return o = ct(o, M), m(), o[o.length - 1] !== null ? [] : (L(e, 0), u.events = Ys(s, u.events, u), u.events);
  }
  function f(M, D) {
    return Kk(d(M), D);
  }
  function d(M) {
    return Uk(o, M);
  }
  function p() {
    const { line: M, column: D, offset: R, _index: _, _bufferIndex: z } = i;
    return {
      line: M,
      column: D,
      offset: R,
      _index: _,
      _bufferIndex: z
    };
  }
  function g(M) {
    r[M.line] = M.column, k();
  }
  function m() {
    let M;
    for (; i._index < o.length; ) {
      const D = o[i._index];
      if (typeof D == "string")
        for (M = i._index, i._bufferIndex < 0 && (i._bufferIndex = 0); i._index === M && i._bufferIndex < D.length; )
          y(D.charCodeAt(i._bufferIndex));
      else
        y(D);
    }
  }
  function y(M) {
    c = c(M);
  }
  function v(M) {
    W(M) ? (i.line++, i.column = 1, i.offset += M === -3 ? 2 : 1, k()) : M !== -1 && (i.column++, i.offset++), i._bufferIndex < 0 ? i._index++ : (i._bufferIndex++, i._bufferIndex === o[i._index].length && (i._bufferIndex = -1, i._index++)), u.previous = M;
  }
  function C(M, D) {
    const R = D || {};
    return R.type = M, R.start = p(), u.events.push(["enter", R, u]), l.push(R), R;
  }
  function O(M) {
    const D = l.pop();
    return D.end = p(), u.events.push(["exit", D, u]), D;
  }
  function A(M, D) {
    L(M, D.from);
  }
  function b(M, D) {
    D.restore();
  }
  function S(M, D) {
    return R;
    function R(_, z, K) {
      let U, ne, ue, x;
      return Array.isArray(_) ? me(_) : "tokenize" in _ ? (
        // @ts-expect-error Looks like a construct.
        me([_])
      ) : le(_);
      function le(Ce) {
        return bi;
        function bi(Zt) {
          const _n = Zt !== null && Ce[Zt], vn = Zt !== null && Ce.null, Zs = [
            // To do: add more extension tests.
            /* c8 ignore next 2 */
            ...Array.isArray(_n) ? _n : _n ? [_n] : [],
            ...Array.isArray(vn) ? vn : vn ? [vn] : []
          ];
          return me(Zs)(Zt);
        }
      }
      function me(Ce) {
        return U = Ce, ne = 0, Ce.length === 0 ? K : w(Ce[ne]);
      }
      function w(Ce) {
        return bi;
        function bi(Zt) {
          return x = P(), ue = Ce, Ce.partial || (u.currentConstruct = Ce), Ce.name && u.parser.constructs.disable.null.includes(Ce.name) ? at() : Ce.tokenize.call(
            // If we do have fields, create an object w/ `context` as its
            // prototype.
            // This allows a “live binding”, which is needed for `interrupt`.
            D ? Object.assign(Object.create(u), D) : u,
            a,
            Se,
            at
          )(Zt);
        }
      }
      function Se(Ce) {
        return M(ue, x), z;
      }
      function at(Ce) {
        return x.restore(), ++ne < U.length ? w(U[ne]) : K;
      }
    }
  }
  function L(M, D) {
    M.resolveAll && !s.includes(M) && s.push(M), M.resolve && gt(
      u.events,
      D,
      u.events.length - D,
      M.resolve(u.events.slice(D), u)
    ), M.resolveTo && (u.events = M.resolveTo(u.events, u));
  }
  function P() {
    const M = p(), D = u.previous, R = u.currentConstruct, _ = u.events.length, z = Array.from(l);
    return {
      restore: K,
      from: _
    };
    function K() {
      i = M, u.previous = D, u.currentConstruct = R, u.events.length = _, l = z, k();
    }
  }
  function k() {
    i.line in r && i.column < 2 && (i.column = r[i.line], i.offset += r[i.line] - 1);
  }
}
function Uk(n, e) {
  const t = e.start._index, i = e.start._bufferIndex, r = e.end._index, s = e.end._bufferIndex;
  let o;
  if (t === r)
    o = [n[t].slice(i, s)];
  else {
    if (o = n.slice(t, r), i > -1) {
      const l = o[0];
      typeof l == "string" ? o[0] = l.slice(i) : o.shift();
    }
    s > 0 && o.push(n[r].slice(0, s));
  }
  return o;
}
function Kk(n, e) {
  let t = -1;
  const i = [];
  let r;
  for (; ++t < n.length; ) {
    const s = n[t];
    let o;
    if (typeof s == "string")
      o = s;
    else
      switch (s) {
        case -5: {
          o = "\r";
          break;
        }
        case -4: {
          o = `
`;
          break;
        }
        case -3: {
          o = `\r
`;
          break;
        }
        case -2: {
          o = e ? " " : "	";
          break;
        }
        case -1: {
          if (!e && r)
            continue;
          o = " ";
          break;
        }
        default:
          o = String.fromCharCode(s);
      }
    r = s === -2, i.push(o);
  }
  return i.join("");
}
const Gk = {
  42: Ye,
  43: Ye,
  45: Ye,
  48: Ye,
  49: Ye,
  50: Ye,
  51: Ye,
  52: Ye,
  53: Ye,
  54: Ye,
  55: Ye,
  56: Ye,
  57: Ye,
  62: vp
}, Yk = {
  91: X2
}, Xk = {
  [-2]: Po,
  [-1]: Po,
  32: Po
}, Jk = {
  35: nk,
  42: es,
  45: [Gc, es],
  60: ok,
  61: Gc,
  95: es,
  96: Uc,
  126: Uc
}, Qk = {
  38: Cp,
  92: Sp
}, Zk = {
  [-5]: Bo,
  [-4]: Bo,
  [-3]: Bo,
  33: Ck,
  38: Cp,
  42: jl,
  60: [M2, dk],
  91: Mk,
  92: [ek, Sp],
  93: Da,
  95: jl,
  96: H2
}, ev = {
  null: [jl, _k]
}, tv = {
  null: [42, 95]
}, nv = {
  null: []
}, iv = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  attentionMarkers: tv,
  contentInitial: Yk,
  disable: nv,
  document: Gk,
  flow: Jk,
  flowInitial: Xk,
  insideSpan: ev,
  string: Qk,
  text: Zk
}, Symbol.toStringTag, { value: "Module" }));
function rv(n) {
  const t = (
    /** @type {FullNormalizedExtension} */
    wp([iv, ...(n || {}).extensions || []])
  ), i = {
    defined: [],
    lazy: {},
    constructs: t,
    content: r(x2),
    document: r(k2),
    flow: r(Hk),
    string: r($k),
    text: r(jk)
  };
  return i;
  function r(s) {
    return o;
    function o(l) {
      return qk(i, s, l);
    }
  }
}
function sv(n) {
  for (; !Ap(n); )
    ;
  return n;
}
const Yc = /[\0\t\n\r]/g;
function ov() {
  let n = 1, e = "", t = !0, i;
  return r;
  function r(s, o, l) {
    const a = [];
    let u, c, h, f, d;
    for (s = e + (typeof s == "string" ? s.toString() : new TextDecoder(o || void 0).decode(s)), h = 0, e = "", t && (s.charCodeAt(0) === 65279 && h++, t = void 0); h < s.length; ) {
      if (Yc.lastIndex = h, u = Yc.exec(s), f = u && u.index !== void 0 ? u.index : s.length, d = s.charCodeAt(f), !u) {
        e = s.slice(h);
        break;
      }
      if (d === 10 && h === f && i)
        a.push(-3), i = void 0;
      else
        switch (i && (a.push(-5), i = void 0), h < f && (a.push(s.slice(h, f)), n += f - h), d) {
          case 0: {
            a.push(65533), n++;
            break;
          }
          case 9: {
            for (c = Math.ceil(n / 4) * 4, a.push(-2); n++ < c; )
              a.push(-1);
            break;
          }
          case 10: {
            a.push(-4), n = 1;
            break;
          }
          default:
            i = !0, n = 1;
        }
      h = f + 1;
    }
    return l && (i && a.push(-5), e && a.push(e), a.push(null)), a;
  }
}
const lv = /\\([!-/:-@[-`{-~])|&(#(?:\d{1,7}|x[\da-f]{1,6})|[\da-z]{1,31});/gi;
function av(n) {
  return n.replace(lv, uv);
}
function uv(n, e, t) {
  if (e)
    return e;
  if (t.charCodeAt(0) === 35) {
    const r = t.charCodeAt(1), s = r === 120 || r === 88;
    return kp(t.slice(s ? 2 : 1), s ? 16 : 10);
  }
  return Oa(t) || n;
}
const Lp = {}.hasOwnProperty;
function cv(n, e, t) {
  return typeof e != "string" && (t = e, e = void 0), hv(t)(
    sv(
      rv(t).document().write(ov()(n, e, !0))
    )
  );
}
function hv(n) {
  const e = {
    transforms: [],
    canContainEols: ["emphasis", "fragment", "heading", "paragraph", "strong"],
    enter: {
      autolink: s(ja),
      autolinkProtocol: P,
      autolinkEmail: P,
      atxHeading: s(Va),
      blockQuote: s(_n),
      characterEscape: P,
      characterReference: P,
      codeFenced: s(vn),
      codeFencedFenceInfo: o,
      codeFencedFenceMeta: o,
      codeIndented: s(vn, o),
      codeText: s(Zs, o),
      codeTextData: P,
      data: P,
      codeFlowValue: P,
      definition: s(Dm),
      definitionDestinationString: o,
      definitionLabelString: o,
      definitionTitleString: o,
      emphasis: s(Em),
      hardBreakEscape: s(_a),
      hardBreakTrailing: s(_a),
      htmlFlow: s($a, o),
      htmlFlowData: P,
      htmlText: s($a, o),
      htmlTextData: P,
      image: s(Lm),
      label: o,
      link: s(ja),
      listItem: s(Im),
      listItemValue: f,
      listOrdered: s(Wa, h),
      listUnordered: s(Wa),
      paragraph: s(Pm),
      reference: w,
      referenceString: o,
      resourceDestinationString: o,
      resourceTitleString: o,
      setextHeading: s(Va),
      strong: s(Bm),
      thematicBreak: s(Nm)
    },
    exit: {
      atxHeading: a(),
      atxHeadingSequence: A,
      autolink: a(),
      autolinkEmail: Zt,
      autolinkProtocol: bi,
      blockQuote: a(),
      characterEscapeValue: k,
      characterReferenceMarkerHexadecimal: at,
      characterReferenceMarkerNumeric: at,
      characterReferenceValue: Ce,
      codeFenced: a(m),
      codeFencedFence: g,
      codeFencedFenceInfo: d,
      codeFencedFenceMeta: p,
      codeFlowValue: k,
      codeIndented: a(y),
      codeText: a(z),
      codeTextData: k,
      data: k,
      definition: a(),
      definitionDestinationString: O,
      definitionLabelString: v,
      definitionTitleString: C,
      emphasis: a(),
      hardBreakEscape: a(D),
      hardBreakTrailing: a(D),
      htmlFlow: a(R),
      htmlFlowData: k,
      htmlText: a(_),
      htmlTextData: k,
      image: a(U),
      label: ue,
      labelText: ne,
      lineEnding: M,
      link: a(K),
      listItem: a(),
      listOrdered: a(),
      listUnordered: a(),
      paragraph: a(),
      referenceString: Se,
      resourceDestinationString: x,
      resourceTitleString: le,
      resource: me,
      setextHeading: a(L),
      setextHeadingLineSequence: S,
      setextHeadingText: b,
      strong: a(),
      thematicBreak: a()
    }
  };
  Ip(e, (n || {}).mdastExtensions || []);
  const t = {};
  return i;
  function i(E) {
    let F = {
      type: "root",
      children: []
    };
    const G = {
      stack: [F],
      tokenStack: [],
      config: e,
      enter: l,
      exit: u,
      buffer: o,
      resume: c,
      data: t
    }, Z = [];
    let ae = -1;
    for (; ++ae < E.length; )
      if (E[ae][1].type === "listOrdered" || E[ae][1].type === "listUnordered")
        if (E[ae][0] === "enter")
          Z.push(ae);
        else {
          const vt = Z.pop();
          ae = r(E, vt, ae);
        }
    for (ae = -1; ++ae < E.length; ) {
      const vt = e[E[ae][0]];
      Lp.call(vt, E[ae][1].type) && vt[E[ae][1].type].call(
        Object.assign(
          {
            sliceSerialize: E[ae][2].sliceSerialize
          },
          G
        ),
        E[ae][1]
      );
    }
    if (G.tokenStack.length > 0) {
      const vt = G.tokenStack[G.tokenStack.length - 1];
      (vt[1] || Xc).call(G, void 0, vt[0]);
    }
    for (F.position = {
      start: en(
        E.length > 0 ? E[0][1].start : {
          line: 1,
          column: 1,
          offset: 0
        }
      ),
      end: en(
        E.length > 0 ? E[E.length - 2][1].end : {
          line: 1,
          column: 1,
          offset: 0
        }
      )
    }, ae = -1; ++ae < e.transforms.length; )
      F = e.transforms[ae](F) || F;
    return F;
  }
  function r(E, F, G) {
    let Z = F - 1, ae = -1, vt = !1, Sn, jt, xi, wi;
    for (; ++Z <= G; ) {
      const et = E[Z];
      switch (et[1].type) {
        case "listUnordered":
        case "listOrdered":
        case "blockQuote": {
          et[0] === "enter" ? ae++ : ae--, wi = void 0;
          break;
        }
        case "lineEndingBlank": {
          et[0] === "enter" && (Sn && !wi && !ae && !xi && (xi = Z), wi = void 0);
          break;
        }
        case "linePrefix":
        case "listItemValue":
        case "listItemMarker":
        case "listItemPrefix":
        case "listItemPrefixWhitespace":
          break;
        default:
          wi = void 0;
      }
      if (!ae && et[0] === "enter" && et[1].type === "listItemPrefix" || ae === -1 && et[0] === "exit" && (et[1].type === "listUnordered" || et[1].type === "listOrdered")) {
        if (Sn) {
          let $n = Z;
          for (jt = void 0; $n--; ) {
            const Wt = E[$n];
            if (Wt[1].type === "lineEnding" || Wt[1].type === "lineEndingBlank") {
              if (Wt[0] === "exit")
                continue;
              jt && (E[jt][1].type = "lineEndingBlank", vt = !0), Wt[1].type = "lineEnding", jt = $n;
            } else if (!(Wt[1].type === "linePrefix" || Wt[1].type === "blockQuotePrefix" || Wt[1].type === "blockQuotePrefixWhitespace" || Wt[1].type === "blockQuoteMarker" || Wt[1].type === "listItemIndent"))
              break;
          }
          xi && (!jt || xi < jt) && (Sn._spread = !0), Sn.end = Object.assign(
            {},
            jt ? E[jt][1].start : et[1].end
          ), E.splice(jt || Z, 0, ["exit", Sn, et[2]]), Z++, G++;
        }
        if (et[1].type === "listItemPrefix") {
          const $n = {
            type: "listItem",
            _spread: !1,
            start: Object.assign({}, et[1].start),
            // @ts-expect-error: we’ll add `end` in a second.
            end: void 0
          };
          Sn = $n, E.splice(Z, 0, ["enter", $n, et[2]]), Z++, G++, xi = void 0, wi = !0;
        }
      }
    }
    return E[F][1]._spread = vt, G;
  }
  function s(E, F) {
    return G;
    function G(Z) {
      l.call(this, E(Z), Z), F && F.call(this, Z);
    }
  }
  function o() {
    this.stack.push({
      type: "fragment",
      children: []
    });
  }
  function l(E, F, G) {
    this.stack[this.stack.length - 1].children.push(E), this.stack.push(E), this.tokenStack.push([F, G]), E.position = {
      start: en(F.start),
      // @ts-expect-error: `end` will be patched later.
      end: void 0
    };
  }
  function a(E) {
    return F;
    function F(G) {
      E && E.call(this, G), u.call(this, G);
    }
  }
  function u(E, F) {
    const G = this.stack.pop(), Z = this.tokenStack.pop();
    if (Z)
      Z[0].type !== E.type && (F ? F.call(this, E, Z[0]) : (Z[1] || Xc).call(this, E, Z[0]));
    else
      throw new Error(
        "Cannot close `" + E.type + "` (" + $i({
          start: E.start,
          end: E.end
        }) + "): it’s not open"
      );
    G.position.end = en(E.end);
  }
  function c() {
    return Ta(this.stack.pop());
  }
  function h() {
    this.data.expectingFirstListItemValue = !0;
  }
  function f(E) {
    if (this.data.expectingFirstListItemValue) {
      const F = this.stack[this.stack.length - 2];
      F.start = Number.parseInt(this.sliceSerialize(E), 10), this.data.expectingFirstListItemValue = void 0;
    }
  }
  function d() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.lang = E;
  }
  function p() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.meta = E;
  }
  function g() {
    this.data.flowCodeInside || (this.buffer(), this.data.flowCodeInside = !0);
  }
  function m() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.value = E.replace(/^(\r?\n|\r)|(\r?\n|\r)$/g, ""), this.data.flowCodeInside = void 0;
  }
  function y() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.value = E.replace(/(\r?\n|\r)$/g, "");
  }
  function v(E) {
    const F = this.resume(), G = this.stack[this.stack.length - 1];
    G.label = F, G.identifier = St(
      this.sliceSerialize(E)
    ).toLowerCase();
  }
  function C() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.title = E;
  }
  function O() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.url = E;
  }
  function A(E) {
    const F = this.stack[this.stack.length - 1];
    if (!F.depth) {
      const G = this.sliceSerialize(E).length;
      F.depth = G;
    }
  }
  function b() {
    this.data.setextHeadingSlurpLineEnding = !0;
  }
  function S(E) {
    const F = this.stack[this.stack.length - 1];
    F.depth = this.sliceSerialize(E).codePointAt(0) === 61 ? 1 : 2;
  }
  function L() {
    this.data.setextHeadingSlurpLineEnding = void 0;
  }
  function P(E) {
    const G = this.stack[this.stack.length - 1].children;
    let Z = G[G.length - 1];
    (!Z || Z.type !== "text") && (Z = Rm(), Z.position = {
      start: en(E.start),
      // @ts-expect-error: we’ll add `end` later.
      end: void 0
    }, G.push(Z)), this.stack.push(Z);
  }
  function k(E) {
    const F = this.stack.pop();
    F.value += this.sliceSerialize(E), F.position.end = en(E.end);
  }
  function M(E) {
    const F = this.stack[this.stack.length - 1];
    if (this.data.atHardBreak) {
      const G = F.children[F.children.length - 1];
      G.position.end = en(E.end), this.data.atHardBreak = void 0;
      return;
    }
    !this.data.setextHeadingSlurpLineEnding && e.canContainEols.includes(F.type) && (P.call(this, E), k.call(this, E));
  }
  function D() {
    this.data.atHardBreak = !0;
  }
  function R() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.value = E;
  }
  function _() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.value = E;
  }
  function z() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.value = E;
  }
  function K() {
    const E = this.stack[this.stack.length - 1];
    if (this.data.inReference) {
      const F = this.data.referenceType || "shortcut";
      E.type += "Reference", E.referenceType = F, delete E.url, delete E.title;
    } else
      delete E.identifier, delete E.label;
    this.data.referenceType = void 0;
  }
  function U() {
    const E = this.stack[this.stack.length - 1];
    if (this.data.inReference) {
      const F = this.data.referenceType || "shortcut";
      E.type += "Reference", E.referenceType = F, delete E.url, delete E.title;
    } else
      delete E.identifier, delete E.label;
    this.data.referenceType = void 0;
  }
  function ne(E) {
    const F = this.sliceSerialize(E), G = this.stack[this.stack.length - 2];
    G.label = av(F), G.identifier = St(F).toLowerCase();
  }
  function ue() {
    const E = this.stack[this.stack.length - 1], F = this.resume(), G = this.stack[this.stack.length - 1];
    if (this.data.inReference = !0, G.type === "link") {
      const Z = E.children;
      G.children = Z;
    } else
      G.alt = F;
  }
  function x() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.url = E;
  }
  function le() {
    const E = this.resume(), F = this.stack[this.stack.length - 1];
    F.title = E;
  }
  function me() {
    this.data.inReference = void 0;
  }
  function w() {
    this.data.referenceType = "collapsed";
  }
  function Se(E) {
    const F = this.resume(), G = this.stack[this.stack.length - 1];
    G.label = F, G.identifier = St(
      this.sliceSerialize(E)
    ).toLowerCase(), this.data.referenceType = "full";
  }
  function at(E) {
    this.data.characterReferenceType = E.type;
  }
  function Ce(E) {
    const F = this.sliceSerialize(E), G = this.data.characterReferenceType;
    let Z;
    G ? (Z = kp(
      F,
      G === "characterReferenceMarkerNumeric" ? 10 : 16
    ), this.data.characterReferenceType = void 0) : Z = Oa(F);
    const ae = this.stack.pop();
    ae.value += Z, ae.position.end = en(E.end);
  }
  function bi(E) {
    k.call(this, E);
    const F = this.stack[this.stack.length - 1];
    F.url = this.sliceSerialize(E);
  }
  function Zt(E) {
    k.call(this, E);
    const F = this.stack[this.stack.length - 1];
    F.url = "mailto:" + this.sliceSerialize(E);
  }
  function _n() {
    return {
      type: "blockquote",
      children: []
    };
  }
  function vn() {
    return {
      type: "code",
      lang: null,
      meta: null,
      value: ""
    };
  }
  function Zs() {
    return {
      type: "inlineCode",
      value: ""
    };
  }
  function Dm() {
    return {
      type: "definition",
      identifier: "",
      label: null,
      title: null,
      url: ""
    };
  }
  function Em() {
    return {
      type: "emphasis",
      children: []
    };
  }
  function Va() {
    return {
      type: "heading",
      // @ts-expect-error `depth` will be set later.
      depth: 0,
      children: []
    };
  }
  function _a() {
    return {
      type: "break"
    };
  }
  function $a() {
    return {
      type: "html",
      value: ""
    };
  }
  function Lm() {
    return {
      type: "image",
      title: null,
      url: "",
      alt: null
    };
  }
  function ja() {
    return {
      type: "link",
      title: null,
      url: "",
      children: []
    };
  }
  function Wa(E) {
    return {
      type: "list",
      ordered: E.type === "listOrdered",
      start: null,
      spread: E._spread,
      children: []
    };
  }
  function Im(E) {
    return {
      type: "listItem",
      spread: E._spread,
      checked: null,
      children: []
    };
  }
  function Pm() {
    return {
      type: "paragraph",
      children: []
    };
  }
  function Bm() {
    return {
      type: "strong",
      children: []
    };
  }
  function Rm() {
    return {
      type: "text",
      value: ""
    };
  }
  function Nm() {
    return {
      type: "thematicBreak"
    };
  }
}
function en(n) {
  return {
    line: n.line,
    column: n.column,
    offset: n.offset
  };
}
function Ip(n, e) {
  let t = -1;
  for (; ++t < e.length; ) {
    const i = e[t];
    Array.isArray(i) ? Ip(n, i) : fv(n, i);
  }
}
function fv(n, e) {
  let t;
  for (t in e)
    if (Lp.call(e, t))
      switch (t) {
        case "canContainEols": {
          const i = e[t];
          i && n[t].push(...i);
          break;
        }
        case "transforms": {
          const i = e[t];
          i && n[t].push(...i);
          break;
        }
        case "enter":
        case "exit": {
          const i = e[t];
          i && Object.assign(n[t], i);
          break;
        }
      }
}
function Xc(n, e) {
  throw n ? new Error(
    "Cannot close `" + n.type + "` (" + $i({
      start: n.start,
      end: n.end
    }) + "): a different token (`" + e.type + "`, " + $i({
      start: e.start,
      end: e.end
    }) + ") is open"
  ) : new Error(
    "Cannot close document, a token (`" + e.type + "`, " + $i({
      start: e.start,
      end: e.end
    }) + ") is still open"
  );
}
function dv(n) {
  const e = this;
  e.parser = t;
  function t(i) {
    return cv(i, {
      ...e.data("settings"),
      ...n,
      // Note: these options are not in the readme.
      // The goal is for them to be set by plugins on `data` instead of being
      // passed by users.
      extensions: e.data("micromarkExtensions") || [],
      mdastExtensions: e.data("fromMarkdownExtensions") || []
    });
  }
}
function pv(n, e) {
  const t = {
    type: "element",
    tagName: "blockquote",
    properties: {},
    children: n.wrap(n.all(e), !0)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function mv(n, e) {
  const t = { type: "element", tagName: "br", properties: {}, children: [] };
  return n.patch(e, t), [n.applyData(e, t), { type: "text", value: `
` }];
}
function gv(n, e) {
  const t = e.value ? e.value + `
` : "", i = {};
  e.lang && (i.className = ["language-" + e.lang]);
  let r = {
    type: "element",
    tagName: "code",
    properties: i,
    children: [{ type: "text", value: t }]
  };
  return e.meta && (r.data = { meta: e.meta }), n.patch(e, r), r = n.applyData(e, r), r = { type: "element", tagName: "pre", properties: {}, children: [r] }, n.patch(e, r), r;
}
function yv(n, e) {
  const t = {
    type: "element",
    tagName: "del",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function bv(n, e) {
  const t = {
    type: "element",
    tagName: "em",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function xv(n, e) {
  const t = typeof n.options.clobberPrefix == "string" ? n.options.clobberPrefix : "user-content-", i = String(e.identifier).toUpperCase(), r = gi(i.toLowerCase()), s = n.footnoteOrder.indexOf(i);
  let o, l = n.footnoteCounts.get(i);
  l === void 0 ? (l = 0, n.footnoteOrder.push(i), o = n.footnoteOrder.length) : o = s + 1, l += 1, n.footnoteCounts.set(i, l);
  const a = {
    type: "element",
    tagName: "a",
    properties: {
      href: "#" + t + "fn-" + r,
      id: t + "fnref-" + r + (l > 1 ? "-" + l : ""),
      dataFootnoteRef: !0,
      ariaDescribedBy: ["footnote-label"]
    },
    children: [{ type: "text", value: String(o) }]
  };
  n.patch(e, a);
  const u = {
    type: "element",
    tagName: "sup",
    properties: {},
    children: [a]
  };
  return n.patch(e, u), n.applyData(e, u);
}
function wv(n, e) {
  const t = {
    type: "element",
    tagName: "h" + e.depth,
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function kv(n, e) {
  if (n.options.allowDangerousHtml) {
    const t = { type: "raw", value: e.value };
    return n.patch(e, t), n.applyData(e, t);
  }
}
function Pp(n, e) {
  const t = e.referenceType;
  let i = "]";
  if (t === "collapsed" ? i += "[]" : t === "full" && (i += "[" + (e.label || e.identifier) + "]"), e.type === "imageReference")
    return [{ type: "text", value: "![" + e.alt + i }];
  const r = n.all(e), s = r[0];
  s && s.type === "text" ? s.value = "[" + s.value : r.unshift({ type: "text", value: "[" });
  const o = r[r.length - 1];
  return o && o.type === "text" ? o.value += i : r.push({ type: "text", value: i }), r;
}
function vv(n, e) {
  const t = String(e.identifier).toUpperCase(), i = n.definitionById.get(t);
  if (!i)
    return Pp(n, e);
  const r = { src: gi(i.url || ""), alt: e.alt };
  i.title !== null && i.title !== void 0 && (r.title = i.title);
  const s = { type: "element", tagName: "img", properties: r, children: [] };
  return n.patch(e, s), n.applyData(e, s);
}
function Sv(n, e) {
  const t = { src: gi(e.url) };
  e.alt !== null && e.alt !== void 0 && (t.alt = e.alt), e.title !== null && e.title !== void 0 && (t.title = e.title);
  const i = { type: "element", tagName: "img", properties: t, children: [] };
  return n.patch(e, i), n.applyData(e, i);
}
function Cv(n, e) {
  const t = { type: "text", value: e.value.replace(/\r?\n|\r/g, " ") };
  n.patch(e, t);
  const i = {
    type: "element",
    tagName: "code",
    properties: {},
    children: [t]
  };
  return n.patch(e, i), n.applyData(e, i);
}
function Av(n, e) {
  const t = String(e.identifier).toUpperCase(), i = n.definitionById.get(t);
  if (!i)
    return Pp(n, e);
  const r = { href: gi(i.url || "") };
  i.title !== null && i.title !== void 0 && (r.title = i.title);
  const s = {
    type: "element",
    tagName: "a",
    properties: r,
    children: n.all(e)
  };
  return n.patch(e, s), n.applyData(e, s);
}
function Mv(n, e) {
  const t = { href: gi(e.url) };
  e.title !== null && e.title !== void 0 && (t.title = e.title);
  const i = {
    type: "element",
    tagName: "a",
    properties: t,
    children: n.all(e)
  };
  return n.patch(e, i), n.applyData(e, i);
}
function Tv(n, e, t) {
  const i = n.all(e), r = t ? Ov(t) : Bp(e), s = {}, o = [];
  if (typeof e.checked == "boolean") {
    const c = i[0];
    let h;
    c && c.type === "element" && c.tagName === "p" ? h = c : (h = { type: "element", tagName: "p", properties: {}, children: [] }, i.unshift(h)), h.children.length > 0 && h.children.unshift({ type: "text", value: " " }), h.children.unshift({
      type: "element",
      tagName: "input",
      properties: { type: "checkbox", checked: e.checked, disabled: !0 },
      children: []
    }), s.className = ["task-list-item"];
  }
  let l = -1;
  for (; ++l < i.length; ) {
    const c = i[l];
    (r || l !== 0 || c.type !== "element" || c.tagName !== "p") && o.push({ type: "text", value: `
` }), c.type === "element" && c.tagName === "p" && !r ? o.push(...c.children) : o.push(c);
  }
  const a = i[i.length - 1];
  a && (r || a.type !== "element" || a.tagName !== "p") && o.push({ type: "text", value: `
` });
  const u = { type: "element", tagName: "li", properties: s, children: o };
  return n.patch(e, u), n.applyData(e, u);
}
function Ov(n) {
  let e = !1;
  if (n.type === "list") {
    e = n.spread || !1;
    const t = n.children;
    let i = -1;
    for (; !e && ++i < t.length; )
      e = Bp(t[i]);
  }
  return e;
}
function Bp(n) {
  const e = n.spread;
  return e ?? n.children.length > 1;
}
function Dv(n, e) {
  const t = {}, i = n.all(e);
  let r = -1;
  for (typeof e.start == "number" && e.start !== 1 && (t.start = e.start); ++r < i.length; ) {
    const o = i[r];
    if (o.type === "element" && o.tagName === "li" && o.properties && Array.isArray(o.properties.className) && o.properties.className.includes("task-list-item")) {
      t.className = ["contains-task-list"];
      break;
    }
  }
  const s = {
    type: "element",
    tagName: e.ordered ? "ol" : "ul",
    properties: t,
    children: n.wrap(i, !0)
  };
  return n.patch(e, s), n.applyData(e, s);
}
function Ev(n, e) {
  const t = {
    type: "element",
    tagName: "p",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
function Lv(n, e) {
  const t = { type: "root", children: n.wrap(n.all(e)) };
  return n.patch(e, t), n.applyData(e, t);
}
function Iv(n, e) {
  const t = {
    type: "element",
    tagName: "strong",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
const Rp = Fp("end"), Np = Fp("start");
function Fp(n) {
  return e;
  function e(t) {
    const i = t && t.position && t.position[n] || {};
    if (typeof i.line == "number" && i.line > 0 && typeof i.column == "number" && i.column > 0)
      return {
        line: i.line,
        column: i.column,
        offset: typeof i.offset == "number" && i.offset > -1 ? i.offset : void 0
      };
  }
}
function Pv(n) {
  const e = Np(n), t = Rp(n);
  if (e && t)
    return { start: e, end: t };
}
function Bv(n, e) {
  const t = n.all(e), i = t.shift(), r = [];
  if (i) {
    const o = {
      type: "element",
      tagName: "thead",
      properties: {},
      children: n.wrap([i], !0)
    };
    n.patch(e.children[0], o), r.push(o);
  }
  if (t.length > 0) {
    const o = {
      type: "element",
      tagName: "tbody",
      properties: {},
      children: n.wrap(t, !0)
    }, l = Np(e.children[1]), a = Rp(e.children[e.children.length - 1]);
    l && a && (o.position = { start: l, end: a }), r.push(o);
  }
  const s = {
    type: "element",
    tagName: "table",
    properties: {},
    children: n.wrap(r, !0)
  };
  return n.patch(e, s), n.applyData(e, s);
}
function Rv(n, e, t) {
  const i = t ? t.children : void 0, s = (i ? i.indexOf(e) : 1) === 0 ? "th" : "td", o = t && t.type === "table" ? t.align : void 0, l = o ? o.length : e.children.length;
  let a = -1;
  const u = [];
  for (; ++a < l; ) {
    const h = e.children[a], f = {}, d = o ? o[a] : void 0;
    d && (f.align = d);
    let p = { type: "element", tagName: s, properties: f, children: [] };
    h && (p.children = n.all(h), n.patch(h, p), p = n.applyData(h, p)), u.push(p);
  }
  const c = {
    type: "element",
    tagName: "tr",
    properties: {},
    children: n.wrap(u, !0)
  };
  return n.patch(e, c), n.applyData(e, c);
}
function Nv(n, e) {
  const t = {
    type: "element",
    tagName: "td",
    // Assume body cell.
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, t), n.applyData(e, t);
}
const Jc = 9, Qc = 32;
function Fv(n) {
  const e = String(n), t = /\r?\n|\r/g;
  let i = t.exec(e), r = 0;
  const s = [];
  for (; i; )
    s.push(
      Zc(e.slice(r, i.index), r > 0, !0),
      i[0]
    ), r = i.index + i[0].length, i = t.exec(e);
  return s.push(Zc(e.slice(r), r > 0, !1)), s.join("");
}
function Zc(n, e, t) {
  let i = 0, r = n.length;
  if (e) {
    let s = n.codePointAt(i);
    for (; s === Jc || s === Qc; )
      i++, s = n.codePointAt(i);
  }
  if (t) {
    let s = n.codePointAt(r - 1);
    for (; s === Jc || s === Qc; )
      r--, s = n.codePointAt(r - 1);
  }
  return r > i ? n.slice(i, r) : "";
}
function zv(n, e) {
  const t = { type: "text", value: Fv(String(e.value)) };
  return n.patch(e, t), n.applyData(e, t);
}
function Hv(n, e) {
  const t = {
    type: "element",
    tagName: "hr",
    properties: {},
    children: []
  };
  return n.patch(e, t), n.applyData(e, t);
}
const Vv = {
  blockquote: pv,
  break: mv,
  code: gv,
  delete: yv,
  emphasis: bv,
  footnoteReference: xv,
  heading: wv,
  html: kv,
  imageReference: vv,
  image: Sv,
  inlineCode: Cv,
  linkReference: Av,
  link: Mv,
  listItem: Tv,
  list: Dv,
  paragraph: Ev,
  // @ts-expect-error: root is different, but hard to type.
  root: Lv,
  strong: Iv,
  table: Bv,
  tableCell: Nv,
  tableRow: Rv,
  text: zv,
  thematicBreak: Hv,
  toml: zr,
  yaml: zr,
  definition: zr,
  footnoteDefinition: zr
};
function zr() {
}
const zp = -1, Xs = 0, Ts = 1, Os = 2, Ea = 3, La = 4, Ia = 5, Pa = 6, Hp = 7, Vp = 8, eh = typeof self == "object" ? self : globalThis, _v = (n, e) => {
  const t = (r, s) => (n.set(s, r), r), i = (r) => {
    if (n.has(r))
      return n.get(r);
    const [s, o] = e[r];
    switch (s) {
      case Xs:
      case zp:
        return t(o, r);
      case Ts: {
        const l = t([], r);
        for (const a of o)
          l.push(i(a));
        return l;
      }
      case Os: {
        const l = t({}, r);
        for (const [a, u] of o)
          l[i(a)] = i(u);
        return l;
      }
      case Ea:
        return t(new Date(o), r);
      case La: {
        const { source: l, flags: a } = o;
        return t(new RegExp(l, a), r);
      }
      case Ia: {
        const l = t(/* @__PURE__ */ new Map(), r);
        for (const [a, u] of o)
          l.set(i(a), i(u));
        return l;
      }
      case Pa: {
        const l = t(/* @__PURE__ */ new Set(), r);
        for (const a of o)
          l.add(i(a));
        return l;
      }
      case Hp: {
        const { name: l, message: a } = o;
        return t(new eh[l](a), r);
      }
      case Vp:
        return t(BigInt(o), r);
      case "BigInt":
        return t(Object(BigInt(o)), r);
    }
    return t(new eh[s](o), r);
  };
  return i;
}, th = (n) => _v(/* @__PURE__ */ new Map(), n)(0), Wn = "", { toString: $v } = {}, { keys: jv } = Object, Oi = (n) => {
  const e = typeof n;
  if (e !== "object" || !n)
    return [Xs, e];
  const t = $v.call(n).slice(8, -1);
  switch (t) {
    case "Array":
      return [Ts, Wn];
    case "Object":
      return [Os, Wn];
    case "Date":
      return [Ea, Wn];
    case "RegExp":
      return [La, Wn];
    case "Map":
      return [Ia, Wn];
    case "Set":
      return [Pa, Wn];
  }
  return t.includes("Array") ? [Ts, t] : t.includes("Error") ? [Hp, t] : [Os, t];
}, Hr = ([n, e]) => n === Xs && (e === "function" || e === "symbol"), Wv = (n, e, t, i) => {
  const r = (o, l) => {
    const a = i.push(o) - 1;
    return t.set(l, a), a;
  }, s = (o) => {
    if (t.has(o))
      return t.get(o);
    let [l, a] = Oi(o);
    switch (l) {
      case Xs: {
        let c = o;
        switch (a) {
          case "bigint":
            l = Vp, c = o.toString();
            break;
          case "function":
          case "symbol":
            if (n)
              throw new TypeError("unable to serialize " + a);
            c = null;
            break;
          case "undefined":
            return r([zp], o);
        }
        return r([l, c], o);
      }
      case Ts: {
        if (a)
          return r([a, [...o]], o);
        const c = [], h = r([l, c], o);
        for (const f of o)
          c.push(s(f));
        return h;
      }
      case Os: {
        if (a)
          switch (a) {
            case "BigInt":
              return r([a, o.toString()], o);
            case "Boolean":
            case "Number":
            case "String":
              return r([a, o.valueOf()], o);
          }
        if (e && "toJSON" in o)
          return s(o.toJSON());
        const c = [], h = r([l, c], o);
        for (const f of jv(o))
          (n || !Hr(Oi(o[f]))) && c.push([s(f), s(o[f])]);
        return h;
      }
      case Ea:
        return r([l, o.toISOString()], o);
      case La: {
        const { source: c, flags: h } = o;
        return r([l, { source: c, flags: h }], o);
      }
      case Ia: {
        const c = [], h = r([l, c], o);
        for (const [f, d] of o)
          (n || !(Hr(Oi(f)) || Hr(Oi(d)))) && c.push([s(f), s(d)]);
        return h;
      }
      case Pa: {
        const c = [], h = r([l, c], o);
        for (const f of o)
          (n || !Hr(Oi(f))) && c.push(s(f));
        return h;
      }
    }
    const { message: u } = o;
    return r([l, { name: a, message: u }], o);
  };
  return s;
}, nh = (n, { json: e, lossy: t } = {}) => {
  const i = [];
  return Wv(!(e || t), !!e, /* @__PURE__ */ new Map(), i)(n), i;
}, Ds = typeof structuredClone == "function" ? (
  /* c8 ignore start */
  (n, e) => e && ("json" in e || "lossy" in e) ? th(nh(n, e)) : structuredClone(n)
) : (n, e) => th(nh(n, e));
function qv(n, e) {
  const t = [{ type: "text", value: "↩" }];
  return e > 1 && t.push({
    type: "element",
    tagName: "sup",
    properties: {},
    children: [{ type: "text", value: String(e) }]
  }), t;
}
function Uv(n, e) {
  return "Back to reference " + (n + 1) + (e > 1 ? "-" + e : "");
}
function Kv(n) {
  const e = typeof n.options.clobberPrefix == "string" ? n.options.clobberPrefix : "user-content-", t = n.options.footnoteBackContent || qv, i = n.options.footnoteBackLabel || Uv, r = n.options.footnoteLabel || "Footnotes", s = n.options.footnoteLabelTagName || "h2", o = n.options.footnoteLabelProperties || {
    className: ["sr-only"]
  }, l = [];
  let a = -1;
  for (; ++a < n.footnoteOrder.length; ) {
    const u = n.footnoteById.get(n.footnoteOrder[a]);
    if (!u)
      continue;
    const c = n.all(u), h = String(u.identifier).toUpperCase(), f = gi(h.toLowerCase());
    let d = 0;
    const p = [], g = n.footnoteCounts.get(h);
    for (; g !== void 0 && ++d <= g; ) {
      p.length > 0 && p.push({ type: "text", value: " " });
      let v = typeof t == "string" ? t : t(a, d);
      typeof v == "string" && (v = { type: "text", value: v }), p.push({
        type: "element",
        tagName: "a",
        properties: {
          href: "#" + e + "fnref-" + f + (d > 1 ? "-" + d : ""),
          dataFootnoteBackref: "",
          ariaLabel: typeof i == "string" ? i : i(a, d),
          className: ["data-footnote-backref"]
        },
        children: Array.isArray(v) ? v : [v]
      });
    }
    const m = c[c.length - 1];
    if (m && m.type === "element" && m.tagName === "p") {
      const v = m.children[m.children.length - 1];
      v && v.type === "text" ? v.value += " " : m.children.push({ type: "text", value: " " }), m.children.push(...p);
    } else
      c.push(...p);
    const y = {
      type: "element",
      tagName: "li",
      properties: { id: e + "fn-" + f },
      children: n.wrap(c, !0)
    };
    n.patch(u, y), l.push(y);
  }
  if (l.length !== 0)
    return {
      type: "element",
      tagName: "section",
      properties: { dataFootnotes: !0, className: ["footnotes"] },
      children: [
        {
          type: "element",
          tagName: s,
          properties: {
            ...Ds(o),
            id: "footnote-label"
          },
          children: [{ type: "text", value: r }]
        },
        { type: "text", value: `
` },
        {
          type: "element",
          tagName: "ol",
          properties: {},
          children: n.wrap(l, !0)
        },
        { type: "text", value: `
` }
      ]
    };
}
const Js = (
  // Note: overloads in JSDoc can’t yet use different `@template`s.
  /**
   * @type {(
   *   (<Condition extends string>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & {type: Condition}) &
   *   (<Condition extends Props>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Condition) &
   *   (<Condition extends TestFunction>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Predicate<Condition, Node>) &
   *   ((test?: null | undefined) => (node?: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node) &
   *   ((test?: Test) => Check)
   * )}
   */
  /**
   * @param {Test} [test]
   * @returns {Check}
   */
  function(n) {
    if (n == null)
      return Jv;
    if (typeof n == "function")
      return Qs(n);
    if (typeof n == "object")
      return Array.isArray(n) ? Gv(n) : Yv(n);
    if (typeof n == "string")
      return Xv(n);
    throw new Error("Expected function, string, or object as test");
  }
);
function Gv(n) {
  const e = [];
  let t = -1;
  for (; ++t < n.length; )
    e[t] = Js(n[t]);
  return Qs(i);
  function i(...r) {
    let s = -1;
    for (; ++s < e.length; )
      if (e[s].apply(this, r))
        return !0;
    return !1;
  }
}
function Yv(n) {
  const e = (
    /** @type {Record<string, unknown>} */
    n
  );
  return Qs(t);
  function t(i) {
    const r = (
      /** @type {Record<string, unknown>} */
      /** @type {unknown} */
      i
    );
    let s;
    for (s in n)
      if (r[s] !== e[s])
        return !1;
    return !0;
  }
}
function Xv(n) {
  return Qs(e);
  function e(t) {
    return t && t.type === n;
  }
}
function Qs(n) {
  return e;
  function e(t, i, r) {
    return !!(Qv(t) && n.call(
      this,
      t,
      typeof i == "number" ? i : void 0,
      r || void 0
    ));
  }
}
function Jv() {
  return !0;
}
function Qv(n) {
  return n !== null && typeof n == "object" && "type" in n;
}
const _p = [], Zv = !0, Wl = !1, eS = "skip";
function $p(n, e, t, i) {
  let r;
  typeof e == "function" && typeof t != "function" ? (i = t, t = e) : r = e;
  const s = Js(r), o = i ? -1 : 1;
  l(n, void 0, [])();
  function l(a, u, c) {
    const h = (
      /** @type {Record<string, unknown>} */
      a && typeof a == "object" ? a : {}
    );
    if (typeof h.type == "string") {
      const d = (
        // `hast`
        typeof h.tagName == "string" ? h.tagName : (
          // `xast`
          typeof h.name == "string" ? h.name : void 0
        )
      );
      Object.defineProperty(f, "name", {
        value: "node (" + (a.type + (d ? "<" + d + ">" : "")) + ")"
      });
    }
    return f;
    function f() {
      let d = _p, p, g, m;
      if ((!e || s(a, u, c[c.length - 1] || void 0)) && (d = tS(t(a, c)), d[0] === Wl))
        return d;
      if ("children" in a && a.children) {
        const y = (
          /** @type {UnistParent} */
          a
        );
        if (y.children && d[0] !== eS)
          for (g = (i ? y.children.length : -1) + o, m = c.concat(y); g > -1 && g < y.children.length; ) {
            const v = y.children[g];
            if (p = l(v, g, m)(), p[0] === Wl)
              return p;
            g = typeof p[1] == "number" ? p[1] : g + o;
          }
      }
      return d;
    }
  }
}
function tS(n) {
  return Array.isArray(n) ? n : typeof n == "number" ? [Zv, n] : n == null ? _p : [n];
}
function jp(n, e, t, i) {
  let r, s, o;
  typeof e == "function" && typeof t != "function" ? (s = void 0, o = e, r = t) : (s = e, o = t, r = i), $p(n, s, l, r);
  function l(a, u) {
    const c = u[u.length - 1], h = c ? c.children.indexOf(a) : void 0;
    return o(a, h, c);
  }
}
const ql = {}.hasOwnProperty, nS = {};
function iS(n, e) {
  const t = e || nS, i = /* @__PURE__ */ new Map(), r = /* @__PURE__ */ new Map(), s = /* @__PURE__ */ new Map(), o = { ...Vv, ...t.handlers }, l = {
    all: u,
    applyData: sS,
    definitionById: i,
    footnoteById: r,
    footnoteCounts: s,
    footnoteOrder: [],
    handlers: o,
    one: a,
    options: t,
    patch: rS,
    wrap: lS
  };
  return jp(n, function(c) {
    if (c.type === "definition" || c.type === "footnoteDefinition") {
      const h = c.type === "definition" ? i : r, f = String(c.identifier).toUpperCase();
      h.has(f) || h.set(f, c);
    }
  }), l;
  function a(c, h) {
    const f = c.type, d = l.handlers[f];
    if (ql.call(l.handlers, f) && d)
      return d(l, c, h);
    if (l.options.passThrough && l.options.passThrough.includes(f)) {
      if ("children" in c) {
        const { children: g, ...m } = c, y = Ds(m);
        return y.children = l.all(c), y;
      }
      return Ds(c);
    }
    return (l.options.unknownHandler || oS)(l, c, h);
  }
  function u(c) {
    const h = [];
    if ("children" in c) {
      const f = c.children;
      let d = -1;
      for (; ++d < f.length; ) {
        const p = l.one(f[d], c);
        if (p) {
          if (d && f[d - 1].type === "break" && (!Array.isArray(p) && p.type === "text" && (p.value = ih(p.value)), !Array.isArray(p) && p.type === "element")) {
            const g = p.children[0];
            g && g.type === "text" && (g.value = ih(g.value));
          }
          Array.isArray(p) ? h.push(...p) : h.push(p);
        }
      }
    }
    return h;
  }
}
function rS(n, e) {
  n.position && (e.position = Pv(n));
}
function sS(n, e) {
  let t = e;
  if (n && n.data) {
    const i = n.data.hName, r = n.data.hChildren, s = n.data.hProperties;
    if (typeof i == "string")
      if (t.type === "element")
        t.tagName = i;
      else {
        const o = "children" in t ? t.children : [t];
        t = { type: "element", tagName: i, properties: {}, children: o };
      }
    t.type === "element" && s && Object.assign(t.properties, Ds(s)), "children" in t && t.children && r !== null && r !== void 0 && (t.children = r);
  }
  return t;
}
function oS(n, e) {
  const t = e.data || {}, i = "value" in e && !(ql.call(t, "hProperties") || ql.call(t, "hChildren")) ? { type: "text", value: e.value } : {
    type: "element",
    tagName: "div",
    properties: {},
    children: n.all(e)
  };
  return n.patch(e, i), n.applyData(e, i);
}
function lS(n, e) {
  const t = [];
  let i = -1;
  for (e && t.push({ type: "text", value: `
` }); ++i < n.length; )
    i && t.push({ type: "text", value: `
` }), t.push(n[i]);
  return e && n.length > 0 && t.push({ type: "text", value: `
` }), t;
}
function ih(n) {
  let e = 0, t = n.charCodeAt(e);
  for (; t === 9 || t === 32; )
    e++, t = n.charCodeAt(e);
  return n.slice(e);
}
function rh(n, e) {
  const t = iS(n, e), i = t.one(n, void 0), r = Kv(t), s = Array.isArray(i) ? { type: "root", children: i } : i || { type: "root", children: [] };
  return r && s.children.push({ type: "text", value: `
` }, r), s;
}
function aS(n, e) {
  return n && "run" in n ? async function(t, i) {
    const r = (
      /** @type {HastRoot} */
      rh(t, { file: i, ...e })
    );
    await n.run(r, i);
  } : function(t, i) {
    return (
      /** @type {HastRoot} */
      rh(t, { file: i, ...e || n })
    );
  };
}
const uS = [
  "area",
  "base",
  "basefont",
  "bgsound",
  "br",
  "col",
  "command",
  "embed",
  "frame",
  "hr",
  "image",
  "img",
  "input",
  "keygen",
  "link",
  "meta",
  "param",
  "source",
  "track",
  "wbr"
];
class fr {
  /**
   * @constructor
   * @param {Properties} property
   * @param {Normal} normal
   * @param {string} [space]
   */
  constructor(e, t, i) {
    this.property = e, this.normal = t, i && (this.space = i);
  }
}
fr.prototype.property = {};
fr.prototype.normal = {};
fr.prototype.space = null;
function Wp(n, e) {
  const t = {}, i = {};
  let r = -1;
  for (; ++r < n.length; )
    Object.assign(t, n[r].property), Object.assign(i, n[r].normal);
  return new fr(t, i, e);
}
function Ul(n) {
  return n.toLowerCase();
}
class kt {
  /**
   * @constructor
   * @param {string} property
   * @param {string} attribute
   */
  constructor(e, t) {
    this.property = e, this.attribute = t;
  }
}
kt.prototype.space = null;
kt.prototype.boolean = !1;
kt.prototype.booleanish = !1;
kt.prototype.overloadedBoolean = !1;
kt.prototype.number = !1;
kt.prototype.commaSeparated = !1;
kt.prototype.spaceSeparated = !1;
kt.prototype.commaOrSpaceSeparated = !1;
kt.prototype.mustUseProperty = !1;
kt.prototype.defined = !1;
let cS = 0;
const Y = Vn(), Ae = Vn(), qp = Vn(), B = Vn(), de = Vn(), ii = Vn(), nt = Vn();
function Vn() {
  return 2 ** ++cS;
}
const Kl = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  boolean: Y,
  booleanish: Ae,
  commaOrSpaceSeparated: nt,
  commaSeparated: ii,
  number: B,
  overloadedBoolean: qp,
  spaceSeparated: de
}, Symbol.toStringTag, { value: "Module" })), Ro = Object.keys(Kl);
class Ba extends kt {
  /**
   * @constructor
   * @param {string} property
   * @param {string} attribute
   * @param {number|null} [mask]
   * @param {string} [space]
   */
  constructor(e, t, i, r) {
    let s = -1;
    if (super(e, t), sh(this, "space", r), typeof i == "number")
      for (; ++s < Ro.length; ) {
        const o = Ro[s];
        sh(this, Ro[s], (i & Kl[o]) === Kl[o]);
      }
  }
}
Ba.prototype.defined = !0;
function sh(n, e, t) {
  t && (n[e] = t);
}
const hS = {}.hasOwnProperty;
function yi(n) {
  const e = {}, t = {};
  let i;
  for (i in n.properties)
    if (hS.call(n.properties, i)) {
      const r = n.properties[i], s = new Ba(
        i,
        n.transform(n.attributes || {}, i),
        r,
        n.space
      );
      n.mustUseProperty && n.mustUseProperty.includes(i) && (s.mustUseProperty = !0), e[i] = s, t[Ul(i)] = i, t[Ul(s.attribute)] = i;
    }
  return new fr(e, t, n.space);
}
const Up = yi({
  space: "xlink",
  transform(n, e) {
    return "xlink:" + e.slice(5).toLowerCase();
  },
  properties: {
    xLinkActuate: null,
    xLinkArcRole: null,
    xLinkHref: null,
    xLinkRole: null,
    xLinkShow: null,
    xLinkTitle: null,
    xLinkType: null
  }
}), Kp = yi({
  space: "xml",
  transform(n, e) {
    return "xml:" + e.slice(3).toLowerCase();
  },
  properties: { xmlLang: null, xmlBase: null, xmlSpace: null }
});
function Gp(n, e) {
  return e in n ? n[e] : e;
}
function Yp(n, e) {
  return Gp(n, e.toLowerCase());
}
const Xp = yi({
  space: "xmlns",
  attributes: { xmlnsxlink: "xmlns:xlink" },
  transform: Yp,
  properties: { xmlns: null, xmlnsXLink: null }
}), Jp = yi({
  transform(n, e) {
    return e === "role" ? e : "aria-" + e.slice(4).toLowerCase();
  },
  properties: {
    ariaActiveDescendant: null,
    ariaAtomic: Ae,
    ariaAutoComplete: null,
    ariaBusy: Ae,
    ariaChecked: Ae,
    ariaColCount: B,
    ariaColIndex: B,
    ariaColSpan: B,
    ariaControls: de,
    ariaCurrent: null,
    ariaDescribedBy: de,
    ariaDetails: null,
    ariaDisabled: Ae,
    ariaDropEffect: de,
    ariaErrorMessage: null,
    ariaExpanded: Ae,
    ariaFlowTo: de,
    ariaGrabbed: Ae,
    ariaHasPopup: null,
    ariaHidden: Ae,
    ariaInvalid: null,
    ariaKeyShortcuts: null,
    ariaLabel: null,
    ariaLabelledBy: de,
    ariaLevel: B,
    ariaLive: null,
    ariaModal: Ae,
    ariaMultiLine: Ae,
    ariaMultiSelectable: Ae,
    ariaOrientation: null,
    ariaOwns: de,
    ariaPlaceholder: null,
    ariaPosInSet: B,
    ariaPressed: Ae,
    ariaReadOnly: Ae,
    ariaRelevant: null,
    ariaRequired: Ae,
    ariaRoleDescription: de,
    ariaRowCount: B,
    ariaRowIndex: B,
    ariaRowSpan: B,
    ariaSelected: Ae,
    ariaSetSize: B,
    ariaSort: null,
    ariaValueMax: B,
    ariaValueMin: B,
    ariaValueNow: B,
    ariaValueText: null,
    role: null
  }
}), fS = yi({
  space: "html",
  attributes: {
    acceptcharset: "accept-charset",
    classname: "class",
    htmlfor: "for",
    httpequiv: "http-equiv"
  },
  transform: Yp,
  mustUseProperty: ["checked", "multiple", "muted", "selected"],
  properties: {
    // Standard Properties.
    abbr: null,
    accept: ii,
    acceptCharset: de,
    accessKey: de,
    action: null,
    allow: null,
    allowFullScreen: Y,
    allowPaymentRequest: Y,
    allowUserMedia: Y,
    alt: null,
    as: null,
    async: Y,
    autoCapitalize: null,
    autoComplete: de,
    autoFocus: Y,
    autoPlay: Y,
    blocking: de,
    capture: null,
    charSet: null,
    checked: Y,
    cite: null,
    className: de,
    cols: B,
    colSpan: null,
    content: null,
    contentEditable: Ae,
    controls: Y,
    controlsList: de,
    coords: B | ii,
    crossOrigin: null,
    data: null,
    dateTime: null,
    decoding: null,
    default: Y,
    defer: Y,
    dir: null,
    dirName: null,
    disabled: Y,
    download: qp,
    draggable: Ae,
    encType: null,
    enterKeyHint: null,
    fetchPriority: null,
    form: null,
    formAction: null,
    formEncType: null,
    formMethod: null,
    formNoValidate: Y,
    formTarget: null,
    headers: de,
    height: B,
    hidden: Y,
    high: B,
    href: null,
    hrefLang: null,
    htmlFor: de,
    httpEquiv: de,
    id: null,
    imageSizes: null,
    imageSrcSet: null,
    inert: Y,
    inputMode: null,
    integrity: null,
    is: null,
    isMap: Y,
    itemId: null,
    itemProp: de,
    itemRef: de,
    itemScope: Y,
    itemType: de,
    kind: null,
    label: null,
    lang: null,
    language: null,
    list: null,
    loading: null,
    loop: Y,
    low: B,
    manifest: null,
    max: null,
    maxLength: B,
    media: null,
    method: null,
    min: null,
    minLength: B,
    multiple: Y,
    muted: Y,
    name: null,
    nonce: null,
    noModule: Y,
    noValidate: Y,
    onAbort: null,
    onAfterPrint: null,
    onAuxClick: null,
    onBeforeMatch: null,
    onBeforePrint: null,
    onBeforeToggle: null,
    onBeforeUnload: null,
    onBlur: null,
    onCancel: null,
    onCanPlay: null,
    onCanPlayThrough: null,
    onChange: null,
    onClick: null,
    onClose: null,
    onContextLost: null,
    onContextMenu: null,
    onContextRestored: null,
    onCopy: null,
    onCueChange: null,
    onCut: null,
    onDblClick: null,
    onDrag: null,
    onDragEnd: null,
    onDragEnter: null,
    onDragExit: null,
    onDragLeave: null,
    onDragOver: null,
    onDragStart: null,
    onDrop: null,
    onDurationChange: null,
    onEmptied: null,
    onEnded: null,
    onError: null,
    onFocus: null,
    onFormData: null,
    onHashChange: null,
    onInput: null,
    onInvalid: null,
    onKeyDown: null,
    onKeyPress: null,
    onKeyUp: null,
    onLanguageChange: null,
    onLoad: null,
    onLoadedData: null,
    onLoadedMetadata: null,
    onLoadEnd: null,
    onLoadStart: null,
    onMessage: null,
    onMessageError: null,
    onMouseDown: null,
    onMouseEnter: null,
    onMouseLeave: null,
    onMouseMove: null,
    onMouseOut: null,
    onMouseOver: null,
    onMouseUp: null,
    onOffline: null,
    onOnline: null,
    onPageHide: null,
    onPageShow: null,
    onPaste: null,
    onPause: null,
    onPlay: null,
    onPlaying: null,
    onPopState: null,
    onProgress: null,
    onRateChange: null,
    onRejectionHandled: null,
    onReset: null,
    onResize: null,
    onScroll: null,
    onScrollEnd: null,
    onSecurityPolicyViolation: null,
    onSeeked: null,
    onSeeking: null,
    onSelect: null,
    onSlotChange: null,
    onStalled: null,
    onStorage: null,
    onSubmit: null,
    onSuspend: null,
    onTimeUpdate: null,
    onToggle: null,
    onUnhandledRejection: null,
    onUnload: null,
    onVolumeChange: null,
    onWaiting: null,
    onWheel: null,
    open: Y,
    optimum: B,
    pattern: null,
    ping: de,
    placeholder: null,
    playsInline: Y,
    popover: null,
    popoverTarget: null,
    popoverTargetAction: null,
    poster: null,
    preload: null,
    readOnly: Y,
    referrerPolicy: null,
    rel: de,
    required: Y,
    reversed: Y,
    rows: B,
    rowSpan: B,
    sandbox: de,
    scope: null,
    scoped: Y,
    seamless: Y,
    selected: Y,
    shadowRootClonable: Y,
    shadowRootDelegatesFocus: Y,
    shadowRootMode: null,
    shape: null,
    size: B,
    sizes: null,
    slot: null,
    span: B,
    spellCheck: Ae,
    src: null,
    srcDoc: null,
    srcLang: null,
    srcSet: null,
    start: B,
    step: null,
    style: null,
    tabIndex: B,
    target: null,
    title: null,
    translate: null,
    type: null,
    typeMustMatch: Y,
    useMap: null,
    value: Ae,
    width: B,
    wrap: null,
    writingSuggestions: null,
    // Legacy.
    // See: https://html.spec.whatwg.org/#other-elements,-attributes-and-apis
    align: null,
    // Several. Use CSS `text-align` instead,
    aLink: null,
    // `<body>`. Use CSS `a:active {color}` instead
    archive: de,
    // `<object>`. List of URIs to archives
    axis: null,
    // `<td>` and `<th>`. Use `scope` on `<th>`
    background: null,
    // `<body>`. Use CSS `background-image` instead
    bgColor: null,
    // `<body>` and table elements. Use CSS `background-color` instead
    border: B,
    // `<table>`. Use CSS `border-width` instead,
    borderColor: null,
    // `<table>`. Use CSS `border-color` instead,
    bottomMargin: B,
    // `<body>`
    cellPadding: null,
    // `<table>`
    cellSpacing: null,
    // `<table>`
    char: null,
    // Several table elements. When `align=char`, sets the character to align on
    charOff: null,
    // Several table elements. When `char`, offsets the alignment
    classId: null,
    // `<object>`
    clear: null,
    // `<br>`. Use CSS `clear` instead
    code: null,
    // `<object>`
    codeBase: null,
    // `<object>`
    codeType: null,
    // `<object>`
    color: null,
    // `<font>` and `<hr>`. Use CSS instead
    compact: Y,
    // Lists. Use CSS to reduce space between items instead
    declare: Y,
    // `<object>`
    event: null,
    // `<script>`
    face: null,
    // `<font>`. Use CSS instead
    frame: null,
    // `<table>`
    frameBorder: null,
    // `<iframe>`. Use CSS `border` instead
    hSpace: B,
    // `<img>` and `<object>`
    leftMargin: B,
    // `<body>`
    link: null,
    // `<body>`. Use CSS `a:link {color: *}` instead
    longDesc: null,
    // `<frame>`, `<iframe>`, and `<img>`. Use an `<a>`
    lowSrc: null,
    // `<img>`. Use a `<picture>`
    marginHeight: B,
    // `<body>`
    marginWidth: B,
    // `<body>`
    noResize: Y,
    // `<frame>`
    noHref: Y,
    // `<area>`. Use no href instead of an explicit `nohref`
    noShade: Y,
    // `<hr>`. Use background-color and height instead of borders
    noWrap: Y,
    // `<td>` and `<th>`
    object: null,
    // `<applet>`
    profile: null,
    // `<head>`
    prompt: null,
    // `<isindex>`
    rev: null,
    // `<link>`
    rightMargin: B,
    // `<body>`
    rules: null,
    // `<table>`
    scheme: null,
    // `<meta>`
    scrolling: Ae,
    // `<frame>`. Use overflow in the child context
    standby: null,
    // `<object>`
    summary: null,
    // `<table>`
    text: null,
    // `<body>`. Use CSS `color` instead
    topMargin: B,
    // `<body>`
    valueType: null,
    // `<param>`
    version: null,
    // `<html>`. Use a doctype.
    vAlign: null,
    // Several. Use CSS `vertical-align` instead
    vLink: null,
    // `<body>`. Use CSS `a:visited {color}` instead
    vSpace: B,
    // `<img>` and `<object>`
    // Non-standard Properties.
    allowTransparency: null,
    autoCorrect: null,
    autoSave: null,
    disablePictureInPicture: Y,
    disableRemotePlayback: Y,
    prefix: null,
    property: null,
    results: B,
    security: null,
    unselectable: null
  }
}), dS = yi({
  space: "svg",
  attributes: {
    accentHeight: "accent-height",
    alignmentBaseline: "alignment-baseline",
    arabicForm: "arabic-form",
    baselineShift: "baseline-shift",
    capHeight: "cap-height",
    className: "class",
    clipPath: "clip-path",
    clipRule: "clip-rule",
    colorInterpolation: "color-interpolation",
    colorInterpolationFilters: "color-interpolation-filters",
    colorProfile: "color-profile",
    colorRendering: "color-rendering",
    crossOrigin: "crossorigin",
    dataType: "datatype",
    dominantBaseline: "dominant-baseline",
    enableBackground: "enable-background",
    fillOpacity: "fill-opacity",
    fillRule: "fill-rule",
    floodColor: "flood-color",
    floodOpacity: "flood-opacity",
    fontFamily: "font-family",
    fontSize: "font-size",
    fontSizeAdjust: "font-size-adjust",
    fontStretch: "font-stretch",
    fontStyle: "font-style",
    fontVariant: "font-variant",
    fontWeight: "font-weight",
    glyphName: "glyph-name",
    glyphOrientationHorizontal: "glyph-orientation-horizontal",
    glyphOrientationVertical: "glyph-orientation-vertical",
    hrefLang: "hreflang",
    horizAdvX: "horiz-adv-x",
    horizOriginX: "horiz-origin-x",
    horizOriginY: "horiz-origin-y",
    imageRendering: "image-rendering",
    letterSpacing: "letter-spacing",
    lightingColor: "lighting-color",
    markerEnd: "marker-end",
    markerMid: "marker-mid",
    markerStart: "marker-start",
    navDown: "nav-down",
    navDownLeft: "nav-down-left",
    navDownRight: "nav-down-right",
    navLeft: "nav-left",
    navNext: "nav-next",
    navPrev: "nav-prev",
    navRight: "nav-right",
    navUp: "nav-up",
    navUpLeft: "nav-up-left",
    navUpRight: "nav-up-right",
    onAbort: "onabort",
    onActivate: "onactivate",
    onAfterPrint: "onafterprint",
    onBeforePrint: "onbeforeprint",
    onBegin: "onbegin",
    onCancel: "oncancel",
    onCanPlay: "oncanplay",
    onCanPlayThrough: "oncanplaythrough",
    onChange: "onchange",
    onClick: "onclick",
    onClose: "onclose",
    onCopy: "oncopy",
    onCueChange: "oncuechange",
    onCut: "oncut",
    onDblClick: "ondblclick",
    onDrag: "ondrag",
    onDragEnd: "ondragend",
    onDragEnter: "ondragenter",
    onDragExit: "ondragexit",
    onDragLeave: "ondragleave",
    onDragOver: "ondragover",
    onDragStart: "ondragstart",
    onDrop: "ondrop",
    onDurationChange: "ondurationchange",
    onEmptied: "onemptied",
    onEnd: "onend",
    onEnded: "onended",
    onError: "onerror",
    onFocus: "onfocus",
    onFocusIn: "onfocusin",
    onFocusOut: "onfocusout",
    onHashChange: "onhashchange",
    onInput: "oninput",
    onInvalid: "oninvalid",
    onKeyDown: "onkeydown",
    onKeyPress: "onkeypress",
    onKeyUp: "onkeyup",
    onLoad: "onload",
    onLoadedData: "onloadeddata",
    onLoadedMetadata: "onloadedmetadata",
    onLoadStart: "onloadstart",
    onMessage: "onmessage",
    onMouseDown: "onmousedown",
    onMouseEnter: "onmouseenter",
    onMouseLeave: "onmouseleave",
    onMouseMove: "onmousemove",
    onMouseOut: "onmouseout",
    onMouseOver: "onmouseover",
    onMouseUp: "onmouseup",
    onMouseWheel: "onmousewheel",
    onOffline: "onoffline",
    onOnline: "ononline",
    onPageHide: "onpagehide",
    onPageShow: "onpageshow",
    onPaste: "onpaste",
    onPause: "onpause",
    onPlay: "onplay",
    onPlaying: "onplaying",
    onPopState: "onpopstate",
    onProgress: "onprogress",
    onRateChange: "onratechange",
    onRepeat: "onrepeat",
    onReset: "onreset",
    onResize: "onresize",
    onScroll: "onscroll",
    onSeeked: "onseeked",
    onSeeking: "onseeking",
    onSelect: "onselect",
    onShow: "onshow",
    onStalled: "onstalled",
    onStorage: "onstorage",
    onSubmit: "onsubmit",
    onSuspend: "onsuspend",
    onTimeUpdate: "ontimeupdate",
    onToggle: "ontoggle",
    onUnload: "onunload",
    onVolumeChange: "onvolumechange",
    onWaiting: "onwaiting",
    onZoom: "onzoom",
    overlinePosition: "overline-position",
    overlineThickness: "overline-thickness",
    paintOrder: "paint-order",
    panose1: "panose-1",
    pointerEvents: "pointer-events",
    referrerPolicy: "referrerpolicy",
    renderingIntent: "rendering-intent",
    shapeRendering: "shape-rendering",
    stopColor: "stop-color",
    stopOpacity: "stop-opacity",
    strikethroughPosition: "strikethrough-position",
    strikethroughThickness: "strikethrough-thickness",
    strokeDashArray: "stroke-dasharray",
    strokeDashOffset: "stroke-dashoffset",
    strokeLineCap: "stroke-linecap",
    strokeLineJoin: "stroke-linejoin",
    strokeMiterLimit: "stroke-miterlimit",
    strokeOpacity: "stroke-opacity",
    strokeWidth: "stroke-width",
    tabIndex: "tabindex",
    textAnchor: "text-anchor",
    textDecoration: "text-decoration",
    textRendering: "text-rendering",
    transformOrigin: "transform-origin",
    typeOf: "typeof",
    underlinePosition: "underline-position",
    underlineThickness: "underline-thickness",
    unicodeBidi: "unicode-bidi",
    unicodeRange: "unicode-range",
    unitsPerEm: "units-per-em",
    vAlphabetic: "v-alphabetic",
    vHanging: "v-hanging",
    vIdeographic: "v-ideographic",
    vMathematical: "v-mathematical",
    vectorEffect: "vector-effect",
    vertAdvY: "vert-adv-y",
    vertOriginX: "vert-origin-x",
    vertOriginY: "vert-origin-y",
    wordSpacing: "word-spacing",
    writingMode: "writing-mode",
    xHeight: "x-height",
    // These were camelcased in Tiny. Now lowercased in SVG 2
    playbackOrder: "playbackorder",
    timelineBegin: "timelinebegin"
  },
  transform: Gp,
  properties: {
    about: nt,
    accentHeight: B,
    accumulate: null,
    additive: null,
    alignmentBaseline: null,
    alphabetic: B,
    amplitude: B,
    arabicForm: null,
    ascent: B,
    attributeName: null,
    attributeType: null,
    azimuth: B,
    bandwidth: null,
    baselineShift: null,
    baseFrequency: null,
    baseProfile: null,
    bbox: null,
    begin: null,
    bias: B,
    by: null,
    calcMode: null,
    capHeight: B,
    className: de,
    clip: null,
    clipPath: null,
    clipPathUnits: null,
    clipRule: null,
    color: null,
    colorInterpolation: null,
    colorInterpolationFilters: null,
    colorProfile: null,
    colorRendering: null,
    content: null,
    contentScriptType: null,
    contentStyleType: null,
    crossOrigin: null,
    cursor: null,
    cx: null,
    cy: null,
    d: null,
    dataType: null,
    defaultAction: null,
    descent: B,
    diffuseConstant: B,
    direction: null,
    display: null,
    dur: null,
    divisor: B,
    dominantBaseline: null,
    download: Y,
    dx: null,
    dy: null,
    edgeMode: null,
    editable: null,
    elevation: B,
    enableBackground: null,
    end: null,
    event: null,
    exponent: B,
    externalResourcesRequired: null,
    fill: null,
    fillOpacity: B,
    fillRule: null,
    filter: null,
    filterRes: null,
    filterUnits: null,
    floodColor: null,
    floodOpacity: null,
    focusable: null,
    focusHighlight: null,
    fontFamily: null,
    fontSize: null,
    fontSizeAdjust: null,
    fontStretch: null,
    fontStyle: null,
    fontVariant: null,
    fontWeight: null,
    format: null,
    fr: null,
    from: null,
    fx: null,
    fy: null,
    g1: ii,
    g2: ii,
    glyphName: ii,
    glyphOrientationHorizontal: null,
    glyphOrientationVertical: null,
    glyphRef: null,
    gradientTransform: null,
    gradientUnits: null,
    handler: null,
    hanging: B,
    hatchContentUnits: null,
    hatchUnits: null,
    height: null,
    href: null,
    hrefLang: null,
    horizAdvX: B,
    horizOriginX: B,
    horizOriginY: B,
    id: null,
    ideographic: B,
    imageRendering: null,
    initialVisibility: null,
    in: null,
    in2: null,
    intercept: B,
    k: B,
    k1: B,
    k2: B,
    k3: B,
    k4: B,
    kernelMatrix: nt,
    kernelUnitLength: null,
    keyPoints: null,
    // SEMI_COLON_SEPARATED
    keySplines: null,
    // SEMI_COLON_SEPARATED
    keyTimes: null,
    // SEMI_COLON_SEPARATED
    kerning: null,
    lang: null,
    lengthAdjust: null,
    letterSpacing: null,
    lightingColor: null,
    limitingConeAngle: B,
    local: null,
    markerEnd: null,
    markerMid: null,
    markerStart: null,
    markerHeight: null,
    markerUnits: null,
    markerWidth: null,
    mask: null,
    maskContentUnits: null,
    maskUnits: null,
    mathematical: null,
    max: null,
    media: null,
    mediaCharacterEncoding: null,
    mediaContentEncodings: null,
    mediaSize: B,
    mediaTime: null,
    method: null,
    min: null,
    mode: null,
    name: null,
    navDown: null,
    navDownLeft: null,
    navDownRight: null,
    navLeft: null,
    navNext: null,
    navPrev: null,
    navRight: null,
    navUp: null,
    navUpLeft: null,
    navUpRight: null,
    numOctaves: null,
    observer: null,
    offset: null,
    onAbort: null,
    onActivate: null,
    onAfterPrint: null,
    onBeforePrint: null,
    onBegin: null,
    onCancel: null,
    onCanPlay: null,
    onCanPlayThrough: null,
    onChange: null,
    onClick: null,
    onClose: null,
    onCopy: null,
    onCueChange: null,
    onCut: null,
    onDblClick: null,
    onDrag: null,
    onDragEnd: null,
    onDragEnter: null,
    onDragExit: null,
    onDragLeave: null,
    onDragOver: null,
    onDragStart: null,
    onDrop: null,
    onDurationChange: null,
    onEmptied: null,
    onEnd: null,
    onEnded: null,
    onError: null,
    onFocus: null,
    onFocusIn: null,
    onFocusOut: null,
    onHashChange: null,
    onInput: null,
    onInvalid: null,
    onKeyDown: null,
    onKeyPress: null,
    onKeyUp: null,
    onLoad: null,
    onLoadedData: null,
    onLoadedMetadata: null,
    onLoadStart: null,
    onMessage: null,
    onMouseDown: null,
    onMouseEnter: null,
    onMouseLeave: null,
    onMouseMove: null,
    onMouseOut: null,
    onMouseOver: null,
    onMouseUp: null,
    onMouseWheel: null,
    onOffline: null,
    onOnline: null,
    onPageHide: null,
    onPageShow: null,
    onPaste: null,
    onPause: null,
    onPlay: null,
    onPlaying: null,
    onPopState: null,
    onProgress: null,
    onRateChange: null,
    onRepeat: null,
    onReset: null,
    onResize: null,
    onScroll: null,
    onSeeked: null,
    onSeeking: null,
    onSelect: null,
    onShow: null,
    onStalled: null,
    onStorage: null,
    onSubmit: null,
    onSuspend: null,
    onTimeUpdate: null,
    onToggle: null,
    onUnload: null,
    onVolumeChange: null,
    onWaiting: null,
    onZoom: null,
    opacity: null,
    operator: null,
    order: null,
    orient: null,
    orientation: null,
    origin: null,
    overflow: null,
    overlay: null,
    overlinePosition: B,
    overlineThickness: B,
    paintOrder: null,
    panose1: null,
    path: null,
    pathLength: B,
    patternContentUnits: null,
    patternTransform: null,
    patternUnits: null,
    phase: null,
    ping: de,
    pitch: null,
    playbackOrder: null,
    pointerEvents: null,
    points: null,
    pointsAtX: B,
    pointsAtY: B,
    pointsAtZ: B,
    preserveAlpha: null,
    preserveAspectRatio: null,
    primitiveUnits: null,
    propagate: null,
    property: nt,
    r: null,
    radius: null,
    referrerPolicy: null,
    refX: null,
    refY: null,
    rel: nt,
    rev: nt,
    renderingIntent: null,
    repeatCount: null,
    repeatDur: null,
    requiredExtensions: nt,
    requiredFeatures: nt,
    requiredFonts: nt,
    requiredFormats: nt,
    resource: null,
    restart: null,
    result: null,
    rotate: null,
    rx: null,
    ry: null,
    scale: null,
    seed: null,
    shapeRendering: null,
    side: null,
    slope: null,
    snapshotTime: null,
    specularConstant: B,
    specularExponent: B,
    spreadMethod: null,
    spacing: null,
    startOffset: null,
    stdDeviation: null,
    stemh: null,
    stemv: null,
    stitchTiles: null,
    stopColor: null,
    stopOpacity: null,
    strikethroughPosition: B,
    strikethroughThickness: B,
    string: null,
    stroke: null,
    strokeDashArray: nt,
    strokeDashOffset: null,
    strokeLineCap: null,
    strokeLineJoin: null,
    strokeMiterLimit: B,
    strokeOpacity: B,
    strokeWidth: null,
    style: null,
    surfaceScale: B,
    syncBehavior: null,
    syncBehaviorDefault: null,
    syncMaster: null,
    syncTolerance: null,
    syncToleranceDefault: null,
    systemLanguage: nt,
    tabIndex: B,
    tableValues: null,
    target: null,
    targetX: B,
    targetY: B,
    textAnchor: null,
    textDecoration: null,
    textRendering: null,
    textLength: null,
    timelineBegin: null,
    title: null,
    transformBehavior: null,
    type: null,
    typeOf: nt,
    to: null,
    transform: null,
    transformOrigin: null,
    u1: null,
    u2: null,
    underlinePosition: B,
    underlineThickness: B,
    unicode: null,
    unicodeBidi: null,
    unicodeRange: null,
    unitsPerEm: B,
    values: null,
    vAlphabetic: B,
    vMathematical: B,
    vectorEffect: null,
    vHanging: B,
    vIdeographic: B,
    version: null,
    vertAdvY: B,
    vertOriginX: B,
    vertOriginY: B,
    viewBox: null,
    viewTarget: null,
    visibility: null,
    width: null,
    widths: null,
    wordSpacing: null,
    writingMode: null,
    x: null,
    x1: null,
    x2: null,
    xChannelSelector: null,
    xHeight: B,
    y: null,
    y1: null,
    y2: null,
    yChannelSelector: null,
    z: null,
    zoomAndPan: null
  }
}), pS = /^data[-\w.:]+$/i, oh = /-[a-z]/g, mS = /[A-Z]/g;
function gS(n, e) {
  const t = Ul(e);
  let i = e, r = kt;
  if (t in n.normal)
    return n.property[n.normal[t]];
  if (t.length > 4 && t.slice(0, 4) === "data" && pS.test(e)) {
    if (e.charAt(4) === "-") {
      const s = e.slice(5).replace(oh, bS);
      i = "data" + s.charAt(0).toUpperCase() + s.slice(1);
    } else {
      const s = e.slice(4);
      if (!oh.test(s)) {
        let o = s.replace(mS, yS);
        o.charAt(0) !== "-" && (o = "-" + o), e = "data" + o;
      }
    }
    r = Ba;
  }
  return new r(i, e);
}
function yS(n) {
  return "-" + n.toLowerCase();
}
function bS(n) {
  return n.charAt(1).toUpperCase();
}
const xS = Wp([Kp, Up, Xp, Jp, fS], "html"), Qp = Wp([Kp, Up, Xp, Jp, dS], "svg"), lh = {}.hasOwnProperty;
function wS(n, e) {
  const t = e || {};
  function i(r, ...s) {
    let o = i.invalid;
    const l = i.handlers;
    if (r && lh.call(r, n)) {
      const a = String(r[n]);
      o = lh.call(l, a) ? l[a] : i.unknown;
    }
    if (o)
      return o.call(this, r, ...s);
  }
  return i.handlers = t.handlers || {}, i.invalid = t.invalid, i.unknown = t.unknown, i;
}
const kS = /["&'<>`]/g, vS = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, SS = (
  // eslint-disable-next-line no-control-regex, unicorn/no-hex-escape
  /[\x01-\t\v\f\x0E-\x1F\x7F\x81\x8D\x8F\x90\x9D\xA0-\uFFFF]/g
), CS = /[|\\{}()[\]^$+*?.]/g, ah = /* @__PURE__ */ new WeakMap();
function AS(n, e) {
  if (n = n.replace(
    e.subset ? MS(e.subset) : kS,
    i
  ), e.subset || e.escapeOnly)
    return n;
  return n.replace(vS, t).replace(SS, i);
  function t(r, s, o) {
    return e.format(
      (r.charCodeAt(0) - 55296) * 1024 + r.charCodeAt(1) - 56320 + 65536,
      o.charCodeAt(s + 2),
      e
    );
  }
  function i(r, s, o) {
    return e.format(
      r.charCodeAt(0),
      o.charCodeAt(s + 1),
      e
    );
  }
}
function MS(n) {
  let e = ah.get(n);
  return e || (e = TS(n), ah.set(n, e)), e;
}
function TS(n) {
  const e = [];
  let t = -1;
  for (; ++t < n.length; )
    e.push(n[t].replace(CS, "\\$&"));
  return new RegExp("(?:" + e.join("|") + ")", "g");
}
const OS = /[\dA-Fa-f]/;
function DS(n, e, t) {
  const i = "&#x" + n.toString(16).toUpperCase();
  return t && e && !OS.test(String.fromCharCode(e)) ? i : i + ";";
}
const ES = /\d/;
function LS(n, e, t) {
  const i = "&#" + String(n);
  return t && e && !ES.test(String.fromCharCode(e)) ? i : i + ";";
}
const IS = [
  "AElig",
  "AMP",
  "Aacute",
  "Acirc",
  "Agrave",
  "Aring",
  "Atilde",
  "Auml",
  "COPY",
  "Ccedil",
  "ETH",
  "Eacute",
  "Ecirc",
  "Egrave",
  "Euml",
  "GT",
  "Iacute",
  "Icirc",
  "Igrave",
  "Iuml",
  "LT",
  "Ntilde",
  "Oacute",
  "Ocirc",
  "Ograve",
  "Oslash",
  "Otilde",
  "Ouml",
  "QUOT",
  "REG",
  "THORN",
  "Uacute",
  "Ucirc",
  "Ugrave",
  "Uuml",
  "Yacute",
  "aacute",
  "acirc",
  "acute",
  "aelig",
  "agrave",
  "amp",
  "aring",
  "atilde",
  "auml",
  "brvbar",
  "ccedil",
  "cedil",
  "cent",
  "copy",
  "curren",
  "deg",
  "divide",
  "eacute",
  "ecirc",
  "egrave",
  "eth",
  "euml",
  "frac12",
  "frac14",
  "frac34",
  "gt",
  "iacute",
  "icirc",
  "iexcl",
  "igrave",
  "iquest",
  "iuml",
  "laquo",
  "lt",
  "macr",
  "micro",
  "middot",
  "nbsp",
  "not",
  "ntilde",
  "oacute",
  "ocirc",
  "ograve",
  "ordf",
  "ordm",
  "oslash",
  "otilde",
  "ouml",
  "para",
  "plusmn",
  "pound",
  "quot",
  "raquo",
  "reg",
  "sect",
  "shy",
  "sup1",
  "sup2",
  "sup3",
  "szlig",
  "thorn",
  "times",
  "uacute",
  "ucirc",
  "ugrave",
  "uml",
  "uuml",
  "yacute",
  "yen",
  "yuml"
], No = {
  nbsp: " ",
  iexcl: "¡",
  cent: "¢",
  pound: "£",
  curren: "¤",
  yen: "¥",
  brvbar: "¦",
  sect: "§",
  uml: "¨",
  copy: "©",
  ordf: "ª",
  laquo: "«",
  not: "¬",
  shy: "­",
  reg: "®",
  macr: "¯",
  deg: "°",
  plusmn: "±",
  sup2: "²",
  sup3: "³",
  acute: "´",
  micro: "µ",
  para: "¶",
  middot: "·",
  cedil: "¸",
  sup1: "¹",
  ordm: "º",
  raquo: "»",
  frac14: "¼",
  frac12: "½",
  frac34: "¾",
  iquest: "¿",
  Agrave: "À",
  Aacute: "Á",
  Acirc: "Â",
  Atilde: "Ã",
  Auml: "Ä",
  Aring: "Å",
  AElig: "Æ",
  Ccedil: "Ç",
  Egrave: "È",
  Eacute: "É",
  Ecirc: "Ê",
  Euml: "Ë",
  Igrave: "Ì",
  Iacute: "Í",
  Icirc: "Î",
  Iuml: "Ï",
  ETH: "Ð",
  Ntilde: "Ñ",
  Ograve: "Ò",
  Oacute: "Ó",
  Ocirc: "Ô",
  Otilde: "Õ",
  Ouml: "Ö",
  times: "×",
  Oslash: "Ø",
  Ugrave: "Ù",
  Uacute: "Ú",
  Ucirc: "Û",
  Uuml: "Ü",
  Yacute: "Ý",
  THORN: "Þ",
  szlig: "ß",
  agrave: "à",
  aacute: "á",
  acirc: "â",
  atilde: "ã",
  auml: "ä",
  aring: "å",
  aelig: "æ",
  ccedil: "ç",
  egrave: "è",
  eacute: "é",
  ecirc: "ê",
  euml: "ë",
  igrave: "ì",
  iacute: "í",
  icirc: "î",
  iuml: "ï",
  eth: "ð",
  ntilde: "ñ",
  ograve: "ò",
  oacute: "ó",
  ocirc: "ô",
  otilde: "õ",
  ouml: "ö",
  divide: "÷",
  oslash: "ø",
  ugrave: "ù",
  uacute: "ú",
  ucirc: "û",
  uuml: "ü",
  yacute: "ý",
  thorn: "þ",
  yuml: "ÿ",
  fnof: "ƒ",
  Alpha: "Α",
  Beta: "Β",
  Gamma: "Γ",
  Delta: "Δ",
  Epsilon: "Ε",
  Zeta: "Ζ",
  Eta: "Η",
  Theta: "Θ",
  Iota: "Ι",
  Kappa: "Κ",
  Lambda: "Λ",
  Mu: "Μ",
  Nu: "Ν",
  Xi: "Ξ",
  Omicron: "Ο",
  Pi: "Π",
  Rho: "Ρ",
  Sigma: "Σ",
  Tau: "Τ",
  Upsilon: "Υ",
  Phi: "Φ",
  Chi: "Χ",
  Psi: "Ψ",
  Omega: "Ω",
  alpha: "α",
  beta: "β",
  gamma: "γ",
  delta: "δ",
  epsilon: "ε",
  zeta: "ζ",
  eta: "η",
  theta: "θ",
  iota: "ι",
  kappa: "κ",
  lambda: "λ",
  mu: "μ",
  nu: "ν",
  xi: "ξ",
  omicron: "ο",
  pi: "π",
  rho: "ρ",
  sigmaf: "ς",
  sigma: "σ",
  tau: "τ",
  upsilon: "υ",
  phi: "φ",
  chi: "χ",
  psi: "ψ",
  omega: "ω",
  thetasym: "ϑ",
  upsih: "ϒ",
  piv: "ϖ",
  bull: "•",
  hellip: "…",
  prime: "′",
  Prime: "″",
  oline: "‾",
  frasl: "⁄",
  weierp: "℘",
  image: "ℑ",
  real: "ℜ",
  trade: "™",
  alefsym: "ℵ",
  larr: "←",
  uarr: "↑",
  rarr: "→",
  darr: "↓",
  harr: "↔",
  crarr: "↵",
  lArr: "⇐",
  uArr: "⇑",
  rArr: "⇒",
  dArr: "⇓",
  hArr: "⇔",
  forall: "∀",
  part: "∂",
  exist: "∃",
  empty: "∅",
  nabla: "∇",
  isin: "∈",
  notin: "∉",
  ni: "∋",
  prod: "∏",
  sum: "∑",
  minus: "−",
  lowast: "∗",
  radic: "√",
  prop: "∝",
  infin: "∞",
  ang: "∠",
  and: "∧",
  or: "∨",
  cap: "∩",
  cup: "∪",
  int: "∫",
  there4: "∴",
  sim: "∼",
  cong: "≅",
  asymp: "≈",
  ne: "≠",
  equiv: "≡",
  le: "≤",
  ge: "≥",
  sub: "⊂",
  sup: "⊃",
  nsub: "⊄",
  sube: "⊆",
  supe: "⊇",
  oplus: "⊕",
  otimes: "⊗",
  perp: "⊥",
  sdot: "⋅",
  lceil: "⌈",
  rceil: "⌉",
  lfloor: "⌊",
  rfloor: "⌋",
  lang: "〈",
  rang: "〉",
  loz: "◊",
  spades: "♠",
  clubs: "♣",
  hearts: "♥",
  diams: "♦",
  quot: '"',
  amp: "&",
  lt: "<",
  gt: ">",
  OElig: "Œ",
  oelig: "œ",
  Scaron: "Š",
  scaron: "š",
  Yuml: "Ÿ",
  circ: "ˆ",
  tilde: "˜",
  ensp: " ",
  emsp: " ",
  thinsp: " ",
  zwnj: "‌",
  zwj: "‍",
  lrm: "‎",
  rlm: "‏",
  ndash: "–",
  mdash: "—",
  lsquo: "‘",
  rsquo: "’",
  sbquo: "‚",
  ldquo: "“",
  rdquo: "”",
  bdquo: "„",
  dagger: "†",
  Dagger: "‡",
  permil: "‰",
  lsaquo: "‹",
  rsaquo: "›",
  euro: "€"
}, PS = [
  "cent",
  "copy",
  "divide",
  "gt",
  "lt",
  "not",
  "para",
  "times"
], Zp = {}.hasOwnProperty, Gl = {};
let Vr;
for (Vr in No)
  Zp.call(No, Vr) && (Gl[No[Vr]] = Vr);
const BS = /[^\dA-Za-z]/;
function RS(n, e, t, i) {
  const r = String.fromCharCode(n);
  if (Zp.call(Gl, r)) {
    const s = Gl[r], o = "&" + s;
    return t && IS.includes(s) && !PS.includes(s) && (!i || e && e !== 61 && BS.test(String.fromCharCode(e))) ? o : o + ";";
  }
  return "";
}
function NS(n, e, t) {
  let i = DS(n, e, t.omitOptionalSemicolons), r;
  if ((t.useNamedReferences || t.useShortestReferences) && (r = RS(
    n,
    e,
    t.omitOptionalSemicolons,
    t.attribute
  )), (t.useShortestReferences || !r) && t.useShortestReferences) {
    const s = LS(n, e, t.omitOptionalSemicolons);
    s.length < i.length && (i = s);
  }
  return r && (!t.useShortestReferences || r.length < i.length) ? r : i;
}
function ri(n, e) {
  return AS(n, Object.assign({ format: NS }, e));
}
const FS = /^>|^->|<!--|-->|--!>|<!-$/g, zS = [">"], HS = ["<", ">"];
function VS(n, e, t, i) {
  return i.settings.bogusComments ? "<?" + ri(
    n.value,
    Object.assign({}, i.settings.characterReferences, {
      subset: zS
    })
  ) + ">" : "<!--" + n.value.replace(FS, r) + "-->";
  function r(s) {
    return ri(
      s,
      Object.assign({}, i.settings.characterReferences, {
        subset: HS
      })
    );
  }
}
function _S(n, e, t, i) {
  return "<!" + (i.settings.upperDoctype ? "DOCTYPE" : "doctype") + (i.settings.tightDoctype ? "" : " ") + "html>";
}
function Es(n, e) {
  const t = String(n);
  if (typeof e != "string")
    throw new TypeError("Expected character");
  let i = 0, r = t.indexOf(e);
  for (; r !== -1; )
    i++, r = t.indexOf(e, r + e.length);
  return i;
}
function $S(n, e) {
  const t = e || {};
  return (n[n.length - 1] === "" ? [...n, ""] : n).join(
    (t.padRight ? " " : "") + "," + (t.padLeft === !1 ? "" : " ")
  ).trim();
}
function jS(n) {
  return n.join(" ").trim();
}
const WS = /[ \t\n\f\r]/g;
function Ra(n) {
  return typeof n == "object" ? n.type === "text" ? uh(n.value) : !1 : uh(n);
}
function uh(n) {
  return n.replace(WS, "") === "";
}
const De = tm(1), em = tm(-1), qS = [];
function tm(n) {
  return e;
  function e(t, i, r) {
    const s = t ? t.children : qS;
    let o = (i || 0) + n, l = s[o];
    if (!r)
      for (; l && Ra(l); )
        o += n, l = s[o];
    return l;
  }
}
const US = {}.hasOwnProperty;
function nm(n) {
  return e;
  function e(t, i, r) {
    return US.call(n, t.tagName) && n[t.tagName](t, i, r);
  }
}
const Na = nm({
  body: GS,
  caption: Fo,
  colgroup: Fo,
  dd: QS,
  dt: JS,
  head: Fo,
  html: KS,
  li: XS,
  optgroup: ZS,
  option: eC,
  p: YS,
  rp: ch,
  rt: ch,
  tbody: nC,
  td: hh,
  tfoot: iC,
  th: hh,
  thead: tC,
  tr: rC
});
function Fo(n, e, t) {
  const i = De(t, e, !0);
  return !i || i.type !== "comment" && !(i.type === "text" && Ra(i.value.charAt(0)));
}
function KS(n, e, t) {
  const i = De(t, e);
  return !i || i.type !== "comment";
}
function GS(n, e, t) {
  const i = De(t, e);
  return !i || i.type !== "comment";
}
function YS(n, e, t) {
  const i = De(t, e);
  return i ? i.type === "element" && (i.tagName === "address" || i.tagName === "article" || i.tagName === "aside" || i.tagName === "blockquote" || i.tagName === "details" || i.tagName === "div" || i.tagName === "dl" || i.tagName === "fieldset" || i.tagName === "figcaption" || i.tagName === "figure" || i.tagName === "footer" || i.tagName === "form" || i.tagName === "h1" || i.tagName === "h2" || i.tagName === "h3" || i.tagName === "h4" || i.tagName === "h5" || i.tagName === "h6" || i.tagName === "header" || i.tagName === "hgroup" || i.tagName === "hr" || i.tagName === "main" || i.tagName === "menu" || i.tagName === "nav" || i.tagName === "ol" || i.tagName === "p" || i.tagName === "pre" || i.tagName === "section" || i.tagName === "table" || i.tagName === "ul") : !t || // Confusing parent.
  !(t.type === "element" && (t.tagName === "a" || t.tagName === "audio" || t.tagName === "del" || t.tagName === "ins" || t.tagName === "map" || t.tagName === "noscript" || t.tagName === "video"));
}
function XS(n, e, t) {
  const i = De(t, e);
  return !i || i.type === "element" && i.tagName === "li";
}
function JS(n, e, t) {
  const i = De(t, e);
  return !!(i && i.type === "element" && (i.tagName === "dt" || i.tagName === "dd"));
}
function QS(n, e, t) {
  const i = De(t, e);
  return !i || i.type === "element" && (i.tagName === "dt" || i.tagName === "dd");
}
function ch(n, e, t) {
  const i = De(t, e);
  return !i || i.type === "element" && (i.tagName === "rp" || i.tagName === "rt");
}
function ZS(n, e, t) {
  const i = De(t, e);
  return !i || i.type === "element" && i.tagName === "optgroup";
}
function eC(n, e, t) {
  const i = De(t, e);
  return !i || i.type === "element" && (i.tagName === "option" || i.tagName === "optgroup");
}
function tC(n, e, t) {
  const i = De(t, e);
  return !!(i && i.type === "element" && (i.tagName === "tbody" || i.tagName === "tfoot"));
}
function nC(n, e, t) {
  const i = De(t, e);
  return !i || i.type === "element" && (i.tagName === "tbody" || i.tagName === "tfoot");
}
function iC(n, e, t) {
  return !De(t, e);
}
function rC(n, e, t) {
  const i = De(t, e);
  return !i || i.type === "element" && i.tagName === "tr";
}
function hh(n, e, t) {
  const i = De(t, e);
  return !i || i.type === "element" && (i.tagName === "td" || i.tagName === "th");
}
const sC = nm({
  body: aC,
  colgroup: uC,
  head: lC,
  html: oC,
  tbody: cC
});
function oC(n) {
  const e = De(n, -1);
  return !e || e.type !== "comment";
}
function lC(n) {
  const e = n.children, t = [];
  let i = -1;
  for (; ++i < e.length; ) {
    const r = e[i];
    if (r.type === "element" && (r.tagName === "title" || r.tagName === "base")) {
      if (t.includes(r.tagName))
        return !1;
      t.push(r.tagName);
    }
  }
  return e.length > 0;
}
function aC(n) {
  const e = De(n, -1, !0);
  return !e || e.type !== "comment" && !(e.type === "text" && Ra(e.value.charAt(0))) && !(e.type === "element" && (e.tagName === "meta" || e.tagName === "link" || e.tagName === "script" || e.tagName === "style" || e.tagName === "template"));
}
function uC(n, e, t) {
  const i = em(t, e), r = De(n, -1, !0);
  return t && i && i.type === "element" && i.tagName === "colgroup" && Na(i, t.children.indexOf(i), t) ? !1 : !!(r && r.type === "element" && r.tagName === "col");
}
function cC(n, e, t) {
  const i = em(t, e), r = De(n, -1);
  return t && i && i.type === "element" && (i.tagName === "thead" || i.tagName === "tbody") && Na(i, t.children.indexOf(i), t) ? !1 : !!(r && r.type === "element" && r.tagName === "tr");
}
const _r = {
  // See: <https://html.spec.whatwg.org/#attribute-name-state>.
  name: [
    [`	
\f\r &/=>`.split(""), `	
\f\r "&'/=>\``.split("")],
    [`\0	
\f\r "&'/<=>`.split(""), `\0	
\f\r "&'/<=>\``.split("")]
  ],
  // See: <https://html.spec.whatwg.org/#attribute-value-(unquoted)-state>.
  unquoted: [
    [`	
\f\r &>`.split(""), `\0	
\f\r "&'<=>\``.split("")],
    [`\0	
\f\r "&'<=>\``.split(""), `\0	
\f\r "&'<=>\``.split("")]
  ],
  // See: <https://html.spec.whatwg.org/#attribute-value-(single-quoted)-state>.
  single: [
    ["&'".split(""), "\"&'`".split("")],
    ["\0&'".split(""), "\0\"&'`".split("")]
  ],
  // See: <https://html.spec.whatwg.org/#attribute-value-(double-quoted)-state>.
  double: [
    ['"&'.split(""), "\"&'`".split("")],
    ['\0"&'.split(""), "\0\"&'`".split("")]
  ]
};
function hC(n, e, t, i) {
  const r = i.schema, s = r.space === "svg" ? !1 : i.settings.omitOptionalTags;
  let o = r.space === "svg" ? i.settings.closeEmptyElements : i.settings.voids.includes(n.tagName.toLowerCase());
  const l = [];
  let a;
  r.space === "html" && n.tagName === "svg" && (i.schema = Qp);
  const u = fC(i, n.properties), c = i.all(
    r.space === "html" && n.tagName === "template" ? n.content : n
  );
  return i.schema = r, c && (o = !1), (u || !s || !sC(n, e, t)) && (l.push("<", n.tagName, u ? " " + u : ""), o && (r.space === "svg" || i.settings.closeSelfClosing) && (a = u.charAt(u.length - 1), (!i.settings.tightSelfClosing || a === "/" || a && a !== '"' && a !== "'") && l.push(" "), l.push("/")), l.push(">")), l.push(c), !o && (!s || !Na(n, e, t)) && l.push("</" + n.tagName + ">"), l.join("");
}
function fC(n, e) {
  const t = [];
  let i = -1, r;
  if (e) {
    for (r in e)
      if (e[r] !== null && e[r] !== void 0) {
        const s = dC(n, r, e[r]);
        s && t.push(s);
      }
  }
  for (; ++i < t.length; ) {
    const s = n.settings.tightAttributes ? t[i].charAt(t[i].length - 1) : void 0;
    i !== t.length - 1 && s !== '"' && s !== "'" && (t[i] += " ");
  }
  return t.join("");
}
function dC(n, e, t) {
  const i = gS(n.schema, e), r = n.settings.allowParseErrors && n.schema.space === "html" ? 0 : 1, s = n.settings.allowDangerousCharacters ? 0 : 1;
  let o = n.quote, l;
  if (i.overloadedBoolean && (t === i.attribute || t === "") ? t = !0 : (i.boolean || i.overloadedBoolean && typeof t != "string") && (t = !!t), t == null || t === !1 || typeof t == "number" && Number.isNaN(t))
    return "";
  const a = ri(
    i.attribute,
    Object.assign({}, n.settings.characterReferences, {
      // Always encode without parse errors in non-HTML.
      subset: _r.name[r][s]
    })
  );
  return t === !0 || (t = Array.isArray(t) ? (i.commaSeparated ? $S : jS)(t, {
    padLeft: !n.settings.tightCommaSeparatedLists
  }) : String(t), n.settings.collapseEmptyAttributes && !t) ? a : (n.settings.preferUnquoted && (l = ri(
    t,
    Object.assign({}, n.settings.characterReferences, {
      attribute: !0,
      subset: _r.unquoted[r][s]
    })
  )), l !== t && (n.settings.quoteSmart && Es(t, o) > Es(t, n.alternative) && (o = n.alternative), l = o + ri(
    t,
    Object.assign({}, n.settings.characterReferences, {
      // Always encode without parse errors in non-HTML.
      subset: (o === "'" ? _r.single : _r.double)[r][s],
      attribute: !0
    })
  ) + o), a + (l && "=" + l));
}
const pC = ["<", "&"];
function im(n, e, t, i) {
  return t && t.type === "element" && (t.tagName === "script" || t.tagName === "style") ? n.value : ri(
    n.value,
    Object.assign({}, i.settings.characterReferences, {
      subset: pC
    })
  );
}
function mC(n, e, t, i) {
  return i.settings.allowDangerousHtml ? n.value : im(n, e, t, i);
}
function gC(n, e, t, i) {
  return i.all(n);
}
const yC = wS("type", {
  invalid: bC,
  unknown: xC,
  handlers: { comment: VS, doctype: _S, element: hC, raw: mC, root: gC, text: im }
});
function bC(n) {
  throw new Error("Expected node, not `" + n + "`");
}
function xC(n) {
  const e = (
    /** @type {Nodes} */
    n
  );
  throw new Error("Cannot compile unknown node `" + e.type + "`");
}
const wC = {}, kC = {}, vC = [];
function SC(n, e) {
  const t = e || wC, i = t.quote || '"', r = i === '"' ? "'" : '"';
  if (i !== '"' && i !== "'")
    throw new Error("Invalid quote `" + i + "`, expected `'` or `\"`");
  return {
    one: CC,
    all: AC,
    settings: {
      omitOptionalTags: t.omitOptionalTags || !1,
      allowParseErrors: t.allowParseErrors || !1,
      allowDangerousCharacters: t.allowDangerousCharacters || !1,
      quoteSmart: t.quoteSmart || !1,
      preferUnquoted: t.preferUnquoted || !1,
      tightAttributes: t.tightAttributes || !1,
      upperDoctype: t.upperDoctype || !1,
      tightDoctype: t.tightDoctype || !1,
      bogusComments: t.bogusComments || !1,
      tightCommaSeparatedLists: t.tightCommaSeparatedLists || !1,
      tightSelfClosing: t.tightSelfClosing || !1,
      collapseEmptyAttributes: t.collapseEmptyAttributes || !1,
      allowDangerousHtml: t.allowDangerousHtml || !1,
      voids: t.voids || uS,
      characterReferences: t.characterReferences || kC,
      closeSelfClosing: t.closeSelfClosing || !1,
      closeEmptyElements: t.closeEmptyElements || !1
    },
    schema: t.space === "svg" ? Qp : xS,
    quote: i,
    alternative: r
  }.one(
    Array.isArray(n) ? { type: "root", children: n } : n,
    void 0,
    void 0
  );
}
function CC(n, e, t) {
  return yC(n, e, t, this);
}
function AC(n) {
  const e = [], t = n && n.children || vC;
  let i = -1;
  for (; ++i < t.length; )
    e[i] = this.one(t[i], i, n);
  return e.join("");
}
function MC(n) {
  const e = this, t = { ...e.data("settings"), ...n };
  e.compiler = i;
  function i(r) {
    return SC(r, t);
  }
}
var TC = typeof global == "object" && global && global.Object === Object && global, OC = typeof self == "object" && self && self.Object === Object && self, rm = TC || OC || Function("return this")(), Ls = rm.Symbol, sm = Object.prototype, DC = sm.hasOwnProperty, EC = sm.toString, Di = Ls ? Ls.toStringTag : void 0;
function LC(n) {
  var e = DC.call(n, Di), t = n[Di];
  try {
    n[Di] = void 0;
    var i = !0;
  } catch {
  }
  var r = EC.call(n);
  return i && (e ? n[Di] = t : delete n[Di]), r;
}
var IC = Object.prototype, PC = IC.toString;
function BC(n) {
  return PC.call(n);
}
var RC = "[object Null]", NC = "[object Undefined]", fh = Ls ? Ls.toStringTag : void 0;
function FC(n) {
  return n == null ? n === void 0 ? NC : RC : fh && fh in Object(n) ? LC(n) : BC(n);
}
function zC(n) {
  return n != null && typeof n == "object";
}
var HC = "[object Symbol]";
function VC(n) {
  return typeof n == "symbol" || zC(n) && FC(n) == HC;
}
var _C = /\s/;
function $C(n) {
  for (var e = n.length; e-- && _C.test(n.charAt(e)); )
    ;
  return e;
}
var jC = /^\s+/;
function WC(n) {
  return n && n.slice(0, $C(n) + 1).replace(jC, "");
}
function Is(n) {
  var e = typeof n;
  return n != null && (e == "object" || e == "function");
}
var dh = NaN, qC = /^[-+]0x[0-9a-f]+$/i, UC = /^0b[01]+$/i, KC = /^0o[0-7]+$/i, GC = parseInt;
function ph(n) {
  if (typeof n == "number")
    return n;
  if (VC(n))
    return dh;
  if (Is(n)) {
    var e = typeof n.valueOf == "function" ? n.valueOf() : n;
    n = Is(e) ? e + "" : e;
  }
  if (typeof n != "string")
    return n === 0 ? n : +n;
  n = WC(n);
  var t = UC.test(n);
  return t || KC.test(n) ? GC(n.slice(2), t ? 2 : 8) : qC.test(n) ? dh : +n;
}
var zo = function() {
  return rm.Date.now();
}, YC = "Expected a function", XC = Math.max, JC = Math.min;
function om(n, e, t) {
  var i, r, s, o, l, a, u = 0, c = !1, h = !1, f = !0;
  if (typeof n != "function")
    throw new TypeError(YC);
  e = ph(e) || 0, Is(t) && (c = !!t.leading, h = "maxWait" in t, s = h ? XC(ph(t.maxWait) || 0, e) : s, f = "trailing" in t ? !!t.trailing : f);
  function d(b) {
    var S = i, L = r;
    return i = r = void 0, u = b, o = n.apply(L, S), o;
  }
  function p(b) {
    return u = b, l = setTimeout(y, e), c ? d(b) : o;
  }
  function g(b) {
    var S = b - a, L = b - u, P = e - S;
    return h ? JC(P, s - L) : P;
  }
  function m(b) {
    var S = b - a, L = b - u;
    return a === void 0 || S >= e || S < 0 || h && L >= s;
  }
  function y() {
    var b = zo();
    if (m(b))
      return v(b);
    l = setTimeout(y, g(b));
  }
  function v(b) {
    return l = void 0, f && i ? d(b) : (i = r = void 0, o);
  }
  function C() {
    l !== void 0 && clearTimeout(l), u = 0, i = a = r = l = void 0;
  }
  function O() {
    return l === void 0 ? o : v(zo());
  }
  function A() {
    var b = zo(), S = m(b);
    if (i = arguments, r = this, a = b, S) {
      if (l === void 0)
        return p(a);
      if (h)
        return clearTimeout(l), l = setTimeout(y, e), d(a);
    }
    return l === void 0 && (l = setTimeout(y, e)), o;
  }
  return A.cancel = C, A.flush = O, A;
}
var QC = "Expected a function";
function ZC(n, e, t) {
  var i = !0, r = !0;
  if (typeof n != "function")
    throw new TypeError(QC);
  return Is(t) && (i = "leading" in t ? !!t.leading : i, r = "trailing" in t ? !!t.trailing : r), om(n, e, {
    leading: i,
    maxWait: e,
    trailing: r
  });
}
const e3 = ["innerHTML"], t3 = /* @__PURE__ */ lt({
  __name: "MViewer",
  props: /* @__PURE__ */ ts({
    plugins: {},
    interval: {}
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: /* @__PURE__ */ ts(["update"], ["update:modelValue"]),
  setup(n, { emit: e }) {
    const t = n, i = Jl(n, "modelValue"), r = oe(null), s = oe(null), o = oe(""), l = e, a = function() {
      return (d) => {
        s.value = d;
      };
    };
    function u() {
      const d = a2();
      if (d.use(dv), t.plugins.remark)
        for (const p of t.plugins.remark)
          Array.isArray(p) ? d.use(p[0], p[1]) : d.use(p);
      if (d.use(aS, t.plugins.remarkRehypeOptions), t.plugins.rehype)
        for (const p of t.plugins.rehype)
          Array.isArray(p) ? d.use(p[0], p[1]) : d.use(p);
      return d.use(a), d.use(MC), d.freeze(), d;
    }
    const c = u();
    async function h(d) {
      return c.process(d);
    }
    const f = ZC(() => {
      try {
        h(i.value).then((d) => {
          o.value = d.toString(), _m().then(() => {
            l("update", s.value, r.value);
          });
        });
      } catch (d) {
        console.log(d);
      }
    }, t.interval);
    return ut(i, () => {
      f();
    }), Xl(() => {
      f();
    }), (d, p) => (se(), xe("div", {
      class: "markdown",
      innerHTML: o.value,
      ref_key: "real",
      ref: r
    }, null, 8, e3));
  }
}), n3 = { class: "cs-toolbar" }, i3 = { class: "cs-toolbar-group" }, r3 = ["onClick"], s3 = ["innerHTML"], o3 = { class: "cs-tooltip" }, l3 = { class: "cs-toolbar-group" }, a3 = ["onClick"], u3 = ["innerHTML"], c3 = { class: "cs-tooltip" }, h3 = /* @__PURE__ */ lt({
  __name: "MToolbar",
  props: {
    toolbarl: {},
    toolbarr: {},
    getCodemirror: { type: Function },
    getCasketstar: { type: Function },
    dialog: {}
  },
  setup(n) {
    const e = vh("i18n"), t = n;
    function i(r) {
      const s = t.getCodemirror(), o = t.getCasketstar();
      s && o && r.func(s, o, t.dialog);
    }
    return (r, s) => (se(), xe("div", n3, [
      I("div", null, [
        (se(!0), xe(qt, null, sn(t.toolbarl, (o) => (se(), xe("span", i3, [
          (se(!0), xe(qt, null, sn(o, (l) => (se(), xe("span", {
            class: "cs-toolbar-tool",
            onClick: (a) => i(l)
          }, [
            I("span", {
              class: "cs-toolbar-tool-button",
              innerHTML: l.icon
            }, null, 8, s3),
            I("span", o3, In(Wi(e)(l.name)), 1)
          ], 8, r3))), 256))
        ]))), 256))
      ]),
      I("div", null, [
        (se(!0), xe(qt, null, sn(t.toolbarr, (o) => (se(), xe("span", l3, [
          (se(!0), xe(qt, null, sn(o, (l) => (se(), xe("span", {
            class: "cs-toolbar-tool",
            onClick: (a) => i(l)
          }, [
            I("span", {
              class: "cs-toolbar-tool-button",
              innerHTML: l.icon
            }, null, 8, u3),
            I("span", c3, In(Wi(e)(l.name)), 1)
          ], 8, a3))), 256))
        ]))), 256))
      ])
    ]));
  }
});
function f3(n) {
  if (typeof n != "string")
    throw new TypeError("Expected a string");
  return n.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&").replace(/-/g, "\\x2d");
}
function d3(n, e, t) {
  const r = Js((t || {}).ignore || []), s = p3(e);
  let o = -1;
  for (; ++o < s.length; )
    $p(n, "text", l);
  function l(u, c) {
    let h = -1, f;
    for (; ++h < c.length; ) {
      const d = c[h], p = f ? f.children : void 0;
      if (r(
        d,
        p ? p.indexOf(d) : void 0,
        f
      ))
        return;
      f = d;
    }
    if (f)
      return a(u, c);
  }
  function a(u, c) {
    const h = c[c.length - 1], f = s[o][0], d = s[o][1];
    let p = 0;
    const m = h.children.indexOf(u);
    let y = !1, v = [];
    f.lastIndex = 0;
    let C = f.exec(u.value);
    for (; C; ) {
      const O = C.index, A = {
        index: C.index,
        input: C.input,
        stack: [...c, u]
      };
      let b = d(...C, A);
      if (typeof b == "string" && (b = b.length > 0 ? { type: "text", value: b } : void 0), b === !1 ? f.lastIndex = O + 1 : (p !== O && v.push({
        type: "text",
        value: u.value.slice(p, O)
      }), Array.isArray(b) ? v.push(...b) : b && v.push(b), p = O + C[0].length, y = !0), !f.global)
        break;
      C = f.exec(u.value);
    }
    return y ? (p < u.value.length && v.push({ type: "text", value: u.value.slice(p) }), h.children.splice(m, 1, ...v)) : v = [u], m + v.length;
  }
}
function p3(n) {
  const e = [];
  if (!Array.isArray(n))
    throw new TypeError("Expected find and replace tuple or list of tuples");
  const t = !n[0] || Array.isArray(n[0]) ? n : [n];
  let i = -1;
  for (; ++i < t.length; ) {
    const r = t[i];
    e.push([m3(r[0]), g3(r[1])]);
  }
  return e;
}
function m3(n) {
  return typeof n == "string" ? new RegExp(f3(n), "g") : n;
}
function g3(n) {
  return typeof n == "function" ? n : function() {
    return n;
  };
}
const Ho = "phrasing", Vo = ["autolink", "link", "image", "label"];
function y3() {
  return {
    transforms: [C3],
    enter: {
      literalAutolink: x3,
      literalAutolinkEmail: _o,
      literalAutolinkHttp: _o,
      literalAutolinkWww: _o
    },
    exit: {
      literalAutolink: S3,
      literalAutolinkEmail: v3,
      literalAutolinkHttp: w3,
      literalAutolinkWww: k3
    }
  };
}
function b3() {
  return {
    unsafe: [
      {
        character: "@",
        before: "[+\\-.\\w]",
        after: "[\\-.\\w]",
        inConstruct: Ho,
        notInConstruct: Vo
      },
      {
        character: ".",
        before: "[Ww]",
        after: "[\\-.\\w]",
        inConstruct: Ho,
        notInConstruct: Vo
      },
      {
        character: ":",
        before: "[ps]",
        after: "\\/",
        inConstruct: Ho,
        notInConstruct: Vo
      }
    ]
  };
}
function x3(n) {
  this.enter({ type: "link", title: null, url: "", children: [] }, n);
}
function _o(n) {
  this.config.enter.autolinkProtocol.call(this, n);
}
function w3(n) {
  this.config.exit.autolinkProtocol.call(this, n);
}
function k3(n) {
  this.config.exit.data.call(this, n);
  const e = this.stack[this.stack.length - 1];
  e.type, e.url = "http://" + this.sliceSerialize(n);
}
function v3(n) {
  this.config.exit.autolinkEmail.call(this, n);
}
function S3(n) {
  this.exit(n);
}
function C3(n) {
  d3(
    n,
    [
      [/(https?:\/\/|www(?=\.))([-.\w]+)([^ \t\r\n]*)/gi, A3],
      [/([-.\w+]+)@([-\w]+(?:\.[-\w]+)+)/g, M3]
    ],
    { ignore: ["link", "linkReference"] }
  );
}
function A3(n, e, t, i, r) {
  let s = "";
  if (!lm(r) || (/^w/i.test(e) && (t = e + t, e = "", s = "http://"), !T3(t)))
    return !1;
  const o = O3(t + i);
  if (!o[0])
    return !1;
  const l = {
    type: "link",
    title: null,
    url: s + e + o[0],
    children: [{ type: "text", value: e + o[0] }]
  };
  return o[1] ? [l, { type: "text", value: o[1] }] : l;
}
function M3(n, e, t, i) {
  return (
    // Not an expected previous character.
    !lm(i, !0) || // Label ends in not allowed character.
    /[-\d_]$/.test(t) ? !1 : {
      type: "link",
      title: null,
      url: "mailto:" + e + "@" + t,
      children: [{ type: "text", value: e + "@" + t }]
    }
  );
}
function T3(n) {
  const e = n.split(".");
  return !(e.length < 2 || e[e.length - 1] && (/_/.test(e[e.length - 1]) || !/[a-zA-Z\d]/.test(e[e.length - 1])) || e[e.length - 2] && (/_/.test(e[e.length - 2]) || !/[a-zA-Z\d]/.test(e[e.length - 2])));
}
function O3(n) {
  const e = /[!"&'),.:;<>?\]}]+$/.exec(n);
  if (!e)
    return [n, void 0];
  n = n.slice(0, e.index);
  let t = e[0], i = t.indexOf(")");
  const r = Es(n, "(");
  let s = Es(n, ")");
  for (; i !== -1 && r > s; )
    n += t.slice(0, i + 1), t = t.slice(i + 1), i = t.indexOf(")"), s++;
  return [n, t];
}
function lm(n, e) {
  const t = n.input.charCodeAt(n.index - 1);
  return (n.index === 0 || zn(t) || Gs(t)) && (!e || t !== 47);
}
am.peek = H3;
function D3() {
  return {
    enter: {
      gfmFootnoteDefinition: L3,
      gfmFootnoteDefinitionLabelString: I3,
      gfmFootnoteCall: R3,
      gfmFootnoteCallString: N3
    },
    exit: {
      gfmFootnoteDefinition: B3,
      gfmFootnoteDefinitionLabelString: P3,
      gfmFootnoteCall: z3,
      gfmFootnoteCallString: F3
    }
  };
}
function E3() {
  return {
    // This is on by default already.
    unsafe: [{ character: "[", inConstruct: ["phrasing", "label", "reference"] }],
    handlers: { footnoteDefinition: V3, footnoteReference: am }
  };
}
function L3(n) {
  this.enter(
    { type: "footnoteDefinition", identifier: "", label: "", children: [] },
    n
  );
}
function I3() {
  this.buffer();
}
function P3(n) {
  const e = this.resume(), t = this.stack[this.stack.length - 1];
  t.type, t.label = e, t.identifier = St(
    this.sliceSerialize(n)
  ).toLowerCase();
}
function B3(n) {
  this.exit(n);
}
function R3(n) {
  this.enter({ type: "footnoteReference", identifier: "", label: "" }, n);
}
function N3() {
  this.buffer();
}
function F3(n) {
  const e = this.resume(), t = this.stack[this.stack.length - 1];
  t.type, t.label = e, t.identifier = St(
    this.sliceSerialize(n)
  ).toLowerCase();
}
function z3(n) {
  this.exit(n);
}
function am(n, e, t, i) {
  const r = t.createTracker(i);
  let s = r.move("[^");
  const o = t.enter("footnoteReference"), l = t.enter("reference");
  return s += r.move(
    t.safe(t.associationId(n), {
      ...r.current(),
      before: s,
      after: "]"
    })
  ), l(), o(), s += r.move("]"), s;
}
function H3() {
  return "[";
}
function V3(n, e, t, i) {
  const r = t.createTracker(i);
  let s = r.move("[^");
  const o = t.enter("footnoteDefinition"), l = t.enter("label");
  return s += r.move(
    t.safe(t.associationId(n), {
      ...r.current(),
      before: s,
      after: "]"
    })
  ), l(), s += r.move(
    "]:" + (n.children && n.children.length > 0 ? " " : "")
  ), r.shift(4), s += r.move(
    t.indentLines(t.containerFlow(n, r.current()), _3)
  ), o(), s;
}
function _3(n, e, t) {
  return e === 0 ? n : (t ? "" : "    ") + n;
}
const $3 = [
  "autolink",
  "destinationLiteral",
  "destinationRaw",
  "reference",
  "titleQuote",
  "titleApostrophe"
];
um.peek = K3;
function j3() {
  return {
    canContainEols: ["delete"],
    enter: { strikethrough: q3 },
    exit: { strikethrough: U3 }
  };
}
function W3() {
  return {
    unsafe: [
      {
        character: "~",
        inConstruct: "phrasing",
        notInConstruct: $3
      }
    ],
    handlers: { delete: um }
  };
}
function q3(n) {
  this.enter({ type: "delete", children: [] }, n);
}
function U3(n) {
  this.exit(n);
}
function um(n, e, t, i) {
  const r = t.createTracker(i), s = t.enter("strikethrough");
  let o = r.move("~~");
  return o += t.containerPhrasing(n, {
    ...r.current(),
    before: o,
    after: "~"
  }), o += r.move("~~"), s(), o;
}
function K3() {
  return "~";
}
function G3(n, e = {}) {
  const t = (e.align || []).concat(), i = e.stringLength || X3, r = [], s = [], o = [], l = [];
  let a = 0, u = -1;
  for (; ++u < n.length; ) {
    const p = [], g = [];
    let m = -1;
    for (n[u].length > a && (a = n[u].length); ++m < n[u].length; ) {
      const y = Y3(n[u][m]);
      if (e.alignDelimiters !== !1) {
        const v = i(y);
        g[m] = v, (l[m] === void 0 || v > l[m]) && (l[m] = v);
      }
      p.push(y);
    }
    s[u] = p, o[u] = g;
  }
  let c = -1;
  if (typeof t == "object" && "length" in t)
    for (; ++c < a; )
      r[c] = mh(t[c]);
  else {
    const p = mh(t);
    for (; ++c < a; )
      r[c] = p;
  }
  c = -1;
  const h = [], f = [];
  for (; ++c < a; ) {
    const p = r[c];
    let g = "", m = "";
    p === 99 ? (g = ":", m = ":") : p === 108 ? g = ":" : p === 114 && (m = ":");
    let y = e.alignDelimiters === !1 ? 1 : Math.max(
      1,
      l[c] - g.length - m.length
    );
    const v = g + "-".repeat(y) + m;
    e.alignDelimiters !== !1 && (y = g.length + y + m.length, y > l[c] && (l[c] = y), f[c] = y), h[c] = v;
  }
  s.splice(1, 0, h), o.splice(1, 0, f), u = -1;
  const d = [];
  for (; ++u < s.length; ) {
    const p = s[u], g = o[u];
    c = -1;
    const m = [];
    for (; ++c < a; ) {
      const y = p[c] || "";
      let v = "", C = "";
      if (e.alignDelimiters !== !1) {
        const O = l[c] - (g[c] || 0), A = r[c];
        A === 114 ? v = " ".repeat(O) : A === 99 ? O % 2 ? (v = " ".repeat(O / 2 + 0.5), C = " ".repeat(O / 2 - 0.5)) : (v = " ".repeat(O / 2), C = v) : C = " ".repeat(O);
      }
      e.delimiterStart !== !1 && !c && m.push("|"), e.padding !== !1 && // Don’t add the opening space if we’re not aligning and the cell is
      // empty: there will be a closing space.
      !(e.alignDelimiters === !1 && y === "") && (e.delimiterStart !== !1 || c) && m.push(" "), e.alignDelimiters !== !1 && m.push(v), m.push(y), e.alignDelimiters !== !1 && m.push(C), e.padding !== !1 && m.push(" "), (e.delimiterEnd !== !1 || c !== a - 1) && m.push("|");
    }
    d.push(
      e.delimiterEnd === !1 ? m.join("").replace(/ +$/, "") : m.join("")
    );
  }
  return d.join(`
`);
}
function Y3(n) {
  return n == null ? "" : String(n);
}
function X3(n) {
  return n.length;
}
function mh(n) {
  const e = typeof n == "string" ? n.codePointAt(0) : 0;
  return e === 67 || e === 99 ? 99 : e === 76 || e === 108 ? 108 : e === 82 || e === 114 ? 114 : 0;
}
function J3(n, e, t, i) {
  const r = t.enter("blockquote"), s = t.createTracker(i);
  s.move("> "), s.shift(2);
  const o = t.indentLines(
    t.containerFlow(n, s.current()),
    Q3
  );
  return r(), o;
}
function Q3(n, e, t) {
  return ">" + (t ? "" : " ") + n;
}
function Z3(n, e) {
  return gh(n, e.inConstruct, !0) && !gh(n, e.notInConstruct, !1);
}
function gh(n, e, t) {
  if (typeof e == "string" && (e = [e]), !e || e.length === 0)
    return t;
  let i = -1;
  for (; ++i < e.length; )
    if (n.includes(e[i]))
      return !0;
  return !1;
}
function yh(n, e, t, i) {
  let r = -1;
  for (; ++r < t.unsafe.length; )
    if (t.unsafe[r].character === `
` && Z3(t.stack, t.unsafe[r]))
      return /[ \t]/.test(i.before) ? "" : " ";
  return `\\
`;
}
function e4(n, e) {
  const t = String(n);
  let i = t.indexOf(e), r = i, s = 0, o = 0;
  if (typeof e != "string")
    throw new TypeError("Expected substring");
  for (; i !== -1; )
    i === r ? ++s > o && (o = s) : s = 1, r = i + e.length, i = t.indexOf(e, r);
  return o;
}
function t4(n, e) {
  return !!(e.options.fences === !1 && n.value && // If there’s no info…
  !n.lang && // And there’s a non-whitespace character…
  /[^ \r\n]/.test(n.value) && // And the value doesn’t start or end in a blank…
  !/^[\t ]*(?:[\r\n]|$)|(?:^|[\r\n])[\t ]*$/.test(n.value));
}
function n4(n) {
  const e = n.options.fence || "`";
  if (e !== "`" && e !== "~")
    throw new Error(
      "Cannot serialize code with `" + e + "` for `options.fence`, expected `` ` `` or `~`"
    );
  return e;
}
function i4(n, e, t, i) {
  const r = n4(t), s = n.value || "", o = r === "`" ? "GraveAccent" : "Tilde";
  if (t4(n, t)) {
    const h = t.enter("codeIndented"), f = t.indentLines(s, r4);
    return h(), f;
  }
  const l = t.createTracker(i), a = r.repeat(Math.max(e4(s, r) + 1, 3)), u = t.enter("codeFenced");
  let c = l.move(a);
  if (n.lang) {
    const h = t.enter(`codeFencedLang${o}`);
    c += l.move(
      t.safe(n.lang, {
        before: c,
        after: " ",
        encode: ["`"],
        ...l.current()
      })
    ), h();
  }
  if (n.lang && n.meta) {
    const h = t.enter(`codeFencedMeta${o}`);
    c += l.move(" "), c += l.move(
      t.safe(n.meta, {
        before: c,
        after: `
`,
        encode: ["`"],
        ...l.current()
      })
    ), h();
  }
  return c += l.move(`
`), s && (c += l.move(s + `
`)), c += l.move(a), u(), c;
}
function r4(n, e, t) {
  return (t ? "" : "    ") + n;
}
function Fa(n) {
  const e = n.options.quote || '"';
  if (e !== '"' && e !== "'")
    throw new Error(
      "Cannot serialize title with `" + e + "` for `options.quote`, expected `\"`, or `'`"
    );
  return e;
}
function s4(n, e, t, i) {
  const r = Fa(t), s = r === '"' ? "Quote" : "Apostrophe", o = t.enter("definition");
  let l = t.enter("label");
  const a = t.createTracker(i);
  let u = a.move("[");
  return u += a.move(
    t.safe(t.associationId(n), {
      before: u,
      after: "]",
      ...a.current()
    })
  ), u += a.move("]: "), l(), // If there’s no url, or…
  !n.url || // If there are control characters or whitespace.
  /[\0- \u007F]/.test(n.url) ? (l = t.enter("destinationLiteral"), u += a.move("<"), u += a.move(
    t.safe(n.url, { before: u, after: ">", ...a.current() })
  ), u += a.move(">")) : (l = t.enter("destinationRaw"), u += a.move(
    t.safe(n.url, {
      before: u,
      after: n.title ? " " : `
`,
      ...a.current()
    })
  )), l(), n.title && (l = t.enter(`title${s}`), u += a.move(" " + r), u += a.move(
    t.safe(n.title, {
      before: u,
      after: r,
      ...a.current()
    })
  ), u += a.move(r), l()), o(), u;
}
function o4(n) {
  const e = n.options.emphasis || "*";
  if (e !== "*" && e !== "_")
    throw new Error(
      "Cannot serialize emphasis with `" + e + "` for `options.emphasis`, expected `*`, or `_`"
    );
  return e;
}
cm.peek = l4;
function cm(n, e, t, i) {
  const r = o4(t), s = t.enter("emphasis"), o = t.createTracker(i);
  let l = o.move(r);
  return l += o.move(
    t.containerPhrasing(n, {
      before: l,
      after: r,
      ...o.current()
    })
  ), l += o.move(r), s(), l;
}
function l4(n, e, t) {
  return t.options.emphasis || "*";
}
function a4(n, e) {
  let t = !1;
  return jp(n, function(i) {
    if ("value" in i && /\r?\n|\r/.test(i.value) || i.type === "break")
      return t = !0, Wl;
  }), !!((!n.depth || n.depth < 3) && Ta(n) && (e.options.setext || t));
}
function u4(n, e, t, i) {
  const r = Math.max(Math.min(6, n.depth || 1), 1), s = t.createTracker(i);
  if (a4(n, t)) {
    const c = t.enter("headingSetext"), h = t.enter("phrasing"), f = t.containerPhrasing(n, {
      ...s.current(),
      before: `
`,
      after: `
`
    });
    return h(), c(), f + `
` + (r === 1 ? "=" : "-").repeat(
      // The whole size…
      f.length - // Minus the position of the character after the last EOL (or
      // 0 if there is none)…
      (Math.max(f.lastIndexOf("\r"), f.lastIndexOf(`
`)) + 1)
    );
  }
  const o = "#".repeat(r), l = t.enter("headingAtx"), a = t.enter("phrasing");
  s.move(o + " ");
  let u = t.containerPhrasing(n, {
    before: "# ",
    after: `
`,
    ...s.current()
  });
  return /^[\t ]/.test(u) && (u = "&#x" + u.charCodeAt(0).toString(16).toUpperCase() + ";" + u.slice(1)), u = u ? o + " " + u : o, t.options.closeAtx && (u += " " + o), a(), l(), u;
}
hm.peek = c4;
function hm(n) {
  return n.value || "";
}
function c4() {
  return "<";
}
fm.peek = h4;
function fm(n, e, t, i) {
  const r = Fa(t), s = r === '"' ? "Quote" : "Apostrophe", o = t.enter("image");
  let l = t.enter("label");
  const a = t.createTracker(i);
  let u = a.move("![");
  return u += a.move(
    t.safe(n.alt, { before: u, after: "]", ...a.current() })
  ), u += a.move("]("), l(), // If there’s no url but there is a title…
  !n.url && n.title || // If there are control characters or whitespace.
  /[\0- \u007F]/.test(n.url) ? (l = t.enter("destinationLiteral"), u += a.move("<"), u += a.move(
    t.safe(n.url, { before: u, after: ">", ...a.current() })
  ), u += a.move(">")) : (l = t.enter("destinationRaw"), u += a.move(
    t.safe(n.url, {
      before: u,
      after: n.title ? " " : ")",
      ...a.current()
    })
  )), l(), n.title && (l = t.enter(`title${s}`), u += a.move(" " + r), u += a.move(
    t.safe(n.title, {
      before: u,
      after: r,
      ...a.current()
    })
  ), u += a.move(r), l()), u += a.move(")"), o(), u;
}
function h4() {
  return "!";
}
dm.peek = f4;
function dm(n, e, t, i) {
  const r = n.referenceType, s = t.enter("imageReference");
  let o = t.enter("label");
  const l = t.createTracker(i);
  let a = l.move("![");
  const u = t.safe(n.alt, {
    before: a,
    after: "]",
    ...l.current()
  });
  a += l.move(u + "]["), o();
  const c = t.stack;
  t.stack = [], o = t.enter("reference");
  const h = t.safe(t.associationId(n), {
    before: a,
    after: "]",
    ...l.current()
  });
  return o(), t.stack = c, s(), r === "full" || !u || u !== h ? a += l.move(h + "]") : r === "shortcut" ? a = a.slice(0, -1) : a += l.move("]"), a;
}
function f4() {
  return "!";
}
pm.peek = d4;
function pm(n, e, t) {
  let i = n.value || "", r = "`", s = -1;
  for (; new RegExp("(^|[^`])" + r + "([^`]|$)").test(i); )
    r += "`";
  for (/[^ \r\n]/.test(i) && (/^[ \r\n]/.test(i) && /[ \r\n]$/.test(i) || /^`|`$/.test(i)) && (i = " " + i + " "); ++s < t.unsafe.length; ) {
    const o = t.unsafe[s], l = t.compilePattern(o);
    let a;
    if (o.atBreak)
      for (; a = l.exec(i); ) {
        let u = a.index;
        i.charCodeAt(u) === 10 && i.charCodeAt(u - 1) === 13 && u--, i = i.slice(0, u) + " " + i.slice(a.index + 1);
      }
  }
  return r + i + r;
}
function d4() {
  return "`";
}
function mm(n, e) {
  const t = Ta(n);
  return !!(!e.options.resourceLink && // If there’s a url…
  n.url && // And there’s a no title…
  !n.title && // And the content of `node` is a single text node…
  n.children && n.children.length === 1 && n.children[0].type === "text" && // And if the url is the same as the content…
  (t === n.url || "mailto:" + t === n.url) && // And that starts w/ a protocol…
  /^[a-z][a-z+.-]+:/i.test(n.url) && // And that doesn’t contain ASCII control codes (character escapes and
  // references don’t work), space, or angle brackets…
  !/[\0- <>\u007F]/.test(n.url));
}
gm.peek = p4;
function gm(n, e, t, i) {
  const r = Fa(t), s = r === '"' ? "Quote" : "Apostrophe", o = t.createTracker(i);
  let l, a;
  if (mm(n, t)) {
    const c = t.stack;
    t.stack = [], l = t.enter("autolink");
    let h = o.move("<");
    return h += o.move(
      t.containerPhrasing(n, {
        before: h,
        after: ">",
        ...o.current()
      })
    ), h += o.move(">"), l(), t.stack = c, h;
  }
  l = t.enter("link"), a = t.enter("label");
  let u = o.move("[");
  return u += o.move(
    t.containerPhrasing(n, {
      before: u,
      after: "](",
      ...o.current()
    })
  ), u += o.move("]("), a(), // If there’s no url but there is a title…
  !n.url && n.title || // If there are control characters or whitespace.
  /[\0- \u007F]/.test(n.url) ? (a = t.enter("destinationLiteral"), u += o.move("<"), u += o.move(
    t.safe(n.url, { before: u, after: ">", ...o.current() })
  ), u += o.move(">")) : (a = t.enter("destinationRaw"), u += o.move(
    t.safe(n.url, {
      before: u,
      after: n.title ? " " : ")",
      ...o.current()
    })
  )), a(), n.title && (a = t.enter(`title${s}`), u += o.move(" " + r), u += o.move(
    t.safe(n.title, {
      before: u,
      after: r,
      ...o.current()
    })
  ), u += o.move(r), a()), u += o.move(")"), l(), u;
}
function p4(n, e, t) {
  return mm(n, t) ? "<" : "[";
}
ym.peek = m4;
function ym(n, e, t, i) {
  const r = n.referenceType, s = t.enter("linkReference");
  let o = t.enter("label");
  const l = t.createTracker(i);
  let a = l.move("[");
  const u = t.containerPhrasing(n, {
    before: a,
    after: "]",
    ...l.current()
  });
  a += l.move(u + "]["), o();
  const c = t.stack;
  t.stack = [], o = t.enter("reference");
  const h = t.safe(t.associationId(n), {
    before: a,
    after: "]",
    ...l.current()
  });
  return o(), t.stack = c, s(), r === "full" || !u || u !== h ? a += l.move(h + "]") : r === "shortcut" ? a = a.slice(0, -1) : a += l.move("]"), a;
}
function m4() {
  return "[";
}
function za(n) {
  const e = n.options.bullet || "*";
  if (e !== "*" && e !== "+" && e !== "-")
    throw new Error(
      "Cannot serialize items with `" + e + "` for `options.bullet`, expected `*`, `+`, or `-`"
    );
  return e;
}
function g4(n) {
  const e = za(n), t = n.options.bulletOther;
  if (!t)
    return e === "*" ? "-" : "*";
  if (t !== "*" && t !== "+" && t !== "-")
    throw new Error(
      "Cannot serialize items with `" + t + "` for `options.bulletOther`, expected `*`, `+`, or `-`"
    );
  if (t === e)
    throw new Error(
      "Expected `bullet` (`" + e + "`) and `bulletOther` (`" + t + "`) to be different"
    );
  return t;
}
function y4(n) {
  const e = n.options.bulletOrdered || ".";
  if (e !== "." && e !== ")")
    throw new Error(
      "Cannot serialize items with `" + e + "` for `options.bulletOrdered`, expected `.` or `)`"
    );
  return e;
}
function bm(n) {
  const e = n.options.rule || "*";
  if (e !== "*" && e !== "-" && e !== "_")
    throw new Error(
      "Cannot serialize rules with `" + e + "` for `options.rule`, expected `*`, `-`, or `_`"
    );
  return e;
}
function b4(n, e, t, i) {
  const r = t.enter("list"), s = t.bulletCurrent;
  let o = n.ordered ? y4(t) : za(t);
  const l = n.ordered ? o === "." ? ")" : "." : g4(t);
  let a = e && t.bulletLastUsed ? o === t.bulletLastUsed : !1;
  if (!n.ordered) {
    const c = n.children ? n.children[0] : void 0;
    if (
      // Bullet could be used as a thematic break marker:
      (o === "*" || o === "-") && // Empty first list item:
      c && (!c.children || !c.children[0]) && // Directly in two other list items:
      t.stack[t.stack.length - 1] === "list" && t.stack[t.stack.length - 2] === "listItem" && t.stack[t.stack.length - 3] === "list" && t.stack[t.stack.length - 4] === "listItem" && // That are each the first child.
      t.indexStack[t.indexStack.length - 1] === 0 && t.indexStack[t.indexStack.length - 2] === 0 && t.indexStack[t.indexStack.length - 3] === 0 && (a = !0), bm(t) === o && c
    ) {
      let h = -1;
      for (; ++h < n.children.length; ) {
        const f = n.children[h];
        if (f && f.type === "listItem" && f.children && f.children[0] && f.children[0].type === "thematicBreak") {
          a = !0;
          break;
        }
      }
    }
  }
  a && (o = l), t.bulletCurrent = o;
  const u = t.containerFlow(n, i);
  return t.bulletLastUsed = o, t.bulletCurrent = s, r(), u;
}
function x4(n) {
  const e = n.options.listItemIndent || "one";
  if (e !== "tab" && e !== "one" && e !== "mixed")
    throw new Error(
      "Cannot serialize items with `" + e + "` for `options.listItemIndent`, expected `tab`, `one`, or `mixed`"
    );
  return e;
}
function w4(n, e, t, i) {
  const r = x4(t);
  let s = t.bulletCurrent || za(t);
  e && e.type === "list" && e.ordered && (s = (typeof e.start == "number" && e.start > -1 ? e.start : 1) + (t.options.incrementListMarker === !1 ? 0 : e.children.indexOf(n)) + s);
  let o = s.length + 1;
  (r === "tab" || r === "mixed" && (e && e.type === "list" && e.spread || n.spread)) && (o = Math.ceil(o / 4) * 4);
  const l = t.createTracker(i);
  l.move(s + " ".repeat(o - s.length)), l.shift(o);
  const a = t.enter("listItem"), u = t.indentLines(
    t.containerFlow(n, l.current()),
    c
  );
  return a(), u;
  function c(h, f, d) {
    return f ? (d ? "" : " ".repeat(o)) + h : (d ? s : s + " ".repeat(o - s.length)) + h;
  }
}
function k4(n, e, t, i) {
  const r = t.enter("paragraph"), s = t.enter("phrasing"), o = t.containerPhrasing(n, i);
  return s(), r(), o;
}
const v4 = (
  /** @type {(node?: unknown) => node is Exclude<PhrasingContent, Html>} */
  Js([
    "break",
    "delete",
    "emphasis",
    // To do: next major: removed since footnotes were added to GFM.
    "footnote",
    "footnoteReference",
    "image",
    "imageReference",
    "inlineCode",
    // Enabled by `mdast-util-math`:
    "inlineMath",
    "link",
    "linkReference",
    // Enabled by `mdast-util-mdx`:
    "mdxJsxTextElement",
    // Enabled by `mdast-util-mdx`:
    "mdxTextExpression",
    "strong",
    "text",
    // Enabled by `mdast-util-directive`:
    "textDirective"
  ])
);
function S4(n, e, t, i) {
  return (n.children.some(function(o) {
    return v4(o);
  }) ? t.containerPhrasing : t.containerFlow).call(t, n, i);
}
function C4(n) {
  const e = n.options.strong || "*";
  if (e !== "*" && e !== "_")
    throw new Error(
      "Cannot serialize strong with `" + e + "` for `options.strong`, expected `*`, or `_`"
    );
  return e;
}
xm.peek = A4;
function xm(n, e, t, i) {
  const r = C4(t), s = t.enter("strong"), o = t.createTracker(i);
  let l = o.move(r + r);
  return l += o.move(
    t.containerPhrasing(n, {
      before: l,
      after: r,
      ...o.current()
    })
  ), l += o.move(r + r), s(), l;
}
function A4(n, e, t) {
  return t.options.strong || "*";
}
function M4(n, e, t, i) {
  return t.safe(n.value, i);
}
function T4(n) {
  const e = n.options.ruleRepetition || 3;
  if (e < 3)
    throw new Error(
      "Cannot serialize rules with repetition `" + e + "` for `options.ruleRepetition`, expected `3` or more"
    );
  return e;
}
function O4(n, e, t) {
  const i = (bm(t) + (t.options.ruleSpaces ? " " : "")).repeat(T4(t));
  return t.options.ruleSpaces ? i.slice(0, -1) : i;
}
const wm = {
  blockquote: J3,
  break: yh,
  code: i4,
  definition: s4,
  emphasis: cm,
  hardBreak: yh,
  heading: u4,
  html: hm,
  image: fm,
  imageReference: dm,
  inlineCode: pm,
  link: gm,
  linkReference: ym,
  list: b4,
  listItem: w4,
  paragraph: k4,
  root: S4,
  strong: xm,
  text: M4,
  thematicBreak: O4
};
function D4() {
  return {
    enter: {
      table: E4,
      tableData: bh,
      tableHeader: bh,
      tableRow: I4
    },
    exit: {
      codeText: P4,
      table: L4,
      tableData: $o,
      tableHeader: $o,
      tableRow: $o
    }
  };
}
function E4(n) {
  const e = n._align;
  this.enter(
    {
      type: "table",
      align: e.map(function(t) {
        return t === "none" ? null : t;
      }),
      children: []
    },
    n
  ), this.data.inTable = !0;
}
function L4(n) {
  this.exit(n), this.data.inTable = void 0;
}
function I4(n) {
  this.enter({ type: "tableRow", children: [] }, n);
}
function $o(n) {
  this.exit(n);
}
function bh(n) {
  this.enter({ type: "tableCell", children: [] }, n);
}
function P4(n) {
  let e = this.resume();
  this.data.inTable && (e = e.replace(/\\([\\|])/g, B4));
  const t = this.stack[this.stack.length - 1];
  t.type, t.value = e, this.exit(n);
}
function B4(n, e) {
  return e === "|" ? e : n;
}
function R4(n) {
  const e = n || {}, t = e.tableCellPadding, i = e.tablePipeAlign, r = e.stringLength, s = t ? " " : "|";
  return {
    unsafe: [
      { character: "\r", inConstruct: "tableCell" },
      { character: `
`, inConstruct: "tableCell" },
      // A pipe, when followed by a tab or space (padding), or a dash or colon
      // (unpadded delimiter row), could result in a table.
      { atBreak: !0, character: "|", after: "[	 :-]" },
      // A pipe in a cell must be encoded.
      { character: "|", inConstruct: "tableCell" },
      // A colon must be followed by a dash, in which case it could start a
      // delimiter row.
      { atBreak: !0, character: ":", after: "-" },
      // A delimiter row can also start with a dash, when followed by more
      // dashes, a colon, or a pipe.
      // This is a stricter version than the built in check for lists, thematic
      // breaks, and setex heading underlines though:
      // <https://github.com/syntax-tree/mdast-util-to-markdown/blob/51a2038/lib/unsafe.js#L57>
      { atBreak: !0, character: "-", after: "[:|-]" }
    ],
    handlers: {
      inlineCode: f,
      table: o,
      tableCell: a,
      tableRow: l
    }
  };
  function o(d, p, g, m) {
    return u(c(d, g, m), d.align);
  }
  function l(d, p, g, m) {
    const y = h(d, g, m), v = u([y]);
    return v.slice(0, v.indexOf(`
`));
  }
  function a(d, p, g, m) {
    const y = g.enter("tableCell"), v = g.enter("phrasing"), C = g.containerPhrasing(d, {
      ...m,
      before: s,
      after: s
    });
    return v(), y(), C;
  }
  function u(d, p) {
    return G3(d, {
      align: p,
      // @ts-expect-error: `markdown-table` types should support `null`.
      alignDelimiters: i,
      // @ts-expect-error: `markdown-table` types should support `null`.
      padding: t,
      // @ts-expect-error: `markdown-table` types should support `null`.
      stringLength: r
    });
  }
  function c(d, p, g) {
    const m = d.children;
    let y = -1;
    const v = [], C = p.enter("table");
    for (; ++y < m.length; )
      v[y] = h(m[y], p, g);
    return C(), v;
  }
  function h(d, p, g) {
    const m = d.children;
    let y = -1;
    const v = [], C = p.enter("tableRow");
    for (; ++y < m.length; )
      v[y] = a(m[y], d, p, g);
    return C(), v;
  }
  function f(d, p, g) {
    let m = wm.inlineCode(d, p, g);
    return g.stack.includes("tableCell") && (m = m.replace(/\|/g, "\\$&")), m;
  }
}
function N4() {
  return {
    exit: {
      taskListCheckValueChecked: xh,
      taskListCheckValueUnchecked: xh,
      paragraph: z4
    }
  };
}
function F4() {
  return {
    unsafe: [{ atBreak: !0, character: "-", after: "[:|-]" }],
    handlers: { listItem: H4 }
  };
}
function xh(n) {
  const e = this.stack[this.stack.length - 2];
  e.type, e.checked = n.type === "taskListCheckValueChecked";
}
function z4(n) {
  const e = this.stack[this.stack.length - 2];
  if (e && e.type === "listItem" && typeof e.checked == "boolean") {
    const t = this.stack[this.stack.length - 1];
    t.type;
    const i = t.children[0];
    if (i && i.type === "text") {
      const r = e.children;
      let s = -1, o;
      for (; ++s < r.length; ) {
        const l = r[s];
        if (l.type === "paragraph") {
          o = l;
          break;
        }
      }
      o === t && (i.value = i.value.slice(1), i.value.length === 0 ? t.children.shift() : t.position && i.position && typeof i.position.start.offset == "number" && (i.position.start.column++, i.position.start.offset++, t.position.start = Object.assign({}, i.position.start)));
    }
  }
  this.exit(n);
}
function H4(n, e, t, i) {
  const r = n.children[0], s = typeof n.checked == "boolean" && r && r.type === "paragraph", o = "[" + (n.checked ? "x" : " ") + "] ", l = t.createTracker(i);
  s && l.move(o);
  let a = wm.listItem(n, e, t, {
    ...i,
    ...l.current()
  });
  return s && (a = a.replace(/^(?:[*+-]|\d+\.)([\r\n]| {1,3})/, u)), a;
  function u(c) {
    return c + o;
  }
}
function V4() {
  return [
    y3(),
    D3(),
    j3(),
    D4(),
    N4()
  ];
}
function _4(n) {
  return {
    extensions: [
      b3(),
      E3(),
      W3(),
      R4(n),
      F4()
    ]
  };
}
const $4 = {
  tokenize: G4,
  partial: !0
}, km = {
  tokenize: Y4,
  partial: !0
}, vm = {
  tokenize: X4,
  partial: !0
}, Sm = {
  tokenize: J4,
  partial: !0
}, j4 = {
  tokenize: Q4,
  partial: !0
}, Cm = {
  tokenize: U4,
  previous: Mm
}, Am = {
  tokenize: K4,
  previous: Tm
}, Qt = {
  tokenize: q4,
  previous: Om
}, $t = {};
function W4() {
  return {
    text: $t
  };
}
let An = 48;
for (; An < 123; )
  $t[An] = Qt, An++, An === 58 ? An = 65 : An === 91 && (An = 97);
$t[43] = Qt;
$t[45] = Qt;
$t[46] = Qt;
$t[95] = Qt;
$t[72] = [Qt, Am];
$t[104] = [Qt, Am];
$t[87] = [Qt, Cm];
$t[119] = [Qt, Cm];
function q4(n, e, t) {
  const i = this;
  let r, s;
  return o;
  function o(h) {
    return !Yl(h) || !Om.call(i, i.previous) || Ha(i.events) ? t(h) : (n.enter("literalAutolink"), n.enter("literalAutolinkEmail"), l(h));
  }
  function l(h) {
    return Yl(h) ? (n.consume(h), l) : h === 64 ? (n.consume(h), a) : t(h);
  }
  function a(h) {
    return h === 46 ? n.check(
      j4,
      c,
      u
    )(h) : h === 45 || h === 95 || Ve(h) ? (s = !0, n.consume(h), a) : c(h);
  }
  function u(h) {
    return n.consume(h), r = !0, a;
  }
  function c(h) {
    return s && r && Ue(i.previous) ? (n.exit("literalAutolinkEmail"), n.exit("literalAutolink"), e(h)) : t(h);
  }
}
function U4(n, e, t) {
  const i = this;
  return r;
  function r(o) {
    return o !== 87 && o !== 119 || !Mm.call(i, i.previous) || Ha(i.events) ? t(o) : (n.enter("literalAutolink"), n.enter("literalAutolinkWww"), n.check(
      $4,
      n.attempt(km, n.attempt(vm, s), t),
      t
    )(o));
  }
  function s(o) {
    return n.exit("literalAutolinkWww"), n.exit("literalAutolink"), e(o);
  }
}
function K4(n, e, t) {
  const i = this;
  let r = "", s = !1;
  return o;
  function o(h) {
    return (h === 72 || h === 104) && Tm.call(i, i.previous) && !Ha(i.events) ? (n.enter("literalAutolink"), n.enter("literalAutolinkHttp"), r += String.fromCodePoint(h), n.consume(h), l) : t(h);
  }
  function l(h) {
    if (Ue(h) && r.length < 5)
      return r += String.fromCodePoint(h), n.consume(h), l;
    if (h === 58) {
      const f = r.toLowerCase();
      if (f === "http" || f === "https")
        return n.consume(h), a;
    }
    return t(h);
  }
  function a(h) {
    return h === 47 ? (n.consume(h), s ? u : (s = !0, a)) : t(h);
  }
  function u(h) {
    return h === null || As(h) || fe(h) || zn(h) || Gs(h) ? t(h) : n.attempt(km, n.attempt(vm, c), t)(h);
  }
  function c(h) {
    return n.exit("literalAutolinkHttp"), n.exit("literalAutolink"), e(h);
  }
}
function G4(n, e, t) {
  let i = 0;
  return r;
  function r(o) {
    return (o === 87 || o === 119) && i < 3 ? (i++, n.consume(o), r) : o === 46 && i === 3 ? (n.consume(o), s) : t(o);
  }
  function s(o) {
    return o === null ? t(o) : e(o);
  }
}
function Y4(n, e, t) {
  let i, r, s;
  return o;
  function o(u) {
    return u === 46 || u === 95 ? n.check(Sm, a, l)(u) : u === null || fe(u) || zn(u) || u !== 45 && Gs(u) ? a(u) : (s = !0, n.consume(u), o);
  }
  function l(u) {
    return u === 95 ? i = !0 : (r = i, i = void 0), n.consume(u), o;
  }
  function a(u) {
    return r || i || !s ? t(u) : e(u);
  }
}
function X4(n, e) {
  let t = 0, i = 0;
  return r;
  function r(o) {
    return o === 40 ? (t++, n.consume(o), r) : o === 41 && i < t ? s(o) : o === 33 || o === 34 || o === 38 || o === 39 || o === 41 || o === 42 || o === 44 || o === 46 || o === 58 || o === 59 || o === 60 || o === 63 || o === 93 || o === 95 || o === 126 ? n.check(Sm, e, s)(o) : o === null || fe(o) || zn(o) ? e(o) : (n.consume(o), r);
  }
  function s(o) {
    return o === 41 && i++, n.consume(o), r;
  }
}
function J4(n, e, t) {
  return i;
  function i(l) {
    return l === 33 || l === 34 || l === 39 || l === 41 || l === 42 || l === 44 || l === 46 || l === 58 || l === 59 || l === 63 || l === 95 || l === 126 ? (n.consume(l), i) : l === 38 ? (n.consume(l), s) : l === 93 ? (n.consume(l), r) : (
      // `<` is an end.
      l === 60 || // So is whitespace.
      l === null || fe(l) || zn(l) ? e(l) : t(l)
    );
  }
  function r(l) {
    return l === null || l === 40 || l === 91 || fe(l) || zn(l) ? e(l) : i(l);
  }
  function s(l) {
    return Ue(l) ? o(l) : t(l);
  }
  function o(l) {
    return l === 59 ? (n.consume(l), i) : Ue(l) ? (n.consume(l), o) : t(l);
  }
}
function Q4(n, e, t) {
  return i;
  function i(s) {
    return n.consume(s), r;
  }
  function r(s) {
    return Ve(s) ? t(s) : e(s);
  }
}
function Mm(n) {
  return n === null || n === 40 || n === 42 || n === 95 || n === 91 || n === 93 || n === 126 || fe(n);
}
function Tm(n) {
  return !Ue(n);
}
function Om(n) {
  return !(n === 47 || Yl(n));
}
function Yl(n) {
  return n === 43 || n === 45 || n === 46 || n === 95 || Ve(n);
}
function Ha(n) {
  let e = n.length, t = !1;
  for (; e--; ) {
    const i = n[e][1];
    if ((i.type === "labelLink" || i.type === "labelImage") && !i._balanced) {
      t = !0;
      break;
    }
    if (i._gfmAutolinkLiteralWalkedInto) {
      t = !1;
      break;
    }
  }
  return n.length > 0 && !t && (n[n.length - 1][1]._gfmAutolinkLiteralWalkedInto = !0), t;
}
const Z4 = {
  tokenize: lA,
  partial: !0
};
function eA() {
  return {
    document: {
      91: {
        tokenize: rA,
        continuation: {
          tokenize: sA
        },
        exit: oA
      }
    },
    text: {
      91: {
        tokenize: iA
      },
      93: {
        add: "after",
        tokenize: tA,
        resolveTo: nA
      }
    }
  };
}
function tA(n, e, t) {
  const i = this;
  let r = i.events.length;
  const s = i.parser.gfmFootnotes || (i.parser.gfmFootnotes = []);
  let o;
  for (; r--; ) {
    const a = i.events[r][1];
    if (a.type === "labelImage") {
      o = a;
      break;
    }
    if (a.type === "gfmFootnoteCall" || a.type === "labelLink" || a.type === "label" || a.type === "image" || a.type === "link")
      break;
  }
  return l;
  function l(a) {
    if (!o || !o._balanced)
      return t(a);
    const u = St(
      i.sliceSerialize({
        start: o.end,
        end: i.now()
      })
    );
    return u.codePointAt(0) !== 94 || !s.includes(u.slice(1)) ? t(a) : (n.enter("gfmFootnoteCallLabelMarker"), n.consume(a), n.exit("gfmFootnoteCallLabelMarker"), e(a));
  }
}
function nA(n, e) {
  let t = n.length;
  for (; t--; )
    if (n[t][1].type === "labelImage" && n[t][0] === "enter") {
      n[t][1];
      break;
    }
  n[t + 1][1].type = "data", n[t + 3][1].type = "gfmFootnoteCallLabelMarker";
  const i = {
    type: "gfmFootnoteCall",
    start: Object.assign({}, n[t + 3][1].start),
    end: Object.assign({}, n[n.length - 1][1].end)
  }, r = {
    type: "gfmFootnoteCallMarker",
    start: Object.assign({}, n[t + 3][1].end),
    end: Object.assign({}, n[t + 3][1].end)
  };
  r.end.column++, r.end.offset++, r.end._bufferIndex++;
  const s = {
    type: "gfmFootnoteCallString",
    start: Object.assign({}, r.end),
    end: Object.assign({}, n[n.length - 1][1].start)
  }, o = {
    type: "chunkString",
    contentType: "string",
    start: Object.assign({}, s.start),
    end: Object.assign({}, s.end)
  }, l = [
    // Take the `labelImageMarker` (now `data`, the `!`)
    n[t + 1],
    n[t + 2],
    ["enter", i, e],
    // The `[`
    n[t + 3],
    n[t + 4],
    // The `^`.
    ["enter", r, e],
    ["exit", r, e],
    // Everything in between.
    ["enter", s, e],
    ["enter", o, e],
    ["exit", o, e],
    ["exit", s, e],
    // The ending (`]`, properly parsed and labelled).
    n[n.length - 2],
    n[n.length - 1],
    ["exit", i, e]
  ];
  return n.splice(t, n.length - t + 1, ...l), n;
}
function iA(n, e, t) {
  const i = this, r = i.parser.gfmFootnotes || (i.parser.gfmFootnotes = []);
  let s = 0, o;
  return l;
  function l(h) {
    return n.enter("gfmFootnoteCall"), n.enter("gfmFootnoteCallLabelMarker"), n.consume(h), n.exit("gfmFootnoteCallLabelMarker"), a;
  }
  function a(h) {
    return h !== 94 ? t(h) : (n.enter("gfmFootnoteCallMarker"), n.consume(h), n.exit("gfmFootnoteCallMarker"), n.enter("gfmFootnoteCallString"), n.enter("chunkString").contentType = "string", u);
  }
  function u(h) {
    if (
      // Too long.
      s > 999 || // Closing brace with nothing.
      h === 93 && !o || // Space or tab is not supported by GFM for some reason.
      // `\n` and `[` not being supported makes sense.
      h === null || h === 91 || fe(h)
    )
      return t(h);
    if (h === 93) {
      n.exit("chunkString");
      const f = n.exit("gfmFootnoteCallString");
      return r.includes(St(i.sliceSerialize(f))) ? (n.enter("gfmFootnoteCallLabelMarker"), n.consume(h), n.exit("gfmFootnoteCallLabelMarker"), n.exit("gfmFootnoteCall"), e) : t(h);
    }
    return fe(h) || (o = !0), s++, n.consume(h), h === 92 ? c : u;
  }
  function c(h) {
    return h === 91 || h === 92 || h === 93 ? (n.consume(h), s++, u) : u(h);
  }
}
function rA(n, e, t) {
  const i = this, r = i.parser.gfmFootnotes || (i.parser.gfmFootnotes = []);
  let s, o = 0, l;
  return a;
  function a(p) {
    return n.enter("gfmFootnoteDefinition")._container = !0, n.enter("gfmFootnoteDefinitionLabel"), n.enter("gfmFootnoteDefinitionLabelMarker"), n.consume(p), n.exit("gfmFootnoteDefinitionLabelMarker"), u;
  }
  function u(p) {
    return p === 94 ? (n.enter("gfmFootnoteDefinitionMarker"), n.consume(p), n.exit("gfmFootnoteDefinitionMarker"), n.enter("gfmFootnoteDefinitionLabelString"), n.enter("chunkString").contentType = "string", c) : t(p);
  }
  function c(p) {
    if (
      // Too long.
      o > 999 || // Closing brace with nothing.
      p === 93 && !l || // Space or tab is not supported by GFM for some reason.
      // `\n` and `[` not being supported makes sense.
      p === null || p === 91 || fe(p)
    )
      return t(p);
    if (p === 93) {
      n.exit("chunkString");
      const g = n.exit("gfmFootnoteDefinitionLabelString");
      return s = St(i.sliceSerialize(g)), n.enter("gfmFootnoteDefinitionLabelMarker"), n.consume(p), n.exit("gfmFootnoteDefinitionLabelMarker"), n.exit("gfmFootnoteDefinitionLabel"), f;
    }
    return fe(p) || (l = !0), o++, n.consume(p), p === 92 ? h : c;
  }
  function h(p) {
    return p === 91 || p === 92 || p === 93 ? (n.consume(p), o++, c) : c(p);
  }
  function f(p) {
    return p === 58 ? (n.enter("definitionMarker"), n.consume(p), n.exit("definitionMarker"), r.includes(s) || r.push(s), te(
      n,
      d,
      "gfmFootnoteDefinitionWhitespace"
    )) : t(p);
  }
  function d(p) {
    return e(p);
  }
}
function sA(n, e, t) {
  return n.check(hr, e, n.attempt(Z4, e, t));
}
function oA(n) {
  n.exit("gfmFootnoteDefinition");
}
function lA(n, e, t) {
  const i = this;
  return te(
    n,
    r,
    "gfmFootnoteDefinitionIndent",
    5
  );
  function r(s) {
    const o = i.events[i.events.length - 1];
    return o && o[1].type === "gfmFootnoteDefinitionIndent" && o[2].sliceSerialize(o[1], !0).length === 4 ? e(s) : t(s);
  }
}
function aA(n) {
  let t = (n || {}).singleTilde;
  const i = {
    tokenize: s,
    resolveAll: r
  };
  return t == null && (t = !0), {
    text: {
      126: i
    },
    insideSpan: {
      null: [i]
    },
    attentionMarkers: {
      null: [126]
    }
  };
  function r(o, l) {
    let a = -1;
    for (; ++a < o.length; )
      if (o[a][0] === "enter" && o[a][1].type === "strikethroughSequenceTemporary" && o[a][1]._close) {
        let u = a;
        for (; u--; )
          if (o[u][0] === "exit" && o[u][1].type === "strikethroughSequenceTemporary" && o[u][1]._open && // If the sizes are the same:
          o[a][1].end.offset - o[a][1].start.offset === o[u][1].end.offset - o[u][1].start.offset) {
            o[a][1].type = "strikethroughSequence", o[u][1].type = "strikethroughSequence";
            const c = {
              type: "strikethrough",
              start: Object.assign({}, o[u][1].start),
              end: Object.assign({}, o[a][1].end)
            }, h = {
              type: "strikethroughText",
              start: Object.assign({}, o[u][1].end),
              end: Object.assign({}, o[a][1].start)
            }, f = [
              ["enter", c, l],
              ["enter", o[u][1], l],
              ["exit", o[u][1], l],
              ["enter", h, l]
            ], d = l.parser.constructs.insideSpan.null;
            d && gt(
              f,
              f.length,
              0,
              Ys(d, o.slice(u + 1, a), l)
            ), gt(f, f.length, 0, [
              ["exit", h, l],
              ["enter", o[a][1], l],
              ["exit", o[a][1], l],
              ["exit", c, l]
            ]), gt(o, u - 1, a - u + 3, f), a = u + f.length - 2;
            break;
          }
      }
    for (a = -1; ++a < o.length; )
      o[a][1].type === "strikethroughSequenceTemporary" && (o[a][1].type = "data");
    return o;
  }
  function s(o, l, a) {
    const u = this.previous, c = this.events;
    let h = 0;
    return f;
    function f(p) {
      return u === 126 && c[c.length - 1][1].type !== "characterEscape" ? a(p) : (o.enter("strikethroughSequenceTemporary"), d(p));
    }
    function d(p) {
      const g = Ms(u);
      if (p === 126)
        return h > 1 ? a(p) : (o.consume(p), h++, d);
      if (h < 2 && !t)
        return a(p);
      const m = o.exit("strikethroughSequenceTemporary"), y = Ms(p);
      return m._open = !y || y === 2 && !!g, m._close = !g || g === 2 && !!y, l(p);
    }
  }
}
class uA {
  /**
   * Create a new edit map.
   */
  constructor() {
    this.map = [];
  }
  /**
   * Create an edit: a remove and/or add at a certain place.
   *
   * @param {number} index
   * @param {number} remove
   * @param {Array<Event>} add
   * @returns {undefined}
   */
  add(e, t, i) {
    cA(this, e, t, i);
  }
  // To do: add this when moving to `micromark`.
  // /**
  //  * Create an edit: but insert `add` before existing additions.
  //  *
  //  * @param {number} index
  //  * @param {number} remove
  //  * @param {Array<Event>} add
  //  * @returns {undefined}
  //  */
  // addBefore(index, remove, add) {
  //   addImpl(this, index, remove, add, true)
  // }
  /**
   * Done, change the events.
   *
   * @param {Array<Event>} events
   * @returns {undefined}
   */
  consume(e) {
    if (this.map.sort(function(s, o) {
      return s[0] - o[0];
    }), this.map.length === 0)
      return;
    let t = this.map.length;
    const i = [];
    for (; t > 0; )
      t -= 1, i.push(
        e.slice(this.map[t][0] + this.map[t][1]),
        this.map[t][2]
      ), e.length = this.map[t][0];
    i.push([...e]), e.length = 0;
    let r = i.pop();
    for (; r; )
      e.push(...r), r = i.pop();
    this.map.length = 0;
  }
}
function cA(n, e, t, i) {
  let r = 0;
  if (!(t === 0 && i.length === 0)) {
    for (; r < n.map.length; ) {
      if (n.map[r][0] === e) {
        n.map[r][1] += t, n.map[r][2].push(...i);
        return;
      }
      r += 1;
    }
    n.map.push([e, t, i]);
  }
}
function hA(n, e) {
  let t = !1;
  const i = [];
  for (; e < n.length; ) {
    const r = n[e];
    if (t) {
      if (r[0] === "enter")
        r[1].type === "tableContent" && i.push(
          n[e + 1][1].type === "tableDelimiterMarker" ? "left" : "none"
        );
      else if (r[1].type === "tableContent") {
        if (n[e - 1][1].type === "tableDelimiterMarker") {
          const s = i.length - 1;
          i[s] = i[s] === "left" ? "center" : "right";
        }
      } else if (r[1].type === "tableDelimiterRow")
        break;
    } else
      r[0] === "enter" && r[1].type === "tableDelimiterRow" && (t = !0);
    e += 1;
  }
  return i;
}
function fA() {
  return {
    flow: {
      null: {
        tokenize: dA,
        resolveAll: pA
      }
    }
  };
}
function dA(n, e, t) {
  const i = this;
  let r = 0, s = 0, o;
  return l;
  function l(k) {
    let M = i.events.length - 1;
    for (; M > -1; ) {
      const _ = i.events[M][1].type;
      if (_ === "lineEnding" || // Note: markdown-rs uses `whitespace` instead of `linePrefix`
      _ === "linePrefix")
        M--;
      else
        break;
    }
    const D = M > -1 ? i.events[M][1].type : null, R = D === "tableHead" || D === "tableRow" ? b : a;
    return R === b && i.parser.lazy[i.now().line] ? t(k) : R(k);
  }
  function a(k) {
    return n.enter("tableHead"), n.enter("tableRow"), u(k);
  }
  function u(k) {
    return k === 124 || (o = !0, s += 1), c(k);
  }
  function c(k) {
    return k === null ? t(k) : W(k) ? s > 1 ? (s = 0, i.interrupt = !0, n.exit("tableRow"), n.enter("lineEnding"), n.consume(k), n.exit("lineEnding"), d) : t(k) : J(k) ? te(n, c, "whitespace")(k) : (s += 1, o && (o = !1, r += 1), k === 124 ? (n.enter("tableCellDivider"), n.consume(k), n.exit("tableCellDivider"), o = !0, c) : (n.enter("data"), h(k)));
  }
  function h(k) {
    return k === null || k === 124 || fe(k) ? (n.exit("data"), c(k)) : (n.consume(k), k === 92 ? f : h);
  }
  function f(k) {
    return k === 92 || k === 124 ? (n.consume(k), h) : h(k);
  }
  function d(k) {
    return i.interrupt = !1, i.parser.lazy[i.now().line] ? t(k) : (n.enter("tableDelimiterRow"), o = !1, J(k) ? te(
      n,
      p,
      "linePrefix",
      i.parser.constructs.disable.null.includes("codeIndented") ? void 0 : 4
    )(k) : p(k));
  }
  function p(k) {
    return k === 45 || k === 58 ? m(k) : k === 124 ? (o = !0, n.enter("tableCellDivider"), n.consume(k), n.exit("tableCellDivider"), g) : A(k);
  }
  function g(k) {
    return J(k) ? te(n, m, "whitespace")(k) : m(k);
  }
  function m(k) {
    return k === 58 ? (s += 1, o = !0, n.enter("tableDelimiterMarker"), n.consume(k), n.exit("tableDelimiterMarker"), y) : k === 45 ? (s += 1, y(k)) : k === null || W(k) ? O(k) : A(k);
  }
  function y(k) {
    return k === 45 ? (n.enter("tableDelimiterFiller"), v(k)) : A(k);
  }
  function v(k) {
    return k === 45 ? (n.consume(k), v) : k === 58 ? (o = !0, n.exit("tableDelimiterFiller"), n.enter("tableDelimiterMarker"), n.consume(k), n.exit("tableDelimiterMarker"), C) : (n.exit("tableDelimiterFiller"), C(k));
  }
  function C(k) {
    return J(k) ? te(n, O, "whitespace")(k) : O(k);
  }
  function O(k) {
    return k === 124 ? p(k) : k === null || W(k) ? !o || r !== s ? A(k) : (n.exit("tableDelimiterRow"), n.exit("tableHead"), e(k)) : A(k);
  }
  function A(k) {
    return t(k);
  }
  function b(k) {
    return n.enter("tableRow"), S(k);
  }
  function S(k) {
    return k === 124 ? (n.enter("tableCellDivider"), n.consume(k), n.exit("tableCellDivider"), S) : k === null || W(k) ? (n.exit("tableRow"), e(k)) : J(k) ? te(n, S, "whitespace")(k) : (n.enter("data"), L(k));
  }
  function L(k) {
    return k === null || k === 124 || fe(k) ? (n.exit("data"), S(k)) : (n.consume(k), k === 92 ? P : L);
  }
  function P(k) {
    return k === 92 || k === 124 ? (n.consume(k), L) : L(k);
  }
}
function pA(n, e) {
  let t = -1, i = !0, r = 0, s = [0, 0, 0, 0], o = [0, 0, 0, 0], l = !1, a = 0, u, c, h;
  const f = new uA();
  for (; ++t < n.length; ) {
    const d = n[t], p = d[1];
    d[0] === "enter" ? p.type === "tableHead" ? (l = !1, a !== 0 && (wh(f, e, a, u, c), c = void 0, a = 0), u = {
      type: "table",
      start: Object.assign({}, p.start),
      // Note: correct end is set later.
      end: Object.assign({}, p.end)
    }, f.add(t, 0, [["enter", u, e]])) : p.type === "tableRow" || p.type === "tableDelimiterRow" ? (i = !0, h = void 0, s = [0, 0, 0, 0], o = [0, t + 1, 0, 0], l && (l = !1, c = {
      type: "tableBody",
      start: Object.assign({}, p.start),
      // Note: correct end is set later.
      end: Object.assign({}, p.end)
    }, f.add(t, 0, [["enter", c, e]])), r = p.type === "tableDelimiterRow" ? 2 : c ? 3 : 1) : r && (p.type === "data" || p.type === "tableDelimiterMarker" || p.type === "tableDelimiterFiller") ? (i = !1, o[2] === 0 && (s[1] !== 0 && (o[0] = o[1], h = $r(
      f,
      e,
      s,
      r,
      void 0,
      h
    ), s = [0, 0, 0, 0]), o[2] = t)) : p.type === "tableCellDivider" && (i ? i = !1 : (s[1] !== 0 && (o[0] = o[1], h = $r(
      f,
      e,
      s,
      r,
      void 0,
      h
    )), s = o, o = [s[1], t, 0, 0])) : p.type === "tableHead" ? (l = !0, a = t) : p.type === "tableRow" || p.type === "tableDelimiterRow" ? (a = t, s[1] !== 0 ? (o[0] = o[1], h = $r(
      f,
      e,
      s,
      r,
      t,
      h
    )) : o[1] !== 0 && (h = $r(f, e, o, r, t, h)), r = 0) : r && (p.type === "data" || p.type === "tableDelimiterMarker" || p.type === "tableDelimiterFiller") && (o[3] = t);
  }
  for (a !== 0 && wh(f, e, a, u, c), f.consume(e.events), t = -1; ++t < e.events.length; ) {
    const d = e.events[t];
    d[0] === "enter" && d[1].type === "table" && (d[1]._align = hA(e.events, t));
  }
  return n;
}
function $r(n, e, t, i, r, s) {
  const o = i === 1 ? "tableHeader" : i === 2 ? "tableDelimiter" : "tableData", l = "tableContent";
  t[0] !== 0 && (s.end = Object.assign({}, Gn(e.events, t[0])), n.add(t[0], 0, [["exit", s, e]]));
  const a = Gn(e.events, t[1]);
  if (s = {
    type: o,
    start: Object.assign({}, a),
    // Note: correct end is set later.
    end: Object.assign({}, a)
  }, n.add(t[1], 0, [["enter", s, e]]), t[2] !== 0) {
    const u = Gn(e.events, t[2]), c = Gn(e.events, t[3]), h = {
      type: l,
      start: Object.assign({}, u),
      end: Object.assign({}, c)
    };
    if (n.add(t[2], 0, [["enter", h, e]]), i !== 2) {
      const f = e.events[t[2]], d = e.events[t[3]];
      if (f[1].end = Object.assign({}, d[1].end), f[1].type = "chunkText", f[1].contentType = "text", t[3] > t[2] + 1) {
        const p = t[2] + 1, g = t[3] - t[2] - 1;
        n.add(p, g, []);
      }
    }
    n.add(t[3] + 1, 0, [["exit", h, e]]);
  }
  return r !== void 0 && (s.end = Object.assign({}, Gn(e.events, r)), n.add(r, 0, [["exit", s, e]]), s = void 0), s;
}
function wh(n, e, t, i, r) {
  const s = [], o = Gn(e.events, t);
  r && (r.end = Object.assign({}, o), s.push(["exit", r, e])), i.end = Object.assign({}, o), s.push(["exit", i, e]), n.add(t + 1, 0, s);
}
function Gn(n, e) {
  const t = n[e], i = t[0] === "enter" ? "start" : "end";
  return t[1][i];
}
const mA = {
  tokenize: yA
};
function gA() {
  return {
    text: {
      91: mA
    }
  };
}
function yA(n, e, t) {
  const i = this;
  return r;
  function r(a) {
    return (
      // Exit if there’s stuff before.
      i.previous !== null || // Exit if not in the first content that is the first child of a list
      // item.
      !i._gfmTasklistFirstContentOfListItem ? t(a) : (n.enter("taskListCheck"), n.enter("taskListCheckMarker"), n.consume(a), n.exit("taskListCheckMarker"), s)
    );
  }
  function s(a) {
    return fe(a) ? (n.enter("taskListCheckValueUnchecked"), n.consume(a), n.exit("taskListCheckValueUnchecked"), o) : a === 88 || a === 120 ? (n.enter("taskListCheckValueChecked"), n.consume(a), n.exit("taskListCheckValueChecked"), o) : t(a);
  }
  function o(a) {
    return a === 93 ? (n.enter("taskListCheckMarker"), n.consume(a), n.exit("taskListCheckMarker"), n.exit("taskListCheck"), l) : t(a);
  }
  function l(a) {
    return W(a) ? e(a) : J(a) ? n.check(
      {
        tokenize: bA
      },
      e,
      t
    )(a) : t(a);
  }
}
function bA(n, e, t) {
  return te(n, i, "whitespace");
  function i(r) {
    return r === null ? t(r) : e(r);
  }
}
function xA(n) {
  return wp([
    W4(),
    eA(),
    aA(n),
    fA(),
    gA()
  ]);
}
const wA = {};
function kA(n) {
  const e = (
    /** @type {Processor} */
    this
  ), t = n || wA, i = e.data(), r = i.micromarkExtensions || (i.micromarkExtensions = []), s = i.fromMarkdownExtensions || (i.fromMarkdownExtensions = []), o = i.toMarkdownExtensions || (i.toMarkdownExtensions = []);
  r.push(xA(t)), s.push(V4()), o.push(_4(t));
}
const ve = {
  xmark: '<svg class="cs-close-button" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M342.6 150.6c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L192 210.7 86.6 105.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3L146.7 256 41.4 361.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L192 301.3 297.4 406.6c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L237.3 256 342.6 150.6z"/></svg>',
  config: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M495.9 166.6c3.2 8.7 .5 18.4-6.4 24.6l-43.3 39.4c1.1 8.3 1.7 16.8 1.7 25.4s-.6 17.1-1.7 25.4l43.3 39.4c6.9 6.2 9.6 15.9 6.4 24.6c-4.4 11.9-9.7 23.3-15.8 34.3l-4.7 8.1c-6.6 11-14 21.4-22.1 31.2c-5.9 7.2-15.7 9.6-24.5 6.8l-55.7-17.7c-13.4 10.3-28.2 18.9-44 25.4l-12.5 57.1c-2 9.1-9 16.3-18.2 17.8c-13.8 2.3-28 3.5-42.5 3.5s-28.7-1.2-42.5-3.5c-9.2-1.5-16.2-8.7-18.2-17.8l-12.5-57.1c-15.8-6.5-30.6-15.1-44-25.4L83.1 425.9c-8.8 2.8-18.6 .3-24.5-6.8c-8.1-9.8-15.5-20.2-22.1-31.2l-4.7-8.1c-6.1-11-11.4-22.4-15.8-34.3c-3.2-8.7-.5-18.4 6.4-24.6l43.3-39.4C64.6 273.1 64 264.6 64 256s.6-17.1 1.7-25.4L22.4 191.2c-6.9-6.2-9.6-15.9-6.4-24.6c4.4-11.9 9.7-23.3 15.8-34.3l4.7-8.1c6.6-11 14-21.4 22.1-31.2c5.9-7.2 15.7-9.6 24.5-6.8l55.7 17.7c13.4-10.3 28.2-18.9 44-25.4l12.5-57.1c2-9.1 9-16.3 18.2-17.8C227.3 1.2 241.5 0 256 0s28.7 1.2 42.5 3.5c9.2 1.5 16.2 8.7 18.2 17.8l12.5 57.1c15.8 6.5 30.6 15.1 44 25.4l55.7-17.7c8.8-2.8 18.6-.3 24.5 6.8c8.1 9.8 15.5 20.2 22.1 31.2l4.7 8.1c6.1 11 11.4 22.4 15.8 34.3zM256 336a80 80 0 1 0 0-160 80 80 0 1 0 0 160z" fill="currentColor"/></svg>',
  headingup: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M32 96l512 0c17.7 0 32-14.3 32-32s-14.3-32-32-32L32 32C14.3 32 0 46.3 0 64S14.3 96 32 96zM9.4 233.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L96 237.3 96 448c0 17.7 14.3 32 32 32s32-14.3 32-32l0-210.7 41.4 41.4c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3l-96-96c-12.5-12.5-32.8-12.5-45.3 0l-96 96zm320 45.3c12.5 12.5 32.8 12.5 45.3 0L416 237.3 416 448c0 17.7 14.3 32 32 32s32-14.3 32-32l0-210.7 41.4 41.4c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3l-96-96c-12.5-12.5-32.8-12.5-45.3 0l-96 96c-12.5 12.5-12.5 32.8 0 45.3z" fill="currentColor"/></svg>',
  headingdown: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M544 416L32 416c-17.7 0-32 14.3-32 32s14.3 32 32 32l512 0c17.7 0 32-14.3 32-32s-14.3-32-32-32zm22.6-137.4c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L480 274.7 480 64c0-17.7-14.3-32-32-32s-32 14.3-32 32l0 210.7-41.4-41.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3l96 96c12.5 12.5 32.8 12.5 45.3 0l96-96zm-320-45.3c-12.5-12.5-32.8-12.5-45.3 0L160 274.7 160 64c0-17.7-14.3-32-32-32s-32 14.3-32 32l0 210.7L54.6 233.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3l96 96c12.5 12.5 32.8 12.5 45.3 0l96-96c12.5-12.5 12.5-32.8 0-45.3z" fill="currentColor"/></svg>',
  bold: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M0 64C0 46.3 14.3 32 32 32H80 96 224c70.7 0 128 57.3 128 128c0 31.3-11.3 60.1-30 82.3c37.1 22.4 62 63.1 62 109.7c0 70.7-57.3 128-128 128H96 80 32c-17.7 0-32-14.3-32-32s14.3-32 32-32H48V256 96H32C14.3 96 0 81.7 0 64zM224 224c35.3 0 64-28.7 64-64s-28.7-64-64-64H112V224H224zM112 288V416H256c35.3 0 64-28.7 64-64s-28.7-64-64-64H224 112z" fill="currentColor"/></svg>',
  italic: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M128 64c0-17.7 14.3-32 32-32H352c17.7 0 32 14.3 32 32s-14.3 32-32 32H293.3L160 416h64c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H90.7L224 96H160c-17.7 0-32-14.3-32-32z" fill="currentColor"/></svg>',
  strikethrough: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M161.3 144c3.2-17.2 14-30.1 33.7-38.6c21.1-9 51.8-12.3 88.6-6.5c11.9 1.9 48.8 9.1 60.1 12c17.1 4.5 34.6-5.6 39.2-22.7s-5.6-34.6-22.7-39.2c-14.3-3.8-53.6-11.4-66.6-13.4c-44.7-7-88.3-4.2-123.7 10.9c-36.5 15.6-64.4 44.8-71.8 87.3c-.1 .6-.2 1.1-.2 1.7c-2.8 23.9 .5 45.6 10.1 64.6c4.5 9 10.2 16.9 16.7 23.9H32c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H270.1c-.1 0-.3-.1-.4-.1l-1.1-.3c-36-10.8-65.2-19.6-85.2-33.1c-9.3-6.3-15-12.6-18.2-19.1c-3.1-6.1-5.2-14.6-3.8-27.4zM348.9 337.2c2.7 6.5 4.4 15.8 1.9 30.1c-3 17.6-13.8 30.8-33.9 39.4c-21.1 9-51.7 12.3-88.5 6.5c-18-2.9-49.1-13.5-74.4-22.1c-5.6-1.9-11-3.7-15.9-5.4c-16.8-5.6-34.9 3.5-40.5 20.3s3.5 34.9 20.3 40.5c3.6 1.2 7.9 2.7 12.7 4.3l0 0 0 0c24.9 8.5 63.6 21.7 87.6 25.6l0 0 .2 0c44.7 7 88.3 4.2 123.7-10.9c36.5-15.6 64.4-44.8 71.8-87.3c3.6-21 2.7-40.4-3.1-58.1H335.1c7 5.6 11.4 11.2 13.9 17.2z" fill="currentColor"/></svg>',
  link: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 640 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M579.8 267.7c56.5-56.5 56.5-148 0-204.5c-50-50-128.8-56.5-186.3-15.4l-1.6 1.1c-14.4 10.3-17.7 30.3-7.4 44.6s30.3 17.7 44.6 7.4l1.6-1.1c32.1-22.9 76-19.3 103.8 8.6c31.5 31.5 31.5 82.5 0 114L422.3 334.8c-31.5 31.5-82.5 31.5-114 0c-27.9-27.9-31.5-71.8-8.6-103.8l1.1-1.6c10.3-14.4 6.9-34.4-7.4-44.6s-34.4-6.9-44.6 7.4l-1.1 1.6C206.5 251.2 213 330 263 380c56.5 56.5 148 56.5 204.5 0L579.8 267.7zM60.2 244.3c-56.5 56.5-56.5 148 0 204.5c50 50 128.8 56.5 186.3 15.4l1.6-1.1c14.4-10.3 17.7-30.3 7.4-44.6s-30.3-17.7-44.6-7.4l-1.6 1.1c-32.1 22.9-76 19.3-103.8-8.6C74 372 74 321 105.5 289.5L217.7 177.2c31.5-31.5 82.5-31.5 114 0c27.9 27.9 31.5 71.8 8.6 103.9l-1.1 1.6c-10.3 14.4-6.9 34.4 7.4 44.6s34.4 6.9 44.6-7.4l1.1-1.6C433.5 260.8 427 182 377 132c-56.5-56.5-148-56.5-204.5 0L60.2 244.3z" fill="currentColor"/></svg>',
  line: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M432 256c0 17.7-14.3 32-32 32L48 288c-17.7 0-32-14.3-32-32s14.3-32 32-32l352 0c17.7 0 32 14.3 32 32z" fill="currentColor"/></svg>',
  listul: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M64 144a48 48 0 1 0 0-96 48 48 0 1 0 0 96zM192 64c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H192zm0 160c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H192zm0 160c-17.7 0-32 14.3-32 32s14.3 32 32 32H480c17.7 0 32-14.3 32-32s-14.3-32-32-32H192zM64 464a48 48 0 1 0 0-96 48 48 0 1 0 0 96zm48-208a48 48 0 1 0 -96 0 48 48 0 1 0 96 0z" fill="currentColor"/></svg>',
  listol: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M24 56c0-13.3 10.7-24 24-24H80c13.3 0 24 10.7 24 24V176h16c13.3 0 24 10.7 24 24s-10.7 24-24 24H40c-13.3 0-24-10.7-24-24s10.7-24 24-24H56V80H48C34.7 80 24 69.3 24 56zM86.7 341.2c-6.5-7.4-18.3-6.9-24 1.2L51.5 357.9c-7.7 10.8-22.7 13.3-33.5 5.6s-13.3-22.7-5.6-33.5l11.1-15.6c23.7-33.2 72.3-35.6 99.2-4.9c21.3 24.4 20.8 60.9-1.1 84.7L86.8 432H120c13.3 0 24 10.7 24 24s-10.7 24-24 24H32c-9.5 0-18.2-5.6-22-14.4s-2.1-18.9 4.3-25.9l72-78c5.3-5.8 5.4-14.6 .3-20.5zM224 64H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H224c-17.7 0-32-14.3-32-32s14.3-32 32-32zm0 160H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H224c-17.7 0-32-14.3-32-32s14.3-32 32-32zm0 160H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H224c-17.7 0-32-14.3-32-32s14.3-32 32-32z" fill="currentColor"/></svg>',
  listtask: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M152.1 38.2c9.9 8.9 10.7 24 1.8 33.9l-72 80c-4.4 4.9-10.6 7.8-17.2 7.9s-12.9-2.4-17.6-7L7 113C-2.3 103.6-2.3 88.4 7 79s24.6-9.4 33.9 0l22.1 22.1 55.1-61.2c8.9-9.9 24-10.7 33.9-1.8zm0 160c9.9 8.9 10.7 24 1.8 33.9l-72 80c-4.4 4.9-10.6 7.8-17.2 7.9s-12.9-2.4-17.6-7L7 273c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l22.1 22.1 55.1-61.2c8.9-9.9 24-10.7 33.9-1.8zM224 96c0-17.7 14.3-32 32-32H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H256c-17.7 0-32-14.3-32-32zm0 160c0-17.7 14.3-32 32-32H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H256c-17.7 0-32-14.3-32-32zM160 416c0-17.7 14.3-32 32-32H480c17.7 0 32 14.3 32 32s-14.3 32-32 32H192c-17.7 0-32-14.3-32-32zM48 368a48 48 0 1 1 0 96 48 48 0 1 1 0-96z" fill="currentColor"/></svg>',
  code: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 640 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M392.8 1.2c-17-4.9-34.7 5-39.6 22l-128 448c-4.9 17 5 34.7 22 39.6s34.7-5 39.6-22l128-448c4.9-17-5-34.7-22-39.6zm80.6 120.1c-12.5 12.5-12.5 32.8 0 45.3L562.7 256l-89.4 89.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0l112-112c12.5-12.5 12.5-32.8 0-45.3l-112-112c-12.5-12.5-32.8-12.5-45.3 0zm-306.7 0c-12.5-12.5-32.8-12.5-45.3 0l-112 112c-12.5 12.5-12.5 32.8 0 45.3l112 112c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L77.3 256l89.4-89.4c12.5-12.5 12.5-32.8 0-45.3z" fill="currentColor"/></svg>',
  block: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M160 368c26.5 0 48 21.5 48 48v16l72.5-54.4c8.3-6.2 18.4-9.6 28.8-9.6H448c8.8 0 16-7.2 16-16V64c0-8.8-7.2-16-16-16H64c-8.8 0-16 7.2-16 16V352c0 8.8 7.2 16 16 16h96zm48 124l-.2 .2-5.1 3.8-17.1 12.8c-4.8 3.6-11.3 4.2-16.8 1.5s-8.8-8.2-8.8-14.3V474.7v-6.4V468v-4V416H112 64c-35.3 0-64-28.7-64-64V64C0 28.7 28.7 0 64 0H448c35.3 0 64 28.7 64 64V352c0 35.3-28.7 64-64 64H309.3L208 492z" fill="currentColor"/></svg>',
  math: '<svg style="width: 16px; height: 16px;"  xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M282.6 78.1c8-27.3 33-46.1 61.4-46.1H544c17.7 0 32 14.3 32 32s-14.3 32-32 32H344L238.7 457c-3.6 12.3-14.1 21.2-26.8 22.8s-25.1-4.6-31.5-15.6L77.6 288H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H77.6c22.8 0 43.8 12.1 55.3 31.8l65.2 111.8L282.6 78.1zM393.4 233.4c12.5-12.5 32.8-12.5 45.3 0L480 274.7l41.4-41.4c12.5-12.5 32.8-12.5 45.3 0s12.5 32.8 0 45.3L525.3 320l41.4 41.4c12.5 12.5 12.5 32.8 0 45.3s-32.8 12.5-45.3 0L480 365.3l-41.4 41.4c-12.5 12.5-32.8 12.5-45.3 0s-12.5-32.8 0-45.3L434.7 320l-41.4-41.4c-12.5-12.5-12.5-32.8 0-45.3z" fill="currentColor"/></svg>',
  editor: '<svg style="width: 16px; height: 16px;"  xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M288 64c0 17.7-14.3 32-32 32H32C14.3 96 0 81.7 0 64S14.3 32 32 32H256c17.7 0 32 14.3 32 32zm0 256c0 17.7-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H256c17.7 0 32 14.3 32 32zM0 192c0-17.7 14.3-32 32-32H416c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32zM448 448c0 17.7-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32z" fill="currentColor"/></svg>',
  viewer: '<svg style="width: 16px; height: 16px;"  xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M448 64c0 17.7-14.3 32-32 32H192c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32zm0 256c0 17.7-14.3 32-32 32H192c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32zM0 192c0-17.7 14.3-32 32-32H416c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32zM448 448c0 17.7-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H416c17.7 0 32 14.3 32 32z" fill="currentColor"/></svg>',
  expand: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M200 32H56C42.7 32 32 42.7 32 56V200c0 9.7 5.8 18.5 14.8 22.2s19.3 1.7 26.2-5.2l40-40 79 79-79 79L73 295c-6.9-6.9-17.2-8.9-26.2-5.2S32 302.3 32 312V456c0 13.3 10.7 24 24 24H200c9.7 0 18.5-5.8 22.2-14.8s1.7-19.3-5.2-26.2l-40-40 79-79 79 79-40 40c-6.9 6.9-8.9 17.2-5.2 26.2s12.5 14.8 22.2 14.8H456c13.3 0 24-10.7 24-24V312c0-9.7-5.8-18.5-14.8-22.2s-19.3-1.7-26.2 5.2l-40 40-79-79 79-79 40 40c6.9 6.9 17.2 8.9 26.2 5.2s14.8-12.5 14.8-22.2V56c0-13.3-10.7-24-24-24H312c-9.7 0-18.5 5.8-22.2 14.8s-1.7 19.3 5.2 26.2l40 40-79 79-79-79 40-40c6.9-6.9 8.9-17.2 5.2-26.2S209.7 32 200 32z" fill="currentColor"/></svg>',
  info: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 192 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M48 80a48 48 0 1 1 96 0A48 48 0 1 1 48 80zM0 224c0-17.7 14.3-32 32-32H96c17.7 0 32 14.3 32 32V448h32c17.7 0 32 14.3 32 32s-14.3 32-32 32H32c-17.7 0-32-14.3-32-32s14.3-32 32-32H64V256H32c-17.7 0-32-14.3-32-32z" fill="currentColor"/></svg>',
  picture: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M0 96C0 60.7 28.7 32 64 32H448c35.3 0 64 28.7 64 64V416c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V96zM323.8 202.5c-4.5-6.6-11.9-10.5-19.8-10.5s-15.4 3.9-19.8 10.5l-87 127.6L170.7 297c-4.6-5.7-11.5-9-18.7-9s-14.2 3.3-18.7 9l-64 80c-5.8 7.2-6.9 17.1-2.9 25.4s12.4 13.6 21.6 13.6h96 32H424c8.9 0 17.1-4.9 21.2-12.8s3.6-17.4-1.4-24.7l-120-176zM112 192a48 48 0 1 0 0-96 48 48 0 1 0 0 96z" fill="currentColor"/></svg>',
  table: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M64 256V160H224v96H64zm0 64H224v96H64V320zm224 96V320H448v96H288zM448 256H288V160H448v96zM64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H448c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64z" fill="currentColor"/></svg>',
  quote: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M0 216C0 149.7 53.7 96 120 96h8c17.7 0 32 14.3 32 32s-14.3 32-32 32h-8c-30.9 0-56 25.1-56 56v8h64c35.3 0 64 28.7 64 64v64c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V320 288 216zm256 0c0-66.3 53.7-120 120-120h8c17.7 0 32 14.3 32 32s-14.3 32-32 32h-8c-30.9 0-56 25.1-56 56v8h64c35.3 0 64 28.7 64 64v64c0 35.3-28.7 64-64 64H320c-35.3 0-64-28.7-64-64V320 288 216z" fill="currentColor"/></svg>',
  help: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 320 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M80 160c0-35.3 28.7-64 64-64h32c35.3 0 64 28.7 64 64v3.6c0 21.8-11.1 42.1-29.4 53.8l-42.2 27.1c-25.2 16.2-40.4 44.1-40.4 74V320c0 17.7 14.3 32 32 32s32-14.3 32-32v-1.4c0-8.2 4.2-15.8 11-20.2l42.2-27.1c36.6-23.6 58.8-64.1 58.8-107.7V160c0-70.7-57.3-128-128-128H144C73.3 32 16 89.3 16 160c0 17.7 14.3 32 32 32s32-14.3 32-32zm80 320a40 40 0 1 0 0-80 40 40 0 1 0 0 80z" fill="currentColor"/></svg>',
  github: '<svg style="width: 16px; height: 16px;" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 496 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M165.9 397.4c0 2-2.3 3.6-5.2 3.6-3.3 .3-5.6-1.3-5.6-3.6 0-2 2.3-3.6 5.2-3.6 3-.3 5.6 1.3 5.6 3.6zm-31.1-4.5c-.7 2 1.3 4.3 4.3 4.9 2.6 1 5.6 0 6.2-2s-1.3-4.3-4.3-5.2c-2.6-.7-5.5 .3-6.2 2.3zm44.2-1.7c-2.9 .7-4.9 2.6-4.6 4.9 .3 2 2.9 3.3 5.9 2.6 2.9-.7 4.9-2.6 4.6-4.6-.3-1.9-3-3.2-5.9-2.9zM244.8 8C106.1 8 0 113.3 0 252c0 110.9 69.8 205.8 169.5 239.2 12.8 2.3 17.3-5.6 17.3-12.1 0-6.2-.3-40.4-.3-61.4 0 0-70 15-84.7-29.8 0 0-11.4-29.1-27.8-36.6 0 0-22.9-15.7 1.6-15.4 0 0 24.9 2 38.6 25.8 21.9 38.6 58.6 27.5 72.9 20.9 2.3-16 8.8-27.1 16-33.7-55.9-6.2-112.3-14.3-112.3-110.5 0-27.5 7.6-41.3 23.6-58.9-2.6-6.5-11.1-33.3 2.6-67.9 20.9-6.5 69 27 69 27 20-5.6 41.5-8.5 62.8-8.5s42.8 2.9 62.8 8.5c0 0 48.1-33.6 69-27 13.7 34.7 5.2 61.4 2.6 67.9 16 17.7 25.8 31.5 25.8 58.9 0 96.5-58.9 104.2-114.8 110.5 9.2 7.9 17 22.9 17 46.4 0 33.7-.3 75.4-.3 83.6 0 6.5 4.6 14.4 17.3 12.1C428.2 457.8 496 362.9 496 252 496 113.3 383.5 8 244.8 8zM97.2 352.9c-1.3 1-1 3.3 .7 5.2 1.6 1.6 3.9 2.3 5.2 1 1.3-1 1-3.3-.7-5.2-1.6-1.6-3.9-2.3-5.2-1zm-10.8-8.1c-.7 1.3 .3 2.9 2.3 3.9 1.6 1 3.6 .7 4.3-.7 .7-1.3-.3-2.9-2.3-3.9-2-.6-3.6-.3-4.3 .7zm32.4 35.6c-1.6 1.3-1 4.3 1.3 6.2 2.3 2.3 5.2 2.6 6.5 1 1.3-1.3 .7-4.3-1.3-6.2-2.2-2.3-5.2-2.6-6.5-1zm-11.4-14.7c-1.6 1-1.6 3.6 0 5.9 1.6 2.3 4.3 3.3 5.6 2.3 1.6-1.3 1.6-3.9 0-6.2-1.4-2.3-4-3.3-5.6-2z" fill="currentColor"/></svg>'
}, vA = { class: "cs-dialog-header" }, SA = ["innerHTML"], dr = /* @__PURE__ */ lt({
  __name: "MDialog",
  emits: ["close"],
  setup(n, { emit: e }) {
    const t = e, i = oe(void 0);
    function r(s) {
      i.value && !i.value.contains(s.target) && t("close");
    }
    return (s, o) => (se(), xe("div", {
      class: "cs-dialog-container",
      onClick: r
    }, [
      I("div", {
        class: "cs-dialog",
        ref_key: "dialog",
        ref: i
      }, [
        I("div", vA, [
          Ni(s.$slots, "header"),
          I("div", {
            class: "cs-close-container",
            onClick: o[0] || (o[0] = (l) => t("close")),
            innerHTML: Wi(ve).xmark
          }, null, 8, SA)
        ]),
        Ni(s.$slots, "default")
      ], 512)
    ]));
  }
}), CA = { class: "cs-dialog-item" }, AA = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 选择语言 ", -1), MA = ["value"], TA = { class: "cs-dialog-item" }, OA = /* @__PURE__ */ I("div", {
  class: "cs-dialog-item-label",
  style: { "min-height": "50vh" }
}, " 代码 ", -1), DA = { class: "cs-dialog-submit-area" }, EA = /* @__PURE__ */ lt({
  __name: "ToolCode",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      xt(null, e.container);
    }
    const i = oe(""), r = oe(""), s = [
      { value: "cpp", name: "C++" },
      { value: "pascal", name: "Pascal" },
      { value: "c", name: "C" },
      { value: "javascript", name: "Javascript" },
      { value: "java", name: "Java" },
      { value: "markdown", name: "Markdown" },
      { value: "latex", name: "LaTeX" }
    ];
    return (o, l) => (se(), xn(dr, { onClose: t }, {
      header: ot(() => [
        fi(" 插入代码 ")
      ]),
      default: ot(() => [
        I("div", null, [
          I("div", CA, [
            AA,
            dt(I("select", {
              "onUpdate:modelValue": l[0] || (l[0] = (a) => i.value = a),
              class: "cs-dialog-item-content"
            }, [
              (se(), xe(qt, null, sn(s, (a) => I("option", {
                key: a.value,
                value: a.value
              }, In(a.name), 9, MA)), 64))
            ], 512), [
              [Sh, i.value]
            ])
          ]),
          I("div", TA, [
            OA,
            dt(I("textarea", {
              class: "cs-dialog-item-content",
              "onUpdate:modelValue": l[1] || (l[1] = (a) => r.value = a)
            }, null, 512), [
              [zt, r.value]
            ])
          ]),
          I("div", DA, [
            I("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, "取消"),
            I("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: l[2] || (l[2] = () => {
                e.confirm(i.value, r.value), t();
              })
            }, "确认")
          ])
        ])
      ]),
      _: 1
    }));
  }
}), LA = { class: "cs-dialog-item" }, IA = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 图片地址 ", -1), PA = { class: "cs-dialog-item" }, BA = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 图片介绍 ", -1), RA = /* @__PURE__ */ I("div", { class: "cs-dialog-item" }, [
  /* @__PURE__ */ I("div", { class: "cs-dialog-upload" }, " 上传图片 ")
], -1), NA = { class: "cs-dialog-submit-area" }, FA = /* @__PURE__ */ lt({
  __name: "ToolPicture",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      xt(null, e.container);
    }
    const i = oe(""), r = oe("");
    return (s, o) => (se(), xn(dr, { onClose: t }, {
      header: ot(() => [
        fi(" 插入图片 ")
      ]),
      default: ot(() => [
        I("div", null, [
          I("div", LA, [
            IA,
            dt(I("input", {
              type: "text",
              "onUpdate:modelValue": o[0] || (o[0] = (l) => i.value = l),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [zt, i.value]
            ])
          ]),
          I("div", PA, [
            BA,
            dt(I("input", {
              type: "text",
              "onUpdate:modelValue": o[1] || (o[1] = (l) => r.value = l),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [zt, r.value]
            ])
          ]),
          RA,
          I("div", NA, [
            I("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, "取消"),
            I("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: o[2] || (o[2] = () => {
                e.confirm(i.value, r.value), t();
              })
            }, "确认")
          ])
        ])
      ]),
      _: 1
    }));
  }
}), zA = { class: "cs-dialog-container" }, HA = { class: "cs-dialog-sidebar" }, VA = { class: "cs-dialog-header" }, _A = ["innerHTML"], $A = { class: "cs-dialog-view" }, jA = /* @__PURE__ */ lt({
  __name: "MDialogExtra",
  emits: ["close"],
  setup(n, { emit: e }) {
    const t = e, i = oe(void 0);
    return (r, s) => (se(), xe("div", zA, [
      I("div", {
        class: "cs-dialog cs-dialog-big",
        ref_key: "dialog",
        ref: i
      }, [
        I("div", HA, [
          I("div", VA, [
            Ni(r.$slots, "header"),
            I("div", {
              class: "cs-close-container",
              onClick: s[0] || (s[0] = (o) => t("close")),
              innerHTML: Wi(ve).xmark
            }, null, 8, _A)
          ]),
          Ni(r.$slots, "default")
        ]),
        I("div", $A, [
          Ni(r.$slots, "view")
        ])
      ], 512)
    ]));
  }
}), WA = { class: "cs-dialog-item" }, qA = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 行数 ", -1), UA = { class: "cs-dialog-item" }, KA = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 列数 ", -1), GA = { class: "cs-dialog-area" }, YA = /* @__PURE__ */ I("h3", null, "编辑区", -1), XA = { class: "submit-area" }, JA = { class: "cs-dialog-table-editor" }, QA = ["data-x", "data-y", "colspan", "rowspan"], ZA = /* @__PURE__ */ lt({
  __name: "ToolTable",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      xt(null, e.container);
    }
    const i = oe(1), r = oe(1), s = oe([NaN, NaN]), o = oe([NaN, NaN]), l = oe([NaN, NaN]), a = oe([NaN, NaN]), u = oe(""), c = oe(!1), h = oe([[{ row: 1, col: 1, data: "", merged: !1 }]]);
    function f() {
      for (i.value = Math.max(1, i.value), r.value = Math.max(1, r.value), i.value = Math.min(100, i.value), r.value = Math.min(100, r.value); h.value.length < i.value; )
        h.value.push([]);
      for (; h.value.length > i.value; )
        h.value.pop();
      for (let b of h.value) {
        for (; b.length < r.value; )
          b.push({ row: 1, col: 1, data: "", merged: !1 });
        for (; b.length > r.value; )
          b.pop();
      }
    }
    function d(b, S) {
      return l.value[0] <= b && b <= a.value[0] && l.value[1] <= S && S <= a.value[1];
    }
    function p() {
      const b = h.value[s.value[0]][s.value[1]], S = h.value[o.value[0]][o.value[1]];
      let [L, P] = [s.value[0], o.value[0]], [k, M] = [s.value[1], o.value[1]];
      l.value[0] = Math.min(L, P), l.value[1] = Math.min(k, M), a.value[0] = Math.max(L + b.row - 1, P + S.row - 1), a.value[1] = Math.max(k + b.col - 1, M + S.col - 1);
    }
    function g(b) {
      if (b.target) {
        c.value = !1;
        const S = Number.parseInt(b.target.dataset.x || "-1"), L = Number.parseInt(b.target.dataset.y || "-1");
        s.value = o.value = [S, L], p();
      }
    }
    function m(b) {
      if (!c.value && !Number.isNaN(s.value[0]) && b.target) {
        const S = Number.parseInt(b.target.dataset.x || "-1"), L = Number.parseInt(b.target.dataset.y || "-1");
        o.value = [S, L], p();
      }
    }
    function y(b) {
      c.value = !0;
    }
    function v() {
      let [b, S] = l.value, [L, P] = a.value;
      for (let k = b; k <= L; k++)
        for (let M = S; M <= P; M++) {
          const D = h.value[k][M];
          if (D.merged) {
            if (D.row < b || D.col < S)
              return !1;
          } else if (D.row + k - 1 > L || D.col + M - 1 > P)
            return !1;
        }
      return !0;
    }
    function C() {
      if (!v())
        return;
      let [b, S] = l.value, [L, P] = a.value;
      if (!(0 <= b && b < i.value && 0 <= L && L < i.value) || !(0 <= S && S < r.value && 0 <= P && P < r.value))
        return;
      const k = h.value[b][S].data;
      for (let M = b; M <= L; M++)
        for (let D = S; D <= P; D++)
          h.value[M][D] = {
            row: b,
            col: S,
            merged: !0,
            data: ""
          };
      h.value[b][S] = {
        row: L - b + 1,
        col: P - S + 1,
        data: k,
        merged: !1
      };
    }
    function O() {
      if (!v())
        return;
      let [b, S] = l.value, [L, P] = a.value;
      if (0 <= b && b < i.value && 0 <= L && L < i.value && 0 <= S && S < r.value && 0 <= P && P < r.value)
        for (let k = b; k <= L; k++)
          for (let M = S; M <= P; M++) {
            for (let D = 0; D < h.value[k][M].row; ++D)
              for (let R = 0; R < h.value[k][M].col; ++R)
                (D !== 0 || R !== 0) && (h.value[k + D][M + R] = {
                  row: 1,
                  col: 1,
                  data: h.value[k][M].data,
                  merged: !1
                });
            h.value[k][M].col = 1, h.value[k][M].row = 1;
          }
    }
    function A() {
      if (!v())
        return;
      let [b, S] = l.value, [L, P] = a.value;
      if (0 <= b && b < i.value && 0 <= L && L < i.value && 0 <= S && S < r.value && 0 <= P && P < r.value)
        for (let k = b; k <= L; k++)
          for (let M = S; M <= P; M++)
            h.value[k][M].merged || (h.value[k][M].data = u.value);
    }
    return ut(i, f), ut(r, f), (b, S) => (se(), xn(jA, { onClose: t }, {
      header: ot(() => [
        fi(" 插入表格 ")
      ]),
      view: ot(() => [
        I("table", JA, [
          I("tbody", null, [
            (se(!0), xe(qt, null, sn(Object.entries(h.value), ([L, P]) => (se(), xe("tr", null, [
              (se(!0), xe(qt, null, sn(Object.entries(P), ([k, M]) => (se(), xe(qt, null, [
                M.merged ? Wo("", !0) : (se(), xe("td", {
                  key: 0,
                  "data-x": L,
                  "data-y": k,
                  colspan: M.col,
                  rowspan: M.row,
                  class: jr({ selected: d(Number.parseInt(L), Number.parseInt(k)) }),
                  onMousedown: g,
                  onMouseenter: m,
                  onMouseup: y
                }, In(M.data) + "  ", 43, QA))
              ], 64))), 256))
            ]))), 256))
          ])
        ])
      ]),
      default: ot(() => [
        I("div", WA, [
          qA,
          dt(I("input", {
            type: "number",
            "onUpdate:modelValue": S[0] || (S[0] = (L) => i.value = L),
            class: "cs-dialog-item-content",
            min: "1",
            max: "100"
          }, null, 512), [
            [zt, i.value]
          ])
        ]),
        I("div", UA, [
          KA,
          dt(I("input", {
            type: "number",
            "onUpdate:modelValue": S[1] || (S[1] = (L) => r.value = L),
            class: "cs-dialog-item-content",
            min: "1",
            max: "100"
          }, null, 512), [
            [zt, r.value]
          ])
        ]),
        I("div", { class: "cs-dialog-item" }, [
          I("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: C
          }, "合并"),
          I("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: O
          }, "拆分"),
          I("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: A
          }, "修改")
        ]),
        I("div", GA, [
          YA,
          dt(I("textarea", {
            "onUpdate:modelValue": S[2] || (S[2] = (L) => u.value = L)
          }, null, 512), [
            [zt, u.value]
          ])
        ]),
        I("div", XA, [
          I("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: t
          }, "取消"),
          I("button", {
            class: "cs-dialog-button cs-dialog-button-info",
            onClick: S[3] || (S[3] = () => {
              b.confirm(i.value, r.value, h.value), t();
            })
          }, "确认")
        ])
      ]),
      _: 1
    }));
  }
}), eM = { class: "cs-dialog-item" }, tM = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 链接地址 ", -1), nM = { class: "cs-dialog-item" }, iM = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 链接介绍 ", -1), rM = { class: "submit-area" }, sM = /* @__PURE__ */ lt({
  __name: "ToolLink",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      xt(null, e.container);
    }
    const i = oe(""), r = oe("");
    return (s, o) => (se(), xn(dr, { onClose: t }, {
      header: ot(() => [
        fi(" 插入链接 ")
      ]),
      default: ot(() => [
        I("div", null, [
          I("div", eM, [
            tM,
            dt(I("input", {
              type: "text",
              "onUpdate:modelValue": o[0] || (o[0] = (l) => i.value = l),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [zt, i.value]
            ])
          ]),
          I("div", nM, [
            iM,
            dt(I("input", {
              type: "text",
              "onUpdate:modelValue": o[1] || (o[1] = (l) => r.value = l),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [zt, r.value]
            ])
          ]),
          I("div", rM, [
            I("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, "取消"),
            I("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: o[2] || (o[2] = () => {
                e.confirm(i.value, r.value), t();
              })
            }, "确认")
          ])
        ])
      ]),
      _: 1
    }));
  }
}), oM = { class: "cs-dialog-item" }, lM = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 选择类型 ", -1), aM = ["value"], uM = { class: "cs-dialog-item" }, cM = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 标题 ", -1), hM = { class: "cs-dialog-item" }, fM = /* @__PURE__ */ I("div", { class: "cs-dialog-item-label" }, " 内容 ", -1), dM = { class: "cs-dialog-submit-area" }, pM = /* @__PURE__ */ lt({
  __name: "ToolBlock",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      xt(null, e.container);
    }
    const i = oe("info"), r = oe(""), s = oe(""), o = [
      { value: "info", name: "信息" },
      { value: "success", name: "成功" },
      { value: "error", name: "错误" },
      { value: "warning", name: "警告" }
    ];
    return (l, a) => (se(), xn(dr, { onClose: t }, {
      header: ot(() => [
        fi(" 插入块体 ")
      ]),
      default: ot(() => [
        I("div", null, [
          I("div", oM, [
            lM,
            dt(I("select", {
              "onUpdate:modelValue": a[0] || (a[0] = (u) => i.value = u),
              class: "cs-dialog-item-content"
            }, [
              (se(), xe(qt, null, sn(o, (u) => I("option", {
                key: u.value,
                value: u.value
              }, In(u.name), 9, aM)), 64))
            ], 512), [
              [Sh, i.value]
            ])
          ]),
          I("div", uM, [
            cM,
            dt(I("input", {
              type: "text",
              "onUpdate:modelValue": a[1] || (a[1] = (u) => r.value = u),
              class: "cs-dialog-item-content"
            }, null, 512), [
              [zt, r.value]
            ])
          ]),
          I("div", hM, [
            fM,
            dt(I("textarea", {
              class: "cs-dialog-item-content",
              "onUpdate:modelValue": a[2] || (a[2] = (u) => s.value = u)
            }, null, 512), [
              [zt, s.value]
            ])
          ]),
          I("div", dM, [
            I("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: t
            }, "取消"),
            I("button", {
              class: "cs-dialog-button cs-dialog-button-info",
              onClick: a[3] || (a[3] = () => {
                e.confirm(i.value, r.value, s.value), t();
              })
            }, "确认")
          ])
        ])
      ]),
      _: 1
    }));
  }
}), mM = /* @__PURE__ */ I("div", null, [
  /* @__PURE__ */ I("h2", null, "Todo"),
  /* @__PURE__ */ I("ul", null, [
    /* @__PURE__ */ I("li", null, "快捷方式（比如按 Ctrl+B 自动将选中范围加粗）；"),
    /* @__PURE__ */ I("li", null, "设置（是否开启快捷方式/显示工具栏）；"),
    /* @__PURE__ */ I("li", null, "研究一下手机适配；"),
    /* @__PURE__ */ I("li", null, "调整一下样式；"),
    /* @__PURE__ */ I("li", null, "把组件打包放到 npm 上面去，新建一个 Playground；"),
    /* @__PURE__ */ I("li", null, "修可能存在的 bug。")
  ])
], -1), gM = /* @__PURE__ */ lt({
  __name: "ToolHelp",
  props: {
    confirm: { type: Function },
    container: {}
  },
  setup(n) {
    const e = n;
    function t() {
      xt(null, e.container);
    }
    return (i, r) => (se(), xn(dr, { onClose: t }, {
      header: ot(() => [
        fi(" 帮助手册我还没写 ")
      ]),
      default: ot(() => [
        mM
      ]),
      _: 1
    }));
  }
});
function yM() {
  return {
    remark: [
      kA
    ]
    // rehype: [
    // ],
    // remarkRehypeOptions: {
    // },
    // codemirror: {
    // }
  };
}
const bM = {
  name: "increase-level",
  icon: ve.headingup,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = c.text;
        console.log(c.text);
        let f = 0, d = 0, p = 0;
        const g = h.length;
        for (; f < g && h[f] === " "; )
          f++;
        for (d = f; d < g && h[d] === "#"; )
          d++;
        for (p = d; p < g && h[p] === " "; )
          p++;
        const m = d - f, y = Math.min(m + 1, 6), v = y === 0 ? "" : "#".repeat(y) + " ";
        o.push({
          from: c.from,
          to: c.from + p,
          insert: v
        }), u === r && (l = c.from), a = a + c.length + v.length - p + 1;
      }
      return a--, {
        changes: o,
        range: T.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, xM = {
  name: "decrease-level",
  icon: ve.headingdown,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = c.text;
        console.log(c.text);
        let f = 0, d = 0, p = 0;
        const g = h.length;
        for (; f < g && h[f] === " "; )
          f++;
        for (d = f; d < g && h[d] === "#"; )
          d++;
        for (p = d; p < g && h[p] === " "; )
          p++;
        const m = d - f, y = Math.max(m - 1, 0), v = y === 0 ? "" : "#".repeat(y) + " ";
        o.push({
          from: c.from,
          to: c.from + p,
          insert: v
        }), u === r && (l = c.from), a = a + c.length + v.length - p + 1;
      }
      return a--, {
        changes: o,
        range: T.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, wM = {
  name: "horizontal",
  icon: ve.line,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = `

---

`;
      return {
        changes: [
          { from: i.from, to: i.to },
          { from: i.from, insert: r }
        ],
        range: T.range(i.from + r.length, i.from + r.length)
      };
    }));
    n.update([t]), n.focus();
  }
}, kM = {
  name: "bold",
  icon: ve.bold,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: "**" },
        { from: i.to, insert: "**" }
      ],
      range: T.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, vM = {
  name: "italic",
  icon: ve.italic,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: " _" },
        { from: i.to, insert: "_ " }
      ],
      range: T.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, SM = {
  name: "strikethrough",
  icon: ve.strikethrough,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => ({
      changes: [
        { from: i.from, insert: "~~" },
        { from: i.to, insert: "~~" }
      ],
      range: T.range(i.from + 2, i.to + 2)
    })));
    n.update([t]), n.focus();
  }
}, CM = {
  name: "link",
  icon: ve.link,
  func: (n, e, t) => {
    function i(s, o) {
      const l = n.state, a = l.update(l.changeByRange((u) => {
        const c = `[${o}](${s})`;
        return {
          changes: [
            { from: u.from, to: u.to },
            { from: u.from, insert: c }
          ],
          range: T.range(u.from + c.length, u.from + c.length)
        };
      }));
      n.update([a]), n.focus();
    }
    const r = Ut(
      sM,
      {
        confirm: i,
        container: t
      }
    );
    xt(r, t);
  }
}, AM = {
  name: "picture",
  icon: ve.picture,
  func: (n, e, t) => {
    function i(s, o) {
      const l = n.state, a = l.update(l.changeByRange((u) => {
        const c = `![${o}](${s})`;
        return {
          changes: [
            { from: u.from, to: u.to },
            { from: u.from, insert: c }
          ],
          range: T.range(u.from + c.length, u.from + c.length)
        };
      }));
      n.update([a]), n.focus();
    }
    const r = Ut(
      FA,
      {
        confirm: i,
        container: t
      }
    );
    xt(r, t);
  }
}, MM = {
  name: "code",
  icon: ve.code,
  func: (n, e, t) => {
    function i(s, o) {
      const l = n.state, a = l.update(l.changeByRange((u) => {
        const c = `
\`\`\`${s}
${o}
\`\`\`
`;
        return {
          changes: [
            { from: u.from, to: u.to },
            { from: u.from, insert: c }
          ],
          range: T.range(u.from + c.length, u.from + c.length)
        };
      }));
      n.update([a]), n.focus();
    }
    const r = Ut(
      EA,
      {
        confirm: i,
        container: t
      }
    );
    xt(r, t);
  }
}, TM = {
  name: "table",
  icon: ve.table,
  func: (n, e, t) => {
    function i(s, o, l) {
      const a = n.state, u = a.update(a.changeByRange((c) => {
        let h = `

`;
        for (let f = 0; f < s; f++)
          for (let d = 0; d < o; d++) {
            const p = l[f][d];
            if (!p.merged && !(p.row === 1 && p.col === 1)) {
              const g = p.data;
              for (let m = f; m < f + p.row; m++)
                for (let y = d; y < d + p.col; y++)
                  m === f && y + 1 === d + p.col ? l[m][y].data = g : m === f ? l[m][y].data = ">" : l[m][y].data = "^";
            }
          }
        for (let f = 0; f < s; f++) {
          for (let d = 0; d < o; d++)
            h += "|" + l[f][d].data;
          if (h += `|
`, f === 0) {
            for (let d = 0; d < o; d++)
              h += "|:-:";
            h += `|
`;
          }
        }
        return h += `
`, {
          changes: [
            { from: c.from, to: c.to },
            { from: c.from, insert: h }
          ],
          range: T.range(c.from + h.length, c.from + h.length)
        };
      }));
      n.update([u]), n.focus();
    }
    const r = Ut(
      ZA,
      {
        confirm: i,
        container: t
      }
    );
    xt(r, t);
  }
}, OM = {
  name: "block",
  icon: ve.block,
  func: (n, e, t) => {
    function i(s, o, l) {
      const a = n.state, u = a.update(a.changeByRange((c) => {
        const h = `
:::${s}${o.trim().length >= 1 ? `[${o}]` : ""}
${l}
:::
`;
        return {
          changes: [
            { from: c.from, to: c.to },
            { from: c.from, insert: h }
          ],
          range: T.range(c.from + h.length, c.from + h.length)
        };
      }));
      n.update([u]), n.focus();
    }
    const r = Ut(
      pM,
      {
        confirm: i,
        container: t
      }
    );
    xt(r, t);
  }
}, DM = {
  name: "quote",
  icon: ve.quote,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = "> ";
        o.push({
          from: c.from,
          insert: h
        }), u === r && (l = c.from), a = a + c.length + h.length + 1;
      }
      return a--, {
        changes: o,
        range: T.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, EM = {
  name: "unordered-list",
  icon: ve.listul,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = "- ";
        o.push({
          from: c.from,
          insert: h
        }), u === r && (l = c.from), a = a + c.length + h.length + 1;
      }
      return a--, {
        changes: o,
        range: T.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, LM = {
  name: "ordered-list",
  icon: ve.listol,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = "1. ";
        o.push({
          from: c.from,
          insert: h
        }), u === r && (l = c.from), a = a + c.length + h.length + 1;
      }
      return a--, {
        changes: o,
        range: T.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, IM = {
  name: "task-list",
  icon: ve.listtask,
  func: (n) => {
    const e = n.state, t = e.update(e.changeByRange((i) => {
      const r = e.doc.lineAt(i.from).number, s = e.doc.lineAt(i.to).number, o = [];
      let l = 0, a = e.doc.line(r).from;
      for (let u = r; u <= s; u++) {
        const c = e.doc.line(u), h = "- [ ] ";
        o.push({
          from: c.from,
          insert: h
        }), u === r && (l = c.from), a = a + c.length + h.length + 1;
      }
      return a--, {
        changes: o,
        range: T.range(l, a)
      };
    }));
    n.update([t]), n.focus();
  }
}, PM = {
  name: "only-editer",
  icon: ve.editor,
  func: (n, e, t) => {
    e.showViewer ? (e.showEditor = !0, e.showViewer = !1) : e.showViewer = !0;
  }
}, BM = {
  name: "only-viewer",
  icon: ve.viewer,
  func: (n, e, t) => {
    e.showEditor ? (e.showViewer = !0, e.showEditor = !1) : e.showEditor = !0;
  }
}, RM = {
  name: "full-screen",
  icon: ve.expand,
  func: (n, e, t) => {
    e.fullScreen = !e.fullScreen;
  }
}, NM = {
  name: "help",
  icon: ve.help,
  func: (n, e, t) => {
    const i = Ut(
      gM,
      {
        container: t
      }
    );
    xt(i, t);
  }
}, FM = [bM, xM, wM], zM = [kM, vM, SM], HM = [CM, AM, MM, TM, OM], VM = [DM, EM, LM, IM], _M = [PM, BM, RM], $M = [NM];
function jM() {
  return [
    FM,
    zM,
    HM,
    VM
  ];
}
function WM() {
  return [
    _M,
    $M
  ];
}
const qM = "水平线", UM = "粗体", KM = "斜体", GM = "删除线", YM = "链接", XM = "图片", JM = "代码", QM = "表格", ZM = "块体", eT = "引用", tT = "帮助", nT = {
  "increase-level": "提升一级",
  "decrease-level": "降低一级",
  horizontal: qM,
  bold: UM,
  italic: KM,
  strikethrough: GM,
  link: YM,
  picture: XM,
  code: JM,
  table: QM,
  block: ZM,
  quote: eT,
  "unordered-list": "无序列表",
  "ordered-list": "有序列表",
  "task-list": "人物列表",
  "only-editor": "仅编辑",
  "only-viewer": "仅预览",
  "full-screen": "全屏",
  help: tT
}, iT = "horizontal", rT = "bold", sT = "italic", oT = "strikethrough", lT = "link", aT = "picture", uT = "code", cT = "table", hT = "block", fT = "quote", dT = "help", kh = {
  "increase-level": "increase level",
  "decrease-level": "decrease level",
  horizontal: iT,
  bold: rT,
  italic: sT,
  strikethrough: oT,
  link: lT,
  picture: aT,
  code: uT,
  table: cT,
  block: hT,
  quote: fT,
  "unordered-list": "unordered list",
  "ordered-list": "ordered list",
  "task-list": "task list",
  "only-editor": "only editor",
  "only-viewer": "only viewer",
  "full-screen": "full screen",
  help: dT
};
function jo(n) {
  return (e) => n[e] || e;
}
function pT(n) {
  switch (n.toLowerCase()) {
    case "zh_cn":
      return jo(nT);
    case "en_us":
      return jo(kh);
    default:
      return jo(kh);
  }
}
const mT = { class: "cs-header" }, gT = { class: "cs-content" }, yT = { class: "cs-footer" }, bT = { class: "cs-footer-left" }, xT = { class: "cs-footer-right" }, ST = /* @__PURE__ */ lt({
  __name: "CasketStar",
  props: /* @__PURE__ */ ts({
    plugins: { default: () => yM() },
    toolbarl: { default: () => jM() },
    toolbarr: { default: () => WM() },
    lang: { default: "en_US" }
  }, {
    modelValue: { required: !0 },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    const e = oe(0);
    let t;
    const i = oe({
      showEditor: !0,
      showViewer: !0,
      fullScreen: !1
    });
    ut(i.value, () => {
      C();
    });
    const r = n, s = Jl(n, "modelValue"), o = pT(r.lang);
    $m("i18n", o);
    function l(D) {
      t = D.view, h.value = t.scrollDOM, h.value.onscroll = L;
    }
    let a = [], u = [];
    const c = oe(!0), h = oe(null), f = oe(null), d = oe(null);
    let p = null, g = null;
    function m() {
      return h.value ? h.value.scrollHeight - h.value.getBoundingClientRect().height : 0;
    }
    function y() {
      return f.value ? f.value.scrollHeight - f.value.getBoundingClientRect().height : 0;
    }
    function v() {
      var _;
      if (!t || !h.value || !f.value || !c.value || !p || !g)
        return;
      a = [0], u = [0];
      for (const z of p.children)
        ((_ = z.position) == null ? void 0 : _.start.offset) !== void 0 && a.push(z.position.start.offset);
      const D = f.value.scrollTop - f.value.getBoundingClientRect().top;
      let R = 0;
      for (const [z, K] of Object.entries(g.children))
        if (!K.classList.contains("katex-display")) {
          const { top: U, bottom: ne } = K.getBoundingClientRect();
          u.push(U + D), R = ne + D;
        }
      a.push(t.state.doc.length), u.push(R);
    }
    const C = om(v, 200);
    function O(D, R) {
      p = D, g = R, C();
    }
    function A() {
      return t;
    }
    function b() {
      return i.value;
    }
    let S = "editor";
    function L(D) {
      var z, K;
      if (S !== "editor" || !t || !c.value)
        return;
      const R = D.target.scrollTop, _ = t.lineBlockAtHeight(R).from;
      if (R + 1 >= m()) {
        (z = f.value) == null || z.scrollTo({ top: y() + 10 });
        return;
      }
      for (let U = 0; U + 1 < a.length; U++) {
        const ne = a[U], ue = a[U + 1], x = t.lineBlockAt(ne).top, le = t.lineBlockAt(ue).top;
        if (ne <= _ && _ < ue) {
          const me = (R - x) / (le - x), w = u[U] + me * (u[U + 1] - u[U]);
          (K = f.value) == null || K.scrollTo({ top: w });
          return;
        }
      }
    }
    function P(D) {
      var _, z;
      if (S !== "viewer" || !t || !c.value)
        return;
      const R = D.target.scrollTop;
      if (R + 1 >= y()) {
        (_ = h.value) == null || _.scrollTo({ top: m() + 10 });
        return;
      }
      for (let K = 0; K + 1 < a.length; K++) {
        const U = u[K], ne = u[K + 1], ue = (R - U) / (ne - U);
        if (U <= R && R < ne) {
          const x = a[K], le = a[K + 1], me = t.lineBlockAt(x).top, w = t.lineBlockAt(le).top, Se = ue * (w - me);
          (z = h.value) == null || z.scrollTo({ top: me + Se });
          return;
        }
      }
    }
    function k() {
      c.value ? c.value = !1 : (c.value = !0, C());
    }
    function M() {
      h.value && h.value.scrollTo({ top: 0 }), f.value && f.value.scrollTo({ top: 0 });
    }
    return Xl(() => {
      addEventListener("resize", C);
    }), jm(() => {
      t == null || t.dispatch();
    }), (D, R) => {
      var _;
      return se(), xe("div", {
        class: jr(["casket cs-main", { "cs-full-screen": i.value.fullScreen }])
      }, [
        I("div", mT, [
          Ut(h3, {
            toolbarl: r.toolbarl,
            toolbarr: r.toolbarr,
            "get-codemirror": A,
            "get-casketstar": b,
            dialog: d.value
          }, null, 8, ["toolbarl", "toolbarr", "dialog"])
        ]),
        I("div", gT, [
          i.value.showEditor ? (se(), xe("div", {
            key: 0,
            class: jr(["cs-editor", {
              "cs-midline": i.value.showViewer,
              "cs-zone-half": i.value.showViewer,
              "cs-zone-full": !i.value.showViewer
            }]),
            onMouseover: R[1] || (R[1] = (z) => qa(S) ? S.value = "editor" : S = "editor")
          }, [
            Ut(jw, {
              modelValue: s.value,
              "onUpdate:modelValue": R[0] || (R[0] = (z) => s.value = z),
              plugins: D.plugins,
              onReady: l
            }, null, 8, ["modelValue", "plugins"])
          ], 34)) : Wo("", !0),
          i.value.showViewer ? (se(), xe("div", {
            key: 1,
            class: jr(["cs-viewer", {
              "cs-zone-half": i.value.showEditor,
              "cs-zone-full": !i.value.showEditor
            }]),
            ref_key: "viewer",
            ref: f,
            onScroll: P,
            onMouseover: R[3] || (R[3] = (z) => qa(S) ? S.value = "viewer" : S = "viewer")
          }, [
            Ut(t3, {
              modelValue: s.value,
              "onUpdate:modelValue": R[2] || (R[2] = (z) => s.value = z),
              plugins: D.plugins,
              onUpdate: O,
              interval: e.value
            }, null, 8, ["modelValue", "plugins", "interval"])
          ], 34)) : Wo("", !0)
        ]),
        I("div", yT, [
          I("div", bT, " 字数统计：" + In(((_ = A()) == null ? void 0 : _.state.doc.length) || 0) + " 字符 ", 1),
          I("div", xT, [
            I("span", {
              class: "cs-footer-button",
              onClick: k
            }, In(c.value ? "禁用滚动" : "启用滚动"), 1),
            I("span", {
              class: "cs-footer-button",
              onClick: M
            }, "回到顶部")
          ])
        ]),
        (se(), xn(Wm, { to: "body" }, [
          I("div", {
            class: "casket",
            ref_key: "dialog",
            ref: d
          }, null, 512)
        ]))
      ], 2);
    };
  }
});
export {
  jw as CasketEditor,
  ST as CasketStar,
  t3 as CasketViewer,
  jo as I18nBuilder,
  dr as MDialog,
  jA as MDialogExtra,
  OM as ToolBlock,
  kM as ToolBold,
  MM as ToolCode,
  xM as ToolDecrease,
  RM as ToolFullScreen,
  VM as ToolGroupBlock,
  _M as ToolGroupCasket,
  $M as ToolGroupHelp,
  zM as ToolGroupInline,
  HM as ToolGroupInterline,
  FM as ToolGroupTitle,
  NM as ToolHelp,
  wM as ToolHorizontal,
  bM as ToolIncrease,
  vM as ToolItalic,
  CM as ToolLinkOrVideo,
  LM as ToolOList,
  PM as ToolOnlyEdit,
  BM as ToolOnlyView,
  AM as ToolPicture,
  DM as ToolQuote,
  SM as ToolStrikethrough,
  TM as ToolTable,
  IM as ToolTaskList,
  EM as ToolUList,
  ve as defaultIcons,
  yM as getDefaultPlugins,
  jM as getDefaultToolbarL,
  WM as getDefaultToolbarR,
  pT as getI18n
};
